#include "sysconfig.h"
#include "sysdeps.h"
#include "options.h"
#include "memory.h"
#include "newcpu.h"
#include "custom.h"
#include "cpu_prefetch.h"
#include "cputbl.h"
#define CPUFUNC(x) x##_ff
#define SET_CFLG_ALWAYS(x) SET_CFLG(x)
#define SET_NFLG_ALWAYS(x) SET_NFLG(x)
#ifdef NOFLAGS
#include "noflags.h"
#endif
#ifdef CPUEMU_0
const struct cputbl CPUFUNC(op_smalltbl_0)[] = {
{ CPUFUNC(op_0000_0), 0 }, /* OR */
{ CPUFUNC(op_0010_0), 16 }, /* OR */
{ CPUFUNC(op_0018_0), 24 }, /* OR */
{ CPUFUNC(op_0020_0), 32 }, /* OR */
{ CPUFUNC(op_0028_0), 40 }, /* OR */
{ CPUFUNC(op_0030_0), 48 }, /* OR */
{ CPUFUNC(op_0038_0), 56 }, /* OR */
{ CPUFUNC(op_0039_0), 57 }, /* OR */
{ CPUFUNC(op_003c_0), 60 }, /* ORSR */
{ CPUFUNC(op_0040_0), 64 }, /* OR */
{ CPUFUNC(op_0050_0), 80 }, /* OR */
{ CPUFUNC(op_0058_0), 88 }, /* OR */
{ CPUFUNC(op_0060_0), 96 }, /* OR */
{ CPUFUNC(op_0068_0), 104 }, /* OR */
{ CPUFUNC(op_0070_0), 112 }, /* OR */
{ CPUFUNC(op_0078_0), 120 }, /* OR */
{ CPUFUNC(op_0079_0), 121 }, /* OR */
{ CPUFUNC(op_007c_0), 124 }, /* ORSR */
{ CPUFUNC(op_0080_0), 128 }, /* OR */
{ CPUFUNC(op_0090_0), 144 }, /* OR */
{ CPUFUNC(op_0098_0), 152 }, /* OR */
{ CPUFUNC(op_00a0_0), 160 }, /* OR */
{ CPUFUNC(op_00a8_0), 168 }, /* OR */
{ CPUFUNC(op_00b0_0), 176 }, /* OR */
{ CPUFUNC(op_00b8_0), 184 }, /* OR */
{ CPUFUNC(op_00b9_0), 185 }, /* OR */
{ CPUFUNC(op_00d0_0), 208 }, /* CHK2 */
{ CPUFUNC(op_00e8_0), 232 }, /* CHK2 */
{ CPUFUNC(op_00f0_0), 240 }, /* CHK2 */
{ CPUFUNC(op_00f8_0), 248 }, /* CHK2 */
{ CPUFUNC(op_00f9_0), 249 }, /* CHK2 */
{ CPUFUNC(op_00fa_0), 250 }, /* CHK2 */
{ CPUFUNC(op_00fb_0), 251 }, /* CHK2 */
{ CPUFUNC(op_0100_0), 256 }, /* BTST */
{ CPUFUNC(op_0108_0), 264 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 272 }, /* BTST */
{ CPUFUNC(op_0118_0), 280 }, /* BTST */
{ CPUFUNC(op_0120_0), 288 }, /* BTST */
{ CPUFUNC(op_0128_0), 296 }, /* BTST */
{ CPUFUNC(op_0130_0), 304 }, /* BTST */
{ CPUFUNC(op_0138_0), 312 }, /* BTST */
{ CPUFUNC(op_0139_0), 313 }, /* BTST */
{ CPUFUNC(op_013a_0), 314 }, /* BTST */
{ CPUFUNC(op_013b_0), 315 }, /* BTST */
{ CPUFUNC(op_013c_0), 316 }, /* BTST */
{ CPUFUNC(op_0140_0), 320 }, /* BCHG */
{ CPUFUNC(op_0148_0), 328 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 336 }, /* BCHG */
{ CPUFUNC(op_0158_0), 344 }, /* BCHG */
{ CPUFUNC(op_0160_0), 352 }, /* BCHG */
{ CPUFUNC(op_0168_0), 360 }, /* BCHG */
{ CPUFUNC(op_0170_0), 368 }, /* BCHG */
{ CPUFUNC(op_0178_0), 376 }, /* BCHG */
{ CPUFUNC(op_0179_0), 377 }, /* BCHG */
{ CPUFUNC(op_0180_0), 384 }, /* BCLR */
{ CPUFUNC(op_0188_0), 392 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 400 }, /* BCLR */
{ CPUFUNC(op_0198_0), 408 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 416 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 424 }, /* BCLR */
{ CPUFUNC(op_01b0_0), 432 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 440 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 441 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 448 }, /* BSET */
{ CPUFUNC(op_01c8_0), 456 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 464 }, /* BSET */
{ CPUFUNC(op_01d8_0), 472 }, /* BSET */
{ CPUFUNC(op_01e0_0), 480 }, /* BSET */
{ CPUFUNC(op_01e8_0), 488 }, /* BSET */
{ CPUFUNC(op_01f0_0), 496 }, /* BSET */
{ CPUFUNC(op_01f8_0), 504 }, /* BSET */
{ CPUFUNC(op_01f9_0), 505 }, /* BSET */
{ CPUFUNC(op_0200_0), 512 }, /* AND */
{ CPUFUNC(op_0210_0), 528 }, /* AND */
{ CPUFUNC(op_0218_0), 536 }, /* AND */
{ CPUFUNC(op_0220_0), 544 }, /* AND */
{ CPUFUNC(op_0228_0), 552 }, /* AND */
{ CPUFUNC(op_0230_0), 560 }, /* AND */
{ CPUFUNC(op_0238_0), 568 }, /* AND */
{ CPUFUNC(op_0239_0), 569 }, /* AND */
{ CPUFUNC(op_023c_0), 572 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 576 }, /* AND */
{ CPUFUNC(op_0250_0), 592 }, /* AND */
{ CPUFUNC(op_0258_0), 600 }, /* AND */
{ CPUFUNC(op_0260_0), 608 }, /* AND */
{ CPUFUNC(op_0268_0), 616 }, /* AND */
{ CPUFUNC(op_0270_0), 624 }, /* AND */
{ CPUFUNC(op_0278_0), 632 }, /* AND */
{ CPUFUNC(op_0279_0), 633 }, /* AND */
{ CPUFUNC(op_027c_0), 636 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 640 }, /* AND */
{ CPUFUNC(op_0290_0), 656 }, /* AND */
{ CPUFUNC(op_0298_0), 664 }, /* AND */
{ CPUFUNC(op_02a0_0), 672 }, /* AND */
{ CPUFUNC(op_02a8_0), 680 }, /* AND */
{ CPUFUNC(op_02b0_0), 688 }, /* AND */
{ CPUFUNC(op_02b8_0), 696 }, /* AND */
{ CPUFUNC(op_02b9_0), 697 }, /* AND */
{ CPUFUNC(op_02d0_0), 720 }, /* CHK2 */
{ CPUFUNC(op_02e8_0), 744 }, /* CHK2 */
{ CPUFUNC(op_02f0_0), 752 }, /* CHK2 */
{ CPUFUNC(op_02f8_0), 760 }, /* CHK2 */
{ CPUFUNC(op_02f9_0), 761 }, /* CHK2 */
{ CPUFUNC(op_02fa_0), 762 }, /* CHK2 */
{ CPUFUNC(op_02fb_0), 763 }, /* CHK2 */
{ CPUFUNC(op_0400_0), 1024 }, /* SUB */
{ CPUFUNC(op_0410_0), 1040 }, /* SUB */
{ CPUFUNC(op_0418_0), 1048 }, /* SUB */
{ CPUFUNC(op_0420_0), 1056 }, /* SUB */
{ CPUFUNC(op_0428_0), 1064 }, /* SUB */
{ CPUFUNC(op_0430_0), 1072 }, /* SUB */
{ CPUFUNC(op_0438_0), 1080 }, /* SUB */
{ CPUFUNC(op_0439_0), 1081 }, /* SUB */
{ CPUFUNC(op_0440_0), 1088 }, /* SUB */
{ CPUFUNC(op_0450_0), 1104 }, /* SUB */
{ CPUFUNC(op_0458_0), 1112 }, /* SUB */
{ CPUFUNC(op_0460_0), 1120 }, /* SUB */
{ CPUFUNC(op_0468_0), 1128 }, /* SUB */
{ CPUFUNC(op_0470_0), 1136 }, /* SUB */
{ CPUFUNC(op_0478_0), 1144 }, /* SUB */
{ CPUFUNC(op_0479_0), 1145 }, /* SUB */
{ CPUFUNC(op_0480_0), 1152 }, /* SUB */
{ CPUFUNC(op_0490_0), 1168 }, /* SUB */
{ CPUFUNC(op_0498_0), 1176 }, /* SUB */
{ CPUFUNC(op_04a0_0), 1184 }, /* SUB */
{ CPUFUNC(op_04a8_0), 1192 }, /* SUB */
{ CPUFUNC(op_04b0_0), 1200 }, /* SUB */
{ CPUFUNC(op_04b8_0), 1208 }, /* SUB */
{ CPUFUNC(op_04b9_0), 1209 }, /* SUB */
{ CPUFUNC(op_04d0_0), 1232 }, /* CHK2 */
{ CPUFUNC(op_04e8_0), 1256 }, /* CHK2 */
{ CPUFUNC(op_04f0_0), 1264 }, /* CHK2 */
{ CPUFUNC(op_04f8_0), 1272 }, /* CHK2 */
{ CPUFUNC(op_04f9_0), 1273 }, /* CHK2 */
{ CPUFUNC(op_04fa_0), 1274 }, /* CHK2 */
{ CPUFUNC(op_04fb_0), 1275 }, /* CHK2 */
{ CPUFUNC(op_0600_0), 1536 }, /* ADD */
{ CPUFUNC(op_0610_0), 1552 }, /* ADD */
{ CPUFUNC(op_0618_0), 1560 }, /* ADD */
{ CPUFUNC(op_0620_0), 1568 }, /* ADD */
{ CPUFUNC(op_0628_0), 1576 }, /* ADD */
{ CPUFUNC(op_0630_0), 1584 }, /* ADD */
{ CPUFUNC(op_0638_0), 1592 }, /* ADD */
{ CPUFUNC(op_0639_0), 1593 }, /* ADD */
{ CPUFUNC(op_0640_0), 1600 }, /* ADD */
{ CPUFUNC(op_0650_0), 1616 }, /* ADD */
{ CPUFUNC(op_0658_0), 1624 }, /* ADD */
{ CPUFUNC(op_0660_0), 1632 }, /* ADD */
{ CPUFUNC(op_0668_0), 1640 }, /* ADD */
{ CPUFUNC(op_0670_0), 1648 }, /* ADD */
{ CPUFUNC(op_0678_0), 1656 }, /* ADD */
{ CPUFUNC(op_0679_0), 1657 }, /* ADD */
{ CPUFUNC(op_0680_0), 1664 }, /* ADD */
{ CPUFUNC(op_0690_0), 1680 }, /* ADD */
{ CPUFUNC(op_0698_0), 1688 }, /* ADD */
{ CPUFUNC(op_06a0_0), 1696 }, /* ADD */
{ CPUFUNC(op_06a8_0), 1704 }, /* ADD */
{ CPUFUNC(op_06b0_0), 1712 }, /* ADD */
{ CPUFUNC(op_06b8_0), 1720 }, /* ADD */
{ CPUFUNC(op_06b9_0), 1721 }, /* ADD */
{ CPUFUNC(op_06c0_0), 1728 }, /* RTM */
{ CPUFUNC(op_06c8_0), 1736 }, /* RTM */
{ CPUFUNC(op_06d0_0), 1744 }, /* CALLM */
{ CPUFUNC(op_06e8_0), 1768 }, /* CALLM */
{ CPUFUNC(op_06f0_0), 1776 }, /* CALLM */
{ CPUFUNC(op_06f8_0), 1784 }, /* CALLM */
{ CPUFUNC(op_06f9_0), 1785 }, /* CALLM */
{ CPUFUNC(op_06fa_0), 1786 }, /* CALLM */
{ CPUFUNC(op_06fb_0), 1787 }, /* CALLM */
{ CPUFUNC(op_0800_0), 2048 }, /* BTST */
{ CPUFUNC(op_0810_0), 2064 }, /* BTST */
{ CPUFUNC(op_0818_0), 2072 }, /* BTST */
{ CPUFUNC(op_0820_0), 2080 }, /* BTST */
{ CPUFUNC(op_0828_0), 2088 }, /* BTST */
{ CPUFUNC(op_0830_0), 2096 }, /* BTST */
{ CPUFUNC(op_0838_0), 2104 }, /* BTST */
{ CPUFUNC(op_0839_0), 2105 }, /* BTST */
{ CPUFUNC(op_083a_0), 2106 }, /* BTST */
{ CPUFUNC(op_083b_0), 2107 }, /* BTST */
{ CPUFUNC(op_083c_0), 2108 }, /* BTST */
{ CPUFUNC(op_0840_0), 2112 }, /* BCHG */
{ CPUFUNC(op_0850_0), 2128 }, /* BCHG */
{ CPUFUNC(op_0858_0), 2136 }, /* BCHG */
{ CPUFUNC(op_0860_0), 2144 }, /* BCHG */
{ CPUFUNC(op_0868_0), 2152 }, /* BCHG */
{ CPUFUNC(op_0870_0), 2160 }, /* BCHG */
{ CPUFUNC(op_0878_0), 2168 }, /* BCHG */
{ CPUFUNC(op_0879_0), 2169 }, /* BCHG */
{ CPUFUNC(op_0880_0), 2176 }, /* BCLR */
{ CPUFUNC(op_0890_0), 2192 }, /* BCLR */
{ CPUFUNC(op_0898_0), 2200 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 2208 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 2216 }, /* BCLR */
{ CPUFUNC(op_08b0_0), 2224 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 2232 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 2233 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 2240 }, /* BSET */
{ CPUFUNC(op_08d0_0), 2256 }, /* BSET */
{ CPUFUNC(op_08d8_0), 2264 }, /* BSET */
{ CPUFUNC(op_08e0_0), 2272 }, /* BSET */
{ CPUFUNC(op_08e8_0), 2280 }, /* BSET */
{ CPUFUNC(op_08f0_0), 2288 }, /* BSET */
{ CPUFUNC(op_08f8_0), 2296 }, /* BSET */
{ CPUFUNC(op_08f9_0), 2297 }, /* BSET */
{ CPUFUNC(op_0a00_0), 2560 }, /* EOR */
{ CPUFUNC(op_0a10_0), 2576 }, /* EOR */
{ CPUFUNC(op_0a18_0), 2584 }, /* EOR */
{ CPUFUNC(op_0a20_0), 2592 }, /* EOR */
{ CPUFUNC(op_0a28_0), 2600 }, /* EOR */
{ CPUFUNC(op_0a30_0), 2608 }, /* EOR */
{ CPUFUNC(op_0a38_0), 2616 }, /* EOR */
{ CPUFUNC(op_0a39_0), 2617 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 2620 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 2624 }, /* EOR */
{ CPUFUNC(op_0a50_0), 2640 }, /* EOR */
{ CPUFUNC(op_0a58_0), 2648 }, /* EOR */
{ CPUFUNC(op_0a60_0), 2656 }, /* EOR */
{ CPUFUNC(op_0a68_0), 2664 }, /* EOR */
{ CPUFUNC(op_0a70_0), 2672 }, /* EOR */
{ CPUFUNC(op_0a78_0), 2680 }, /* EOR */
{ CPUFUNC(op_0a79_0), 2681 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 2684 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 2688 }, /* EOR */
{ CPUFUNC(op_0a90_0), 2704 }, /* EOR */
{ CPUFUNC(op_0a98_0), 2712 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 2720 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 2728 }, /* EOR */
{ CPUFUNC(op_0ab0_0), 2736 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 2744 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 2745 }, /* EOR */
{ CPUFUNC(op_0ad0_0), 2768 }, /* CAS */
{ CPUFUNC(op_0ad8_0), 2776 }, /* CAS */
{ CPUFUNC(op_0ae0_0), 2784 }, /* CAS */
{ CPUFUNC(op_0ae8_0), 2792 }, /* CAS */
{ CPUFUNC(op_0af0_0), 2800 }, /* CAS */
{ CPUFUNC(op_0af8_0), 2808 }, /* CAS */
{ CPUFUNC(op_0af9_0), 2809 }, /* CAS */
{ CPUFUNC(op_0c00_0), 3072 }, /* CMP */
{ CPUFUNC(op_0c10_0), 3088 }, /* CMP */
{ CPUFUNC(op_0c18_0), 3096 }, /* CMP */
{ CPUFUNC(op_0c20_0), 3104 }, /* CMP */
{ CPUFUNC(op_0c28_0), 3112 }, /* CMP */
{ CPUFUNC(op_0c30_0), 3120 }, /* CMP */
{ CPUFUNC(op_0c38_0), 3128 }, /* CMP */
{ CPUFUNC(op_0c39_0), 3129 }, /* CMP */
{ CPUFUNC(op_0c3a_0), 3130 }, /* CMP */
{ CPUFUNC(op_0c3b_0), 3131 }, /* CMP */
{ CPUFUNC(op_0c40_0), 3136 }, /* CMP */
{ CPUFUNC(op_0c50_0), 3152 }, /* CMP */
{ CPUFUNC(op_0c58_0), 3160 }, /* CMP */
{ CPUFUNC(op_0c60_0), 3168 }, /* CMP */
{ CPUFUNC(op_0c68_0), 3176 }, /* CMP */
{ CPUFUNC(op_0c70_0), 3184 }, /* CMP */
{ CPUFUNC(op_0c78_0), 3192 }, /* CMP */
{ CPUFUNC(op_0c79_0), 3193 }, /* CMP */
{ CPUFUNC(op_0c7a_0), 3194 }, /* CMP */
{ CPUFUNC(op_0c7b_0), 3195 }, /* CMP */
{ CPUFUNC(op_0c80_0), 3200 }, /* CMP */
{ CPUFUNC(op_0c90_0), 3216 }, /* CMP */
{ CPUFUNC(op_0c98_0), 3224 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 3232 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 3240 }, /* CMP */
{ CPUFUNC(op_0cb0_0), 3248 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 3256 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 3257 }, /* CMP */
{ CPUFUNC(op_0cba_0), 3258 }, /* CMP */
{ CPUFUNC(op_0cbb_0), 3259 }, /* CMP */
{ CPUFUNC(op_0cd0_0), 3280 }, /* CAS */
{ CPUFUNC(op_0cd8_0), 3288 }, /* CAS */
{ CPUFUNC(op_0ce0_0), 3296 }, /* CAS */
{ CPUFUNC(op_0ce8_0), 3304 }, /* CAS */
{ CPUFUNC(op_0cf0_0), 3312 }, /* CAS */
{ CPUFUNC(op_0cf8_0), 3320 }, /* CAS */
{ CPUFUNC(op_0cf9_0), 3321 }, /* CAS */
{ CPUFUNC(op_0cfc_0), 3324 }, /* CAS2 */
{ CPUFUNC(op_0e10_0), 3600 }, /* MOVES */
{ CPUFUNC(op_0e18_0), 3608 }, /* MOVES */
{ CPUFUNC(op_0e20_0), 3616 }, /* MOVES */
{ CPUFUNC(op_0e28_0), 3624 }, /* MOVES */
{ CPUFUNC(op_0e30_0), 3632 }, /* MOVES */
{ CPUFUNC(op_0e38_0), 3640 }, /* MOVES */
{ CPUFUNC(op_0e39_0), 3641 }, /* MOVES */
{ CPUFUNC(op_0e50_0), 3664 }, /* MOVES */
{ CPUFUNC(op_0e58_0), 3672 }, /* MOVES */
{ CPUFUNC(op_0e60_0), 3680 }, /* MOVES */
{ CPUFUNC(op_0e68_0), 3688 }, /* MOVES */
{ CPUFUNC(op_0e70_0), 3696 }, /* MOVES */
{ CPUFUNC(op_0e78_0), 3704 }, /* MOVES */
{ CPUFUNC(op_0e79_0), 3705 }, /* MOVES */
{ CPUFUNC(op_0e90_0), 3728 }, /* MOVES */
{ CPUFUNC(op_0e98_0), 3736 }, /* MOVES */
{ CPUFUNC(op_0ea0_0), 3744 }, /* MOVES */
{ CPUFUNC(op_0ea8_0), 3752 }, /* MOVES */
{ CPUFUNC(op_0eb0_0), 3760 }, /* MOVES */
{ CPUFUNC(op_0eb8_0), 3768 }, /* MOVES */
{ CPUFUNC(op_0eb9_0), 3769 }, /* MOVES */
{ CPUFUNC(op_0ed0_0), 3792 }, /* CAS */
{ CPUFUNC(op_0ed8_0), 3800 }, /* CAS */
{ CPUFUNC(op_0ee0_0), 3808 }, /* CAS */
{ CPUFUNC(op_0ee8_0), 3816 }, /* CAS */
{ CPUFUNC(op_0ef0_0), 3824 }, /* CAS */
{ CPUFUNC(op_0ef8_0), 3832 }, /* CAS */
{ CPUFUNC(op_0ef9_0), 3833 }, /* CAS */
{ CPUFUNC(op_0efc_0), 3836 }, /* CAS2 */
{ CPUFUNC(op_1000_0), 4096 }, /* MOVE */
{ CPUFUNC(op_1010_0), 4112 }, /* MOVE */
{ CPUFUNC(op_1018_0), 4120 }, /* MOVE */
{ CPUFUNC(op_1020_0), 4128 }, /* MOVE */
{ CPUFUNC(op_1028_0), 4136 }, /* MOVE */
{ CPUFUNC(op_1030_0), 4144 }, /* MOVE */
{ CPUFUNC(op_1038_0), 4152 }, /* MOVE */
{ CPUFUNC(op_1039_0), 4153 }, /* MOVE */
{ CPUFUNC(op_103a_0), 4154 }, /* MOVE */
{ CPUFUNC(op_103b_0), 4155 }, /* MOVE */
{ CPUFUNC(op_103c_0), 4156 }, /* MOVE */
{ CPUFUNC(op_1080_0), 4224 }, /* MOVE */
{ CPUFUNC(op_1090_0), 4240 }, /* MOVE */
{ CPUFUNC(op_1098_0), 4248 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 4256 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 4264 }, /* MOVE */
{ CPUFUNC(op_10b0_0), 4272 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 4280 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 4281 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 4282 }, /* MOVE */
{ CPUFUNC(op_10bb_0), 4283 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 4284 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 4288 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 4304 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 4312 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 4320 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 4328 }, /* MOVE */
{ CPUFUNC(op_10f0_0), 4336 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 4344 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 4345 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 4346 }, /* MOVE */
{ CPUFUNC(op_10fb_0), 4347 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 4348 }, /* MOVE */
{ CPUFUNC(op_1100_0), 4352 }, /* MOVE */
{ CPUFUNC(op_1110_0), 4368 }, /* MOVE */
{ CPUFUNC(op_1118_0), 4376 }, /* MOVE */
{ CPUFUNC(op_1120_0), 4384 }, /* MOVE */
{ CPUFUNC(op_1128_0), 4392 }, /* MOVE */
{ CPUFUNC(op_1130_0), 4400 }, /* MOVE */
{ CPUFUNC(op_1138_0), 4408 }, /* MOVE */
{ CPUFUNC(op_1139_0), 4409 }, /* MOVE */
{ CPUFUNC(op_113a_0), 4410 }, /* MOVE */
{ CPUFUNC(op_113b_0), 4411 }, /* MOVE */
{ CPUFUNC(op_113c_0), 4412 }, /* MOVE */
{ CPUFUNC(op_1140_0), 4416 }, /* MOVE */
{ CPUFUNC(op_1150_0), 4432 }, /* MOVE */
{ CPUFUNC(op_1158_0), 4440 }, /* MOVE */
{ CPUFUNC(op_1160_0), 4448 }, /* MOVE */
{ CPUFUNC(op_1168_0), 4456 }, /* MOVE */
{ CPUFUNC(op_1170_0), 4464 }, /* MOVE */
{ CPUFUNC(op_1178_0), 4472 }, /* MOVE */
{ CPUFUNC(op_1179_0), 4473 }, /* MOVE */
{ CPUFUNC(op_117a_0), 4474 }, /* MOVE */
{ CPUFUNC(op_117b_0), 4475 }, /* MOVE */
{ CPUFUNC(op_117c_0), 4476 }, /* MOVE */
{ CPUFUNC(op_1180_0), 4480 }, /* MOVE */
{ CPUFUNC(op_1190_0), 4496 }, /* MOVE */
{ CPUFUNC(op_1198_0), 4504 }, /* MOVE */
{ CPUFUNC(op_11a0_0), 4512 }, /* MOVE */
{ CPUFUNC(op_11a8_0), 4520 }, /* MOVE */
{ CPUFUNC(op_11b0_0), 4528 }, /* MOVE */
{ CPUFUNC(op_11b8_0), 4536 }, /* MOVE */
{ CPUFUNC(op_11b9_0), 4537 }, /* MOVE */
{ CPUFUNC(op_11ba_0), 4538 }, /* MOVE */
{ CPUFUNC(op_11bb_0), 4539 }, /* MOVE */
{ CPUFUNC(op_11bc_0), 4540 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 4544 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 4560 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 4568 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 4576 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 4584 }, /* MOVE */
{ CPUFUNC(op_11f0_0), 4592 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 4600 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 4601 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 4602 }, /* MOVE */
{ CPUFUNC(op_11fb_0), 4603 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 4604 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 5056 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 5072 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 5080 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 5088 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 5096 }, /* MOVE */
{ CPUFUNC(op_13f0_0), 5104 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 5112 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 5113 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 5114 }, /* MOVE */
{ CPUFUNC(op_13fb_0), 5115 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 5116 }, /* MOVE */
{ CPUFUNC(op_2000_0), 8192 }, /* MOVE */
{ CPUFUNC(op_2008_0), 8200 }, /* MOVE */
{ CPUFUNC(op_2010_0), 8208 }, /* MOVE */
{ CPUFUNC(op_2018_0), 8216 }, /* MOVE */
{ CPUFUNC(op_2020_0), 8224 }, /* MOVE */
{ CPUFUNC(op_2028_0), 8232 }, /* MOVE */
{ CPUFUNC(op_2030_0), 8240 }, /* MOVE */
{ CPUFUNC(op_2038_0), 8248 }, /* MOVE */
{ CPUFUNC(op_2039_0), 8249 }, /* MOVE */
{ CPUFUNC(op_203a_0), 8250 }, /* MOVE */
{ CPUFUNC(op_203b_0), 8251 }, /* MOVE */
{ CPUFUNC(op_203c_0), 8252 }, /* MOVE */
{ CPUFUNC(op_2040_0), 8256 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 8264 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 8272 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 8280 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 8288 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 8296 }, /* MOVEA */
{ CPUFUNC(op_2070_0), 8304 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 8312 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 8313 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 8314 }, /* MOVEA */
{ CPUFUNC(op_207b_0), 8315 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 8316 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 8320 }, /* MOVE */
{ CPUFUNC(op_2088_0), 8328 }, /* MOVE */
{ CPUFUNC(op_2090_0), 8336 }, /* MOVE */
{ CPUFUNC(op_2098_0), 8344 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 8352 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 8360 }, /* MOVE */
{ CPUFUNC(op_20b0_0), 8368 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 8376 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 8377 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 8378 }, /* MOVE */
{ CPUFUNC(op_20bb_0), 8379 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 8380 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 8384 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 8392 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 8400 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 8408 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 8416 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 8424 }, /* MOVE */
{ CPUFUNC(op_20f0_0), 8432 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 8440 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 8441 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 8442 }, /* MOVE */
{ CPUFUNC(op_20fb_0), 8443 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 8444 }, /* MOVE */
{ CPUFUNC(op_2100_0), 8448 }, /* MOVE */
{ CPUFUNC(op_2108_0), 8456 }, /* MOVE */
{ CPUFUNC(op_2110_0), 8464 }, /* MOVE */
{ CPUFUNC(op_2118_0), 8472 }, /* MOVE */
{ CPUFUNC(op_2120_0), 8480 }, /* MOVE */
{ CPUFUNC(op_2128_0), 8488 }, /* MOVE */
{ CPUFUNC(op_2130_0), 8496 }, /* MOVE */
{ CPUFUNC(op_2138_0), 8504 }, /* MOVE */
{ CPUFUNC(op_2139_0), 8505 }, /* MOVE */
{ CPUFUNC(op_213a_0), 8506 }, /* MOVE */
{ CPUFUNC(op_213b_0), 8507 }, /* MOVE */
{ CPUFUNC(op_213c_0), 8508 }, /* MOVE */
{ CPUFUNC(op_2140_0), 8512 }, /* MOVE */
{ CPUFUNC(op_2148_0), 8520 }, /* MOVE */
{ CPUFUNC(op_2150_0), 8528 }, /* MOVE */
{ CPUFUNC(op_2158_0), 8536 }, /* MOVE */
{ CPUFUNC(op_2160_0), 8544 }, /* MOVE */
{ CPUFUNC(op_2168_0), 8552 }, /* MOVE */
{ CPUFUNC(op_2170_0), 8560 }, /* MOVE */
{ CPUFUNC(op_2178_0), 8568 }, /* MOVE */
{ CPUFUNC(op_2179_0), 8569 }, /* MOVE */
{ CPUFUNC(op_217a_0), 8570 }, /* MOVE */
{ CPUFUNC(op_217b_0), 8571 }, /* MOVE */
{ CPUFUNC(op_217c_0), 8572 }, /* MOVE */
{ CPUFUNC(op_2180_0), 8576 }, /* MOVE */
{ CPUFUNC(op_2188_0), 8584 }, /* MOVE */
{ CPUFUNC(op_2190_0), 8592 }, /* MOVE */
{ CPUFUNC(op_2198_0), 8600 }, /* MOVE */
{ CPUFUNC(op_21a0_0), 8608 }, /* MOVE */
{ CPUFUNC(op_21a8_0), 8616 }, /* MOVE */
{ CPUFUNC(op_21b0_0), 8624 }, /* MOVE */
{ CPUFUNC(op_21b8_0), 8632 }, /* MOVE */
{ CPUFUNC(op_21b9_0), 8633 }, /* MOVE */
{ CPUFUNC(op_21ba_0), 8634 }, /* MOVE */
{ CPUFUNC(op_21bb_0), 8635 }, /* MOVE */
{ CPUFUNC(op_21bc_0), 8636 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 8640 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 8648 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 8656 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 8664 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 8672 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 8680 }, /* MOVE */
{ CPUFUNC(op_21f0_0), 8688 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 8696 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 8697 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 8698 }, /* MOVE */
{ CPUFUNC(op_21fb_0), 8699 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 8700 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 9152 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 9160 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 9168 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 9176 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 9184 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 9192 }, /* MOVE */
{ CPUFUNC(op_23f0_0), 9200 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 9208 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 9209 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 9210 }, /* MOVE */
{ CPUFUNC(op_23fb_0), 9211 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 9212 }, /* MOVE */
{ CPUFUNC(op_3000_0), 12288 }, /* MOVE */
{ CPUFUNC(op_3008_0), 12296 }, /* MOVE */
{ CPUFUNC(op_3010_0), 12304 }, /* MOVE */
{ CPUFUNC(op_3018_0), 12312 }, /* MOVE */
{ CPUFUNC(op_3020_0), 12320 }, /* MOVE */
{ CPUFUNC(op_3028_0), 12328 }, /* MOVE */
{ CPUFUNC(op_3030_0), 12336 }, /* MOVE */
{ CPUFUNC(op_3038_0), 12344 }, /* MOVE */
{ CPUFUNC(op_3039_0), 12345 }, /* MOVE */
{ CPUFUNC(op_303a_0), 12346 }, /* MOVE */
{ CPUFUNC(op_303b_0), 12347 }, /* MOVE */
{ CPUFUNC(op_303c_0), 12348 }, /* MOVE */
{ CPUFUNC(op_3040_0), 12352 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 12360 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 12368 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 12376 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 12384 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 12392 }, /* MOVEA */
{ CPUFUNC(op_3070_0), 12400 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 12408 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 12409 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 12410 }, /* MOVEA */
{ CPUFUNC(op_307b_0), 12411 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 12412 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 12416 }, /* MOVE */
{ CPUFUNC(op_3088_0), 12424 }, /* MOVE */
{ CPUFUNC(op_3090_0), 12432 }, /* MOVE */
{ CPUFUNC(op_3098_0), 12440 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 12448 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 12456 }, /* MOVE */
{ CPUFUNC(op_30b0_0), 12464 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 12472 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 12473 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 12474 }, /* MOVE */
{ CPUFUNC(op_30bb_0), 12475 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 12476 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 12480 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 12488 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 12496 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 12504 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 12512 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 12520 }, /* MOVE */
{ CPUFUNC(op_30f0_0), 12528 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 12536 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 12537 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 12538 }, /* MOVE */
{ CPUFUNC(op_30fb_0), 12539 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 12540 }, /* MOVE */
{ CPUFUNC(op_3100_0), 12544 }, /* MOVE */
{ CPUFUNC(op_3108_0), 12552 }, /* MOVE */
{ CPUFUNC(op_3110_0), 12560 }, /* MOVE */
{ CPUFUNC(op_3118_0), 12568 }, /* MOVE */
{ CPUFUNC(op_3120_0), 12576 }, /* MOVE */
{ CPUFUNC(op_3128_0), 12584 }, /* MOVE */
{ CPUFUNC(op_3130_0), 12592 }, /* MOVE */
{ CPUFUNC(op_3138_0), 12600 }, /* MOVE */
{ CPUFUNC(op_3139_0), 12601 }, /* MOVE */
{ CPUFUNC(op_313a_0), 12602 }, /* MOVE */
{ CPUFUNC(op_313b_0), 12603 }, /* MOVE */
{ CPUFUNC(op_313c_0), 12604 }, /* MOVE */
{ CPUFUNC(op_3140_0), 12608 }, /* MOVE */
{ CPUFUNC(op_3148_0), 12616 }, /* MOVE */
{ CPUFUNC(op_3150_0), 12624 }, /* MOVE */
{ CPUFUNC(op_3158_0), 12632 }, /* MOVE */
{ CPUFUNC(op_3160_0), 12640 }, /* MOVE */
{ CPUFUNC(op_3168_0), 12648 }, /* MOVE */
{ CPUFUNC(op_3170_0), 12656 }, /* MOVE */
{ CPUFUNC(op_3178_0), 12664 }, /* MOVE */
{ CPUFUNC(op_3179_0), 12665 }, /* MOVE */
{ CPUFUNC(op_317a_0), 12666 }, /* MOVE */
{ CPUFUNC(op_317b_0), 12667 }, /* MOVE */
{ CPUFUNC(op_317c_0), 12668 }, /* MOVE */
{ CPUFUNC(op_3180_0), 12672 }, /* MOVE */
{ CPUFUNC(op_3188_0), 12680 }, /* MOVE */
{ CPUFUNC(op_3190_0), 12688 }, /* MOVE */
{ CPUFUNC(op_3198_0), 12696 }, /* MOVE */
{ CPUFUNC(op_31a0_0), 12704 }, /* MOVE */
{ CPUFUNC(op_31a8_0), 12712 }, /* MOVE */
{ CPUFUNC(op_31b0_0), 12720 }, /* MOVE */
{ CPUFUNC(op_31b8_0), 12728 }, /* MOVE */
{ CPUFUNC(op_31b9_0), 12729 }, /* MOVE */
{ CPUFUNC(op_31ba_0), 12730 }, /* MOVE */
{ CPUFUNC(op_31bb_0), 12731 }, /* MOVE */
{ CPUFUNC(op_31bc_0), 12732 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 12736 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 12744 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 12752 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 12760 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 12768 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 12776 }, /* MOVE */
{ CPUFUNC(op_31f0_0), 12784 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 12792 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 12793 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 12794 }, /* MOVE */
{ CPUFUNC(op_31fb_0), 12795 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 12796 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 13248 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 13256 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 13264 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 13272 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 13280 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 13288 }, /* MOVE */
{ CPUFUNC(op_33f0_0), 13296 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 13304 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 13305 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 13306 }, /* MOVE */
{ CPUFUNC(op_33fb_0), 13307 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 13308 }, /* MOVE */
{ CPUFUNC(op_4000_0), 16384 }, /* NEGX */
{ CPUFUNC(op_4010_0), 16400 }, /* NEGX */
{ CPUFUNC(op_4018_0), 16408 }, /* NEGX */
{ CPUFUNC(op_4020_0), 16416 }, /* NEGX */
{ CPUFUNC(op_4028_0), 16424 }, /* NEGX */
{ CPUFUNC(op_4030_0), 16432 }, /* NEGX */
{ CPUFUNC(op_4038_0), 16440 }, /* NEGX */
{ CPUFUNC(op_4039_0), 16441 }, /* NEGX */
{ CPUFUNC(op_4040_0), 16448 }, /* NEGX */
{ CPUFUNC(op_4050_0), 16464 }, /* NEGX */
{ CPUFUNC(op_4058_0), 16472 }, /* NEGX */
{ CPUFUNC(op_4060_0), 16480 }, /* NEGX */
{ CPUFUNC(op_4068_0), 16488 }, /* NEGX */
{ CPUFUNC(op_4070_0), 16496 }, /* NEGX */
{ CPUFUNC(op_4078_0), 16504 }, /* NEGX */
{ CPUFUNC(op_4079_0), 16505 }, /* NEGX */
{ CPUFUNC(op_4080_0), 16512 }, /* NEGX */
{ CPUFUNC(op_4090_0), 16528 }, /* NEGX */
{ CPUFUNC(op_4098_0), 16536 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 16544 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 16552 }, /* NEGX */
{ CPUFUNC(op_40b0_0), 16560 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 16568 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 16569 }, /* NEGX */
{ CPUFUNC(op_40c0_0), 16576 }, /* MVSR2 */
{ CPUFUNC(op_40d0_0), 16592 }, /* MVSR2 */
{ CPUFUNC(op_40d8_0), 16600 }, /* MVSR2 */
{ CPUFUNC(op_40e0_0), 16608 }, /* MVSR2 */
{ CPUFUNC(op_40e8_0), 16616 }, /* MVSR2 */
{ CPUFUNC(op_40f0_0), 16624 }, /* MVSR2 */
{ CPUFUNC(op_40f8_0), 16632 }, /* MVSR2 */
{ CPUFUNC(op_40f9_0), 16633 }, /* MVSR2 */
{ CPUFUNC(op_4100_0), 16640 }, /* CHK */
{ CPUFUNC(op_4110_0), 16656 }, /* CHK */
{ CPUFUNC(op_4118_0), 16664 }, /* CHK */
{ CPUFUNC(op_4120_0), 16672 }, /* CHK */
{ CPUFUNC(op_4128_0), 16680 }, /* CHK */
{ CPUFUNC(op_4130_0), 16688 }, /* CHK */
{ CPUFUNC(op_4138_0), 16696 }, /* CHK */
{ CPUFUNC(op_4139_0), 16697 }, /* CHK */
{ CPUFUNC(op_413a_0), 16698 }, /* CHK */
{ CPUFUNC(op_413b_0), 16699 }, /* CHK */
{ CPUFUNC(op_413c_0), 16700 }, /* CHK */
{ CPUFUNC(op_4180_0), 16768 }, /* CHK */
{ CPUFUNC(op_4190_0), 16784 }, /* CHK */
{ CPUFUNC(op_4198_0), 16792 }, /* CHK */
{ CPUFUNC(op_41a0_0), 16800 }, /* CHK */
{ CPUFUNC(op_41a8_0), 16808 }, /* CHK */
{ CPUFUNC(op_41b0_0), 16816 }, /* CHK */
{ CPUFUNC(op_41b8_0), 16824 }, /* CHK */
{ CPUFUNC(op_41b9_0), 16825 }, /* CHK */
{ CPUFUNC(op_41ba_0), 16826 }, /* CHK */
{ CPUFUNC(op_41bb_0), 16827 }, /* CHK */
{ CPUFUNC(op_41bc_0), 16828 }, /* CHK */
{ CPUFUNC(op_41d0_0), 16848 }, /* LEA */
{ CPUFUNC(op_41e8_0), 16872 }, /* LEA */
{ CPUFUNC(op_41f0_0), 16880 }, /* LEA */
{ CPUFUNC(op_41f8_0), 16888 }, /* LEA */
{ CPUFUNC(op_41f9_0), 16889 }, /* LEA */
{ CPUFUNC(op_41fa_0), 16890 }, /* LEA */
{ CPUFUNC(op_41fb_0), 16891 }, /* LEA */
{ CPUFUNC(op_4200_0), 16896 }, /* CLR */
{ CPUFUNC(op_4210_0), 16912 }, /* CLR */
{ CPUFUNC(op_4218_0), 16920 }, /* CLR */
{ CPUFUNC(op_4220_0), 16928 }, /* CLR */
{ CPUFUNC(op_4228_0), 16936 }, /* CLR */
{ CPUFUNC(op_4230_0), 16944 }, /* CLR */
{ CPUFUNC(op_4238_0), 16952 }, /* CLR */
{ CPUFUNC(op_4239_0), 16953 }, /* CLR */
{ CPUFUNC(op_4240_0), 16960 }, /* CLR */
{ CPUFUNC(op_4250_0), 16976 }, /* CLR */
{ CPUFUNC(op_4258_0), 16984 }, /* CLR */
{ CPUFUNC(op_4260_0), 16992 }, /* CLR */
{ CPUFUNC(op_4268_0), 17000 }, /* CLR */
{ CPUFUNC(op_4270_0), 17008 }, /* CLR */
{ CPUFUNC(op_4278_0), 17016 }, /* CLR */
{ CPUFUNC(op_4279_0), 17017 }, /* CLR */
{ CPUFUNC(op_4280_0), 17024 }, /* CLR */
{ CPUFUNC(op_4290_0), 17040 }, /* CLR */
{ CPUFUNC(op_4298_0), 17048 }, /* CLR */
{ CPUFUNC(op_42a0_0), 17056 }, /* CLR */
{ CPUFUNC(op_42a8_0), 17064 }, /* CLR */
{ CPUFUNC(op_42b0_0), 17072 }, /* CLR */
{ CPUFUNC(op_42b8_0), 17080 }, /* CLR */
{ CPUFUNC(op_42b9_0), 17081 }, /* CLR */
{ CPUFUNC(op_42c0_0), 17088 }, /* MVSR2 */
{ CPUFUNC(op_42d0_0), 17104 }, /* MVSR2 */
{ CPUFUNC(op_42d8_0), 17112 }, /* MVSR2 */
{ CPUFUNC(op_42e0_0), 17120 }, /* MVSR2 */
{ CPUFUNC(op_42e8_0), 17128 }, /* MVSR2 */
{ CPUFUNC(op_42f0_0), 17136 }, /* MVSR2 */
{ CPUFUNC(op_42f8_0), 17144 }, /* MVSR2 */
{ CPUFUNC(op_42f9_0), 17145 }, /* MVSR2 */
{ CPUFUNC(op_4400_0), 17408 }, /* NEG */
{ CPUFUNC(op_4410_0), 17424 }, /* NEG */
{ CPUFUNC(op_4418_0), 17432 }, /* NEG */
{ CPUFUNC(op_4420_0), 17440 }, /* NEG */
{ CPUFUNC(op_4428_0), 17448 }, /* NEG */
{ CPUFUNC(op_4430_0), 17456 }, /* NEG */
{ CPUFUNC(op_4438_0), 17464 }, /* NEG */
{ CPUFUNC(op_4439_0), 17465 }, /* NEG */
{ CPUFUNC(op_4440_0), 17472 }, /* NEG */
{ CPUFUNC(op_4450_0), 17488 }, /* NEG */
{ CPUFUNC(op_4458_0), 17496 }, /* NEG */
{ CPUFUNC(op_4460_0), 17504 }, /* NEG */
{ CPUFUNC(op_4468_0), 17512 }, /* NEG */
{ CPUFUNC(op_4470_0), 17520 }, /* NEG */
{ CPUFUNC(op_4478_0), 17528 }, /* NEG */
{ CPUFUNC(op_4479_0), 17529 }, /* NEG */
{ CPUFUNC(op_4480_0), 17536 }, /* NEG */
{ CPUFUNC(op_4490_0), 17552 }, /* NEG */
{ CPUFUNC(op_4498_0), 17560 }, /* NEG */
{ CPUFUNC(op_44a0_0), 17568 }, /* NEG */
{ CPUFUNC(op_44a8_0), 17576 }, /* NEG */
{ CPUFUNC(op_44b0_0), 17584 }, /* NEG */
{ CPUFUNC(op_44b8_0), 17592 }, /* NEG */
{ CPUFUNC(op_44b9_0), 17593 }, /* NEG */
{ CPUFUNC(op_44c0_0), 17600 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 17616 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 17624 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 17632 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 17640 }, /* MV2SR */
{ CPUFUNC(op_44f0_0), 17648 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 17656 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 17657 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 17658 }, /* MV2SR */
{ CPUFUNC(op_44fb_0), 17659 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 17660 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 17920 }, /* NOT */
{ CPUFUNC(op_4610_0), 17936 }, /* NOT */
{ CPUFUNC(op_4618_0), 17944 }, /* NOT */
{ CPUFUNC(op_4620_0), 17952 }, /* NOT */
{ CPUFUNC(op_4628_0), 17960 }, /* NOT */
{ CPUFUNC(op_4630_0), 17968 }, /* NOT */
{ CPUFUNC(op_4638_0), 17976 }, /* NOT */
{ CPUFUNC(op_4639_0), 17977 }, /* NOT */
{ CPUFUNC(op_4640_0), 17984 }, /* NOT */
{ CPUFUNC(op_4650_0), 18000 }, /* NOT */
{ CPUFUNC(op_4658_0), 18008 }, /* NOT */
{ CPUFUNC(op_4660_0), 18016 }, /* NOT */
{ CPUFUNC(op_4668_0), 18024 }, /* NOT */
{ CPUFUNC(op_4670_0), 18032 }, /* NOT */
{ CPUFUNC(op_4678_0), 18040 }, /* NOT */
{ CPUFUNC(op_4679_0), 18041 }, /* NOT */
{ CPUFUNC(op_4680_0), 18048 }, /* NOT */
{ CPUFUNC(op_4690_0), 18064 }, /* NOT */
{ CPUFUNC(op_4698_0), 18072 }, /* NOT */
{ CPUFUNC(op_46a0_0), 18080 }, /* NOT */
{ CPUFUNC(op_46a8_0), 18088 }, /* NOT */
{ CPUFUNC(op_46b0_0), 18096 }, /* NOT */
{ CPUFUNC(op_46b8_0), 18104 }, /* NOT */
{ CPUFUNC(op_46b9_0), 18105 }, /* NOT */
{ CPUFUNC(op_46c0_0), 18112 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 18128 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 18136 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 18144 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 18152 }, /* MV2SR */
{ CPUFUNC(op_46f0_0), 18160 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 18168 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 18169 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 18170 }, /* MV2SR */
{ CPUFUNC(op_46fb_0), 18171 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 18172 }, /* MV2SR */
{ CPUFUNC(op_4800_0), 18432 }, /* NBCD */
{ CPUFUNC(op_4808_0), 18440 }, /* LINK */
{ CPUFUNC(op_4810_0), 18448 }, /* NBCD */
{ CPUFUNC(op_4818_0), 18456 }, /* NBCD */
{ CPUFUNC(op_4820_0), 18464 }, /* NBCD */
{ CPUFUNC(op_4828_0), 18472 }, /* NBCD */
{ CPUFUNC(op_4830_0), 18480 }, /* NBCD */
{ CPUFUNC(op_4838_0), 18488 }, /* NBCD */
{ CPUFUNC(op_4839_0), 18489 }, /* NBCD */
{ CPUFUNC(op_4840_0), 18496 }, /* SWAP */
{ CPUFUNC(op_4848_0), 18504 }, /* BKPT */
{ CPUFUNC(op_4850_0), 18512 }, /* PEA */
{ CPUFUNC(op_4868_0), 18536 }, /* PEA */
{ CPUFUNC(op_4870_0), 18544 }, /* PEA */
{ CPUFUNC(op_4878_0), 18552 }, /* PEA */
{ CPUFUNC(op_4879_0), 18553 }, /* PEA */
{ CPUFUNC(op_487a_0), 18554 }, /* PEA */
{ CPUFUNC(op_487b_0), 18555 }, /* PEA */
{ CPUFUNC(op_4880_0), 18560 }, /* EXT */
{ CPUFUNC(op_4890_0), 18576 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 18592 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 18600 }, /* MVMLE */
{ CPUFUNC(op_48b0_0), 18608 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 18616 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 18617 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 18624 }, /* EXT */
{ CPUFUNC(op_48d0_0), 18640 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 18656 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 18664 }, /* MVMLE */
{ CPUFUNC(op_48f0_0), 18672 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 18680 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 18681 }, /* MVMLE */
{ CPUFUNC(op_49c0_0), 18880 }, /* EXT */
{ CPUFUNC(op_4a00_0), 18944 }, /* TST */
{ CPUFUNC(op_4a10_0), 18960 }, /* TST */
{ CPUFUNC(op_4a18_0), 18968 }, /* TST */
{ CPUFUNC(op_4a20_0), 18976 }, /* TST */
{ CPUFUNC(op_4a28_0), 18984 }, /* TST */
{ CPUFUNC(op_4a30_0), 18992 }, /* TST */
{ CPUFUNC(op_4a38_0), 19000 }, /* TST */
{ CPUFUNC(op_4a39_0), 19001 }, /* TST */
{ CPUFUNC(op_4a3a_0), 19002 }, /* TST */
{ CPUFUNC(op_4a3b_0), 19003 }, /* TST */
{ CPUFUNC(op_4a3c_0), 19004 }, /* TST */
{ CPUFUNC(op_4a40_0), 19008 }, /* TST */
{ CPUFUNC(op_4a48_0), 19016 }, /* TST */
{ CPUFUNC(op_4a50_0), 19024 }, /* TST */
{ CPUFUNC(op_4a58_0), 19032 }, /* TST */
{ CPUFUNC(op_4a60_0), 19040 }, /* TST */
{ CPUFUNC(op_4a68_0), 19048 }, /* TST */
{ CPUFUNC(op_4a70_0), 19056 }, /* TST */
{ CPUFUNC(op_4a78_0), 19064 }, /* TST */
{ CPUFUNC(op_4a79_0), 19065 }, /* TST */
{ CPUFUNC(op_4a7a_0), 19066 }, /* TST */
{ CPUFUNC(op_4a7b_0), 19067 }, /* TST */
{ CPUFUNC(op_4a7c_0), 19068 }, /* TST */
{ CPUFUNC(op_4a80_0), 19072 }, /* TST */
{ CPUFUNC(op_4a88_0), 19080 }, /* TST */
{ CPUFUNC(op_4a90_0), 19088 }, /* TST */
{ CPUFUNC(op_4a98_0), 19096 }, /* TST */
{ CPUFUNC(op_4aa0_0), 19104 }, /* TST */
{ CPUFUNC(op_4aa8_0), 19112 }, /* TST */
{ CPUFUNC(op_4ab0_0), 19120 }, /* TST */
{ CPUFUNC(op_4ab8_0), 19128 }, /* TST */
{ CPUFUNC(op_4ab9_0), 19129 }, /* TST */
{ CPUFUNC(op_4aba_0), 19130 }, /* TST */
{ CPUFUNC(op_4abb_0), 19131 }, /* TST */
{ CPUFUNC(op_4abc_0), 19132 }, /* TST */
{ CPUFUNC(op_4ac0_0), 19136 }, /* TAS */
{ CPUFUNC(op_4ad0_0), 19152 }, /* TAS */
{ CPUFUNC(op_4ad8_0), 19160 }, /* TAS */
{ CPUFUNC(op_4ae0_0), 19168 }, /* TAS */
{ CPUFUNC(op_4ae8_0), 19176 }, /* TAS */
{ CPUFUNC(op_4af0_0), 19184 }, /* TAS */
{ CPUFUNC(op_4af8_0), 19192 }, /* TAS */
{ CPUFUNC(op_4af9_0), 19193 }, /* TAS */
{ CPUFUNC(op_4c00_0), 19456 }, /* MULL */
{ CPUFUNC(op_4c10_0), 19472 }, /* MULL */
{ CPUFUNC(op_4c18_0), 19480 }, /* MULL */
{ CPUFUNC(op_4c20_0), 19488 }, /* MULL */
{ CPUFUNC(op_4c28_0), 19496 }, /* MULL */
{ CPUFUNC(op_4c30_0), 19504 }, /* MULL */
{ CPUFUNC(op_4c38_0), 19512 }, /* MULL */
{ CPUFUNC(op_4c39_0), 19513 }, /* MULL */
{ CPUFUNC(op_4c3a_0), 19514 }, /* MULL */
{ CPUFUNC(op_4c3b_0), 19515 }, /* MULL */
{ CPUFUNC(op_4c3c_0), 19516 }, /* MULL */
{ CPUFUNC(op_4c40_0), 19520 }, /* DIVL */
{ CPUFUNC(op_4c50_0), 19536 }, /* DIVL */
{ CPUFUNC(op_4c58_0), 19544 }, /* DIVL */
{ CPUFUNC(op_4c60_0), 19552 }, /* DIVL */
{ CPUFUNC(op_4c68_0), 19560 }, /* DIVL */
{ CPUFUNC(op_4c70_0), 19568 }, /* DIVL */
{ CPUFUNC(op_4c78_0), 19576 }, /* DIVL */
{ CPUFUNC(op_4c79_0), 19577 }, /* DIVL */
{ CPUFUNC(op_4c7a_0), 19578 }, /* DIVL */
{ CPUFUNC(op_4c7b_0), 19579 }, /* DIVL */
{ CPUFUNC(op_4c7c_0), 19580 }, /* DIVL */
{ CPUFUNC(op_4c90_0), 19600 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 19608 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 19624 }, /* MVMEL */
{ CPUFUNC(op_4cb0_0), 19632 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 19640 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 19641 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 19642 }, /* MVMEL */
{ CPUFUNC(op_4cbb_0), 19643 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 19664 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 19672 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 19688 }, /* MVMEL */
{ CPUFUNC(op_4cf0_0), 19696 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 19704 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 19705 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 19706 }, /* MVMEL */
{ CPUFUNC(op_4cfb_0), 19707 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 20032 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 20048 }, /* LINK */
{ CPUFUNC(op_4e58_0), 20056 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 20064 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 20072 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 20080 }, /* RESET */
{ CPUFUNC(op_4e71_0), 20081 }, /* NOP */
{ CPUFUNC(op_4e72_0), 20082 }, /* STOP */
{ CPUFUNC(op_4e73_0), 20083 }, /* RTE */
{ CPUFUNC(op_4e74_0), 20084 }, /* RTD */
{ CPUFUNC(op_4e75_0), 20085 }, /* RTS */
{ CPUFUNC(op_4e76_0), 20086 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 20087 }, /* RTR */
{ CPUFUNC(op_4e7a_0), 20090 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_0), 20091 }, /* MOVE2C */
{ CPUFUNC(op_4e90_0), 20112 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 20136 }, /* JSR */
{ CPUFUNC(op_4eb0_0), 20144 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 20152 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 20153 }, /* JSR */
{ CPUFUNC(op_4eba_0), 20154 }, /* JSR */
{ CPUFUNC(op_4ebb_0), 20155 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 20176 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 20200 }, /* JMP */
{ CPUFUNC(op_4ef0_0), 20208 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 20216 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 20217 }, /* JMP */
{ CPUFUNC(op_4efa_0), 20218 }, /* JMP */
{ CPUFUNC(op_4efb_0), 20219 }, /* JMP */
{ CPUFUNC(op_5000_0), 20480 }, /* ADD */
{ CPUFUNC(op_5010_0), 20496 }, /* ADD */
{ CPUFUNC(op_5018_0), 20504 }, /* ADD */
{ CPUFUNC(op_5020_0), 20512 }, /* ADD */
{ CPUFUNC(op_5028_0), 20520 }, /* ADD */
{ CPUFUNC(op_5030_0), 20528 }, /* ADD */
{ CPUFUNC(op_5038_0), 20536 }, /* ADD */
{ CPUFUNC(op_5039_0), 20537 }, /* ADD */
{ CPUFUNC(op_5040_0), 20544 }, /* ADD */
{ CPUFUNC(op_5048_0), 20552 }, /* ADDA */
{ CPUFUNC(op_5050_0), 20560 }, /* ADD */
{ CPUFUNC(op_5058_0), 20568 }, /* ADD */
{ CPUFUNC(op_5060_0), 20576 }, /* ADD */
{ CPUFUNC(op_5068_0), 20584 }, /* ADD */
{ CPUFUNC(op_5070_0), 20592 }, /* ADD */
{ CPUFUNC(op_5078_0), 20600 }, /* ADD */
{ CPUFUNC(op_5079_0), 20601 }, /* ADD */
{ CPUFUNC(op_5080_0), 20608 }, /* ADD */
{ CPUFUNC(op_5088_0), 20616 }, /* ADDA */
{ CPUFUNC(op_5090_0), 20624 }, /* ADD */
{ CPUFUNC(op_5098_0), 20632 }, /* ADD */
{ CPUFUNC(op_50a0_0), 20640 }, /* ADD */
{ CPUFUNC(op_50a8_0), 20648 }, /* ADD */
{ CPUFUNC(op_50b0_0), 20656 }, /* ADD */
{ CPUFUNC(op_50b8_0), 20664 }, /* ADD */
{ CPUFUNC(op_50b9_0), 20665 }, /* ADD */
{ CPUFUNC(op_50c0_0), 20672 }, /* Scc */
{ CPUFUNC(op_50c8_0), 20680 }, /* DBcc */
{ CPUFUNC(op_50d0_0), 20688 }, /* Scc */
{ CPUFUNC(op_50d8_0), 20696 }, /* Scc */
{ CPUFUNC(op_50e0_0), 20704 }, /* Scc */
{ CPUFUNC(op_50e8_0), 20712 }, /* Scc */
{ CPUFUNC(op_50f0_0), 20720 }, /* Scc */
{ CPUFUNC(op_50f8_0), 20728 }, /* Scc */
{ CPUFUNC(op_50f9_0), 20729 }, /* Scc */
{ CPUFUNC(op_50fa_0), 20730 }, /* TRAPcc */
{ CPUFUNC(op_50fb_0), 20731 }, /* TRAPcc */
{ CPUFUNC(op_50fc_0), 20732 }, /* TRAPcc */
{ CPUFUNC(op_5100_0), 20736 }, /* SUB */
{ CPUFUNC(op_5110_0), 20752 }, /* SUB */
{ CPUFUNC(op_5118_0), 20760 }, /* SUB */
{ CPUFUNC(op_5120_0), 20768 }, /* SUB */
{ CPUFUNC(op_5128_0), 20776 }, /* SUB */
{ CPUFUNC(op_5130_0), 20784 }, /* SUB */
{ CPUFUNC(op_5138_0), 20792 }, /* SUB */
{ CPUFUNC(op_5139_0), 20793 }, /* SUB */
{ CPUFUNC(op_5140_0), 20800 }, /* SUB */
{ CPUFUNC(op_5148_0), 20808 }, /* SUBA */
{ CPUFUNC(op_5150_0), 20816 }, /* SUB */
{ CPUFUNC(op_5158_0), 20824 }, /* SUB */
{ CPUFUNC(op_5160_0), 20832 }, /* SUB */
{ CPUFUNC(op_5168_0), 20840 }, /* SUB */
{ CPUFUNC(op_5170_0), 20848 }, /* SUB */
{ CPUFUNC(op_5178_0), 20856 }, /* SUB */
{ CPUFUNC(op_5179_0), 20857 }, /* SUB */
{ CPUFUNC(op_5180_0), 20864 }, /* SUB */
{ CPUFUNC(op_5188_0), 20872 }, /* SUBA */
{ CPUFUNC(op_5190_0), 20880 }, /* SUB */
{ CPUFUNC(op_5198_0), 20888 }, /* SUB */
{ CPUFUNC(op_51a0_0), 20896 }, /* SUB */
{ CPUFUNC(op_51a8_0), 20904 }, /* SUB */
{ CPUFUNC(op_51b0_0), 20912 }, /* SUB */
{ CPUFUNC(op_51b8_0), 20920 }, /* SUB */
{ CPUFUNC(op_51b9_0), 20921 }, /* SUB */
{ CPUFUNC(op_51c0_0), 20928 }, /* Scc */
{ CPUFUNC(op_51c8_0), 20936 }, /* DBcc */
{ CPUFUNC(op_51d0_0), 20944 }, /* Scc */
{ CPUFUNC(op_51d8_0), 20952 }, /* Scc */
{ CPUFUNC(op_51e0_0), 20960 }, /* Scc */
{ CPUFUNC(op_51e8_0), 20968 }, /* Scc */
{ CPUFUNC(op_51f0_0), 20976 }, /* Scc */
{ CPUFUNC(op_51f8_0), 20984 }, /* Scc */
{ CPUFUNC(op_51f9_0), 20985 }, /* Scc */
{ CPUFUNC(op_51fa_0), 20986 }, /* TRAPcc */
{ CPUFUNC(op_51fb_0), 20987 }, /* TRAPcc */
{ CPUFUNC(op_51fc_0), 20988 }, /* TRAPcc */
{ CPUFUNC(op_52c0_0), 21184 }, /* Scc */
{ CPUFUNC(op_52c8_0), 21192 }, /* DBcc */
{ CPUFUNC(op_52d0_0), 21200 }, /* Scc */
{ CPUFUNC(op_52d8_0), 21208 }, /* Scc */
{ CPUFUNC(op_52e0_0), 21216 }, /* Scc */
{ CPUFUNC(op_52e8_0), 21224 }, /* Scc */
{ CPUFUNC(op_52f0_0), 21232 }, /* Scc */
{ CPUFUNC(op_52f8_0), 21240 }, /* Scc */
{ CPUFUNC(op_52f9_0), 21241 }, /* Scc */
{ CPUFUNC(op_52fa_0), 21242 }, /* TRAPcc */
{ CPUFUNC(op_52fb_0), 21243 }, /* TRAPcc */
{ CPUFUNC(op_52fc_0), 21244 }, /* TRAPcc */
{ CPUFUNC(op_53c0_0), 21440 }, /* Scc */
{ CPUFUNC(op_53c8_0), 21448 }, /* DBcc */
{ CPUFUNC(op_53d0_0), 21456 }, /* Scc */
{ CPUFUNC(op_53d8_0), 21464 }, /* Scc */
{ CPUFUNC(op_53e0_0), 21472 }, /* Scc */
{ CPUFUNC(op_53e8_0), 21480 }, /* Scc */
{ CPUFUNC(op_53f0_0), 21488 }, /* Scc */
{ CPUFUNC(op_53f8_0), 21496 }, /* Scc */
{ CPUFUNC(op_53f9_0), 21497 }, /* Scc */
{ CPUFUNC(op_53fa_0), 21498 }, /* TRAPcc */
{ CPUFUNC(op_53fb_0), 21499 }, /* TRAPcc */
{ CPUFUNC(op_53fc_0), 21500 }, /* TRAPcc */
{ CPUFUNC(op_54c0_0), 21696 }, /* Scc */
{ CPUFUNC(op_54c8_0), 21704 }, /* DBcc */
{ CPUFUNC(op_54d0_0), 21712 }, /* Scc */
{ CPUFUNC(op_54d8_0), 21720 }, /* Scc */
{ CPUFUNC(op_54e0_0), 21728 }, /* Scc */
{ CPUFUNC(op_54e8_0), 21736 }, /* Scc */
{ CPUFUNC(op_54f0_0), 21744 }, /* Scc */
{ CPUFUNC(op_54f8_0), 21752 }, /* Scc */
{ CPUFUNC(op_54f9_0), 21753 }, /* Scc */
{ CPUFUNC(op_54fa_0), 21754 }, /* TRAPcc */
{ CPUFUNC(op_54fb_0), 21755 }, /* TRAPcc */
{ CPUFUNC(op_54fc_0), 21756 }, /* TRAPcc */
{ CPUFUNC(op_55c0_0), 21952 }, /* Scc */
{ CPUFUNC(op_55c8_0), 21960 }, /* DBcc */
{ CPUFUNC(op_55d0_0), 21968 }, /* Scc */
{ CPUFUNC(op_55d8_0), 21976 }, /* Scc */
{ CPUFUNC(op_55e0_0), 21984 }, /* Scc */
{ CPUFUNC(op_55e8_0), 21992 }, /* Scc */
{ CPUFUNC(op_55f0_0), 22000 }, /* Scc */
{ CPUFUNC(op_55f8_0), 22008 }, /* Scc */
{ CPUFUNC(op_55f9_0), 22009 }, /* Scc */
{ CPUFUNC(op_55fa_0), 22010 }, /* TRAPcc */
{ CPUFUNC(op_55fb_0), 22011 }, /* TRAPcc */
{ CPUFUNC(op_55fc_0), 22012 }, /* TRAPcc */
{ CPUFUNC(op_56c0_0), 22208 }, /* Scc */
{ CPUFUNC(op_56c8_0), 22216 }, /* DBcc */
{ CPUFUNC(op_56d0_0), 22224 }, /* Scc */
{ CPUFUNC(op_56d8_0), 22232 }, /* Scc */
{ CPUFUNC(op_56e0_0), 22240 }, /* Scc */
{ CPUFUNC(op_56e8_0), 22248 }, /* Scc */
{ CPUFUNC(op_56f0_0), 22256 }, /* Scc */
{ CPUFUNC(op_56f8_0), 22264 }, /* Scc */
{ CPUFUNC(op_56f9_0), 22265 }, /* Scc */
{ CPUFUNC(op_56fa_0), 22266 }, /* TRAPcc */
{ CPUFUNC(op_56fb_0), 22267 }, /* TRAPcc */
{ CPUFUNC(op_56fc_0), 22268 }, /* TRAPcc */
{ CPUFUNC(op_57c0_0), 22464 }, /* Scc */
{ CPUFUNC(op_57c8_0), 22472 }, /* DBcc */
{ CPUFUNC(op_57d0_0), 22480 }, /* Scc */
{ CPUFUNC(op_57d8_0), 22488 }, /* Scc */
{ CPUFUNC(op_57e0_0), 22496 }, /* Scc */
{ CPUFUNC(op_57e8_0), 22504 }, /* Scc */
{ CPUFUNC(op_57f0_0), 22512 }, /* Scc */
{ CPUFUNC(op_57f8_0), 22520 }, /* Scc */
{ CPUFUNC(op_57f9_0), 22521 }, /* Scc */
{ CPUFUNC(op_57fa_0), 22522 }, /* TRAPcc */
{ CPUFUNC(op_57fb_0), 22523 }, /* TRAPcc */
{ CPUFUNC(op_57fc_0), 22524 }, /* TRAPcc */
{ CPUFUNC(op_58c0_0), 22720 }, /* Scc */
{ CPUFUNC(op_58c8_0), 22728 }, /* DBcc */
{ CPUFUNC(op_58d0_0), 22736 }, /* Scc */
{ CPUFUNC(op_58d8_0), 22744 }, /* Scc */
{ CPUFUNC(op_58e0_0), 22752 }, /* Scc */
{ CPUFUNC(op_58e8_0), 22760 }, /* Scc */
{ CPUFUNC(op_58f0_0), 22768 }, /* Scc */
{ CPUFUNC(op_58f8_0), 22776 }, /* Scc */
{ CPUFUNC(op_58f9_0), 22777 }, /* Scc */
{ CPUFUNC(op_58fa_0), 22778 }, /* TRAPcc */
{ CPUFUNC(op_58fb_0), 22779 }, /* TRAPcc */
{ CPUFUNC(op_58fc_0), 22780 }, /* TRAPcc */
{ CPUFUNC(op_59c0_0), 22976 }, /* Scc */
{ CPUFUNC(op_59c8_0), 22984 }, /* DBcc */
{ CPUFUNC(op_59d0_0), 22992 }, /* Scc */
{ CPUFUNC(op_59d8_0), 23000 }, /* Scc */
{ CPUFUNC(op_59e0_0), 23008 }, /* Scc */
{ CPUFUNC(op_59e8_0), 23016 }, /* Scc */
{ CPUFUNC(op_59f0_0), 23024 }, /* Scc */
{ CPUFUNC(op_59f8_0), 23032 }, /* Scc */
{ CPUFUNC(op_59f9_0), 23033 }, /* Scc */
{ CPUFUNC(op_59fa_0), 23034 }, /* TRAPcc */
{ CPUFUNC(op_59fb_0), 23035 }, /* TRAPcc */
{ CPUFUNC(op_59fc_0), 23036 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_0), 23232 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 23240 }, /* DBcc */
{ CPUFUNC(op_5ad0_0), 23248 }, /* Scc */
{ CPUFUNC(op_5ad8_0), 23256 }, /* Scc */
{ CPUFUNC(op_5ae0_0), 23264 }, /* Scc */
{ CPUFUNC(op_5ae8_0), 23272 }, /* Scc */
{ CPUFUNC(op_5af0_0), 23280 }, /* Scc */
{ CPUFUNC(op_5af8_0), 23288 }, /* Scc */
{ CPUFUNC(op_5af9_0), 23289 }, /* Scc */
{ CPUFUNC(op_5afa_0), 23290 }, /* TRAPcc */
{ CPUFUNC(op_5afb_0), 23291 }, /* TRAPcc */
{ CPUFUNC(op_5afc_0), 23292 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_0), 23488 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 23496 }, /* DBcc */
{ CPUFUNC(op_5bd0_0), 23504 }, /* Scc */
{ CPUFUNC(op_5bd8_0), 23512 }, /* Scc */
{ CPUFUNC(op_5be0_0), 23520 }, /* Scc */
{ CPUFUNC(op_5be8_0), 23528 }, /* Scc */
{ CPUFUNC(op_5bf0_0), 23536 }, /* Scc */
{ CPUFUNC(op_5bf8_0), 23544 }, /* Scc */
{ CPUFUNC(op_5bf9_0), 23545 }, /* Scc */
{ CPUFUNC(op_5bfa_0), 23546 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_0), 23547 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_0), 23548 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_0), 23744 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 23752 }, /* DBcc */
{ CPUFUNC(op_5cd0_0), 23760 }, /* Scc */
{ CPUFUNC(op_5cd8_0), 23768 }, /* Scc */
{ CPUFUNC(op_5ce0_0), 23776 }, /* Scc */
{ CPUFUNC(op_5ce8_0), 23784 }, /* Scc */
{ CPUFUNC(op_5cf0_0), 23792 }, /* Scc */
{ CPUFUNC(op_5cf8_0), 23800 }, /* Scc */
{ CPUFUNC(op_5cf9_0), 23801 }, /* Scc */
{ CPUFUNC(op_5cfa_0), 23802 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_0), 23803 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_0), 23804 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_0), 24000 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 24008 }, /* DBcc */
{ CPUFUNC(op_5dd0_0), 24016 }, /* Scc */
{ CPUFUNC(op_5dd8_0), 24024 }, /* Scc */
{ CPUFUNC(op_5de0_0), 24032 }, /* Scc */
{ CPUFUNC(op_5de8_0), 24040 }, /* Scc */
{ CPUFUNC(op_5df0_0), 24048 }, /* Scc */
{ CPUFUNC(op_5df8_0), 24056 }, /* Scc */
{ CPUFUNC(op_5df9_0), 24057 }, /* Scc */
{ CPUFUNC(op_5dfa_0), 24058 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_0), 24059 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_0), 24060 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_0), 24256 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 24264 }, /* DBcc */
{ CPUFUNC(op_5ed0_0), 24272 }, /* Scc */
{ CPUFUNC(op_5ed8_0), 24280 }, /* Scc */
{ CPUFUNC(op_5ee0_0), 24288 }, /* Scc */
{ CPUFUNC(op_5ee8_0), 24296 }, /* Scc */
{ CPUFUNC(op_5ef0_0), 24304 }, /* Scc */
{ CPUFUNC(op_5ef8_0), 24312 }, /* Scc */
{ CPUFUNC(op_5ef9_0), 24313 }, /* Scc */
{ CPUFUNC(op_5efa_0), 24314 }, /* TRAPcc */
{ CPUFUNC(op_5efb_0), 24315 }, /* TRAPcc */
{ CPUFUNC(op_5efc_0), 24316 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_0), 24512 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 24520 }, /* DBcc */
{ CPUFUNC(op_5fd0_0), 24528 }, /* Scc */
{ CPUFUNC(op_5fd8_0), 24536 }, /* Scc */
{ CPUFUNC(op_5fe0_0), 24544 }, /* Scc */
{ CPUFUNC(op_5fe8_0), 24552 }, /* Scc */
{ CPUFUNC(op_5ff0_0), 24560 }, /* Scc */
{ CPUFUNC(op_5ff8_0), 24568 }, /* Scc */
{ CPUFUNC(op_5ff9_0), 24569 }, /* Scc */
{ CPUFUNC(op_5ffa_0), 24570 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_0), 24571 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_0), 24572 }, /* TRAPcc */
{ CPUFUNC(op_6000_0), 24576 }, /* Bcc */
{ CPUFUNC(op_6001_0), 24577 }, /* Bcc */
{ CPUFUNC(op_60ff_0), 24831 }, /* Bcc */
{ CPUFUNC(op_6100_0), 24832 }, /* BSR */
{ CPUFUNC(op_6101_0), 24833 }, /* BSR */
{ CPUFUNC(op_61ff_0), 25087 }, /* BSR */
{ CPUFUNC(op_6200_0), 25088 }, /* Bcc */
{ CPUFUNC(op_6201_0), 25089 }, /* Bcc */
{ CPUFUNC(op_62ff_0), 25343 }, /* Bcc */
{ CPUFUNC(op_6300_0), 25344 }, /* Bcc */
{ CPUFUNC(op_6301_0), 25345 }, /* Bcc */
{ CPUFUNC(op_63ff_0), 25599 }, /* Bcc */
{ CPUFUNC(op_6400_0), 25600 }, /* Bcc */
{ CPUFUNC(op_6401_0), 25601 }, /* Bcc */
{ CPUFUNC(op_64ff_0), 25855 }, /* Bcc */
{ CPUFUNC(op_6500_0), 25856 }, /* Bcc */
{ CPUFUNC(op_6501_0), 25857 }, /* Bcc */
{ CPUFUNC(op_65ff_0), 26111 }, /* Bcc */
{ CPUFUNC(op_6600_0), 26112 }, /* Bcc */
{ CPUFUNC(op_6601_0), 26113 }, /* Bcc */
{ CPUFUNC(op_66ff_0), 26367 }, /* Bcc */
{ CPUFUNC(op_6700_0), 26368 }, /* Bcc */
{ CPUFUNC(op_6701_0), 26369 }, /* Bcc */
{ CPUFUNC(op_67ff_0), 26623 }, /* Bcc */
{ CPUFUNC(op_6800_0), 26624 }, /* Bcc */
{ CPUFUNC(op_6801_0), 26625 }, /* Bcc */
{ CPUFUNC(op_68ff_0), 26879 }, /* Bcc */
{ CPUFUNC(op_6900_0), 26880 }, /* Bcc */
{ CPUFUNC(op_6901_0), 26881 }, /* Bcc */
{ CPUFUNC(op_69ff_0), 27135 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 27136 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 27137 }, /* Bcc */
{ CPUFUNC(op_6aff_0), 27391 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 27392 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 27393 }, /* Bcc */
{ CPUFUNC(op_6bff_0), 27647 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 27648 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 27649 }, /* Bcc */
{ CPUFUNC(op_6cff_0), 27903 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 27904 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 27905 }, /* Bcc */
{ CPUFUNC(op_6dff_0), 28159 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 28160 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 28161 }, /* Bcc */
{ CPUFUNC(op_6eff_0), 28415 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 28416 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 28417 }, /* Bcc */
{ CPUFUNC(op_6fff_0), 28671 }, /* Bcc */
{ CPUFUNC(op_7000_0), 28672 }, /* MOVE */
{ CPUFUNC(op_8000_0), 32768 }, /* OR */
{ CPUFUNC(op_8010_0), 32784 }, /* OR */
{ CPUFUNC(op_8018_0), 32792 }, /* OR */
{ CPUFUNC(op_8020_0), 32800 }, /* OR */
{ CPUFUNC(op_8028_0), 32808 }, /* OR */
{ CPUFUNC(op_8030_0), 32816 }, /* OR */
{ CPUFUNC(op_8038_0), 32824 }, /* OR */
{ CPUFUNC(op_8039_0), 32825 }, /* OR */
{ CPUFUNC(op_803a_0), 32826 }, /* OR */
{ CPUFUNC(op_803b_0), 32827 }, /* OR */
{ CPUFUNC(op_803c_0), 32828 }, /* OR */
{ CPUFUNC(op_8040_0), 32832 }, /* OR */
{ CPUFUNC(op_8050_0), 32848 }, /* OR */
{ CPUFUNC(op_8058_0), 32856 }, /* OR */
{ CPUFUNC(op_8060_0), 32864 }, /* OR */
{ CPUFUNC(op_8068_0), 32872 }, /* OR */
{ CPUFUNC(op_8070_0), 32880 }, /* OR */
{ CPUFUNC(op_8078_0), 32888 }, /* OR */
{ CPUFUNC(op_8079_0), 32889 }, /* OR */
{ CPUFUNC(op_807a_0), 32890 }, /* OR */
{ CPUFUNC(op_807b_0), 32891 }, /* OR */
{ CPUFUNC(op_807c_0), 32892 }, /* OR */
{ CPUFUNC(op_8080_0), 32896 }, /* OR */
{ CPUFUNC(op_8090_0), 32912 }, /* OR */
{ CPUFUNC(op_8098_0), 32920 }, /* OR */
{ CPUFUNC(op_80a0_0), 32928 }, /* OR */
{ CPUFUNC(op_80a8_0), 32936 }, /* OR */
{ CPUFUNC(op_80b0_0), 32944 }, /* OR */
{ CPUFUNC(op_80b8_0), 32952 }, /* OR */
{ CPUFUNC(op_80b9_0), 32953 }, /* OR */
{ CPUFUNC(op_80ba_0), 32954 }, /* OR */
{ CPUFUNC(op_80bb_0), 32955 }, /* OR */
{ CPUFUNC(op_80bc_0), 32956 }, /* OR */
{ CPUFUNC(op_80c0_0), 32960 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 32976 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 32984 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 32992 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 33000 }, /* DIVU */
{ CPUFUNC(op_80f0_0), 33008 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 33016 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 33017 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 33018 }, /* DIVU */
{ CPUFUNC(op_80fb_0), 33019 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 33020 }, /* DIVU */
{ CPUFUNC(op_8100_0), 33024 }, /* SBCD */
{ CPUFUNC(op_8108_0), 33032 }, /* SBCD */
{ CPUFUNC(op_8110_0), 33040 }, /* OR */
{ CPUFUNC(op_8118_0), 33048 }, /* OR */
{ CPUFUNC(op_8120_0), 33056 }, /* OR */
{ CPUFUNC(op_8128_0), 33064 }, /* OR */
{ CPUFUNC(op_8130_0), 33072 }, /* OR */
{ CPUFUNC(op_8138_0), 33080 }, /* OR */
{ CPUFUNC(op_8139_0), 33081 }, /* OR */
{ CPUFUNC(op_8140_0), 33088 }, /* PACK */
{ CPUFUNC(op_8148_0), 33096 }, /* PACK */
{ CPUFUNC(op_8150_0), 33104 }, /* OR */
{ CPUFUNC(op_8158_0), 33112 }, /* OR */
{ CPUFUNC(op_8160_0), 33120 }, /* OR */
{ CPUFUNC(op_8168_0), 33128 }, /* OR */
{ CPUFUNC(op_8170_0), 33136 }, /* OR */
{ CPUFUNC(op_8178_0), 33144 }, /* OR */
{ CPUFUNC(op_8179_0), 33145 }, /* OR */
{ CPUFUNC(op_8180_0), 33152 }, /* UNPK */
{ CPUFUNC(op_8188_0), 33160 }, /* UNPK */
{ CPUFUNC(op_8190_0), 33168 }, /* OR */
{ CPUFUNC(op_8198_0), 33176 }, /* OR */
{ CPUFUNC(op_81a0_0), 33184 }, /* OR */
{ CPUFUNC(op_81a8_0), 33192 }, /* OR */
{ CPUFUNC(op_81b0_0), 33200 }, /* OR */
{ CPUFUNC(op_81b8_0), 33208 }, /* OR */
{ CPUFUNC(op_81b9_0), 33209 }, /* OR */
{ CPUFUNC(op_81c0_0), 33216 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 33232 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 33240 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 33248 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 33256 }, /* DIVS */
{ CPUFUNC(op_81f0_0), 33264 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 33272 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 33273 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 33274 }, /* DIVS */
{ CPUFUNC(op_81fb_0), 33275 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 33276 }, /* DIVS */
{ CPUFUNC(op_9000_0), 36864 }, /* SUB */
{ CPUFUNC(op_9010_0), 36880 }, /* SUB */
{ CPUFUNC(op_9018_0), 36888 }, /* SUB */
{ CPUFUNC(op_9020_0), 36896 }, /* SUB */
{ CPUFUNC(op_9028_0), 36904 }, /* SUB */
{ CPUFUNC(op_9030_0), 36912 }, /* SUB */
{ CPUFUNC(op_9038_0), 36920 }, /* SUB */
{ CPUFUNC(op_9039_0), 36921 }, /* SUB */
{ CPUFUNC(op_903a_0), 36922 }, /* SUB */
{ CPUFUNC(op_903b_0), 36923 }, /* SUB */
{ CPUFUNC(op_903c_0), 36924 }, /* SUB */
{ CPUFUNC(op_9040_0), 36928 }, /* SUB */
{ CPUFUNC(op_9048_0), 36936 }, /* SUB */
{ CPUFUNC(op_9050_0), 36944 }, /* SUB */
{ CPUFUNC(op_9058_0), 36952 }, /* SUB */
{ CPUFUNC(op_9060_0), 36960 }, /* SUB */
{ CPUFUNC(op_9068_0), 36968 }, /* SUB */
{ CPUFUNC(op_9070_0), 36976 }, /* SUB */
{ CPUFUNC(op_9078_0), 36984 }, /* SUB */
{ CPUFUNC(op_9079_0), 36985 }, /* SUB */
{ CPUFUNC(op_907a_0), 36986 }, /* SUB */
{ CPUFUNC(op_907b_0), 36987 }, /* SUB */
{ CPUFUNC(op_907c_0), 36988 }, /* SUB */
{ CPUFUNC(op_9080_0), 36992 }, /* SUB */
{ CPUFUNC(op_9088_0), 37000 }, /* SUB */
{ CPUFUNC(op_9090_0), 37008 }, /* SUB */
{ CPUFUNC(op_9098_0), 37016 }, /* SUB */
{ CPUFUNC(op_90a0_0), 37024 }, /* SUB */
{ CPUFUNC(op_90a8_0), 37032 }, /* SUB */
{ CPUFUNC(op_90b0_0), 37040 }, /* SUB */
{ CPUFUNC(op_90b8_0), 37048 }, /* SUB */
{ CPUFUNC(op_90b9_0), 37049 }, /* SUB */
{ CPUFUNC(op_90ba_0), 37050 }, /* SUB */
{ CPUFUNC(op_90bb_0), 37051 }, /* SUB */
{ CPUFUNC(op_90bc_0), 37052 }, /* SUB */
{ CPUFUNC(op_90c0_0), 37056 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 37064 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 37072 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 37080 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 37088 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 37096 }, /* SUBA */
{ CPUFUNC(op_90f0_0), 37104 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 37112 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 37113 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 37114 }, /* SUBA */
{ CPUFUNC(op_90fb_0), 37115 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 37116 }, /* SUBA */
{ CPUFUNC(op_9100_0), 37120 }, /* SUBX */
{ CPUFUNC(op_9108_0), 37128 }, /* SUBX */
{ CPUFUNC(op_9110_0), 37136 }, /* SUB */
{ CPUFUNC(op_9118_0), 37144 }, /* SUB */
{ CPUFUNC(op_9120_0), 37152 }, /* SUB */
{ CPUFUNC(op_9128_0), 37160 }, /* SUB */
{ CPUFUNC(op_9130_0), 37168 }, /* SUB */
{ CPUFUNC(op_9138_0), 37176 }, /* SUB */
{ CPUFUNC(op_9139_0), 37177 }, /* SUB */
{ CPUFUNC(op_9140_0), 37184 }, /* SUBX */
{ CPUFUNC(op_9148_0), 37192 }, /* SUBX */
{ CPUFUNC(op_9150_0), 37200 }, /* SUB */
{ CPUFUNC(op_9158_0), 37208 }, /* SUB */
{ CPUFUNC(op_9160_0), 37216 }, /* SUB */
{ CPUFUNC(op_9168_0), 37224 }, /* SUB */
{ CPUFUNC(op_9170_0), 37232 }, /* SUB */
{ CPUFUNC(op_9178_0), 37240 }, /* SUB */
{ CPUFUNC(op_9179_0), 37241 }, /* SUB */
{ CPUFUNC(op_9180_0), 37248 }, /* SUBX */
{ CPUFUNC(op_9188_0), 37256 }, /* SUBX */
{ CPUFUNC(op_9190_0), 37264 }, /* SUB */
{ CPUFUNC(op_9198_0), 37272 }, /* SUB */
{ CPUFUNC(op_91a0_0), 37280 }, /* SUB */
{ CPUFUNC(op_91a8_0), 37288 }, /* SUB */
{ CPUFUNC(op_91b0_0), 37296 }, /* SUB */
{ CPUFUNC(op_91b8_0), 37304 }, /* SUB */
{ CPUFUNC(op_91b9_0), 37305 }, /* SUB */
{ CPUFUNC(op_91c0_0), 37312 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 37320 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 37328 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 37336 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 37344 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 37352 }, /* SUBA */
{ CPUFUNC(op_91f0_0), 37360 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 37368 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 37369 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 37370 }, /* SUBA */
{ CPUFUNC(op_91fb_0), 37371 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 37372 }, /* SUBA */
{ CPUFUNC(op_b000_0), 45056 }, /* CMP */
{ CPUFUNC(op_b010_0), 45072 }, /* CMP */
{ CPUFUNC(op_b018_0), 45080 }, /* CMP */
{ CPUFUNC(op_b020_0), 45088 }, /* CMP */
{ CPUFUNC(op_b028_0), 45096 }, /* CMP */
{ CPUFUNC(op_b030_0), 45104 }, /* CMP */
{ CPUFUNC(op_b038_0), 45112 }, /* CMP */
{ CPUFUNC(op_b039_0), 45113 }, /* CMP */
{ CPUFUNC(op_b03a_0), 45114 }, /* CMP */
{ CPUFUNC(op_b03b_0), 45115 }, /* CMP */
{ CPUFUNC(op_b03c_0), 45116 }, /* CMP */
{ CPUFUNC(op_b040_0), 45120 }, /* CMP */
{ CPUFUNC(op_b048_0), 45128 }, /* CMP */
{ CPUFUNC(op_b050_0), 45136 }, /* CMP */
{ CPUFUNC(op_b058_0), 45144 }, /* CMP */
{ CPUFUNC(op_b060_0), 45152 }, /* CMP */
{ CPUFUNC(op_b068_0), 45160 }, /* CMP */
{ CPUFUNC(op_b070_0), 45168 }, /* CMP */
{ CPUFUNC(op_b078_0), 45176 }, /* CMP */
{ CPUFUNC(op_b079_0), 45177 }, /* CMP */
{ CPUFUNC(op_b07a_0), 45178 }, /* CMP */
{ CPUFUNC(op_b07b_0), 45179 }, /* CMP */
{ CPUFUNC(op_b07c_0), 45180 }, /* CMP */
{ CPUFUNC(op_b080_0), 45184 }, /* CMP */
{ CPUFUNC(op_b088_0), 45192 }, /* CMP */
{ CPUFUNC(op_b090_0), 45200 }, /* CMP */
{ CPUFUNC(op_b098_0), 45208 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 45216 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 45224 }, /* CMP */
{ CPUFUNC(op_b0b0_0), 45232 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 45240 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 45241 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 45242 }, /* CMP */
{ CPUFUNC(op_b0bb_0), 45243 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 45244 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 45248 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 45256 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 45264 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 45272 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 45280 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 45288 }, /* CMPA */
{ CPUFUNC(op_b0f0_0), 45296 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 45304 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 45305 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 45306 }, /* CMPA */
{ CPUFUNC(op_b0fb_0), 45307 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 45308 }, /* CMPA */
{ CPUFUNC(op_b100_0), 45312 }, /* EOR */
{ CPUFUNC(op_b108_0), 45320 }, /* CMPM */
{ CPUFUNC(op_b110_0), 45328 }, /* EOR */
{ CPUFUNC(op_b118_0), 45336 }, /* EOR */
{ CPUFUNC(op_b120_0), 45344 }, /* EOR */
{ CPUFUNC(op_b128_0), 45352 }, /* EOR */
{ CPUFUNC(op_b130_0), 45360 }, /* EOR */
{ CPUFUNC(op_b138_0), 45368 }, /* EOR */
{ CPUFUNC(op_b139_0), 45369 }, /* EOR */
{ CPUFUNC(op_b140_0), 45376 }, /* EOR */
{ CPUFUNC(op_b148_0), 45384 }, /* CMPM */
{ CPUFUNC(op_b150_0), 45392 }, /* EOR */
{ CPUFUNC(op_b158_0), 45400 }, /* EOR */
{ CPUFUNC(op_b160_0), 45408 }, /* EOR */
{ CPUFUNC(op_b168_0), 45416 }, /* EOR */
{ CPUFUNC(op_b170_0), 45424 }, /* EOR */
{ CPUFUNC(op_b178_0), 45432 }, /* EOR */
{ CPUFUNC(op_b179_0), 45433 }, /* EOR */
{ CPUFUNC(op_b180_0), 45440 }, /* EOR */
{ CPUFUNC(op_b188_0), 45448 }, /* CMPM */
{ CPUFUNC(op_b190_0), 45456 }, /* EOR */
{ CPUFUNC(op_b198_0), 45464 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 45472 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 45480 }, /* EOR */
{ CPUFUNC(op_b1b0_0), 45488 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 45496 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 45497 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 45504 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 45512 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 45520 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 45528 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 45536 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 45544 }, /* CMPA */
{ CPUFUNC(op_b1f0_0), 45552 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 45560 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 45561 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 45562 }, /* CMPA */
{ CPUFUNC(op_b1fb_0), 45563 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 45564 }, /* CMPA */
{ CPUFUNC(op_c000_0), 49152 }, /* AND */
{ CPUFUNC(op_c010_0), 49168 }, /* AND */
{ CPUFUNC(op_c018_0), 49176 }, /* AND */
{ CPUFUNC(op_c020_0), 49184 }, /* AND */
{ CPUFUNC(op_c028_0), 49192 }, /* AND */
{ CPUFUNC(op_c030_0), 49200 }, /* AND */
{ CPUFUNC(op_c038_0), 49208 }, /* AND */
{ CPUFUNC(op_c039_0), 49209 }, /* AND */
{ CPUFUNC(op_c03a_0), 49210 }, /* AND */
{ CPUFUNC(op_c03b_0), 49211 }, /* AND */
{ CPUFUNC(op_c03c_0), 49212 }, /* AND */
{ CPUFUNC(op_c040_0), 49216 }, /* AND */
{ CPUFUNC(op_c050_0), 49232 }, /* AND */
{ CPUFUNC(op_c058_0), 49240 }, /* AND */
{ CPUFUNC(op_c060_0), 49248 }, /* AND */
{ CPUFUNC(op_c068_0), 49256 }, /* AND */
{ CPUFUNC(op_c070_0), 49264 }, /* AND */
{ CPUFUNC(op_c078_0), 49272 }, /* AND */
{ CPUFUNC(op_c079_0), 49273 }, /* AND */
{ CPUFUNC(op_c07a_0), 49274 }, /* AND */
{ CPUFUNC(op_c07b_0), 49275 }, /* AND */
{ CPUFUNC(op_c07c_0), 49276 }, /* AND */
{ CPUFUNC(op_c080_0), 49280 }, /* AND */
{ CPUFUNC(op_c090_0), 49296 }, /* AND */
{ CPUFUNC(op_c098_0), 49304 }, /* AND */
{ CPUFUNC(op_c0a0_0), 49312 }, /* AND */
{ CPUFUNC(op_c0a8_0), 49320 }, /* AND */
{ CPUFUNC(op_c0b0_0), 49328 }, /* AND */
{ CPUFUNC(op_c0b8_0), 49336 }, /* AND */
{ CPUFUNC(op_c0b9_0), 49337 }, /* AND */
{ CPUFUNC(op_c0ba_0), 49338 }, /* AND */
{ CPUFUNC(op_c0bb_0), 49339 }, /* AND */
{ CPUFUNC(op_c0bc_0), 49340 }, /* AND */
{ CPUFUNC(op_c0c0_0), 49344 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 49360 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 49368 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 49376 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 49384 }, /* MULU */
{ CPUFUNC(op_c0f0_0), 49392 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 49400 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 49401 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 49402 }, /* MULU */
{ CPUFUNC(op_c0fb_0), 49403 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 49404 }, /* MULU */
{ CPUFUNC(op_c100_0), 49408 }, /* ABCD */
{ CPUFUNC(op_c108_0), 49416 }, /* ABCD */
{ CPUFUNC(op_c110_0), 49424 }, /* AND */
{ CPUFUNC(op_c118_0), 49432 }, /* AND */
{ CPUFUNC(op_c120_0), 49440 }, /* AND */
{ CPUFUNC(op_c128_0), 49448 }, /* AND */
{ CPUFUNC(op_c130_0), 49456 }, /* AND */
{ CPUFUNC(op_c138_0), 49464 }, /* AND */
{ CPUFUNC(op_c139_0), 49465 }, /* AND */
{ CPUFUNC(op_c140_0), 49472 }, /* EXG */
{ CPUFUNC(op_c148_0), 49480 }, /* EXG */
{ CPUFUNC(op_c150_0), 49488 }, /* AND */
{ CPUFUNC(op_c158_0), 49496 }, /* AND */
{ CPUFUNC(op_c160_0), 49504 }, /* AND */
{ CPUFUNC(op_c168_0), 49512 }, /* AND */
{ CPUFUNC(op_c170_0), 49520 }, /* AND */
{ CPUFUNC(op_c178_0), 49528 }, /* AND */
{ CPUFUNC(op_c179_0), 49529 }, /* AND */
{ CPUFUNC(op_c188_0), 49544 }, /* EXG */
{ CPUFUNC(op_c190_0), 49552 }, /* AND */
{ CPUFUNC(op_c198_0), 49560 }, /* AND */
{ CPUFUNC(op_c1a0_0), 49568 }, /* AND */
{ CPUFUNC(op_c1a8_0), 49576 }, /* AND */
{ CPUFUNC(op_c1b0_0), 49584 }, /* AND */
{ CPUFUNC(op_c1b8_0), 49592 }, /* AND */
{ CPUFUNC(op_c1b9_0), 49593 }, /* AND */
{ CPUFUNC(op_c1c0_0), 49600 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 49616 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 49624 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 49632 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 49640 }, /* MULS */
{ CPUFUNC(op_c1f0_0), 49648 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 49656 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 49657 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 49658 }, /* MULS */
{ CPUFUNC(op_c1fb_0), 49659 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 49660 }, /* MULS */
{ CPUFUNC(op_d000_0), 53248 }, /* ADD */
{ CPUFUNC(op_d010_0), 53264 }, /* ADD */
{ CPUFUNC(op_d018_0), 53272 }, /* ADD */
{ CPUFUNC(op_d020_0), 53280 }, /* ADD */
{ CPUFUNC(op_d028_0), 53288 }, /* ADD */
{ CPUFUNC(op_d030_0), 53296 }, /* ADD */
{ CPUFUNC(op_d038_0), 53304 }, /* ADD */
{ CPUFUNC(op_d039_0), 53305 }, /* ADD */
{ CPUFUNC(op_d03a_0), 53306 }, /* ADD */
{ CPUFUNC(op_d03b_0), 53307 }, /* ADD */
{ CPUFUNC(op_d03c_0), 53308 }, /* ADD */
{ CPUFUNC(op_d040_0), 53312 }, /* ADD */
{ CPUFUNC(op_d048_0), 53320 }, /* ADD */
{ CPUFUNC(op_d050_0), 53328 }, /* ADD */
{ CPUFUNC(op_d058_0), 53336 }, /* ADD */
{ CPUFUNC(op_d060_0), 53344 }, /* ADD */
{ CPUFUNC(op_d068_0), 53352 }, /* ADD */
{ CPUFUNC(op_d070_0), 53360 }, /* ADD */
{ CPUFUNC(op_d078_0), 53368 }, /* ADD */
{ CPUFUNC(op_d079_0), 53369 }, /* ADD */
{ CPUFUNC(op_d07a_0), 53370 }, /* ADD */
{ CPUFUNC(op_d07b_0), 53371 }, /* ADD */
{ CPUFUNC(op_d07c_0), 53372 }, /* ADD */
{ CPUFUNC(op_d080_0), 53376 }, /* ADD */
{ CPUFUNC(op_d088_0), 53384 }, /* ADD */
{ CPUFUNC(op_d090_0), 53392 }, /* ADD */
{ CPUFUNC(op_d098_0), 53400 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 53408 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 53416 }, /* ADD */
{ CPUFUNC(op_d0b0_0), 53424 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 53432 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 53433 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 53434 }, /* ADD */
{ CPUFUNC(op_d0bb_0), 53435 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 53436 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 53440 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 53448 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 53456 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 53464 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 53472 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 53480 }, /* ADDA */
{ CPUFUNC(op_d0f0_0), 53488 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 53496 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 53497 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 53498 }, /* ADDA */
{ CPUFUNC(op_d0fb_0), 53499 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 53500 }, /* ADDA */
{ CPUFUNC(op_d100_0), 53504 }, /* ADDX */
{ CPUFUNC(op_d108_0), 53512 }, /* ADDX */
{ CPUFUNC(op_d110_0), 53520 }, /* ADD */
{ CPUFUNC(op_d118_0), 53528 }, /* ADD */
{ CPUFUNC(op_d120_0), 53536 }, /* ADD */
{ CPUFUNC(op_d128_0), 53544 }, /* ADD */
{ CPUFUNC(op_d130_0), 53552 }, /* ADD */
{ CPUFUNC(op_d138_0), 53560 }, /* ADD */
{ CPUFUNC(op_d139_0), 53561 }, /* ADD */
{ CPUFUNC(op_d140_0), 53568 }, /* ADDX */
{ CPUFUNC(op_d148_0), 53576 }, /* ADDX */
{ CPUFUNC(op_d150_0), 53584 }, /* ADD */
{ CPUFUNC(op_d158_0), 53592 }, /* ADD */
{ CPUFUNC(op_d160_0), 53600 }, /* ADD */
{ CPUFUNC(op_d168_0), 53608 }, /* ADD */
{ CPUFUNC(op_d170_0), 53616 }, /* ADD */
{ CPUFUNC(op_d178_0), 53624 }, /* ADD */
{ CPUFUNC(op_d179_0), 53625 }, /* ADD */
{ CPUFUNC(op_d180_0), 53632 }, /* ADDX */
{ CPUFUNC(op_d188_0), 53640 }, /* ADDX */
{ CPUFUNC(op_d190_0), 53648 }, /* ADD */
{ CPUFUNC(op_d198_0), 53656 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 53664 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 53672 }, /* ADD */
{ CPUFUNC(op_d1b0_0), 53680 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 53688 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 53689 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 53696 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 53704 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 53712 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 53720 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 53728 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 53736 }, /* ADDA */
{ CPUFUNC(op_d1f0_0), 53744 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 53752 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 53753 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 53754 }, /* ADDA */
{ CPUFUNC(op_d1fb_0), 53755 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 53756 }, /* ADDA */
{ CPUFUNC(op_e000_0), 57344 }, /* ASR */
{ CPUFUNC(op_e008_0), 57352 }, /* LSR */
{ CPUFUNC(op_e010_0), 57360 }, /* ROXR */
{ CPUFUNC(op_e018_0), 57368 }, /* ROR */
{ CPUFUNC(op_e020_0), 57376 }, /* ASR */
{ CPUFUNC(op_e028_0), 57384 }, /* LSR */
{ CPUFUNC(op_e030_0), 57392 }, /* ROXR */
{ CPUFUNC(op_e038_0), 57400 }, /* ROR */
{ CPUFUNC(op_e040_0), 57408 }, /* ASR */
{ CPUFUNC(op_e048_0), 57416 }, /* LSR */
{ CPUFUNC(op_e050_0), 57424 }, /* ROXR */
{ CPUFUNC(op_e058_0), 57432 }, /* ROR */
{ CPUFUNC(op_e060_0), 57440 }, /* ASR */
{ CPUFUNC(op_e068_0), 57448 }, /* LSR */
{ CPUFUNC(op_e070_0), 57456 }, /* ROXR */
{ CPUFUNC(op_e078_0), 57464 }, /* ROR */
{ CPUFUNC(op_e080_0), 57472 }, /* ASR */
{ CPUFUNC(op_e088_0), 57480 }, /* LSR */
{ CPUFUNC(op_e090_0), 57488 }, /* ROXR */
{ CPUFUNC(op_e098_0), 57496 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 57504 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 57512 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 57520 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 57528 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 57552 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 57560 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 57568 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 57576 }, /* ASRW */
{ CPUFUNC(op_e0f0_0), 57584 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 57592 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 57593 }, /* ASRW */
{ CPUFUNC(op_e100_0), 57600 }, /* ASL */
{ CPUFUNC(op_e108_0), 57608 }, /* LSL */
{ CPUFUNC(op_e110_0), 57616 }, /* ROXL */
{ CPUFUNC(op_e118_0), 57624 }, /* ROL */
{ CPUFUNC(op_e120_0), 57632 }, /* ASL */
{ CPUFUNC(op_e128_0), 57640 }, /* LSL */
{ CPUFUNC(op_e130_0), 57648 }, /* ROXL */
{ CPUFUNC(op_e138_0), 57656 }, /* ROL */
{ CPUFUNC(op_e140_0), 57664 }, /* ASL */
{ CPUFUNC(op_e148_0), 57672 }, /* LSL */
{ CPUFUNC(op_e150_0), 57680 }, /* ROXL */
{ CPUFUNC(op_e158_0), 57688 }, /* ROL */
{ CPUFUNC(op_e160_0), 57696 }, /* ASL */
{ CPUFUNC(op_e168_0), 57704 }, /* LSL */
{ CPUFUNC(op_e170_0), 57712 }, /* ROXL */
{ CPUFUNC(op_e178_0), 57720 }, /* ROL */
{ CPUFUNC(op_e180_0), 57728 }, /* ASL */
{ CPUFUNC(op_e188_0), 57736 }, /* LSL */
{ CPUFUNC(op_e190_0), 57744 }, /* ROXL */
{ CPUFUNC(op_e198_0), 57752 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 57760 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 57768 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 57776 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 57784 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 57808 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 57816 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 57824 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 57832 }, /* ASLW */
{ CPUFUNC(op_e1f0_0), 57840 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 57848 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 57849 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 58064 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 58072 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 58080 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 58088 }, /* LSRW */
{ CPUFUNC(op_e2f0_0), 58096 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 58104 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 58105 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 58320 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 58328 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 58336 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 58344 }, /* LSLW */
{ CPUFUNC(op_e3f0_0), 58352 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 58360 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 58361 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 58576 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 58584 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 58592 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 58600 }, /* ROXRW */
{ CPUFUNC(op_e4f0_0), 58608 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 58616 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 58617 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 58832 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 58840 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 58848 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 58856 }, /* ROXLW */
{ CPUFUNC(op_e5f0_0), 58864 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 58872 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 58873 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 59088 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 59096 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 59104 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 59112 }, /* RORW */
{ CPUFUNC(op_e6f0_0), 59120 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 59128 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 59129 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 59344 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 59352 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 59360 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 59368 }, /* ROLW */
{ CPUFUNC(op_e7f0_0), 59376 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 59384 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 59385 }, /* ROLW */
{ CPUFUNC(op_e8c0_0), 59584 }, /* BFTST */
{ CPUFUNC(op_e8d0_0), 59600 }, /* BFTST */
{ CPUFUNC(op_e8e8_0), 59624 }, /* BFTST */
{ CPUFUNC(op_e8f0_0), 59632 }, /* BFTST */
{ CPUFUNC(op_e8f8_0), 59640 }, /* BFTST */
{ CPUFUNC(op_e8f9_0), 59641 }, /* BFTST */
{ CPUFUNC(op_e8fa_0), 59642 }, /* BFTST */
{ CPUFUNC(op_e8fb_0), 59643 }, /* BFTST */
{ CPUFUNC(op_e9c0_0), 59840 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_0), 59856 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_0), 59880 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_0), 59888 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_0), 59896 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_0), 59897 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_0), 59898 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_0), 59899 }, /* BFEXTU */
{ CPUFUNC(op_eac0_0), 60096 }, /* BFCHG */
{ CPUFUNC(op_ead0_0), 60112 }, /* BFCHG */
{ CPUFUNC(op_eae8_0), 60136 }, /* BFCHG */
{ CPUFUNC(op_eaf0_0), 60144 }, /* BFCHG */
{ CPUFUNC(op_eaf8_0), 60152 }, /* BFCHG */
{ CPUFUNC(op_eaf9_0), 60153 }, /* BFCHG */
{ CPUFUNC(op_ebc0_0), 60352 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_0), 60368 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_0), 60392 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_0), 60400 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_0), 60408 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_0), 60409 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_0), 60410 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_0), 60411 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_0), 60608 }, /* BFCLR */
{ CPUFUNC(op_ecd0_0), 60624 }, /* BFCLR */
{ CPUFUNC(op_ece8_0), 60648 }, /* BFCLR */
{ CPUFUNC(op_ecf0_0), 60656 }, /* BFCLR */
{ CPUFUNC(op_ecf8_0), 60664 }, /* BFCLR */
{ CPUFUNC(op_ecf9_0), 60665 }, /* BFCLR */
{ CPUFUNC(op_edc0_0), 60864 }, /* BFFFO */
{ CPUFUNC(op_edd0_0), 60880 }, /* BFFFO */
{ CPUFUNC(op_ede8_0), 60904 }, /* BFFFO */
{ CPUFUNC(op_edf0_0), 60912 }, /* BFFFO */
{ CPUFUNC(op_edf8_0), 60920 }, /* BFFFO */
{ CPUFUNC(op_edf9_0), 60921 }, /* BFFFO */
{ CPUFUNC(op_edfa_0), 60922 }, /* BFFFO */
{ CPUFUNC(op_edfb_0), 60923 }, /* BFFFO */
{ CPUFUNC(op_eec0_0), 61120 }, /* BFSET */
{ CPUFUNC(op_eed0_0), 61136 }, /* BFSET */
{ CPUFUNC(op_eee8_0), 61160 }, /* BFSET */
{ CPUFUNC(op_eef0_0), 61168 }, /* BFSET */
{ CPUFUNC(op_eef8_0), 61176 }, /* BFSET */
{ CPUFUNC(op_eef9_0), 61177 }, /* BFSET */
{ CPUFUNC(op_efc0_0), 61376 }, /* BFINS */
{ CPUFUNC(op_efd0_0), 61392 }, /* BFINS */
{ CPUFUNC(op_efe8_0), 61416 }, /* BFINS */
{ CPUFUNC(op_eff0_0), 61424 }, /* BFINS */
{ CPUFUNC(op_eff8_0), 61432 }, /* BFINS */
{ CPUFUNC(op_eff9_0), 61433 }, /* BFINS */
{ CPUFUNC(op_f010_0), 61456 }, /* MMUOP030 */
{ CPUFUNC(op_f028_0), 61480 }, /* MMUOP030 */
{ CPUFUNC(op_f030_0), 61488 }, /* MMUOP030 */
{ CPUFUNC(op_f038_0), 61496 }, /* MMUOP030 */
{ CPUFUNC(op_f039_0), 61497 }, /* MMUOP030 */
{ CPUFUNC(op_f200_0), 61952 }, /* FPP */
{ CPUFUNC(op_f208_0), 61960 }, /* FPP */
{ CPUFUNC(op_f210_0), 61968 }, /* FPP */
{ CPUFUNC(op_f218_0), 61976 }, /* FPP */
{ CPUFUNC(op_f220_0), 61984 }, /* FPP */
{ CPUFUNC(op_f228_0), 61992 }, /* FPP */
{ CPUFUNC(op_f230_0), 62000 }, /* FPP */
{ CPUFUNC(op_f238_0), 62008 }, /* FPP */
{ CPUFUNC(op_f239_0), 62009 }, /* FPP */
{ CPUFUNC(op_f23a_0), 62010 }, /* FPP */
{ CPUFUNC(op_f23b_0), 62011 }, /* FPP */
{ CPUFUNC(op_f23c_0), 62012 }, /* FPP */
{ CPUFUNC(op_f240_0), 62016 }, /* FScc */
{ CPUFUNC(op_f248_0), 62024 }, /* FDBcc */
{ CPUFUNC(op_f250_0), 62032 }, /* FScc */
{ CPUFUNC(op_f258_0), 62040 }, /* FScc */
{ CPUFUNC(op_f260_0), 62048 }, /* FScc */
{ CPUFUNC(op_f268_0), 62056 }, /* FScc */
{ CPUFUNC(op_f270_0), 62064 }, /* FScc */
{ CPUFUNC(op_f278_0), 62072 }, /* FScc */
{ CPUFUNC(op_f279_0), 62073 }, /* FScc */
{ CPUFUNC(op_f27a_0), 62074 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_0), 62075 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_0), 62076 }, /* FTRAPcc */
{ CPUFUNC(op_f280_0), 62080 }, /* FBcc */
{ CPUFUNC(op_f2c0_0), 62144 }, /* FBcc */
{ CPUFUNC(op_f310_0), 62224 }, /* FSAVE */
{ CPUFUNC(op_f320_0), 62240 }, /* FSAVE */
{ CPUFUNC(op_f328_0), 62248 }, /* FSAVE */
{ CPUFUNC(op_f330_0), 62256 }, /* FSAVE */
{ CPUFUNC(op_f338_0), 62264 }, /* FSAVE */
{ CPUFUNC(op_f339_0), 62265 }, /* FSAVE */
{ CPUFUNC(op_f350_0), 62288 }, /* FRESTORE */
{ CPUFUNC(op_f358_0), 62296 }, /* FRESTORE */
{ CPUFUNC(op_f368_0), 62312 }, /* FRESTORE */
{ CPUFUNC(op_f370_0), 62320 }, /* FRESTORE */
{ CPUFUNC(op_f378_0), 62328 }, /* FRESTORE */
{ CPUFUNC(op_f379_0), 62329 }, /* FRESTORE */
{ CPUFUNC(op_f37a_0), 62330 }, /* FRESTORE */
{ CPUFUNC(op_f37b_0), 62331 }, /* FRESTORE */
{ CPUFUNC(op_f408_0), 62472 }, /* CINVL */
{ CPUFUNC(op_f410_0), 62480 }, /* CINVP */
{ CPUFUNC(op_f418_0), 62488 }, /* CINVA */
{ CPUFUNC(op_f419_0), 62489 }, /* CINVA */
{ CPUFUNC(op_f41a_0), 62490 }, /* CINVA */
{ CPUFUNC(op_f41b_0), 62491 }, /* CINVA */
{ CPUFUNC(op_f41c_0), 62492 }, /* CINVA */
{ CPUFUNC(op_f41d_0), 62493 }, /* CINVA */
{ CPUFUNC(op_f41e_0), 62494 }, /* CINVA */
{ CPUFUNC(op_f41f_0), 62495 }, /* CINVA */
{ CPUFUNC(op_f428_0), 62504 }, /* CPUSHL */
{ CPUFUNC(op_f430_0), 62512 }, /* CPUSHP */
{ CPUFUNC(op_f438_0), 62520 }, /* CPUSHA */
{ CPUFUNC(op_f439_0), 62521 }, /* CPUSHA */
{ CPUFUNC(op_f43a_0), 62522 }, /* CPUSHA */
{ CPUFUNC(op_f43b_0), 62523 }, /* CPUSHA */
{ CPUFUNC(op_f43c_0), 62524 }, /* CPUSHA */
{ CPUFUNC(op_f43d_0), 62525 }, /* CPUSHA */
{ CPUFUNC(op_f43e_0), 62526 }, /* CPUSHA */
{ CPUFUNC(op_f43f_0), 62527 }, /* CPUSHA */
{ CPUFUNC(op_f500_0), 62720 }, /* PFLUSHN */
{ CPUFUNC(op_f508_0), 62728 }, /* PFLUSH */
{ CPUFUNC(op_f510_0), 62736 }, /* PFLUSHAN */
{ CPUFUNC(op_f518_0), 62744 }, /* PFLUSHA */
{ CPUFUNC(op_f548_0), 62792 }, /* PTESTR */
{ CPUFUNC(op_f568_0), 62824 }, /* PTESTW */
{ CPUFUNC(op_f588_0), 62856 }, /* PLPAR */
{ CPUFUNC(op_f5c8_0), 62920 }, /* PLPAW */
{ CPUFUNC(op_f600_0), 62976 }, /* MOVE16 */
{ CPUFUNC(op_f608_0), 62984 }, /* MOVE16 */
{ CPUFUNC(op_f610_0), 62992 }, /* MOVE16 */
{ CPUFUNC(op_f618_0), 63000 }, /* MOVE16 */
{ CPUFUNC(op_f620_0), 63008 }, /* MOVE16 */
{ CPUFUNC(op_f800_0), 63488 }, /* LPSTOP */
{ 0, 0 }};
#endif /* CPUEMU_0 */
const struct cputbl CPUFUNC(op_smalltbl_1)[] = {
{ CPUFUNC(op_0000_0), 0 }, /* OR */
{ CPUFUNC(op_0010_0), 16 }, /* OR */
{ CPUFUNC(op_0018_0), 24 }, /* OR */
{ CPUFUNC(op_0020_0), 32 }, /* OR */
{ CPUFUNC(op_0028_0), 40 }, /* OR */
{ CPUFUNC(op_0030_0), 48 }, /* OR */
{ CPUFUNC(op_0038_0), 56 }, /* OR */
{ CPUFUNC(op_0039_0), 57 }, /* OR */
{ CPUFUNC(op_003c_0), 60 }, /* ORSR */
{ CPUFUNC(op_0040_0), 64 }, /* OR */
{ CPUFUNC(op_0050_0), 80 }, /* OR */
{ CPUFUNC(op_0058_0), 88 }, /* OR */
{ CPUFUNC(op_0060_0), 96 }, /* OR */
{ CPUFUNC(op_0068_0), 104 }, /* OR */
{ CPUFUNC(op_0070_0), 112 }, /* OR */
{ CPUFUNC(op_0078_0), 120 }, /* OR */
{ CPUFUNC(op_0079_0), 121 }, /* OR */
{ CPUFUNC(op_007c_0), 124 }, /* ORSR */
{ CPUFUNC(op_0080_0), 128 }, /* OR */
{ CPUFUNC(op_0090_0), 144 }, /* OR */
{ CPUFUNC(op_0098_0), 152 }, /* OR */
{ CPUFUNC(op_00a0_0), 160 }, /* OR */
{ CPUFUNC(op_00a8_0), 168 }, /* OR */
{ CPUFUNC(op_00b0_0), 176 }, /* OR */
{ CPUFUNC(op_00b8_0), 184 }, /* OR */
{ CPUFUNC(op_00b9_0), 185 }, /* OR */
{ CPUFUNC(op_00d0_0), 208 }, /* CHK2 */
{ CPUFUNC(op_00e8_0), 232 }, /* CHK2 */
{ CPUFUNC(op_00f0_0), 240 }, /* CHK2 */
{ CPUFUNC(op_00f8_0), 248 }, /* CHK2 */
{ CPUFUNC(op_00f9_0), 249 }, /* CHK2 */
{ CPUFUNC(op_00fa_0), 250 }, /* CHK2 */
{ CPUFUNC(op_00fb_0), 251 }, /* CHK2 */
{ CPUFUNC(op_0100_0), 256 }, /* BTST */
{ CPUFUNC(op_0108_0), 264 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 272 }, /* BTST */
{ CPUFUNC(op_0118_0), 280 }, /* BTST */
{ CPUFUNC(op_0120_0), 288 }, /* BTST */
{ CPUFUNC(op_0128_0), 296 }, /* BTST */
{ CPUFUNC(op_0130_0), 304 }, /* BTST */
{ CPUFUNC(op_0138_0), 312 }, /* BTST */
{ CPUFUNC(op_0139_0), 313 }, /* BTST */
{ CPUFUNC(op_013a_0), 314 }, /* BTST */
{ CPUFUNC(op_013b_0), 315 }, /* BTST */
{ CPUFUNC(op_013c_0), 316 }, /* BTST */
{ CPUFUNC(op_0140_0), 320 }, /* BCHG */
{ CPUFUNC(op_0148_0), 328 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 336 }, /* BCHG */
{ CPUFUNC(op_0158_0), 344 }, /* BCHG */
{ CPUFUNC(op_0160_0), 352 }, /* BCHG */
{ CPUFUNC(op_0168_0), 360 }, /* BCHG */
{ CPUFUNC(op_0170_0), 368 }, /* BCHG */
{ CPUFUNC(op_0178_0), 376 }, /* BCHG */
{ CPUFUNC(op_0179_0), 377 }, /* BCHG */
{ CPUFUNC(op_0180_0), 384 }, /* BCLR */
{ CPUFUNC(op_0188_0), 392 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 400 }, /* BCLR */
{ CPUFUNC(op_0198_0), 408 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 416 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 424 }, /* BCLR */
{ CPUFUNC(op_01b0_0), 432 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 440 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 441 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 448 }, /* BSET */
{ CPUFUNC(op_01c8_0), 456 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 464 }, /* BSET */
{ CPUFUNC(op_01d8_0), 472 }, /* BSET */
{ CPUFUNC(op_01e0_0), 480 }, /* BSET */
{ CPUFUNC(op_01e8_0), 488 }, /* BSET */
{ CPUFUNC(op_01f0_0), 496 }, /* BSET */
{ CPUFUNC(op_01f8_0), 504 }, /* BSET */
{ CPUFUNC(op_01f9_0), 505 }, /* BSET */
{ CPUFUNC(op_0200_0), 512 }, /* AND */
{ CPUFUNC(op_0210_0), 528 }, /* AND */
{ CPUFUNC(op_0218_0), 536 }, /* AND */
{ CPUFUNC(op_0220_0), 544 }, /* AND */
{ CPUFUNC(op_0228_0), 552 }, /* AND */
{ CPUFUNC(op_0230_0), 560 }, /* AND */
{ CPUFUNC(op_0238_0), 568 }, /* AND */
{ CPUFUNC(op_0239_0), 569 }, /* AND */
{ CPUFUNC(op_023c_0), 572 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 576 }, /* AND */
{ CPUFUNC(op_0250_0), 592 }, /* AND */
{ CPUFUNC(op_0258_0), 600 }, /* AND */
{ CPUFUNC(op_0260_0), 608 }, /* AND */
{ CPUFUNC(op_0268_0), 616 }, /* AND */
{ CPUFUNC(op_0270_0), 624 }, /* AND */
{ CPUFUNC(op_0278_0), 632 }, /* AND */
{ CPUFUNC(op_0279_0), 633 }, /* AND */
{ CPUFUNC(op_027c_0), 636 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 640 }, /* AND */
{ CPUFUNC(op_0290_0), 656 }, /* AND */
{ CPUFUNC(op_0298_0), 664 }, /* AND */
{ CPUFUNC(op_02a0_0), 672 }, /* AND */
{ CPUFUNC(op_02a8_0), 680 }, /* AND */
{ CPUFUNC(op_02b0_0), 688 }, /* AND */
{ CPUFUNC(op_02b8_0), 696 }, /* AND */
{ CPUFUNC(op_02b9_0), 697 }, /* AND */
{ CPUFUNC(op_02d0_0), 720 }, /* CHK2 */
{ CPUFUNC(op_02e8_0), 744 }, /* CHK2 */
{ CPUFUNC(op_02f0_0), 752 }, /* CHK2 */
{ CPUFUNC(op_02f8_0), 760 }, /* CHK2 */
{ CPUFUNC(op_02f9_0), 761 }, /* CHK2 */
{ CPUFUNC(op_02fa_0), 762 }, /* CHK2 */
{ CPUFUNC(op_02fb_0), 763 }, /* CHK2 */
{ CPUFUNC(op_0400_0), 1024 }, /* SUB */
{ CPUFUNC(op_0410_0), 1040 }, /* SUB */
{ CPUFUNC(op_0418_0), 1048 }, /* SUB */
{ CPUFUNC(op_0420_0), 1056 }, /* SUB */
{ CPUFUNC(op_0428_0), 1064 }, /* SUB */
{ CPUFUNC(op_0430_0), 1072 }, /* SUB */
{ CPUFUNC(op_0438_0), 1080 }, /* SUB */
{ CPUFUNC(op_0439_0), 1081 }, /* SUB */
{ CPUFUNC(op_0440_0), 1088 }, /* SUB */
{ CPUFUNC(op_0450_0), 1104 }, /* SUB */
{ CPUFUNC(op_0458_0), 1112 }, /* SUB */
{ CPUFUNC(op_0460_0), 1120 }, /* SUB */
{ CPUFUNC(op_0468_0), 1128 }, /* SUB */
{ CPUFUNC(op_0470_0), 1136 }, /* SUB */
{ CPUFUNC(op_0478_0), 1144 }, /* SUB */
{ CPUFUNC(op_0479_0), 1145 }, /* SUB */
{ CPUFUNC(op_0480_0), 1152 }, /* SUB */
{ CPUFUNC(op_0490_0), 1168 }, /* SUB */
{ CPUFUNC(op_0498_0), 1176 }, /* SUB */
{ CPUFUNC(op_04a0_0), 1184 }, /* SUB */
{ CPUFUNC(op_04a8_0), 1192 }, /* SUB */
{ CPUFUNC(op_04b0_0), 1200 }, /* SUB */
{ CPUFUNC(op_04b8_0), 1208 }, /* SUB */
{ CPUFUNC(op_04b9_0), 1209 }, /* SUB */
{ CPUFUNC(op_04d0_0), 1232 }, /* CHK2 */
{ CPUFUNC(op_04e8_0), 1256 }, /* CHK2 */
{ CPUFUNC(op_04f0_0), 1264 }, /* CHK2 */
{ CPUFUNC(op_04f8_0), 1272 }, /* CHK2 */
{ CPUFUNC(op_04f9_0), 1273 }, /* CHK2 */
{ CPUFUNC(op_04fa_0), 1274 }, /* CHK2 */
{ CPUFUNC(op_04fb_0), 1275 }, /* CHK2 */
{ CPUFUNC(op_0600_0), 1536 }, /* ADD */
{ CPUFUNC(op_0610_0), 1552 }, /* ADD */
{ CPUFUNC(op_0618_0), 1560 }, /* ADD */
{ CPUFUNC(op_0620_0), 1568 }, /* ADD */
{ CPUFUNC(op_0628_0), 1576 }, /* ADD */
{ CPUFUNC(op_0630_0), 1584 }, /* ADD */
{ CPUFUNC(op_0638_0), 1592 }, /* ADD */
{ CPUFUNC(op_0639_0), 1593 }, /* ADD */
{ CPUFUNC(op_0640_0), 1600 }, /* ADD */
{ CPUFUNC(op_0650_0), 1616 }, /* ADD */
{ CPUFUNC(op_0658_0), 1624 }, /* ADD */
{ CPUFUNC(op_0660_0), 1632 }, /* ADD */
{ CPUFUNC(op_0668_0), 1640 }, /* ADD */
{ CPUFUNC(op_0670_0), 1648 }, /* ADD */
{ CPUFUNC(op_0678_0), 1656 }, /* ADD */
{ CPUFUNC(op_0679_0), 1657 }, /* ADD */
{ CPUFUNC(op_0680_0), 1664 }, /* ADD */
{ CPUFUNC(op_0690_0), 1680 }, /* ADD */
{ CPUFUNC(op_0698_0), 1688 }, /* ADD */
{ CPUFUNC(op_06a0_0), 1696 }, /* ADD */
{ CPUFUNC(op_06a8_0), 1704 }, /* ADD */
{ CPUFUNC(op_06b0_0), 1712 }, /* ADD */
{ CPUFUNC(op_06b8_0), 1720 }, /* ADD */
{ CPUFUNC(op_06b9_0), 1721 }, /* ADD */
{ CPUFUNC(op_06c0_0), 1728 }, /* RTM */
{ CPUFUNC(op_06c8_0), 1736 }, /* RTM */
{ CPUFUNC(op_06d0_0), 1744 }, /* CALLM */
{ CPUFUNC(op_06e8_0), 1768 }, /* CALLM */
{ CPUFUNC(op_06f0_0), 1776 }, /* CALLM */
{ CPUFUNC(op_06f8_0), 1784 }, /* CALLM */
{ CPUFUNC(op_06f9_0), 1785 }, /* CALLM */
{ CPUFUNC(op_06fa_0), 1786 }, /* CALLM */
{ CPUFUNC(op_06fb_0), 1787 }, /* CALLM */
{ CPUFUNC(op_0800_0), 2048 }, /* BTST */
{ CPUFUNC(op_0810_0), 2064 }, /* BTST */
{ CPUFUNC(op_0818_0), 2072 }, /* BTST */
{ CPUFUNC(op_0820_0), 2080 }, /* BTST */
{ CPUFUNC(op_0828_0), 2088 }, /* BTST */
{ CPUFUNC(op_0830_0), 2096 }, /* BTST */
{ CPUFUNC(op_0838_0), 2104 }, /* BTST */
{ CPUFUNC(op_0839_0), 2105 }, /* BTST */
{ CPUFUNC(op_083a_0), 2106 }, /* BTST */
{ CPUFUNC(op_083b_0), 2107 }, /* BTST */
{ CPUFUNC(op_083c_0), 2108 }, /* BTST */
{ CPUFUNC(op_0840_0), 2112 }, /* BCHG */
{ CPUFUNC(op_0850_0), 2128 }, /* BCHG */
{ CPUFUNC(op_0858_0), 2136 }, /* BCHG */
{ CPUFUNC(op_0860_0), 2144 }, /* BCHG */
{ CPUFUNC(op_0868_0), 2152 }, /* BCHG */
{ CPUFUNC(op_0870_0), 2160 }, /* BCHG */
{ CPUFUNC(op_0878_0), 2168 }, /* BCHG */
{ CPUFUNC(op_0879_0), 2169 }, /* BCHG */
{ CPUFUNC(op_0880_0), 2176 }, /* BCLR */
{ CPUFUNC(op_0890_0), 2192 }, /* BCLR */
{ CPUFUNC(op_0898_0), 2200 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 2208 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 2216 }, /* BCLR */
{ CPUFUNC(op_08b0_0), 2224 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 2232 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 2233 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 2240 }, /* BSET */
{ CPUFUNC(op_08d0_0), 2256 }, /* BSET */
{ CPUFUNC(op_08d8_0), 2264 }, /* BSET */
{ CPUFUNC(op_08e0_0), 2272 }, /* BSET */
{ CPUFUNC(op_08e8_0), 2280 }, /* BSET */
{ CPUFUNC(op_08f0_0), 2288 }, /* BSET */
{ CPUFUNC(op_08f8_0), 2296 }, /* BSET */
{ CPUFUNC(op_08f9_0), 2297 }, /* BSET */
{ CPUFUNC(op_0a00_0), 2560 }, /* EOR */
{ CPUFUNC(op_0a10_0), 2576 }, /* EOR */
{ CPUFUNC(op_0a18_0), 2584 }, /* EOR */
{ CPUFUNC(op_0a20_0), 2592 }, /* EOR */
{ CPUFUNC(op_0a28_0), 2600 }, /* EOR */
{ CPUFUNC(op_0a30_0), 2608 }, /* EOR */
{ CPUFUNC(op_0a38_0), 2616 }, /* EOR */
{ CPUFUNC(op_0a39_0), 2617 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 2620 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 2624 }, /* EOR */
{ CPUFUNC(op_0a50_0), 2640 }, /* EOR */
{ CPUFUNC(op_0a58_0), 2648 }, /* EOR */
{ CPUFUNC(op_0a60_0), 2656 }, /* EOR */
{ CPUFUNC(op_0a68_0), 2664 }, /* EOR */
{ CPUFUNC(op_0a70_0), 2672 }, /* EOR */
{ CPUFUNC(op_0a78_0), 2680 }, /* EOR */
{ CPUFUNC(op_0a79_0), 2681 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 2684 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 2688 }, /* EOR */
{ CPUFUNC(op_0a90_0), 2704 }, /* EOR */
{ CPUFUNC(op_0a98_0), 2712 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 2720 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 2728 }, /* EOR */
{ CPUFUNC(op_0ab0_0), 2736 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 2744 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 2745 }, /* EOR */
{ CPUFUNC(op_0ad0_0), 2768 }, /* CAS */
{ CPUFUNC(op_0ad8_0), 2776 }, /* CAS */
{ CPUFUNC(op_0ae0_0), 2784 }, /* CAS */
{ CPUFUNC(op_0ae8_0), 2792 }, /* CAS */
{ CPUFUNC(op_0af0_0), 2800 }, /* CAS */
{ CPUFUNC(op_0af8_0), 2808 }, /* CAS */
{ CPUFUNC(op_0af9_0), 2809 }, /* CAS */
{ CPUFUNC(op_0c00_0), 3072 }, /* CMP */
{ CPUFUNC(op_0c10_0), 3088 }, /* CMP */
{ CPUFUNC(op_0c18_0), 3096 }, /* CMP */
{ CPUFUNC(op_0c20_0), 3104 }, /* CMP */
{ CPUFUNC(op_0c28_0), 3112 }, /* CMP */
{ CPUFUNC(op_0c30_0), 3120 }, /* CMP */
{ CPUFUNC(op_0c38_0), 3128 }, /* CMP */
{ CPUFUNC(op_0c39_0), 3129 }, /* CMP */
{ CPUFUNC(op_0c3a_0), 3130 }, /* CMP */
{ CPUFUNC(op_0c3b_0), 3131 }, /* CMP */
{ CPUFUNC(op_0c40_0), 3136 }, /* CMP */
{ CPUFUNC(op_0c50_0), 3152 }, /* CMP */
{ CPUFUNC(op_0c58_0), 3160 }, /* CMP */
{ CPUFUNC(op_0c60_0), 3168 }, /* CMP */
{ CPUFUNC(op_0c68_0), 3176 }, /* CMP */
{ CPUFUNC(op_0c70_0), 3184 }, /* CMP */
{ CPUFUNC(op_0c78_0), 3192 }, /* CMP */
{ CPUFUNC(op_0c79_0), 3193 }, /* CMP */
{ CPUFUNC(op_0c7a_0), 3194 }, /* CMP */
{ CPUFUNC(op_0c7b_0), 3195 }, /* CMP */
{ CPUFUNC(op_0c80_0), 3200 }, /* CMP */
{ CPUFUNC(op_0c90_0), 3216 }, /* CMP */
{ CPUFUNC(op_0c98_0), 3224 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 3232 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 3240 }, /* CMP */
{ CPUFUNC(op_0cb0_0), 3248 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 3256 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 3257 }, /* CMP */
{ CPUFUNC(op_0cba_0), 3258 }, /* CMP */
{ CPUFUNC(op_0cbb_0), 3259 }, /* CMP */
{ CPUFUNC(op_0cd0_0), 3280 }, /* CAS */
{ CPUFUNC(op_0cd8_0), 3288 }, /* CAS */
{ CPUFUNC(op_0ce0_0), 3296 }, /* CAS */
{ CPUFUNC(op_0ce8_0), 3304 }, /* CAS */
{ CPUFUNC(op_0cf0_0), 3312 }, /* CAS */
{ CPUFUNC(op_0cf8_0), 3320 }, /* CAS */
{ CPUFUNC(op_0cf9_0), 3321 }, /* CAS */
{ CPUFUNC(op_0cfc_0), 3324 }, /* CAS2 */
{ CPUFUNC(op_0e10_0), 3600 }, /* MOVES */
{ CPUFUNC(op_0e18_0), 3608 }, /* MOVES */
{ CPUFUNC(op_0e20_0), 3616 }, /* MOVES */
{ CPUFUNC(op_0e28_0), 3624 }, /* MOVES */
{ CPUFUNC(op_0e30_0), 3632 }, /* MOVES */
{ CPUFUNC(op_0e38_0), 3640 }, /* MOVES */
{ CPUFUNC(op_0e39_0), 3641 }, /* MOVES */
{ CPUFUNC(op_0e50_0), 3664 }, /* MOVES */
{ CPUFUNC(op_0e58_0), 3672 }, /* MOVES */
{ CPUFUNC(op_0e60_0), 3680 }, /* MOVES */
{ CPUFUNC(op_0e68_0), 3688 }, /* MOVES */
{ CPUFUNC(op_0e70_0), 3696 }, /* MOVES */
{ CPUFUNC(op_0e78_0), 3704 }, /* MOVES */
{ CPUFUNC(op_0e79_0), 3705 }, /* MOVES */
{ CPUFUNC(op_0e90_0), 3728 }, /* MOVES */
{ CPUFUNC(op_0e98_0), 3736 }, /* MOVES */
{ CPUFUNC(op_0ea0_0), 3744 }, /* MOVES */
{ CPUFUNC(op_0ea8_0), 3752 }, /* MOVES */
{ CPUFUNC(op_0eb0_0), 3760 }, /* MOVES */
{ CPUFUNC(op_0eb8_0), 3768 }, /* MOVES */
{ CPUFUNC(op_0eb9_0), 3769 }, /* MOVES */
{ CPUFUNC(op_0ed0_0), 3792 }, /* CAS */
{ CPUFUNC(op_0ed8_0), 3800 }, /* CAS */
{ CPUFUNC(op_0ee0_0), 3808 }, /* CAS */
{ CPUFUNC(op_0ee8_0), 3816 }, /* CAS */
{ CPUFUNC(op_0ef0_0), 3824 }, /* CAS */
{ CPUFUNC(op_0ef8_0), 3832 }, /* CAS */
{ CPUFUNC(op_0ef9_0), 3833 }, /* CAS */
{ CPUFUNC(op_0efc_0), 3836 }, /* CAS2 */
{ CPUFUNC(op_1000_0), 4096 }, /* MOVE */
{ CPUFUNC(op_1010_0), 4112 }, /* MOVE */
{ CPUFUNC(op_1018_0), 4120 }, /* MOVE */
{ CPUFUNC(op_1020_0), 4128 }, /* MOVE */
{ CPUFUNC(op_1028_0), 4136 }, /* MOVE */
{ CPUFUNC(op_1030_0), 4144 }, /* MOVE */
{ CPUFUNC(op_1038_0), 4152 }, /* MOVE */
{ CPUFUNC(op_1039_0), 4153 }, /* MOVE */
{ CPUFUNC(op_103a_0), 4154 }, /* MOVE */
{ CPUFUNC(op_103b_0), 4155 }, /* MOVE */
{ CPUFUNC(op_103c_0), 4156 }, /* MOVE */
{ CPUFUNC(op_1080_0), 4224 }, /* MOVE */
{ CPUFUNC(op_1090_0), 4240 }, /* MOVE */
{ CPUFUNC(op_1098_0), 4248 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 4256 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 4264 }, /* MOVE */
{ CPUFUNC(op_10b0_0), 4272 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 4280 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 4281 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 4282 }, /* MOVE */
{ CPUFUNC(op_10bb_0), 4283 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 4284 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 4288 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 4304 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 4312 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 4320 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 4328 }, /* MOVE */
{ CPUFUNC(op_10f0_0), 4336 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 4344 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 4345 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 4346 }, /* MOVE */
{ CPUFUNC(op_10fb_0), 4347 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 4348 }, /* MOVE */
{ CPUFUNC(op_1100_0), 4352 }, /* MOVE */
{ CPUFUNC(op_1110_0), 4368 }, /* MOVE */
{ CPUFUNC(op_1118_0), 4376 }, /* MOVE */
{ CPUFUNC(op_1120_0), 4384 }, /* MOVE */
{ CPUFUNC(op_1128_0), 4392 }, /* MOVE */
{ CPUFUNC(op_1130_0), 4400 }, /* MOVE */
{ CPUFUNC(op_1138_0), 4408 }, /* MOVE */
{ CPUFUNC(op_1139_0), 4409 }, /* MOVE */
{ CPUFUNC(op_113a_0), 4410 }, /* MOVE */
{ CPUFUNC(op_113b_0), 4411 }, /* MOVE */
{ CPUFUNC(op_113c_0), 4412 }, /* MOVE */
{ CPUFUNC(op_1140_0), 4416 }, /* MOVE */
{ CPUFUNC(op_1150_0), 4432 }, /* MOVE */
{ CPUFUNC(op_1158_0), 4440 }, /* MOVE */
{ CPUFUNC(op_1160_0), 4448 }, /* MOVE */
{ CPUFUNC(op_1168_0), 4456 }, /* MOVE */
{ CPUFUNC(op_1170_0), 4464 }, /* MOVE */
{ CPUFUNC(op_1178_0), 4472 }, /* MOVE */
{ CPUFUNC(op_1179_0), 4473 }, /* MOVE */
{ CPUFUNC(op_117a_0), 4474 }, /* MOVE */
{ CPUFUNC(op_117b_0), 4475 }, /* MOVE */
{ CPUFUNC(op_117c_0), 4476 }, /* MOVE */
{ CPUFUNC(op_1180_0), 4480 }, /* MOVE */
{ CPUFUNC(op_1190_0), 4496 }, /* MOVE */
{ CPUFUNC(op_1198_0), 4504 }, /* MOVE */
{ CPUFUNC(op_11a0_0), 4512 }, /* MOVE */
{ CPUFUNC(op_11a8_0), 4520 }, /* MOVE */
{ CPUFUNC(op_11b0_0), 4528 }, /* MOVE */
{ CPUFUNC(op_11b8_0), 4536 }, /* MOVE */
{ CPUFUNC(op_11b9_0), 4537 }, /* MOVE */
{ CPUFUNC(op_11ba_0), 4538 }, /* MOVE */
{ CPUFUNC(op_11bb_0), 4539 }, /* MOVE */
{ CPUFUNC(op_11bc_0), 4540 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 4544 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 4560 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 4568 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 4576 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 4584 }, /* MOVE */
{ CPUFUNC(op_11f0_0), 4592 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 4600 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 4601 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 4602 }, /* MOVE */
{ CPUFUNC(op_11fb_0), 4603 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 4604 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 5056 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 5072 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 5080 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 5088 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 5096 }, /* MOVE */
{ CPUFUNC(op_13f0_0), 5104 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 5112 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 5113 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 5114 }, /* MOVE */
{ CPUFUNC(op_13fb_0), 5115 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 5116 }, /* MOVE */
{ CPUFUNC(op_2000_0), 8192 }, /* MOVE */
{ CPUFUNC(op_2008_0), 8200 }, /* MOVE */
{ CPUFUNC(op_2010_0), 8208 }, /* MOVE */
{ CPUFUNC(op_2018_0), 8216 }, /* MOVE */
{ CPUFUNC(op_2020_0), 8224 }, /* MOVE */
{ CPUFUNC(op_2028_0), 8232 }, /* MOVE */
{ CPUFUNC(op_2030_0), 8240 }, /* MOVE */
{ CPUFUNC(op_2038_0), 8248 }, /* MOVE */
{ CPUFUNC(op_2039_0), 8249 }, /* MOVE */
{ CPUFUNC(op_203a_0), 8250 }, /* MOVE */
{ CPUFUNC(op_203b_0), 8251 }, /* MOVE */
{ CPUFUNC(op_203c_0), 8252 }, /* MOVE */
{ CPUFUNC(op_2040_0), 8256 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 8264 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 8272 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 8280 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 8288 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 8296 }, /* MOVEA */
{ CPUFUNC(op_2070_0), 8304 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 8312 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 8313 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 8314 }, /* MOVEA */
{ CPUFUNC(op_207b_0), 8315 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 8316 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 8320 }, /* MOVE */
{ CPUFUNC(op_2088_0), 8328 }, /* MOVE */
{ CPUFUNC(op_2090_0), 8336 }, /* MOVE */
{ CPUFUNC(op_2098_0), 8344 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 8352 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 8360 }, /* MOVE */
{ CPUFUNC(op_20b0_0), 8368 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 8376 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 8377 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 8378 }, /* MOVE */
{ CPUFUNC(op_20bb_0), 8379 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 8380 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 8384 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 8392 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 8400 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 8408 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 8416 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 8424 }, /* MOVE */
{ CPUFUNC(op_20f0_0), 8432 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 8440 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 8441 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 8442 }, /* MOVE */
{ CPUFUNC(op_20fb_0), 8443 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 8444 }, /* MOVE */
{ CPUFUNC(op_2100_0), 8448 }, /* MOVE */
{ CPUFUNC(op_2108_0), 8456 }, /* MOVE */
{ CPUFUNC(op_2110_0), 8464 }, /* MOVE */
{ CPUFUNC(op_2118_0), 8472 }, /* MOVE */
{ CPUFUNC(op_2120_0), 8480 }, /* MOVE */
{ CPUFUNC(op_2128_0), 8488 }, /* MOVE */
{ CPUFUNC(op_2130_0), 8496 }, /* MOVE */
{ CPUFUNC(op_2138_0), 8504 }, /* MOVE */
{ CPUFUNC(op_2139_0), 8505 }, /* MOVE */
{ CPUFUNC(op_213a_0), 8506 }, /* MOVE */
{ CPUFUNC(op_213b_0), 8507 }, /* MOVE */
{ CPUFUNC(op_213c_0), 8508 }, /* MOVE */
{ CPUFUNC(op_2140_0), 8512 }, /* MOVE */
{ CPUFUNC(op_2148_0), 8520 }, /* MOVE */
{ CPUFUNC(op_2150_0), 8528 }, /* MOVE */
{ CPUFUNC(op_2158_0), 8536 }, /* MOVE */
{ CPUFUNC(op_2160_0), 8544 }, /* MOVE */
{ CPUFUNC(op_2168_0), 8552 }, /* MOVE */
{ CPUFUNC(op_2170_0), 8560 }, /* MOVE */
{ CPUFUNC(op_2178_0), 8568 }, /* MOVE */
{ CPUFUNC(op_2179_0), 8569 }, /* MOVE */
{ CPUFUNC(op_217a_0), 8570 }, /* MOVE */
{ CPUFUNC(op_217b_0), 8571 }, /* MOVE */
{ CPUFUNC(op_217c_0), 8572 }, /* MOVE */
{ CPUFUNC(op_2180_0), 8576 }, /* MOVE */
{ CPUFUNC(op_2188_0), 8584 }, /* MOVE */
{ CPUFUNC(op_2190_0), 8592 }, /* MOVE */
{ CPUFUNC(op_2198_0), 8600 }, /* MOVE */
{ CPUFUNC(op_21a0_0), 8608 }, /* MOVE */
{ CPUFUNC(op_21a8_0), 8616 }, /* MOVE */
{ CPUFUNC(op_21b0_0), 8624 }, /* MOVE */
{ CPUFUNC(op_21b8_0), 8632 }, /* MOVE */
{ CPUFUNC(op_21b9_0), 8633 }, /* MOVE */
{ CPUFUNC(op_21ba_0), 8634 }, /* MOVE */
{ CPUFUNC(op_21bb_0), 8635 }, /* MOVE */
{ CPUFUNC(op_21bc_0), 8636 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 8640 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 8648 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 8656 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 8664 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 8672 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 8680 }, /* MOVE */
{ CPUFUNC(op_21f0_0), 8688 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 8696 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 8697 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 8698 }, /* MOVE */
{ CPUFUNC(op_21fb_0), 8699 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 8700 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 9152 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 9160 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 9168 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 9176 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 9184 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 9192 }, /* MOVE */
{ CPUFUNC(op_23f0_0), 9200 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 9208 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 9209 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 9210 }, /* MOVE */
{ CPUFUNC(op_23fb_0), 9211 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 9212 }, /* MOVE */
{ CPUFUNC(op_3000_0), 12288 }, /* MOVE */
{ CPUFUNC(op_3008_0), 12296 }, /* MOVE */
{ CPUFUNC(op_3010_0), 12304 }, /* MOVE */
{ CPUFUNC(op_3018_0), 12312 }, /* MOVE */
{ CPUFUNC(op_3020_0), 12320 }, /* MOVE */
{ CPUFUNC(op_3028_0), 12328 }, /* MOVE */
{ CPUFUNC(op_3030_0), 12336 }, /* MOVE */
{ CPUFUNC(op_3038_0), 12344 }, /* MOVE */
{ CPUFUNC(op_3039_0), 12345 }, /* MOVE */
{ CPUFUNC(op_303a_0), 12346 }, /* MOVE */
{ CPUFUNC(op_303b_0), 12347 }, /* MOVE */
{ CPUFUNC(op_303c_0), 12348 }, /* MOVE */
{ CPUFUNC(op_3040_0), 12352 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 12360 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 12368 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 12376 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 12384 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 12392 }, /* MOVEA */
{ CPUFUNC(op_3070_0), 12400 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 12408 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 12409 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 12410 }, /* MOVEA */
{ CPUFUNC(op_307b_0), 12411 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 12412 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 12416 }, /* MOVE */
{ CPUFUNC(op_3088_0), 12424 }, /* MOVE */
{ CPUFUNC(op_3090_0), 12432 }, /* MOVE */
{ CPUFUNC(op_3098_0), 12440 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 12448 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 12456 }, /* MOVE */
{ CPUFUNC(op_30b0_0), 12464 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 12472 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 12473 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 12474 }, /* MOVE */
{ CPUFUNC(op_30bb_0), 12475 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 12476 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 12480 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 12488 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 12496 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 12504 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 12512 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 12520 }, /* MOVE */
{ CPUFUNC(op_30f0_0), 12528 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 12536 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 12537 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 12538 }, /* MOVE */
{ CPUFUNC(op_30fb_0), 12539 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 12540 }, /* MOVE */
{ CPUFUNC(op_3100_0), 12544 }, /* MOVE */
{ CPUFUNC(op_3108_0), 12552 }, /* MOVE */
{ CPUFUNC(op_3110_0), 12560 }, /* MOVE */
{ CPUFUNC(op_3118_0), 12568 }, /* MOVE */
{ CPUFUNC(op_3120_0), 12576 }, /* MOVE */
{ CPUFUNC(op_3128_0), 12584 }, /* MOVE */
{ CPUFUNC(op_3130_0), 12592 }, /* MOVE */
{ CPUFUNC(op_3138_0), 12600 }, /* MOVE */
{ CPUFUNC(op_3139_0), 12601 }, /* MOVE */
{ CPUFUNC(op_313a_0), 12602 }, /* MOVE */
{ CPUFUNC(op_313b_0), 12603 }, /* MOVE */
{ CPUFUNC(op_313c_0), 12604 }, /* MOVE */
{ CPUFUNC(op_3140_0), 12608 }, /* MOVE */
{ CPUFUNC(op_3148_0), 12616 }, /* MOVE */
{ CPUFUNC(op_3150_0), 12624 }, /* MOVE */
{ CPUFUNC(op_3158_0), 12632 }, /* MOVE */
{ CPUFUNC(op_3160_0), 12640 }, /* MOVE */
{ CPUFUNC(op_3168_0), 12648 }, /* MOVE */
{ CPUFUNC(op_3170_0), 12656 }, /* MOVE */
{ CPUFUNC(op_3178_0), 12664 }, /* MOVE */
{ CPUFUNC(op_3179_0), 12665 }, /* MOVE */
{ CPUFUNC(op_317a_0), 12666 }, /* MOVE */
{ CPUFUNC(op_317b_0), 12667 }, /* MOVE */
{ CPUFUNC(op_317c_0), 12668 }, /* MOVE */
{ CPUFUNC(op_3180_0), 12672 }, /* MOVE */
{ CPUFUNC(op_3188_0), 12680 }, /* MOVE */
{ CPUFUNC(op_3190_0), 12688 }, /* MOVE */
{ CPUFUNC(op_3198_0), 12696 }, /* MOVE */
{ CPUFUNC(op_31a0_0), 12704 }, /* MOVE */
{ CPUFUNC(op_31a8_0), 12712 }, /* MOVE */
{ CPUFUNC(op_31b0_0), 12720 }, /* MOVE */
{ CPUFUNC(op_31b8_0), 12728 }, /* MOVE */
{ CPUFUNC(op_31b9_0), 12729 }, /* MOVE */
{ CPUFUNC(op_31ba_0), 12730 }, /* MOVE */
{ CPUFUNC(op_31bb_0), 12731 }, /* MOVE */
{ CPUFUNC(op_31bc_0), 12732 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 12736 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 12744 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 12752 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 12760 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 12768 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 12776 }, /* MOVE */
{ CPUFUNC(op_31f0_0), 12784 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 12792 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 12793 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 12794 }, /* MOVE */
{ CPUFUNC(op_31fb_0), 12795 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 12796 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 13248 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 13256 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 13264 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 13272 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 13280 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 13288 }, /* MOVE */
{ CPUFUNC(op_33f0_0), 13296 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 13304 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 13305 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 13306 }, /* MOVE */
{ CPUFUNC(op_33fb_0), 13307 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 13308 }, /* MOVE */
{ CPUFUNC(op_4000_0), 16384 }, /* NEGX */
{ CPUFUNC(op_4010_0), 16400 }, /* NEGX */
{ CPUFUNC(op_4018_0), 16408 }, /* NEGX */
{ CPUFUNC(op_4020_0), 16416 }, /* NEGX */
{ CPUFUNC(op_4028_0), 16424 }, /* NEGX */
{ CPUFUNC(op_4030_0), 16432 }, /* NEGX */
{ CPUFUNC(op_4038_0), 16440 }, /* NEGX */
{ CPUFUNC(op_4039_0), 16441 }, /* NEGX */
{ CPUFUNC(op_4040_0), 16448 }, /* NEGX */
{ CPUFUNC(op_4050_0), 16464 }, /* NEGX */
{ CPUFUNC(op_4058_0), 16472 }, /* NEGX */
{ CPUFUNC(op_4060_0), 16480 }, /* NEGX */
{ CPUFUNC(op_4068_0), 16488 }, /* NEGX */
{ CPUFUNC(op_4070_0), 16496 }, /* NEGX */
{ CPUFUNC(op_4078_0), 16504 }, /* NEGX */
{ CPUFUNC(op_4079_0), 16505 }, /* NEGX */
{ CPUFUNC(op_4080_0), 16512 }, /* NEGX */
{ CPUFUNC(op_4090_0), 16528 }, /* NEGX */
{ CPUFUNC(op_4098_0), 16536 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 16544 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 16552 }, /* NEGX */
{ CPUFUNC(op_40b0_0), 16560 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 16568 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 16569 }, /* NEGX */
{ CPUFUNC(op_40c0_0), 16576 }, /* MVSR2 */
{ CPUFUNC(op_40d0_0), 16592 }, /* MVSR2 */
{ CPUFUNC(op_40d8_0), 16600 }, /* MVSR2 */
{ CPUFUNC(op_40e0_0), 16608 }, /* MVSR2 */
{ CPUFUNC(op_40e8_0), 16616 }, /* MVSR2 */
{ CPUFUNC(op_40f0_0), 16624 }, /* MVSR2 */
{ CPUFUNC(op_40f8_0), 16632 }, /* MVSR2 */
{ CPUFUNC(op_40f9_0), 16633 }, /* MVSR2 */
{ CPUFUNC(op_4100_0), 16640 }, /* CHK */
{ CPUFUNC(op_4110_0), 16656 }, /* CHK */
{ CPUFUNC(op_4118_0), 16664 }, /* CHK */
{ CPUFUNC(op_4120_0), 16672 }, /* CHK */
{ CPUFUNC(op_4128_0), 16680 }, /* CHK */
{ CPUFUNC(op_4130_0), 16688 }, /* CHK */
{ CPUFUNC(op_4138_0), 16696 }, /* CHK */
{ CPUFUNC(op_4139_0), 16697 }, /* CHK */
{ CPUFUNC(op_413a_0), 16698 }, /* CHK */
{ CPUFUNC(op_413b_0), 16699 }, /* CHK */
{ CPUFUNC(op_413c_0), 16700 }, /* CHK */
{ CPUFUNC(op_4180_0), 16768 }, /* CHK */
{ CPUFUNC(op_4190_0), 16784 }, /* CHK */
{ CPUFUNC(op_4198_0), 16792 }, /* CHK */
{ CPUFUNC(op_41a0_0), 16800 }, /* CHK */
{ CPUFUNC(op_41a8_0), 16808 }, /* CHK */
{ CPUFUNC(op_41b0_0), 16816 }, /* CHK */
{ CPUFUNC(op_41b8_0), 16824 }, /* CHK */
{ CPUFUNC(op_41b9_0), 16825 }, /* CHK */
{ CPUFUNC(op_41ba_0), 16826 }, /* CHK */
{ CPUFUNC(op_41bb_0), 16827 }, /* CHK */
{ CPUFUNC(op_41bc_0), 16828 }, /* CHK */
{ CPUFUNC(op_41d0_0), 16848 }, /* LEA */
{ CPUFUNC(op_41e8_0), 16872 }, /* LEA */
{ CPUFUNC(op_41f0_0), 16880 }, /* LEA */
{ CPUFUNC(op_41f8_0), 16888 }, /* LEA */
{ CPUFUNC(op_41f9_0), 16889 }, /* LEA */
{ CPUFUNC(op_41fa_0), 16890 }, /* LEA */
{ CPUFUNC(op_41fb_0), 16891 }, /* LEA */
{ CPUFUNC(op_4200_0), 16896 }, /* CLR */
{ CPUFUNC(op_4210_0), 16912 }, /* CLR */
{ CPUFUNC(op_4218_0), 16920 }, /* CLR */
{ CPUFUNC(op_4220_0), 16928 }, /* CLR */
{ CPUFUNC(op_4228_0), 16936 }, /* CLR */
{ CPUFUNC(op_4230_0), 16944 }, /* CLR */
{ CPUFUNC(op_4238_0), 16952 }, /* CLR */
{ CPUFUNC(op_4239_0), 16953 }, /* CLR */
{ CPUFUNC(op_4240_0), 16960 }, /* CLR */
{ CPUFUNC(op_4250_0), 16976 }, /* CLR */
{ CPUFUNC(op_4258_0), 16984 }, /* CLR */
{ CPUFUNC(op_4260_0), 16992 }, /* CLR */
{ CPUFUNC(op_4268_0), 17000 }, /* CLR */
{ CPUFUNC(op_4270_0), 17008 }, /* CLR */
{ CPUFUNC(op_4278_0), 17016 }, /* CLR */
{ CPUFUNC(op_4279_0), 17017 }, /* CLR */
{ CPUFUNC(op_4280_0), 17024 }, /* CLR */
{ CPUFUNC(op_4290_0), 17040 }, /* CLR */
{ CPUFUNC(op_4298_0), 17048 }, /* CLR */
{ CPUFUNC(op_42a0_0), 17056 }, /* CLR */
{ CPUFUNC(op_42a8_0), 17064 }, /* CLR */
{ CPUFUNC(op_42b0_0), 17072 }, /* CLR */
{ CPUFUNC(op_42b8_0), 17080 }, /* CLR */
{ CPUFUNC(op_42b9_0), 17081 }, /* CLR */
{ CPUFUNC(op_42c0_0), 17088 }, /* MVSR2 */
{ CPUFUNC(op_42d0_0), 17104 }, /* MVSR2 */
{ CPUFUNC(op_42d8_0), 17112 }, /* MVSR2 */
{ CPUFUNC(op_42e0_0), 17120 }, /* MVSR2 */
{ CPUFUNC(op_42e8_0), 17128 }, /* MVSR2 */
{ CPUFUNC(op_42f0_0), 17136 }, /* MVSR2 */
{ CPUFUNC(op_42f8_0), 17144 }, /* MVSR2 */
{ CPUFUNC(op_42f9_0), 17145 }, /* MVSR2 */
{ CPUFUNC(op_4400_0), 17408 }, /* NEG */
{ CPUFUNC(op_4410_0), 17424 }, /* NEG */
{ CPUFUNC(op_4418_0), 17432 }, /* NEG */
{ CPUFUNC(op_4420_0), 17440 }, /* NEG */
{ CPUFUNC(op_4428_0), 17448 }, /* NEG */
{ CPUFUNC(op_4430_0), 17456 }, /* NEG */
{ CPUFUNC(op_4438_0), 17464 }, /* NEG */
{ CPUFUNC(op_4439_0), 17465 }, /* NEG */
{ CPUFUNC(op_4440_0), 17472 }, /* NEG */
{ CPUFUNC(op_4450_0), 17488 }, /* NEG */
{ CPUFUNC(op_4458_0), 17496 }, /* NEG */
{ CPUFUNC(op_4460_0), 17504 }, /* NEG */
{ CPUFUNC(op_4468_0), 17512 }, /* NEG */
{ CPUFUNC(op_4470_0), 17520 }, /* NEG */
{ CPUFUNC(op_4478_0), 17528 }, /* NEG */
{ CPUFUNC(op_4479_0), 17529 }, /* NEG */
{ CPUFUNC(op_4480_0), 17536 }, /* NEG */
{ CPUFUNC(op_4490_0), 17552 }, /* NEG */
{ CPUFUNC(op_4498_0), 17560 }, /* NEG */
{ CPUFUNC(op_44a0_0), 17568 }, /* NEG */
{ CPUFUNC(op_44a8_0), 17576 }, /* NEG */
{ CPUFUNC(op_44b0_0), 17584 }, /* NEG */
{ CPUFUNC(op_44b8_0), 17592 }, /* NEG */
{ CPUFUNC(op_44b9_0), 17593 }, /* NEG */
{ CPUFUNC(op_44c0_0), 17600 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 17616 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 17624 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 17632 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 17640 }, /* MV2SR */
{ CPUFUNC(op_44f0_0), 17648 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 17656 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 17657 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 17658 }, /* MV2SR */
{ CPUFUNC(op_44fb_0), 17659 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 17660 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 17920 }, /* NOT */
{ CPUFUNC(op_4610_0), 17936 }, /* NOT */
{ CPUFUNC(op_4618_0), 17944 }, /* NOT */
{ CPUFUNC(op_4620_0), 17952 }, /* NOT */
{ CPUFUNC(op_4628_0), 17960 }, /* NOT */
{ CPUFUNC(op_4630_0), 17968 }, /* NOT */
{ CPUFUNC(op_4638_0), 17976 }, /* NOT */
{ CPUFUNC(op_4639_0), 17977 }, /* NOT */
{ CPUFUNC(op_4640_0), 17984 }, /* NOT */
{ CPUFUNC(op_4650_0), 18000 }, /* NOT */
{ CPUFUNC(op_4658_0), 18008 }, /* NOT */
{ CPUFUNC(op_4660_0), 18016 }, /* NOT */
{ CPUFUNC(op_4668_0), 18024 }, /* NOT */
{ CPUFUNC(op_4670_0), 18032 }, /* NOT */
{ CPUFUNC(op_4678_0), 18040 }, /* NOT */
{ CPUFUNC(op_4679_0), 18041 }, /* NOT */
{ CPUFUNC(op_4680_0), 18048 }, /* NOT */
{ CPUFUNC(op_4690_0), 18064 }, /* NOT */
{ CPUFUNC(op_4698_0), 18072 }, /* NOT */
{ CPUFUNC(op_46a0_0), 18080 }, /* NOT */
{ CPUFUNC(op_46a8_0), 18088 }, /* NOT */
{ CPUFUNC(op_46b0_0), 18096 }, /* NOT */
{ CPUFUNC(op_46b8_0), 18104 }, /* NOT */
{ CPUFUNC(op_46b9_0), 18105 }, /* NOT */
{ CPUFUNC(op_46c0_0), 18112 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 18128 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 18136 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 18144 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 18152 }, /* MV2SR */
{ CPUFUNC(op_46f0_0), 18160 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 18168 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 18169 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 18170 }, /* MV2SR */
{ CPUFUNC(op_46fb_0), 18171 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 18172 }, /* MV2SR */
{ CPUFUNC(op_4800_0), 18432 }, /* NBCD */
{ CPUFUNC(op_4808_0), 18440 }, /* LINK */
{ CPUFUNC(op_4810_0), 18448 }, /* NBCD */
{ CPUFUNC(op_4818_0), 18456 }, /* NBCD */
{ CPUFUNC(op_4820_0), 18464 }, /* NBCD */
{ CPUFUNC(op_4828_0), 18472 }, /* NBCD */
{ CPUFUNC(op_4830_0), 18480 }, /* NBCD */
{ CPUFUNC(op_4838_0), 18488 }, /* NBCD */
{ CPUFUNC(op_4839_0), 18489 }, /* NBCD */
{ CPUFUNC(op_4840_0), 18496 }, /* SWAP */
{ CPUFUNC(op_4848_0), 18504 }, /* BKPT */
{ CPUFUNC(op_4850_0), 18512 }, /* PEA */
{ CPUFUNC(op_4868_0), 18536 }, /* PEA */
{ CPUFUNC(op_4870_0), 18544 }, /* PEA */
{ CPUFUNC(op_4878_0), 18552 }, /* PEA */
{ CPUFUNC(op_4879_0), 18553 }, /* PEA */
{ CPUFUNC(op_487a_0), 18554 }, /* PEA */
{ CPUFUNC(op_487b_0), 18555 }, /* PEA */
{ CPUFUNC(op_4880_0), 18560 }, /* EXT */
{ CPUFUNC(op_4890_0), 18576 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 18592 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 18600 }, /* MVMLE */
{ CPUFUNC(op_48b0_0), 18608 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 18616 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 18617 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 18624 }, /* EXT */
{ CPUFUNC(op_48d0_0), 18640 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 18656 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 18664 }, /* MVMLE */
{ CPUFUNC(op_48f0_0), 18672 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 18680 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 18681 }, /* MVMLE */
{ CPUFUNC(op_49c0_0), 18880 }, /* EXT */
{ CPUFUNC(op_4a00_0), 18944 }, /* TST */
{ CPUFUNC(op_4a10_0), 18960 }, /* TST */
{ CPUFUNC(op_4a18_0), 18968 }, /* TST */
{ CPUFUNC(op_4a20_0), 18976 }, /* TST */
{ CPUFUNC(op_4a28_0), 18984 }, /* TST */
{ CPUFUNC(op_4a30_0), 18992 }, /* TST */
{ CPUFUNC(op_4a38_0), 19000 }, /* TST */
{ CPUFUNC(op_4a39_0), 19001 }, /* TST */
{ CPUFUNC(op_4a3a_0), 19002 }, /* TST */
{ CPUFUNC(op_4a3b_0), 19003 }, /* TST */
{ CPUFUNC(op_4a3c_0), 19004 }, /* TST */
{ CPUFUNC(op_4a40_0), 19008 }, /* TST */
{ CPUFUNC(op_4a48_0), 19016 }, /* TST */
{ CPUFUNC(op_4a50_0), 19024 }, /* TST */
{ CPUFUNC(op_4a58_0), 19032 }, /* TST */
{ CPUFUNC(op_4a60_0), 19040 }, /* TST */
{ CPUFUNC(op_4a68_0), 19048 }, /* TST */
{ CPUFUNC(op_4a70_0), 19056 }, /* TST */
{ CPUFUNC(op_4a78_0), 19064 }, /* TST */
{ CPUFUNC(op_4a79_0), 19065 }, /* TST */
{ CPUFUNC(op_4a7a_0), 19066 }, /* TST */
{ CPUFUNC(op_4a7b_0), 19067 }, /* TST */
{ CPUFUNC(op_4a7c_0), 19068 }, /* TST */
{ CPUFUNC(op_4a80_0), 19072 }, /* TST */
{ CPUFUNC(op_4a88_0), 19080 }, /* TST */
{ CPUFUNC(op_4a90_0), 19088 }, /* TST */
{ CPUFUNC(op_4a98_0), 19096 }, /* TST */
{ CPUFUNC(op_4aa0_0), 19104 }, /* TST */
{ CPUFUNC(op_4aa8_0), 19112 }, /* TST */
{ CPUFUNC(op_4ab0_0), 19120 }, /* TST */
{ CPUFUNC(op_4ab8_0), 19128 }, /* TST */
{ CPUFUNC(op_4ab9_0), 19129 }, /* TST */
{ CPUFUNC(op_4aba_0), 19130 }, /* TST */
{ CPUFUNC(op_4abb_0), 19131 }, /* TST */
{ CPUFUNC(op_4abc_0), 19132 }, /* TST */
{ CPUFUNC(op_4ac0_0), 19136 }, /* TAS */
{ CPUFUNC(op_4ad0_0), 19152 }, /* TAS */
{ CPUFUNC(op_4ad8_0), 19160 }, /* TAS */
{ CPUFUNC(op_4ae0_0), 19168 }, /* TAS */
{ CPUFUNC(op_4ae8_0), 19176 }, /* TAS */
{ CPUFUNC(op_4af0_0), 19184 }, /* TAS */
{ CPUFUNC(op_4af8_0), 19192 }, /* TAS */
{ CPUFUNC(op_4af9_0), 19193 }, /* TAS */
{ CPUFUNC(op_4c00_0), 19456 }, /* MULL */
{ CPUFUNC(op_4c10_0), 19472 }, /* MULL */
{ CPUFUNC(op_4c18_0), 19480 }, /* MULL */
{ CPUFUNC(op_4c20_0), 19488 }, /* MULL */
{ CPUFUNC(op_4c28_0), 19496 }, /* MULL */
{ CPUFUNC(op_4c30_0), 19504 }, /* MULL */
{ CPUFUNC(op_4c38_0), 19512 }, /* MULL */
{ CPUFUNC(op_4c39_0), 19513 }, /* MULL */
{ CPUFUNC(op_4c3a_0), 19514 }, /* MULL */
{ CPUFUNC(op_4c3b_0), 19515 }, /* MULL */
{ CPUFUNC(op_4c3c_0), 19516 }, /* MULL */
{ CPUFUNC(op_4c40_0), 19520 }, /* DIVL */
{ CPUFUNC(op_4c50_0), 19536 }, /* DIVL */
{ CPUFUNC(op_4c58_0), 19544 }, /* DIVL */
{ CPUFUNC(op_4c60_0), 19552 }, /* DIVL */
{ CPUFUNC(op_4c68_0), 19560 }, /* DIVL */
{ CPUFUNC(op_4c70_0), 19568 }, /* DIVL */
{ CPUFUNC(op_4c78_0), 19576 }, /* DIVL */
{ CPUFUNC(op_4c79_0), 19577 }, /* DIVL */
{ CPUFUNC(op_4c7a_0), 19578 }, /* DIVL */
{ CPUFUNC(op_4c7b_0), 19579 }, /* DIVL */
{ CPUFUNC(op_4c7c_0), 19580 }, /* DIVL */
{ CPUFUNC(op_4c90_0), 19600 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 19608 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 19624 }, /* MVMEL */
{ CPUFUNC(op_4cb0_0), 19632 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 19640 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 19641 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 19642 }, /* MVMEL */
{ CPUFUNC(op_4cbb_0), 19643 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 19664 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 19672 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 19688 }, /* MVMEL */
{ CPUFUNC(op_4cf0_0), 19696 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 19704 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 19705 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 19706 }, /* MVMEL */
{ CPUFUNC(op_4cfb_0), 19707 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 20032 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 20048 }, /* LINK */
{ CPUFUNC(op_4e58_0), 20056 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 20064 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 20072 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 20080 }, /* RESET */
{ CPUFUNC(op_4e71_0), 20081 }, /* NOP */
{ CPUFUNC(op_4e72_0), 20082 }, /* STOP */
{ CPUFUNC(op_4e73_0), 20083 }, /* RTE */
{ CPUFUNC(op_4e74_0), 20084 }, /* RTD */
{ CPUFUNC(op_4e75_0), 20085 }, /* RTS */
{ CPUFUNC(op_4e76_0), 20086 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 20087 }, /* RTR */
{ CPUFUNC(op_4e7a_0), 20090 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_0), 20091 }, /* MOVE2C */
{ CPUFUNC(op_4e90_0), 20112 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 20136 }, /* JSR */
{ CPUFUNC(op_4eb0_0), 20144 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 20152 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 20153 }, /* JSR */
{ CPUFUNC(op_4eba_0), 20154 }, /* JSR */
{ CPUFUNC(op_4ebb_0), 20155 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 20176 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 20200 }, /* JMP */
{ CPUFUNC(op_4ef0_0), 20208 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 20216 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 20217 }, /* JMP */
{ CPUFUNC(op_4efa_0), 20218 }, /* JMP */
{ CPUFUNC(op_4efb_0), 20219 }, /* JMP */
{ CPUFUNC(op_5000_0), 20480 }, /* ADD */
{ CPUFUNC(op_5010_0), 20496 }, /* ADD */
{ CPUFUNC(op_5018_0), 20504 }, /* ADD */
{ CPUFUNC(op_5020_0), 20512 }, /* ADD */
{ CPUFUNC(op_5028_0), 20520 }, /* ADD */
{ CPUFUNC(op_5030_0), 20528 }, /* ADD */
{ CPUFUNC(op_5038_0), 20536 }, /* ADD */
{ CPUFUNC(op_5039_0), 20537 }, /* ADD */
{ CPUFUNC(op_5040_0), 20544 }, /* ADD */
{ CPUFUNC(op_5048_0), 20552 }, /* ADDA */
{ CPUFUNC(op_5050_0), 20560 }, /* ADD */
{ CPUFUNC(op_5058_0), 20568 }, /* ADD */
{ CPUFUNC(op_5060_0), 20576 }, /* ADD */
{ CPUFUNC(op_5068_0), 20584 }, /* ADD */
{ CPUFUNC(op_5070_0), 20592 }, /* ADD */
{ CPUFUNC(op_5078_0), 20600 }, /* ADD */
{ CPUFUNC(op_5079_0), 20601 }, /* ADD */
{ CPUFUNC(op_5080_0), 20608 }, /* ADD */
{ CPUFUNC(op_5088_0), 20616 }, /* ADDA */
{ CPUFUNC(op_5090_0), 20624 }, /* ADD */
{ CPUFUNC(op_5098_0), 20632 }, /* ADD */
{ CPUFUNC(op_50a0_0), 20640 }, /* ADD */
{ CPUFUNC(op_50a8_0), 20648 }, /* ADD */
{ CPUFUNC(op_50b0_0), 20656 }, /* ADD */
{ CPUFUNC(op_50b8_0), 20664 }, /* ADD */
{ CPUFUNC(op_50b9_0), 20665 }, /* ADD */
{ CPUFUNC(op_50c0_0), 20672 }, /* Scc */
{ CPUFUNC(op_50c8_0), 20680 }, /* DBcc */
{ CPUFUNC(op_50d0_0), 20688 }, /* Scc */
{ CPUFUNC(op_50d8_0), 20696 }, /* Scc */
{ CPUFUNC(op_50e0_0), 20704 }, /* Scc */
{ CPUFUNC(op_50e8_0), 20712 }, /* Scc */
{ CPUFUNC(op_50f0_0), 20720 }, /* Scc */
{ CPUFUNC(op_50f8_0), 20728 }, /* Scc */
{ CPUFUNC(op_50f9_0), 20729 }, /* Scc */
{ CPUFUNC(op_50fa_0), 20730 }, /* TRAPcc */
{ CPUFUNC(op_50fb_0), 20731 }, /* TRAPcc */
{ CPUFUNC(op_50fc_0), 20732 }, /* TRAPcc */
{ CPUFUNC(op_5100_0), 20736 }, /* SUB */
{ CPUFUNC(op_5110_0), 20752 }, /* SUB */
{ CPUFUNC(op_5118_0), 20760 }, /* SUB */
{ CPUFUNC(op_5120_0), 20768 }, /* SUB */
{ CPUFUNC(op_5128_0), 20776 }, /* SUB */
{ CPUFUNC(op_5130_0), 20784 }, /* SUB */
{ CPUFUNC(op_5138_0), 20792 }, /* SUB */
{ CPUFUNC(op_5139_0), 20793 }, /* SUB */
{ CPUFUNC(op_5140_0), 20800 }, /* SUB */
{ CPUFUNC(op_5148_0), 20808 }, /* SUBA */
{ CPUFUNC(op_5150_0), 20816 }, /* SUB */
{ CPUFUNC(op_5158_0), 20824 }, /* SUB */
{ CPUFUNC(op_5160_0), 20832 }, /* SUB */
{ CPUFUNC(op_5168_0), 20840 }, /* SUB */
{ CPUFUNC(op_5170_0), 20848 }, /* SUB */
{ CPUFUNC(op_5178_0), 20856 }, /* SUB */
{ CPUFUNC(op_5179_0), 20857 }, /* SUB */
{ CPUFUNC(op_5180_0), 20864 }, /* SUB */
{ CPUFUNC(op_5188_0), 20872 }, /* SUBA */
{ CPUFUNC(op_5190_0), 20880 }, /* SUB */
{ CPUFUNC(op_5198_0), 20888 }, /* SUB */
{ CPUFUNC(op_51a0_0), 20896 }, /* SUB */
{ CPUFUNC(op_51a8_0), 20904 }, /* SUB */
{ CPUFUNC(op_51b0_0), 20912 }, /* SUB */
{ CPUFUNC(op_51b8_0), 20920 }, /* SUB */
{ CPUFUNC(op_51b9_0), 20921 }, /* SUB */
{ CPUFUNC(op_51c0_0), 20928 }, /* Scc */
{ CPUFUNC(op_51c8_0), 20936 }, /* DBcc */
{ CPUFUNC(op_51d0_0), 20944 }, /* Scc */
{ CPUFUNC(op_51d8_0), 20952 }, /* Scc */
{ CPUFUNC(op_51e0_0), 20960 }, /* Scc */
{ CPUFUNC(op_51e8_0), 20968 }, /* Scc */
{ CPUFUNC(op_51f0_0), 20976 }, /* Scc */
{ CPUFUNC(op_51f8_0), 20984 }, /* Scc */
{ CPUFUNC(op_51f9_0), 20985 }, /* Scc */
{ CPUFUNC(op_51fa_0), 20986 }, /* TRAPcc */
{ CPUFUNC(op_51fb_0), 20987 }, /* TRAPcc */
{ CPUFUNC(op_51fc_0), 20988 }, /* TRAPcc */
{ CPUFUNC(op_52c0_0), 21184 }, /* Scc */
{ CPUFUNC(op_52c8_0), 21192 }, /* DBcc */
{ CPUFUNC(op_52d0_0), 21200 }, /* Scc */
{ CPUFUNC(op_52d8_0), 21208 }, /* Scc */
{ CPUFUNC(op_52e0_0), 21216 }, /* Scc */
{ CPUFUNC(op_52e8_0), 21224 }, /* Scc */
{ CPUFUNC(op_52f0_0), 21232 }, /* Scc */
{ CPUFUNC(op_52f8_0), 21240 }, /* Scc */
{ CPUFUNC(op_52f9_0), 21241 }, /* Scc */
{ CPUFUNC(op_52fa_0), 21242 }, /* TRAPcc */
{ CPUFUNC(op_52fb_0), 21243 }, /* TRAPcc */
{ CPUFUNC(op_52fc_0), 21244 }, /* TRAPcc */
{ CPUFUNC(op_53c0_0), 21440 }, /* Scc */
{ CPUFUNC(op_53c8_0), 21448 }, /* DBcc */
{ CPUFUNC(op_53d0_0), 21456 }, /* Scc */
{ CPUFUNC(op_53d8_0), 21464 }, /* Scc */
{ CPUFUNC(op_53e0_0), 21472 }, /* Scc */
{ CPUFUNC(op_53e8_0), 21480 }, /* Scc */
{ CPUFUNC(op_53f0_0), 21488 }, /* Scc */
{ CPUFUNC(op_53f8_0), 21496 }, /* Scc */
{ CPUFUNC(op_53f9_0), 21497 }, /* Scc */
{ CPUFUNC(op_53fa_0), 21498 }, /* TRAPcc */
{ CPUFUNC(op_53fb_0), 21499 }, /* TRAPcc */
{ CPUFUNC(op_53fc_0), 21500 }, /* TRAPcc */
{ CPUFUNC(op_54c0_0), 21696 }, /* Scc */
{ CPUFUNC(op_54c8_0), 21704 }, /* DBcc */
{ CPUFUNC(op_54d0_0), 21712 }, /* Scc */
{ CPUFUNC(op_54d8_0), 21720 }, /* Scc */
{ CPUFUNC(op_54e0_0), 21728 }, /* Scc */
{ CPUFUNC(op_54e8_0), 21736 }, /* Scc */
{ CPUFUNC(op_54f0_0), 21744 }, /* Scc */
{ CPUFUNC(op_54f8_0), 21752 }, /* Scc */
{ CPUFUNC(op_54f9_0), 21753 }, /* Scc */
{ CPUFUNC(op_54fa_0), 21754 }, /* TRAPcc */
{ CPUFUNC(op_54fb_0), 21755 }, /* TRAPcc */
{ CPUFUNC(op_54fc_0), 21756 }, /* TRAPcc */
{ CPUFUNC(op_55c0_0), 21952 }, /* Scc */
{ CPUFUNC(op_55c8_0), 21960 }, /* DBcc */
{ CPUFUNC(op_55d0_0), 21968 }, /* Scc */
{ CPUFUNC(op_55d8_0), 21976 }, /* Scc */
{ CPUFUNC(op_55e0_0), 21984 }, /* Scc */
{ CPUFUNC(op_55e8_0), 21992 }, /* Scc */
{ CPUFUNC(op_55f0_0), 22000 }, /* Scc */
{ CPUFUNC(op_55f8_0), 22008 }, /* Scc */
{ CPUFUNC(op_55f9_0), 22009 }, /* Scc */
{ CPUFUNC(op_55fa_0), 22010 }, /* TRAPcc */
{ CPUFUNC(op_55fb_0), 22011 }, /* TRAPcc */
{ CPUFUNC(op_55fc_0), 22012 }, /* TRAPcc */
{ CPUFUNC(op_56c0_0), 22208 }, /* Scc */
{ CPUFUNC(op_56c8_0), 22216 }, /* DBcc */
{ CPUFUNC(op_56d0_0), 22224 }, /* Scc */
{ CPUFUNC(op_56d8_0), 22232 }, /* Scc */
{ CPUFUNC(op_56e0_0), 22240 }, /* Scc */
{ CPUFUNC(op_56e8_0), 22248 }, /* Scc */
{ CPUFUNC(op_56f0_0), 22256 }, /* Scc */
{ CPUFUNC(op_56f8_0), 22264 }, /* Scc */
{ CPUFUNC(op_56f9_0), 22265 }, /* Scc */
{ CPUFUNC(op_56fa_0), 22266 }, /* TRAPcc */
{ CPUFUNC(op_56fb_0), 22267 }, /* TRAPcc */
{ CPUFUNC(op_56fc_0), 22268 }, /* TRAPcc */
{ CPUFUNC(op_57c0_0), 22464 }, /* Scc */
{ CPUFUNC(op_57c8_0), 22472 }, /* DBcc */
{ CPUFUNC(op_57d0_0), 22480 }, /* Scc */
{ CPUFUNC(op_57d8_0), 22488 }, /* Scc */
{ CPUFUNC(op_57e0_0), 22496 }, /* Scc */
{ CPUFUNC(op_57e8_0), 22504 }, /* Scc */
{ CPUFUNC(op_57f0_0), 22512 }, /* Scc */
{ CPUFUNC(op_57f8_0), 22520 }, /* Scc */
{ CPUFUNC(op_57f9_0), 22521 }, /* Scc */
{ CPUFUNC(op_57fa_0), 22522 }, /* TRAPcc */
{ CPUFUNC(op_57fb_0), 22523 }, /* TRAPcc */
{ CPUFUNC(op_57fc_0), 22524 }, /* TRAPcc */
{ CPUFUNC(op_58c0_0), 22720 }, /* Scc */
{ CPUFUNC(op_58c8_0), 22728 }, /* DBcc */
{ CPUFUNC(op_58d0_0), 22736 }, /* Scc */
{ CPUFUNC(op_58d8_0), 22744 }, /* Scc */
{ CPUFUNC(op_58e0_0), 22752 }, /* Scc */
{ CPUFUNC(op_58e8_0), 22760 }, /* Scc */
{ CPUFUNC(op_58f0_0), 22768 }, /* Scc */
{ CPUFUNC(op_58f8_0), 22776 }, /* Scc */
{ CPUFUNC(op_58f9_0), 22777 }, /* Scc */
{ CPUFUNC(op_58fa_0), 22778 }, /* TRAPcc */
{ CPUFUNC(op_58fb_0), 22779 }, /* TRAPcc */
{ CPUFUNC(op_58fc_0), 22780 }, /* TRAPcc */
{ CPUFUNC(op_59c0_0), 22976 }, /* Scc */
{ CPUFUNC(op_59c8_0), 22984 }, /* DBcc */
{ CPUFUNC(op_59d0_0), 22992 }, /* Scc */
{ CPUFUNC(op_59d8_0), 23000 }, /* Scc */
{ CPUFUNC(op_59e0_0), 23008 }, /* Scc */
{ CPUFUNC(op_59e8_0), 23016 }, /* Scc */
{ CPUFUNC(op_59f0_0), 23024 }, /* Scc */
{ CPUFUNC(op_59f8_0), 23032 }, /* Scc */
{ CPUFUNC(op_59f9_0), 23033 }, /* Scc */
{ CPUFUNC(op_59fa_0), 23034 }, /* TRAPcc */
{ CPUFUNC(op_59fb_0), 23035 }, /* TRAPcc */
{ CPUFUNC(op_59fc_0), 23036 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_0), 23232 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 23240 }, /* DBcc */
{ CPUFUNC(op_5ad0_0), 23248 }, /* Scc */
{ CPUFUNC(op_5ad8_0), 23256 }, /* Scc */
{ CPUFUNC(op_5ae0_0), 23264 }, /* Scc */
{ CPUFUNC(op_5ae8_0), 23272 }, /* Scc */
{ CPUFUNC(op_5af0_0), 23280 }, /* Scc */
{ CPUFUNC(op_5af8_0), 23288 }, /* Scc */
{ CPUFUNC(op_5af9_0), 23289 }, /* Scc */
{ CPUFUNC(op_5afa_0), 23290 }, /* TRAPcc */
{ CPUFUNC(op_5afb_0), 23291 }, /* TRAPcc */
{ CPUFUNC(op_5afc_0), 23292 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_0), 23488 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 23496 }, /* DBcc */
{ CPUFUNC(op_5bd0_0), 23504 }, /* Scc */
{ CPUFUNC(op_5bd8_0), 23512 }, /* Scc */
{ CPUFUNC(op_5be0_0), 23520 }, /* Scc */
{ CPUFUNC(op_5be8_0), 23528 }, /* Scc */
{ CPUFUNC(op_5bf0_0), 23536 }, /* Scc */
{ CPUFUNC(op_5bf8_0), 23544 }, /* Scc */
{ CPUFUNC(op_5bf9_0), 23545 }, /* Scc */
{ CPUFUNC(op_5bfa_0), 23546 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_0), 23547 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_0), 23548 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_0), 23744 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 23752 }, /* DBcc */
{ CPUFUNC(op_5cd0_0), 23760 }, /* Scc */
{ CPUFUNC(op_5cd8_0), 23768 }, /* Scc */
{ CPUFUNC(op_5ce0_0), 23776 }, /* Scc */
{ CPUFUNC(op_5ce8_0), 23784 }, /* Scc */
{ CPUFUNC(op_5cf0_0), 23792 }, /* Scc */
{ CPUFUNC(op_5cf8_0), 23800 }, /* Scc */
{ CPUFUNC(op_5cf9_0), 23801 }, /* Scc */
{ CPUFUNC(op_5cfa_0), 23802 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_0), 23803 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_0), 23804 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_0), 24000 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 24008 }, /* DBcc */
{ CPUFUNC(op_5dd0_0), 24016 }, /* Scc */
{ CPUFUNC(op_5dd8_0), 24024 }, /* Scc */
{ CPUFUNC(op_5de0_0), 24032 }, /* Scc */
{ CPUFUNC(op_5de8_0), 24040 }, /* Scc */
{ CPUFUNC(op_5df0_0), 24048 }, /* Scc */
{ CPUFUNC(op_5df8_0), 24056 }, /* Scc */
{ CPUFUNC(op_5df9_0), 24057 }, /* Scc */
{ CPUFUNC(op_5dfa_0), 24058 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_0), 24059 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_0), 24060 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_0), 24256 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 24264 }, /* DBcc */
{ CPUFUNC(op_5ed0_0), 24272 }, /* Scc */
{ CPUFUNC(op_5ed8_0), 24280 }, /* Scc */
{ CPUFUNC(op_5ee0_0), 24288 }, /* Scc */
{ CPUFUNC(op_5ee8_0), 24296 }, /* Scc */
{ CPUFUNC(op_5ef0_0), 24304 }, /* Scc */
{ CPUFUNC(op_5ef8_0), 24312 }, /* Scc */
{ CPUFUNC(op_5ef9_0), 24313 }, /* Scc */
{ CPUFUNC(op_5efa_0), 24314 }, /* TRAPcc */
{ CPUFUNC(op_5efb_0), 24315 }, /* TRAPcc */
{ CPUFUNC(op_5efc_0), 24316 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_0), 24512 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 24520 }, /* DBcc */
{ CPUFUNC(op_5fd0_0), 24528 }, /* Scc */
{ CPUFUNC(op_5fd8_0), 24536 }, /* Scc */
{ CPUFUNC(op_5fe0_0), 24544 }, /* Scc */
{ CPUFUNC(op_5fe8_0), 24552 }, /* Scc */
{ CPUFUNC(op_5ff0_0), 24560 }, /* Scc */
{ CPUFUNC(op_5ff8_0), 24568 }, /* Scc */
{ CPUFUNC(op_5ff9_0), 24569 }, /* Scc */
{ CPUFUNC(op_5ffa_0), 24570 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_0), 24571 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_0), 24572 }, /* TRAPcc */
{ CPUFUNC(op_6000_0), 24576 }, /* Bcc */
{ CPUFUNC(op_6001_0), 24577 }, /* Bcc */
{ CPUFUNC(op_60ff_0), 24831 }, /* Bcc */
{ CPUFUNC(op_6100_0), 24832 }, /* BSR */
{ CPUFUNC(op_6101_0), 24833 }, /* BSR */
{ CPUFUNC(op_61ff_0), 25087 }, /* BSR */
{ CPUFUNC(op_6200_0), 25088 }, /* Bcc */
{ CPUFUNC(op_6201_0), 25089 }, /* Bcc */
{ CPUFUNC(op_62ff_0), 25343 }, /* Bcc */
{ CPUFUNC(op_6300_0), 25344 }, /* Bcc */
{ CPUFUNC(op_6301_0), 25345 }, /* Bcc */
{ CPUFUNC(op_63ff_0), 25599 }, /* Bcc */
{ CPUFUNC(op_6400_0), 25600 }, /* Bcc */
{ CPUFUNC(op_6401_0), 25601 }, /* Bcc */
{ CPUFUNC(op_64ff_0), 25855 }, /* Bcc */
{ CPUFUNC(op_6500_0), 25856 }, /* Bcc */
{ CPUFUNC(op_6501_0), 25857 }, /* Bcc */
{ CPUFUNC(op_65ff_0), 26111 }, /* Bcc */
{ CPUFUNC(op_6600_0), 26112 }, /* Bcc */
{ CPUFUNC(op_6601_0), 26113 }, /* Bcc */
{ CPUFUNC(op_66ff_0), 26367 }, /* Bcc */
{ CPUFUNC(op_6700_0), 26368 }, /* Bcc */
{ CPUFUNC(op_6701_0), 26369 }, /* Bcc */
{ CPUFUNC(op_67ff_0), 26623 }, /* Bcc */
{ CPUFUNC(op_6800_0), 26624 }, /* Bcc */
{ CPUFUNC(op_6801_0), 26625 }, /* Bcc */
{ CPUFUNC(op_68ff_0), 26879 }, /* Bcc */
{ CPUFUNC(op_6900_0), 26880 }, /* Bcc */
{ CPUFUNC(op_6901_0), 26881 }, /* Bcc */
{ CPUFUNC(op_69ff_0), 27135 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 27136 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 27137 }, /* Bcc */
{ CPUFUNC(op_6aff_0), 27391 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 27392 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 27393 }, /* Bcc */
{ CPUFUNC(op_6bff_0), 27647 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 27648 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 27649 }, /* Bcc */
{ CPUFUNC(op_6cff_0), 27903 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 27904 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 27905 }, /* Bcc */
{ CPUFUNC(op_6dff_0), 28159 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 28160 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 28161 }, /* Bcc */
{ CPUFUNC(op_6eff_0), 28415 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 28416 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 28417 }, /* Bcc */
{ CPUFUNC(op_6fff_0), 28671 }, /* Bcc */
{ CPUFUNC(op_7000_0), 28672 }, /* MOVE */
{ CPUFUNC(op_8000_0), 32768 }, /* OR */
{ CPUFUNC(op_8010_0), 32784 }, /* OR */
{ CPUFUNC(op_8018_0), 32792 }, /* OR */
{ CPUFUNC(op_8020_0), 32800 }, /* OR */
{ CPUFUNC(op_8028_0), 32808 }, /* OR */
{ CPUFUNC(op_8030_0), 32816 }, /* OR */
{ CPUFUNC(op_8038_0), 32824 }, /* OR */
{ CPUFUNC(op_8039_0), 32825 }, /* OR */
{ CPUFUNC(op_803a_0), 32826 }, /* OR */
{ CPUFUNC(op_803b_0), 32827 }, /* OR */
{ CPUFUNC(op_803c_0), 32828 }, /* OR */
{ CPUFUNC(op_8040_0), 32832 }, /* OR */
{ CPUFUNC(op_8050_0), 32848 }, /* OR */
{ CPUFUNC(op_8058_0), 32856 }, /* OR */
{ CPUFUNC(op_8060_0), 32864 }, /* OR */
{ CPUFUNC(op_8068_0), 32872 }, /* OR */
{ CPUFUNC(op_8070_0), 32880 }, /* OR */
{ CPUFUNC(op_8078_0), 32888 }, /* OR */
{ CPUFUNC(op_8079_0), 32889 }, /* OR */
{ CPUFUNC(op_807a_0), 32890 }, /* OR */
{ CPUFUNC(op_807b_0), 32891 }, /* OR */
{ CPUFUNC(op_807c_0), 32892 }, /* OR */
{ CPUFUNC(op_8080_0), 32896 }, /* OR */
{ CPUFUNC(op_8090_0), 32912 }, /* OR */
{ CPUFUNC(op_8098_0), 32920 }, /* OR */
{ CPUFUNC(op_80a0_0), 32928 }, /* OR */
{ CPUFUNC(op_80a8_0), 32936 }, /* OR */
{ CPUFUNC(op_80b0_0), 32944 }, /* OR */
{ CPUFUNC(op_80b8_0), 32952 }, /* OR */
{ CPUFUNC(op_80b9_0), 32953 }, /* OR */
{ CPUFUNC(op_80ba_0), 32954 }, /* OR */
{ CPUFUNC(op_80bb_0), 32955 }, /* OR */
{ CPUFUNC(op_80bc_0), 32956 }, /* OR */
{ CPUFUNC(op_80c0_0), 32960 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 32976 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 32984 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 32992 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 33000 }, /* DIVU */
{ CPUFUNC(op_80f0_0), 33008 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 33016 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 33017 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 33018 }, /* DIVU */
{ CPUFUNC(op_80fb_0), 33019 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 33020 }, /* DIVU */
{ CPUFUNC(op_8100_0), 33024 }, /* SBCD */
{ CPUFUNC(op_8108_0), 33032 }, /* SBCD */
{ CPUFUNC(op_8110_0), 33040 }, /* OR */
{ CPUFUNC(op_8118_0), 33048 }, /* OR */
{ CPUFUNC(op_8120_0), 33056 }, /* OR */
{ CPUFUNC(op_8128_0), 33064 }, /* OR */
{ CPUFUNC(op_8130_0), 33072 }, /* OR */
{ CPUFUNC(op_8138_0), 33080 }, /* OR */
{ CPUFUNC(op_8139_0), 33081 }, /* OR */
{ CPUFUNC(op_8140_0), 33088 }, /* PACK */
{ CPUFUNC(op_8148_0), 33096 }, /* PACK */
{ CPUFUNC(op_8150_0), 33104 }, /* OR */
{ CPUFUNC(op_8158_0), 33112 }, /* OR */
{ CPUFUNC(op_8160_0), 33120 }, /* OR */
{ CPUFUNC(op_8168_0), 33128 }, /* OR */
{ CPUFUNC(op_8170_0), 33136 }, /* OR */
{ CPUFUNC(op_8178_0), 33144 }, /* OR */
{ CPUFUNC(op_8179_0), 33145 }, /* OR */
{ CPUFUNC(op_8180_0), 33152 }, /* UNPK */
{ CPUFUNC(op_8188_0), 33160 }, /* UNPK */
{ CPUFUNC(op_8190_0), 33168 }, /* OR */
{ CPUFUNC(op_8198_0), 33176 }, /* OR */
{ CPUFUNC(op_81a0_0), 33184 }, /* OR */
{ CPUFUNC(op_81a8_0), 33192 }, /* OR */
{ CPUFUNC(op_81b0_0), 33200 }, /* OR */
{ CPUFUNC(op_81b8_0), 33208 }, /* OR */
{ CPUFUNC(op_81b9_0), 33209 }, /* OR */
{ CPUFUNC(op_81c0_0), 33216 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 33232 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 33240 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 33248 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 33256 }, /* DIVS */
{ CPUFUNC(op_81f0_0), 33264 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 33272 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 33273 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 33274 }, /* DIVS */
{ CPUFUNC(op_81fb_0), 33275 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 33276 }, /* DIVS */
{ CPUFUNC(op_9000_0), 36864 }, /* SUB */
{ CPUFUNC(op_9010_0), 36880 }, /* SUB */
{ CPUFUNC(op_9018_0), 36888 }, /* SUB */
{ CPUFUNC(op_9020_0), 36896 }, /* SUB */
{ CPUFUNC(op_9028_0), 36904 }, /* SUB */
{ CPUFUNC(op_9030_0), 36912 }, /* SUB */
{ CPUFUNC(op_9038_0), 36920 }, /* SUB */
{ CPUFUNC(op_9039_0), 36921 }, /* SUB */
{ CPUFUNC(op_903a_0), 36922 }, /* SUB */
{ CPUFUNC(op_903b_0), 36923 }, /* SUB */
{ CPUFUNC(op_903c_0), 36924 }, /* SUB */
{ CPUFUNC(op_9040_0), 36928 }, /* SUB */
{ CPUFUNC(op_9048_0), 36936 }, /* SUB */
{ CPUFUNC(op_9050_0), 36944 }, /* SUB */
{ CPUFUNC(op_9058_0), 36952 }, /* SUB */
{ CPUFUNC(op_9060_0), 36960 }, /* SUB */
{ CPUFUNC(op_9068_0), 36968 }, /* SUB */
{ CPUFUNC(op_9070_0), 36976 }, /* SUB */
{ CPUFUNC(op_9078_0), 36984 }, /* SUB */
{ CPUFUNC(op_9079_0), 36985 }, /* SUB */
{ CPUFUNC(op_907a_0), 36986 }, /* SUB */
{ CPUFUNC(op_907b_0), 36987 }, /* SUB */
{ CPUFUNC(op_907c_0), 36988 }, /* SUB */
{ CPUFUNC(op_9080_0), 36992 }, /* SUB */
{ CPUFUNC(op_9088_0), 37000 }, /* SUB */
{ CPUFUNC(op_9090_0), 37008 }, /* SUB */
{ CPUFUNC(op_9098_0), 37016 }, /* SUB */
{ CPUFUNC(op_90a0_0), 37024 }, /* SUB */
{ CPUFUNC(op_90a8_0), 37032 }, /* SUB */
{ CPUFUNC(op_90b0_0), 37040 }, /* SUB */
{ CPUFUNC(op_90b8_0), 37048 }, /* SUB */
{ CPUFUNC(op_90b9_0), 37049 }, /* SUB */
{ CPUFUNC(op_90ba_0), 37050 }, /* SUB */
{ CPUFUNC(op_90bb_0), 37051 }, /* SUB */
{ CPUFUNC(op_90bc_0), 37052 }, /* SUB */
{ CPUFUNC(op_90c0_0), 37056 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 37064 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 37072 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 37080 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 37088 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 37096 }, /* SUBA */
{ CPUFUNC(op_90f0_0), 37104 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 37112 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 37113 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 37114 }, /* SUBA */
{ CPUFUNC(op_90fb_0), 37115 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 37116 }, /* SUBA */
{ CPUFUNC(op_9100_0), 37120 }, /* SUBX */
{ CPUFUNC(op_9108_0), 37128 }, /* SUBX */
{ CPUFUNC(op_9110_0), 37136 }, /* SUB */
{ CPUFUNC(op_9118_0), 37144 }, /* SUB */
{ CPUFUNC(op_9120_0), 37152 }, /* SUB */
{ CPUFUNC(op_9128_0), 37160 }, /* SUB */
{ CPUFUNC(op_9130_0), 37168 }, /* SUB */
{ CPUFUNC(op_9138_0), 37176 }, /* SUB */
{ CPUFUNC(op_9139_0), 37177 }, /* SUB */
{ CPUFUNC(op_9140_0), 37184 }, /* SUBX */
{ CPUFUNC(op_9148_0), 37192 }, /* SUBX */
{ CPUFUNC(op_9150_0), 37200 }, /* SUB */
{ CPUFUNC(op_9158_0), 37208 }, /* SUB */
{ CPUFUNC(op_9160_0), 37216 }, /* SUB */
{ CPUFUNC(op_9168_0), 37224 }, /* SUB */
{ CPUFUNC(op_9170_0), 37232 }, /* SUB */
{ CPUFUNC(op_9178_0), 37240 }, /* SUB */
{ CPUFUNC(op_9179_0), 37241 }, /* SUB */
{ CPUFUNC(op_9180_0), 37248 }, /* SUBX */
{ CPUFUNC(op_9188_0), 37256 }, /* SUBX */
{ CPUFUNC(op_9190_0), 37264 }, /* SUB */
{ CPUFUNC(op_9198_0), 37272 }, /* SUB */
{ CPUFUNC(op_91a0_0), 37280 }, /* SUB */
{ CPUFUNC(op_91a8_0), 37288 }, /* SUB */
{ CPUFUNC(op_91b0_0), 37296 }, /* SUB */
{ CPUFUNC(op_91b8_0), 37304 }, /* SUB */
{ CPUFUNC(op_91b9_0), 37305 }, /* SUB */
{ CPUFUNC(op_91c0_0), 37312 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 37320 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 37328 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 37336 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 37344 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 37352 }, /* SUBA */
{ CPUFUNC(op_91f0_0), 37360 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 37368 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 37369 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 37370 }, /* SUBA */
{ CPUFUNC(op_91fb_0), 37371 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 37372 }, /* SUBA */
{ CPUFUNC(op_b000_0), 45056 }, /* CMP */
{ CPUFUNC(op_b010_0), 45072 }, /* CMP */
{ CPUFUNC(op_b018_0), 45080 }, /* CMP */
{ CPUFUNC(op_b020_0), 45088 }, /* CMP */
{ CPUFUNC(op_b028_0), 45096 }, /* CMP */
{ CPUFUNC(op_b030_0), 45104 }, /* CMP */
{ CPUFUNC(op_b038_0), 45112 }, /* CMP */
{ CPUFUNC(op_b039_0), 45113 }, /* CMP */
{ CPUFUNC(op_b03a_0), 45114 }, /* CMP */
{ CPUFUNC(op_b03b_0), 45115 }, /* CMP */
{ CPUFUNC(op_b03c_0), 45116 }, /* CMP */
{ CPUFUNC(op_b040_0), 45120 }, /* CMP */
{ CPUFUNC(op_b048_0), 45128 }, /* CMP */
{ CPUFUNC(op_b050_0), 45136 }, /* CMP */
{ CPUFUNC(op_b058_0), 45144 }, /* CMP */
{ CPUFUNC(op_b060_0), 45152 }, /* CMP */
{ CPUFUNC(op_b068_0), 45160 }, /* CMP */
{ CPUFUNC(op_b070_0), 45168 }, /* CMP */
{ CPUFUNC(op_b078_0), 45176 }, /* CMP */
{ CPUFUNC(op_b079_0), 45177 }, /* CMP */
{ CPUFUNC(op_b07a_0), 45178 }, /* CMP */
{ CPUFUNC(op_b07b_0), 45179 }, /* CMP */
{ CPUFUNC(op_b07c_0), 45180 }, /* CMP */
{ CPUFUNC(op_b080_0), 45184 }, /* CMP */
{ CPUFUNC(op_b088_0), 45192 }, /* CMP */
{ CPUFUNC(op_b090_0), 45200 }, /* CMP */
{ CPUFUNC(op_b098_0), 45208 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 45216 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 45224 }, /* CMP */
{ CPUFUNC(op_b0b0_0), 45232 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 45240 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 45241 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 45242 }, /* CMP */
{ CPUFUNC(op_b0bb_0), 45243 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 45244 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 45248 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 45256 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 45264 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 45272 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 45280 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 45288 }, /* CMPA */
{ CPUFUNC(op_b0f0_0), 45296 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 45304 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 45305 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 45306 }, /* CMPA */
{ CPUFUNC(op_b0fb_0), 45307 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 45308 }, /* CMPA */
{ CPUFUNC(op_b100_0), 45312 }, /* EOR */
{ CPUFUNC(op_b108_0), 45320 }, /* CMPM */
{ CPUFUNC(op_b110_0), 45328 }, /* EOR */
{ CPUFUNC(op_b118_0), 45336 }, /* EOR */
{ CPUFUNC(op_b120_0), 45344 }, /* EOR */
{ CPUFUNC(op_b128_0), 45352 }, /* EOR */
{ CPUFUNC(op_b130_0), 45360 }, /* EOR */
{ CPUFUNC(op_b138_0), 45368 }, /* EOR */
{ CPUFUNC(op_b139_0), 45369 }, /* EOR */
{ CPUFUNC(op_b140_0), 45376 }, /* EOR */
{ CPUFUNC(op_b148_0), 45384 }, /* CMPM */
{ CPUFUNC(op_b150_0), 45392 }, /* EOR */
{ CPUFUNC(op_b158_0), 45400 }, /* EOR */
{ CPUFUNC(op_b160_0), 45408 }, /* EOR */
{ CPUFUNC(op_b168_0), 45416 }, /* EOR */
{ CPUFUNC(op_b170_0), 45424 }, /* EOR */
{ CPUFUNC(op_b178_0), 45432 }, /* EOR */
{ CPUFUNC(op_b179_0), 45433 }, /* EOR */
{ CPUFUNC(op_b180_0), 45440 }, /* EOR */
{ CPUFUNC(op_b188_0), 45448 }, /* CMPM */
{ CPUFUNC(op_b190_0), 45456 }, /* EOR */
{ CPUFUNC(op_b198_0), 45464 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 45472 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 45480 }, /* EOR */
{ CPUFUNC(op_b1b0_0), 45488 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 45496 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 45497 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 45504 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 45512 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 45520 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 45528 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 45536 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 45544 }, /* CMPA */
{ CPUFUNC(op_b1f0_0), 45552 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 45560 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 45561 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 45562 }, /* CMPA */
{ CPUFUNC(op_b1fb_0), 45563 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 45564 }, /* CMPA */
{ CPUFUNC(op_c000_0), 49152 }, /* AND */
{ CPUFUNC(op_c010_0), 49168 }, /* AND */
{ CPUFUNC(op_c018_0), 49176 }, /* AND */
{ CPUFUNC(op_c020_0), 49184 }, /* AND */
{ CPUFUNC(op_c028_0), 49192 }, /* AND */
{ CPUFUNC(op_c030_0), 49200 }, /* AND */
{ CPUFUNC(op_c038_0), 49208 }, /* AND */
{ CPUFUNC(op_c039_0), 49209 }, /* AND */
{ CPUFUNC(op_c03a_0), 49210 }, /* AND */
{ CPUFUNC(op_c03b_0), 49211 }, /* AND */
{ CPUFUNC(op_c03c_0), 49212 }, /* AND */
{ CPUFUNC(op_c040_0), 49216 }, /* AND */
{ CPUFUNC(op_c050_0), 49232 }, /* AND */
{ CPUFUNC(op_c058_0), 49240 }, /* AND */
{ CPUFUNC(op_c060_0), 49248 }, /* AND */
{ CPUFUNC(op_c068_0), 49256 }, /* AND */
{ CPUFUNC(op_c070_0), 49264 }, /* AND */
{ CPUFUNC(op_c078_0), 49272 }, /* AND */
{ CPUFUNC(op_c079_0), 49273 }, /* AND */
{ CPUFUNC(op_c07a_0), 49274 }, /* AND */
{ CPUFUNC(op_c07b_0), 49275 }, /* AND */
{ CPUFUNC(op_c07c_0), 49276 }, /* AND */
{ CPUFUNC(op_c080_0), 49280 }, /* AND */
{ CPUFUNC(op_c090_0), 49296 }, /* AND */
{ CPUFUNC(op_c098_0), 49304 }, /* AND */
{ CPUFUNC(op_c0a0_0), 49312 }, /* AND */
{ CPUFUNC(op_c0a8_0), 49320 }, /* AND */
{ CPUFUNC(op_c0b0_0), 49328 }, /* AND */
{ CPUFUNC(op_c0b8_0), 49336 }, /* AND */
{ CPUFUNC(op_c0b9_0), 49337 }, /* AND */
{ CPUFUNC(op_c0ba_0), 49338 }, /* AND */
{ CPUFUNC(op_c0bb_0), 49339 }, /* AND */
{ CPUFUNC(op_c0bc_0), 49340 }, /* AND */
{ CPUFUNC(op_c0c0_0), 49344 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 49360 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 49368 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 49376 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 49384 }, /* MULU */
{ CPUFUNC(op_c0f0_0), 49392 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 49400 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 49401 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 49402 }, /* MULU */
{ CPUFUNC(op_c0fb_0), 49403 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 49404 }, /* MULU */
{ CPUFUNC(op_c100_0), 49408 }, /* ABCD */
{ CPUFUNC(op_c108_0), 49416 }, /* ABCD */
{ CPUFUNC(op_c110_0), 49424 }, /* AND */
{ CPUFUNC(op_c118_0), 49432 }, /* AND */
{ CPUFUNC(op_c120_0), 49440 }, /* AND */
{ CPUFUNC(op_c128_0), 49448 }, /* AND */
{ CPUFUNC(op_c130_0), 49456 }, /* AND */
{ CPUFUNC(op_c138_0), 49464 }, /* AND */
{ CPUFUNC(op_c139_0), 49465 }, /* AND */
{ CPUFUNC(op_c140_0), 49472 }, /* EXG */
{ CPUFUNC(op_c148_0), 49480 }, /* EXG */
{ CPUFUNC(op_c150_0), 49488 }, /* AND */
{ CPUFUNC(op_c158_0), 49496 }, /* AND */
{ CPUFUNC(op_c160_0), 49504 }, /* AND */
{ CPUFUNC(op_c168_0), 49512 }, /* AND */
{ CPUFUNC(op_c170_0), 49520 }, /* AND */
{ CPUFUNC(op_c178_0), 49528 }, /* AND */
{ CPUFUNC(op_c179_0), 49529 }, /* AND */
{ CPUFUNC(op_c188_0), 49544 }, /* EXG */
{ CPUFUNC(op_c190_0), 49552 }, /* AND */
{ CPUFUNC(op_c198_0), 49560 }, /* AND */
{ CPUFUNC(op_c1a0_0), 49568 }, /* AND */
{ CPUFUNC(op_c1a8_0), 49576 }, /* AND */
{ CPUFUNC(op_c1b0_0), 49584 }, /* AND */
{ CPUFUNC(op_c1b8_0), 49592 }, /* AND */
{ CPUFUNC(op_c1b9_0), 49593 }, /* AND */
{ CPUFUNC(op_c1c0_0), 49600 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 49616 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 49624 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 49632 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 49640 }, /* MULS */
{ CPUFUNC(op_c1f0_0), 49648 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 49656 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 49657 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 49658 }, /* MULS */
{ CPUFUNC(op_c1fb_0), 49659 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 49660 }, /* MULS */
{ CPUFUNC(op_d000_0), 53248 }, /* ADD */
{ CPUFUNC(op_d010_0), 53264 }, /* ADD */
{ CPUFUNC(op_d018_0), 53272 }, /* ADD */
{ CPUFUNC(op_d020_0), 53280 }, /* ADD */
{ CPUFUNC(op_d028_0), 53288 }, /* ADD */
{ CPUFUNC(op_d030_0), 53296 }, /* ADD */
{ CPUFUNC(op_d038_0), 53304 }, /* ADD */
{ CPUFUNC(op_d039_0), 53305 }, /* ADD */
{ CPUFUNC(op_d03a_0), 53306 }, /* ADD */
{ CPUFUNC(op_d03b_0), 53307 }, /* ADD */
{ CPUFUNC(op_d03c_0), 53308 }, /* ADD */
{ CPUFUNC(op_d040_0), 53312 }, /* ADD */
{ CPUFUNC(op_d048_0), 53320 }, /* ADD */
{ CPUFUNC(op_d050_0), 53328 }, /* ADD */
{ CPUFUNC(op_d058_0), 53336 }, /* ADD */
{ CPUFUNC(op_d060_0), 53344 }, /* ADD */
{ CPUFUNC(op_d068_0), 53352 }, /* ADD */
{ CPUFUNC(op_d070_0), 53360 }, /* ADD */
{ CPUFUNC(op_d078_0), 53368 }, /* ADD */
{ CPUFUNC(op_d079_0), 53369 }, /* ADD */
{ CPUFUNC(op_d07a_0), 53370 }, /* ADD */
{ CPUFUNC(op_d07b_0), 53371 }, /* ADD */
{ CPUFUNC(op_d07c_0), 53372 }, /* ADD */
{ CPUFUNC(op_d080_0), 53376 }, /* ADD */
{ CPUFUNC(op_d088_0), 53384 }, /* ADD */
{ CPUFUNC(op_d090_0), 53392 }, /* ADD */
{ CPUFUNC(op_d098_0), 53400 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 53408 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 53416 }, /* ADD */
{ CPUFUNC(op_d0b0_0), 53424 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 53432 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 53433 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 53434 }, /* ADD */
{ CPUFUNC(op_d0bb_0), 53435 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 53436 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 53440 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 53448 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 53456 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 53464 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 53472 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 53480 }, /* ADDA */
{ CPUFUNC(op_d0f0_0), 53488 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 53496 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 53497 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 53498 }, /* ADDA */
{ CPUFUNC(op_d0fb_0), 53499 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 53500 }, /* ADDA */
{ CPUFUNC(op_d100_0), 53504 }, /* ADDX */
{ CPUFUNC(op_d108_0), 53512 }, /* ADDX */
{ CPUFUNC(op_d110_0), 53520 }, /* ADD */
{ CPUFUNC(op_d118_0), 53528 }, /* ADD */
{ CPUFUNC(op_d120_0), 53536 }, /* ADD */
{ CPUFUNC(op_d128_0), 53544 }, /* ADD */
{ CPUFUNC(op_d130_0), 53552 }, /* ADD */
{ CPUFUNC(op_d138_0), 53560 }, /* ADD */
{ CPUFUNC(op_d139_0), 53561 }, /* ADD */
{ CPUFUNC(op_d140_0), 53568 }, /* ADDX */
{ CPUFUNC(op_d148_0), 53576 }, /* ADDX */
{ CPUFUNC(op_d150_0), 53584 }, /* ADD */
{ CPUFUNC(op_d158_0), 53592 }, /* ADD */
{ CPUFUNC(op_d160_0), 53600 }, /* ADD */
{ CPUFUNC(op_d168_0), 53608 }, /* ADD */
{ CPUFUNC(op_d170_0), 53616 }, /* ADD */
{ CPUFUNC(op_d178_0), 53624 }, /* ADD */
{ CPUFUNC(op_d179_0), 53625 }, /* ADD */
{ CPUFUNC(op_d180_0), 53632 }, /* ADDX */
{ CPUFUNC(op_d188_0), 53640 }, /* ADDX */
{ CPUFUNC(op_d190_0), 53648 }, /* ADD */
{ CPUFUNC(op_d198_0), 53656 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 53664 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 53672 }, /* ADD */
{ CPUFUNC(op_d1b0_0), 53680 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 53688 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 53689 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 53696 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 53704 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 53712 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 53720 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 53728 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 53736 }, /* ADDA */
{ CPUFUNC(op_d1f0_0), 53744 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 53752 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 53753 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 53754 }, /* ADDA */
{ CPUFUNC(op_d1fb_0), 53755 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 53756 }, /* ADDA */
{ CPUFUNC(op_e000_0), 57344 }, /* ASR */
{ CPUFUNC(op_e008_0), 57352 }, /* LSR */
{ CPUFUNC(op_e010_0), 57360 }, /* ROXR */
{ CPUFUNC(op_e018_0), 57368 }, /* ROR */
{ CPUFUNC(op_e020_0), 57376 }, /* ASR */
{ CPUFUNC(op_e028_0), 57384 }, /* LSR */
{ CPUFUNC(op_e030_0), 57392 }, /* ROXR */
{ CPUFUNC(op_e038_0), 57400 }, /* ROR */
{ CPUFUNC(op_e040_0), 57408 }, /* ASR */
{ CPUFUNC(op_e048_0), 57416 }, /* LSR */
{ CPUFUNC(op_e050_0), 57424 }, /* ROXR */
{ CPUFUNC(op_e058_0), 57432 }, /* ROR */
{ CPUFUNC(op_e060_0), 57440 }, /* ASR */
{ CPUFUNC(op_e068_0), 57448 }, /* LSR */
{ CPUFUNC(op_e070_0), 57456 }, /* ROXR */
{ CPUFUNC(op_e078_0), 57464 }, /* ROR */
{ CPUFUNC(op_e080_0), 57472 }, /* ASR */
{ CPUFUNC(op_e088_0), 57480 }, /* LSR */
{ CPUFUNC(op_e090_0), 57488 }, /* ROXR */
{ CPUFUNC(op_e098_0), 57496 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 57504 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 57512 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 57520 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 57528 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 57552 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 57560 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 57568 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 57576 }, /* ASRW */
{ CPUFUNC(op_e0f0_0), 57584 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 57592 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 57593 }, /* ASRW */
{ CPUFUNC(op_e100_0), 57600 }, /* ASL */
{ CPUFUNC(op_e108_0), 57608 }, /* LSL */
{ CPUFUNC(op_e110_0), 57616 }, /* ROXL */
{ CPUFUNC(op_e118_0), 57624 }, /* ROL */
{ CPUFUNC(op_e120_0), 57632 }, /* ASL */
{ CPUFUNC(op_e128_0), 57640 }, /* LSL */
{ CPUFUNC(op_e130_0), 57648 }, /* ROXL */
{ CPUFUNC(op_e138_0), 57656 }, /* ROL */
{ CPUFUNC(op_e140_0), 57664 }, /* ASL */
{ CPUFUNC(op_e148_0), 57672 }, /* LSL */
{ CPUFUNC(op_e150_0), 57680 }, /* ROXL */
{ CPUFUNC(op_e158_0), 57688 }, /* ROL */
{ CPUFUNC(op_e160_0), 57696 }, /* ASL */
{ CPUFUNC(op_e168_0), 57704 }, /* LSL */
{ CPUFUNC(op_e170_0), 57712 }, /* ROXL */
{ CPUFUNC(op_e178_0), 57720 }, /* ROL */
{ CPUFUNC(op_e180_0), 57728 }, /* ASL */
{ CPUFUNC(op_e188_0), 57736 }, /* LSL */
{ CPUFUNC(op_e190_0), 57744 }, /* ROXL */
{ CPUFUNC(op_e198_0), 57752 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 57760 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 57768 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 57776 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 57784 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 57808 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 57816 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 57824 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 57832 }, /* ASLW */
{ CPUFUNC(op_e1f0_0), 57840 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 57848 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 57849 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 58064 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 58072 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 58080 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 58088 }, /* LSRW */
{ CPUFUNC(op_e2f0_0), 58096 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 58104 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 58105 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 58320 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 58328 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 58336 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 58344 }, /* LSLW */
{ CPUFUNC(op_e3f0_0), 58352 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 58360 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 58361 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 58576 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 58584 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 58592 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 58600 }, /* ROXRW */
{ CPUFUNC(op_e4f0_0), 58608 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 58616 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 58617 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 58832 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 58840 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 58848 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 58856 }, /* ROXLW */
{ CPUFUNC(op_e5f0_0), 58864 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 58872 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 58873 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 59088 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 59096 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 59104 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 59112 }, /* RORW */
{ CPUFUNC(op_e6f0_0), 59120 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 59128 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 59129 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 59344 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 59352 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 59360 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 59368 }, /* ROLW */
{ CPUFUNC(op_e7f0_0), 59376 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 59384 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 59385 }, /* ROLW */
{ CPUFUNC(op_e8c0_0), 59584 }, /* BFTST */
{ CPUFUNC(op_e8d0_0), 59600 }, /* BFTST */
{ CPUFUNC(op_e8e8_0), 59624 }, /* BFTST */
{ CPUFUNC(op_e8f0_0), 59632 }, /* BFTST */
{ CPUFUNC(op_e8f8_0), 59640 }, /* BFTST */
{ CPUFUNC(op_e8f9_0), 59641 }, /* BFTST */
{ CPUFUNC(op_e8fa_0), 59642 }, /* BFTST */
{ CPUFUNC(op_e8fb_0), 59643 }, /* BFTST */
{ CPUFUNC(op_e9c0_0), 59840 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_0), 59856 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_0), 59880 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_0), 59888 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_0), 59896 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_0), 59897 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_0), 59898 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_0), 59899 }, /* BFEXTU */
{ CPUFUNC(op_eac0_0), 60096 }, /* BFCHG */
{ CPUFUNC(op_ead0_0), 60112 }, /* BFCHG */
{ CPUFUNC(op_eae8_0), 60136 }, /* BFCHG */
{ CPUFUNC(op_eaf0_0), 60144 }, /* BFCHG */
{ CPUFUNC(op_eaf8_0), 60152 }, /* BFCHG */
{ CPUFUNC(op_eaf9_0), 60153 }, /* BFCHG */
{ CPUFUNC(op_ebc0_0), 60352 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_0), 60368 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_0), 60392 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_0), 60400 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_0), 60408 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_0), 60409 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_0), 60410 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_0), 60411 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_0), 60608 }, /* BFCLR */
{ CPUFUNC(op_ecd0_0), 60624 }, /* BFCLR */
{ CPUFUNC(op_ece8_0), 60648 }, /* BFCLR */
{ CPUFUNC(op_ecf0_0), 60656 }, /* BFCLR */
{ CPUFUNC(op_ecf8_0), 60664 }, /* BFCLR */
{ CPUFUNC(op_ecf9_0), 60665 }, /* BFCLR */
{ CPUFUNC(op_edc0_0), 60864 }, /* BFFFO */
{ CPUFUNC(op_edd0_0), 60880 }, /* BFFFO */
{ CPUFUNC(op_ede8_0), 60904 }, /* BFFFO */
{ CPUFUNC(op_edf0_0), 60912 }, /* BFFFO */
{ CPUFUNC(op_edf8_0), 60920 }, /* BFFFO */
{ CPUFUNC(op_edf9_0), 60921 }, /* BFFFO */
{ CPUFUNC(op_edfa_0), 60922 }, /* BFFFO */
{ CPUFUNC(op_edfb_0), 60923 }, /* BFFFO */
{ CPUFUNC(op_eec0_0), 61120 }, /* BFSET */
{ CPUFUNC(op_eed0_0), 61136 }, /* BFSET */
{ CPUFUNC(op_eee8_0), 61160 }, /* BFSET */
{ CPUFUNC(op_eef0_0), 61168 }, /* BFSET */
{ CPUFUNC(op_eef8_0), 61176 }, /* BFSET */
{ CPUFUNC(op_eef9_0), 61177 }, /* BFSET */
{ CPUFUNC(op_efc0_0), 61376 }, /* BFINS */
{ CPUFUNC(op_efd0_0), 61392 }, /* BFINS */
{ CPUFUNC(op_efe8_0), 61416 }, /* BFINS */
{ CPUFUNC(op_eff0_0), 61424 }, /* BFINS */
{ CPUFUNC(op_eff8_0), 61432 }, /* BFINS */
{ CPUFUNC(op_eff9_0), 61433 }, /* BFINS */
{ CPUFUNC(op_f010_0), 61456 }, /* MMUOP030 */
{ CPUFUNC(op_f028_0), 61480 }, /* MMUOP030 */
{ CPUFUNC(op_f030_0), 61488 }, /* MMUOP030 */
{ CPUFUNC(op_f038_0), 61496 }, /* MMUOP030 */
{ CPUFUNC(op_f039_0), 61497 }, /* MMUOP030 */
{ CPUFUNC(op_f200_0), 61952 }, /* FPP */
{ CPUFUNC(op_f208_0), 61960 }, /* FPP */
{ CPUFUNC(op_f210_0), 61968 }, /* FPP */
{ CPUFUNC(op_f218_0), 61976 }, /* FPP */
{ CPUFUNC(op_f220_0), 61984 }, /* FPP */
{ CPUFUNC(op_f228_0), 61992 }, /* FPP */
{ CPUFUNC(op_f230_0), 62000 }, /* FPP */
{ CPUFUNC(op_f238_0), 62008 }, /* FPP */
{ CPUFUNC(op_f239_0), 62009 }, /* FPP */
{ CPUFUNC(op_f23a_0), 62010 }, /* FPP */
{ CPUFUNC(op_f23b_0), 62011 }, /* FPP */
{ CPUFUNC(op_f23c_0), 62012 }, /* FPP */
{ CPUFUNC(op_f240_0), 62016 }, /* FScc */
{ CPUFUNC(op_f248_0), 62024 }, /* FDBcc */
{ CPUFUNC(op_f250_0), 62032 }, /* FScc */
{ CPUFUNC(op_f258_0), 62040 }, /* FScc */
{ CPUFUNC(op_f260_0), 62048 }, /* FScc */
{ CPUFUNC(op_f268_0), 62056 }, /* FScc */
{ CPUFUNC(op_f270_0), 62064 }, /* FScc */
{ CPUFUNC(op_f278_0), 62072 }, /* FScc */
{ CPUFUNC(op_f279_0), 62073 }, /* FScc */
{ CPUFUNC(op_f27a_0), 62074 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_0), 62075 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_0), 62076 }, /* FTRAPcc */
{ CPUFUNC(op_f280_0), 62080 }, /* FBcc */
{ CPUFUNC(op_f2c0_0), 62144 }, /* FBcc */
{ CPUFUNC(op_f310_0), 62224 }, /* FSAVE */
{ CPUFUNC(op_f320_0), 62240 }, /* FSAVE */
{ CPUFUNC(op_f328_0), 62248 }, /* FSAVE */
{ CPUFUNC(op_f330_0), 62256 }, /* FSAVE */
{ CPUFUNC(op_f338_0), 62264 }, /* FSAVE */
{ CPUFUNC(op_f339_0), 62265 }, /* FSAVE */
{ CPUFUNC(op_f350_0), 62288 }, /* FRESTORE */
{ CPUFUNC(op_f358_0), 62296 }, /* FRESTORE */
{ CPUFUNC(op_f368_0), 62312 }, /* FRESTORE */
{ CPUFUNC(op_f370_0), 62320 }, /* FRESTORE */
{ CPUFUNC(op_f378_0), 62328 }, /* FRESTORE */
{ CPUFUNC(op_f379_0), 62329 }, /* FRESTORE */
{ CPUFUNC(op_f37a_0), 62330 }, /* FRESTORE */
{ CPUFUNC(op_f37b_0), 62331 }, /* FRESTORE */
{ CPUFUNC(op_f408_0), 62472 }, /* CINVL */
{ CPUFUNC(op_f410_0), 62480 }, /* CINVP */
{ CPUFUNC(op_f418_0), 62488 }, /* CINVA */
{ CPUFUNC(op_f419_0), 62489 }, /* CINVA */
{ CPUFUNC(op_f41a_0), 62490 }, /* CINVA */
{ CPUFUNC(op_f41b_0), 62491 }, /* CINVA */
{ CPUFUNC(op_f41c_0), 62492 }, /* CINVA */
{ CPUFUNC(op_f41d_0), 62493 }, /* CINVA */
{ CPUFUNC(op_f41e_0), 62494 }, /* CINVA */
{ CPUFUNC(op_f41f_0), 62495 }, /* CINVA */
{ CPUFUNC(op_f428_0), 62504 }, /* CPUSHL */
{ CPUFUNC(op_f430_0), 62512 }, /* CPUSHP */
{ CPUFUNC(op_f438_0), 62520 }, /* CPUSHA */
{ CPUFUNC(op_f439_0), 62521 }, /* CPUSHA */
{ CPUFUNC(op_f43a_0), 62522 }, /* CPUSHA */
{ CPUFUNC(op_f43b_0), 62523 }, /* CPUSHA */
{ CPUFUNC(op_f43c_0), 62524 }, /* CPUSHA */
{ CPUFUNC(op_f43d_0), 62525 }, /* CPUSHA */
{ CPUFUNC(op_f43e_0), 62526 }, /* CPUSHA */
{ CPUFUNC(op_f43f_0), 62527 }, /* CPUSHA */
{ CPUFUNC(op_f500_0), 62720 }, /* PFLUSHN */
{ CPUFUNC(op_f508_0), 62728 }, /* PFLUSH */
{ CPUFUNC(op_f510_0), 62736 }, /* PFLUSHAN */
{ CPUFUNC(op_f518_0), 62744 }, /* PFLUSHA */
{ CPUFUNC(op_f548_0), 62792 }, /* PTESTR */
{ CPUFUNC(op_f568_0), 62824 }, /* PTESTW */
{ CPUFUNC(op_f600_0), 62976 }, /* MOVE16 */
{ CPUFUNC(op_f608_0), 62984 }, /* MOVE16 */
{ CPUFUNC(op_f610_0), 62992 }, /* MOVE16 */
{ CPUFUNC(op_f618_0), 63000 }, /* MOVE16 */
{ CPUFUNC(op_f620_0), 63008 }, /* MOVE16 */
{ 0, 0 }};
const struct cputbl CPUFUNC(op_smalltbl_2)[] = {
{ CPUFUNC(op_0000_0), 0 }, /* OR */
{ CPUFUNC(op_0010_0), 16 }, /* OR */
{ CPUFUNC(op_0018_0), 24 }, /* OR */
{ CPUFUNC(op_0020_0), 32 }, /* OR */
{ CPUFUNC(op_0028_0), 40 }, /* OR */
{ CPUFUNC(op_0030_0), 48 }, /* OR */
{ CPUFUNC(op_0038_0), 56 }, /* OR */
{ CPUFUNC(op_0039_0), 57 }, /* OR */
{ CPUFUNC(op_003c_0), 60 }, /* ORSR */
{ CPUFUNC(op_0040_0), 64 }, /* OR */
{ CPUFUNC(op_0050_0), 80 }, /* OR */
{ CPUFUNC(op_0058_0), 88 }, /* OR */
{ CPUFUNC(op_0060_0), 96 }, /* OR */
{ CPUFUNC(op_0068_0), 104 }, /* OR */
{ CPUFUNC(op_0070_0), 112 }, /* OR */
{ CPUFUNC(op_0078_0), 120 }, /* OR */
{ CPUFUNC(op_0079_0), 121 }, /* OR */
{ CPUFUNC(op_007c_0), 124 }, /* ORSR */
{ CPUFUNC(op_0080_0), 128 }, /* OR */
{ CPUFUNC(op_0090_0), 144 }, /* OR */
{ CPUFUNC(op_0098_0), 152 }, /* OR */
{ CPUFUNC(op_00a0_0), 160 }, /* OR */
{ CPUFUNC(op_00a8_0), 168 }, /* OR */
{ CPUFUNC(op_00b0_0), 176 }, /* OR */
{ CPUFUNC(op_00b8_0), 184 }, /* OR */
{ CPUFUNC(op_00b9_0), 185 }, /* OR */
{ CPUFUNC(op_00d0_0), 208 }, /* CHK2 */
{ CPUFUNC(op_00e8_0), 232 }, /* CHK2 */
{ CPUFUNC(op_00f0_0), 240 }, /* CHK2 */
{ CPUFUNC(op_00f8_0), 248 }, /* CHK2 */
{ CPUFUNC(op_00f9_0), 249 }, /* CHK2 */
{ CPUFUNC(op_00fa_0), 250 }, /* CHK2 */
{ CPUFUNC(op_00fb_0), 251 }, /* CHK2 */
{ CPUFUNC(op_0100_0), 256 }, /* BTST */
{ CPUFUNC(op_0108_0), 264 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 272 }, /* BTST */
{ CPUFUNC(op_0118_0), 280 }, /* BTST */
{ CPUFUNC(op_0120_0), 288 }, /* BTST */
{ CPUFUNC(op_0128_0), 296 }, /* BTST */
{ CPUFUNC(op_0130_0), 304 }, /* BTST */
{ CPUFUNC(op_0138_0), 312 }, /* BTST */
{ CPUFUNC(op_0139_0), 313 }, /* BTST */
{ CPUFUNC(op_013a_0), 314 }, /* BTST */
{ CPUFUNC(op_013b_0), 315 }, /* BTST */
{ CPUFUNC(op_013c_0), 316 }, /* BTST */
{ CPUFUNC(op_0140_0), 320 }, /* BCHG */
{ CPUFUNC(op_0148_0), 328 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 336 }, /* BCHG */
{ CPUFUNC(op_0158_0), 344 }, /* BCHG */
{ CPUFUNC(op_0160_0), 352 }, /* BCHG */
{ CPUFUNC(op_0168_0), 360 }, /* BCHG */
{ CPUFUNC(op_0170_0), 368 }, /* BCHG */
{ CPUFUNC(op_0178_0), 376 }, /* BCHG */
{ CPUFUNC(op_0179_0), 377 }, /* BCHG */
{ CPUFUNC(op_0180_0), 384 }, /* BCLR */
{ CPUFUNC(op_0188_0), 392 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 400 }, /* BCLR */
{ CPUFUNC(op_0198_0), 408 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 416 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 424 }, /* BCLR */
{ CPUFUNC(op_01b0_0), 432 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 440 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 441 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 448 }, /* BSET */
{ CPUFUNC(op_01c8_0), 456 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 464 }, /* BSET */
{ CPUFUNC(op_01d8_0), 472 }, /* BSET */
{ CPUFUNC(op_01e0_0), 480 }, /* BSET */
{ CPUFUNC(op_01e8_0), 488 }, /* BSET */
{ CPUFUNC(op_01f0_0), 496 }, /* BSET */
{ CPUFUNC(op_01f8_0), 504 }, /* BSET */
{ CPUFUNC(op_01f9_0), 505 }, /* BSET */
{ CPUFUNC(op_0200_0), 512 }, /* AND */
{ CPUFUNC(op_0210_0), 528 }, /* AND */
{ CPUFUNC(op_0218_0), 536 }, /* AND */
{ CPUFUNC(op_0220_0), 544 }, /* AND */
{ CPUFUNC(op_0228_0), 552 }, /* AND */
{ CPUFUNC(op_0230_0), 560 }, /* AND */
{ CPUFUNC(op_0238_0), 568 }, /* AND */
{ CPUFUNC(op_0239_0), 569 }, /* AND */
{ CPUFUNC(op_023c_0), 572 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 576 }, /* AND */
{ CPUFUNC(op_0250_0), 592 }, /* AND */
{ CPUFUNC(op_0258_0), 600 }, /* AND */
{ CPUFUNC(op_0260_0), 608 }, /* AND */
{ CPUFUNC(op_0268_0), 616 }, /* AND */
{ CPUFUNC(op_0270_0), 624 }, /* AND */
{ CPUFUNC(op_0278_0), 632 }, /* AND */
{ CPUFUNC(op_0279_0), 633 }, /* AND */
{ CPUFUNC(op_027c_0), 636 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 640 }, /* AND */
{ CPUFUNC(op_0290_0), 656 }, /* AND */
{ CPUFUNC(op_0298_0), 664 }, /* AND */
{ CPUFUNC(op_02a0_0), 672 }, /* AND */
{ CPUFUNC(op_02a8_0), 680 }, /* AND */
{ CPUFUNC(op_02b0_0), 688 }, /* AND */
{ CPUFUNC(op_02b8_0), 696 }, /* AND */
{ CPUFUNC(op_02b9_0), 697 }, /* AND */
{ CPUFUNC(op_02d0_0), 720 }, /* CHK2 */
{ CPUFUNC(op_02e8_0), 744 }, /* CHK2 */
{ CPUFUNC(op_02f0_0), 752 }, /* CHK2 */
{ CPUFUNC(op_02f8_0), 760 }, /* CHK2 */
{ CPUFUNC(op_02f9_0), 761 }, /* CHK2 */
{ CPUFUNC(op_02fa_0), 762 }, /* CHK2 */
{ CPUFUNC(op_02fb_0), 763 }, /* CHK2 */
{ CPUFUNC(op_0400_0), 1024 }, /* SUB */
{ CPUFUNC(op_0410_0), 1040 }, /* SUB */
{ CPUFUNC(op_0418_0), 1048 }, /* SUB */
{ CPUFUNC(op_0420_0), 1056 }, /* SUB */
{ CPUFUNC(op_0428_0), 1064 }, /* SUB */
{ CPUFUNC(op_0430_0), 1072 }, /* SUB */
{ CPUFUNC(op_0438_0), 1080 }, /* SUB */
{ CPUFUNC(op_0439_0), 1081 }, /* SUB */
{ CPUFUNC(op_0440_0), 1088 }, /* SUB */
{ CPUFUNC(op_0450_0), 1104 }, /* SUB */
{ CPUFUNC(op_0458_0), 1112 }, /* SUB */
{ CPUFUNC(op_0460_0), 1120 }, /* SUB */
{ CPUFUNC(op_0468_0), 1128 }, /* SUB */
{ CPUFUNC(op_0470_0), 1136 }, /* SUB */
{ CPUFUNC(op_0478_0), 1144 }, /* SUB */
{ CPUFUNC(op_0479_0), 1145 }, /* SUB */
{ CPUFUNC(op_0480_0), 1152 }, /* SUB */
{ CPUFUNC(op_0490_0), 1168 }, /* SUB */
{ CPUFUNC(op_0498_0), 1176 }, /* SUB */
{ CPUFUNC(op_04a0_0), 1184 }, /* SUB */
{ CPUFUNC(op_04a8_0), 1192 }, /* SUB */
{ CPUFUNC(op_04b0_0), 1200 }, /* SUB */
{ CPUFUNC(op_04b8_0), 1208 }, /* SUB */
{ CPUFUNC(op_04b9_0), 1209 }, /* SUB */
{ CPUFUNC(op_04d0_0), 1232 }, /* CHK2 */
{ CPUFUNC(op_04e8_0), 1256 }, /* CHK2 */
{ CPUFUNC(op_04f0_0), 1264 }, /* CHK2 */
{ CPUFUNC(op_04f8_0), 1272 }, /* CHK2 */
{ CPUFUNC(op_04f9_0), 1273 }, /* CHK2 */
{ CPUFUNC(op_04fa_0), 1274 }, /* CHK2 */
{ CPUFUNC(op_04fb_0), 1275 }, /* CHK2 */
{ CPUFUNC(op_0600_0), 1536 }, /* ADD */
{ CPUFUNC(op_0610_0), 1552 }, /* ADD */
{ CPUFUNC(op_0618_0), 1560 }, /* ADD */
{ CPUFUNC(op_0620_0), 1568 }, /* ADD */
{ CPUFUNC(op_0628_0), 1576 }, /* ADD */
{ CPUFUNC(op_0630_0), 1584 }, /* ADD */
{ CPUFUNC(op_0638_0), 1592 }, /* ADD */
{ CPUFUNC(op_0639_0), 1593 }, /* ADD */
{ CPUFUNC(op_0640_0), 1600 }, /* ADD */
{ CPUFUNC(op_0650_0), 1616 }, /* ADD */
{ CPUFUNC(op_0658_0), 1624 }, /* ADD */
{ CPUFUNC(op_0660_0), 1632 }, /* ADD */
{ CPUFUNC(op_0668_0), 1640 }, /* ADD */
{ CPUFUNC(op_0670_0), 1648 }, /* ADD */
{ CPUFUNC(op_0678_0), 1656 }, /* ADD */
{ CPUFUNC(op_0679_0), 1657 }, /* ADD */
{ CPUFUNC(op_0680_0), 1664 }, /* ADD */
{ CPUFUNC(op_0690_0), 1680 }, /* ADD */
{ CPUFUNC(op_0698_0), 1688 }, /* ADD */
{ CPUFUNC(op_06a0_0), 1696 }, /* ADD */
{ CPUFUNC(op_06a8_0), 1704 }, /* ADD */
{ CPUFUNC(op_06b0_0), 1712 }, /* ADD */
{ CPUFUNC(op_06b8_0), 1720 }, /* ADD */
{ CPUFUNC(op_06b9_0), 1721 }, /* ADD */
{ CPUFUNC(op_06c0_0), 1728 }, /* RTM */
{ CPUFUNC(op_06c8_0), 1736 }, /* RTM */
{ CPUFUNC(op_06d0_0), 1744 }, /* CALLM */
{ CPUFUNC(op_06e8_0), 1768 }, /* CALLM */
{ CPUFUNC(op_06f0_0), 1776 }, /* CALLM */
{ CPUFUNC(op_06f8_0), 1784 }, /* CALLM */
{ CPUFUNC(op_06f9_0), 1785 }, /* CALLM */
{ CPUFUNC(op_06fa_0), 1786 }, /* CALLM */
{ CPUFUNC(op_06fb_0), 1787 }, /* CALLM */
{ CPUFUNC(op_0800_0), 2048 }, /* BTST */
{ CPUFUNC(op_0810_0), 2064 }, /* BTST */
{ CPUFUNC(op_0818_0), 2072 }, /* BTST */
{ CPUFUNC(op_0820_0), 2080 }, /* BTST */
{ CPUFUNC(op_0828_0), 2088 }, /* BTST */
{ CPUFUNC(op_0830_0), 2096 }, /* BTST */
{ CPUFUNC(op_0838_0), 2104 }, /* BTST */
{ CPUFUNC(op_0839_0), 2105 }, /* BTST */
{ CPUFUNC(op_083a_0), 2106 }, /* BTST */
{ CPUFUNC(op_083b_0), 2107 }, /* BTST */
{ CPUFUNC(op_083c_0), 2108 }, /* BTST */
{ CPUFUNC(op_0840_0), 2112 }, /* BCHG */
{ CPUFUNC(op_0850_0), 2128 }, /* BCHG */
{ CPUFUNC(op_0858_0), 2136 }, /* BCHG */
{ CPUFUNC(op_0860_0), 2144 }, /* BCHG */
{ CPUFUNC(op_0868_0), 2152 }, /* BCHG */
{ CPUFUNC(op_0870_0), 2160 }, /* BCHG */
{ CPUFUNC(op_0878_0), 2168 }, /* BCHG */
{ CPUFUNC(op_0879_0), 2169 }, /* BCHG */
{ CPUFUNC(op_0880_0), 2176 }, /* BCLR */
{ CPUFUNC(op_0890_0), 2192 }, /* BCLR */
{ CPUFUNC(op_0898_0), 2200 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 2208 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 2216 }, /* BCLR */
{ CPUFUNC(op_08b0_0), 2224 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 2232 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 2233 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 2240 }, /* BSET */
{ CPUFUNC(op_08d0_0), 2256 }, /* BSET */
{ CPUFUNC(op_08d8_0), 2264 }, /* BSET */
{ CPUFUNC(op_08e0_0), 2272 }, /* BSET */
{ CPUFUNC(op_08e8_0), 2280 }, /* BSET */
{ CPUFUNC(op_08f0_0), 2288 }, /* BSET */
{ CPUFUNC(op_08f8_0), 2296 }, /* BSET */
{ CPUFUNC(op_08f9_0), 2297 }, /* BSET */
{ CPUFUNC(op_0a00_0), 2560 }, /* EOR */
{ CPUFUNC(op_0a10_0), 2576 }, /* EOR */
{ CPUFUNC(op_0a18_0), 2584 }, /* EOR */
{ CPUFUNC(op_0a20_0), 2592 }, /* EOR */
{ CPUFUNC(op_0a28_0), 2600 }, /* EOR */
{ CPUFUNC(op_0a30_0), 2608 }, /* EOR */
{ CPUFUNC(op_0a38_0), 2616 }, /* EOR */
{ CPUFUNC(op_0a39_0), 2617 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 2620 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 2624 }, /* EOR */
{ CPUFUNC(op_0a50_0), 2640 }, /* EOR */
{ CPUFUNC(op_0a58_0), 2648 }, /* EOR */
{ CPUFUNC(op_0a60_0), 2656 }, /* EOR */
{ CPUFUNC(op_0a68_0), 2664 }, /* EOR */
{ CPUFUNC(op_0a70_0), 2672 }, /* EOR */
{ CPUFUNC(op_0a78_0), 2680 }, /* EOR */
{ CPUFUNC(op_0a79_0), 2681 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 2684 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 2688 }, /* EOR */
{ CPUFUNC(op_0a90_0), 2704 }, /* EOR */
{ CPUFUNC(op_0a98_0), 2712 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 2720 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 2728 }, /* EOR */
{ CPUFUNC(op_0ab0_0), 2736 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 2744 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 2745 }, /* EOR */
{ CPUFUNC(op_0ad0_0), 2768 }, /* CAS */
{ CPUFUNC(op_0ad8_0), 2776 }, /* CAS */
{ CPUFUNC(op_0ae0_0), 2784 }, /* CAS */
{ CPUFUNC(op_0ae8_0), 2792 }, /* CAS */
{ CPUFUNC(op_0af0_0), 2800 }, /* CAS */
{ CPUFUNC(op_0af8_0), 2808 }, /* CAS */
{ CPUFUNC(op_0af9_0), 2809 }, /* CAS */
{ CPUFUNC(op_0c00_0), 3072 }, /* CMP */
{ CPUFUNC(op_0c10_0), 3088 }, /* CMP */
{ CPUFUNC(op_0c18_0), 3096 }, /* CMP */
{ CPUFUNC(op_0c20_0), 3104 }, /* CMP */
{ CPUFUNC(op_0c28_0), 3112 }, /* CMP */
{ CPUFUNC(op_0c30_0), 3120 }, /* CMP */
{ CPUFUNC(op_0c38_0), 3128 }, /* CMP */
{ CPUFUNC(op_0c39_0), 3129 }, /* CMP */
{ CPUFUNC(op_0c3a_0), 3130 }, /* CMP */
{ CPUFUNC(op_0c3b_0), 3131 }, /* CMP */
{ CPUFUNC(op_0c40_0), 3136 }, /* CMP */
{ CPUFUNC(op_0c50_0), 3152 }, /* CMP */
{ CPUFUNC(op_0c58_0), 3160 }, /* CMP */
{ CPUFUNC(op_0c60_0), 3168 }, /* CMP */
{ CPUFUNC(op_0c68_0), 3176 }, /* CMP */
{ CPUFUNC(op_0c70_0), 3184 }, /* CMP */
{ CPUFUNC(op_0c78_0), 3192 }, /* CMP */
{ CPUFUNC(op_0c79_0), 3193 }, /* CMP */
{ CPUFUNC(op_0c7a_0), 3194 }, /* CMP */
{ CPUFUNC(op_0c7b_0), 3195 }, /* CMP */
{ CPUFUNC(op_0c80_0), 3200 }, /* CMP */
{ CPUFUNC(op_0c90_0), 3216 }, /* CMP */
{ CPUFUNC(op_0c98_0), 3224 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 3232 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 3240 }, /* CMP */
{ CPUFUNC(op_0cb0_0), 3248 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 3256 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 3257 }, /* CMP */
{ CPUFUNC(op_0cba_0), 3258 }, /* CMP */
{ CPUFUNC(op_0cbb_0), 3259 }, /* CMP */
{ CPUFUNC(op_0cd0_0), 3280 }, /* CAS */
{ CPUFUNC(op_0cd8_0), 3288 }, /* CAS */
{ CPUFUNC(op_0ce0_0), 3296 }, /* CAS */
{ CPUFUNC(op_0ce8_0), 3304 }, /* CAS */
{ CPUFUNC(op_0cf0_0), 3312 }, /* CAS */
{ CPUFUNC(op_0cf8_0), 3320 }, /* CAS */
{ CPUFUNC(op_0cf9_0), 3321 }, /* CAS */
{ CPUFUNC(op_0cfc_0), 3324 }, /* CAS2 */
{ CPUFUNC(op_0e10_0), 3600 }, /* MOVES */
{ CPUFUNC(op_0e18_0), 3608 }, /* MOVES */
{ CPUFUNC(op_0e20_0), 3616 }, /* MOVES */
{ CPUFUNC(op_0e28_0), 3624 }, /* MOVES */
{ CPUFUNC(op_0e30_0), 3632 }, /* MOVES */
{ CPUFUNC(op_0e38_0), 3640 }, /* MOVES */
{ CPUFUNC(op_0e39_0), 3641 }, /* MOVES */
{ CPUFUNC(op_0e50_0), 3664 }, /* MOVES */
{ CPUFUNC(op_0e58_0), 3672 }, /* MOVES */
{ CPUFUNC(op_0e60_0), 3680 }, /* MOVES */
{ CPUFUNC(op_0e68_0), 3688 }, /* MOVES */
{ CPUFUNC(op_0e70_0), 3696 }, /* MOVES */
{ CPUFUNC(op_0e78_0), 3704 }, /* MOVES */
{ CPUFUNC(op_0e79_0), 3705 }, /* MOVES */
{ CPUFUNC(op_0e90_0), 3728 }, /* MOVES */
{ CPUFUNC(op_0e98_0), 3736 }, /* MOVES */
{ CPUFUNC(op_0ea0_0), 3744 }, /* MOVES */
{ CPUFUNC(op_0ea8_0), 3752 }, /* MOVES */
{ CPUFUNC(op_0eb0_0), 3760 }, /* MOVES */
{ CPUFUNC(op_0eb8_0), 3768 }, /* MOVES */
{ CPUFUNC(op_0eb9_0), 3769 }, /* MOVES */
{ CPUFUNC(op_0ed0_0), 3792 }, /* CAS */
{ CPUFUNC(op_0ed8_0), 3800 }, /* CAS */
{ CPUFUNC(op_0ee0_0), 3808 }, /* CAS */
{ CPUFUNC(op_0ee8_0), 3816 }, /* CAS */
{ CPUFUNC(op_0ef0_0), 3824 }, /* CAS */
{ CPUFUNC(op_0ef8_0), 3832 }, /* CAS */
{ CPUFUNC(op_0ef9_0), 3833 }, /* CAS */
{ CPUFUNC(op_0efc_0), 3836 }, /* CAS2 */
{ CPUFUNC(op_1000_0), 4096 }, /* MOVE */
{ CPUFUNC(op_1010_0), 4112 }, /* MOVE */
{ CPUFUNC(op_1018_0), 4120 }, /* MOVE */
{ CPUFUNC(op_1020_0), 4128 }, /* MOVE */
{ CPUFUNC(op_1028_0), 4136 }, /* MOVE */
{ CPUFUNC(op_1030_0), 4144 }, /* MOVE */
{ CPUFUNC(op_1038_0), 4152 }, /* MOVE */
{ CPUFUNC(op_1039_0), 4153 }, /* MOVE */
{ CPUFUNC(op_103a_0), 4154 }, /* MOVE */
{ CPUFUNC(op_103b_0), 4155 }, /* MOVE */
{ CPUFUNC(op_103c_0), 4156 }, /* MOVE */
{ CPUFUNC(op_1080_0), 4224 }, /* MOVE */
{ CPUFUNC(op_1090_0), 4240 }, /* MOVE */
{ CPUFUNC(op_1098_0), 4248 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 4256 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 4264 }, /* MOVE */
{ CPUFUNC(op_10b0_0), 4272 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 4280 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 4281 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 4282 }, /* MOVE */
{ CPUFUNC(op_10bb_0), 4283 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 4284 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 4288 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 4304 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 4312 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 4320 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 4328 }, /* MOVE */
{ CPUFUNC(op_10f0_0), 4336 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 4344 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 4345 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 4346 }, /* MOVE */
{ CPUFUNC(op_10fb_0), 4347 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 4348 }, /* MOVE */
{ CPUFUNC(op_1100_0), 4352 }, /* MOVE */
{ CPUFUNC(op_1110_0), 4368 }, /* MOVE */
{ CPUFUNC(op_1118_0), 4376 }, /* MOVE */
{ CPUFUNC(op_1120_0), 4384 }, /* MOVE */
{ CPUFUNC(op_1128_0), 4392 }, /* MOVE */
{ CPUFUNC(op_1130_0), 4400 }, /* MOVE */
{ CPUFUNC(op_1138_0), 4408 }, /* MOVE */
{ CPUFUNC(op_1139_0), 4409 }, /* MOVE */
{ CPUFUNC(op_113a_0), 4410 }, /* MOVE */
{ CPUFUNC(op_113b_0), 4411 }, /* MOVE */
{ CPUFUNC(op_113c_0), 4412 }, /* MOVE */
{ CPUFUNC(op_1140_0), 4416 }, /* MOVE */
{ CPUFUNC(op_1150_0), 4432 }, /* MOVE */
{ CPUFUNC(op_1158_0), 4440 }, /* MOVE */
{ CPUFUNC(op_1160_0), 4448 }, /* MOVE */
{ CPUFUNC(op_1168_0), 4456 }, /* MOVE */
{ CPUFUNC(op_1170_0), 4464 }, /* MOVE */
{ CPUFUNC(op_1178_0), 4472 }, /* MOVE */
{ CPUFUNC(op_1179_0), 4473 }, /* MOVE */
{ CPUFUNC(op_117a_0), 4474 }, /* MOVE */
{ CPUFUNC(op_117b_0), 4475 }, /* MOVE */
{ CPUFUNC(op_117c_0), 4476 }, /* MOVE */
{ CPUFUNC(op_1180_0), 4480 }, /* MOVE */
{ CPUFUNC(op_1190_0), 4496 }, /* MOVE */
{ CPUFUNC(op_1198_0), 4504 }, /* MOVE */
{ CPUFUNC(op_11a0_0), 4512 }, /* MOVE */
{ CPUFUNC(op_11a8_0), 4520 }, /* MOVE */
{ CPUFUNC(op_11b0_0), 4528 }, /* MOVE */
{ CPUFUNC(op_11b8_0), 4536 }, /* MOVE */
{ CPUFUNC(op_11b9_0), 4537 }, /* MOVE */
{ CPUFUNC(op_11ba_0), 4538 }, /* MOVE */
{ CPUFUNC(op_11bb_0), 4539 }, /* MOVE */
{ CPUFUNC(op_11bc_0), 4540 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 4544 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 4560 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 4568 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 4576 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 4584 }, /* MOVE */
{ CPUFUNC(op_11f0_0), 4592 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 4600 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 4601 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 4602 }, /* MOVE */
{ CPUFUNC(op_11fb_0), 4603 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 4604 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 5056 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 5072 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 5080 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 5088 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 5096 }, /* MOVE */
{ CPUFUNC(op_13f0_0), 5104 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 5112 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 5113 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 5114 }, /* MOVE */
{ CPUFUNC(op_13fb_0), 5115 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 5116 }, /* MOVE */
{ CPUFUNC(op_2000_0), 8192 }, /* MOVE */
{ CPUFUNC(op_2008_0), 8200 }, /* MOVE */
{ CPUFUNC(op_2010_0), 8208 }, /* MOVE */
{ CPUFUNC(op_2018_0), 8216 }, /* MOVE */
{ CPUFUNC(op_2020_0), 8224 }, /* MOVE */
{ CPUFUNC(op_2028_0), 8232 }, /* MOVE */
{ CPUFUNC(op_2030_0), 8240 }, /* MOVE */
{ CPUFUNC(op_2038_0), 8248 }, /* MOVE */
{ CPUFUNC(op_2039_0), 8249 }, /* MOVE */
{ CPUFUNC(op_203a_0), 8250 }, /* MOVE */
{ CPUFUNC(op_203b_0), 8251 }, /* MOVE */
{ CPUFUNC(op_203c_0), 8252 }, /* MOVE */
{ CPUFUNC(op_2040_0), 8256 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 8264 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 8272 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 8280 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 8288 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 8296 }, /* MOVEA */
{ CPUFUNC(op_2070_0), 8304 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 8312 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 8313 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 8314 }, /* MOVEA */
{ CPUFUNC(op_207b_0), 8315 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 8316 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 8320 }, /* MOVE */
{ CPUFUNC(op_2088_0), 8328 }, /* MOVE */
{ CPUFUNC(op_2090_0), 8336 }, /* MOVE */
{ CPUFUNC(op_2098_0), 8344 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 8352 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 8360 }, /* MOVE */
{ CPUFUNC(op_20b0_0), 8368 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 8376 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 8377 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 8378 }, /* MOVE */
{ CPUFUNC(op_20bb_0), 8379 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 8380 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 8384 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 8392 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 8400 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 8408 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 8416 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 8424 }, /* MOVE */
{ CPUFUNC(op_20f0_0), 8432 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 8440 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 8441 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 8442 }, /* MOVE */
{ CPUFUNC(op_20fb_0), 8443 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 8444 }, /* MOVE */
{ CPUFUNC(op_2100_0), 8448 }, /* MOVE */
{ CPUFUNC(op_2108_0), 8456 }, /* MOVE */
{ CPUFUNC(op_2110_0), 8464 }, /* MOVE */
{ CPUFUNC(op_2118_0), 8472 }, /* MOVE */
{ CPUFUNC(op_2120_0), 8480 }, /* MOVE */
{ CPUFUNC(op_2128_0), 8488 }, /* MOVE */
{ CPUFUNC(op_2130_0), 8496 }, /* MOVE */
{ CPUFUNC(op_2138_0), 8504 }, /* MOVE */
{ CPUFUNC(op_2139_0), 8505 }, /* MOVE */
{ CPUFUNC(op_213a_0), 8506 }, /* MOVE */
{ CPUFUNC(op_213b_0), 8507 }, /* MOVE */
{ CPUFUNC(op_213c_0), 8508 }, /* MOVE */
{ CPUFUNC(op_2140_0), 8512 }, /* MOVE */
{ CPUFUNC(op_2148_0), 8520 }, /* MOVE */
{ CPUFUNC(op_2150_0), 8528 }, /* MOVE */
{ CPUFUNC(op_2158_0), 8536 }, /* MOVE */
{ CPUFUNC(op_2160_0), 8544 }, /* MOVE */
{ CPUFUNC(op_2168_0), 8552 }, /* MOVE */
{ CPUFUNC(op_2170_0), 8560 }, /* MOVE */
{ CPUFUNC(op_2178_0), 8568 }, /* MOVE */
{ CPUFUNC(op_2179_0), 8569 }, /* MOVE */
{ CPUFUNC(op_217a_0), 8570 }, /* MOVE */
{ CPUFUNC(op_217b_0), 8571 }, /* MOVE */
{ CPUFUNC(op_217c_0), 8572 }, /* MOVE */
{ CPUFUNC(op_2180_0), 8576 }, /* MOVE */
{ CPUFUNC(op_2188_0), 8584 }, /* MOVE */
{ CPUFUNC(op_2190_0), 8592 }, /* MOVE */
{ CPUFUNC(op_2198_0), 8600 }, /* MOVE */
{ CPUFUNC(op_21a0_0), 8608 }, /* MOVE */
{ CPUFUNC(op_21a8_0), 8616 }, /* MOVE */
{ CPUFUNC(op_21b0_0), 8624 }, /* MOVE */
{ CPUFUNC(op_21b8_0), 8632 }, /* MOVE */
{ CPUFUNC(op_21b9_0), 8633 }, /* MOVE */
{ CPUFUNC(op_21ba_0), 8634 }, /* MOVE */
{ CPUFUNC(op_21bb_0), 8635 }, /* MOVE */
{ CPUFUNC(op_21bc_0), 8636 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 8640 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 8648 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 8656 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 8664 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 8672 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 8680 }, /* MOVE */
{ CPUFUNC(op_21f0_0), 8688 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 8696 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 8697 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 8698 }, /* MOVE */
{ CPUFUNC(op_21fb_0), 8699 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 8700 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 9152 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 9160 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 9168 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 9176 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 9184 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 9192 }, /* MOVE */
{ CPUFUNC(op_23f0_0), 9200 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 9208 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 9209 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 9210 }, /* MOVE */
{ CPUFUNC(op_23fb_0), 9211 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 9212 }, /* MOVE */
{ CPUFUNC(op_3000_0), 12288 }, /* MOVE */
{ CPUFUNC(op_3008_0), 12296 }, /* MOVE */
{ CPUFUNC(op_3010_0), 12304 }, /* MOVE */
{ CPUFUNC(op_3018_0), 12312 }, /* MOVE */
{ CPUFUNC(op_3020_0), 12320 }, /* MOVE */
{ CPUFUNC(op_3028_0), 12328 }, /* MOVE */
{ CPUFUNC(op_3030_0), 12336 }, /* MOVE */
{ CPUFUNC(op_3038_0), 12344 }, /* MOVE */
{ CPUFUNC(op_3039_0), 12345 }, /* MOVE */
{ CPUFUNC(op_303a_0), 12346 }, /* MOVE */
{ CPUFUNC(op_303b_0), 12347 }, /* MOVE */
{ CPUFUNC(op_303c_0), 12348 }, /* MOVE */
{ CPUFUNC(op_3040_0), 12352 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 12360 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 12368 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 12376 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 12384 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 12392 }, /* MOVEA */
{ CPUFUNC(op_3070_0), 12400 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 12408 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 12409 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 12410 }, /* MOVEA */
{ CPUFUNC(op_307b_0), 12411 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 12412 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 12416 }, /* MOVE */
{ CPUFUNC(op_3088_0), 12424 }, /* MOVE */
{ CPUFUNC(op_3090_0), 12432 }, /* MOVE */
{ CPUFUNC(op_3098_0), 12440 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 12448 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 12456 }, /* MOVE */
{ CPUFUNC(op_30b0_0), 12464 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 12472 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 12473 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 12474 }, /* MOVE */
{ CPUFUNC(op_30bb_0), 12475 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 12476 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 12480 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 12488 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 12496 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 12504 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 12512 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 12520 }, /* MOVE */
{ CPUFUNC(op_30f0_0), 12528 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 12536 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 12537 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 12538 }, /* MOVE */
{ CPUFUNC(op_30fb_0), 12539 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 12540 }, /* MOVE */
{ CPUFUNC(op_3100_0), 12544 }, /* MOVE */
{ CPUFUNC(op_3108_0), 12552 }, /* MOVE */
{ CPUFUNC(op_3110_0), 12560 }, /* MOVE */
{ CPUFUNC(op_3118_0), 12568 }, /* MOVE */
{ CPUFUNC(op_3120_0), 12576 }, /* MOVE */
{ CPUFUNC(op_3128_0), 12584 }, /* MOVE */
{ CPUFUNC(op_3130_0), 12592 }, /* MOVE */
{ CPUFUNC(op_3138_0), 12600 }, /* MOVE */
{ CPUFUNC(op_3139_0), 12601 }, /* MOVE */
{ CPUFUNC(op_313a_0), 12602 }, /* MOVE */
{ CPUFUNC(op_313b_0), 12603 }, /* MOVE */
{ CPUFUNC(op_313c_0), 12604 }, /* MOVE */
{ CPUFUNC(op_3140_0), 12608 }, /* MOVE */
{ CPUFUNC(op_3148_0), 12616 }, /* MOVE */
{ CPUFUNC(op_3150_0), 12624 }, /* MOVE */
{ CPUFUNC(op_3158_0), 12632 }, /* MOVE */
{ CPUFUNC(op_3160_0), 12640 }, /* MOVE */
{ CPUFUNC(op_3168_0), 12648 }, /* MOVE */
{ CPUFUNC(op_3170_0), 12656 }, /* MOVE */
{ CPUFUNC(op_3178_0), 12664 }, /* MOVE */
{ CPUFUNC(op_3179_0), 12665 }, /* MOVE */
{ CPUFUNC(op_317a_0), 12666 }, /* MOVE */
{ CPUFUNC(op_317b_0), 12667 }, /* MOVE */
{ CPUFUNC(op_317c_0), 12668 }, /* MOVE */
{ CPUFUNC(op_3180_0), 12672 }, /* MOVE */
{ CPUFUNC(op_3188_0), 12680 }, /* MOVE */
{ CPUFUNC(op_3190_0), 12688 }, /* MOVE */
{ CPUFUNC(op_3198_0), 12696 }, /* MOVE */
{ CPUFUNC(op_31a0_0), 12704 }, /* MOVE */
{ CPUFUNC(op_31a8_0), 12712 }, /* MOVE */
{ CPUFUNC(op_31b0_0), 12720 }, /* MOVE */
{ CPUFUNC(op_31b8_0), 12728 }, /* MOVE */
{ CPUFUNC(op_31b9_0), 12729 }, /* MOVE */
{ CPUFUNC(op_31ba_0), 12730 }, /* MOVE */
{ CPUFUNC(op_31bb_0), 12731 }, /* MOVE */
{ CPUFUNC(op_31bc_0), 12732 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 12736 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 12744 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 12752 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 12760 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 12768 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 12776 }, /* MOVE */
{ CPUFUNC(op_31f0_0), 12784 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 12792 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 12793 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 12794 }, /* MOVE */
{ CPUFUNC(op_31fb_0), 12795 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 12796 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 13248 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 13256 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 13264 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 13272 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 13280 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 13288 }, /* MOVE */
{ CPUFUNC(op_33f0_0), 13296 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 13304 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 13305 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 13306 }, /* MOVE */
{ CPUFUNC(op_33fb_0), 13307 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 13308 }, /* MOVE */
{ CPUFUNC(op_4000_0), 16384 }, /* NEGX */
{ CPUFUNC(op_4010_0), 16400 }, /* NEGX */
{ CPUFUNC(op_4018_0), 16408 }, /* NEGX */
{ CPUFUNC(op_4020_0), 16416 }, /* NEGX */
{ CPUFUNC(op_4028_0), 16424 }, /* NEGX */
{ CPUFUNC(op_4030_0), 16432 }, /* NEGX */
{ CPUFUNC(op_4038_0), 16440 }, /* NEGX */
{ CPUFUNC(op_4039_0), 16441 }, /* NEGX */
{ CPUFUNC(op_4040_0), 16448 }, /* NEGX */
{ CPUFUNC(op_4050_0), 16464 }, /* NEGX */
{ CPUFUNC(op_4058_0), 16472 }, /* NEGX */
{ CPUFUNC(op_4060_0), 16480 }, /* NEGX */
{ CPUFUNC(op_4068_0), 16488 }, /* NEGX */
{ CPUFUNC(op_4070_0), 16496 }, /* NEGX */
{ CPUFUNC(op_4078_0), 16504 }, /* NEGX */
{ CPUFUNC(op_4079_0), 16505 }, /* NEGX */
{ CPUFUNC(op_4080_0), 16512 }, /* NEGX */
{ CPUFUNC(op_4090_0), 16528 }, /* NEGX */
{ CPUFUNC(op_4098_0), 16536 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 16544 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 16552 }, /* NEGX */
{ CPUFUNC(op_40b0_0), 16560 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 16568 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 16569 }, /* NEGX */
{ CPUFUNC(op_40c0_0), 16576 }, /* MVSR2 */
{ CPUFUNC(op_40d0_0), 16592 }, /* MVSR2 */
{ CPUFUNC(op_40d8_0), 16600 }, /* MVSR2 */
{ CPUFUNC(op_40e0_0), 16608 }, /* MVSR2 */
{ CPUFUNC(op_40e8_0), 16616 }, /* MVSR2 */
{ CPUFUNC(op_40f0_0), 16624 }, /* MVSR2 */
{ CPUFUNC(op_40f8_0), 16632 }, /* MVSR2 */
{ CPUFUNC(op_40f9_0), 16633 }, /* MVSR2 */
{ CPUFUNC(op_4100_0), 16640 }, /* CHK */
{ CPUFUNC(op_4110_0), 16656 }, /* CHK */
{ CPUFUNC(op_4118_0), 16664 }, /* CHK */
{ CPUFUNC(op_4120_0), 16672 }, /* CHK */
{ CPUFUNC(op_4128_0), 16680 }, /* CHK */
{ CPUFUNC(op_4130_0), 16688 }, /* CHK */
{ CPUFUNC(op_4138_0), 16696 }, /* CHK */
{ CPUFUNC(op_4139_0), 16697 }, /* CHK */
{ CPUFUNC(op_413a_0), 16698 }, /* CHK */
{ CPUFUNC(op_413b_0), 16699 }, /* CHK */
{ CPUFUNC(op_413c_0), 16700 }, /* CHK */
{ CPUFUNC(op_4180_0), 16768 }, /* CHK */
{ CPUFUNC(op_4190_0), 16784 }, /* CHK */
{ CPUFUNC(op_4198_0), 16792 }, /* CHK */
{ CPUFUNC(op_41a0_0), 16800 }, /* CHK */
{ CPUFUNC(op_41a8_0), 16808 }, /* CHK */
{ CPUFUNC(op_41b0_0), 16816 }, /* CHK */
{ CPUFUNC(op_41b8_0), 16824 }, /* CHK */
{ CPUFUNC(op_41b9_0), 16825 }, /* CHK */
{ CPUFUNC(op_41ba_0), 16826 }, /* CHK */
{ CPUFUNC(op_41bb_0), 16827 }, /* CHK */
{ CPUFUNC(op_41bc_0), 16828 }, /* CHK */
{ CPUFUNC(op_41d0_0), 16848 }, /* LEA */
{ CPUFUNC(op_41e8_0), 16872 }, /* LEA */
{ CPUFUNC(op_41f0_0), 16880 }, /* LEA */
{ CPUFUNC(op_41f8_0), 16888 }, /* LEA */
{ CPUFUNC(op_41f9_0), 16889 }, /* LEA */
{ CPUFUNC(op_41fa_0), 16890 }, /* LEA */
{ CPUFUNC(op_41fb_0), 16891 }, /* LEA */
{ CPUFUNC(op_4200_0), 16896 }, /* CLR */
{ CPUFUNC(op_4210_0), 16912 }, /* CLR */
{ CPUFUNC(op_4218_0), 16920 }, /* CLR */
{ CPUFUNC(op_4220_0), 16928 }, /* CLR */
{ CPUFUNC(op_4228_0), 16936 }, /* CLR */
{ CPUFUNC(op_4230_0), 16944 }, /* CLR */
{ CPUFUNC(op_4238_0), 16952 }, /* CLR */
{ CPUFUNC(op_4239_0), 16953 }, /* CLR */
{ CPUFUNC(op_4240_0), 16960 }, /* CLR */
{ CPUFUNC(op_4250_0), 16976 }, /* CLR */
{ CPUFUNC(op_4258_0), 16984 }, /* CLR */
{ CPUFUNC(op_4260_0), 16992 }, /* CLR */
{ CPUFUNC(op_4268_0), 17000 }, /* CLR */
{ CPUFUNC(op_4270_0), 17008 }, /* CLR */
{ CPUFUNC(op_4278_0), 17016 }, /* CLR */
{ CPUFUNC(op_4279_0), 17017 }, /* CLR */
{ CPUFUNC(op_4280_0), 17024 }, /* CLR */
{ CPUFUNC(op_4290_0), 17040 }, /* CLR */
{ CPUFUNC(op_4298_0), 17048 }, /* CLR */
{ CPUFUNC(op_42a0_0), 17056 }, /* CLR */
{ CPUFUNC(op_42a8_0), 17064 }, /* CLR */
{ CPUFUNC(op_42b0_0), 17072 }, /* CLR */
{ CPUFUNC(op_42b8_0), 17080 }, /* CLR */
{ CPUFUNC(op_42b9_0), 17081 }, /* CLR */
{ CPUFUNC(op_42c0_0), 17088 }, /* MVSR2 */
{ CPUFUNC(op_42d0_0), 17104 }, /* MVSR2 */
{ CPUFUNC(op_42d8_0), 17112 }, /* MVSR2 */
{ CPUFUNC(op_42e0_0), 17120 }, /* MVSR2 */
{ CPUFUNC(op_42e8_0), 17128 }, /* MVSR2 */
{ CPUFUNC(op_42f0_0), 17136 }, /* MVSR2 */
{ CPUFUNC(op_42f8_0), 17144 }, /* MVSR2 */
{ CPUFUNC(op_42f9_0), 17145 }, /* MVSR2 */
{ CPUFUNC(op_4400_0), 17408 }, /* NEG */
{ CPUFUNC(op_4410_0), 17424 }, /* NEG */
{ CPUFUNC(op_4418_0), 17432 }, /* NEG */
{ CPUFUNC(op_4420_0), 17440 }, /* NEG */
{ CPUFUNC(op_4428_0), 17448 }, /* NEG */
{ CPUFUNC(op_4430_0), 17456 }, /* NEG */
{ CPUFUNC(op_4438_0), 17464 }, /* NEG */
{ CPUFUNC(op_4439_0), 17465 }, /* NEG */
{ CPUFUNC(op_4440_0), 17472 }, /* NEG */
{ CPUFUNC(op_4450_0), 17488 }, /* NEG */
{ CPUFUNC(op_4458_0), 17496 }, /* NEG */
{ CPUFUNC(op_4460_0), 17504 }, /* NEG */
{ CPUFUNC(op_4468_0), 17512 }, /* NEG */
{ CPUFUNC(op_4470_0), 17520 }, /* NEG */
{ CPUFUNC(op_4478_0), 17528 }, /* NEG */
{ CPUFUNC(op_4479_0), 17529 }, /* NEG */
{ CPUFUNC(op_4480_0), 17536 }, /* NEG */
{ CPUFUNC(op_4490_0), 17552 }, /* NEG */
{ CPUFUNC(op_4498_0), 17560 }, /* NEG */
{ CPUFUNC(op_44a0_0), 17568 }, /* NEG */
{ CPUFUNC(op_44a8_0), 17576 }, /* NEG */
{ CPUFUNC(op_44b0_0), 17584 }, /* NEG */
{ CPUFUNC(op_44b8_0), 17592 }, /* NEG */
{ CPUFUNC(op_44b9_0), 17593 }, /* NEG */
{ CPUFUNC(op_44c0_0), 17600 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 17616 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 17624 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 17632 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 17640 }, /* MV2SR */
{ CPUFUNC(op_44f0_0), 17648 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 17656 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 17657 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 17658 }, /* MV2SR */
{ CPUFUNC(op_44fb_0), 17659 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 17660 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 17920 }, /* NOT */
{ CPUFUNC(op_4610_0), 17936 }, /* NOT */
{ CPUFUNC(op_4618_0), 17944 }, /* NOT */
{ CPUFUNC(op_4620_0), 17952 }, /* NOT */
{ CPUFUNC(op_4628_0), 17960 }, /* NOT */
{ CPUFUNC(op_4630_0), 17968 }, /* NOT */
{ CPUFUNC(op_4638_0), 17976 }, /* NOT */
{ CPUFUNC(op_4639_0), 17977 }, /* NOT */
{ CPUFUNC(op_4640_0), 17984 }, /* NOT */
{ CPUFUNC(op_4650_0), 18000 }, /* NOT */
{ CPUFUNC(op_4658_0), 18008 }, /* NOT */
{ CPUFUNC(op_4660_0), 18016 }, /* NOT */
{ CPUFUNC(op_4668_0), 18024 }, /* NOT */
{ CPUFUNC(op_4670_0), 18032 }, /* NOT */
{ CPUFUNC(op_4678_0), 18040 }, /* NOT */
{ CPUFUNC(op_4679_0), 18041 }, /* NOT */
{ CPUFUNC(op_4680_0), 18048 }, /* NOT */
{ CPUFUNC(op_4690_0), 18064 }, /* NOT */
{ CPUFUNC(op_4698_0), 18072 }, /* NOT */
{ CPUFUNC(op_46a0_0), 18080 }, /* NOT */
{ CPUFUNC(op_46a8_0), 18088 }, /* NOT */
{ CPUFUNC(op_46b0_0), 18096 }, /* NOT */
{ CPUFUNC(op_46b8_0), 18104 }, /* NOT */
{ CPUFUNC(op_46b9_0), 18105 }, /* NOT */
{ CPUFUNC(op_46c0_0), 18112 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 18128 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 18136 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 18144 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 18152 }, /* MV2SR */
{ CPUFUNC(op_46f0_0), 18160 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 18168 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 18169 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 18170 }, /* MV2SR */
{ CPUFUNC(op_46fb_0), 18171 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 18172 }, /* MV2SR */
{ CPUFUNC(op_4800_2), 18432 }, /* NBCD */
{ CPUFUNC(op_4808_0), 18440 }, /* LINK */
{ CPUFUNC(op_4810_2), 18448 }, /* NBCD */
{ CPUFUNC(op_4818_2), 18456 }, /* NBCD */
{ CPUFUNC(op_4820_2), 18464 }, /* NBCD */
{ CPUFUNC(op_4828_2), 18472 }, /* NBCD */
{ CPUFUNC(op_4830_2), 18480 }, /* NBCD */
{ CPUFUNC(op_4838_2), 18488 }, /* NBCD */
{ CPUFUNC(op_4839_2), 18489 }, /* NBCD */
{ CPUFUNC(op_4840_0), 18496 }, /* SWAP */
{ CPUFUNC(op_4848_0), 18504 }, /* BKPT */
{ CPUFUNC(op_4850_0), 18512 }, /* PEA */
{ CPUFUNC(op_4868_0), 18536 }, /* PEA */
{ CPUFUNC(op_4870_0), 18544 }, /* PEA */
{ CPUFUNC(op_4878_0), 18552 }, /* PEA */
{ CPUFUNC(op_4879_0), 18553 }, /* PEA */
{ CPUFUNC(op_487a_0), 18554 }, /* PEA */
{ CPUFUNC(op_487b_0), 18555 }, /* PEA */
{ CPUFUNC(op_4880_0), 18560 }, /* EXT */
{ CPUFUNC(op_4890_0), 18576 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 18592 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 18600 }, /* MVMLE */
{ CPUFUNC(op_48b0_0), 18608 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 18616 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 18617 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 18624 }, /* EXT */
{ CPUFUNC(op_48d0_0), 18640 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 18656 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 18664 }, /* MVMLE */
{ CPUFUNC(op_48f0_0), 18672 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 18680 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 18681 }, /* MVMLE */
{ CPUFUNC(op_49c0_0), 18880 }, /* EXT */
{ CPUFUNC(op_4a00_0), 18944 }, /* TST */
{ CPUFUNC(op_4a10_0), 18960 }, /* TST */
{ CPUFUNC(op_4a18_0), 18968 }, /* TST */
{ CPUFUNC(op_4a20_0), 18976 }, /* TST */
{ CPUFUNC(op_4a28_0), 18984 }, /* TST */
{ CPUFUNC(op_4a30_0), 18992 }, /* TST */
{ CPUFUNC(op_4a38_0), 19000 }, /* TST */
{ CPUFUNC(op_4a39_0), 19001 }, /* TST */
{ CPUFUNC(op_4a3a_0), 19002 }, /* TST */
{ CPUFUNC(op_4a3b_0), 19003 }, /* TST */
{ CPUFUNC(op_4a3c_0), 19004 }, /* TST */
{ CPUFUNC(op_4a40_0), 19008 }, /* TST */
{ CPUFUNC(op_4a48_0), 19016 }, /* TST */
{ CPUFUNC(op_4a50_0), 19024 }, /* TST */
{ CPUFUNC(op_4a58_0), 19032 }, /* TST */
{ CPUFUNC(op_4a60_0), 19040 }, /* TST */
{ CPUFUNC(op_4a68_0), 19048 }, /* TST */
{ CPUFUNC(op_4a70_0), 19056 }, /* TST */
{ CPUFUNC(op_4a78_0), 19064 }, /* TST */
{ CPUFUNC(op_4a79_0), 19065 }, /* TST */
{ CPUFUNC(op_4a7a_0), 19066 }, /* TST */
{ CPUFUNC(op_4a7b_0), 19067 }, /* TST */
{ CPUFUNC(op_4a7c_0), 19068 }, /* TST */
{ CPUFUNC(op_4a80_0), 19072 }, /* TST */
{ CPUFUNC(op_4a88_0), 19080 }, /* TST */
{ CPUFUNC(op_4a90_0), 19088 }, /* TST */
{ CPUFUNC(op_4a98_0), 19096 }, /* TST */
{ CPUFUNC(op_4aa0_0), 19104 }, /* TST */
{ CPUFUNC(op_4aa8_0), 19112 }, /* TST */
{ CPUFUNC(op_4ab0_0), 19120 }, /* TST */
{ CPUFUNC(op_4ab8_0), 19128 }, /* TST */
{ CPUFUNC(op_4ab9_0), 19129 }, /* TST */
{ CPUFUNC(op_4aba_0), 19130 }, /* TST */
{ CPUFUNC(op_4abb_0), 19131 }, /* TST */
{ CPUFUNC(op_4abc_0), 19132 }, /* TST */
{ CPUFUNC(op_4ac0_0), 19136 }, /* TAS */
{ CPUFUNC(op_4ad0_0), 19152 }, /* TAS */
{ CPUFUNC(op_4ad8_0), 19160 }, /* TAS */
{ CPUFUNC(op_4ae0_0), 19168 }, /* TAS */
{ CPUFUNC(op_4ae8_0), 19176 }, /* TAS */
{ CPUFUNC(op_4af0_0), 19184 }, /* TAS */
{ CPUFUNC(op_4af8_0), 19192 }, /* TAS */
{ CPUFUNC(op_4af9_0), 19193 }, /* TAS */
{ CPUFUNC(op_4c00_0), 19456 }, /* MULL */
{ CPUFUNC(op_4c10_0), 19472 }, /* MULL */
{ CPUFUNC(op_4c18_0), 19480 }, /* MULL */
{ CPUFUNC(op_4c20_0), 19488 }, /* MULL */
{ CPUFUNC(op_4c28_0), 19496 }, /* MULL */
{ CPUFUNC(op_4c30_0), 19504 }, /* MULL */
{ CPUFUNC(op_4c38_0), 19512 }, /* MULL */
{ CPUFUNC(op_4c39_0), 19513 }, /* MULL */
{ CPUFUNC(op_4c3a_0), 19514 }, /* MULL */
{ CPUFUNC(op_4c3b_0), 19515 }, /* MULL */
{ CPUFUNC(op_4c3c_0), 19516 }, /* MULL */
{ CPUFUNC(op_4c40_0), 19520 }, /* DIVL */
{ CPUFUNC(op_4c50_0), 19536 }, /* DIVL */
{ CPUFUNC(op_4c58_0), 19544 }, /* DIVL */
{ CPUFUNC(op_4c60_0), 19552 }, /* DIVL */
{ CPUFUNC(op_4c68_0), 19560 }, /* DIVL */
{ CPUFUNC(op_4c70_0), 19568 }, /* DIVL */
{ CPUFUNC(op_4c78_0), 19576 }, /* DIVL */
{ CPUFUNC(op_4c79_0), 19577 }, /* DIVL */
{ CPUFUNC(op_4c7a_0), 19578 }, /* DIVL */
{ CPUFUNC(op_4c7b_0), 19579 }, /* DIVL */
{ CPUFUNC(op_4c7c_0), 19580 }, /* DIVL */
{ CPUFUNC(op_4c90_0), 19600 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 19608 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 19624 }, /* MVMEL */
{ CPUFUNC(op_4cb0_0), 19632 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 19640 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 19641 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 19642 }, /* MVMEL */
{ CPUFUNC(op_4cbb_0), 19643 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 19664 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 19672 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 19688 }, /* MVMEL */
{ CPUFUNC(op_4cf0_0), 19696 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 19704 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 19705 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 19706 }, /* MVMEL */
{ CPUFUNC(op_4cfb_0), 19707 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 20032 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 20048 }, /* LINK */
{ CPUFUNC(op_4e58_0), 20056 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 20064 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 20072 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 20080 }, /* RESET */
{ CPUFUNC(op_4e71_0), 20081 }, /* NOP */
{ CPUFUNC(op_4e72_0), 20082 }, /* STOP */
{ CPUFUNC(op_4e73_0), 20083 }, /* RTE */
{ CPUFUNC(op_4e74_0), 20084 }, /* RTD */
{ CPUFUNC(op_4e75_0), 20085 }, /* RTS */
{ CPUFUNC(op_4e76_0), 20086 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 20087 }, /* RTR */
{ CPUFUNC(op_4e7a_0), 20090 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_0), 20091 }, /* MOVE2C */
{ CPUFUNC(op_4e90_0), 20112 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 20136 }, /* JSR */
{ CPUFUNC(op_4eb0_0), 20144 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 20152 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 20153 }, /* JSR */
{ CPUFUNC(op_4eba_0), 20154 }, /* JSR */
{ CPUFUNC(op_4ebb_0), 20155 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 20176 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 20200 }, /* JMP */
{ CPUFUNC(op_4ef0_0), 20208 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 20216 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 20217 }, /* JMP */
{ CPUFUNC(op_4efa_0), 20218 }, /* JMP */
{ CPUFUNC(op_4efb_0), 20219 }, /* JMP */
{ CPUFUNC(op_5000_0), 20480 }, /* ADD */
{ CPUFUNC(op_5010_0), 20496 }, /* ADD */
{ CPUFUNC(op_5018_0), 20504 }, /* ADD */
{ CPUFUNC(op_5020_0), 20512 }, /* ADD */
{ CPUFUNC(op_5028_0), 20520 }, /* ADD */
{ CPUFUNC(op_5030_0), 20528 }, /* ADD */
{ CPUFUNC(op_5038_0), 20536 }, /* ADD */
{ CPUFUNC(op_5039_0), 20537 }, /* ADD */
{ CPUFUNC(op_5040_0), 20544 }, /* ADD */
{ CPUFUNC(op_5048_0), 20552 }, /* ADDA */
{ CPUFUNC(op_5050_0), 20560 }, /* ADD */
{ CPUFUNC(op_5058_0), 20568 }, /* ADD */
{ CPUFUNC(op_5060_0), 20576 }, /* ADD */
{ CPUFUNC(op_5068_0), 20584 }, /* ADD */
{ CPUFUNC(op_5070_0), 20592 }, /* ADD */
{ CPUFUNC(op_5078_0), 20600 }, /* ADD */
{ CPUFUNC(op_5079_0), 20601 }, /* ADD */
{ CPUFUNC(op_5080_0), 20608 }, /* ADD */
{ CPUFUNC(op_5088_0), 20616 }, /* ADDA */
{ CPUFUNC(op_5090_0), 20624 }, /* ADD */
{ CPUFUNC(op_5098_0), 20632 }, /* ADD */
{ CPUFUNC(op_50a0_0), 20640 }, /* ADD */
{ CPUFUNC(op_50a8_0), 20648 }, /* ADD */
{ CPUFUNC(op_50b0_0), 20656 }, /* ADD */
{ CPUFUNC(op_50b8_0), 20664 }, /* ADD */
{ CPUFUNC(op_50b9_0), 20665 }, /* ADD */
{ CPUFUNC(op_50c0_0), 20672 }, /* Scc */
{ CPUFUNC(op_50c8_0), 20680 }, /* DBcc */
{ CPUFUNC(op_50d0_0), 20688 }, /* Scc */
{ CPUFUNC(op_50d8_0), 20696 }, /* Scc */
{ CPUFUNC(op_50e0_0), 20704 }, /* Scc */
{ CPUFUNC(op_50e8_0), 20712 }, /* Scc */
{ CPUFUNC(op_50f0_0), 20720 }, /* Scc */
{ CPUFUNC(op_50f8_0), 20728 }, /* Scc */
{ CPUFUNC(op_50f9_0), 20729 }, /* Scc */
{ CPUFUNC(op_50fa_0), 20730 }, /* TRAPcc */
{ CPUFUNC(op_50fb_0), 20731 }, /* TRAPcc */
{ CPUFUNC(op_50fc_0), 20732 }, /* TRAPcc */
{ CPUFUNC(op_5100_0), 20736 }, /* SUB */
{ CPUFUNC(op_5110_0), 20752 }, /* SUB */
{ CPUFUNC(op_5118_0), 20760 }, /* SUB */
{ CPUFUNC(op_5120_0), 20768 }, /* SUB */
{ CPUFUNC(op_5128_0), 20776 }, /* SUB */
{ CPUFUNC(op_5130_0), 20784 }, /* SUB */
{ CPUFUNC(op_5138_0), 20792 }, /* SUB */
{ CPUFUNC(op_5139_0), 20793 }, /* SUB */
{ CPUFUNC(op_5140_0), 20800 }, /* SUB */
{ CPUFUNC(op_5148_0), 20808 }, /* SUBA */
{ CPUFUNC(op_5150_0), 20816 }, /* SUB */
{ CPUFUNC(op_5158_0), 20824 }, /* SUB */
{ CPUFUNC(op_5160_0), 20832 }, /* SUB */
{ CPUFUNC(op_5168_0), 20840 }, /* SUB */
{ CPUFUNC(op_5170_0), 20848 }, /* SUB */
{ CPUFUNC(op_5178_0), 20856 }, /* SUB */
{ CPUFUNC(op_5179_0), 20857 }, /* SUB */
{ CPUFUNC(op_5180_0), 20864 }, /* SUB */
{ CPUFUNC(op_5188_0), 20872 }, /* SUBA */
{ CPUFUNC(op_5190_0), 20880 }, /* SUB */
{ CPUFUNC(op_5198_0), 20888 }, /* SUB */
{ CPUFUNC(op_51a0_0), 20896 }, /* SUB */
{ CPUFUNC(op_51a8_0), 20904 }, /* SUB */
{ CPUFUNC(op_51b0_0), 20912 }, /* SUB */
{ CPUFUNC(op_51b8_0), 20920 }, /* SUB */
{ CPUFUNC(op_51b9_0), 20921 }, /* SUB */
{ CPUFUNC(op_51c0_0), 20928 }, /* Scc */
{ CPUFUNC(op_51c8_0), 20936 }, /* DBcc */
{ CPUFUNC(op_51d0_0), 20944 }, /* Scc */
{ CPUFUNC(op_51d8_0), 20952 }, /* Scc */
{ CPUFUNC(op_51e0_0), 20960 }, /* Scc */
{ CPUFUNC(op_51e8_0), 20968 }, /* Scc */
{ CPUFUNC(op_51f0_0), 20976 }, /* Scc */
{ CPUFUNC(op_51f8_0), 20984 }, /* Scc */
{ CPUFUNC(op_51f9_0), 20985 }, /* Scc */
{ CPUFUNC(op_51fa_0), 20986 }, /* TRAPcc */
{ CPUFUNC(op_51fb_0), 20987 }, /* TRAPcc */
{ CPUFUNC(op_51fc_0), 20988 }, /* TRAPcc */
{ CPUFUNC(op_52c0_0), 21184 }, /* Scc */
{ CPUFUNC(op_52c8_0), 21192 }, /* DBcc */
{ CPUFUNC(op_52d0_0), 21200 }, /* Scc */
{ CPUFUNC(op_52d8_0), 21208 }, /* Scc */
{ CPUFUNC(op_52e0_0), 21216 }, /* Scc */
{ CPUFUNC(op_52e8_0), 21224 }, /* Scc */
{ CPUFUNC(op_52f0_0), 21232 }, /* Scc */
{ CPUFUNC(op_52f8_0), 21240 }, /* Scc */
{ CPUFUNC(op_52f9_0), 21241 }, /* Scc */
{ CPUFUNC(op_52fa_0), 21242 }, /* TRAPcc */
{ CPUFUNC(op_52fb_0), 21243 }, /* TRAPcc */
{ CPUFUNC(op_52fc_0), 21244 }, /* TRAPcc */
{ CPUFUNC(op_53c0_0), 21440 }, /* Scc */
{ CPUFUNC(op_53c8_0), 21448 }, /* DBcc */
{ CPUFUNC(op_53d0_0), 21456 }, /* Scc */
{ CPUFUNC(op_53d8_0), 21464 }, /* Scc */
{ CPUFUNC(op_53e0_0), 21472 }, /* Scc */
{ CPUFUNC(op_53e8_0), 21480 }, /* Scc */
{ CPUFUNC(op_53f0_0), 21488 }, /* Scc */
{ CPUFUNC(op_53f8_0), 21496 }, /* Scc */
{ CPUFUNC(op_53f9_0), 21497 }, /* Scc */
{ CPUFUNC(op_53fa_0), 21498 }, /* TRAPcc */
{ CPUFUNC(op_53fb_0), 21499 }, /* TRAPcc */
{ CPUFUNC(op_53fc_0), 21500 }, /* TRAPcc */
{ CPUFUNC(op_54c0_0), 21696 }, /* Scc */
{ CPUFUNC(op_54c8_0), 21704 }, /* DBcc */
{ CPUFUNC(op_54d0_0), 21712 }, /* Scc */
{ CPUFUNC(op_54d8_0), 21720 }, /* Scc */
{ CPUFUNC(op_54e0_0), 21728 }, /* Scc */
{ CPUFUNC(op_54e8_0), 21736 }, /* Scc */
{ CPUFUNC(op_54f0_0), 21744 }, /* Scc */
{ CPUFUNC(op_54f8_0), 21752 }, /* Scc */
{ CPUFUNC(op_54f9_0), 21753 }, /* Scc */
{ CPUFUNC(op_54fa_0), 21754 }, /* TRAPcc */
{ CPUFUNC(op_54fb_0), 21755 }, /* TRAPcc */
{ CPUFUNC(op_54fc_0), 21756 }, /* TRAPcc */
{ CPUFUNC(op_55c0_0), 21952 }, /* Scc */
{ CPUFUNC(op_55c8_0), 21960 }, /* DBcc */
{ CPUFUNC(op_55d0_0), 21968 }, /* Scc */
{ CPUFUNC(op_55d8_0), 21976 }, /* Scc */
{ CPUFUNC(op_55e0_0), 21984 }, /* Scc */
{ CPUFUNC(op_55e8_0), 21992 }, /* Scc */
{ CPUFUNC(op_55f0_0), 22000 }, /* Scc */
{ CPUFUNC(op_55f8_0), 22008 }, /* Scc */
{ CPUFUNC(op_55f9_0), 22009 }, /* Scc */
{ CPUFUNC(op_55fa_0), 22010 }, /* TRAPcc */
{ CPUFUNC(op_55fb_0), 22011 }, /* TRAPcc */
{ CPUFUNC(op_55fc_0), 22012 }, /* TRAPcc */
{ CPUFUNC(op_56c0_0), 22208 }, /* Scc */
{ CPUFUNC(op_56c8_0), 22216 }, /* DBcc */
{ CPUFUNC(op_56d0_0), 22224 }, /* Scc */
{ CPUFUNC(op_56d8_0), 22232 }, /* Scc */
{ CPUFUNC(op_56e0_0), 22240 }, /* Scc */
{ CPUFUNC(op_56e8_0), 22248 }, /* Scc */
{ CPUFUNC(op_56f0_0), 22256 }, /* Scc */
{ CPUFUNC(op_56f8_0), 22264 }, /* Scc */
{ CPUFUNC(op_56f9_0), 22265 }, /* Scc */
{ CPUFUNC(op_56fa_0), 22266 }, /* TRAPcc */
{ CPUFUNC(op_56fb_0), 22267 }, /* TRAPcc */
{ CPUFUNC(op_56fc_0), 22268 }, /* TRAPcc */
{ CPUFUNC(op_57c0_0), 22464 }, /* Scc */
{ CPUFUNC(op_57c8_0), 22472 }, /* DBcc */
{ CPUFUNC(op_57d0_0), 22480 }, /* Scc */
{ CPUFUNC(op_57d8_0), 22488 }, /* Scc */
{ CPUFUNC(op_57e0_0), 22496 }, /* Scc */
{ CPUFUNC(op_57e8_0), 22504 }, /* Scc */
{ CPUFUNC(op_57f0_0), 22512 }, /* Scc */
{ CPUFUNC(op_57f8_0), 22520 }, /* Scc */
{ CPUFUNC(op_57f9_0), 22521 }, /* Scc */
{ CPUFUNC(op_57fa_0), 22522 }, /* TRAPcc */
{ CPUFUNC(op_57fb_0), 22523 }, /* TRAPcc */
{ CPUFUNC(op_57fc_0), 22524 }, /* TRAPcc */
{ CPUFUNC(op_58c0_0), 22720 }, /* Scc */
{ CPUFUNC(op_58c8_0), 22728 }, /* DBcc */
{ CPUFUNC(op_58d0_0), 22736 }, /* Scc */
{ CPUFUNC(op_58d8_0), 22744 }, /* Scc */
{ CPUFUNC(op_58e0_0), 22752 }, /* Scc */
{ CPUFUNC(op_58e8_0), 22760 }, /* Scc */
{ CPUFUNC(op_58f0_0), 22768 }, /* Scc */
{ CPUFUNC(op_58f8_0), 22776 }, /* Scc */
{ CPUFUNC(op_58f9_0), 22777 }, /* Scc */
{ CPUFUNC(op_58fa_0), 22778 }, /* TRAPcc */
{ CPUFUNC(op_58fb_0), 22779 }, /* TRAPcc */
{ CPUFUNC(op_58fc_0), 22780 }, /* TRAPcc */
{ CPUFUNC(op_59c0_0), 22976 }, /* Scc */
{ CPUFUNC(op_59c8_0), 22984 }, /* DBcc */
{ CPUFUNC(op_59d0_0), 22992 }, /* Scc */
{ CPUFUNC(op_59d8_0), 23000 }, /* Scc */
{ CPUFUNC(op_59e0_0), 23008 }, /* Scc */
{ CPUFUNC(op_59e8_0), 23016 }, /* Scc */
{ CPUFUNC(op_59f0_0), 23024 }, /* Scc */
{ CPUFUNC(op_59f8_0), 23032 }, /* Scc */
{ CPUFUNC(op_59f9_0), 23033 }, /* Scc */
{ CPUFUNC(op_59fa_0), 23034 }, /* TRAPcc */
{ CPUFUNC(op_59fb_0), 23035 }, /* TRAPcc */
{ CPUFUNC(op_59fc_0), 23036 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_0), 23232 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 23240 }, /* DBcc */
{ CPUFUNC(op_5ad0_0), 23248 }, /* Scc */
{ CPUFUNC(op_5ad8_0), 23256 }, /* Scc */
{ CPUFUNC(op_5ae0_0), 23264 }, /* Scc */
{ CPUFUNC(op_5ae8_0), 23272 }, /* Scc */
{ CPUFUNC(op_5af0_0), 23280 }, /* Scc */
{ CPUFUNC(op_5af8_0), 23288 }, /* Scc */
{ CPUFUNC(op_5af9_0), 23289 }, /* Scc */
{ CPUFUNC(op_5afa_0), 23290 }, /* TRAPcc */
{ CPUFUNC(op_5afb_0), 23291 }, /* TRAPcc */
{ CPUFUNC(op_5afc_0), 23292 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_0), 23488 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 23496 }, /* DBcc */
{ CPUFUNC(op_5bd0_0), 23504 }, /* Scc */
{ CPUFUNC(op_5bd8_0), 23512 }, /* Scc */
{ CPUFUNC(op_5be0_0), 23520 }, /* Scc */
{ CPUFUNC(op_5be8_0), 23528 }, /* Scc */
{ CPUFUNC(op_5bf0_0), 23536 }, /* Scc */
{ CPUFUNC(op_5bf8_0), 23544 }, /* Scc */
{ CPUFUNC(op_5bf9_0), 23545 }, /* Scc */
{ CPUFUNC(op_5bfa_0), 23546 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_0), 23547 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_0), 23548 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_0), 23744 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 23752 }, /* DBcc */
{ CPUFUNC(op_5cd0_0), 23760 }, /* Scc */
{ CPUFUNC(op_5cd8_0), 23768 }, /* Scc */
{ CPUFUNC(op_5ce0_0), 23776 }, /* Scc */
{ CPUFUNC(op_5ce8_0), 23784 }, /* Scc */
{ CPUFUNC(op_5cf0_0), 23792 }, /* Scc */
{ CPUFUNC(op_5cf8_0), 23800 }, /* Scc */
{ CPUFUNC(op_5cf9_0), 23801 }, /* Scc */
{ CPUFUNC(op_5cfa_0), 23802 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_0), 23803 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_0), 23804 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_0), 24000 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 24008 }, /* DBcc */
{ CPUFUNC(op_5dd0_0), 24016 }, /* Scc */
{ CPUFUNC(op_5dd8_0), 24024 }, /* Scc */
{ CPUFUNC(op_5de0_0), 24032 }, /* Scc */
{ CPUFUNC(op_5de8_0), 24040 }, /* Scc */
{ CPUFUNC(op_5df0_0), 24048 }, /* Scc */
{ CPUFUNC(op_5df8_0), 24056 }, /* Scc */
{ CPUFUNC(op_5df9_0), 24057 }, /* Scc */
{ CPUFUNC(op_5dfa_0), 24058 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_0), 24059 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_0), 24060 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_0), 24256 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 24264 }, /* DBcc */
{ CPUFUNC(op_5ed0_0), 24272 }, /* Scc */
{ CPUFUNC(op_5ed8_0), 24280 }, /* Scc */
{ CPUFUNC(op_5ee0_0), 24288 }, /* Scc */
{ CPUFUNC(op_5ee8_0), 24296 }, /* Scc */
{ CPUFUNC(op_5ef0_0), 24304 }, /* Scc */
{ CPUFUNC(op_5ef8_0), 24312 }, /* Scc */
{ CPUFUNC(op_5ef9_0), 24313 }, /* Scc */
{ CPUFUNC(op_5efa_0), 24314 }, /* TRAPcc */
{ CPUFUNC(op_5efb_0), 24315 }, /* TRAPcc */
{ CPUFUNC(op_5efc_0), 24316 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_0), 24512 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 24520 }, /* DBcc */
{ CPUFUNC(op_5fd0_0), 24528 }, /* Scc */
{ CPUFUNC(op_5fd8_0), 24536 }, /* Scc */
{ CPUFUNC(op_5fe0_0), 24544 }, /* Scc */
{ CPUFUNC(op_5fe8_0), 24552 }, /* Scc */
{ CPUFUNC(op_5ff0_0), 24560 }, /* Scc */
{ CPUFUNC(op_5ff8_0), 24568 }, /* Scc */
{ CPUFUNC(op_5ff9_0), 24569 }, /* Scc */
{ CPUFUNC(op_5ffa_0), 24570 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_0), 24571 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_0), 24572 }, /* TRAPcc */
{ CPUFUNC(op_6000_0), 24576 }, /* Bcc */
{ CPUFUNC(op_6001_0), 24577 }, /* Bcc */
{ CPUFUNC(op_60ff_0), 24831 }, /* Bcc */
{ CPUFUNC(op_6100_0), 24832 }, /* BSR */
{ CPUFUNC(op_6101_0), 24833 }, /* BSR */
{ CPUFUNC(op_61ff_0), 25087 }, /* BSR */
{ CPUFUNC(op_6200_0), 25088 }, /* Bcc */
{ CPUFUNC(op_6201_0), 25089 }, /* Bcc */
{ CPUFUNC(op_62ff_0), 25343 }, /* Bcc */
{ CPUFUNC(op_6300_0), 25344 }, /* Bcc */
{ CPUFUNC(op_6301_0), 25345 }, /* Bcc */
{ CPUFUNC(op_63ff_0), 25599 }, /* Bcc */
{ CPUFUNC(op_6400_0), 25600 }, /* Bcc */
{ CPUFUNC(op_6401_0), 25601 }, /* Bcc */
{ CPUFUNC(op_64ff_0), 25855 }, /* Bcc */
{ CPUFUNC(op_6500_0), 25856 }, /* Bcc */
{ CPUFUNC(op_6501_0), 25857 }, /* Bcc */
{ CPUFUNC(op_65ff_0), 26111 }, /* Bcc */
{ CPUFUNC(op_6600_0), 26112 }, /* Bcc */
{ CPUFUNC(op_6601_0), 26113 }, /* Bcc */
{ CPUFUNC(op_66ff_0), 26367 }, /* Bcc */
{ CPUFUNC(op_6700_0), 26368 }, /* Bcc */
{ CPUFUNC(op_6701_0), 26369 }, /* Bcc */
{ CPUFUNC(op_67ff_0), 26623 }, /* Bcc */
{ CPUFUNC(op_6800_0), 26624 }, /* Bcc */
{ CPUFUNC(op_6801_0), 26625 }, /* Bcc */
{ CPUFUNC(op_68ff_0), 26879 }, /* Bcc */
{ CPUFUNC(op_6900_0), 26880 }, /* Bcc */
{ CPUFUNC(op_6901_0), 26881 }, /* Bcc */
{ CPUFUNC(op_69ff_0), 27135 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 27136 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 27137 }, /* Bcc */
{ CPUFUNC(op_6aff_0), 27391 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 27392 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 27393 }, /* Bcc */
{ CPUFUNC(op_6bff_0), 27647 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 27648 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 27649 }, /* Bcc */
{ CPUFUNC(op_6cff_0), 27903 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 27904 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 27905 }, /* Bcc */
{ CPUFUNC(op_6dff_0), 28159 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 28160 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 28161 }, /* Bcc */
{ CPUFUNC(op_6eff_0), 28415 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 28416 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 28417 }, /* Bcc */
{ CPUFUNC(op_6fff_0), 28671 }, /* Bcc */
{ CPUFUNC(op_7000_0), 28672 }, /* MOVE */
{ CPUFUNC(op_8000_0), 32768 }, /* OR */
{ CPUFUNC(op_8010_0), 32784 }, /* OR */
{ CPUFUNC(op_8018_0), 32792 }, /* OR */
{ CPUFUNC(op_8020_0), 32800 }, /* OR */
{ CPUFUNC(op_8028_0), 32808 }, /* OR */
{ CPUFUNC(op_8030_0), 32816 }, /* OR */
{ CPUFUNC(op_8038_0), 32824 }, /* OR */
{ CPUFUNC(op_8039_0), 32825 }, /* OR */
{ CPUFUNC(op_803a_0), 32826 }, /* OR */
{ CPUFUNC(op_803b_0), 32827 }, /* OR */
{ CPUFUNC(op_803c_0), 32828 }, /* OR */
{ CPUFUNC(op_8040_0), 32832 }, /* OR */
{ CPUFUNC(op_8050_0), 32848 }, /* OR */
{ CPUFUNC(op_8058_0), 32856 }, /* OR */
{ CPUFUNC(op_8060_0), 32864 }, /* OR */
{ CPUFUNC(op_8068_0), 32872 }, /* OR */
{ CPUFUNC(op_8070_0), 32880 }, /* OR */
{ CPUFUNC(op_8078_0), 32888 }, /* OR */
{ CPUFUNC(op_8079_0), 32889 }, /* OR */
{ CPUFUNC(op_807a_0), 32890 }, /* OR */
{ CPUFUNC(op_807b_0), 32891 }, /* OR */
{ CPUFUNC(op_807c_0), 32892 }, /* OR */
{ CPUFUNC(op_8080_0), 32896 }, /* OR */
{ CPUFUNC(op_8090_0), 32912 }, /* OR */
{ CPUFUNC(op_8098_0), 32920 }, /* OR */
{ CPUFUNC(op_80a0_0), 32928 }, /* OR */
{ CPUFUNC(op_80a8_0), 32936 }, /* OR */
{ CPUFUNC(op_80b0_0), 32944 }, /* OR */
{ CPUFUNC(op_80b8_0), 32952 }, /* OR */
{ CPUFUNC(op_80b9_0), 32953 }, /* OR */
{ CPUFUNC(op_80ba_0), 32954 }, /* OR */
{ CPUFUNC(op_80bb_0), 32955 }, /* OR */
{ CPUFUNC(op_80bc_0), 32956 }, /* OR */
{ CPUFUNC(op_80c0_0), 32960 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 32976 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 32984 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 32992 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 33000 }, /* DIVU */
{ CPUFUNC(op_80f0_0), 33008 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 33016 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 33017 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 33018 }, /* DIVU */
{ CPUFUNC(op_80fb_0), 33019 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 33020 }, /* DIVU */
{ CPUFUNC(op_8100_2), 33024 }, /* SBCD */
{ CPUFUNC(op_8108_2), 33032 }, /* SBCD */
{ CPUFUNC(op_8110_0), 33040 }, /* OR */
{ CPUFUNC(op_8118_0), 33048 }, /* OR */
{ CPUFUNC(op_8120_0), 33056 }, /* OR */
{ CPUFUNC(op_8128_0), 33064 }, /* OR */
{ CPUFUNC(op_8130_0), 33072 }, /* OR */
{ CPUFUNC(op_8138_0), 33080 }, /* OR */
{ CPUFUNC(op_8139_0), 33081 }, /* OR */
{ CPUFUNC(op_8140_0), 33088 }, /* PACK */
{ CPUFUNC(op_8148_0), 33096 }, /* PACK */
{ CPUFUNC(op_8150_0), 33104 }, /* OR */
{ CPUFUNC(op_8158_0), 33112 }, /* OR */
{ CPUFUNC(op_8160_0), 33120 }, /* OR */
{ CPUFUNC(op_8168_0), 33128 }, /* OR */
{ CPUFUNC(op_8170_0), 33136 }, /* OR */
{ CPUFUNC(op_8178_0), 33144 }, /* OR */
{ CPUFUNC(op_8179_0), 33145 }, /* OR */
{ CPUFUNC(op_8180_0), 33152 }, /* UNPK */
{ CPUFUNC(op_8188_0), 33160 }, /* UNPK */
{ CPUFUNC(op_8190_0), 33168 }, /* OR */
{ CPUFUNC(op_8198_0), 33176 }, /* OR */
{ CPUFUNC(op_81a0_0), 33184 }, /* OR */
{ CPUFUNC(op_81a8_0), 33192 }, /* OR */
{ CPUFUNC(op_81b0_0), 33200 }, /* OR */
{ CPUFUNC(op_81b8_0), 33208 }, /* OR */
{ CPUFUNC(op_81b9_0), 33209 }, /* OR */
{ CPUFUNC(op_81c0_0), 33216 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 33232 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 33240 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 33248 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 33256 }, /* DIVS */
{ CPUFUNC(op_81f0_0), 33264 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 33272 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 33273 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 33274 }, /* DIVS */
{ CPUFUNC(op_81fb_0), 33275 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 33276 }, /* DIVS */
{ CPUFUNC(op_9000_0), 36864 }, /* SUB */
{ CPUFUNC(op_9010_0), 36880 }, /* SUB */
{ CPUFUNC(op_9018_0), 36888 }, /* SUB */
{ CPUFUNC(op_9020_0), 36896 }, /* SUB */
{ CPUFUNC(op_9028_0), 36904 }, /* SUB */
{ CPUFUNC(op_9030_0), 36912 }, /* SUB */
{ CPUFUNC(op_9038_0), 36920 }, /* SUB */
{ CPUFUNC(op_9039_0), 36921 }, /* SUB */
{ CPUFUNC(op_903a_0), 36922 }, /* SUB */
{ CPUFUNC(op_903b_0), 36923 }, /* SUB */
{ CPUFUNC(op_903c_0), 36924 }, /* SUB */
{ CPUFUNC(op_9040_0), 36928 }, /* SUB */
{ CPUFUNC(op_9048_0), 36936 }, /* SUB */
{ CPUFUNC(op_9050_0), 36944 }, /* SUB */
{ CPUFUNC(op_9058_0), 36952 }, /* SUB */
{ CPUFUNC(op_9060_0), 36960 }, /* SUB */
{ CPUFUNC(op_9068_0), 36968 }, /* SUB */
{ CPUFUNC(op_9070_0), 36976 }, /* SUB */
{ CPUFUNC(op_9078_0), 36984 }, /* SUB */
{ CPUFUNC(op_9079_0), 36985 }, /* SUB */
{ CPUFUNC(op_907a_0), 36986 }, /* SUB */
{ CPUFUNC(op_907b_0), 36987 }, /* SUB */
{ CPUFUNC(op_907c_0), 36988 }, /* SUB */
{ CPUFUNC(op_9080_0), 36992 }, /* SUB */
{ CPUFUNC(op_9088_0), 37000 }, /* SUB */
{ CPUFUNC(op_9090_0), 37008 }, /* SUB */
{ CPUFUNC(op_9098_0), 37016 }, /* SUB */
{ CPUFUNC(op_90a0_0), 37024 }, /* SUB */
{ CPUFUNC(op_90a8_0), 37032 }, /* SUB */
{ CPUFUNC(op_90b0_0), 37040 }, /* SUB */
{ CPUFUNC(op_90b8_0), 37048 }, /* SUB */
{ CPUFUNC(op_90b9_0), 37049 }, /* SUB */
{ CPUFUNC(op_90ba_0), 37050 }, /* SUB */
{ CPUFUNC(op_90bb_0), 37051 }, /* SUB */
{ CPUFUNC(op_90bc_0), 37052 }, /* SUB */
{ CPUFUNC(op_90c0_0), 37056 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 37064 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 37072 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 37080 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 37088 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 37096 }, /* SUBA */
{ CPUFUNC(op_90f0_0), 37104 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 37112 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 37113 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 37114 }, /* SUBA */
{ CPUFUNC(op_90fb_0), 37115 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 37116 }, /* SUBA */
{ CPUFUNC(op_9100_0), 37120 }, /* SUBX */
{ CPUFUNC(op_9108_0), 37128 }, /* SUBX */
{ CPUFUNC(op_9110_0), 37136 }, /* SUB */
{ CPUFUNC(op_9118_0), 37144 }, /* SUB */
{ CPUFUNC(op_9120_0), 37152 }, /* SUB */
{ CPUFUNC(op_9128_0), 37160 }, /* SUB */
{ CPUFUNC(op_9130_0), 37168 }, /* SUB */
{ CPUFUNC(op_9138_0), 37176 }, /* SUB */
{ CPUFUNC(op_9139_0), 37177 }, /* SUB */
{ CPUFUNC(op_9140_0), 37184 }, /* SUBX */
{ CPUFUNC(op_9148_0), 37192 }, /* SUBX */
{ CPUFUNC(op_9150_0), 37200 }, /* SUB */
{ CPUFUNC(op_9158_0), 37208 }, /* SUB */
{ CPUFUNC(op_9160_0), 37216 }, /* SUB */
{ CPUFUNC(op_9168_0), 37224 }, /* SUB */
{ CPUFUNC(op_9170_0), 37232 }, /* SUB */
{ CPUFUNC(op_9178_0), 37240 }, /* SUB */
{ CPUFUNC(op_9179_0), 37241 }, /* SUB */
{ CPUFUNC(op_9180_0), 37248 }, /* SUBX */
{ CPUFUNC(op_9188_0), 37256 }, /* SUBX */
{ CPUFUNC(op_9190_0), 37264 }, /* SUB */
{ CPUFUNC(op_9198_0), 37272 }, /* SUB */
{ CPUFUNC(op_91a0_0), 37280 }, /* SUB */
{ CPUFUNC(op_91a8_0), 37288 }, /* SUB */
{ CPUFUNC(op_91b0_0), 37296 }, /* SUB */
{ CPUFUNC(op_91b8_0), 37304 }, /* SUB */
{ CPUFUNC(op_91b9_0), 37305 }, /* SUB */
{ CPUFUNC(op_91c0_0), 37312 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 37320 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 37328 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 37336 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 37344 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 37352 }, /* SUBA */
{ CPUFUNC(op_91f0_0), 37360 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 37368 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 37369 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 37370 }, /* SUBA */
{ CPUFUNC(op_91fb_0), 37371 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 37372 }, /* SUBA */
{ CPUFUNC(op_b000_0), 45056 }, /* CMP */
{ CPUFUNC(op_b010_0), 45072 }, /* CMP */
{ CPUFUNC(op_b018_0), 45080 }, /* CMP */
{ CPUFUNC(op_b020_0), 45088 }, /* CMP */
{ CPUFUNC(op_b028_0), 45096 }, /* CMP */
{ CPUFUNC(op_b030_0), 45104 }, /* CMP */
{ CPUFUNC(op_b038_0), 45112 }, /* CMP */
{ CPUFUNC(op_b039_0), 45113 }, /* CMP */
{ CPUFUNC(op_b03a_0), 45114 }, /* CMP */
{ CPUFUNC(op_b03b_0), 45115 }, /* CMP */
{ CPUFUNC(op_b03c_0), 45116 }, /* CMP */
{ CPUFUNC(op_b040_0), 45120 }, /* CMP */
{ CPUFUNC(op_b048_0), 45128 }, /* CMP */
{ CPUFUNC(op_b050_0), 45136 }, /* CMP */
{ CPUFUNC(op_b058_0), 45144 }, /* CMP */
{ CPUFUNC(op_b060_0), 45152 }, /* CMP */
{ CPUFUNC(op_b068_0), 45160 }, /* CMP */
{ CPUFUNC(op_b070_0), 45168 }, /* CMP */
{ CPUFUNC(op_b078_0), 45176 }, /* CMP */
{ CPUFUNC(op_b079_0), 45177 }, /* CMP */
{ CPUFUNC(op_b07a_0), 45178 }, /* CMP */
{ CPUFUNC(op_b07b_0), 45179 }, /* CMP */
{ CPUFUNC(op_b07c_0), 45180 }, /* CMP */
{ CPUFUNC(op_b080_0), 45184 }, /* CMP */
{ CPUFUNC(op_b088_0), 45192 }, /* CMP */
{ CPUFUNC(op_b090_0), 45200 }, /* CMP */
{ CPUFUNC(op_b098_0), 45208 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 45216 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 45224 }, /* CMP */
{ CPUFUNC(op_b0b0_0), 45232 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 45240 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 45241 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 45242 }, /* CMP */
{ CPUFUNC(op_b0bb_0), 45243 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 45244 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 45248 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 45256 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 45264 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 45272 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 45280 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 45288 }, /* CMPA */
{ CPUFUNC(op_b0f0_0), 45296 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 45304 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 45305 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 45306 }, /* CMPA */
{ CPUFUNC(op_b0fb_0), 45307 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 45308 }, /* CMPA */
{ CPUFUNC(op_b100_0), 45312 }, /* EOR */
{ CPUFUNC(op_b108_0), 45320 }, /* CMPM */
{ CPUFUNC(op_b110_0), 45328 }, /* EOR */
{ CPUFUNC(op_b118_0), 45336 }, /* EOR */
{ CPUFUNC(op_b120_0), 45344 }, /* EOR */
{ CPUFUNC(op_b128_0), 45352 }, /* EOR */
{ CPUFUNC(op_b130_0), 45360 }, /* EOR */
{ CPUFUNC(op_b138_0), 45368 }, /* EOR */
{ CPUFUNC(op_b139_0), 45369 }, /* EOR */
{ CPUFUNC(op_b140_0), 45376 }, /* EOR */
{ CPUFUNC(op_b148_0), 45384 }, /* CMPM */
{ CPUFUNC(op_b150_0), 45392 }, /* EOR */
{ CPUFUNC(op_b158_0), 45400 }, /* EOR */
{ CPUFUNC(op_b160_0), 45408 }, /* EOR */
{ CPUFUNC(op_b168_0), 45416 }, /* EOR */
{ CPUFUNC(op_b170_0), 45424 }, /* EOR */
{ CPUFUNC(op_b178_0), 45432 }, /* EOR */
{ CPUFUNC(op_b179_0), 45433 }, /* EOR */
{ CPUFUNC(op_b180_0), 45440 }, /* EOR */
{ CPUFUNC(op_b188_0), 45448 }, /* CMPM */
{ CPUFUNC(op_b190_0), 45456 }, /* EOR */
{ CPUFUNC(op_b198_0), 45464 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 45472 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 45480 }, /* EOR */
{ CPUFUNC(op_b1b0_0), 45488 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 45496 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 45497 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 45504 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 45512 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 45520 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 45528 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 45536 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 45544 }, /* CMPA */
{ CPUFUNC(op_b1f0_0), 45552 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 45560 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 45561 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 45562 }, /* CMPA */
{ CPUFUNC(op_b1fb_0), 45563 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 45564 }, /* CMPA */
{ CPUFUNC(op_c000_0), 49152 }, /* AND */
{ CPUFUNC(op_c010_0), 49168 }, /* AND */
{ CPUFUNC(op_c018_0), 49176 }, /* AND */
{ CPUFUNC(op_c020_0), 49184 }, /* AND */
{ CPUFUNC(op_c028_0), 49192 }, /* AND */
{ CPUFUNC(op_c030_0), 49200 }, /* AND */
{ CPUFUNC(op_c038_0), 49208 }, /* AND */
{ CPUFUNC(op_c039_0), 49209 }, /* AND */
{ CPUFUNC(op_c03a_0), 49210 }, /* AND */
{ CPUFUNC(op_c03b_0), 49211 }, /* AND */
{ CPUFUNC(op_c03c_0), 49212 }, /* AND */
{ CPUFUNC(op_c040_0), 49216 }, /* AND */
{ CPUFUNC(op_c050_0), 49232 }, /* AND */
{ CPUFUNC(op_c058_0), 49240 }, /* AND */
{ CPUFUNC(op_c060_0), 49248 }, /* AND */
{ CPUFUNC(op_c068_0), 49256 }, /* AND */
{ CPUFUNC(op_c070_0), 49264 }, /* AND */
{ CPUFUNC(op_c078_0), 49272 }, /* AND */
{ CPUFUNC(op_c079_0), 49273 }, /* AND */
{ CPUFUNC(op_c07a_0), 49274 }, /* AND */
{ CPUFUNC(op_c07b_0), 49275 }, /* AND */
{ CPUFUNC(op_c07c_0), 49276 }, /* AND */
{ CPUFUNC(op_c080_0), 49280 }, /* AND */
{ CPUFUNC(op_c090_0), 49296 }, /* AND */
{ CPUFUNC(op_c098_0), 49304 }, /* AND */
{ CPUFUNC(op_c0a0_0), 49312 }, /* AND */
{ CPUFUNC(op_c0a8_0), 49320 }, /* AND */
{ CPUFUNC(op_c0b0_0), 49328 }, /* AND */
{ CPUFUNC(op_c0b8_0), 49336 }, /* AND */
{ CPUFUNC(op_c0b9_0), 49337 }, /* AND */
{ CPUFUNC(op_c0ba_0), 49338 }, /* AND */
{ CPUFUNC(op_c0bb_0), 49339 }, /* AND */
{ CPUFUNC(op_c0bc_0), 49340 }, /* AND */
{ CPUFUNC(op_c0c0_0), 49344 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 49360 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 49368 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 49376 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 49384 }, /* MULU */
{ CPUFUNC(op_c0f0_0), 49392 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 49400 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 49401 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 49402 }, /* MULU */
{ CPUFUNC(op_c0fb_0), 49403 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 49404 }, /* MULU */
{ CPUFUNC(op_c100_2), 49408 }, /* ABCD */
{ CPUFUNC(op_c108_2), 49416 }, /* ABCD */
{ CPUFUNC(op_c110_0), 49424 }, /* AND */
{ CPUFUNC(op_c118_0), 49432 }, /* AND */
{ CPUFUNC(op_c120_0), 49440 }, /* AND */
{ CPUFUNC(op_c128_0), 49448 }, /* AND */
{ CPUFUNC(op_c130_0), 49456 }, /* AND */
{ CPUFUNC(op_c138_0), 49464 }, /* AND */
{ CPUFUNC(op_c139_0), 49465 }, /* AND */
{ CPUFUNC(op_c140_0), 49472 }, /* EXG */
{ CPUFUNC(op_c148_0), 49480 }, /* EXG */
{ CPUFUNC(op_c150_0), 49488 }, /* AND */
{ CPUFUNC(op_c158_0), 49496 }, /* AND */
{ CPUFUNC(op_c160_0), 49504 }, /* AND */
{ CPUFUNC(op_c168_0), 49512 }, /* AND */
{ CPUFUNC(op_c170_0), 49520 }, /* AND */
{ CPUFUNC(op_c178_0), 49528 }, /* AND */
{ CPUFUNC(op_c179_0), 49529 }, /* AND */
{ CPUFUNC(op_c188_0), 49544 }, /* EXG */
{ CPUFUNC(op_c190_0), 49552 }, /* AND */
{ CPUFUNC(op_c198_0), 49560 }, /* AND */
{ CPUFUNC(op_c1a0_0), 49568 }, /* AND */
{ CPUFUNC(op_c1a8_0), 49576 }, /* AND */
{ CPUFUNC(op_c1b0_0), 49584 }, /* AND */
{ CPUFUNC(op_c1b8_0), 49592 }, /* AND */
{ CPUFUNC(op_c1b9_0), 49593 }, /* AND */
{ CPUFUNC(op_c1c0_0), 49600 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 49616 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 49624 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 49632 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 49640 }, /* MULS */
{ CPUFUNC(op_c1f0_0), 49648 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 49656 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 49657 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 49658 }, /* MULS */
{ CPUFUNC(op_c1fb_0), 49659 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 49660 }, /* MULS */
{ CPUFUNC(op_d000_0), 53248 }, /* ADD */
{ CPUFUNC(op_d010_0), 53264 }, /* ADD */
{ CPUFUNC(op_d018_0), 53272 }, /* ADD */
{ CPUFUNC(op_d020_0), 53280 }, /* ADD */
{ CPUFUNC(op_d028_0), 53288 }, /* ADD */
{ CPUFUNC(op_d030_0), 53296 }, /* ADD */
{ CPUFUNC(op_d038_0), 53304 }, /* ADD */
{ CPUFUNC(op_d039_0), 53305 }, /* ADD */
{ CPUFUNC(op_d03a_0), 53306 }, /* ADD */
{ CPUFUNC(op_d03b_0), 53307 }, /* ADD */
{ CPUFUNC(op_d03c_0), 53308 }, /* ADD */
{ CPUFUNC(op_d040_0), 53312 }, /* ADD */
{ CPUFUNC(op_d048_0), 53320 }, /* ADD */
{ CPUFUNC(op_d050_0), 53328 }, /* ADD */
{ CPUFUNC(op_d058_0), 53336 }, /* ADD */
{ CPUFUNC(op_d060_0), 53344 }, /* ADD */
{ CPUFUNC(op_d068_0), 53352 }, /* ADD */
{ CPUFUNC(op_d070_0), 53360 }, /* ADD */
{ CPUFUNC(op_d078_0), 53368 }, /* ADD */
{ CPUFUNC(op_d079_0), 53369 }, /* ADD */
{ CPUFUNC(op_d07a_0), 53370 }, /* ADD */
{ CPUFUNC(op_d07b_0), 53371 }, /* ADD */
{ CPUFUNC(op_d07c_0), 53372 }, /* ADD */
{ CPUFUNC(op_d080_0), 53376 }, /* ADD */
{ CPUFUNC(op_d088_0), 53384 }, /* ADD */
{ CPUFUNC(op_d090_0), 53392 }, /* ADD */
{ CPUFUNC(op_d098_0), 53400 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 53408 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 53416 }, /* ADD */
{ CPUFUNC(op_d0b0_0), 53424 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 53432 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 53433 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 53434 }, /* ADD */
{ CPUFUNC(op_d0bb_0), 53435 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 53436 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 53440 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 53448 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 53456 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 53464 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 53472 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 53480 }, /* ADDA */
{ CPUFUNC(op_d0f0_0), 53488 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 53496 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 53497 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 53498 }, /* ADDA */
{ CPUFUNC(op_d0fb_0), 53499 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 53500 }, /* ADDA */
{ CPUFUNC(op_d100_0), 53504 }, /* ADDX */
{ CPUFUNC(op_d108_0), 53512 }, /* ADDX */
{ CPUFUNC(op_d110_0), 53520 }, /* ADD */
{ CPUFUNC(op_d118_0), 53528 }, /* ADD */
{ CPUFUNC(op_d120_0), 53536 }, /* ADD */
{ CPUFUNC(op_d128_0), 53544 }, /* ADD */
{ CPUFUNC(op_d130_0), 53552 }, /* ADD */
{ CPUFUNC(op_d138_0), 53560 }, /* ADD */
{ CPUFUNC(op_d139_0), 53561 }, /* ADD */
{ CPUFUNC(op_d140_0), 53568 }, /* ADDX */
{ CPUFUNC(op_d148_0), 53576 }, /* ADDX */
{ CPUFUNC(op_d150_0), 53584 }, /* ADD */
{ CPUFUNC(op_d158_0), 53592 }, /* ADD */
{ CPUFUNC(op_d160_0), 53600 }, /* ADD */
{ CPUFUNC(op_d168_0), 53608 }, /* ADD */
{ CPUFUNC(op_d170_0), 53616 }, /* ADD */
{ CPUFUNC(op_d178_0), 53624 }, /* ADD */
{ CPUFUNC(op_d179_0), 53625 }, /* ADD */
{ CPUFUNC(op_d180_0), 53632 }, /* ADDX */
{ CPUFUNC(op_d188_0), 53640 }, /* ADDX */
{ CPUFUNC(op_d190_0), 53648 }, /* ADD */
{ CPUFUNC(op_d198_0), 53656 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 53664 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 53672 }, /* ADD */
{ CPUFUNC(op_d1b0_0), 53680 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 53688 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 53689 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 53696 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 53704 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 53712 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 53720 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 53728 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 53736 }, /* ADDA */
{ CPUFUNC(op_d1f0_0), 53744 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 53752 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 53753 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 53754 }, /* ADDA */
{ CPUFUNC(op_d1fb_0), 53755 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 53756 }, /* ADDA */
{ CPUFUNC(op_e000_0), 57344 }, /* ASR */
{ CPUFUNC(op_e008_0), 57352 }, /* LSR */
{ CPUFUNC(op_e010_0), 57360 }, /* ROXR */
{ CPUFUNC(op_e018_0), 57368 }, /* ROR */
{ CPUFUNC(op_e020_0), 57376 }, /* ASR */
{ CPUFUNC(op_e028_0), 57384 }, /* LSR */
{ CPUFUNC(op_e030_0), 57392 }, /* ROXR */
{ CPUFUNC(op_e038_0), 57400 }, /* ROR */
{ CPUFUNC(op_e040_0), 57408 }, /* ASR */
{ CPUFUNC(op_e048_0), 57416 }, /* LSR */
{ CPUFUNC(op_e050_0), 57424 }, /* ROXR */
{ CPUFUNC(op_e058_0), 57432 }, /* ROR */
{ CPUFUNC(op_e060_0), 57440 }, /* ASR */
{ CPUFUNC(op_e068_0), 57448 }, /* LSR */
{ CPUFUNC(op_e070_0), 57456 }, /* ROXR */
{ CPUFUNC(op_e078_0), 57464 }, /* ROR */
{ CPUFUNC(op_e080_0), 57472 }, /* ASR */
{ CPUFUNC(op_e088_0), 57480 }, /* LSR */
{ CPUFUNC(op_e090_0), 57488 }, /* ROXR */
{ CPUFUNC(op_e098_0), 57496 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 57504 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 57512 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 57520 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 57528 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 57552 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 57560 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 57568 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 57576 }, /* ASRW */
{ CPUFUNC(op_e0f0_0), 57584 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 57592 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 57593 }, /* ASRW */
{ CPUFUNC(op_e100_0), 57600 }, /* ASL */
{ CPUFUNC(op_e108_0), 57608 }, /* LSL */
{ CPUFUNC(op_e110_0), 57616 }, /* ROXL */
{ CPUFUNC(op_e118_0), 57624 }, /* ROL */
{ CPUFUNC(op_e120_0), 57632 }, /* ASL */
{ CPUFUNC(op_e128_0), 57640 }, /* LSL */
{ CPUFUNC(op_e130_0), 57648 }, /* ROXL */
{ CPUFUNC(op_e138_0), 57656 }, /* ROL */
{ CPUFUNC(op_e140_0), 57664 }, /* ASL */
{ CPUFUNC(op_e148_0), 57672 }, /* LSL */
{ CPUFUNC(op_e150_0), 57680 }, /* ROXL */
{ CPUFUNC(op_e158_0), 57688 }, /* ROL */
{ CPUFUNC(op_e160_0), 57696 }, /* ASL */
{ CPUFUNC(op_e168_0), 57704 }, /* LSL */
{ CPUFUNC(op_e170_0), 57712 }, /* ROXL */
{ CPUFUNC(op_e178_0), 57720 }, /* ROL */
{ CPUFUNC(op_e180_0), 57728 }, /* ASL */
{ CPUFUNC(op_e188_0), 57736 }, /* LSL */
{ CPUFUNC(op_e190_0), 57744 }, /* ROXL */
{ CPUFUNC(op_e198_0), 57752 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 57760 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 57768 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 57776 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 57784 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 57808 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 57816 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 57824 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 57832 }, /* ASLW */
{ CPUFUNC(op_e1f0_0), 57840 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 57848 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 57849 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 58064 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 58072 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 58080 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 58088 }, /* LSRW */
{ CPUFUNC(op_e2f0_0), 58096 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 58104 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 58105 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 58320 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 58328 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 58336 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 58344 }, /* LSLW */
{ CPUFUNC(op_e3f0_0), 58352 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 58360 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 58361 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 58576 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 58584 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 58592 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 58600 }, /* ROXRW */
{ CPUFUNC(op_e4f0_0), 58608 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 58616 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 58617 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 58832 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 58840 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 58848 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 58856 }, /* ROXLW */
{ CPUFUNC(op_e5f0_0), 58864 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 58872 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 58873 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 59088 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 59096 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 59104 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 59112 }, /* RORW */
{ CPUFUNC(op_e6f0_0), 59120 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 59128 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 59129 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 59344 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 59352 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 59360 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 59368 }, /* ROLW */
{ CPUFUNC(op_e7f0_0), 59376 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 59384 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 59385 }, /* ROLW */
{ CPUFUNC(op_e8c0_0), 59584 }, /* BFTST */
{ CPUFUNC(op_e8d0_0), 59600 }, /* BFTST */
{ CPUFUNC(op_e8e8_0), 59624 }, /* BFTST */
{ CPUFUNC(op_e8f0_0), 59632 }, /* BFTST */
{ CPUFUNC(op_e8f8_0), 59640 }, /* BFTST */
{ CPUFUNC(op_e8f9_0), 59641 }, /* BFTST */
{ CPUFUNC(op_e8fa_0), 59642 }, /* BFTST */
{ CPUFUNC(op_e8fb_0), 59643 }, /* BFTST */
{ CPUFUNC(op_e9c0_0), 59840 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_0), 59856 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_0), 59880 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_0), 59888 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_0), 59896 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_0), 59897 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_0), 59898 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_0), 59899 }, /* BFEXTU */
{ CPUFUNC(op_eac0_0), 60096 }, /* BFCHG */
{ CPUFUNC(op_ead0_0), 60112 }, /* BFCHG */
{ CPUFUNC(op_eae8_0), 60136 }, /* BFCHG */
{ CPUFUNC(op_eaf0_0), 60144 }, /* BFCHG */
{ CPUFUNC(op_eaf8_0), 60152 }, /* BFCHG */
{ CPUFUNC(op_eaf9_0), 60153 }, /* BFCHG */
{ CPUFUNC(op_ebc0_0), 60352 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_0), 60368 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_0), 60392 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_0), 60400 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_0), 60408 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_0), 60409 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_0), 60410 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_0), 60411 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_0), 60608 }, /* BFCLR */
{ CPUFUNC(op_ecd0_0), 60624 }, /* BFCLR */
{ CPUFUNC(op_ece8_0), 60648 }, /* BFCLR */
{ CPUFUNC(op_ecf0_0), 60656 }, /* BFCLR */
{ CPUFUNC(op_ecf8_0), 60664 }, /* BFCLR */
{ CPUFUNC(op_ecf9_0), 60665 }, /* BFCLR */
{ CPUFUNC(op_edc0_0), 60864 }, /* BFFFO */
{ CPUFUNC(op_edd0_0), 60880 }, /* BFFFO */
{ CPUFUNC(op_ede8_0), 60904 }, /* BFFFO */
{ CPUFUNC(op_edf0_0), 60912 }, /* BFFFO */
{ CPUFUNC(op_edf8_0), 60920 }, /* BFFFO */
{ CPUFUNC(op_edf9_0), 60921 }, /* BFFFO */
{ CPUFUNC(op_edfa_0), 60922 }, /* BFFFO */
{ CPUFUNC(op_edfb_0), 60923 }, /* BFFFO */
{ CPUFUNC(op_eec0_0), 61120 }, /* BFSET */
{ CPUFUNC(op_eed0_0), 61136 }, /* BFSET */
{ CPUFUNC(op_eee8_0), 61160 }, /* BFSET */
{ CPUFUNC(op_eef0_0), 61168 }, /* BFSET */
{ CPUFUNC(op_eef8_0), 61176 }, /* BFSET */
{ CPUFUNC(op_eef9_0), 61177 }, /* BFSET */
{ CPUFUNC(op_efc0_0), 61376 }, /* BFINS */
{ CPUFUNC(op_efd0_0), 61392 }, /* BFINS */
{ CPUFUNC(op_efe8_0), 61416 }, /* BFINS */
{ CPUFUNC(op_eff0_0), 61424 }, /* BFINS */
{ CPUFUNC(op_eff8_0), 61432 }, /* BFINS */
{ CPUFUNC(op_eff9_0), 61433 }, /* BFINS */
{ CPUFUNC(op_f010_0), 61456 }, /* MMUOP030 */
{ CPUFUNC(op_f028_0), 61480 }, /* MMUOP030 */
{ CPUFUNC(op_f030_0), 61488 }, /* MMUOP030 */
{ CPUFUNC(op_f038_0), 61496 }, /* MMUOP030 */
{ CPUFUNC(op_f039_0), 61497 }, /* MMUOP030 */
{ CPUFUNC(op_f200_0), 61952 }, /* FPP */
{ CPUFUNC(op_f208_0), 61960 }, /* FPP */
{ CPUFUNC(op_f210_0), 61968 }, /* FPP */
{ CPUFUNC(op_f218_0), 61976 }, /* FPP */
{ CPUFUNC(op_f220_0), 61984 }, /* FPP */
{ CPUFUNC(op_f228_0), 61992 }, /* FPP */
{ CPUFUNC(op_f230_0), 62000 }, /* FPP */
{ CPUFUNC(op_f238_0), 62008 }, /* FPP */
{ CPUFUNC(op_f239_0), 62009 }, /* FPP */
{ CPUFUNC(op_f23a_0), 62010 }, /* FPP */
{ CPUFUNC(op_f23b_0), 62011 }, /* FPP */
{ CPUFUNC(op_f23c_0), 62012 }, /* FPP */
{ CPUFUNC(op_f240_0), 62016 }, /* FScc */
{ CPUFUNC(op_f248_0), 62024 }, /* FDBcc */
{ CPUFUNC(op_f250_0), 62032 }, /* FScc */
{ CPUFUNC(op_f258_0), 62040 }, /* FScc */
{ CPUFUNC(op_f260_0), 62048 }, /* FScc */
{ CPUFUNC(op_f268_0), 62056 }, /* FScc */
{ CPUFUNC(op_f270_0), 62064 }, /* FScc */
{ CPUFUNC(op_f278_0), 62072 }, /* FScc */
{ CPUFUNC(op_f279_0), 62073 }, /* FScc */
{ CPUFUNC(op_f27a_0), 62074 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_0), 62075 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_0), 62076 }, /* FTRAPcc */
{ CPUFUNC(op_f280_0), 62080 }, /* FBcc */
{ CPUFUNC(op_f2c0_0), 62144 }, /* FBcc */
{ CPUFUNC(op_f310_0), 62224 }, /* FSAVE */
{ CPUFUNC(op_f320_0), 62240 }, /* FSAVE */
{ CPUFUNC(op_f328_0), 62248 }, /* FSAVE */
{ CPUFUNC(op_f330_0), 62256 }, /* FSAVE */
{ CPUFUNC(op_f338_0), 62264 }, /* FSAVE */
{ CPUFUNC(op_f339_0), 62265 }, /* FSAVE */
{ CPUFUNC(op_f350_0), 62288 }, /* FRESTORE */
{ CPUFUNC(op_f358_0), 62296 }, /* FRESTORE */
{ CPUFUNC(op_f368_0), 62312 }, /* FRESTORE */
{ CPUFUNC(op_f370_0), 62320 }, /* FRESTORE */
{ CPUFUNC(op_f378_0), 62328 }, /* FRESTORE */
{ CPUFUNC(op_f379_0), 62329 }, /* FRESTORE */
{ CPUFUNC(op_f37a_0), 62330 }, /* FRESTORE */
{ CPUFUNC(op_f37b_0), 62331 }, /* FRESTORE */
{ 0, 0 }};
const struct cputbl CPUFUNC(op_smalltbl_3)[] = {
{ CPUFUNC(op_0000_0), 0 }, /* OR */
{ CPUFUNC(op_0010_0), 16 }, /* OR */
{ CPUFUNC(op_0018_0), 24 }, /* OR */
{ CPUFUNC(op_0020_0), 32 }, /* OR */
{ CPUFUNC(op_0028_0), 40 }, /* OR */
{ CPUFUNC(op_0030_0), 48 }, /* OR */
{ CPUFUNC(op_0038_0), 56 }, /* OR */
{ CPUFUNC(op_0039_0), 57 }, /* OR */
{ CPUFUNC(op_003c_0), 60 }, /* ORSR */
{ CPUFUNC(op_0040_0), 64 }, /* OR */
{ CPUFUNC(op_0050_0), 80 }, /* OR */
{ CPUFUNC(op_0058_0), 88 }, /* OR */
{ CPUFUNC(op_0060_0), 96 }, /* OR */
{ CPUFUNC(op_0068_0), 104 }, /* OR */
{ CPUFUNC(op_0070_0), 112 }, /* OR */
{ CPUFUNC(op_0078_0), 120 }, /* OR */
{ CPUFUNC(op_0079_0), 121 }, /* OR */
{ CPUFUNC(op_007c_0), 124 }, /* ORSR */
{ CPUFUNC(op_0080_0), 128 }, /* OR */
{ CPUFUNC(op_0090_0), 144 }, /* OR */
{ CPUFUNC(op_0098_0), 152 }, /* OR */
{ CPUFUNC(op_00a0_0), 160 }, /* OR */
{ CPUFUNC(op_00a8_0), 168 }, /* OR */
{ CPUFUNC(op_00b0_0), 176 }, /* OR */
{ CPUFUNC(op_00b8_0), 184 }, /* OR */
{ CPUFUNC(op_00b9_0), 185 }, /* OR */
{ CPUFUNC(op_00d0_0), 208 }, /* CHK2 */
{ CPUFUNC(op_00e8_0), 232 }, /* CHK2 */
{ CPUFUNC(op_00f0_0), 240 }, /* CHK2 */
{ CPUFUNC(op_00f8_0), 248 }, /* CHK2 */
{ CPUFUNC(op_00f9_0), 249 }, /* CHK2 */
{ CPUFUNC(op_00fa_0), 250 }, /* CHK2 */
{ CPUFUNC(op_00fb_0), 251 }, /* CHK2 */
{ CPUFUNC(op_0100_0), 256 }, /* BTST */
{ CPUFUNC(op_0108_0), 264 }, /* MVPMR */
{ CPUFUNC(op_0110_0), 272 }, /* BTST */
{ CPUFUNC(op_0118_0), 280 }, /* BTST */
{ CPUFUNC(op_0120_0), 288 }, /* BTST */
{ CPUFUNC(op_0128_0), 296 }, /* BTST */
{ CPUFUNC(op_0130_0), 304 }, /* BTST */
{ CPUFUNC(op_0138_0), 312 }, /* BTST */
{ CPUFUNC(op_0139_0), 313 }, /* BTST */
{ CPUFUNC(op_013a_0), 314 }, /* BTST */
{ CPUFUNC(op_013b_0), 315 }, /* BTST */
{ CPUFUNC(op_013c_0), 316 }, /* BTST */
{ CPUFUNC(op_0140_0), 320 }, /* BCHG */
{ CPUFUNC(op_0148_0), 328 }, /* MVPMR */
{ CPUFUNC(op_0150_0), 336 }, /* BCHG */
{ CPUFUNC(op_0158_0), 344 }, /* BCHG */
{ CPUFUNC(op_0160_0), 352 }, /* BCHG */
{ CPUFUNC(op_0168_0), 360 }, /* BCHG */
{ CPUFUNC(op_0170_0), 368 }, /* BCHG */
{ CPUFUNC(op_0178_0), 376 }, /* BCHG */
{ CPUFUNC(op_0179_0), 377 }, /* BCHG */
{ CPUFUNC(op_0180_0), 384 }, /* BCLR */
{ CPUFUNC(op_0188_0), 392 }, /* MVPRM */
{ CPUFUNC(op_0190_0), 400 }, /* BCLR */
{ CPUFUNC(op_0198_0), 408 }, /* BCLR */
{ CPUFUNC(op_01a0_0), 416 }, /* BCLR */
{ CPUFUNC(op_01a8_0), 424 }, /* BCLR */
{ CPUFUNC(op_01b0_0), 432 }, /* BCLR */
{ CPUFUNC(op_01b8_0), 440 }, /* BCLR */
{ CPUFUNC(op_01b9_0), 441 }, /* BCLR */
{ CPUFUNC(op_01c0_0), 448 }, /* BSET */
{ CPUFUNC(op_01c8_0), 456 }, /* MVPRM */
{ CPUFUNC(op_01d0_0), 464 }, /* BSET */
{ CPUFUNC(op_01d8_0), 472 }, /* BSET */
{ CPUFUNC(op_01e0_0), 480 }, /* BSET */
{ CPUFUNC(op_01e8_0), 488 }, /* BSET */
{ CPUFUNC(op_01f0_0), 496 }, /* BSET */
{ CPUFUNC(op_01f8_0), 504 }, /* BSET */
{ CPUFUNC(op_01f9_0), 505 }, /* BSET */
{ CPUFUNC(op_0200_0), 512 }, /* AND */
{ CPUFUNC(op_0210_0), 528 }, /* AND */
{ CPUFUNC(op_0218_0), 536 }, /* AND */
{ CPUFUNC(op_0220_0), 544 }, /* AND */
{ CPUFUNC(op_0228_0), 552 }, /* AND */
{ CPUFUNC(op_0230_0), 560 }, /* AND */
{ CPUFUNC(op_0238_0), 568 }, /* AND */
{ CPUFUNC(op_0239_0), 569 }, /* AND */
{ CPUFUNC(op_023c_0), 572 }, /* ANDSR */
{ CPUFUNC(op_0240_0), 576 }, /* AND */
{ CPUFUNC(op_0250_0), 592 }, /* AND */
{ CPUFUNC(op_0258_0), 600 }, /* AND */
{ CPUFUNC(op_0260_0), 608 }, /* AND */
{ CPUFUNC(op_0268_0), 616 }, /* AND */
{ CPUFUNC(op_0270_0), 624 }, /* AND */
{ CPUFUNC(op_0278_0), 632 }, /* AND */
{ CPUFUNC(op_0279_0), 633 }, /* AND */
{ CPUFUNC(op_027c_0), 636 }, /* ANDSR */
{ CPUFUNC(op_0280_0), 640 }, /* AND */
{ CPUFUNC(op_0290_0), 656 }, /* AND */
{ CPUFUNC(op_0298_0), 664 }, /* AND */
{ CPUFUNC(op_02a0_0), 672 }, /* AND */
{ CPUFUNC(op_02a8_0), 680 }, /* AND */
{ CPUFUNC(op_02b0_0), 688 }, /* AND */
{ CPUFUNC(op_02b8_0), 696 }, /* AND */
{ CPUFUNC(op_02b9_0), 697 }, /* AND */
{ CPUFUNC(op_02d0_0), 720 }, /* CHK2 */
{ CPUFUNC(op_02e8_0), 744 }, /* CHK2 */
{ CPUFUNC(op_02f0_0), 752 }, /* CHK2 */
{ CPUFUNC(op_02f8_0), 760 }, /* CHK2 */
{ CPUFUNC(op_02f9_0), 761 }, /* CHK2 */
{ CPUFUNC(op_02fa_0), 762 }, /* CHK2 */
{ CPUFUNC(op_02fb_0), 763 }, /* CHK2 */
{ CPUFUNC(op_0400_0), 1024 }, /* SUB */
{ CPUFUNC(op_0410_0), 1040 }, /* SUB */
{ CPUFUNC(op_0418_0), 1048 }, /* SUB */
{ CPUFUNC(op_0420_0), 1056 }, /* SUB */
{ CPUFUNC(op_0428_0), 1064 }, /* SUB */
{ CPUFUNC(op_0430_0), 1072 }, /* SUB */
{ CPUFUNC(op_0438_0), 1080 }, /* SUB */
{ CPUFUNC(op_0439_0), 1081 }, /* SUB */
{ CPUFUNC(op_0440_0), 1088 }, /* SUB */
{ CPUFUNC(op_0450_0), 1104 }, /* SUB */
{ CPUFUNC(op_0458_0), 1112 }, /* SUB */
{ CPUFUNC(op_0460_0), 1120 }, /* SUB */
{ CPUFUNC(op_0468_0), 1128 }, /* SUB */
{ CPUFUNC(op_0470_0), 1136 }, /* SUB */
{ CPUFUNC(op_0478_0), 1144 }, /* SUB */
{ CPUFUNC(op_0479_0), 1145 }, /* SUB */
{ CPUFUNC(op_0480_0), 1152 }, /* SUB */
{ CPUFUNC(op_0490_0), 1168 }, /* SUB */
{ CPUFUNC(op_0498_0), 1176 }, /* SUB */
{ CPUFUNC(op_04a0_0), 1184 }, /* SUB */
{ CPUFUNC(op_04a8_0), 1192 }, /* SUB */
{ CPUFUNC(op_04b0_0), 1200 }, /* SUB */
{ CPUFUNC(op_04b8_0), 1208 }, /* SUB */
{ CPUFUNC(op_04b9_0), 1209 }, /* SUB */
{ CPUFUNC(op_04d0_0), 1232 }, /* CHK2 */
{ CPUFUNC(op_04e8_0), 1256 }, /* CHK2 */
{ CPUFUNC(op_04f0_0), 1264 }, /* CHK2 */
{ CPUFUNC(op_04f8_0), 1272 }, /* CHK2 */
{ CPUFUNC(op_04f9_0), 1273 }, /* CHK2 */
{ CPUFUNC(op_04fa_0), 1274 }, /* CHK2 */
{ CPUFUNC(op_04fb_0), 1275 }, /* CHK2 */
{ CPUFUNC(op_0600_0), 1536 }, /* ADD */
{ CPUFUNC(op_0610_0), 1552 }, /* ADD */
{ CPUFUNC(op_0618_0), 1560 }, /* ADD */
{ CPUFUNC(op_0620_0), 1568 }, /* ADD */
{ CPUFUNC(op_0628_0), 1576 }, /* ADD */
{ CPUFUNC(op_0630_0), 1584 }, /* ADD */
{ CPUFUNC(op_0638_0), 1592 }, /* ADD */
{ CPUFUNC(op_0639_0), 1593 }, /* ADD */
{ CPUFUNC(op_0640_0), 1600 }, /* ADD */
{ CPUFUNC(op_0650_0), 1616 }, /* ADD */
{ CPUFUNC(op_0658_0), 1624 }, /* ADD */
{ CPUFUNC(op_0660_0), 1632 }, /* ADD */
{ CPUFUNC(op_0668_0), 1640 }, /* ADD */
{ CPUFUNC(op_0670_0), 1648 }, /* ADD */
{ CPUFUNC(op_0678_0), 1656 }, /* ADD */
{ CPUFUNC(op_0679_0), 1657 }, /* ADD */
{ CPUFUNC(op_0680_0), 1664 }, /* ADD */
{ CPUFUNC(op_0690_0), 1680 }, /* ADD */
{ CPUFUNC(op_0698_0), 1688 }, /* ADD */
{ CPUFUNC(op_06a0_0), 1696 }, /* ADD */
{ CPUFUNC(op_06a8_0), 1704 }, /* ADD */
{ CPUFUNC(op_06b0_0), 1712 }, /* ADD */
{ CPUFUNC(op_06b8_0), 1720 }, /* ADD */
{ CPUFUNC(op_06b9_0), 1721 }, /* ADD */
{ CPUFUNC(op_06c0_0), 1728 }, /* RTM */
{ CPUFUNC(op_06c8_0), 1736 }, /* RTM */
{ CPUFUNC(op_06d0_0), 1744 }, /* CALLM */
{ CPUFUNC(op_06e8_0), 1768 }, /* CALLM */
{ CPUFUNC(op_06f0_0), 1776 }, /* CALLM */
{ CPUFUNC(op_06f8_0), 1784 }, /* CALLM */
{ CPUFUNC(op_06f9_0), 1785 }, /* CALLM */
{ CPUFUNC(op_06fa_0), 1786 }, /* CALLM */
{ CPUFUNC(op_06fb_0), 1787 }, /* CALLM */
{ CPUFUNC(op_0800_0), 2048 }, /* BTST */
{ CPUFUNC(op_0810_0), 2064 }, /* BTST */
{ CPUFUNC(op_0818_0), 2072 }, /* BTST */
{ CPUFUNC(op_0820_0), 2080 }, /* BTST */
{ CPUFUNC(op_0828_0), 2088 }, /* BTST */
{ CPUFUNC(op_0830_0), 2096 }, /* BTST */
{ CPUFUNC(op_0838_0), 2104 }, /* BTST */
{ CPUFUNC(op_0839_0), 2105 }, /* BTST */
{ CPUFUNC(op_083a_0), 2106 }, /* BTST */
{ CPUFUNC(op_083b_0), 2107 }, /* BTST */
{ CPUFUNC(op_083c_0), 2108 }, /* BTST */
{ CPUFUNC(op_0840_0), 2112 }, /* BCHG */
{ CPUFUNC(op_0850_0), 2128 }, /* BCHG */
{ CPUFUNC(op_0858_0), 2136 }, /* BCHG */
{ CPUFUNC(op_0860_0), 2144 }, /* BCHG */
{ CPUFUNC(op_0868_0), 2152 }, /* BCHG */
{ CPUFUNC(op_0870_0), 2160 }, /* BCHG */
{ CPUFUNC(op_0878_0), 2168 }, /* BCHG */
{ CPUFUNC(op_0879_0), 2169 }, /* BCHG */
{ CPUFUNC(op_0880_0), 2176 }, /* BCLR */
{ CPUFUNC(op_0890_0), 2192 }, /* BCLR */
{ CPUFUNC(op_0898_0), 2200 }, /* BCLR */
{ CPUFUNC(op_08a0_0), 2208 }, /* BCLR */
{ CPUFUNC(op_08a8_0), 2216 }, /* BCLR */
{ CPUFUNC(op_08b0_0), 2224 }, /* BCLR */
{ CPUFUNC(op_08b8_0), 2232 }, /* BCLR */
{ CPUFUNC(op_08b9_0), 2233 }, /* BCLR */
{ CPUFUNC(op_08c0_0), 2240 }, /* BSET */
{ CPUFUNC(op_08d0_0), 2256 }, /* BSET */
{ CPUFUNC(op_08d8_0), 2264 }, /* BSET */
{ CPUFUNC(op_08e0_0), 2272 }, /* BSET */
{ CPUFUNC(op_08e8_0), 2280 }, /* BSET */
{ CPUFUNC(op_08f0_0), 2288 }, /* BSET */
{ CPUFUNC(op_08f8_0), 2296 }, /* BSET */
{ CPUFUNC(op_08f9_0), 2297 }, /* BSET */
{ CPUFUNC(op_0a00_0), 2560 }, /* EOR */
{ CPUFUNC(op_0a10_0), 2576 }, /* EOR */
{ CPUFUNC(op_0a18_0), 2584 }, /* EOR */
{ CPUFUNC(op_0a20_0), 2592 }, /* EOR */
{ CPUFUNC(op_0a28_0), 2600 }, /* EOR */
{ CPUFUNC(op_0a30_0), 2608 }, /* EOR */
{ CPUFUNC(op_0a38_0), 2616 }, /* EOR */
{ CPUFUNC(op_0a39_0), 2617 }, /* EOR */
{ CPUFUNC(op_0a3c_0), 2620 }, /* EORSR */
{ CPUFUNC(op_0a40_0), 2624 }, /* EOR */
{ CPUFUNC(op_0a50_0), 2640 }, /* EOR */
{ CPUFUNC(op_0a58_0), 2648 }, /* EOR */
{ CPUFUNC(op_0a60_0), 2656 }, /* EOR */
{ CPUFUNC(op_0a68_0), 2664 }, /* EOR */
{ CPUFUNC(op_0a70_0), 2672 }, /* EOR */
{ CPUFUNC(op_0a78_0), 2680 }, /* EOR */
{ CPUFUNC(op_0a79_0), 2681 }, /* EOR */
{ CPUFUNC(op_0a7c_0), 2684 }, /* EORSR */
{ CPUFUNC(op_0a80_0), 2688 }, /* EOR */
{ CPUFUNC(op_0a90_0), 2704 }, /* EOR */
{ CPUFUNC(op_0a98_0), 2712 }, /* EOR */
{ CPUFUNC(op_0aa0_0), 2720 }, /* EOR */
{ CPUFUNC(op_0aa8_0), 2728 }, /* EOR */
{ CPUFUNC(op_0ab0_0), 2736 }, /* EOR */
{ CPUFUNC(op_0ab8_0), 2744 }, /* EOR */
{ CPUFUNC(op_0ab9_0), 2745 }, /* EOR */
{ CPUFUNC(op_0ad0_0), 2768 }, /* CAS */
{ CPUFUNC(op_0ad8_0), 2776 }, /* CAS */
{ CPUFUNC(op_0ae0_0), 2784 }, /* CAS */
{ CPUFUNC(op_0ae8_0), 2792 }, /* CAS */
{ CPUFUNC(op_0af0_0), 2800 }, /* CAS */
{ CPUFUNC(op_0af8_0), 2808 }, /* CAS */
{ CPUFUNC(op_0af9_0), 2809 }, /* CAS */
{ CPUFUNC(op_0c00_0), 3072 }, /* CMP */
{ CPUFUNC(op_0c10_0), 3088 }, /* CMP */
{ CPUFUNC(op_0c18_0), 3096 }, /* CMP */
{ CPUFUNC(op_0c20_0), 3104 }, /* CMP */
{ CPUFUNC(op_0c28_0), 3112 }, /* CMP */
{ CPUFUNC(op_0c30_0), 3120 }, /* CMP */
{ CPUFUNC(op_0c38_0), 3128 }, /* CMP */
{ CPUFUNC(op_0c39_0), 3129 }, /* CMP */
{ CPUFUNC(op_0c3a_0), 3130 }, /* CMP */
{ CPUFUNC(op_0c3b_0), 3131 }, /* CMP */
{ CPUFUNC(op_0c40_0), 3136 }, /* CMP */
{ CPUFUNC(op_0c50_0), 3152 }, /* CMP */
{ CPUFUNC(op_0c58_0), 3160 }, /* CMP */
{ CPUFUNC(op_0c60_0), 3168 }, /* CMP */
{ CPUFUNC(op_0c68_0), 3176 }, /* CMP */
{ CPUFUNC(op_0c70_0), 3184 }, /* CMP */
{ CPUFUNC(op_0c78_0), 3192 }, /* CMP */
{ CPUFUNC(op_0c79_0), 3193 }, /* CMP */
{ CPUFUNC(op_0c7a_0), 3194 }, /* CMP */
{ CPUFUNC(op_0c7b_0), 3195 }, /* CMP */
{ CPUFUNC(op_0c80_0), 3200 }, /* CMP */
{ CPUFUNC(op_0c90_0), 3216 }, /* CMP */
{ CPUFUNC(op_0c98_0), 3224 }, /* CMP */
{ CPUFUNC(op_0ca0_0), 3232 }, /* CMP */
{ CPUFUNC(op_0ca8_0), 3240 }, /* CMP */
{ CPUFUNC(op_0cb0_0), 3248 }, /* CMP */
{ CPUFUNC(op_0cb8_0), 3256 }, /* CMP */
{ CPUFUNC(op_0cb9_0), 3257 }, /* CMP */
{ CPUFUNC(op_0cba_0), 3258 }, /* CMP */
{ CPUFUNC(op_0cbb_0), 3259 }, /* CMP */
{ CPUFUNC(op_0cd0_0), 3280 }, /* CAS */
{ CPUFUNC(op_0cd8_0), 3288 }, /* CAS */
{ CPUFUNC(op_0ce0_0), 3296 }, /* CAS */
{ CPUFUNC(op_0ce8_0), 3304 }, /* CAS */
{ CPUFUNC(op_0cf0_0), 3312 }, /* CAS */
{ CPUFUNC(op_0cf8_0), 3320 }, /* CAS */
{ CPUFUNC(op_0cf9_0), 3321 }, /* CAS */
{ CPUFUNC(op_0cfc_0), 3324 }, /* CAS2 */
{ CPUFUNC(op_0e10_0), 3600 }, /* MOVES */
{ CPUFUNC(op_0e18_0), 3608 }, /* MOVES */
{ CPUFUNC(op_0e20_0), 3616 }, /* MOVES */
{ CPUFUNC(op_0e28_0), 3624 }, /* MOVES */
{ CPUFUNC(op_0e30_0), 3632 }, /* MOVES */
{ CPUFUNC(op_0e38_0), 3640 }, /* MOVES */
{ CPUFUNC(op_0e39_0), 3641 }, /* MOVES */
{ CPUFUNC(op_0e50_0), 3664 }, /* MOVES */
{ CPUFUNC(op_0e58_0), 3672 }, /* MOVES */
{ CPUFUNC(op_0e60_0), 3680 }, /* MOVES */
{ CPUFUNC(op_0e68_0), 3688 }, /* MOVES */
{ CPUFUNC(op_0e70_0), 3696 }, /* MOVES */
{ CPUFUNC(op_0e78_0), 3704 }, /* MOVES */
{ CPUFUNC(op_0e79_0), 3705 }, /* MOVES */
{ CPUFUNC(op_0e90_0), 3728 }, /* MOVES */
{ CPUFUNC(op_0e98_0), 3736 }, /* MOVES */
{ CPUFUNC(op_0ea0_0), 3744 }, /* MOVES */
{ CPUFUNC(op_0ea8_0), 3752 }, /* MOVES */
{ CPUFUNC(op_0eb0_0), 3760 }, /* MOVES */
{ CPUFUNC(op_0eb8_0), 3768 }, /* MOVES */
{ CPUFUNC(op_0eb9_0), 3769 }, /* MOVES */
{ CPUFUNC(op_0ed0_0), 3792 }, /* CAS */
{ CPUFUNC(op_0ed8_0), 3800 }, /* CAS */
{ CPUFUNC(op_0ee0_0), 3808 }, /* CAS */
{ CPUFUNC(op_0ee8_0), 3816 }, /* CAS */
{ CPUFUNC(op_0ef0_0), 3824 }, /* CAS */
{ CPUFUNC(op_0ef8_0), 3832 }, /* CAS */
{ CPUFUNC(op_0ef9_0), 3833 }, /* CAS */
{ CPUFUNC(op_0efc_0), 3836 }, /* CAS2 */
{ CPUFUNC(op_1000_0), 4096 }, /* MOVE */
{ CPUFUNC(op_1010_0), 4112 }, /* MOVE */
{ CPUFUNC(op_1018_0), 4120 }, /* MOVE */
{ CPUFUNC(op_1020_0), 4128 }, /* MOVE */
{ CPUFUNC(op_1028_0), 4136 }, /* MOVE */
{ CPUFUNC(op_1030_0), 4144 }, /* MOVE */
{ CPUFUNC(op_1038_0), 4152 }, /* MOVE */
{ CPUFUNC(op_1039_0), 4153 }, /* MOVE */
{ CPUFUNC(op_103a_0), 4154 }, /* MOVE */
{ CPUFUNC(op_103b_0), 4155 }, /* MOVE */
{ CPUFUNC(op_103c_0), 4156 }, /* MOVE */
{ CPUFUNC(op_1080_0), 4224 }, /* MOVE */
{ CPUFUNC(op_1090_0), 4240 }, /* MOVE */
{ CPUFUNC(op_1098_0), 4248 }, /* MOVE */
{ CPUFUNC(op_10a0_0), 4256 }, /* MOVE */
{ CPUFUNC(op_10a8_0), 4264 }, /* MOVE */
{ CPUFUNC(op_10b0_0), 4272 }, /* MOVE */
{ CPUFUNC(op_10b8_0), 4280 }, /* MOVE */
{ CPUFUNC(op_10b9_0), 4281 }, /* MOVE */
{ CPUFUNC(op_10ba_0), 4282 }, /* MOVE */
{ CPUFUNC(op_10bb_0), 4283 }, /* MOVE */
{ CPUFUNC(op_10bc_0), 4284 }, /* MOVE */
{ CPUFUNC(op_10c0_0), 4288 }, /* MOVE */
{ CPUFUNC(op_10d0_0), 4304 }, /* MOVE */
{ CPUFUNC(op_10d8_0), 4312 }, /* MOVE */
{ CPUFUNC(op_10e0_0), 4320 }, /* MOVE */
{ CPUFUNC(op_10e8_0), 4328 }, /* MOVE */
{ CPUFUNC(op_10f0_0), 4336 }, /* MOVE */
{ CPUFUNC(op_10f8_0), 4344 }, /* MOVE */
{ CPUFUNC(op_10f9_0), 4345 }, /* MOVE */
{ CPUFUNC(op_10fa_0), 4346 }, /* MOVE */
{ CPUFUNC(op_10fb_0), 4347 }, /* MOVE */
{ CPUFUNC(op_10fc_0), 4348 }, /* MOVE */
{ CPUFUNC(op_1100_0), 4352 }, /* MOVE */
{ CPUFUNC(op_1110_0), 4368 }, /* MOVE */
{ CPUFUNC(op_1118_0), 4376 }, /* MOVE */
{ CPUFUNC(op_1120_0), 4384 }, /* MOVE */
{ CPUFUNC(op_1128_0), 4392 }, /* MOVE */
{ CPUFUNC(op_1130_0), 4400 }, /* MOVE */
{ CPUFUNC(op_1138_0), 4408 }, /* MOVE */
{ CPUFUNC(op_1139_0), 4409 }, /* MOVE */
{ CPUFUNC(op_113a_0), 4410 }, /* MOVE */
{ CPUFUNC(op_113b_0), 4411 }, /* MOVE */
{ CPUFUNC(op_113c_0), 4412 }, /* MOVE */
{ CPUFUNC(op_1140_0), 4416 }, /* MOVE */
{ CPUFUNC(op_1150_0), 4432 }, /* MOVE */
{ CPUFUNC(op_1158_0), 4440 }, /* MOVE */
{ CPUFUNC(op_1160_0), 4448 }, /* MOVE */
{ CPUFUNC(op_1168_0), 4456 }, /* MOVE */
{ CPUFUNC(op_1170_0), 4464 }, /* MOVE */
{ CPUFUNC(op_1178_0), 4472 }, /* MOVE */
{ CPUFUNC(op_1179_0), 4473 }, /* MOVE */
{ CPUFUNC(op_117a_0), 4474 }, /* MOVE */
{ CPUFUNC(op_117b_0), 4475 }, /* MOVE */
{ CPUFUNC(op_117c_0), 4476 }, /* MOVE */
{ CPUFUNC(op_1180_0), 4480 }, /* MOVE */
{ CPUFUNC(op_1190_0), 4496 }, /* MOVE */
{ CPUFUNC(op_1198_0), 4504 }, /* MOVE */
{ CPUFUNC(op_11a0_0), 4512 }, /* MOVE */
{ CPUFUNC(op_11a8_0), 4520 }, /* MOVE */
{ CPUFUNC(op_11b0_0), 4528 }, /* MOVE */
{ CPUFUNC(op_11b8_0), 4536 }, /* MOVE */
{ CPUFUNC(op_11b9_0), 4537 }, /* MOVE */
{ CPUFUNC(op_11ba_0), 4538 }, /* MOVE */
{ CPUFUNC(op_11bb_0), 4539 }, /* MOVE */
{ CPUFUNC(op_11bc_0), 4540 }, /* MOVE */
{ CPUFUNC(op_11c0_0), 4544 }, /* MOVE */
{ CPUFUNC(op_11d0_0), 4560 }, /* MOVE */
{ CPUFUNC(op_11d8_0), 4568 }, /* MOVE */
{ CPUFUNC(op_11e0_0), 4576 }, /* MOVE */
{ CPUFUNC(op_11e8_0), 4584 }, /* MOVE */
{ CPUFUNC(op_11f0_0), 4592 }, /* MOVE */
{ CPUFUNC(op_11f8_0), 4600 }, /* MOVE */
{ CPUFUNC(op_11f9_0), 4601 }, /* MOVE */
{ CPUFUNC(op_11fa_0), 4602 }, /* MOVE */
{ CPUFUNC(op_11fb_0), 4603 }, /* MOVE */
{ CPUFUNC(op_11fc_0), 4604 }, /* MOVE */
{ CPUFUNC(op_13c0_0), 5056 }, /* MOVE */
{ CPUFUNC(op_13d0_0), 5072 }, /* MOVE */
{ CPUFUNC(op_13d8_0), 5080 }, /* MOVE */
{ CPUFUNC(op_13e0_0), 5088 }, /* MOVE */
{ CPUFUNC(op_13e8_0), 5096 }, /* MOVE */
{ CPUFUNC(op_13f0_0), 5104 }, /* MOVE */
{ CPUFUNC(op_13f8_0), 5112 }, /* MOVE */
{ CPUFUNC(op_13f9_0), 5113 }, /* MOVE */
{ CPUFUNC(op_13fa_0), 5114 }, /* MOVE */
{ CPUFUNC(op_13fb_0), 5115 }, /* MOVE */
{ CPUFUNC(op_13fc_0), 5116 }, /* MOVE */
{ CPUFUNC(op_2000_0), 8192 }, /* MOVE */
{ CPUFUNC(op_2008_0), 8200 }, /* MOVE */
{ CPUFUNC(op_2010_0), 8208 }, /* MOVE */
{ CPUFUNC(op_2018_0), 8216 }, /* MOVE */
{ CPUFUNC(op_2020_0), 8224 }, /* MOVE */
{ CPUFUNC(op_2028_0), 8232 }, /* MOVE */
{ CPUFUNC(op_2030_0), 8240 }, /* MOVE */
{ CPUFUNC(op_2038_0), 8248 }, /* MOVE */
{ CPUFUNC(op_2039_0), 8249 }, /* MOVE */
{ CPUFUNC(op_203a_0), 8250 }, /* MOVE */
{ CPUFUNC(op_203b_0), 8251 }, /* MOVE */
{ CPUFUNC(op_203c_0), 8252 }, /* MOVE */
{ CPUFUNC(op_2040_0), 8256 }, /* MOVEA */
{ CPUFUNC(op_2048_0), 8264 }, /* MOVEA */
{ CPUFUNC(op_2050_0), 8272 }, /* MOVEA */
{ CPUFUNC(op_2058_0), 8280 }, /* MOVEA */
{ CPUFUNC(op_2060_0), 8288 }, /* MOVEA */
{ CPUFUNC(op_2068_0), 8296 }, /* MOVEA */
{ CPUFUNC(op_2070_0), 8304 }, /* MOVEA */
{ CPUFUNC(op_2078_0), 8312 }, /* MOVEA */
{ CPUFUNC(op_2079_0), 8313 }, /* MOVEA */
{ CPUFUNC(op_207a_0), 8314 }, /* MOVEA */
{ CPUFUNC(op_207b_0), 8315 }, /* MOVEA */
{ CPUFUNC(op_207c_0), 8316 }, /* MOVEA */
{ CPUFUNC(op_2080_0), 8320 }, /* MOVE */
{ CPUFUNC(op_2088_0), 8328 }, /* MOVE */
{ CPUFUNC(op_2090_0), 8336 }, /* MOVE */
{ CPUFUNC(op_2098_0), 8344 }, /* MOVE */
{ CPUFUNC(op_20a0_0), 8352 }, /* MOVE */
{ CPUFUNC(op_20a8_0), 8360 }, /* MOVE */
{ CPUFUNC(op_20b0_0), 8368 }, /* MOVE */
{ CPUFUNC(op_20b8_0), 8376 }, /* MOVE */
{ CPUFUNC(op_20b9_0), 8377 }, /* MOVE */
{ CPUFUNC(op_20ba_0), 8378 }, /* MOVE */
{ CPUFUNC(op_20bb_0), 8379 }, /* MOVE */
{ CPUFUNC(op_20bc_0), 8380 }, /* MOVE */
{ CPUFUNC(op_20c0_0), 8384 }, /* MOVE */
{ CPUFUNC(op_20c8_0), 8392 }, /* MOVE */
{ CPUFUNC(op_20d0_0), 8400 }, /* MOVE */
{ CPUFUNC(op_20d8_0), 8408 }, /* MOVE */
{ CPUFUNC(op_20e0_0), 8416 }, /* MOVE */
{ CPUFUNC(op_20e8_0), 8424 }, /* MOVE */
{ CPUFUNC(op_20f0_0), 8432 }, /* MOVE */
{ CPUFUNC(op_20f8_0), 8440 }, /* MOVE */
{ CPUFUNC(op_20f9_0), 8441 }, /* MOVE */
{ CPUFUNC(op_20fa_0), 8442 }, /* MOVE */
{ CPUFUNC(op_20fb_0), 8443 }, /* MOVE */
{ CPUFUNC(op_20fc_0), 8444 }, /* MOVE */
{ CPUFUNC(op_2100_0), 8448 }, /* MOVE */
{ CPUFUNC(op_2108_0), 8456 }, /* MOVE */
{ CPUFUNC(op_2110_0), 8464 }, /* MOVE */
{ CPUFUNC(op_2118_0), 8472 }, /* MOVE */
{ CPUFUNC(op_2120_0), 8480 }, /* MOVE */
{ CPUFUNC(op_2128_0), 8488 }, /* MOVE */
{ CPUFUNC(op_2130_0), 8496 }, /* MOVE */
{ CPUFUNC(op_2138_0), 8504 }, /* MOVE */
{ CPUFUNC(op_2139_0), 8505 }, /* MOVE */
{ CPUFUNC(op_213a_0), 8506 }, /* MOVE */
{ CPUFUNC(op_213b_0), 8507 }, /* MOVE */
{ CPUFUNC(op_213c_0), 8508 }, /* MOVE */
{ CPUFUNC(op_2140_0), 8512 }, /* MOVE */
{ CPUFUNC(op_2148_0), 8520 }, /* MOVE */
{ CPUFUNC(op_2150_0), 8528 }, /* MOVE */
{ CPUFUNC(op_2158_0), 8536 }, /* MOVE */
{ CPUFUNC(op_2160_0), 8544 }, /* MOVE */
{ CPUFUNC(op_2168_0), 8552 }, /* MOVE */
{ CPUFUNC(op_2170_0), 8560 }, /* MOVE */
{ CPUFUNC(op_2178_0), 8568 }, /* MOVE */
{ CPUFUNC(op_2179_0), 8569 }, /* MOVE */
{ CPUFUNC(op_217a_0), 8570 }, /* MOVE */
{ CPUFUNC(op_217b_0), 8571 }, /* MOVE */
{ CPUFUNC(op_217c_0), 8572 }, /* MOVE */
{ CPUFUNC(op_2180_0), 8576 }, /* MOVE */
{ CPUFUNC(op_2188_0), 8584 }, /* MOVE */
{ CPUFUNC(op_2190_0), 8592 }, /* MOVE */
{ CPUFUNC(op_2198_0), 8600 }, /* MOVE */
{ CPUFUNC(op_21a0_0), 8608 }, /* MOVE */
{ CPUFUNC(op_21a8_0), 8616 }, /* MOVE */
{ CPUFUNC(op_21b0_0), 8624 }, /* MOVE */
{ CPUFUNC(op_21b8_0), 8632 }, /* MOVE */
{ CPUFUNC(op_21b9_0), 8633 }, /* MOVE */
{ CPUFUNC(op_21ba_0), 8634 }, /* MOVE */
{ CPUFUNC(op_21bb_0), 8635 }, /* MOVE */
{ CPUFUNC(op_21bc_0), 8636 }, /* MOVE */
{ CPUFUNC(op_21c0_0), 8640 }, /* MOVE */
{ CPUFUNC(op_21c8_0), 8648 }, /* MOVE */
{ CPUFUNC(op_21d0_0), 8656 }, /* MOVE */
{ CPUFUNC(op_21d8_0), 8664 }, /* MOVE */
{ CPUFUNC(op_21e0_0), 8672 }, /* MOVE */
{ CPUFUNC(op_21e8_0), 8680 }, /* MOVE */
{ CPUFUNC(op_21f0_0), 8688 }, /* MOVE */
{ CPUFUNC(op_21f8_0), 8696 }, /* MOVE */
{ CPUFUNC(op_21f9_0), 8697 }, /* MOVE */
{ CPUFUNC(op_21fa_0), 8698 }, /* MOVE */
{ CPUFUNC(op_21fb_0), 8699 }, /* MOVE */
{ CPUFUNC(op_21fc_0), 8700 }, /* MOVE */
{ CPUFUNC(op_23c0_0), 9152 }, /* MOVE */
{ CPUFUNC(op_23c8_0), 9160 }, /* MOVE */
{ CPUFUNC(op_23d0_0), 9168 }, /* MOVE */
{ CPUFUNC(op_23d8_0), 9176 }, /* MOVE */
{ CPUFUNC(op_23e0_0), 9184 }, /* MOVE */
{ CPUFUNC(op_23e8_0), 9192 }, /* MOVE */
{ CPUFUNC(op_23f0_0), 9200 }, /* MOVE */
{ CPUFUNC(op_23f8_0), 9208 }, /* MOVE */
{ CPUFUNC(op_23f9_0), 9209 }, /* MOVE */
{ CPUFUNC(op_23fa_0), 9210 }, /* MOVE */
{ CPUFUNC(op_23fb_0), 9211 }, /* MOVE */
{ CPUFUNC(op_23fc_0), 9212 }, /* MOVE */
{ CPUFUNC(op_3000_0), 12288 }, /* MOVE */
{ CPUFUNC(op_3008_0), 12296 }, /* MOVE */
{ CPUFUNC(op_3010_0), 12304 }, /* MOVE */
{ CPUFUNC(op_3018_0), 12312 }, /* MOVE */
{ CPUFUNC(op_3020_0), 12320 }, /* MOVE */
{ CPUFUNC(op_3028_0), 12328 }, /* MOVE */
{ CPUFUNC(op_3030_0), 12336 }, /* MOVE */
{ CPUFUNC(op_3038_0), 12344 }, /* MOVE */
{ CPUFUNC(op_3039_0), 12345 }, /* MOVE */
{ CPUFUNC(op_303a_0), 12346 }, /* MOVE */
{ CPUFUNC(op_303b_0), 12347 }, /* MOVE */
{ CPUFUNC(op_303c_0), 12348 }, /* MOVE */
{ CPUFUNC(op_3040_0), 12352 }, /* MOVEA */
{ CPUFUNC(op_3048_0), 12360 }, /* MOVEA */
{ CPUFUNC(op_3050_0), 12368 }, /* MOVEA */
{ CPUFUNC(op_3058_0), 12376 }, /* MOVEA */
{ CPUFUNC(op_3060_0), 12384 }, /* MOVEA */
{ CPUFUNC(op_3068_0), 12392 }, /* MOVEA */
{ CPUFUNC(op_3070_0), 12400 }, /* MOVEA */
{ CPUFUNC(op_3078_0), 12408 }, /* MOVEA */
{ CPUFUNC(op_3079_0), 12409 }, /* MOVEA */
{ CPUFUNC(op_307a_0), 12410 }, /* MOVEA */
{ CPUFUNC(op_307b_0), 12411 }, /* MOVEA */
{ CPUFUNC(op_307c_0), 12412 }, /* MOVEA */
{ CPUFUNC(op_3080_0), 12416 }, /* MOVE */
{ CPUFUNC(op_3088_0), 12424 }, /* MOVE */
{ CPUFUNC(op_3090_0), 12432 }, /* MOVE */
{ CPUFUNC(op_3098_0), 12440 }, /* MOVE */
{ CPUFUNC(op_30a0_0), 12448 }, /* MOVE */
{ CPUFUNC(op_30a8_0), 12456 }, /* MOVE */
{ CPUFUNC(op_30b0_0), 12464 }, /* MOVE */
{ CPUFUNC(op_30b8_0), 12472 }, /* MOVE */
{ CPUFUNC(op_30b9_0), 12473 }, /* MOVE */
{ CPUFUNC(op_30ba_0), 12474 }, /* MOVE */
{ CPUFUNC(op_30bb_0), 12475 }, /* MOVE */
{ CPUFUNC(op_30bc_0), 12476 }, /* MOVE */
{ CPUFUNC(op_30c0_0), 12480 }, /* MOVE */
{ CPUFUNC(op_30c8_0), 12488 }, /* MOVE */
{ CPUFUNC(op_30d0_0), 12496 }, /* MOVE */
{ CPUFUNC(op_30d8_0), 12504 }, /* MOVE */
{ CPUFUNC(op_30e0_0), 12512 }, /* MOVE */
{ CPUFUNC(op_30e8_0), 12520 }, /* MOVE */
{ CPUFUNC(op_30f0_0), 12528 }, /* MOVE */
{ CPUFUNC(op_30f8_0), 12536 }, /* MOVE */
{ CPUFUNC(op_30f9_0), 12537 }, /* MOVE */
{ CPUFUNC(op_30fa_0), 12538 }, /* MOVE */
{ CPUFUNC(op_30fb_0), 12539 }, /* MOVE */
{ CPUFUNC(op_30fc_0), 12540 }, /* MOVE */
{ CPUFUNC(op_3100_0), 12544 }, /* MOVE */
{ CPUFUNC(op_3108_0), 12552 }, /* MOVE */
{ CPUFUNC(op_3110_0), 12560 }, /* MOVE */
{ CPUFUNC(op_3118_0), 12568 }, /* MOVE */
{ CPUFUNC(op_3120_0), 12576 }, /* MOVE */
{ CPUFUNC(op_3128_0), 12584 }, /* MOVE */
{ CPUFUNC(op_3130_0), 12592 }, /* MOVE */
{ CPUFUNC(op_3138_0), 12600 }, /* MOVE */
{ CPUFUNC(op_3139_0), 12601 }, /* MOVE */
{ CPUFUNC(op_313a_0), 12602 }, /* MOVE */
{ CPUFUNC(op_313b_0), 12603 }, /* MOVE */
{ CPUFUNC(op_313c_0), 12604 }, /* MOVE */
{ CPUFUNC(op_3140_0), 12608 }, /* MOVE */
{ CPUFUNC(op_3148_0), 12616 }, /* MOVE */
{ CPUFUNC(op_3150_0), 12624 }, /* MOVE */
{ CPUFUNC(op_3158_0), 12632 }, /* MOVE */
{ CPUFUNC(op_3160_0), 12640 }, /* MOVE */
{ CPUFUNC(op_3168_0), 12648 }, /* MOVE */
{ CPUFUNC(op_3170_0), 12656 }, /* MOVE */
{ CPUFUNC(op_3178_0), 12664 }, /* MOVE */
{ CPUFUNC(op_3179_0), 12665 }, /* MOVE */
{ CPUFUNC(op_317a_0), 12666 }, /* MOVE */
{ CPUFUNC(op_317b_0), 12667 }, /* MOVE */
{ CPUFUNC(op_317c_0), 12668 }, /* MOVE */
{ CPUFUNC(op_3180_0), 12672 }, /* MOVE */
{ CPUFUNC(op_3188_0), 12680 }, /* MOVE */
{ CPUFUNC(op_3190_0), 12688 }, /* MOVE */
{ CPUFUNC(op_3198_0), 12696 }, /* MOVE */
{ CPUFUNC(op_31a0_0), 12704 }, /* MOVE */
{ CPUFUNC(op_31a8_0), 12712 }, /* MOVE */
{ CPUFUNC(op_31b0_0), 12720 }, /* MOVE */
{ CPUFUNC(op_31b8_0), 12728 }, /* MOVE */
{ CPUFUNC(op_31b9_0), 12729 }, /* MOVE */
{ CPUFUNC(op_31ba_0), 12730 }, /* MOVE */
{ CPUFUNC(op_31bb_0), 12731 }, /* MOVE */
{ CPUFUNC(op_31bc_0), 12732 }, /* MOVE */
{ CPUFUNC(op_31c0_0), 12736 }, /* MOVE */
{ CPUFUNC(op_31c8_0), 12744 }, /* MOVE */
{ CPUFUNC(op_31d0_0), 12752 }, /* MOVE */
{ CPUFUNC(op_31d8_0), 12760 }, /* MOVE */
{ CPUFUNC(op_31e0_0), 12768 }, /* MOVE */
{ CPUFUNC(op_31e8_0), 12776 }, /* MOVE */
{ CPUFUNC(op_31f0_0), 12784 }, /* MOVE */
{ CPUFUNC(op_31f8_0), 12792 }, /* MOVE */
{ CPUFUNC(op_31f9_0), 12793 }, /* MOVE */
{ CPUFUNC(op_31fa_0), 12794 }, /* MOVE */
{ CPUFUNC(op_31fb_0), 12795 }, /* MOVE */
{ CPUFUNC(op_31fc_0), 12796 }, /* MOVE */
{ CPUFUNC(op_33c0_0), 13248 }, /* MOVE */
{ CPUFUNC(op_33c8_0), 13256 }, /* MOVE */
{ CPUFUNC(op_33d0_0), 13264 }, /* MOVE */
{ CPUFUNC(op_33d8_0), 13272 }, /* MOVE */
{ CPUFUNC(op_33e0_0), 13280 }, /* MOVE */
{ CPUFUNC(op_33e8_0), 13288 }, /* MOVE */
{ CPUFUNC(op_33f0_0), 13296 }, /* MOVE */
{ CPUFUNC(op_33f8_0), 13304 }, /* MOVE */
{ CPUFUNC(op_33f9_0), 13305 }, /* MOVE */
{ CPUFUNC(op_33fa_0), 13306 }, /* MOVE */
{ CPUFUNC(op_33fb_0), 13307 }, /* MOVE */
{ CPUFUNC(op_33fc_0), 13308 }, /* MOVE */
{ CPUFUNC(op_4000_0), 16384 }, /* NEGX */
{ CPUFUNC(op_4010_0), 16400 }, /* NEGX */
{ CPUFUNC(op_4018_0), 16408 }, /* NEGX */
{ CPUFUNC(op_4020_0), 16416 }, /* NEGX */
{ CPUFUNC(op_4028_0), 16424 }, /* NEGX */
{ CPUFUNC(op_4030_0), 16432 }, /* NEGX */
{ CPUFUNC(op_4038_0), 16440 }, /* NEGX */
{ CPUFUNC(op_4039_0), 16441 }, /* NEGX */
{ CPUFUNC(op_4040_0), 16448 }, /* NEGX */
{ CPUFUNC(op_4050_0), 16464 }, /* NEGX */
{ CPUFUNC(op_4058_0), 16472 }, /* NEGX */
{ CPUFUNC(op_4060_0), 16480 }, /* NEGX */
{ CPUFUNC(op_4068_0), 16488 }, /* NEGX */
{ CPUFUNC(op_4070_0), 16496 }, /* NEGX */
{ CPUFUNC(op_4078_0), 16504 }, /* NEGX */
{ CPUFUNC(op_4079_0), 16505 }, /* NEGX */
{ CPUFUNC(op_4080_0), 16512 }, /* NEGX */
{ CPUFUNC(op_4090_0), 16528 }, /* NEGX */
{ CPUFUNC(op_4098_0), 16536 }, /* NEGX */
{ CPUFUNC(op_40a0_0), 16544 }, /* NEGX */
{ CPUFUNC(op_40a8_0), 16552 }, /* NEGX */
{ CPUFUNC(op_40b0_0), 16560 }, /* NEGX */
{ CPUFUNC(op_40b8_0), 16568 }, /* NEGX */
{ CPUFUNC(op_40b9_0), 16569 }, /* NEGX */
{ CPUFUNC(op_40c0_0), 16576 }, /* MVSR2 */
{ CPUFUNC(op_40d0_0), 16592 }, /* MVSR2 */
{ CPUFUNC(op_40d8_0), 16600 }, /* MVSR2 */
{ CPUFUNC(op_40e0_0), 16608 }, /* MVSR2 */
{ CPUFUNC(op_40e8_0), 16616 }, /* MVSR2 */
{ CPUFUNC(op_40f0_0), 16624 }, /* MVSR2 */
{ CPUFUNC(op_40f8_0), 16632 }, /* MVSR2 */
{ CPUFUNC(op_40f9_0), 16633 }, /* MVSR2 */
{ CPUFUNC(op_4100_0), 16640 }, /* CHK */
{ CPUFUNC(op_4110_0), 16656 }, /* CHK */
{ CPUFUNC(op_4118_0), 16664 }, /* CHK */
{ CPUFUNC(op_4120_0), 16672 }, /* CHK */
{ CPUFUNC(op_4128_0), 16680 }, /* CHK */
{ CPUFUNC(op_4130_0), 16688 }, /* CHK */
{ CPUFUNC(op_4138_0), 16696 }, /* CHK */
{ CPUFUNC(op_4139_0), 16697 }, /* CHK */
{ CPUFUNC(op_413a_0), 16698 }, /* CHK */
{ CPUFUNC(op_413b_0), 16699 }, /* CHK */
{ CPUFUNC(op_413c_0), 16700 }, /* CHK */
{ CPUFUNC(op_4180_0), 16768 }, /* CHK */
{ CPUFUNC(op_4190_0), 16784 }, /* CHK */
{ CPUFUNC(op_4198_0), 16792 }, /* CHK */
{ CPUFUNC(op_41a0_0), 16800 }, /* CHK */
{ CPUFUNC(op_41a8_0), 16808 }, /* CHK */
{ CPUFUNC(op_41b0_0), 16816 }, /* CHK */
{ CPUFUNC(op_41b8_0), 16824 }, /* CHK */
{ CPUFUNC(op_41b9_0), 16825 }, /* CHK */
{ CPUFUNC(op_41ba_0), 16826 }, /* CHK */
{ CPUFUNC(op_41bb_0), 16827 }, /* CHK */
{ CPUFUNC(op_41bc_0), 16828 }, /* CHK */
{ CPUFUNC(op_41d0_0), 16848 }, /* LEA */
{ CPUFUNC(op_41e8_0), 16872 }, /* LEA */
{ CPUFUNC(op_41f0_0), 16880 }, /* LEA */
{ CPUFUNC(op_41f8_0), 16888 }, /* LEA */
{ CPUFUNC(op_41f9_0), 16889 }, /* LEA */
{ CPUFUNC(op_41fa_0), 16890 }, /* LEA */
{ CPUFUNC(op_41fb_0), 16891 }, /* LEA */
{ CPUFUNC(op_4200_0), 16896 }, /* CLR */
{ CPUFUNC(op_4210_0), 16912 }, /* CLR */
{ CPUFUNC(op_4218_0), 16920 }, /* CLR */
{ CPUFUNC(op_4220_0), 16928 }, /* CLR */
{ CPUFUNC(op_4228_0), 16936 }, /* CLR */
{ CPUFUNC(op_4230_0), 16944 }, /* CLR */
{ CPUFUNC(op_4238_0), 16952 }, /* CLR */
{ CPUFUNC(op_4239_0), 16953 }, /* CLR */
{ CPUFUNC(op_4240_0), 16960 }, /* CLR */
{ CPUFUNC(op_4250_0), 16976 }, /* CLR */
{ CPUFUNC(op_4258_0), 16984 }, /* CLR */
{ CPUFUNC(op_4260_0), 16992 }, /* CLR */
{ CPUFUNC(op_4268_0), 17000 }, /* CLR */
{ CPUFUNC(op_4270_0), 17008 }, /* CLR */
{ CPUFUNC(op_4278_0), 17016 }, /* CLR */
{ CPUFUNC(op_4279_0), 17017 }, /* CLR */
{ CPUFUNC(op_4280_0), 17024 }, /* CLR */
{ CPUFUNC(op_4290_0), 17040 }, /* CLR */
{ CPUFUNC(op_4298_0), 17048 }, /* CLR */
{ CPUFUNC(op_42a0_0), 17056 }, /* CLR */
{ CPUFUNC(op_42a8_0), 17064 }, /* CLR */
{ CPUFUNC(op_42b0_0), 17072 }, /* CLR */
{ CPUFUNC(op_42b8_0), 17080 }, /* CLR */
{ CPUFUNC(op_42b9_0), 17081 }, /* CLR */
{ CPUFUNC(op_42c0_0), 17088 }, /* MVSR2 */
{ CPUFUNC(op_42d0_0), 17104 }, /* MVSR2 */
{ CPUFUNC(op_42d8_0), 17112 }, /* MVSR2 */
{ CPUFUNC(op_42e0_0), 17120 }, /* MVSR2 */
{ CPUFUNC(op_42e8_0), 17128 }, /* MVSR2 */
{ CPUFUNC(op_42f0_0), 17136 }, /* MVSR2 */
{ CPUFUNC(op_42f8_0), 17144 }, /* MVSR2 */
{ CPUFUNC(op_42f9_0), 17145 }, /* MVSR2 */
{ CPUFUNC(op_4400_0), 17408 }, /* NEG */
{ CPUFUNC(op_4410_0), 17424 }, /* NEG */
{ CPUFUNC(op_4418_0), 17432 }, /* NEG */
{ CPUFUNC(op_4420_0), 17440 }, /* NEG */
{ CPUFUNC(op_4428_0), 17448 }, /* NEG */
{ CPUFUNC(op_4430_0), 17456 }, /* NEG */
{ CPUFUNC(op_4438_0), 17464 }, /* NEG */
{ CPUFUNC(op_4439_0), 17465 }, /* NEG */
{ CPUFUNC(op_4440_0), 17472 }, /* NEG */
{ CPUFUNC(op_4450_0), 17488 }, /* NEG */
{ CPUFUNC(op_4458_0), 17496 }, /* NEG */
{ CPUFUNC(op_4460_0), 17504 }, /* NEG */
{ CPUFUNC(op_4468_0), 17512 }, /* NEG */
{ CPUFUNC(op_4470_0), 17520 }, /* NEG */
{ CPUFUNC(op_4478_0), 17528 }, /* NEG */
{ CPUFUNC(op_4479_0), 17529 }, /* NEG */
{ CPUFUNC(op_4480_0), 17536 }, /* NEG */
{ CPUFUNC(op_4490_0), 17552 }, /* NEG */
{ CPUFUNC(op_4498_0), 17560 }, /* NEG */
{ CPUFUNC(op_44a0_0), 17568 }, /* NEG */
{ CPUFUNC(op_44a8_0), 17576 }, /* NEG */
{ CPUFUNC(op_44b0_0), 17584 }, /* NEG */
{ CPUFUNC(op_44b8_0), 17592 }, /* NEG */
{ CPUFUNC(op_44b9_0), 17593 }, /* NEG */
{ CPUFUNC(op_44c0_0), 17600 }, /* MV2SR */
{ CPUFUNC(op_44d0_0), 17616 }, /* MV2SR */
{ CPUFUNC(op_44d8_0), 17624 }, /* MV2SR */
{ CPUFUNC(op_44e0_0), 17632 }, /* MV2SR */
{ CPUFUNC(op_44e8_0), 17640 }, /* MV2SR */
{ CPUFUNC(op_44f0_0), 17648 }, /* MV2SR */
{ CPUFUNC(op_44f8_0), 17656 }, /* MV2SR */
{ CPUFUNC(op_44f9_0), 17657 }, /* MV2SR */
{ CPUFUNC(op_44fa_0), 17658 }, /* MV2SR */
{ CPUFUNC(op_44fb_0), 17659 }, /* MV2SR */
{ CPUFUNC(op_44fc_0), 17660 }, /* MV2SR */
{ CPUFUNC(op_4600_0), 17920 }, /* NOT */
{ CPUFUNC(op_4610_0), 17936 }, /* NOT */
{ CPUFUNC(op_4618_0), 17944 }, /* NOT */
{ CPUFUNC(op_4620_0), 17952 }, /* NOT */
{ CPUFUNC(op_4628_0), 17960 }, /* NOT */
{ CPUFUNC(op_4630_0), 17968 }, /* NOT */
{ CPUFUNC(op_4638_0), 17976 }, /* NOT */
{ CPUFUNC(op_4639_0), 17977 }, /* NOT */
{ CPUFUNC(op_4640_0), 17984 }, /* NOT */
{ CPUFUNC(op_4650_0), 18000 }, /* NOT */
{ CPUFUNC(op_4658_0), 18008 }, /* NOT */
{ CPUFUNC(op_4660_0), 18016 }, /* NOT */
{ CPUFUNC(op_4668_0), 18024 }, /* NOT */
{ CPUFUNC(op_4670_0), 18032 }, /* NOT */
{ CPUFUNC(op_4678_0), 18040 }, /* NOT */
{ CPUFUNC(op_4679_0), 18041 }, /* NOT */
{ CPUFUNC(op_4680_0), 18048 }, /* NOT */
{ CPUFUNC(op_4690_0), 18064 }, /* NOT */
{ CPUFUNC(op_4698_0), 18072 }, /* NOT */
{ CPUFUNC(op_46a0_0), 18080 }, /* NOT */
{ CPUFUNC(op_46a8_0), 18088 }, /* NOT */
{ CPUFUNC(op_46b0_0), 18096 }, /* NOT */
{ CPUFUNC(op_46b8_0), 18104 }, /* NOT */
{ CPUFUNC(op_46b9_0), 18105 }, /* NOT */
{ CPUFUNC(op_46c0_0), 18112 }, /* MV2SR */
{ CPUFUNC(op_46d0_0), 18128 }, /* MV2SR */
{ CPUFUNC(op_46d8_0), 18136 }, /* MV2SR */
{ CPUFUNC(op_46e0_0), 18144 }, /* MV2SR */
{ CPUFUNC(op_46e8_0), 18152 }, /* MV2SR */
{ CPUFUNC(op_46f0_0), 18160 }, /* MV2SR */
{ CPUFUNC(op_46f8_0), 18168 }, /* MV2SR */
{ CPUFUNC(op_46f9_0), 18169 }, /* MV2SR */
{ CPUFUNC(op_46fa_0), 18170 }, /* MV2SR */
{ CPUFUNC(op_46fb_0), 18171 }, /* MV2SR */
{ CPUFUNC(op_46fc_0), 18172 }, /* MV2SR */
{ CPUFUNC(op_4800_2), 18432 }, /* NBCD */
{ CPUFUNC(op_4808_0), 18440 }, /* LINK */
{ CPUFUNC(op_4810_2), 18448 }, /* NBCD */
{ CPUFUNC(op_4818_2), 18456 }, /* NBCD */
{ CPUFUNC(op_4820_2), 18464 }, /* NBCD */
{ CPUFUNC(op_4828_2), 18472 }, /* NBCD */
{ CPUFUNC(op_4830_2), 18480 }, /* NBCD */
{ CPUFUNC(op_4838_2), 18488 }, /* NBCD */
{ CPUFUNC(op_4839_2), 18489 }, /* NBCD */
{ CPUFUNC(op_4840_0), 18496 }, /* SWAP */
{ CPUFUNC(op_4848_0), 18504 }, /* BKPT */
{ CPUFUNC(op_4850_0), 18512 }, /* PEA */
{ CPUFUNC(op_4868_0), 18536 }, /* PEA */
{ CPUFUNC(op_4870_0), 18544 }, /* PEA */
{ CPUFUNC(op_4878_0), 18552 }, /* PEA */
{ CPUFUNC(op_4879_0), 18553 }, /* PEA */
{ CPUFUNC(op_487a_0), 18554 }, /* PEA */
{ CPUFUNC(op_487b_0), 18555 }, /* PEA */
{ CPUFUNC(op_4880_0), 18560 }, /* EXT */
{ CPUFUNC(op_4890_0), 18576 }, /* MVMLE */
{ CPUFUNC(op_48a0_0), 18592 }, /* MVMLE */
{ CPUFUNC(op_48a8_0), 18600 }, /* MVMLE */
{ CPUFUNC(op_48b0_0), 18608 }, /* MVMLE */
{ CPUFUNC(op_48b8_0), 18616 }, /* MVMLE */
{ CPUFUNC(op_48b9_0), 18617 }, /* MVMLE */
{ CPUFUNC(op_48c0_0), 18624 }, /* EXT */
{ CPUFUNC(op_48d0_0), 18640 }, /* MVMLE */
{ CPUFUNC(op_48e0_0), 18656 }, /* MVMLE */
{ CPUFUNC(op_48e8_0), 18664 }, /* MVMLE */
{ CPUFUNC(op_48f0_0), 18672 }, /* MVMLE */
{ CPUFUNC(op_48f8_0), 18680 }, /* MVMLE */
{ CPUFUNC(op_48f9_0), 18681 }, /* MVMLE */
{ CPUFUNC(op_49c0_0), 18880 }, /* EXT */
{ CPUFUNC(op_4a00_0), 18944 }, /* TST */
{ CPUFUNC(op_4a10_0), 18960 }, /* TST */
{ CPUFUNC(op_4a18_0), 18968 }, /* TST */
{ CPUFUNC(op_4a20_0), 18976 }, /* TST */
{ CPUFUNC(op_4a28_0), 18984 }, /* TST */
{ CPUFUNC(op_4a30_0), 18992 }, /* TST */
{ CPUFUNC(op_4a38_0), 19000 }, /* TST */
{ CPUFUNC(op_4a39_0), 19001 }, /* TST */
{ CPUFUNC(op_4a3a_0), 19002 }, /* TST */
{ CPUFUNC(op_4a3b_0), 19003 }, /* TST */
{ CPUFUNC(op_4a3c_0), 19004 }, /* TST */
{ CPUFUNC(op_4a40_0), 19008 }, /* TST */
{ CPUFUNC(op_4a48_0), 19016 }, /* TST */
{ CPUFUNC(op_4a50_0), 19024 }, /* TST */
{ CPUFUNC(op_4a58_0), 19032 }, /* TST */
{ CPUFUNC(op_4a60_0), 19040 }, /* TST */
{ CPUFUNC(op_4a68_0), 19048 }, /* TST */
{ CPUFUNC(op_4a70_0), 19056 }, /* TST */
{ CPUFUNC(op_4a78_0), 19064 }, /* TST */
{ CPUFUNC(op_4a79_0), 19065 }, /* TST */
{ CPUFUNC(op_4a7a_0), 19066 }, /* TST */
{ CPUFUNC(op_4a7b_0), 19067 }, /* TST */
{ CPUFUNC(op_4a7c_0), 19068 }, /* TST */
{ CPUFUNC(op_4a80_0), 19072 }, /* TST */
{ CPUFUNC(op_4a88_0), 19080 }, /* TST */
{ CPUFUNC(op_4a90_0), 19088 }, /* TST */
{ CPUFUNC(op_4a98_0), 19096 }, /* TST */
{ CPUFUNC(op_4aa0_0), 19104 }, /* TST */
{ CPUFUNC(op_4aa8_0), 19112 }, /* TST */
{ CPUFUNC(op_4ab0_0), 19120 }, /* TST */
{ CPUFUNC(op_4ab8_0), 19128 }, /* TST */
{ CPUFUNC(op_4ab9_0), 19129 }, /* TST */
{ CPUFUNC(op_4aba_0), 19130 }, /* TST */
{ CPUFUNC(op_4abb_0), 19131 }, /* TST */
{ CPUFUNC(op_4abc_0), 19132 }, /* TST */
{ CPUFUNC(op_4ac0_0), 19136 }, /* TAS */
{ CPUFUNC(op_4ad0_0), 19152 }, /* TAS */
{ CPUFUNC(op_4ad8_0), 19160 }, /* TAS */
{ CPUFUNC(op_4ae0_0), 19168 }, /* TAS */
{ CPUFUNC(op_4ae8_0), 19176 }, /* TAS */
{ CPUFUNC(op_4af0_0), 19184 }, /* TAS */
{ CPUFUNC(op_4af8_0), 19192 }, /* TAS */
{ CPUFUNC(op_4af9_0), 19193 }, /* TAS */
{ CPUFUNC(op_4c00_0), 19456 }, /* MULL */
{ CPUFUNC(op_4c10_0), 19472 }, /* MULL */
{ CPUFUNC(op_4c18_0), 19480 }, /* MULL */
{ CPUFUNC(op_4c20_0), 19488 }, /* MULL */
{ CPUFUNC(op_4c28_0), 19496 }, /* MULL */
{ CPUFUNC(op_4c30_0), 19504 }, /* MULL */
{ CPUFUNC(op_4c38_0), 19512 }, /* MULL */
{ CPUFUNC(op_4c39_0), 19513 }, /* MULL */
{ CPUFUNC(op_4c3a_0), 19514 }, /* MULL */
{ CPUFUNC(op_4c3b_0), 19515 }, /* MULL */
{ CPUFUNC(op_4c3c_0), 19516 }, /* MULL */
{ CPUFUNC(op_4c40_0), 19520 }, /* DIVL */
{ CPUFUNC(op_4c50_0), 19536 }, /* DIVL */
{ CPUFUNC(op_4c58_0), 19544 }, /* DIVL */
{ CPUFUNC(op_4c60_0), 19552 }, /* DIVL */
{ CPUFUNC(op_4c68_0), 19560 }, /* DIVL */
{ CPUFUNC(op_4c70_0), 19568 }, /* DIVL */
{ CPUFUNC(op_4c78_0), 19576 }, /* DIVL */
{ CPUFUNC(op_4c79_0), 19577 }, /* DIVL */
{ CPUFUNC(op_4c7a_0), 19578 }, /* DIVL */
{ CPUFUNC(op_4c7b_0), 19579 }, /* DIVL */
{ CPUFUNC(op_4c7c_0), 19580 }, /* DIVL */
{ CPUFUNC(op_4c90_0), 19600 }, /* MVMEL */
{ CPUFUNC(op_4c98_0), 19608 }, /* MVMEL */
{ CPUFUNC(op_4ca8_0), 19624 }, /* MVMEL */
{ CPUFUNC(op_4cb0_0), 19632 }, /* MVMEL */
{ CPUFUNC(op_4cb8_0), 19640 }, /* MVMEL */
{ CPUFUNC(op_4cb9_0), 19641 }, /* MVMEL */
{ CPUFUNC(op_4cba_0), 19642 }, /* MVMEL */
{ CPUFUNC(op_4cbb_0), 19643 }, /* MVMEL */
{ CPUFUNC(op_4cd0_0), 19664 }, /* MVMEL */
{ CPUFUNC(op_4cd8_0), 19672 }, /* MVMEL */
{ CPUFUNC(op_4ce8_0), 19688 }, /* MVMEL */
{ CPUFUNC(op_4cf0_0), 19696 }, /* MVMEL */
{ CPUFUNC(op_4cf8_0), 19704 }, /* MVMEL */
{ CPUFUNC(op_4cf9_0), 19705 }, /* MVMEL */
{ CPUFUNC(op_4cfa_0), 19706 }, /* MVMEL */
{ CPUFUNC(op_4cfb_0), 19707 }, /* MVMEL */
{ CPUFUNC(op_4e40_0), 20032 }, /* TRAP */
{ CPUFUNC(op_4e50_0), 20048 }, /* LINK */
{ CPUFUNC(op_4e58_0), 20056 }, /* UNLK */
{ CPUFUNC(op_4e60_0), 20064 }, /* MVR2USP */
{ CPUFUNC(op_4e68_0), 20072 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_0), 20080 }, /* RESET */
{ CPUFUNC(op_4e71_0), 20081 }, /* NOP */
{ CPUFUNC(op_4e72_0), 20082 }, /* STOP */
{ CPUFUNC(op_4e73_0), 20083 }, /* RTE */
{ CPUFUNC(op_4e74_0), 20084 }, /* RTD */
{ CPUFUNC(op_4e75_0), 20085 }, /* RTS */
{ CPUFUNC(op_4e76_0), 20086 }, /* TRAPV */
{ CPUFUNC(op_4e77_0), 20087 }, /* RTR */
{ CPUFUNC(op_4e7a_0), 20090 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_0), 20091 }, /* MOVE2C */
{ CPUFUNC(op_4e90_0), 20112 }, /* JSR */
{ CPUFUNC(op_4ea8_0), 20136 }, /* JSR */
{ CPUFUNC(op_4eb0_0), 20144 }, /* JSR */
{ CPUFUNC(op_4eb8_0), 20152 }, /* JSR */
{ CPUFUNC(op_4eb9_0), 20153 }, /* JSR */
{ CPUFUNC(op_4eba_0), 20154 }, /* JSR */
{ CPUFUNC(op_4ebb_0), 20155 }, /* JSR */
{ CPUFUNC(op_4ed0_0), 20176 }, /* JMP */
{ CPUFUNC(op_4ee8_0), 20200 }, /* JMP */
{ CPUFUNC(op_4ef0_0), 20208 }, /* JMP */
{ CPUFUNC(op_4ef8_0), 20216 }, /* JMP */
{ CPUFUNC(op_4ef9_0), 20217 }, /* JMP */
{ CPUFUNC(op_4efa_0), 20218 }, /* JMP */
{ CPUFUNC(op_4efb_0), 20219 }, /* JMP */
{ CPUFUNC(op_5000_0), 20480 }, /* ADD */
{ CPUFUNC(op_5010_0), 20496 }, /* ADD */
{ CPUFUNC(op_5018_0), 20504 }, /* ADD */
{ CPUFUNC(op_5020_0), 20512 }, /* ADD */
{ CPUFUNC(op_5028_0), 20520 }, /* ADD */
{ CPUFUNC(op_5030_0), 20528 }, /* ADD */
{ CPUFUNC(op_5038_0), 20536 }, /* ADD */
{ CPUFUNC(op_5039_0), 20537 }, /* ADD */
{ CPUFUNC(op_5040_0), 20544 }, /* ADD */
{ CPUFUNC(op_5048_0), 20552 }, /* ADDA */
{ CPUFUNC(op_5050_0), 20560 }, /* ADD */
{ CPUFUNC(op_5058_0), 20568 }, /* ADD */
{ CPUFUNC(op_5060_0), 20576 }, /* ADD */
{ CPUFUNC(op_5068_0), 20584 }, /* ADD */
{ CPUFUNC(op_5070_0), 20592 }, /* ADD */
{ CPUFUNC(op_5078_0), 20600 }, /* ADD */
{ CPUFUNC(op_5079_0), 20601 }, /* ADD */
{ CPUFUNC(op_5080_0), 20608 }, /* ADD */
{ CPUFUNC(op_5088_0), 20616 }, /* ADDA */
{ CPUFUNC(op_5090_0), 20624 }, /* ADD */
{ CPUFUNC(op_5098_0), 20632 }, /* ADD */
{ CPUFUNC(op_50a0_0), 20640 }, /* ADD */
{ CPUFUNC(op_50a8_0), 20648 }, /* ADD */
{ CPUFUNC(op_50b0_0), 20656 }, /* ADD */
{ CPUFUNC(op_50b8_0), 20664 }, /* ADD */
{ CPUFUNC(op_50b9_0), 20665 }, /* ADD */
{ CPUFUNC(op_50c0_0), 20672 }, /* Scc */
{ CPUFUNC(op_50c8_0), 20680 }, /* DBcc */
{ CPUFUNC(op_50d0_0), 20688 }, /* Scc */
{ CPUFUNC(op_50d8_0), 20696 }, /* Scc */
{ CPUFUNC(op_50e0_0), 20704 }, /* Scc */
{ CPUFUNC(op_50e8_0), 20712 }, /* Scc */
{ CPUFUNC(op_50f0_0), 20720 }, /* Scc */
{ CPUFUNC(op_50f8_0), 20728 }, /* Scc */
{ CPUFUNC(op_50f9_0), 20729 }, /* Scc */
{ CPUFUNC(op_50fa_0), 20730 }, /* TRAPcc */
{ CPUFUNC(op_50fb_0), 20731 }, /* TRAPcc */
{ CPUFUNC(op_50fc_0), 20732 }, /* TRAPcc */
{ CPUFUNC(op_5100_0), 20736 }, /* SUB */
{ CPUFUNC(op_5110_0), 20752 }, /* SUB */
{ CPUFUNC(op_5118_0), 20760 }, /* SUB */
{ CPUFUNC(op_5120_0), 20768 }, /* SUB */
{ CPUFUNC(op_5128_0), 20776 }, /* SUB */
{ CPUFUNC(op_5130_0), 20784 }, /* SUB */
{ CPUFUNC(op_5138_0), 20792 }, /* SUB */
{ CPUFUNC(op_5139_0), 20793 }, /* SUB */
{ CPUFUNC(op_5140_0), 20800 }, /* SUB */
{ CPUFUNC(op_5148_0), 20808 }, /* SUBA */
{ CPUFUNC(op_5150_0), 20816 }, /* SUB */
{ CPUFUNC(op_5158_0), 20824 }, /* SUB */
{ CPUFUNC(op_5160_0), 20832 }, /* SUB */
{ CPUFUNC(op_5168_0), 20840 }, /* SUB */
{ CPUFUNC(op_5170_0), 20848 }, /* SUB */
{ CPUFUNC(op_5178_0), 20856 }, /* SUB */
{ CPUFUNC(op_5179_0), 20857 }, /* SUB */
{ CPUFUNC(op_5180_0), 20864 }, /* SUB */
{ CPUFUNC(op_5188_0), 20872 }, /* SUBA */
{ CPUFUNC(op_5190_0), 20880 }, /* SUB */
{ CPUFUNC(op_5198_0), 20888 }, /* SUB */
{ CPUFUNC(op_51a0_0), 20896 }, /* SUB */
{ CPUFUNC(op_51a8_0), 20904 }, /* SUB */
{ CPUFUNC(op_51b0_0), 20912 }, /* SUB */
{ CPUFUNC(op_51b8_0), 20920 }, /* SUB */
{ CPUFUNC(op_51b9_0), 20921 }, /* SUB */
{ CPUFUNC(op_51c0_0), 20928 }, /* Scc */
{ CPUFUNC(op_51c8_0), 20936 }, /* DBcc */
{ CPUFUNC(op_51d0_0), 20944 }, /* Scc */
{ CPUFUNC(op_51d8_0), 20952 }, /* Scc */
{ CPUFUNC(op_51e0_0), 20960 }, /* Scc */
{ CPUFUNC(op_51e8_0), 20968 }, /* Scc */
{ CPUFUNC(op_51f0_0), 20976 }, /* Scc */
{ CPUFUNC(op_51f8_0), 20984 }, /* Scc */
{ CPUFUNC(op_51f9_0), 20985 }, /* Scc */
{ CPUFUNC(op_51fa_0), 20986 }, /* TRAPcc */
{ CPUFUNC(op_51fb_0), 20987 }, /* TRAPcc */
{ CPUFUNC(op_51fc_0), 20988 }, /* TRAPcc */
{ CPUFUNC(op_52c0_0), 21184 }, /* Scc */
{ CPUFUNC(op_52c8_0), 21192 }, /* DBcc */
{ CPUFUNC(op_52d0_0), 21200 }, /* Scc */
{ CPUFUNC(op_52d8_0), 21208 }, /* Scc */
{ CPUFUNC(op_52e0_0), 21216 }, /* Scc */
{ CPUFUNC(op_52e8_0), 21224 }, /* Scc */
{ CPUFUNC(op_52f0_0), 21232 }, /* Scc */
{ CPUFUNC(op_52f8_0), 21240 }, /* Scc */
{ CPUFUNC(op_52f9_0), 21241 }, /* Scc */
{ CPUFUNC(op_52fa_0), 21242 }, /* TRAPcc */
{ CPUFUNC(op_52fb_0), 21243 }, /* TRAPcc */
{ CPUFUNC(op_52fc_0), 21244 }, /* TRAPcc */
{ CPUFUNC(op_53c0_0), 21440 }, /* Scc */
{ CPUFUNC(op_53c8_0), 21448 }, /* DBcc */
{ CPUFUNC(op_53d0_0), 21456 }, /* Scc */
{ CPUFUNC(op_53d8_0), 21464 }, /* Scc */
{ CPUFUNC(op_53e0_0), 21472 }, /* Scc */
{ CPUFUNC(op_53e8_0), 21480 }, /* Scc */
{ CPUFUNC(op_53f0_0), 21488 }, /* Scc */
{ CPUFUNC(op_53f8_0), 21496 }, /* Scc */
{ CPUFUNC(op_53f9_0), 21497 }, /* Scc */
{ CPUFUNC(op_53fa_0), 21498 }, /* TRAPcc */
{ CPUFUNC(op_53fb_0), 21499 }, /* TRAPcc */
{ CPUFUNC(op_53fc_0), 21500 }, /* TRAPcc */
{ CPUFUNC(op_54c0_0), 21696 }, /* Scc */
{ CPUFUNC(op_54c8_0), 21704 }, /* DBcc */
{ CPUFUNC(op_54d0_0), 21712 }, /* Scc */
{ CPUFUNC(op_54d8_0), 21720 }, /* Scc */
{ CPUFUNC(op_54e0_0), 21728 }, /* Scc */
{ CPUFUNC(op_54e8_0), 21736 }, /* Scc */
{ CPUFUNC(op_54f0_0), 21744 }, /* Scc */
{ CPUFUNC(op_54f8_0), 21752 }, /* Scc */
{ CPUFUNC(op_54f9_0), 21753 }, /* Scc */
{ CPUFUNC(op_54fa_0), 21754 }, /* TRAPcc */
{ CPUFUNC(op_54fb_0), 21755 }, /* TRAPcc */
{ CPUFUNC(op_54fc_0), 21756 }, /* TRAPcc */
{ CPUFUNC(op_55c0_0), 21952 }, /* Scc */
{ CPUFUNC(op_55c8_0), 21960 }, /* DBcc */
{ CPUFUNC(op_55d0_0), 21968 }, /* Scc */
{ CPUFUNC(op_55d8_0), 21976 }, /* Scc */
{ CPUFUNC(op_55e0_0), 21984 }, /* Scc */
{ CPUFUNC(op_55e8_0), 21992 }, /* Scc */
{ CPUFUNC(op_55f0_0), 22000 }, /* Scc */
{ CPUFUNC(op_55f8_0), 22008 }, /* Scc */
{ CPUFUNC(op_55f9_0), 22009 }, /* Scc */
{ CPUFUNC(op_55fa_0), 22010 }, /* TRAPcc */
{ CPUFUNC(op_55fb_0), 22011 }, /* TRAPcc */
{ CPUFUNC(op_55fc_0), 22012 }, /* TRAPcc */
{ CPUFUNC(op_56c0_0), 22208 }, /* Scc */
{ CPUFUNC(op_56c8_0), 22216 }, /* DBcc */
{ CPUFUNC(op_56d0_0), 22224 }, /* Scc */
{ CPUFUNC(op_56d8_0), 22232 }, /* Scc */
{ CPUFUNC(op_56e0_0), 22240 }, /* Scc */
{ CPUFUNC(op_56e8_0), 22248 }, /* Scc */
{ CPUFUNC(op_56f0_0), 22256 }, /* Scc */
{ CPUFUNC(op_56f8_0), 22264 }, /* Scc */
{ CPUFUNC(op_56f9_0), 22265 }, /* Scc */
{ CPUFUNC(op_56fa_0), 22266 }, /* TRAPcc */
{ CPUFUNC(op_56fb_0), 22267 }, /* TRAPcc */
{ CPUFUNC(op_56fc_0), 22268 }, /* TRAPcc */
{ CPUFUNC(op_57c0_0), 22464 }, /* Scc */
{ CPUFUNC(op_57c8_0), 22472 }, /* DBcc */
{ CPUFUNC(op_57d0_0), 22480 }, /* Scc */
{ CPUFUNC(op_57d8_0), 22488 }, /* Scc */
{ CPUFUNC(op_57e0_0), 22496 }, /* Scc */
{ CPUFUNC(op_57e8_0), 22504 }, /* Scc */
{ CPUFUNC(op_57f0_0), 22512 }, /* Scc */
{ CPUFUNC(op_57f8_0), 22520 }, /* Scc */
{ CPUFUNC(op_57f9_0), 22521 }, /* Scc */
{ CPUFUNC(op_57fa_0), 22522 }, /* TRAPcc */
{ CPUFUNC(op_57fb_0), 22523 }, /* TRAPcc */
{ CPUFUNC(op_57fc_0), 22524 }, /* TRAPcc */
{ CPUFUNC(op_58c0_0), 22720 }, /* Scc */
{ CPUFUNC(op_58c8_0), 22728 }, /* DBcc */
{ CPUFUNC(op_58d0_0), 22736 }, /* Scc */
{ CPUFUNC(op_58d8_0), 22744 }, /* Scc */
{ CPUFUNC(op_58e0_0), 22752 }, /* Scc */
{ CPUFUNC(op_58e8_0), 22760 }, /* Scc */
{ CPUFUNC(op_58f0_0), 22768 }, /* Scc */
{ CPUFUNC(op_58f8_0), 22776 }, /* Scc */
{ CPUFUNC(op_58f9_0), 22777 }, /* Scc */
{ CPUFUNC(op_58fa_0), 22778 }, /* TRAPcc */
{ CPUFUNC(op_58fb_0), 22779 }, /* TRAPcc */
{ CPUFUNC(op_58fc_0), 22780 }, /* TRAPcc */
{ CPUFUNC(op_59c0_0), 22976 }, /* Scc */
{ CPUFUNC(op_59c8_0), 22984 }, /* DBcc */
{ CPUFUNC(op_59d0_0), 22992 }, /* Scc */
{ CPUFUNC(op_59d8_0), 23000 }, /* Scc */
{ CPUFUNC(op_59e0_0), 23008 }, /* Scc */
{ CPUFUNC(op_59e8_0), 23016 }, /* Scc */
{ CPUFUNC(op_59f0_0), 23024 }, /* Scc */
{ CPUFUNC(op_59f8_0), 23032 }, /* Scc */
{ CPUFUNC(op_59f9_0), 23033 }, /* Scc */
{ CPUFUNC(op_59fa_0), 23034 }, /* TRAPcc */
{ CPUFUNC(op_59fb_0), 23035 }, /* TRAPcc */
{ CPUFUNC(op_59fc_0), 23036 }, /* TRAPcc */
{ CPUFUNC(op_5ac0_0), 23232 }, /* Scc */
{ CPUFUNC(op_5ac8_0), 23240 }, /* DBcc */
{ CPUFUNC(op_5ad0_0), 23248 }, /* Scc */
{ CPUFUNC(op_5ad8_0), 23256 }, /* Scc */
{ CPUFUNC(op_5ae0_0), 23264 }, /* Scc */
{ CPUFUNC(op_5ae8_0), 23272 }, /* Scc */
{ CPUFUNC(op_5af0_0), 23280 }, /* Scc */
{ CPUFUNC(op_5af8_0), 23288 }, /* Scc */
{ CPUFUNC(op_5af9_0), 23289 }, /* Scc */
{ CPUFUNC(op_5afa_0), 23290 }, /* TRAPcc */
{ CPUFUNC(op_5afb_0), 23291 }, /* TRAPcc */
{ CPUFUNC(op_5afc_0), 23292 }, /* TRAPcc */
{ CPUFUNC(op_5bc0_0), 23488 }, /* Scc */
{ CPUFUNC(op_5bc8_0), 23496 }, /* DBcc */
{ CPUFUNC(op_5bd0_0), 23504 }, /* Scc */
{ CPUFUNC(op_5bd8_0), 23512 }, /* Scc */
{ CPUFUNC(op_5be0_0), 23520 }, /* Scc */
{ CPUFUNC(op_5be8_0), 23528 }, /* Scc */
{ CPUFUNC(op_5bf0_0), 23536 }, /* Scc */
{ CPUFUNC(op_5bf8_0), 23544 }, /* Scc */
{ CPUFUNC(op_5bf9_0), 23545 }, /* Scc */
{ CPUFUNC(op_5bfa_0), 23546 }, /* TRAPcc */
{ CPUFUNC(op_5bfb_0), 23547 }, /* TRAPcc */
{ CPUFUNC(op_5bfc_0), 23548 }, /* TRAPcc */
{ CPUFUNC(op_5cc0_0), 23744 }, /* Scc */
{ CPUFUNC(op_5cc8_0), 23752 }, /* DBcc */
{ CPUFUNC(op_5cd0_0), 23760 }, /* Scc */
{ CPUFUNC(op_5cd8_0), 23768 }, /* Scc */
{ CPUFUNC(op_5ce0_0), 23776 }, /* Scc */
{ CPUFUNC(op_5ce8_0), 23784 }, /* Scc */
{ CPUFUNC(op_5cf0_0), 23792 }, /* Scc */
{ CPUFUNC(op_5cf8_0), 23800 }, /* Scc */
{ CPUFUNC(op_5cf9_0), 23801 }, /* Scc */
{ CPUFUNC(op_5cfa_0), 23802 }, /* TRAPcc */
{ CPUFUNC(op_5cfb_0), 23803 }, /* TRAPcc */
{ CPUFUNC(op_5cfc_0), 23804 }, /* TRAPcc */
{ CPUFUNC(op_5dc0_0), 24000 }, /* Scc */
{ CPUFUNC(op_5dc8_0), 24008 }, /* DBcc */
{ CPUFUNC(op_5dd0_0), 24016 }, /* Scc */
{ CPUFUNC(op_5dd8_0), 24024 }, /* Scc */
{ CPUFUNC(op_5de0_0), 24032 }, /* Scc */
{ CPUFUNC(op_5de8_0), 24040 }, /* Scc */
{ CPUFUNC(op_5df0_0), 24048 }, /* Scc */
{ CPUFUNC(op_5df8_0), 24056 }, /* Scc */
{ CPUFUNC(op_5df9_0), 24057 }, /* Scc */
{ CPUFUNC(op_5dfa_0), 24058 }, /* TRAPcc */
{ CPUFUNC(op_5dfb_0), 24059 }, /* TRAPcc */
{ CPUFUNC(op_5dfc_0), 24060 }, /* TRAPcc */
{ CPUFUNC(op_5ec0_0), 24256 }, /* Scc */
{ CPUFUNC(op_5ec8_0), 24264 }, /* DBcc */
{ CPUFUNC(op_5ed0_0), 24272 }, /* Scc */
{ CPUFUNC(op_5ed8_0), 24280 }, /* Scc */
{ CPUFUNC(op_5ee0_0), 24288 }, /* Scc */
{ CPUFUNC(op_5ee8_0), 24296 }, /* Scc */
{ CPUFUNC(op_5ef0_0), 24304 }, /* Scc */
{ CPUFUNC(op_5ef8_0), 24312 }, /* Scc */
{ CPUFUNC(op_5ef9_0), 24313 }, /* Scc */
{ CPUFUNC(op_5efa_0), 24314 }, /* TRAPcc */
{ CPUFUNC(op_5efb_0), 24315 }, /* TRAPcc */
{ CPUFUNC(op_5efc_0), 24316 }, /* TRAPcc */
{ CPUFUNC(op_5fc0_0), 24512 }, /* Scc */
{ CPUFUNC(op_5fc8_0), 24520 }, /* DBcc */
{ CPUFUNC(op_5fd0_0), 24528 }, /* Scc */
{ CPUFUNC(op_5fd8_0), 24536 }, /* Scc */
{ CPUFUNC(op_5fe0_0), 24544 }, /* Scc */
{ CPUFUNC(op_5fe8_0), 24552 }, /* Scc */
{ CPUFUNC(op_5ff0_0), 24560 }, /* Scc */
{ CPUFUNC(op_5ff8_0), 24568 }, /* Scc */
{ CPUFUNC(op_5ff9_0), 24569 }, /* Scc */
{ CPUFUNC(op_5ffa_0), 24570 }, /* TRAPcc */
{ CPUFUNC(op_5ffb_0), 24571 }, /* TRAPcc */
{ CPUFUNC(op_5ffc_0), 24572 }, /* TRAPcc */
{ CPUFUNC(op_6000_0), 24576 }, /* Bcc */
{ CPUFUNC(op_6001_0), 24577 }, /* Bcc */
{ CPUFUNC(op_60ff_0), 24831 }, /* Bcc */
{ CPUFUNC(op_6100_0), 24832 }, /* BSR */
{ CPUFUNC(op_6101_0), 24833 }, /* BSR */
{ CPUFUNC(op_61ff_0), 25087 }, /* BSR */
{ CPUFUNC(op_6200_0), 25088 }, /* Bcc */
{ CPUFUNC(op_6201_0), 25089 }, /* Bcc */
{ CPUFUNC(op_62ff_0), 25343 }, /* Bcc */
{ CPUFUNC(op_6300_0), 25344 }, /* Bcc */
{ CPUFUNC(op_6301_0), 25345 }, /* Bcc */
{ CPUFUNC(op_63ff_0), 25599 }, /* Bcc */
{ CPUFUNC(op_6400_0), 25600 }, /* Bcc */
{ CPUFUNC(op_6401_0), 25601 }, /* Bcc */
{ CPUFUNC(op_64ff_0), 25855 }, /* Bcc */
{ CPUFUNC(op_6500_0), 25856 }, /* Bcc */
{ CPUFUNC(op_6501_0), 25857 }, /* Bcc */
{ CPUFUNC(op_65ff_0), 26111 }, /* Bcc */
{ CPUFUNC(op_6600_0), 26112 }, /* Bcc */
{ CPUFUNC(op_6601_0), 26113 }, /* Bcc */
{ CPUFUNC(op_66ff_0), 26367 }, /* Bcc */
{ CPUFUNC(op_6700_0), 26368 }, /* Bcc */
{ CPUFUNC(op_6701_0), 26369 }, /* Bcc */
{ CPUFUNC(op_67ff_0), 26623 }, /* Bcc */
{ CPUFUNC(op_6800_0), 26624 }, /* Bcc */
{ CPUFUNC(op_6801_0), 26625 }, /* Bcc */
{ CPUFUNC(op_68ff_0), 26879 }, /* Bcc */
{ CPUFUNC(op_6900_0), 26880 }, /* Bcc */
{ CPUFUNC(op_6901_0), 26881 }, /* Bcc */
{ CPUFUNC(op_69ff_0), 27135 }, /* Bcc */
{ CPUFUNC(op_6a00_0), 27136 }, /* Bcc */
{ CPUFUNC(op_6a01_0), 27137 }, /* Bcc */
{ CPUFUNC(op_6aff_0), 27391 }, /* Bcc */
{ CPUFUNC(op_6b00_0), 27392 }, /* Bcc */
{ CPUFUNC(op_6b01_0), 27393 }, /* Bcc */
{ CPUFUNC(op_6bff_0), 27647 }, /* Bcc */
{ CPUFUNC(op_6c00_0), 27648 }, /* Bcc */
{ CPUFUNC(op_6c01_0), 27649 }, /* Bcc */
{ CPUFUNC(op_6cff_0), 27903 }, /* Bcc */
{ CPUFUNC(op_6d00_0), 27904 }, /* Bcc */
{ CPUFUNC(op_6d01_0), 27905 }, /* Bcc */
{ CPUFUNC(op_6dff_0), 28159 }, /* Bcc */
{ CPUFUNC(op_6e00_0), 28160 }, /* Bcc */
{ CPUFUNC(op_6e01_0), 28161 }, /* Bcc */
{ CPUFUNC(op_6eff_0), 28415 }, /* Bcc */
{ CPUFUNC(op_6f00_0), 28416 }, /* Bcc */
{ CPUFUNC(op_6f01_0), 28417 }, /* Bcc */
{ CPUFUNC(op_6fff_0), 28671 }, /* Bcc */
{ CPUFUNC(op_7000_0), 28672 }, /* MOVE */
{ CPUFUNC(op_8000_0), 32768 }, /* OR */
{ CPUFUNC(op_8010_0), 32784 }, /* OR */
{ CPUFUNC(op_8018_0), 32792 }, /* OR */
{ CPUFUNC(op_8020_0), 32800 }, /* OR */
{ CPUFUNC(op_8028_0), 32808 }, /* OR */
{ CPUFUNC(op_8030_0), 32816 }, /* OR */
{ CPUFUNC(op_8038_0), 32824 }, /* OR */
{ CPUFUNC(op_8039_0), 32825 }, /* OR */
{ CPUFUNC(op_803a_0), 32826 }, /* OR */
{ CPUFUNC(op_803b_0), 32827 }, /* OR */
{ CPUFUNC(op_803c_0), 32828 }, /* OR */
{ CPUFUNC(op_8040_0), 32832 }, /* OR */
{ CPUFUNC(op_8050_0), 32848 }, /* OR */
{ CPUFUNC(op_8058_0), 32856 }, /* OR */
{ CPUFUNC(op_8060_0), 32864 }, /* OR */
{ CPUFUNC(op_8068_0), 32872 }, /* OR */
{ CPUFUNC(op_8070_0), 32880 }, /* OR */
{ CPUFUNC(op_8078_0), 32888 }, /* OR */
{ CPUFUNC(op_8079_0), 32889 }, /* OR */
{ CPUFUNC(op_807a_0), 32890 }, /* OR */
{ CPUFUNC(op_807b_0), 32891 }, /* OR */
{ CPUFUNC(op_807c_0), 32892 }, /* OR */
{ CPUFUNC(op_8080_0), 32896 }, /* OR */
{ CPUFUNC(op_8090_0), 32912 }, /* OR */
{ CPUFUNC(op_8098_0), 32920 }, /* OR */
{ CPUFUNC(op_80a0_0), 32928 }, /* OR */
{ CPUFUNC(op_80a8_0), 32936 }, /* OR */
{ CPUFUNC(op_80b0_0), 32944 }, /* OR */
{ CPUFUNC(op_80b8_0), 32952 }, /* OR */
{ CPUFUNC(op_80b9_0), 32953 }, /* OR */
{ CPUFUNC(op_80ba_0), 32954 }, /* OR */
{ CPUFUNC(op_80bb_0), 32955 }, /* OR */
{ CPUFUNC(op_80bc_0), 32956 }, /* OR */
{ CPUFUNC(op_80c0_0), 32960 }, /* DIVU */
{ CPUFUNC(op_80d0_0), 32976 }, /* DIVU */
{ CPUFUNC(op_80d8_0), 32984 }, /* DIVU */
{ CPUFUNC(op_80e0_0), 32992 }, /* DIVU */
{ CPUFUNC(op_80e8_0), 33000 }, /* DIVU */
{ CPUFUNC(op_80f0_0), 33008 }, /* DIVU */
{ CPUFUNC(op_80f8_0), 33016 }, /* DIVU */
{ CPUFUNC(op_80f9_0), 33017 }, /* DIVU */
{ CPUFUNC(op_80fa_0), 33018 }, /* DIVU */
{ CPUFUNC(op_80fb_0), 33019 }, /* DIVU */
{ CPUFUNC(op_80fc_0), 33020 }, /* DIVU */
{ CPUFUNC(op_8100_2), 33024 }, /* SBCD */
{ CPUFUNC(op_8108_2), 33032 }, /* SBCD */
{ CPUFUNC(op_8110_0), 33040 }, /* OR */
{ CPUFUNC(op_8118_0), 33048 }, /* OR */
{ CPUFUNC(op_8120_0), 33056 }, /* OR */
{ CPUFUNC(op_8128_0), 33064 }, /* OR */
{ CPUFUNC(op_8130_0), 33072 }, /* OR */
{ CPUFUNC(op_8138_0), 33080 }, /* OR */
{ CPUFUNC(op_8139_0), 33081 }, /* OR */
{ CPUFUNC(op_8140_0), 33088 }, /* PACK */
{ CPUFUNC(op_8148_0), 33096 }, /* PACK */
{ CPUFUNC(op_8150_0), 33104 }, /* OR */
{ CPUFUNC(op_8158_0), 33112 }, /* OR */
{ CPUFUNC(op_8160_0), 33120 }, /* OR */
{ CPUFUNC(op_8168_0), 33128 }, /* OR */
{ CPUFUNC(op_8170_0), 33136 }, /* OR */
{ CPUFUNC(op_8178_0), 33144 }, /* OR */
{ CPUFUNC(op_8179_0), 33145 }, /* OR */
{ CPUFUNC(op_8180_0), 33152 }, /* UNPK */
{ CPUFUNC(op_8188_0), 33160 }, /* UNPK */
{ CPUFUNC(op_8190_0), 33168 }, /* OR */
{ CPUFUNC(op_8198_0), 33176 }, /* OR */
{ CPUFUNC(op_81a0_0), 33184 }, /* OR */
{ CPUFUNC(op_81a8_0), 33192 }, /* OR */
{ CPUFUNC(op_81b0_0), 33200 }, /* OR */
{ CPUFUNC(op_81b8_0), 33208 }, /* OR */
{ CPUFUNC(op_81b9_0), 33209 }, /* OR */
{ CPUFUNC(op_81c0_0), 33216 }, /* DIVS */
{ CPUFUNC(op_81d0_0), 33232 }, /* DIVS */
{ CPUFUNC(op_81d8_0), 33240 }, /* DIVS */
{ CPUFUNC(op_81e0_0), 33248 }, /* DIVS */
{ CPUFUNC(op_81e8_0), 33256 }, /* DIVS */
{ CPUFUNC(op_81f0_0), 33264 }, /* DIVS */
{ CPUFUNC(op_81f8_0), 33272 }, /* DIVS */
{ CPUFUNC(op_81f9_0), 33273 }, /* DIVS */
{ CPUFUNC(op_81fa_0), 33274 }, /* DIVS */
{ CPUFUNC(op_81fb_0), 33275 }, /* DIVS */
{ CPUFUNC(op_81fc_0), 33276 }, /* DIVS */
{ CPUFUNC(op_9000_0), 36864 }, /* SUB */
{ CPUFUNC(op_9010_0), 36880 }, /* SUB */
{ CPUFUNC(op_9018_0), 36888 }, /* SUB */
{ CPUFUNC(op_9020_0), 36896 }, /* SUB */
{ CPUFUNC(op_9028_0), 36904 }, /* SUB */
{ CPUFUNC(op_9030_0), 36912 }, /* SUB */
{ CPUFUNC(op_9038_0), 36920 }, /* SUB */
{ CPUFUNC(op_9039_0), 36921 }, /* SUB */
{ CPUFUNC(op_903a_0), 36922 }, /* SUB */
{ CPUFUNC(op_903b_0), 36923 }, /* SUB */
{ CPUFUNC(op_903c_0), 36924 }, /* SUB */
{ CPUFUNC(op_9040_0), 36928 }, /* SUB */
{ CPUFUNC(op_9048_0), 36936 }, /* SUB */
{ CPUFUNC(op_9050_0), 36944 }, /* SUB */
{ CPUFUNC(op_9058_0), 36952 }, /* SUB */
{ CPUFUNC(op_9060_0), 36960 }, /* SUB */
{ CPUFUNC(op_9068_0), 36968 }, /* SUB */
{ CPUFUNC(op_9070_0), 36976 }, /* SUB */
{ CPUFUNC(op_9078_0), 36984 }, /* SUB */
{ CPUFUNC(op_9079_0), 36985 }, /* SUB */
{ CPUFUNC(op_907a_0), 36986 }, /* SUB */
{ CPUFUNC(op_907b_0), 36987 }, /* SUB */
{ CPUFUNC(op_907c_0), 36988 }, /* SUB */
{ CPUFUNC(op_9080_0), 36992 }, /* SUB */
{ CPUFUNC(op_9088_0), 37000 }, /* SUB */
{ CPUFUNC(op_9090_0), 37008 }, /* SUB */
{ CPUFUNC(op_9098_0), 37016 }, /* SUB */
{ CPUFUNC(op_90a0_0), 37024 }, /* SUB */
{ CPUFUNC(op_90a8_0), 37032 }, /* SUB */
{ CPUFUNC(op_90b0_0), 37040 }, /* SUB */
{ CPUFUNC(op_90b8_0), 37048 }, /* SUB */
{ CPUFUNC(op_90b9_0), 37049 }, /* SUB */
{ CPUFUNC(op_90ba_0), 37050 }, /* SUB */
{ CPUFUNC(op_90bb_0), 37051 }, /* SUB */
{ CPUFUNC(op_90bc_0), 37052 }, /* SUB */
{ CPUFUNC(op_90c0_0), 37056 }, /* SUBA */
{ CPUFUNC(op_90c8_0), 37064 }, /* SUBA */
{ CPUFUNC(op_90d0_0), 37072 }, /* SUBA */
{ CPUFUNC(op_90d8_0), 37080 }, /* SUBA */
{ CPUFUNC(op_90e0_0), 37088 }, /* SUBA */
{ CPUFUNC(op_90e8_0), 37096 }, /* SUBA */
{ CPUFUNC(op_90f0_0), 37104 }, /* SUBA */
{ CPUFUNC(op_90f8_0), 37112 }, /* SUBA */
{ CPUFUNC(op_90f9_0), 37113 }, /* SUBA */
{ CPUFUNC(op_90fa_0), 37114 }, /* SUBA */
{ CPUFUNC(op_90fb_0), 37115 }, /* SUBA */
{ CPUFUNC(op_90fc_0), 37116 }, /* SUBA */
{ CPUFUNC(op_9100_0), 37120 }, /* SUBX */
{ CPUFUNC(op_9108_0), 37128 }, /* SUBX */
{ CPUFUNC(op_9110_0), 37136 }, /* SUB */
{ CPUFUNC(op_9118_0), 37144 }, /* SUB */
{ CPUFUNC(op_9120_0), 37152 }, /* SUB */
{ CPUFUNC(op_9128_0), 37160 }, /* SUB */
{ CPUFUNC(op_9130_0), 37168 }, /* SUB */
{ CPUFUNC(op_9138_0), 37176 }, /* SUB */
{ CPUFUNC(op_9139_0), 37177 }, /* SUB */
{ CPUFUNC(op_9140_0), 37184 }, /* SUBX */
{ CPUFUNC(op_9148_0), 37192 }, /* SUBX */
{ CPUFUNC(op_9150_0), 37200 }, /* SUB */
{ CPUFUNC(op_9158_0), 37208 }, /* SUB */
{ CPUFUNC(op_9160_0), 37216 }, /* SUB */
{ CPUFUNC(op_9168_0), 37224 }, /* SUB */
{ CPUFUNC(op_9170_0), 37232 }, /* SUB */
{ CPUFUNC(op_9178_0), 37240 }, /* SUB */
{ CPUFUNC(op_9179_0), 37241 }, /* SUB */
{ CPUFUNC(op_9180_0), 37248 }, /* SUBX */
{ CPUFUNC(op_9188_0), 37256 }, /* SUBX */
{ CPUFUNC(op_9190_0), 37264 }, /* SUB */
{ CPUFUNC(op_9198_0), 37272 }, /* SUB */
{ CPUFUNC(op_91a0_0), 37280 }, /* SUB */
{ CPUFUNC(op_91a8_0), 37288 }, /* SUB */
{ CPUFUNC(op_91b0_0), 37296 }, /* SUB */
{ CPUFUNC(op_91b8_0), 37304 }, /* SUB */
{ CPUFUNC(op_91b9_0), 37305 }, /* SUB */
{ CPUFUNC(op_91c0_0), 37312 }, /* SUBA */
{ CPUFUNC(op_91c8_0), 37320 }, /* SUBA */
{ CPUFUNC(op_91d0_0), 37328 }, /* SUBA */
{ CPUFUNC(op_91d8_0), 37336 }, /* SUBA */
{ CPUFUNC(op_91e0_0), 37344 }, /* SUBA */
{ CPUFUNC(op_91e8_0), 37352 }, /* SUBA */
{ CPUFUNC(op_91f0_0), 37360 }, /* SUBA */
{ CPUFUNC(op_91f8_0), 37368 }, /* SUBA */
{ CPUFUNC(op_91f9_0), 37369 }, /* SUBA */
{ CPUFUNC(op_91fa_0), 37370 }, /* SUBA */
{ CPUFUNC(op_91fb_0), 37371 }, /* SUBA */
{ CPUFUNC(op_91fc_0), 37372 }, /* SUBA */
{ CPUFUNC(op_b000_0), 45056 }, /* CMP */
{ CPUFUNC(op_b010_0), 45072 }, /* CMP */
{ CPUFUNC(op_b018_0), 45080 }, /* CMP */
{ CPUFUNC(op_b020_0), 45088 }, /* CMP */
{ CPUFUNC(op_b028_0), 45096 }, /* CMP */
{ CPUFUNC(op_b030_0), 45104 }, /* CMP */
{ CPUFUNC(op_b038_0), 45112 }, /* CMP */
{ CPUFUNC(op_b039_0), 45113 }, /* CMP */
{ CPUFUNC(op_b03a_0), 45114 }, /* CMP */
{ CPUFUNC(op_b03b_0), 45115 }, /* CMP */
{ CPUFUNC(op_b03c_0), 45116 }, /* CMP */
{ CPUFUNC(op_b040_0), 45120 }, /* CMP */
{ CPUFUNC(op_b048_0), 45128 }, /* CMP */
{ CPUFUNC(op_b050_0), 45136 }, /* CMP */
{ CPUFUNC(op_b058_0), 45144 }, /* CMP */
{ CPUFUNC(op_b060_0), 45152 }, /* CMP */
{ CPUFUNC(op_b068_0), 45160 }, /* CMP */
{ CPUFUNC(op_b070_0), 45168 }, /* CMP */
{ CPUFUNC(op_b078_0), 45176 }, /* CMP */
{ CPUFUNC(op_b079_0), 45177 }, /* CMP */
{ CPUFUNC(op_b07a_0), 45178 }, /* CMP */
{ CPUFUNC(op_b07b_0), 45179 }, /* CMP */
{ CPUFUNC(op_b07c_0), 45180 }, /* CMP */
{ CPUFUNC(op_b080_0), 45184 }, /* CMP */
{ CPUFUNC(op_b088_0), 45192 }, /* CMP */
{ CPUFUNC(op_b090_0), 45200 }, /* CMP */
{ CPUFUNC(op_b098_0), 45208 }, /* CMP */
{ CPUFUNC(op_b0a0_0), 45216 }, /* CMP */
{ CPUFUNC(op_b0a8_0), 45224 }, /* CMP */
{ CPUFUNC(op_b0b0_0), 45232 }, /* CMP */
{ CPUFUNC(op_b0b8_0), 45240 }, /* CMP */
{ CPUFUNC(op_b0b9_0), 45241 }, /* CMP */
{ CPUFUNC(op_b0ba_0), 45242 }, /* CMP */
{ CPUFUNC(op_b0bb_0), 45243 }, /* CMP */
{ CPUFUNC(op_b0bc_0), 45244 }, /* CMP */
{ CPUFUNC(op_b0c0_0), 45248 }, /* CMPA */
{ CPUFUNC(op_b0c8_0), 45256 }, /* CMPA */
{ CPUFUNC(op_b0d0_0), 45264 }, /* CMPA */
{ CPUFUNC(op_b0d8_0), 45272 }, /* CMPA */
{ CPUFUNC(op_b0e0_0), 45280 }, /* CMPA */
{ CPUFUNC(op_b0e8_0), 45288 }, /* CMPA */
{ CPUFUNC(op_b0f0_0), 45296 }, /* CMPA */
{ CPUFUNC(op_b0f8_0), 45304 }, /* CMPA */
{ CPUFUNC(op_b0f9_0), 45305 }, /* CMPA */
{ CPUFUNC(op_b0fa_0), 45306 }, /* CMPA */
{ CPUFUNC(op_b0fb_0), 45307 }, /* CMPA */
{ CPUFUNC(op_b0fc_0), 45308 }, /* CMPA */
{ CPUFUNC(op_b100_0), 45312 }, /* EOR */
{ CPUFUNC(op_b108_0), 45320 }, /* CMPM */
{ CPUFUNC(op_b110_0), 45328 }, /* EOR */
{ CPUFUNC(op_b118_0), 45336 }, /* EOR */
{ CPUFUNC(op_b120_0), 45344 }, /* EOR */
{ CPUFUNC(op_b128_0), 45352 }, /* EOR */
{ CPUFUNC(op_b130_0), 45360 }, /* EOR */
{ CPUFUNC(op_b138_0), 45368 }, /* EOR */
{ CPUFUNC(op_b139_0), 45369 }, /* EOR */
{ CPUFUNC(op_b140_0), 45376 }, /* EOR */
{ CPUFUNC(op_b148_0), 45384 }, /* CMPM */
{ CPUFUNC(op_b150_0), 45392 }, /* EOR */
{ CPUFUNC(op_b158_0), 45400 }, /* EOR */
{ CPUFUNC(op_b160_0), 45408 }, /* EOR */
{ CPUFUNC(op_b168_0), 45416 }, /* EOR */
{ CPUFUNC(op_b170_0), 45424 }, /* EOR */
{ CPUFUNC(op_b178_0), 45432 }, /* EOR */
{ CPUFUNC(op_b179_0), 45433 }, /* EOR */
{ CPUFUNC(op_b180_0), 45440 }, /* EOR */
{ CPUFUNC(op_b188_0), 45448 }, /* CMPM */
{ CPUFUNC(op_b190_0), 45456 }, /* EOR */
{ CPUFUNC(op_b198_0), 45464 }, /* EOR */
{ CPUFUNC(op_b1a0_0), 45472 }, /* EOR */
{ CPUFUNC(op_b1a8_0), 45480 }, /* EOR */
{ CPUFUNC(op_b1b0_0), 45488 }, /* EOR */
{ CPUFUNC(op_b1b8_0), 45496 }, /* EOR */
{ CPUFUNC(op_b1b9_0), 45497 }, /* EOR */
{ CPUFUNC(op_b1c0_0), 45504 }, /* CMPA */
{ CPUFUNC(op_b1c8_0), 45512 }, /* CMPA */
{ CPUFUNC(op_b1d0_0), 45520 }, /* CMPA */
{ CPUFUNC(op_b1d8_0), 45528 }, /* CMPA */
{ CPUFUNC(op_b1e0_0), 45536 }, /* CMPA */
{ CPUFUNC(op_b1e8_0), 45544 }, /* CMPA */
{ CPUFUNC(op_b1f0_0), 45552 }, /* CMPA */
{ CPUFUNC(op_b1f8_0), 45560 }, /* CMPA */
{ CPUFUNC(op_b1f9_0), 45561 }, /* CMPA */
{ CPUFUNC(op_b1fa_0), 45562 }, /* CMPA */
{ CPUFUNC(op_b1fb_0), 45563 }, /* CMPA */
{ CPUFUNC(op_b1fc_0), 45564 }, /* CMPA */
{ CPUFUNC(op_c000_0), 49152 }, /* AND */
{ CPUFUNC(op_c010_0), 49168 }, /* AND */
{ CPUFUNC(op_c018_0), 49176 }, /* AND */
{ CPUFUNC(op_c020_0), 49184 }, /* AND */
{ CPUFUNC(op_c028_0), 49192 }, /* AND */
{ CPUFUNC(op_c030_0), 49200 }, /* AND */
{ CPUFUNC(op_c038_0), 49208 }, /* AND */
{ CPUFUNC(op_c039_0), 49209 }, /* AND */
{ CPUFUNC(op_c03a_0), 49210 }, /* AND */
{ CPUFUNC(op_c03b_0), 49211 }, /* AND */
{ CPUFUNC(op_c03c_0), 49212 }, /* AND */
{ CPUFUNC(op_c040_0), 49216 }, /* AND */
{ CPUFUNC(op_c050_0), 49232 }, /* AND */
{ CPUFUNC(op_c058_0), 49240 }, /* AND */
{ CPUFUNC(op_c060_0), 49248 }, /* AND */
{ CPUFUNC(op_c068_0), 49256 }, /* AND */
{ CPUFUNC(op_c070_0), 49264 }, /* AND */
{ CPUFUNC(op_c078_0), 49272 }, /* AND */
{ CPUFUNC(op_c079_0), 49273 }, /* AND */
{ CPUFUNC(op_c07a_0), 49274 }, /* AND */
{ CPUFUNC(op_c07b_0), 49275 }, /* AND */
{ CPUFUNC(op_c07c_0), 49276 }, /* AND */
{ CPUFUNC(op_c080_0), 49280 }, /* AND */
{ CPUFUNC(op_c090_0), 49296 }, /* AND */
{ CPUFUNC(op_c098_0), 49304 }, /* AND */
{ CPUFUNC(op_c0a0_0), 49312 }, /* AND */
{ CPUFUNC(op_c0a8_0), 49320 }, /* AND */
{ CPUFUNC(op_c0b0_0), 49328 }, /* AND */
{ CPUFUNC(op_c0b8_0), 49336 }, /* AND */
{ CPUFUNC(op_c0b9_0), 49337 }, /* AND */
{ CPUFUNC(op_c0ba_0), 49338 }, /* AND */
{ CPUFUNC(op_c0bb_0), 49339 }, /* AND */
{ CPUFUNC(op_c0bc_0), 49340 }, /* AND */
{ CPUFUNC(op_c0c0_0), 49344 }, /* MULU */
{ CPUFUNC(op_c0d0_0), 49360 }, /* MULU */
{ CPUFUNC(op_c0d8_0), 49368 }, /* MULU */
{ CPUFUNC(op_c0e0_0), 49376 }, /* MULU */
{ CPUFUNC(op_c0e8_0), 49384 }, /* MULU */
{ CPUFUNC(op_c0f0_0), 49392 }, /* MULU */
{ CPUFUNC(op_c0f8_0), 49400 }, /* MULU */
{ CPUFUNC(op_c0f9_0), 49401 }, /* MULU */
{ CPUFUNC(op_c0fa_0), 49402 }, /* MULU */
{ CPUFUNC(op_c0fb_0), 49403 }, /* MULU */
{ CPUFUNC(op_c0fc_0), 49404 }, /* MULU */
{ CPUFUNC(op_c100_2), 49408 }, /* ABCD */
{ CPUFUNC(op_c108_2), 49416 }, /* ABCD */
{ CPUFUNC(op_c110_0), 49424 }, /* AND */
{ CPUFUNC(op_c118_0), 49432 }, /* AND */
{ CPUFUNC(op_c120_0), 49440 }, /* AND */
{ CPUFUNC(op_c128_0), 49448 }, /* AND */
{ CPUFUNC(op_c130_0), 49456 }, /* AND */
{ CPUFUNC(op_c138_0), 49464 }, /* AND */
{ CPUFUNC(op_c139_0), 49465 }, /* AND */
{ CPUFUNC(op_c140_0), 49472 }, /* EXG */
{ CPUFUNC(op_c148_0), 49480 }, /* EXG */
{ CPUFUNC(op_c150_0), 49488 }, /* AND */
{ CPUFUNC(op_c158_0), 49496 }, /* AND */
{ CPUFUNC(op_c160_0), 49504 }, /* AND */
{ CPUFUNC(op_c168_0), 49512 }, /* AND */
{ CPUFUNC(op_c170_0), 49520 }, /* AND */
{ CPUFUNC(op_c178_0), 49528 }, /* AND */
{ CPUFUNC(op_c179_0), 49529 }, /* AND */
{ CPUFUNC(op_c188_0), 49544 }, /* EXG */
{ CPUFUNC(op_c190_0), 49552 }, /* AND */
{ CPUFUNC(op_c198_0), 49560 }, /* AND */
{ CPUFUNC(op_c1a0_0), 49568 }, /* AND */
{ CPUFUNC(op_c1a8_0), 49576 }, /* AND */
{ CPUFUNC(op_c1b0_0), 49584 }, /* AND */
{ CPUFUNC(op_c1b8_0), 49592 }, /* AND */
{ CPUFUNC(op_c1b9_0), 49593 }, /* AND */
{ CPUFUNC(op_c1c0_0), 49600 }, /* MULS */
{ CPUFUNC(op_c1d0_0), 49616 }, /* MULS */
{ CPUFUNC(op_c1d8_0), 49624 }, /* MULS */
{ CPUFUNC(op_c1e0_0), 49632 }, /* MULS */
{ CPUFUNC(op_c1e8_0), 49640 }, /* MULS */
{ CPUFUNC(op_c1f0_0), 49648 }, /* MULS */
{ CPUFUNC(op_c1f8_0), 49656 }, /* MULS */
{ CPUFUNC(op_c1f9_0), 49657 }, /* MULS */
{ CPUFUNC(op_c1fa_0), 49658 }, /* MULS */
{ CPUFUNC(op_c1fb_0), 49659 }, /* MULS */
{ CPUFUNC(op_c1fc_0), 49660 }, /* MULS */
{ CPUFUNC(op_d000_0), 53248 }, /* ADD */
{ CPUFUNC(op_d010_0), 53264 }, /* ADD */
{ CPUFUNC(op_d018_0), 53272 }, /* ADD */
{ CPUFUNC(op_d020_0), 53280 }, /* ADD */
{ CPUFUNC(op_d028_0), 53288 }, /* ADD */
{ CPUFUNC(op_d030_0), 53296 }, /* ADD */
{ CPUFUNC(op_d038_0), 53304 }, /* ADD */
{ CPUFUNC(op_d039_0), 53305 }, /* ADD */
{ CPUFUNC(op_d03a_0), 53306 }, /* ADD */
{ CPUFUNC(op_d03b_0), 53307 }, /* ADD */
{ CPUFUNC(op_d03c_0), 53308 }, /* ADD */
{ CPUFUNC(op_d040_0), 53312 }, /* ADD */
{ CPUFUNC(op_d048_0), 53320 }, /* ADD */
{ CPUFUNC(op_d050_0), 53328 }, /* ADD */
{ CPUFUNC(op_d058_0), 53336 }, /* ADD */
{ CPUFUNC(op_d060_0), 53344 }, /* ADD */
{ CPUFUNC(op_d068_0), 53352 }, /* ADD */
{ CPUFUNC(op_d070_0), 53360 }, /* ADD */
{ CPUFUNC(op_d078_0), 53368 }, /* ADD */
{ CPUFUNC(op_d079_0), 53369 }, /* ADD */
{ CPUFUNC(op_d07a_0), 53370 }, /* ADD */
{ CPUFUNC(op_d07b_0), 53371 }, /* ADD */
{ CPUFUNC(op_d07c_0), 53372 }, /* ADD */
{ CPUFUNC(op_d080_0), 53376 }, /* ADD */
{ CPUFUNC(op_d088_0), 53384 }, /* ADD */
{ CPUFUNC(op_d090_0), 53392 }, /* ADD */
{ CPUFUNC(op_d098_0), 53400 }, /* ADD */
{ CPUFUNC(op_d0a0_0), 53408 }, /* ADD */
{ CPUFUNC(op_d0a8_0), 53416 }, /* ADD */
{ CPUFUNC(op_d0b0_0), 53424 }, /* ADD */
{ CPUFUNC(op_d0b8_0), 53432 }, /* ADD */
{ CPUFUNC(op_d0b9_0), 53433 }, /* ADD */
{ CPUFUNC(op_d0ba_0), 53434 }, /* ADD */
{ CPUFUNC(op_d0bb_0), 53435 }, /* ADD */
{ CPUFUNC(op_d0bc_0), 53436 }, /* ADD */
{ CPUFUNC(op_d0c0_0), 53440 }, /* ADDA */
{ CPUFUNC(op_d0c8_0), 53448 }, /* ADDA */
{ CPUFUNC(op_d0d0_0), 53456 }, /* ADDA */
{ CPUFUNC(op_d0d8_0), 53464 }, /* ADDA */
{ CPUFUNC(op_d0e0_0), 53472 }, /* ADDA */
{ CPUFUNC(op_d0e8_0), 53480 }, /* ADDA */
{ CPUFUNC(op_d0f0_0), 53488 }, /* ADDA */
{ CPUFUNC(op_d0f8_0), 53496 }, /* ADDA */
{ CPUFUNC(op_d0f9_0), 53497 }, /* ADDA */
{ CPUFUNC(op_d0fa_0), 53498 }, /* ADDA */
{ CPUFUNC(op_d0fb_0), 53499 }, /* ADDA */
{ CPUFUNC(op_d0fc_0), 53500 }, /* ADDA */
{ CPUFUNC(op_d100_0), 53504 }, /* ADDX */
{ CPUFUNC(op_d108_0), 53512 }, /* ADDX */
{ CPUFUNC(op_d110_0), 53520 }, /* ADD */
{ CPUFUNC(op_d118_0), 53528 }, /* ADD */
{ CPUFUNC(op_d120_0), 53536 }, /* ADD */
{ CPUFUNC(op_d128_0), 53544 }, /* ADD */
{ CPUFUNC(op_d130_0), 53552 }, /* ADD */
{ CPUFUNC(op_d138_0), 53560 }, /* ADD */
{ CPUFUNC(op_d139_0), 53561 }, /* ADD */
{ CPUFUNC(op_d140_0), 53568 }, /* ADDX */
{ CPUFUNC(op_d148_0), 53576 }, /* ADDX */
{ CPUFUNC(op_d150_0), 53584 }, /* ADD */
{ CPUFUNC(op_d158_0), 53592 }, /* ADD */
{ CPUFUNC(op_d160_0), 53600 }, /* ADD */
{ CPUFUNC(op_d168_0), 53608 }, /* ADD */
{ CPUFUNC(op_d170_0), 53616 }, /* ADD */
{ CPUFUNC(op_d178_0), 53624 }, /* ADD */
{ CPUFUNC(op_d179_0), 53625 }, /* ADD */
{ CPUFUNC(op_d180_0), 53632 }, /* ADDX */
{ CPUFUNC(op_d188_0), 53640 }, /* ADDX */
{ CPUFUNC(op_d190_0), 53648 }, /* ADD */
{ CPUFUNC(op_d198_0), 53656 }, /* ADD */
{ CPUFUNC(op_d1a0_0), 53664 }, /* ADD */
{ CPUFUNC(op_d1a8_0), 53672 }, /* ADD */
{ CPUFUNC(op_d1b0_0), 53680 }, /* ADD */
{ CPUFUNC(op_d1b8_0), 53688 }, /* ADD */
{ CPUFUNC(op_d1b9_0), 53689 }, /* ADD */
{ CPUFUNC(op_d1c0_0), 53696 }, /* ADDA */
{ CPUFUNC(op_d1c8_0), 53704 }, /* ADDA */
{ CPUFUNC(op_d1d0_0), 53712 }, /* ADDA */
{ CPUFUNC(op_d1d8_0), 53720 }, /* ADDA */
{ CPUFUNC(op_d1e0_0), 53728 }, /* ADDA */
{ CPUFUNC(op_d1e8_0), 53736 }, /* ADDA */
{ CPUFUNC(op_d1f0_0), 53744 }, /* ADDA */
{ CPUFUNC(op_d1f8_0), 53752 }, /* ADDA */
{ CPUFUNC(op_d1f9_0), 53753 }, /* ADDA */
{ CPUFUNC(op_d1fa_0), 53754 }, /* ADDA */
{ CPUFUNC(op_d1fb_0), 53755 }, /* ADDA */
{ CPUFUNC(op_d1fc_0), 53756 }, /* ADDA */
{ CPUFUNC(op_e000_0), 57344 }, /* ASR */
{ CPUFUNC(op_e008_0), 57352 }, /* LSR */
{ CPUFUNC(op_e010_0), 57360 }, /* ROXR */
{ CPUFUNC(op_e018_0), 57368 }, /* ROR */
{ CPUFUNC(op_e020_0), 57376 }, /* ASR */
{ CPUFUNC(op_e028_0), 57384 }, /* LSR */
{ CPUFUNC(op_e030_0), 57392 }, /* ROXR */
{ CPUFUNC(op_e038_0), 57400 }, /* ROR */
{ CPUFUNC(op_e040_0), 57408 }, /* ASR */
{ CPUFUNC(op_e048_0), 57416 }, /* LSR */
{ CPUFUNC(op_e050_0), 57424 }, /* ROXR */
{ CPUFUNC(op_e058_0), 57432 }, /* ROR */
{ CPUFUNC(op_e060_0), 57440 }, /* ASR */
{ CPUFUNC(op_e068_0), 57448 }, /* LSR */
{ CPUFUNC(op_e070_0), 57456 }, /* ROXR */
{ CPUFUNC(op_e078_0), 57464 }, /* ROR */
{ CPUFUNC(op_e080_0), 57472 }, /* ASR */
{ CPUFUNC(op_e088_0), 57480 }, /* LSR */
{ CPUFUNC(op_e090_0), 57488 }, /* ROXR */
{ CPUFUNC(op_e098_0), 57496 }, /* ROR */
{ CPUFUNC(op_e0a0_0), 57504 }, /* ASR */
{ CPUFUNC(op_e0a8_0), 57512 }, /* LSR */
{ CPUFUNC(op_e0b0_0), 57520 }, /* ROXR */
{ CPUFUNC(op_e0b8_0), 57528 }, /* ROR */
{ CPUFUNC(op_e0d0_0), 57552 }, /* ASRW */
{ CPUFUNC(op_e0d8_0), 57560 }, /* ASRW */
{ CPUFUNC(op_e0e0_0), 57568 }, /* ASRW */
{ CPUFUNC(op_e0e8_0), 57576 }, /* ASRW */
{ CPUFUNC(op_e0f0_0), 57584 }, /* ASRW */
{ CPUFUNC(op_e0f8_0), 57592 }, /* ASRW */
{ CPUFUNC(op_e0f9_0), 57593 }, /* ASRW */
{ CPUFUNC(op_e100_0), 57600 }, /* ASL */
{ CPUFUNC(op_e108_0), 57608 }, /* LSL */
{ CPUFUNC(op_e110_0), 57616 }, /* ROXL */
{ CPUFUNC(op_e118_0), 57624 }, /* ROL */
{ CPUFUNC(op_e120_0), 57632 }, /* ASL */
{ CPUFUNC(op_e128_0), 57640 }, /* LSL */
{ CPUFUNC(op_e130_0), 57648 }, /* ROXL */
{ CPUFUNC(op_e138_0), 57656 }, /* ROL */
{ CPUFUNC(op_e140_0), 57664 }, /* ASL */
{ CPUFUNC(op_e148_0), 57672 }, /* LSL */
{ CPUFUNC(op_e150_0), 57680 }, /* ROXL */
{ CPUFUNC(op_e158_0), 57688 }, /* ROL */
{ CPUFUNC(op_e160_0), 57696 }, /* ASL */
{ CPUFUNC(op_e168_0), 57704 }, /* LSL */
{ CPUFUNC(op_e170_0), 57712 }, /* ROXL */
{ CPUFUNC(op_e178_0), 57720 }, /* ROL */
{ CPUFUNC(op_e180_0), 57728 }, /* ASL */
{ CPUFUNC(op_e188_0), 57736 }, /* LSL */
{ CPUFUNC(op_e190_0), 57744 }, /* ROXL */
{ CPUFUNC(op_e198_0), 57752 }, /* ROL */
{ CPUFUNC(op_e1a0_0), 57760 }, /* ASL */
{ CPUFUNC(op_e1a8_0), 57768 }, /* LSL */
{ CPUFUNC(op_e1b0_0), 57776 }, /* ROXL */
{ CPUFUNC(op_e1b8_0), 57784 }, /* ROL */
{ CPUFUNC(op_e1d0_0), 57808 }, /* ASLW */
{ CPUFUNC(op_e1d8_0), 57816 }, /* ASLW */
{ CPUFUNC(op_e1e0_0), 57824 }, /* ASLW */
{ CPUFUNC(op_e1e8_0), 57832 }, /* ASLW */
{ CPUFUNC(op_e1f0_0), 57840 }, /* ASLW */
{ CPUFUNC(op_e1f8_0), 57848 }, /* ASLW */
{ CPUFUNC(op_e1f9_0), 57849 }, /* ASLW */
{ CPUFUNC(op_e2d0_0), 58064 }, /* LSRW */
{ CPUFUNC(op_e2d8_0), 58072 }, /* LSRW */
{ CPUFUNC(op_e2e0_0), 58080 }, /* LSRW */
{ CPUFUNC(op_e2e8_0), 58088 }, /* LSRW */
{ CPUFUNC(op_e2f0_0), 58096 }, /* LSRW */
{ CPUFUNC(op_e2f8_0), 58104 }, /* LSRW */
{ CPUFUNC(op_e2f9_0), 58105 }, /* LSRW */
{ CPUFUNC(op_e3d0_0), 58320 }, /* LSLW */
{ CPUFUNC(op_e3d8_0), 58328 }, /* LSLW */
{ CPUFUNC(op_e3e0_0), 58336 }, /* LSLW */
{ CPUFUNC(op_e3e8_0), 58344 }, /* LSLW */
{ CPUFUNC(op_e3f0_0), 58352 }, /* LSLW */
{ CPUFUNC(op_e3f8_0), 58360 }, /* LSLW */
{ CPUFUNC(op_e3f9_0), 58361 }, /* LSLW */
{ CPUFUNC(op_e4d0_0), 58576 }, /* ROXRW */
{ CPUFUNC(op_e4d8_0), 58584 }, /* ROXRW */
{ CPUFUNC(op_e4e0_0), 58592 }, /* ROXRW */
{ CPUFUNC(op_e4e8_0), 58600 }, /* ROXRW */
{ CPUFUNC(op_e4f0_0), 58608 }, /* ROXRW */
{ CPUFUNC(op_e4f8_0), 58616 }, /* ROXRW */
{ CPUFUNC(op_e4f9_0), 58617 }, /* ROXRW */
{ CPUFUNC(op_e5d0_0), 58832 }, /* ROXLW */
{ CPUFUNC(op_e5d8_0), 58840 }, /* ROXLW */
{ CPUFUNC(op_e5e0_0), 58848 }, /* ROXLW */
{ CPUFUNC(op_e5e8_0), 58856 }, /* ROXLW */
{ CPUFUNC(op_e5f0_0), 58864 }, /* ROXLW */
{ CPUFUNC(op_e5f8_0), 58872 }, /* ROXLW */
{ CPUFUNC(op_e5f9_0), 58873 }, /* ROXLW */
{ CPUFUNC(op_e6d0_0), 59088 }, /* RORW */
{ CPUFUNC(op_e6d8_0), 59096 }, /* RORW */
{ CPUFUNC(op_e6e0_0), 59104 }, /* RORW */
{ CPUFUNC(op_e6e8_0), 59112 }, /* RORW */
{ CPUFUNC(op_e6f0_0), 59120 }, /* RORW */
{ CPUFUNC(op_e6f8_0), 59128 }, /* RORW */
{ CPUFUNC(op_e6f9_0), 59129 }, /* RORW */
{ CPUFUNC(op_e7d0_0), 59344 }, /* ROLW */
{ CPUFUNC(op_e7d8_0), 59352 }, /* ROLW */
{ CPUFUNC(op_e7e0_0), 59360 }, /* ROLW */
{ CPUFUNC(op_e7e8_0), 59368 }, /* ROLW */
{ CPUFUNC(op_e7f0_0), 59376 }, /* ROLW */
{ CPUFUNC(op_e7f8_0), 59384 }, /* ROLW */
{ CPUFUNC(op_e7f9_0), 59385 }, /* ROLW */
{ CPUFUNC(op_e8c0_0), 59584 }, /* BFTST */
{ CPUFUNC(op_e8d0_0), 59600 }, /* BFTST */
{ CPUFUNC(op_e8e8_0), 59624 }, /* BFTST */
{ CPUFUNC(op_e8f0_0), 59632 }, /* BFTST */
{ CPUFUNC(op_e8f8_0), 59640 }, /* BFTST */
{ CPUFUNC(op_e8f9_0), 59641 }, /* BFTST */
{ CPUFUNC(op_e8fa_0), 59642 }, /* BFTST */
{ CPUFUNC(op_e8fb_0), 59643 }, /* BFTST */
{ CPUFUNC(op_e9c0_0), 59840 }, /* BFEXTU */
{ CPUFUNC(op_e9d0_0), 59856 }, /* BFEXTU */
{ CPUFUNC(op_e9e8_0), 59880 }, /* BFEXTU */
{ CPUFUNC(op_e9f0_0), 59888 }, /* BFEXTU */
{ CPUFUNC(op_e9f8_0), 59896 }, /* BFEXTU */
{ CPUFUNC(op_e9f9_0), 59897 }, /* BFEXTU */
{ CPUFUNC(op_e9fa_0), 59898 }, /* BFEXTU */
{ CPUFUNC(op_e9fb_0), 59899 }, /* BFEXTU */
{ CPUFUNC(op_eac0_0), 60096 }, /* BFCHG */
{ CPUFUNC(op_ead0_0), 60112 }, /* BFCHG */
{ CPUFUNC(op_eae8_0), 60136 }, /* BFCHG */
{ CPUFUNC(op_eaf0_0), 60144 }, /* BFCHG */
{ CPUFUNC(op_eaf8_0), 60152 }, /* BFCHG */
{ CPUFUNC(op_eaf9_0), 60153 }, /* BFCHG */
{ CPUFUNC(op_ebc0_0), 60352 }, /* BFEXTS */
{ CPUFUNC(op_ebd0_0), 60368 }, /* BFEXTS */
{ CPUFUNC(op_ebe8_0), 60392 }, /* BFEXTS */
{ CPUFUNC(op_ebf0_0), 60400 }, /* BFEXTS */
{ CPUFUNC(op_ebf8_0), 60408 }, /* BFEXTS */
{ CPUFUNC(op_ebf9_0), 60409 }, /* BFEXTS */
{ CPUFUNC(op_ebfa_0), 60410 }, /* BFEXTS */
{ CPUFUNC(op_ebfb_0), 60411 }, /* BFEXTS */
{ CPUFUNC(op_ecc0_0), 60608 }, /* BFCLR */
{ CPUFUNC(op_ecd0_0), 60624 }, /* BFCLR */
{ CPUFUNC(op_ece8_0), 60648 }, /* BFCLR */
{ CPUFUNC(op_ecf0_0), 60656 }, /* BFCLR */
{ CPUFUNC(op_ecf8_0), 60664 }, /* BFCLR */
{ CPUFUNC(op_ecf9_0), 60665 }, /* BFCLR */
{ CPUFUNC(op_edc0_0), 60864 }, /* BFFFO */
{ CPUFUNC(op_edd0_0), 60880 }, /* BFFFO */
{ CPUFUNC(op_ede8_0), 60904 }, /* BFFFO */
{ CPUFUNC(op_edf0_0), 60912 }, /* BFFFO */
{ CPUFUNC(op_edf8_0), 60920 }, /* BFFFO */
{ CPUFUNC(op_edf9_0), 60921 }, /* BFFFO */
{ CPUFUNC(op_edfa_0), 60922 }, /* BFFFO */
{ CPUFUNC(op_edfb_0), 60923 }, /* BFFFO */
{ CPUFUNC(op_eec0_0), 61120 }, /* BFSET */
{ CPUFUNC(op_eed0_0), 61136 }, /* BFSET */
{ CPUFUNC(op_eee8_0), 61160 }, /* BFSET */
{ CPUFUNC(op_eef0_0), 61168 }, /* BFSET */
{ CPUFUNC(op_eef8_0), 61176 }, /* BFSET */
{ CPUFUNC(op_eef9_0), 61177 }, /* BFSET */
{ CPUFUNC(op_efc0_0), 61376 }, /* BFINS */
{ CPUFUNC(op_efd0_0), 61392 }, /* BFINS */
{ CPUFUNC(op_efe8_0), 61416 }, /* BFINS */
{ CPUFUNC(op_eff0_0), 61424 }, /* BFINS */
{ CPUFUNC(op_eff8_0), 61432 }, /* BFINS */
{ CPUFUNC(op_eff9_0), 61433 }, /* BFINS */
{ CPUFUNC(op_f200_0), 61952 }, /* FPP */
{ CPUFUNC(op_f208_0), 61960 }, /* FPP */
{ CPUFUNC(op_f210_0), 61968 }, /* FPP */
{ CPUFUNC(op_f218_0), 61976 }, /* FPP */
{ CPUFUNC(op_f220_0), 61984 }, /* FPP */
{ CPUFUNC(op_f228_0), 61992 }, /* FPP */
{ CPUFUNC(op_f230_0), 62000 }, /* FPP */
{ CPUFUNC(op_f238_0), 62008 }, /* FPP */
{ CPUFUNC(op_f239_0), 62009 }, /* FPP */
{ CPUFUNC(op_f23a_0), 62010 }, /* FPP */
{ CPUFUNC(op_f23b_0), 62011 }, /* FPP */
{ CPUFUNC(op_f23c_0), 62012 }, /* FPP */
{ CPUFUNC(op_f240_0), 62016 }, /* FScc */
{ CPUFUNC(op_f248_0), 62024 }, /* FDBcc */
{ CPUFUNC(op_f250_0), 62032 }, /* FScc */
{ CPUFUNC(op_f258_0), 62040 }, /* FScc */
{ CPUFUNC(op_f260_0), 62048 }, /* FScc */
{ CPUFUNC(op_f268_0), 62056 }, /* FScc */
{ CPUFUNC(op_f270_0), 62064 }, /* FScc */
{ CPUFUNC(op_f278_0), 62072 }, /* FScc */
{ CPUFUNC(op_f279_0), 62073 }, /* FScc */
{ CPUFUNC(op_f27a_0), 62074 }, /* FTRAPcc */
{ CPUFUNC(op_f27b_0), 62075 }, /* FTRAPcc */
{ CPUFUNC(op_f27c_0), 62076 }, /* FTRAPcc */
{ CPUFUNC(op_f280_0), 62080 }, /* FBcc */
{ CPUFUNC(op_f2c0_0), 62144 }, /* FBcc */
{ CPUFUNC(op_f310_0), 62224 }, /* FSAVE */
{ CPUFUNC(op_f320_0), 62240 }, /* FSAVE */
{ CPUFUNC(op_f328_0), 62248 }, /* FSAVE */
{ CPUFUNC(op_f330_0), 62256 }, /* FSAVE */
{ CPUFUNC(op_f338_0), 62264 }, /* FSAVE */
{ CPUFUNC(op_f339_0), 62265 }, /* FSAVE */
{ CPUFUNC(op_f350_0), 62288 }, /* FRESTORE */
{ CPUFUNC(op_f358_0), 62296 }, /* FRESTORE */
{ CPUFUNC(op_f368_0), 62312 }, /* FRESTORE */
{ CPUFUNC(op_f370_0), 62320 }, /* FRESTORE */
{ CPUFUNC(op_f378_0), 62328 }, /* FRESTORE */
{ CPUFUNC(op_f379_0), 62329 }, /* FRESTORE */
{ CPUFUNC(op_f37a_0), 62330 }, /* FRESTORE */
{ CPUFUNC(op_f37b_0), 62331 }, /* FRESTORE */
{ 0, 0 }};
const struct cputbl CPUFUNC(op_smalltbl_4)[] = {
{ CPUFUNC(op_0000_4), 0 }, /* OR */
{ CPUFUNC(op_0010_4), 16 }, /* OR */
{ CPUFUNC(op_0018_4), 24 }, /* OR */
{ CPUFUNC(op_0020_4), 32 }, /* OR */
{ CPUFUNC(op_0028_4), 40 }, /* OR */
{ CPUFUNC(op_0030_4), 48 }, /* OR */
{ CPUFUNC(op_0038_4), 56 }, /* OR */
{ CPUFUNC(op_0039_4), 57 }, /* OR */
{ CPUFUNC(op_003c_4), 60 }, /* ORSR */
{ CPUFUNC(op_0040_4), 64 }, /* OR */
{ CPUFUNC(op_0050_4), 80 }, /* OR */
{ CPUFUNC(op_0058_4), 88 }, /* OR */
{ CPUFUNC(op_0060_4), 96 }, /* OR */
{ CPUFUNC(op_0068_4), 104 }, /* OR */
{ CPUFUNC(op_0070_4), 112 }, /* OR */
{ CPUFUNC(op_0078_4), 120 }, /* OR */
{ CPUFUNC(op_0079_4), 121 }, /* OR */
{ CPUFUNC(op_007c_4), 124 }, /* ORSR */
{ CPUFUNC(op_0080_4), 128 }, /* OR */
{ CPUFUNC(op_0090_4), 144 }, /* OR */
{ CPUFUNC(op_0098_4), 152 }, /* OR */
{ CPUFUNC(op_00a0_4), 160 }, /* OR */
{ CPUFUNC(op_00a8_4), 168 }, /* OR */
{ CPUFUNC(op_00b0_4), 176 }, /* OR */
{ CPUFUNC(op_00b8_4), 184 }, /* OR */
{ CPUFUNC(op_00b9_4), 185 }, /* OR */
{ CPUFUNC(op_0100_4), 256 }, /* BTST */
{ CPUFUNC(op_0108_4), 264 }, /* MVPMR */
{ CPUFUNC(op_0110_4), 272 }, /* BTST */
{ CPUFUNC(op_0118_4), 280 }, /* BTST */
{ CPUFUNC(op_0120_4), 288 }, /* BTST */
{ CPUFUNC(op_0128_4), 296 }, /* BTST */
{ CPUFUNC(op_0130_4), 304 }, /* BTST */
{ CPUFUNC(op_0138_4), 312 }, /* BTST */
{ CPUFUNC(op_0139_4), 313 }, /* BTST */
{ CPUFUNC(op_013a_4), 314 }, /* BTST */
{ CPUFUNC(op_013b_4), 315 }, /* BTST */
{ CPUFUNC(op_013c_4), 316 }, /* BTST */
{ CPUFUNC(op_0140_4), 320 }, /* BCHG */
{ CPUFUNC(op_0148_4), 328 }, /* MVPMR */
{ CPUFUNC(op_0150_4), 336 }, /* BCHG */
{ CPUFUNC(op_0158_4), 344 }, /* BCHG */
{ CPUFUNC(op_0160_4), 352 }, /* BCHG */
{ CPUFUNC(op_0168_4), 360 }, /* BCHG */
{ CPUFUNC(op_0170_4), 368 }, /* BCHG */
{ CPUFUNC(op_0178_4), 376 }, /* BCHG */
{ CPUFUNC(op_0179_4), 377 }, /* BCHG */
{ CPUFUNC(op_0180_4), 384 }, /* BCLR */
{ CPUFUNC(op_0188_4), 392 }, /* MVPRM */
{ CPUFUNC(op_0190_4), 400 }, /* BCLR */
{ CPUFUNC(op_0198_4), 408 }, /* BCLR */
{ CPUFUNC(op_01a0_4), 416 }, /* BCLR */
{ CPUFUNC(op_01a8_4), 424 }, /* BCLR */
{ CPUFUNC(op_01b0_4), 432 }, /* BCLR */
{ CPUFUNC(op_01b8_4), 440 }, /* BCLR */
{ CPUFUNC(op_01b9_4), 441 }, /* BCLR */
{ CPUFUNC(op_01c0_4), 448 }, /* BSET */
{ CPUFUNC(op_01c8_4), 456 }, /* MVPRM */
{ CPUFUNC(op_01d0_4), 464 }, /* BSET */
{ CPUFUNC(op_01d8_4), 472 }, /* BSET */
{ CPUFUNC(op_01e0_4), 480 }, /* BSET */
{ CPUFUNC(op_01e8_4), 488 }, /* BSET */
{ CPUFUNC(op_01f0_4), 496 }, /* BSET */
{ CPUFUNC(op_01f8_4), 504 }, /* BSET */
{ CPUFUNC(op_01f9_4), 505 }, /* BSET */
{ CPUFUNC(op_0200_4), 512 }, /* AND */
{ CPUFUNC(op_0210_4), 528 }, /* AND */
{ CPUFUNC(op_0218_4), 536 }, /* AND */
{ CPUFUNC(op_0220_4), 544 }, /* AND */
{ CPUFUNC(op_0228_4), 552 }, /* AND */
{ CPUFUNC(op_0230_4), 560 }, /* AND */
{ CPUFUNC(op_0238_4), 568 }, /* AND */
{ CPUFUNC(op_0239_4), 569 }, /* AND */
{ CPUFUNC(op_023c_4), 572 }, /* ANDSR */
{ CPUFUNC(op_0240_4), 576 }, /* AND */
{ CPUFUNC(op_0250_4), 592 }, /* AND */
{ CPUFUNC(op_0258_4), 600 }, /* AND */
{ CPUFUNC(op_0260_4), 608 }, /* AND */
{ CPUFUNC(op_0268_4), 616 }, /* AND */
{ CPUFUNC(op_0270_4), 624 }, /* AND */
{ CPUFUNC(op_0278_4), 632 }, /* AND */
{ CPUFUNC(op_0279_4), 633 }, /* AND */
{ CPUFUNC(op_027c_4), 636 }, /* ANDSR */
{ CPUFUNC(op_0280_4), 640 }, /* AND */
{ CPUFUNC(op_0290_4), 656 }, /* AND */
{ CPUFUNC(op_0298_4), 664 }, /* AND */
{ CPUFUNC(op_02a0_4), 672 }, /* AND */
{ CPUFUNC(op_02a8_4), 680 }, /* AND */
{ CPUFUNC(op_02b0_4), 688 }, /* AND */
{ CPUFUNC(op_02b8_4), 696 }, /* AND */
{ CPUFUNC(op_02b9_4), 697 }, /* AND */
{ CPUFUNC(op_0400_4), 1024 }, /* SUB */
{ CPUFUNC(op_0410_4), 1040 }, /* SUB */
{ CPUFUNC(op_0418_4), 1048 }, /* SUB */
{ CPUFUNC(op_0420_4), 1056 }, /* SUB */
{ CPUFUNC(op_0428_4), 1064 }, /* SUB */
{ CPUFUNC(op_0430_4), 1072 }, /* SUB */
{ CPUFUNC(op_0438_4), 1080 }, /* SUB */
{ CPUFUNC(op_0439_4), 1081 }, /* SUB */
{ CPUFUNC(op_0440_4), 1088 }, /* SUB */
{ CPUFUNC(op_0450_4), 1104 }, /* SUB */
{ CPUFUNC(op_0458_4), 1112 }, /* SUB */
{ CPUFUNC(op_0460_4), 1120 }, /* SUB */
{ CPUFUNC(op_0468_4), 1128 }, /* SUB */
{ CPUFUNC(op_0470_4), 1136 }, /* SUB */
{ CPUFUNC(op_0478_4), 1144 }, /* SUB */
{ CPUFUNC(op_0479_4), 1145 }, /* SUB */
{ CPUFUNC(op_0480_4), 1152 }, /* SUB */
{ CPUFUNC(op_0490_4), 1168 }, /* SUB */
{ CPUFUNC(op_0498_4), 1176 }, /* SUB */
{ CPUFUNC(op_04a0_4), 1184 }, /* SUB */
{ CPUFUNC(op_04a8_4), 1192 }, /* SUB */
{ CPUFUNC(op_04b0_4), 1200 }, /* SUB */
{ CPUFUNC(op_04b8_4), 1208 }, /* SUB */
{ CPUFUNC(op_04b9_4), 1209 }, /* SUB */
{ CPUFUNC(op_0600_4), 1536 }, /* ADD */
{ CPUFUNC(op_0610_4), 1552 }, /* ADD */
{ CPUFUNC(op_0618_4), 1560 }, /* ADD */
{ CPUFUNC(op_0620_4), 1568 }, /* ADD */
{ CPUFUNC(op_0628_4), 1576 }, /* ADD */
{ CPUFUNC(op_0630_4), 1584 }, /* ADD */
{ CPUFUNC(op_0638_4), 1592 }, /* ADD */
{ CPUFUNC(op_0639_4), 1593 }, /* ADD */
{ CPUFUNC(op_0640_4), 1600 }, /* ADD */
{ CPUFUNC(op_0650_4), 1616 }, /* ADD */
{ CPUFUNC(op_0658_4), 1624 }, /* ADD */
{ CPUFUNC(op_0660_4), 1632 }, /* ADD */
{ CPUFUNC(op_0668_4), 1640 }, /* ADD */
{ CPUFUNC(op_0670_4), 1648 }, /* ADD */
{ CPUFUNC(op_0678_4), 1656 }, /* ADD */
{ CPUFUNC(op_0679_4), 1657 }, /* ADD */
{ CPUFUNC(op_0680_4), 1664 }, /* ADD */
{ CPUFUNC(op_0690_4), 1680 }, /* ADD */
{ CPUFUNC(op_0698_4), 1688 }, /* ADD */
{ CPUFUNC(op_06a0_4), 1696 }, /* ADD */
{ CPUFUNC(op_06a8_4), 1704 }, /* ADD */
{ CPUFUNC(op_06b0_4), 1712 }, /* ADD */
{ CPUFUNC(op_06b8_4), 1720 }, /* ADD */
{ CPUFUNC(op_06b9_4), 1721 }, /* ADD */
{ CPUFUNC(op_0800_4), 2048 }, /* BTST */
{ CPUFUNC(op_0810_4), 2064 }, /* BTST */
{ CPUFUNC(op_0818_4), 2072 }, /* BTST */
{ CPUFUNC(op_0820_4), 2080 }, /* BTST */
{ CPUFUNC(op_0828_4), 2088 }, /* BTST */
{ CPUFUNC(op_0830_4), 2096 }, /* BTST */
{ CPUFUNC(op_0838_4), 2104 }, /* BTST */
{ CPUFUNC(op_0839_4), 2105 }, /* BTST */
{ CPUFUNC(op_083a_4), 2106 }, /* BTST */
{ CPUFUNC(op_083b_4), 2107 }, /* BTST */
{ CPUFUNC(op_083c_4), 2108 }, /* BTST */
{ CPUFUNC(op_0840_4), 2112 }, /* BCHG */
{ CPUFUNC(op_0850_4), 2128 }, /* BCHG */
{ CPUFUNC(op_0858_4), 2136 }, /* BCHG */
{ CPUFUNC(op_0860_4), 2144 }, /* BCHG */
{ CPUFUNC(op_0868_4), 2152 }, /* BCHG */
{ CPUFUNC(op_0870_4), 2160 }, /* BCHG */
{ CPUFUNC(op_0878_4), 2168 }, /* BCHG */
{ CPUFUNC(op_0879_4), 2169 }, /* BCHG */
{ CPUFUNC(op_0880_4), 2176 }, /* BCLR */
{ CPUFUNC(op_0890_4), 2192 }, /* BCLR */
{ CPUFUNC(op_0898_4), 2200 }, /* BCLR */
{ CPUFUNC(op_08a0_4), 2208 }, /* BCLR */
{ CPUFUNC(op_08a8_4), 2216 }, /* BCLR */
{ CPUFUNC(op_08b0_4), 2224 }, /* BCLR */
{ CPUFUNC(op_08b8_4), 2232 }, /* BCLR */
{ CPUFUNC(op_08b9_4), 2233 }, /* BCLR */
{ CPUFUNC(op_08c0_4), 2240 }, /* BSET */
{ CPUFUNC(op_08d0_4), 2256 }, /* BSET */
{ CPUFUNC(op_08d8_4), 2264 }, /* BSET */
{ CPUFUNC(op_08e0_4), 2272 }, /* BSET */
{ CPUFUNC(op_08e8_4), 2280 }, /* BSET */
{ CPUFUNC(op_08f0_4), 2288 }, /* BSET */
{ CPUFUNC(op_08f8_4), 2296 }, /* BSET */
{ CPUFUNC(op_08f9_4), 2297 }, /* BSET */
{ CPUFUNC(op_0a00_4), 2560 }, /* EOR */
{ CPUFUNC(op_0a10_4), 2576 }, /* EOR */
{ CPUFUNC(op_0a18_4), 2584 }, /* EOR */
{ CPUFUNC(op_0a20_4), 2592 }, /* EOR */
{ CPUFUNC(op_0a28_4), 2600 }, /* EOR */
{ CPUFUNC(op_0a30_4), 2608 }, /* EOR */
{ CPUFUNC(op_0a38_4), 2616 }, /* EOR */
{ CPUFUNC(op_0a39_4), 2617 }, /* EOR */
{ CPUFUNC(op_0a3c_4), 2620 }, /* EORSR */
{ CPUFUNC(op_0a40_4), 2624 }, /* EOR */
{ CPUFUNC(op_0a50_4), 2640 }, /* EOR */
{ CPUFUNC(op_0a58_4), 2648 }, /* EOR */
{ CPUFUNC(op_0a60_4), 2656 }, /* EOR */
{ CPUFUNC(op_0a68_4), 2664 }, /* EOR */
{ CPUFUNC(op_0a70_4), 2672 }, /* EOR */
{ CPUFUNC(op_0a78_4), 2680 }, /* EOR */
{ CPUFUNC(op_0a79_4), 2681 }, /* EOR */
{ CPUFUNC(op_0a7c_4), 2684 }, /* EORSR */
{ CPUFUNC(op_0a80_4), 2688 }, /* EOR */
{ CPUFUNC(op_0a90_4), 2704 }, /* EOR */
{ CPUFUNC(op_0a98_4), 2712 }, /* EOR */
{ CPUFUNC(op_0aa0_4), 2720 }, /* EOR */
{ CPUFUNC(op_0aa8_4), 2728 }, /* EOR */
{ CPUFUNC(op_0ab0_4), 2736 }, /* EOR */
{ CPUFUNC(op_0ab8_4), 2744 }, /* EOR */
{ CPUFUNC(op_0ab9_4), 2745 }, /* EOR */
{ CPUFUNC(op_0c00_4), 3072 }, /* CMP */
{ CPUFUNC(op_0c10_4), 3088 }, /* CMP */
{ CPUFUNC(op_0c18_4), 3096 }, /* CMP */
{ CPUFUNC(op_0c20_4), 3104 }, /* CMP */
{ CPUFUNC(op_0c28_4), 3112 }, /* CMP */
{ CPUFUNC(op_0c30_4), 3120 }, /* CMP */
{ CPUFUNC(op_0c38_4), 3128 }, /* CMP */
{ CPUFUNC(op_0c39_4), 3129 }, /* CMP */
{ CPUFUNC(op_0c40_4), 3136 }, /* CMP */
{ CPUFUNC(op_0c50_4), 3152 }, /* CMP */
{ CPUFUNC(op_0c58_4), 3160 }, /* CMP */
{ CPUFUNC(op_0c60_4), 3168 }, /* CMP */
{ CPUFUNC(op_0c68_4), 3176 }, /* CMP */
{ CPUFUNC(op_0c70_4), 3184 }, /* CMP */
{ CPUFUNC(op_0c78_4), 3192 }, /* CMP */
{ CPUFUNC(op_0c79_4), 3193 }, /* CMP */
{ CPUFUNC(op_0c80_4), 3200 }, /* CMP */
{ CPUFUNC(op_0c90_4), 3216 }, /* CMP */
{ CPUFUNC(op_0c98_4), 3224 }, /* CMP */
{ CPUFUNC(op_0ca0_4), 3232 }, /* CMP */
{ CPUFUNC(op_0ca8_4), 3240 }, /* CMP */
{ CPUFUNC(op_0cb0_4), 3248 }, /* CMP */
{ CPUFUNC(op_0cb8_4), 3256 }, /* CMP */
{ CPUFUNC(op_0cb9_4), 3257 }, /* CMP */
{ CPUFUNC(op_1000_4), 4096 }, /* MOVE */
{ CPUFUNC(op_1010_4), 4112 }, /* MOVE */
{ CPUFUNC(op_1018_4), 4120 }, /* MOVE */
{ CPUFUNC(op_1020_4), 4128 }, /* MOVE */
{ CPUFUNC(op_1028_4), 4136 }, /* MOVE */
{ CPUFUNC(op_1030_4), 4144 }, /* MOVE */
{ CPUFUNC(op_1038_4), 4152 }, /* MOVE */
{ CPUFUNC(op_1039_4), 4153 }, /* MOVE */
{ CPUFUNC(op_103a_4), 4154 }, /* MOVE */
{ CPUFUNC(op_103b_4), 4155 }, /* MOVE */
{ CPUFUNC(op_103c_4), 4156 }, /* MOVE */
{ CPUFUNC(op_1080_4), 4224 }, /* MOVE */
{ CPUFUNC(op_1090_4), 4240 }, /* MOVE */
{ CPUFUNC(op_1098_4), 4248 }, /* MOVE */
{ CPUFUNC(op_10a0_4), 4256 }, /* MOVE */
{ CPUFUNC(op_10a8_4), 4264 }, /* MOVE */
{ CPUFUNC(op_10b0_4), 4272 }, /* MOVE */
{ CPUFUNC(op_10b8_4), 4280 }, /* MOVE */
{ CPUFUNC(op_10b9_4), 4281 }, /* MOVE */
{ CPUFUNC(op_10ba_4), 4282 }, /* MOVE */
{ CPUFUNC(op_10bb_4), 4283 }, /* MOVE */
{ CPUFUNC(op_10bc_4), 4284 }, /* MOVE */
{ CPUFUNC(op_10c0_4), 4288 }, /* MOVE */
{ CPUFUNC(op_10d0_4), 4304 }, /* MOVE */
{ CPUFUNC(op_10d8_4), 4312 }, /* MOVE */
{ CPUFUNC(op_10e0_4), 4320 }, /* MOVE */
{ CPUFUNC(op_10e8_4), 4328 }, /* MOVE */
{ CPUFUNC(op_10f0_4), 4336 }, /* MOVE */
{ CPUFUNC(op_10f8_4), 4344 }, /* MOVE */
{ CPUFUNC(op_10f9_4), 4345 }, /* MOVE */
{ CPUFUNC(op_10fa_4), 4346 }, /* MOVE */
{ CPUFUNC(op_10fb_4), 4347 }, /* MOVE */
{ CPUFUNC(op_10fc_4), 4348 }, /* MOVE */
{ CPUFUNC(op_1100_4), 4352 }, /* MOVE */
{ CPUFUNC(op_1110_4), 4368 }, /* MOVE */
{ CPUFUNC(op_1118_4), 4376 }, /* MOVE */
{ CPUFUNC(op_1120_4), 4384 }, /* MOVE */
{ CPUFUNC(op_1128_4), 4392 }, /* MOVE */
{ CPUFUNC(op_1130_4), 4400 }, /* MOVE */
{ CPUFUNC(op_1138_4), 4408 }, /* MOVE */
{ CPUFUNC(op_1139_4), 4409 }, /* MOVE */
{ CPUFUNC(op_113a_4), 4410 }, /* MOVE */
{ CPUFUNC(op_113b_4), 4411 }, /* MOVE */
{ CPUFUNC(op_113c_4), 4412 }, /* MOVE */
{ CPUFUNC(op_1140_4), 4416 }, /* MOVE */
{ CPUFUNC(op_1150_4), 4432 }, /* MOVE */
{ CPUFUNC(op_1158_4), 4440 }, /* MOVE */
{ CPUFUNC(op_1160_4), 4448 }, /* MOVE */
{ CPUFUNC(op_1168_4), 4456 }, /* MOVE */
{ CPUFUNC(op_1170_4), 4464 }, /* MOVE */
{ CPUFUNC(op_1178_4), 4472 }, /* MOVE */
{ CPUFUNC(op_1179_4), 4473 }, /* MOVE */
{ CPUFUNC(op_117a_4), 4474 }, /* MOVE */
{ CPUFUNC(op_117b_4), 4475 }, /* MOVE */
{ CPUFUNC(op_117c_4), 4476 }, /* MOVE */
{ CPUFUNC(op_1180_4), 4480 }, /* MOVE */
{ CPUFUNC(op_1190_4), 4496 }, /* MOVE */
{ CPUFUNC(op_1198_4), 4504 }, /* MOVE */
{ CPUFUNC(op_11a0_4), 4512 }, /* MOVE */
{ CPUFUNC(op_11a8_4), 4520 }, /* MOVE */
{ CPUFUNC(op_11b0_4), 4528 }, /* MOVE */
{ CPUFUNC(op_11b8_4), 4536 }, /* MOVE */
{ CPUFUNC(op_11b9_4), 4537 }, /* MOVE */
{ CPUFUNC(op_11ba_4), 4538 }, /* MOVE */
{ CPUFUNC(op_11bb_4), 4539 }, /* MOVE */
{ CPUFUNC(op_11bc_4), 4540 }, /* MOVE */
{ CPUFUNC(op_11c0_4), 4544 }, /* MOVE */
{ CPUFUNC(op_11d0_4), 4560 }, /* MOVE */
{ CPUFUNC(op_11d8_4), 4568 }, /* MOVE */
{ CPUFUNC(op_11e0_4), 4576 }, /* MOVE */
{ CPUFUNC(op_11e8_4), 4584 }, /* MOVE */
{ CPUFUNC(op_11f0_4), 4592 }, /* MOVE */
{ CPUFUNC(op_11f8_4), 4600 }, /* MOVE */
{ CPUFUNC(op_11f9_4), 4601 }, /* MOVE */
{ CPUFUNC(op_11fa_4), 4602 }, /* MOVE */
{ CPUFUNC(op_11fb_4), 4603 }, /* MOVE */
{ CPUFUNC(op_11fc_4), 4604 }, /* MOVE */
{ CPUFUNC(op_13c0_4), 5056 }, /* MOVE */
{ CPUFUNC(op_13d0_4), 5072 }, /* MOVE */
{ CPUFUNC(op_13d8_4), 5080 }, /* MOVE */
{ CPUFUNC(op_13e0_4), 5088 }, /* MOVE */
{ CPUFUNC(op_13e8_4), 5096 }, /* MOVE */
{ CPUFUNC(op_13f0_4), 5104 }, /* MOVE */
{ CPUFUNC(op_13f8_4), 5112 }, /* MOVE */
{ CPUFUNC(op_13f9_4), 5113 }, /* MOVE */
{ CPUFUNC(op_13fa_4), 5114 }, /* MOVE */
{ CPUFUNC(op_13fb_4), 5115 }, /* MOVE */
{ CPUFUNC(op_13fc_4), 5116 }, /* MOVE */
{ CPUFUNC(op_2000_4), 8192 }, /* MOVE */
{ CPUFUNC(op_2008_4), 8200 }, /* MOVE */
{ CPUFUNC(op_2010_4), 8208 }, /* MOVE */
{ CPUFUNC(op_2018_4), 8216 }, /* MOVE */
{ CPUFUNC(op_2020_4), 8224 }, /* MOVE */
{ CPUFUNC(op_2028_4), 8232 }, /* MOVE */
{ CPUFUNC(op_2030_4), 8240 }, /* MOVE */
{ CPUFUNC(op_2038_4), 8248 }, /* MOVE */
{ CPUFUNC(op_2039_4), 8249 }, /* MOVE */
{ CPUFUNC(op_203a_4), 8250 }, /* MOVE */
{ CPUFUNC(op_203b_4), 8251 }, /* MOVE */
{ CPUFUNC(op_203c_4), 8252 }, /* MOVE */
{ CPUFUNC(op_2040_4), 8256 }, /* MOVEA */
{ CPUFUNC(op_2048_4), 8264 }, /* MOVEA */
{ CPUFUNC(op_2050_4), 8272 }, /* MOVEA */
{ CPUFUNC(op_2058_4), 8280 }, /* MOVEA */
{ CPUFUNC(op_2060_4), 8288 }, /* MOVEA */
{ CPUFUNC(op_2068_4), 8296 }, /* MOVEA */
{ CPUFUNC(op_2070_4), 8304 }, /* MOVEA */
{ CPUFUNC(op_2078_4), 8312 }, /* MOVEA */
{ CPUFUNC(op_2079_4), 8313 }, /* MOVEA */
{ CPUFUNC(op_207a_4), 8314 }, /* MOVEA */
{ CPUFUNC(op_207b_4), 8315 }, /* MOVEA */
{ CPUFUNC(op_207c_4), 8316 }, /* MOVEA */
{ CPUFUNC(op_2080_4), 8320 }, /* MOVE */
{ CPUFUNC(op_2088_4), 8328 }, /* MOVE */
{ CPUFUNC(op_2090_4), 8336 }, /* MOVE */
{ CPUFUNC(op_2098_4), 8344 }, /* MOVE */
{ CPUFUNC(op_20a0_4), 8352 }, /* MOVE */
{ CPUFUNC(op_20a8_4), 8360 }, /* MOVE */
{ CPUFUNC(op_20b0_4), 8368 }, /* MOVE */
{ CPUFUNC(op_20b8_4), 8376 }, /* MOVE */
{ CPUFUNC(op_20b9_4), 8377 }, /* MOVE */
{ CPUFUNC(op_20ba_4), 8378 }, /* MOVE */
{ CPUFUNC(op_20bb_4), 8379 }, /* MOVE */
{ CPUFUNC(op_20bc_4), 8380 }, /* MOVE */
{ CPUFUNC(op_20c0_4), 8384 }, /* MOVE */
{ CPUFUNC(op_20c8_4), 8392 }, /* MOVE */
{ CPUFUNC(op_20d0_4), 8400 }, /* MOVE */
{ CPUFUNC(op_20d8_4), 8408 }, /* MOVE */
{ CPUFUNC(op_20e0_4), 8416 }, /* MOVE */
{ CPUFUNC(op_20e8_4), 8424 }, /* MOVE */
{ CPUFUNC(op_20f0_4), 8432 }, /* MOVE */
{ CPUFUNC(op_20f8_4), 8440 }, /* MOVE */
{ CPUFUNC(op_20f9_4), 8441 }, /* MOVE */
{ CPUFUNC(op_20fa_4), 8442 }, /* MOVE */
{ CPUFUNC(op_20fb_4), 8443 }, /* MOVE */
{ CPUFUNC(op_20fc_4), 8444 }, /* MOVE */
{ CPUFUNC(op_2100_4), 8448 }, /* MOVE */
{ CPUFUNC(op_2108_4), 8456 }, /* MOVE */
{ CPUFUNC(op_2110_4), 8464 }, /* MOVE */
{ CPUFUNC(op_2118_4), 8472 }, /* MOVE */
{ CPUFUNC(op_2120_4), 8480 }, /* MOVE */
{ CPUFUNC(op_2128_4), 8488 }, /* MOVE */
{ CPUFUNC(op_2130_4), 8496 }, /* MOVE */
{ CPUFUNC(op_2138_4), 8504 }, /* MOVE */
{ CPUFUNC(op_2139_4), 8505 }, /* MOVE */
{ CPUFUNC(op_213a_4), 8506 }, /* MOVE */
{ CPUFUNC(op_213b_4), 8507 }, /* MOVE */
{ CPUFUNC(op_213c_4), 8508 }, /* MOVE */
{ CPUFUNC(op_2140_4), 8512 }, /* MOVE */
{ CPUFUNC(op_2148_4), 8520 }, /* MOVE */
{ CPUFUNC(op_2150_4), 8528 }, /* MOVE */
{ CPUFUNC(op_2158_4), 8536 }, /* MOVE */
{ CPUFUNC(op_2160_4), 8544 }, /* MOVE */
{ CPUFUNC(op_2168_4), 8552 }, /* MOVE */
{ CPUFUNC(op_2170_4), 8560 }, /* MOVE */
{ CPUFUNC(op_2178_4), 8568 }, /* MOVE */
{ CPUFUNC(op_2179_4), 8569 }, /* MOVE */
{ CPUFUNC(op_217a_4), 8570 }, /* MOVE */
{ CPUFUNC(op_217b_4), 8571 }, /* MOVE */
{ CPUFUNC(op_217c_4), 8572 }, /* MOVE */
{ CPUFUNC(op_2180_4), 8576 }, /* MOVE */
{ CPUFUNC(op_2188_4), 8584 }, /* MOVE */
{ CPUFUNC(op_2190_4), 8592 }, /* MOVE */
{ CPUFUNC(op_2198_4), 8600 }, /* MOVE */
{ CPUFUNC(op_21a0_4), 8608 }, /* MOVE */
{ CPUFUNC(op_21a8_4), 8616 }, /* MOVE */
{ CPUFUNC(op_21b0_4), 8624 }, /* MOVE */
{ CPUFUNC(op_21b8_4), 8632 }, /* MOVE */
{ CPUFUNC(op_21b9_4), 8633 }, /* MOVE */
{ CPUFUNC(op_21ba_4), 8634 }, /* MOVE */
{ CPUFUNC(op_21bb_4), 8635 }, /* MOVE */
{ CPUFUNC(op_21bc_4), 8636 }, /* MOVE */
{ CPUFUNC(op_21c0_4), 8640 }, /* MOVE */
{ CPUFUNC(op_21c8_4), 8648 }, /* MOVE */
{ CPUFUNC(op_21d0_4), 8656 }, /* MOVE */
{ CPUFUNC(op_21d8_4), 8664 }, /* MOVE */
{ CPUFUNC(op_21e0_4), 8672 }, /* MOVE */
{ CPUFUNC(op_21e8_4), 8680 }, /* MOVE */
{ CPUFUNC(op_21f0_4), 8688 }, /* MOVE */
{ CPUFUNC(op_21f8_4), 8696 }, /* MOVE */
{ CPUFUNC(op_21f9_4), 8697 }, /* MOVE */
{ CPUFUNC(op_21fa_4), 8698 }, /* MOVE */
{ CPUFUNC(op_21fb_4), 8699 }, /* MOVE */
{ CPUFUNC(op_21fc_4), 8700 }, /* MOVE */
{ CPUFUNC(op_23c0_4), 9152 }, /* MOVE */
{ CPUFUNC(op_23c8_4), 9160 }, /* MOVE */
{ CPUFUNC(op_23d0_4), 9168 }, /* MOVE */
{ CPUFUNC(op_23d8_4), 9176 }, /* MOVE */
{ CPUFUNC(op_23e0_4), 9184 }, /* MOVE */
{ CPUFUNC(op_23e8_4), 9192 }, /* MOVE */
{ CPUFUNC(op_23f0_4), 9200 }, /* MOVE */
{ CPUFUNC(op_23f8_4), 9208 }, /* MOVE */
{ CPUFUNC(op_23f9_4), 9209 }, /* MOVE */
{ CPUFUNC(op_23fa_4), 9210 }, /* MOVE */
{ CPUFUNC(op_23fb_4), 9211 }, /* MOVE */
{ CPUFUNC(op_23fc_4), 9212 }, /* MOVE */
{ CPUFUNC(op_3000_4), 12288 }, /* MOVE */
{ CPUFUNC(op_3008_4), 12296 }, /* MOVE */
{ CPUFUNC(op_3010_4), 12304 }, /* MOVE */
{ CPUFUNC(op_3018_4), 12312 }, /* MOVE */
{ CPUFUNC(op_3020_4), 12320 }, /* MOVE */
{ CPUFUNC(op_3028_4), 12328 }, /* MOVE */
{ CPUFUNC(op_3030_4), 12336 }, /* MOVE */
{ CPUFUNC(op_3038_4), 12344 }, /* MOVE */
{ CPUFUNC(op_3039_4), 12345 }, /* MOVE */
{ CPUFUNC(op_303a_4), 12346 }, /* MOVE */
{ CPUFUNC(op_303b_4), 12347 }, /* MOVE */
{ CPUFUNC(op_303c_4), 12348 }, /* MOVE */
{ CPUFUNC(op_3040_4), 12352 }, /* MOVEA */
{ CPUFUNC(op_3048_4), 12360 }, /* MOVEA */
{ CPUFUNC(op_3050_4), 12368 }, /* MOVEA */
{ CPUFUNC(op_3058_4), 12376 }, /* MOVEA */
{ CPUFUNC(op_3060_4), 12384 }, /* MOVEA */
{ CPUFUNC(op_3068_4), 12392 }, /* MOVEA */
{ CPUFUNC(op_3070_4), 12400 }, /* MOVEA */
{ CPUFUNC(op_3078_4), 12408 }, /* MOVEA */
{ CPUFUNC(op_3079_4), 12409 }, /* MOVEA */
{ CPUFUNC(op_307a_4), 12410 }, /* MOVEA */
{ CPUFUNC(op_307b_4), 12411 }, /* MOVEA */
{ CPUFUNC(op_307c_4), 12412 }, /* MOVEA */
{ CPUFUNC(op_3080_4), 12416 }, /* MOVE */
{ CPUFUNC(op_3088_4), 12424 }, /* MOVE */
{ CPUFUNC(op_3090_4), 12432 }, /* MOVE */
{ CPUFUNC(op_3098_4), 12440 }, /* MOVE */
{ CPUFUNC(op_30a0_4), 12448 }, /* MOVE */
{ CPUFUNC(op_30a8_4), 12456 }, /* MOVE */
{ CPUFUNC(op_30b0_4), 12464 }, /* MOVE */
{ CPUFUNC(op_30b8_4), 12472 }, /* MOVE */
{ CPUFUNC(op_30b9_4), 12473 }, /* MOVE */
{ CPUFUNC(op_30ba_4), 12474 }, /* MOVE */
{ CPUFUNC(op_30bb_4), 12475 }, /* MOVE */
{ CPUFUNC(op_30bc_4), 12476 }, /* MOVE */
{ CPUFUNC(op_30c0_4), 12480 }, /* MOVE */
{ CPUFUNC(op_30c8_4), 12488 }, /* MOVE */
{ CPUFUNC(op_30d0_4), 12496 }, /* MOVE */
{ CPUFUNC(op_30d8_4), 12504 }, /* MOVE */
{ CPUFUNC(op_30e0_4), 12512 }, /* MOVE */
{ CPUFUNC(op_30e8_4), 12520 }, /* MOVE */
{ CPUFUNC(op_30f0_4), 12528 }, /* MOVE */
{ CPUFUNC(op_30f8_4), 12536 }, /* MOVE */
{ CPUFUNC(op_30f9_4), 12537 }, /* MOVE */
{ CPUFUNC(op_30fa_4), 12538 }, /* MOVE */
{ CPUFUNC(op_30fb_4), 12539 }, /* MOVE */
{ CPUFUNC(op_30fc_4), 12540 }, /* MOVE */
{ CPUFUNC(op_3100_4), 12544 }, /* MOVE */
{ CPUFUNC(op_3108_4), 12552 }, /* MOVE */
{ CPUFUNC(op_3110_4), 12560 }, /* MOVE */
{ CPUFUNC(op_3118_4), 12568 }, /* MOVE */
{ CPUFUNC(op_3120_4), 12576 }, /* MOVE */
{ CPUFUNC(op_3128_4), 12584 }, /* MOVE */
{ CPUFUNC(op_3130_4), 12592 }, /* MOVE */
{ CPUFUNC(op_3138_4), 12600 }, /* MOVE */
{ CPUFUNC(op_3139_4), 12601 }, /* MOVE */
{ CPUFUNC(op_313a_4), 12602 }, /* MOVE */
{ CPUFUNC(op_313b_4), 12603 }, /* MOVE */
{ CPUFUNC(op_313c_4), 12604 }, /* MOVE */
{ CPUFUNC(op_3140_4), 12608 }, /* MOVE */
{ CPUFUNC(op_3148_4), 12616 }, /* MOVE */
{ CPUFUNC(op_3150_4), 12624 }, /* MOVE */
{ CPUFUNC(op_3158_4), 12632 }, /* MOVE */
{ CPUFUNC(op_3160_4), 12640 }, /* MOVE */
{ CPUFUNC(op_3168_4), 12648 }, /* MOVE */
{ CPUFUNC(op_3170_4), 12656 }, /* MOVE */
{ CPUFUNC(op_3178_4), 12664 }, /* MOVE */
{ CPUFUNC(op_3179_4), 12665 }, /* MOVE */
{ CPUFUNC(op_317a_4), 12666 }, /* MOVE */
{ CPUFUNC(op_317b_4), 12667 }, /* MOVE */
{ CPUFUNC(op_317c_4), 12668 }, /* MOVE */
{ CPUFUNC(op_3180_4), 12672 }, /* MOVE */
{ CPUFUNC(op_3188_4), 12680 }, /* MOVE */
{ CPUFUNC(op_3190_4), 12688 }, /* MOVE */
{ CPUFUNC(op_3198_4), 12696 }, /* MOVE */
{ CPUFUNC(op_31a0_4), 12704 }, /* MOVE */
{ CPUFUNC(op_31a8_4), 12712 }, /* MOVE */
{ CPUFUNC(op_31b0_4), 12720 }, /* MOVE */
{ CPUFUNC(op_31b8_4), 12728 }, /* MOVE */
{ CPUFUNC(op_31b9_4), 12729 }, /* MOVE */
{ CPUFUNC(op_31ba_4), 12730 }, /* MOVE */
{ CPUFUNC(op_31bb_4), 12731 }, /* MOVE */
{ CPUFUNC(op_31bc_4), 12732 }, /* MOVE */
{ CPUFUNC(op_31c0_4), 12736 }, /* MOVE */
{ CPUFUNC(op_31c8_4), 12744 }, /* MOVE */
{ CPUFUNC(op_31d0_4), 12752 }, /* MOVE */
{ CPUFUNC(op_31d8_4), 12760 }, /* MOVE */
{ CPUFUNC(op_31e0_4), 12768 }, /* MOVE */
{ CPUFUNC(op_31e8_4), 12776 }, /* MOVE */
{ CPUFUNC(op_31f0_4), 12784 }, /* MOVE */
{ CPUFUNC(op_31f8_4), 12792 }, /* MOVE */
{ CPUFUNC(op_31f9_4), 12793 }, /* MOVE */
{ CPUFUNC(op_31fa_4), 12794 }, /* MOVE */
{ CPUFUNC(op_31fb_4), 12795 }, /* MOVE */
{ CPUFUNC(op_31fc_4), 12796 }, /* MOVE */
{ CPUFUNC(op_33c0_4), 13248 }, /* MOVE */
{ CPUFUNC(op_33c8_4), 13256 }, /* MOVE */
{ CPUFUNC(op_33d0_4), 13264 }, /* MOVE */
{ CPUFUNC(op_33d8_4), 13272 }, /* MOVE */
{ CPUFUNC(op_33e0_4), 13280 }, /* MOVE */
{ CPUFUNC(op_33e8_4), 13288 }, /* MOVE */
{ CPUFUNC(op_33f0_4), 13296 }, /* MOVE */
{ CPUFUNC(op_33f8_4), 13304 }, /* MOVE */
{ CPUFUNC(op_33f9_4), 13305 }, /* MOVE */
{ CPUFUNC(op_33fa_4), 13306 }, /* MOVE */
{ CPUFUNC(op_33fb_4), 13307 }, /* MOVE */
{ CPUFUNC(op_33fc_4), 13308 }, /* MOVE */
{ CPUFUNC(op_4000_4), 16384 }, /* NEGX */
{ CPUFUNC(op_4010_4), 16400 }, /* NEGX */
{ CPUFUNC(op_4018_4), 16408 }, /* NEGX */
{ CPUFUNC(op_4020_4), 16416 }, /* NEGX */
{ CPUFUNC(op_4028_4), 16424 }, /* NEGX */
{ CPUFUNC(op_4030_4), 16432 }, /* NEGX */
{ CPUFUNC(op_4038_4), 16440 }, /* NEGX */
{ CPUFUNC(op_4039_4), 16441 }, /* NEGX */
{ CPUFUNC(op_4040_4), 16448 }, /* NEGX */
{ CPUFUNC(op_4050_4), 16464 }, /* NEGX */
{ CPUFUNC(op_4058_4), 16472 }, /* NEGX */
{ CPUFUNC(op_4060_4), 16480 }, /* NEGX */
{ CPUFUNC(op_4068_4), 16488 }, /* NEGX */
{ CPUFUNC(op_4070_4), 16496 }, /* NEGX */
{ CPUFUNC(op_4078_4), 16504 }, /* NEGX */
{ CPUFUNC(op_4079_4), 16505 }, /* NEGX */
{ CPUFUNC(op_4080_4), 16512 }, /* NEGX */
{ CPUFUNC(op_4090_4), 16528 }, /* NEGX */
{ CPUFUNC(op_4098_4), 16536 }, /* NEGX */
{ CPUFUNC(op_40a0_4), 16544 }, /* NEGX */
{ CPUFUNC(op_40a8_4), 16552 }, /* NEGX */
{ CPUFUNC(op_40b0_4), 16560 }, /* NEGX */
{ CPUFUNC(op_40b8_4), 16568 }, /* NEGX */
{ CPUFUNC(op_40b9_4), 16569 }, /* NEGX */
{ CPUFUNC(op_40c0_4), 16576 }, /* MVSR2 */
{ CPUFUNC(op_40d0_4), 16592 }, /* MVSR2 */
{ CPUFUNC(op_40d8_4), 16600 }, /* MVSR2 */
{ CPUFUNC(op_40e0_4), 16608 }, /* MVSR2 */
{ CPUFUNC(op_40e8_4), 16616 }, /* MVSR2 */
{ CPUFUNC(op_40f0_4), 16624 }, /* MVSR2 */
{ CPUFUNC(op_40f8_4), 16632 }, /* MVSR2 */
{ CPUFUNC(op_40f9_4), 16633 }, /* MVSR2 */
{ CPUFUNC(op_4180_4), 16768 }, /* CHK */
{ CPUFUNC(op_4190_4), 16784 }, /* CHK */
{ CPUFUNC(op_4198_4), 16792 }, /* CHK */
{ CPUFUNC(op_41a0_4), 16800 }, /* CHK */
{ CPUFUNC(op_41a8_4), 16808 }, /* CHK */
{ CPUFUNC(op_41b0_4), 16816 }, /* CHK */
{ CPUFUNC(op_41b8_4), 16824 }, /* CHK */
{ CPUFUNC(op_41b9_4), 16825 }, /* CHK */
{ CPUFUNC(op_41ba_4), 16826 }, /* CHK */
{ CPUFUNC(op_41bb_4), 16827 }, /* CHK */
{ CPUFUNC(op_41bc_4), 16828 }, /* CHK */
{ CPUFUNC(op_41d0_4), 16848 }, /* LEA */
{ CPUFUNC(op_41e8_4), 16872 }, /* LEA */
{ CPUFUNC(op_41f0_4), 16880 }, /* LEA */
{ CPUFUNC(op_41f8_4), 16888 }, /* LEA */
{ CPUFUNC(op_41f9_4), 16889 }, /* LEA */
{ CPUFUNC(op_41fa_4), 16890 }, /* LEA */
{ CPUFUNC(op_41fb_4), 16891 }, /* LEA */
{ CPUFUNC(op_4200_4), 16896 }, /* CLR */
{ CPUFUNC(op_4210_4), 16912 }, /* CLR */
{ CPUFUNC(op_4218_4), 16920 }, /* CLR */
{ CPUFUNC(op_4220_4), 16928 }, /* CLR */
{ CPUFUNC(op_4228_4), 16936 }, /* CLR */
{ CPUFUNC(op_4230_4), 16944 }, /* CLR */
{ CPUFUNC(op_4238_4), 16952 }, /* CLR */
{ CPUFUNC(op_4239_4), 16953 }, /* CLR */
{ CPUFUNC(op_4240_4), 16960 }, /* CLR */
{ CPUFUNC(op_4250_4), 16976 }, /* CLR */
{ CPUFUNC(op_4258_4), 16984 }, /* CLR */
{ CPUFUNC(op_4260_4), 16992 }, /* CLR */
{ CPUFUNC(op_4268_4), 17000 }, /* CLR */
{ CPUFUNC(op_4270_4), 17008 }, /* CLR */
{ CPUFUNC(op_4278_4), 17016 }, /* CLR */
{ CPUFUNC(op_4279_4), 17017 }, /* CLR */
{ CPUFUNC(op_4280_4), 17024 }, /* CLR */
{ CPUFUNC(op_4290_4), 17040 }, /* CLR */
{ CPUFUNC(op_4298_4), 17048 }, /* CLR */
{ CPUFUNC(op_42a0_4), 17056 }, /* CLR */
{ CPUFUNC(op_42a8_4), 17064 }, /* CLR */
{ CPUFUNC(op_42b0_4), 17072 }, /* CLR */
{ CPUFUNC(op_42b8_4), 17080 }, /* CLR */
{ CPUFUNC(op_42b9_4), 17081 }, /* CLR */
{ CPUFUNC(op_42c0_4), 17088 }, /* MVSR2 */
{ CPUFUNC(op_42d0_4), 17104 }, /* MVSR2 */
{ CPUFUNC(op_42d8_4), 17112 }, /* MVSR2 */
{ CPUFUNC(op_42e0_4), 17120 }, /* MVSR2 */
{ CPUFUNC(op_42e8_4), 17128 }, /* MVSR2 */
{ CPUFUNC(op_42f0_4), 17136 }, /* MVSR2 */
{ CPUFUNC(op_42f8_4), 17144 }, /* MVSR2 */
{ CPUFUNC(op_42f9_4), 17145 }, /* MVSR2 */
{ CPUFUNC(op_4400_4), 17408 }, /* NEG */
{ CPUFUNC(op_4410_4), 17424 }, /* NEG */
{ CPUFUNC(op_4418_4), 17432 }, /* NEG */
{ CPUFUNC(op_4420_4), 17440 }, /* NEG */
{ CPUFUNC(op_4428_4), 17448 }, /* NEG */
{ CPUFUNC(op_4430_4), 17456 }, /* NEG */
{ CPUFUNC(op_4438_4), 17464 }, /* NEG */
{ CPUFUNC(op_4439_4), 17465 }, /* NEG */
{ CPUFUNC(op_4440_4), 17472 }, /* NEG */
{ CPUFUNC(op_4450_4), 17488 }, /* NEG */
{ CPUFUNC(op_4458_4), 17496 }, /* NEG */
{ CPUFUNC(op_4460_4), 17504 }, /* NEG */
{ CPUFUNC(op_4468_4), 17512 }, /* NEG */
{ CPUFUNC(op_4470_4), 17520 }, /* NEG */
{ CPUFUNC(op_4478_4), 17528 }, /* NEG */
{ CPUFUNC(op_4479_4), 17529 }, /* NEG */
{ CPUFUNC(op_4480_4), 17536 }, /* NEG */
{ CPUFUNC(op_4490_4), 17552 }, /* NEG */
{ CPUFUNC(op_4498_4), 17560 }, /* NEG */
{ CPUFUNC(op_44a0_4), 17568 }, /* NEG */
{ CPUFUNC(op_44a8_4), 17576 }, /* NEG */
{ CPUFUNC(op_44b0_4), 17584 }, /* NEG */
{ CPUFUNC(op_44b8_4), 17592 }, /* NEG */
{ CPUFUNC(op_44b9_4), 17593 }, /* NEG */
{ CPUFUNC(op_44c0_4), 17600 }, /* MV2SR */
{ CPUFUNC(op_44d0_4), 17616 }, /* MV2SR */
{ CPUFUNC(op_44d8_4), 17624 }, /* MV2SR */
{ CPUFUNC(op_44e0_4), 17632 }, /* MV2SR */
{ CPUFUNC(op_44e8_4), 17640 }, /* MV2SR */
{ CPUFUNC(op_44f0_4), 17648 }, /* MV2SR */
{ CPUFUNC(op_44f8_4), 17656 }, /* MV2SR */
{ CPUFUNC(op_44f9_4), 17657 }, /* MV2SR */
{ CPUFUNC(op_44fa_4), 17658 }, /* MV2SR */
{ CPUFUNC(op_44fb_4), 17659 }, /* MV2SR */
{ CPUFUNC(op_44fc_4), 17660 }, /* MV2SR */
{ CPUFUNC(op_4600_4), 17920 }, /* NOT */
{ CPUFUNC(op_4610_4), 17936 }, /* NOT */
{ CPUFUNC(op_4618_4), 17944 }, /* NOT */
{ CPUFUNC(op_4620_4), 17952 }, /* NOT */
{ CPUFUNC(op_4628_4), 17960 }, /* NOT */
{ CPUFUNC(op_4630_4), 17968 }, /* NOT */
{ CPUFUNC(op_4638_4), 17976 }, /* NOT */
{ CPUFUNC(op_4639_4), 17977 }, /* NOT */
{ CPUFUNC(op_4640_4), 17984 }, /* NOT */
{ CPUFUNC(op_4650_4), 18000 }, /* NOT */
{ CPUFUNC(op_4658_4), 18008 }, /* NOT */
{ CPUFUNC(op_4660_4), 18016 }, /* NOT */
{ CPUFUNC(op_4668_4), 18024 }, /* NOT */
{ CPUFUNC(op_4670_4), 18032 }, /* NOT */
{ CPUFUNC(op_4678_4), 18040 }, /* NOT */
{ CPUFUNC(op_4679_4), 18041 }, /* NOT */
{ CPUFUNC(op_4680_4), 18048 }, /* NOT */
{ CPUFUNC(op_4690_4), 18064 }, /* NOT */
{ CPUFUNC(op_4698_4), 18072 }, /* NOT */
{ CPUFUNC(op_46a0_4), 18080 }, /* NOT */
{ CPUFUNC(op_46a8_4), 18088 }, /* NOT */
{ CPUFUNC(op_46b0_4), 18096 }, /* NOT */
{ CPUFUNC(op_46b8_4), 18104 }, /* NOT */
{ CPUFUNC(op_46b9_4), 18105 }, /* NOT */
{ CPUFUNC(op_46c0_4), 18112 }, /* MV2SR */
{ CPUFUNC(op_46d0_4), 18128 }, /* MV2SR */
{ CPUFUNC(op_46d8_4), 18136 }, /* MV2SR */
{ CPUFUNC(op_46e0_4), 18144 }, /* MV2SR */
{ CPUFUNC(op_46e8_4), 18152 }, /* MV2SR */
{ CPUFUNC(op_46f0_4), 18160 }, /* MV2SR */
{ CPUFUNC(op_46f8_4), 18168 }, /* MV2SR */
{ CPUFUNC(op_46f9_4), 18169 }, /* MV2SR */
{ CPUFUNC(op_46fa_4), 18170 }, /* MV2SR */
{ CPUFUNC(op_46fb_4), 18171 }, /* MV2SR */
{ CPUFUNC(op_46fc_4), 18172 }, /* MV2SR */
{ CPUFUNC(op_4800_4), 18432 }, /* NBCD */
{ CPUFUNC(op_4810_4), 18448 }, /* NBCD */
{ CPUFUNC(op_4818_4), 18456 }, /* NBCD */
{ CPUFUNC(op_4820_4), 18464 }, /* NBCD */
{ CPUFUNC(op_4828_4), 18472 }, /* NBCD */
{ CPUFUNC(op_4830_4), 18480 }, /* NBCD */
{ CPUFUNC(op_4838_4), 18488 }, /* NBCD */
{ CPUFUNC(op_4839_4), 18489 }, /* NBCD */
{ CPUFUNC(op_4840_4), 18496 }, /* SWAP */
{ CPUFUNC(op_4850_4), 18512 }, /* PEA */
{ CPUFUNC(op_4868_4), 18536 }, /* PEA */
{ CPUFUNC(op_4870_4), 18544 }, /* PEA */
{ CPUFUNC(op_4878_4), 18552 }, /* PEA */
{ CPUFUNC(op_4879_4), 18553 }, /* PEA */
{ CPUFUNC(op_487a_4), 18554 }, /* PEA */
{ CPUFUNC(op_487b_4), 18555 }, /* PEA */
{ CPUFUNC(op_4880_4), 18560 }, /* EXT */
{ CPUFUNC(op_4890_4), 18576 }, /* MVMLE */
{ CPUFUNC(op_48a0_4), 18592 }, /* MVMLE */
{ CPUFUNC(op_48a8_4), 18600 }, /* MVMLE */
{ CPUFUNC(op_48b0_4), 18608 }, /* MVMLE */
{ CPUFUNC(op_48b8_4), 18616 }, /* MVMLE */
{ CPUFUNC(op_48b9_4), 18617 }, /* MVMLE */
{ CPUFUNC(op_48c0_4), 18624 }, /* EXT */
{ CPUFUNC(op_48d0_4), 18640 }, /* MVMLE */
{ CPUFUNC(op_48e0_4), 18656 }, /* MVMLE */
{ CPUFUNC(op_48e8_4), 18664 }, /* MVMLE */
{ CPUFUNC(op_48f0_4), 18672 }, /* MVMLE */
{ CPUFUNC(op_48f8_4), 18680 }, /* MVMLE */
{ CPUFUNC(op_48f9_4), 18681 }, /* MVMLE */
{ CPUFUNC(op_4a00_4), 18944 }, /* TST */
{ CPUFUNC(op_4a10_4), 18960 }, /* TST */
{ CPUFUNC(op_4a18_4), 18968 }, /* TST */
{ CPUFUNC(op_4a20_4), 18976 }, /* TST */
{ CPUFUNC(op_4a28_4), 18984 }, /* TST */
{ CPUFUNC(op_4a30_4), 18992 }, /* TST */
{ CPUFUNC(op_4a38_4), 19000 }, /* TST */
{ CPUFUNC(op_4a39_4), 19001 }, /* TST */
{ CPUFUNC(op_4a40_4), 19008 }, /* TST */
{ CPUFUNC(op_4a50_4), 19024 }, /* TST */
{ CPUFUNC(op_4a58_4), 19032 }, /* TST */
{ CPUFUNC(op_4a60_4), 19040 }, /* TST */
{ CPUFUNC(op_4a68_4), 19048 }, /* TST */
{ CPUFUNC(op_4a70_4), 19056 }, /* TST */
{ CPUFUNC(op_4a78_4), 19064 }, /* TST */
{ CPUFUNC(op_4a79_4), 19065 }, /* TST */
{ CPUFUNC(op_4a80_4), 19072 }, /* TST */
{ CPUFUNC(op_4a90_4), 19088 }, /* TST */
{ CPUFUNC(op_4a98_4), 19096 }, /* TST */
{ CPUFUNC(op_4aa0_4), 19104 }, /* TST */
{ CPUFUNC(op_4aa8_4), 19112 }, /* TST */
{ CPUFUNC(op_4ab0_4), 19120 }, /* TST */
{ CPUFUNC(op_4ab8_4), 19128 }, /* TST */
{ CPUFUNC(op_4ab9_4), 19129 }, /* TST */
{ CPUFUNC(op_4ac0_4), 19136 }, /* TAS */
{ CPUFUNC(op_4ad0_4), 19152 }, /* TAS */
{ CPUFUNC(op_4ad8_4), 19160 }, /* TAS */
{ CPUFUNC(op_4ae0_4), 19168 }, /* TAS */
{ CPUFUNC(op_4ae8_4), 19176 }, /* TAS */
{ CPUFUNC(op_4af0_4), 19184 }, /* TAS */
{ CPUFUNC(op_4af8_4), 19192 }, /* TAS */
{ CPUFUNC(op_4af9_4), 19193 }, /* TAS */
{ CPUFUNC(op_4c90_4), 19600 }, /* MVMEL */
{ CPUFUNC(op_4c98_4), 19608 }, /* MVMEL */
{ CPUFUNC(op_4ca8_4), 19624 }, /* MVMEL */
{ CPUFUNC(op_4cb0_4), 19632 }, /* MVMEL */
{ CPUFUNC(op_4cb8_4), 19640 }, /* MVMEL */
{ CPUFUNC(op_4cb9_4), 19641 }, /* MVMEL */
{ CPUFUNC(op_4cba_4), 19642 }, /* MVMEL */
{ CPUFUNC(op_4cbb_4), 19643 }, /* MVMEL */
{ CPUFUNC(op_4cd0_4), 19664 }, /* MVMEL */
{ CPUFUNC(op_4cd8_4), 19672 }, /* MVMEL */
{ CPUFUNC(op_4ce8_4), 19688 }, /* MVMEL */
{ CPUFUNC(op_4cf0_4), 19696 }, /* MVMEL */
{ CPUFUNC(op_4cf8_4), 19704 }, /* MVMEL */
{ CPUFUNC(op_4cf9_4), 19705 }, /* MVMEL */
{ CPUFUNC(op_4cfa_4), 19706 }, /* MVMEL */
{ CPUFUNC(op_4cfb_4), 19707 }, /* MVMEL */
{ CPUFUNC(op_4e40_4), 20032 }, /* TRAP */
{ CPUFUNC(op_4e50_4), 20048 }, /* LINK */
{ CPUFUNC(op_4e58_4), 20056 }, /* UNLK */
{ CPUFUNC(op_4e60_4), 20064 }, /* MVR2USP */
{ CPUFUNC(op_4e68_4), 20072 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_4), 20080 }, /* RESET */
{ CPUFUNC(op_4e71_4), 20081 }, /* NOP */
{ CPUFUNC(op_4e72_4), 20082 }, /* STOP */
{ CPUFUNC(op_4e73_4), 20083 }, /* RTE */
{ CPUFUNC(op_4e74_4), 20084 }, /* RTD */
{ CPUFUNC(op_4e75_4), 20085 }, /* RTS */
{ CPUFUNC(op_4e76_4), 20086 }, /* TRAPV */
{ CPUFUNC(op_4e77_4), 20087 }, /* RTR */
{ CPUFUNC(op_4e7a_4), 20090 }, /* MOVEC2 */
{ CPUFUNC(op_4e7b_4), 20091 }, /* MOVE2C */
{ CPUFUNC(op_4e90_4), 20112 }, /* JSR */
{ CPUFUNC(op_4ea8_4), 20136 }, /* JSR */
{ CPUFUNC(op_4eb0_4), 20144 }, /* JSR */
{ CPUFUNC(op_4eb8_4), 20152 }, /* JSR */
{ CPUFUNC(op_4eb9_4), 20153 }, /* JSR */
{ CPUFUNC(op_4eba_4), 20154 }, /* JSR */
{ CPUFUNC(op_4ebb_4), 20155 }, /* JSR */
{ CPUFUNC(op_4ed0_4), 20176 }, /* JMP */
{ CPUFUNC(op_4ee8_4), 20200 }, /* JMP */
{ CPUFUNC(op_4ef0_4), 20208 }, /* JMP */
{ CPUFUNC(op_4ef8_4), 20216 }, /* JMP */
{ CPUFUNC(op_4ef9_4), 20217 }, /* JMP */
{ CPUFUNC(op_4efa_4), 20218 }, /* JMP */
{ CPUFUNC(op_4efb_4), 20219 }, /* JMP */
{ CPUFUNC(op_5000_4), 20480 }, /* ADD */
{ CPUFUNC(op_5010_4), 20496 }, /* ADD */
{ CPUFUNC(op_5018_4), 20504 }, /* ADD */
{ CPUFUNC(op_5020_4), 20512 }, /* ADD */
{ CPUFUNC(op_5028_4), 20520 }, /* ADD */
{ CPUFUNC(op_5030_4), 20528 }, /* ADD */
{ CPUFUNC(op_5038_4), 20536 }, /* ADD */
{ CPUFUNC(op_5039_4), 20537 }, /* ADD */
{ CPUFUNC(op_5040_4), 20544 }, /* ADD */
{ CPUFUNC(op_5048_4), 20552 }, /* ADDA */
{ CPUFUNC(op_5050_4), 20560 }, /* ADD */
{ CPUFUNC(op_5058_4), 20568 }, /* ADD */
{ CPUFUNC(op_5060_4), 20576 }, /* ADD */
{ CPUFUNC(op_5068_4), 20584 }, /* ADD */
{ CPUFUNC(op_5070_4), 20592 }, /* ADD */
{ CPUFUNC(op_5078_4), 20600 }, /* ADD */
{ CPUFUNC(op_5079_4), 20601 }, /* ADD */
{ CPUFUNC(op_5080_4), 20608 }, /* ADD */
{ CPUFUNC(op_5088_4), 20616 }, /* ADDA */
{ CPUFUNC(op_5090_4), 20624 }, /* ADD */
{ CPUFUNC(op_5098_4), 20632 }, /* ADD */
{ CPUFUNC(op_50a0_4), 20640 }, /* ADD */
{ CPUFUNC(op_50a8_4), 20648 }, /* ADD */
{ CPUFUNC(op_50b0_4), 20656 }, /* ADD */
{ CPUFUNC(op_50b8_4), 20664 }, /* ADD */
{ CPUFUNC(op_50b9_4), 20665 }, /* ADD */
{ CPUFUNC(op_50c0_4), 20672 }, /* Scc */
{ CPUFUNC(op_50c8_4), 20680 }, /* DBcc */
{ CPUFUNC(op_50d0_4), 20688 }, /* Scc */
{ CPUFUNC(op_50d8_4), 20696 }, /* Scc */
{ CPUFUNC(op_50e0_4), 20704 }, /* Scc */
{ CPUFUNC(op_50e8_4), 20712 }, /* Scc */
{ CPUFUNC(op_50f0_4), 20720 }, /* Scc */
{ CPUFUNC(op_50f8_4), 20728 }, /* Scc */
{ CPUFUNC(op_50f9_4), 20729 }, /* Scc */
{ CPUFUNC(op_5100_4), 20736 }, /* SUB */
{ CPUFUNC(op_5110_4), 20752 }, /* SUB */
{ CPUFUNC(op_5118_4), 20760 }, /* SUB */
{ CPUFUNC(op_5120_4), 20768 }, /* SUB */
{ CPUFUNC(op_5128_4), 20776 }, /* SUB */
{ CPUFUNC(op_5130_4), 20784 }, /* SUB */
{ CPUFUNC(op_5138_4), 20792 }, /* SUB */
{ CPUFUNC(op_5139_4), 20793 }, /* SUB */
{ CPUFUNC(op_5140_4), 20800 }, /* SUB */
{ CPUFUNC(op_5148_4), 20808 }, /* SUBA */
{ CPUFUNC(op_5150_4), 20816 }, /* SUB */
{ CPUFUNC(op_5158_4), 20824 }, /* SUB */
{ CPUFUNC(op_5160_4), 20832 }, /* SUB */
{ CPUFUNC(op_5168_4), 20840 }, /* SUB */
{ CPUFUNC(op_5170_4), 20848 }, /* SUB */
{ CPUFUNC(op_5178_4), 20856 }, /* SUB */
{ CPUFUNC(op_5179_4), 20857 }, /* SUB */
{ CPUFUNC(op_5180_4), 20864 }, /* SUB */
{ CPUFUNC(op_5188_4), 20872 }, /* SUBA */
{ CPUFUNC(op_5190_4), 20880 }, /* SUB */
{ CPUFUNC(op_5198_4), 20888 }, /* SUB */
{ CPUFUNC(op_51a0_4), 20896 }, /* SUB */
{ CPUFUNC(op_51a8_4), 20904 }, /* SUB */
{ CPUFUNC(op_51b0_4), 20912 }, /* SUB */
{ CPUFUNC(op_51b8_4), 20920 }, /* SUB */
{ CPUFUNC(op_51b9_4), 20921 }, /* SUB */
{ CPUFUNC(op_51c0_4), 20928 }, /* Scc */
{ CPUFUNC(op_51c8_4), 20936 }, /* DBcc */
{ CPUFUNC(op_51d0_4), 20944 }, /* Scc */
{ CPUFUNC(op_51d8_4), 20952 }, /* Scc */
{ CPUFUNC(op_51e0_4), 20960 }, /* Scc */
{ CPUFUNC(op_51e8_4), 20968 }, /* Scc */
{ CPUFUNC(op_51f0_4), 20976 }, /* Scc */
{ CPUFUNC(op_51f8_4), 20984 }, /* Scc */
{ CPUFUNC(op_51f9_4), 20985 }, /* Scc */
{ CPUFUNC(op_52c0_4), 21184 }, /* Scc */
{ CPUFUNC(op_52c8_4), 21192 }, /* DBcc */
{ CPUFUNC(op_52d0_4), 21200 }, /* Scc */
{ CPUFUNC(op_52d8_4), 21208 }, /* Scc */
{ CPUFUNC(op_52e0_4), 21216 }, /* Scc */
{ CPUFUNC(op_52e8_4), 21224 }, /* Scc */
{ CPUFUNC(op_52f0_4), 21232 }, /* Scc */
{ CPUFUNC(op_52f8_4), 21240 }, /* Scc */
{ CPUFUNC(op_52f9_4), 21241 }, /* Scc */
{ CPUFUNC(op_53c0_4), 21440 }, /* Scc */
{ CPUFUNC(op_53c8_4), 21448 }, /* DBcc */
{ CPUFUNC(op_53d0_4), 21456 }, /* Scc */
{ CPUFUNC(op_53d8_4), 21464 }, /* Scc */
{ CPUFUNC(op_53e0_4), 21472 }, /* Scc */
{ CPUFUNC(op_53e8_4), 21480 }, /* Scc */
{ CPUFUNC(op_53f0_4), 21488 }, /* Scc */
{ CPUFUNC(op_53f8_4), 21496 }, /* Scc */
{ CPUFUNC(op_53f9_4), 21497 }, /* Scc */
{ CPUFUNC(op_54c0_4), 21696 }, /* Scc */
{ CPUFUNC(op_54c8_4), 21704 }, /* DBcc */
{ CPUFUNC(op_54d0_4), 21712 }, /* Scc */
{ CPUFUNC(op_54d8_4), 21720 }, /* Scc */
{ CPUFUNC(op_54e0_4), 21728 }, /* Scc */
{ CPUFUNC(op_54e8_4), 21736 }, /* Scc */
{ CPUFUNC(op_54f0_4), 21744 }, /* Scc */
{ CPUFUNC(op_54f8_4), 21752 }, /* Scc */
{ CPUFUNC(op_54f9_4), 21753 }, /* Scc */
{ CPUFUNC(op_55c0_4), 21952 }, /* Scc */
{ CPUFUNC(op_55c8_4), 21960 }, /* DBcc */
{ CPUFUNC(op_55d0_4), 21968 }, /* Scc */
{ CPUFUNC(op_55d8_4), 21976 }, /* Scc */
{ CPUFUNC(op_55e0_4), 21984 }, /* Scc */
{ CPUFUNC(op_55e8_4), 21992 }, /* Scc */
{ CPUFUNC(op_55f0_4), 22000 }, /* Scc */
{ CPUFUNC(op_55f8_4), 22008 }, /* Scc */
{ CPUFUNC(op_55f9_4), 22009 }, /* Scc */
{ CPUFUNC(op_56c0_4), 22208 }, /* Scc */
{ CPUFUNC(op_56c8_4), 22216 }, /* DBcc */
{ CPUFUNC(op_56d0_4), 22224 }, /* Scc */
{ CPUFUNC(op_56d8_4), 22232 }, /* Scc */
{ CPUFUNC(op_56e0_4), 22240 }, /* Scc */
{ CPUFUNC(op_56e8_4), 22248 }, /* Scc */
{ CPUFUNC(op_56f0_4), 22256 }, /* Scc */
{ CPUFUNC(op_56f8_4), 22264 }, /* Scc */
{ CPUFUNC(op_56f9_4), 22265 }, /* Scc */
{ CPUFUNC(op_57c0_4), 22464 }, /* Scc */
{ CPUFUNC(op_57c8_4), 22472 }, /* DBcc */
{ CPUFUNC(op_57d0_4), 22480 }, /* Scc */
{ CPUFUNC(op_57d8_4), 22488 }, /* Scc */
{ CPUFUNC(op_57e0_4), 22496 }, /* Scc */
{ CPUFUNC(op_57e8_4), 22504 }, /* Scc */
{ CPUFUNC(op_57f0_4), 22512 }, /* Scc */
{ CPUFUNC(op_57f8_4), 22520 }, /* Scc */
{ CPUFUNC(op_57f9_4), 22521 }, /* Scc */
{ CPUFUNC(op_58c0_4), 22720 }, /* Scc */
{ CPUFUNC(op_58c8_4), 22728 }, /* DBcc */
{ CPUFUNC(op_58d0_4), 22736 }, /* Scc */
{ CPUFUNC(op_58d8_4), 22744 }, /* Scc */
{ CPUFUNC(op_58e0_4), 22752 }, /* Scc */
{ CPUFUNC(op_58e8_4), 22760 }, /* Scc */
{ CPUFUNC(op_58f0_4), 22768 }, /* Scc */
{ CPUFUNC(op_58f8_4), 22776 }, /* Scc */
{ CPUFUNC(op_58f9_4), 22777 }, /* Scc */
{ CPUFUNC(op_59c0_4), 22976 }, /* Scc */
{ CPUFUNC(op_59c8_4), 22984 }, /* DBcc */
{ CPUFUNC(op_59d0_4), 22992 }, /* Scc */
{ CPUFUNC(op_59d8_4), 23000 }, /* Scc */
{ CPUFUNC(op_59e0_4), 23008 }, /* Scc */
{ CPUFUNC(op_59e8_4), 23016 }, /* Scc */
{ CPUFUNC(op_59f0_4), 23024 }, /* Scc */
{ CPUFUNC(op_59f8_4), 23032 }, /* Scc */
{ CPUFUNC(op_59f9_4), 23033 }, /* Scc */
{ CPUFUNC(op_5ac0_4), 23232 }, /* Scc */
{ CPUFUNC(op_5ac8_4), 23240 }, /* DBcc */
{ CPUFUNC(op_5ad0_4), 23248 }, /* Scc */
{ CPUFUNC(op_5ad8_4), 23256 }, /* Scc */
{ CPUFUNC(op_5ae0_4), 23264 }, /* Scc */
{ CPUFUNC(op_5ae8_4), 23272 }, /* Scc */
{ CPUFUNC(op_5af0_4), 23280 }, /* Scc */
{ CPUFUNC(op_5af8_4), 23288 }, /* Scc */
{ CPUFUNC(op_5af9_4), 23289 }, /* Scc */
{ CPUFUNC(op_5bc0_4), 23488 }, /* Scc */
{ CPUFUNC(op_5bc8_4), 23496 }, /* DBcc */
{ CPUFUNC(op_5bd0_4), 23504 }, /* Scc */
{ CPUFUNC(op_5bd8_4), 23512 }, /* Scc */
{ CPUFUNC(op_5be0_4), 23520 }, /* Scc */
{ CPUFUNC(op_5be8_4), 23528 }, /* Scc */
{ CPUFUNC(op_5bf0_4), 23536 }, /* Scc */
{ CPUFUNC(op_5bf8_4), 23544 }, /* Scc */
{ CPUFUNC(op_5bf9_4), 23545 }, /* Scc */
{ CPUFUNC(op_5cc0_4), 23744 }, /* Scc */
{ CPUFUNC(op_5cc8_4), 23752 }, /* DBcc */
{ CPUFUNC(op_5cd0_4), 23760 }, /* Scc */
{ CPUFUNC(op_5cd8_4), 23768 }, /* Scc */
{ CPUFUNC(op_5ce0_4), 23776 }, /* Scc */
{ CPUFUNC(op_5ce8_4), 23784 }, /* Scc */
{ CPUFUNC(op_5cf0_4), 23792 }, /* Scc */
{ CPUFUNC(op_5cf8_4), 23800 }, /* Scc */
{ CPUFUNC(op_5cf9_4), 23801 }, /* Scc */
{ CPUFUNC(op_5dc0_4), 24000 }, /* Scc */
{ CPUFUNC(op_5dc8_4), 24008 }, /* DBcc */
{ CPUFUNC(op_5dd0_4), 24016 }, /* Scc */
{ CPUFUNC(op_5dd8_4), 24024 }, /* Scc */
{ CPUFUNC(op_5de0_4), 24032 }, /* Scc */
{ CPUFUNC(op_5de8_4), 24040 }, /* Scc */
{ CPUFUNC(op_5df0_4), 24048 }, /* Scc */
{ CPUFUNC(op_5df8_4), 24056 }, /* Scc */
{ CPUFUNC(op_5df9_4), 24057 }, /* Scc */
{ CPUFUNC(op_5ec0_4), 24256 }, /* Scc */
{ CPUFUNC(op_5ec8_4), 24264 }, /* DBcc */
{ CPUFUNC(op_5ed0_4), 24272 }, /* Scc */
{ CPUFUNC(op_5ed8_4), 24280 }, /* Scc */
{ CPUFUNC(op_5ee0_4), 24288 }, /* Scc */
{ CPUFUNC(op_5ee8_4), 24296 }, /* Scc */
{ CPUFUNC(op_5ef0_4), 24304 }, /* Scc */
{ CPUFUNC(op_5ef8_4), 24312 }, /* Scc */
{ CPUFUNC(op_5ef9_4), 24313 }, /* Scc */
{ CPUFUNC(op_5fc0_4), 24512 }, /* Scc */
{ CPUFUNC(op_5fc8_4), 24520 }, /* DBcc */
{ CPUFUNC(op_5fd0_4), 24528 }, /* Scc */
{ CPUFUNC(op_5fd8_4), 24536 }, /* Scc */
{ CPUFUNC(op_5fe0_4), 24544 }, /* Scc */
{ CPUFUNC(op_5fe8_4), 24552 }, /* Scc */
{ CPUFUNC(op_5ff0_4), 24560 }, /* Scc */
{ CPUFUNC(op_5ff8_4), 24568 }, /* Scc */
{ CPUFUNC(op_5ff9_4), 24569 }, /* Scc */
{ CPUFUNC(op_6000_4), 24576 }, /* Bcc */
{ CPUFUNC(op_6001_4), 24577 }, /* Bcc */
{ CPUFUNC(op_60ff_4), 24831 }, /* Bcc */
{ CPUFUNC(op_6100_4), 24832 }, /* BSR */
{ CPUFUNC(op_6101_4), 24833 }, /* BSR */
{ CPUFUNC(op_61ff_4), 25087 }, /* BSR */
{ CPUFUNC(op_6200_4), 25088 }, /* Bcc */
{ CPUFUNC(op_6201_4), 25089 }, /* Bcc */
{ CPUFUNC(op_62ff_4), 25343 }, /* Bcc */
{ CPUFUNC(op_6300_4), 25344 }, /* Bcc */
{ CPUFUNC(op_6301_4), 25345 }, /* Bcc */
{ CPUFUNC(op_63ff_4), 25599 }, /* Bcc */
{ CPUFUNC(op_6400_4), 25600 }, /* Bcc */
{ CPUFUNC(op_6401_4), 25601 }, /* Bcc */
{ CPUFUNC(op_64ff_4), 25855 }, /* Bcc */
{ CPUFUNC(op_6500_4), 25856 }, /* Bcc */
{ CPUFUNC(op_6501_4), 25857 }, /* Bcc */
{ CPUFUNC(op_65ff_4), 26111 }, /* Bcc */
{ CPUFUNC(op_6600_4), 26112 }, /* Bcc */
{ CPUFUNC(op_6601_4), 26113 }, /* Bcc */
{ CPUFUNC(op_66ff_4), 26367 }, /* Bcc */
{ CPUFUNC(op_6700_4), 26368 }, /* Bcc */
{ CPUFUNC(op_6701_4), 26369 }, /* Bcc */
{ CPUFUNC(op_67ff_4), 26623 }, /* Bcc */
{ CPUFUNC(op_6800_4), 26624 }, /* Bcc */
{ CPUFUNC(op_6801_4), 26625 }, /* Bcc */
{ CPUFUNC(op_68ff_4), 26879 }, /* Bcc */
{ CPUFUNC(op_6900_4), 26880 }, /* Bcc */
{ CPUFUNC(op_6901_4), 26881 }, /* Bcc */
{ CPUFUNC(op_69ff_4), 27135 }, /* Bcc */
{ CPUFUNC(op_6a00_4), 27136 }, /* Bcc */
{ CPUFUNC(op_6a01_4), 27137 }, /* Bcc */
{ CPUFUNC(op_6aff_4), 27391 }, /* Bcc */
{ CPUFUNC(op_6b00_4), 27392 }, /* Bcc */
{ CPUFUNC(op_6b01_4), 27393 }, /* Bcc */
{ CPUFUNC(op_6bff_4), 27647 }, /* Bcc */
{ CPUFUNC(op_6c00_4), 27648 }, /* Bcc */
{ CPUFUNC(op_6c01_4), 27649 }, /* Bcc */
{ CPUFUNC(op_6cff_4), 27903 }, /* Bcc */
{ CPUFUNC(op_6d00_4), 27904 }, /* Bcc */
{ CPUFUNC(op_6d01_4), 27905 }, /* Bcc */
{ CPUFUNC(op_6dff_4), 28159 }, /* Bcc */
{ CPUFUNC(op_6e00_4), 28160 }, /* Bcc */
{ CPUFUNC(op_6e01_4), 28161 }, /* Bcc */
{ CPUFUNC(op_6eff_4), 28415 }, /* Bcc */
{ CPUFUNC(op_6f00_4), 28416 }, /* Bcc */
{ CPUFUNC(op_6f01_4), 28417 }, /* Bcc */
{ CPUFUNC(op_6fff_4), 28671 }, /* Bcc */
{ CPUFUNC(op_7000_4), 28672 }, /* MOVE */
{ CPUFUNC(op_8000_4), 32768 }, /* OR */
{ CPUFUNC(op_8010_4), 32784 }, /* OR */
{ CPUFUNC(op_8018_4), 32792 }, /* OR */
{ CPUFUNC(op_8020_4), 32800 }, /* OR */
{ CPUFUNC(op_8028_4), 32808 }, /* OR */
{ CPUFUNC(op_8030_4), 32816 }, /* OR */
{ CPUFUNC(op_8038_4), 32824 }, /* OR */
{ CPUFUNC(op_8039_4), 32825 }, /* OR */
{ CPUFUNC(op_803a_4), 32826 }, /* OR */
{ CPUFUNC(op_803b_4), 32827 }, /* OR */
{ CPUFUNC(op_803c_4), 32828 }, /* OR */
{ CPUFUNC(op_8040_4), 32832 }, /* OR */
{ CPUFUNC(op_8050_4), 32848 }, /* OR */
{ CPUFUNC(op_8058_4), 32856 }, /* OR */
{ CPUFUNC(op_8060_4), 32864 }, /* OR */
{ CPUFUNC(op_8068_4), 32872 }, /* OR */
{ CPUFUNC(op_8070_4), 32880 }, /* OR */
{ CPUFUNC(op_8078_4), 32888 }, /* OR */
{ CPUFUNC(op_8079_4), 32889 }, /* OR */
{ CPUFUNC(op_807a_4), 32890 }, /* OR */
{ CPUFUNC(op_807b_4), 32891 }, /* OR */
{ CPUFUNC(op_807c_4), 32892 }, /* OR */
{ CPUFUNC(op_8080_4), 32896 }, /* OR */
{ CPUFUNC(op_8090_4), 32912 }, /* OR */
{ CPUFUNC(op_8098_4), 32920 }, /* OR */
{ CPUFUNC(op_80a0_4), 32928 }, /* OR */
{ CPUFUNC(op_80a8_4), 32936 }, /* OR */
{ CPUFUNC(op_80b0_4), 32944 }, /* OR */
{ CPUFUNC(op_80b8_4), 32952 }, /* OR */
{ CPUFUNC(op_80b9_4), 32953 }, /* OR */
{ CPUFUNC(op_80ba_4), 32954 }, /* OR */
{ CPUFUNC(op_80bb_4), 32955 }, /* OR */
{ CPUFUNC(op_80bc_4), 32956 }, /* OR */
{ CPUFUNC(op_80c0_4), 32960 }, /* DIVU */
{ CPUFUNC(op_80d0_4), 32976 }, /* DIVU */
{ CPUFUNC(op_80d8_4), 32984 }, /* DIVU */
{ CPUFUNC(op_80e0_4), 32992 }, /* DIVU */
{ CPUFUNC(op_80e8_4), 33000 }, /* DIVU */
{ CPUFUNC(op_80f0_4), 33008 }, /* DIVU */
{ CPUFUNC(op_80f8_4), 33016 }, /* DIVU */
{ CPUFUNC(op_80f9_4), 33017 }, /* DIVU */
{ CPUFUNC(op_80fa_4), 33018 }, /* DIVU */
{ CPUFUNC(op_80fb_4), 33019 }, /* DIVU */
{ CPUFUNC(op_80fc_4), 33020 }, /* DIVU */
{ CPUFUNC(op_8100_4), 33024 }, /* SBCD */
{ CPUFUNC(op_8108_4), 33032 }, /* SBCD */
{ CPUFUNC(op_8110_4), 33040 }, /* OR */
{ CPUFUNC(op_8118_4), 33048 }, /* OR */
{ CPUFUNC(op_8120_4), 33056 }, /* OR */
{ CPUFUNC(op_8128_4), 33064 }, /* OR */
{ CPUFUNC(op_8130_4), 33072 }, /* OR */
{ CPUFUNC(op_8138_4), 33080 }, /* OR */
{ CPUFUNC(op_8139_4), 33081 }, /* OR */
{ CPUFUNC(op_8150_4), 33104 }, /* OR */
{ CPUFUNC(op_8158_4), 33112 }, /* OR */
{ CPUFUNC(op_8160_4), 33120 }, /* OR */
{ CPUFUNC(op_8168_4), 33128 }, /* OR */
{ CPUFUNC(op_8170_4), 33136 }, /* OR */
{ CPUFUNC(op_8178_4), 33144 }, /* OR */
{ CPUFUNC(op_8179_4), 33145 }, /* OR */
{ CPUFUNC(op_8190_4), 33168 }, /* OR */
{ CPUFUNC(op_8198_4), 33176 }, /* OR */
{ CPUFUNC(op_81a0_4), 33184 }, /* OR */
{ CPUFUNC(op_81a8_4), 33192 }, /* OR */
{ CPUFUNC(op_81b0_4), 33200 }, /* OR */
{ CPUFUNC(op_81b8_4), 33208 }, /* OR */
{ CPUFUNC(op_81b9_4), 33209 }, /* OR */
{ CPUFUNC(op_81c0_4), 33216 }, /* DIVS */
{ CPUFUNC(op_81d0_4), 33232 }, /* DIVS */
{ CPUFUNC(op_81d8_4), 33240 }, /* DIVS */
{ CPUFUNC(op_81e0_4), 33248 }, /* DIVS */
{ CPUFUNC(op_81e8_4), 33256 }, /* DIVS */
{ CPUFUNC(op_81f0_4), 33264 }, /* DIVS */
{ CPUFUNC(op_81f8_4), 33272 }, /* DIVS */
{ CPUFUNC(op_81f9_4), 33273 }, /* DIVS */
{ CPUFUNC(op_81fa_4), 33274 }, /* DIVS */
{ CPUFUNC(op_81fb_4), 33275 }, /* DIVS */
{ CPUFUNC(op_81fc_4), 33276 }, /* DIVS */
{ CPUFUNC(op_9000_4), 36864 }, /* SUB */
{ CPUFUNC(op_9010_4), 36880 }, /* SUB */
{ CPUFUNC(op_9018_4), 36888 }, /* SUB */
{ CPUFUNC(op_9020_4), 36896 }, /* SUB */
{ CPUFUNC(op_9028_4), 36904 }, /* SUB */
{ CPUFUNC(op_9030_4), 36912 }, /* SUB */
{ CPUFUNC(op_9038_4), 36920 }, /* SUB */
{ CPUFUNC(op_9039_4), 36921 }, /* SUB */
{ CPUFUNC(op_903a_4), 36922 }, /* SUB */
{ CPUFUNC(op_903b_4), 36923 }, /* SUB */
{ CPUFUNC(op_903c_4), 36924 }, /* SUB */
{ CPUFUNC(op_9040_4), 36928 }, /* SUB */
{ CPUFUNC(op_9048_4), 36936 }, /* SUB */
{ CPUFUNC(op_9050_4), 36944 }, /* SUB */
{ CPUFUNC(op_9058_4), 36952 }, /* SUB */
{ CPUFUNC(op_9060_4), 36960 }, /* SUB */
{ CPUFUNC(op_9068_4), 36968 }, /* SUB */
{ CPUFUNC(op_9070_4), 36976 }, /* SUB */
{ CPUFUNC(op_9078_4), 36984 }, /* SUB */
{ CPUFUNC(op_9079_4), 36985 }, /* SUB */
{ CPUFUNC(op_907a_4), 36986 }, /* SUB */
{ CPUFUNC(op_907b_4), 36987 }, /* SUB */
{ CPUFUNC(op_907c_4), 36988 }, /* SUB */
{ CPUFUNC(op_9080_4), 36992 }, /* SUB */
{ CPUFUNC(op_9088_4), 37000 }, /* SUB */
{ CPUFUNC(op_9090_4), 37008 }, /* SUB */
{ CPUFUNC(op_9098_4), 37016 }, /* SUB */
{ CPUFUNC(op_90a0_4), 37024 }, /* SUB */
{ CPUFUNC(op_90a8_4), 37032 }, /* SUB */
{ CPUFUNC(op_90b0_4), 37040 }, /* SUB */
{ CPUFUNC(op_90b8_4), 37048 }, /* SUB */
{ CPUFUNC(op_90b9_4), 37049 }, /* SUB */
{ CPUFUNC(op_90ba_4), 37050 }, /* SUB */
{ CPUFUNC(op_90bb_4), 37051 }, /* SUB */
{ CPUFUNC(op_90bc_4), 37052 }, /* SUB */
{ CPUFUNC(op_90c0_4), 37056 }, /* SUBA */
{ CPUFUNC(op_90c8_4), 37064 }, /* SUBA */
{ CPUFUNC(op_90d0_4), 37072 }, /* SUBA */
{ CPUFUNC(op_90d8_4), 37080 }, /* SUBA */
{ CPUFUNC(op_90e0_4), 37088 }, /* SUBA */
{ CPUFUNC(op_90e8_4), 37096 }, /* SUBA */
{ CPUFUNC(op_90f0_4), 37104 }, /* SUBA */
{ CPUFUNC(op_90f8_4), 37112 }, /* SUBA */
{ CPUFUNC(op_90f9_4), 37113 }, /* SUBA */
{ CPUFUNC(op_90fa_4), 37114 }, /* SUBA */
{ CPUFUNC(op_90fb_4), 37115 }, /* SUBA */
{ CPUFUNC(op_90fc_4), 37116 }, /* SUBA */
{ CPUFUNC(op_9100_4), 37120 }, /* SUBX */
{ CPUFUNC(op_9108_4), 37128 }, /* SUBX */
{ CPUFUNC(op_9110_4), 37136 }, /* SUB */
{ CPUFUNC(op_9118_4), 37144 }, /* SUB */
{ CPUFUNC(op_9120_4), 37152 }, /* SUB */
{ CPUFUNC(op_9128_4), 37160 }, /* SUB */
{ CPUFUNC(op_9130_4), 37168 }, /* SUB */
{ CPUFUNC(op_9138_4), 37176 }, /* SUB */
{ CPUFUNC(op_9139_4), 37177 }, /* SUB */
{ CPUFUNC(op_9140_4), 37184 }, /* SUBX */
{ CPUFUNC(op_9148_4), 37192 }, /* SUBX */
{ CPUFUNC(op_9150_4), 37200 }, /* SUB */
{ CPUFUNC(op_9158_4), 37208 }, /* SUB */
{ CPUFUNC(op_9160_4), 37216 }, /* SUB */
{ CPUFUNC(op_9168_4), 37224 }, /* SUB */
{ CPUFUNC(op_9170_4), 37232 }, /* SUB */
{ CPUFUNC(op_9178_4), 37240 }, /* SUB */
{ CPUFUNC(op_9179_4), 37241 }, /* SUB */
{ CPUFUNC(op_9180_4), 37248 }, /* SUBX */
{ CPUFUNC(op_9188_4), 37256 }, /* SUBX */
{ CPUFUNC(op_9190_4), 37264 }, /* SUB */
{ CPUFUNC(op_9198_4), 37272 }, /* SUB */
{ CPUFUNC(op_91a0_4), 37280 }, /* SUB */
{ CPUFUNC(op_91a8_4), 37288 }, /* SUB */
{ CPUFUNC(op_91b0_4), 37296 }, /* SUB */
{ CPUFUNC(op_91b8_4), 37304 }, /* SUB */
{ CPUFUNC(op_91b9_4), 37305 }, /* SUB */
{ CPUFUNC(op_91c0_4), 37312 }, /* SUBA */
{ CPUFUNC(op_91c8_4), 37320 }, /* SUBA */
{ CPUFUNC(op_91d0_4), 37328 }, /* SUBA */
{ CPUFUNC(op_91d8_4), 37336 }, /* SUBA */
{ CPUFUNC(op_91e0_4), 37344 }, /* SUBA */
{ CPUFUNC(op_91e8_4), 37352 }, /* SUBA */
{ CPUFUNC(op_91f0_4), 37360 }, /* SUBA */
{ CPUFUNC(op_91f8_4), 37368 }, /* SUBA */
{ CPUFUNC(op_91f9_4), 37369 }, /* SUBA */
{ CPUFUNC(op_91fa_4), 37370 }, /* SUBA */
{ CPUFUNC(op_91fb_4), 37371 }, /* SUBA */
{ CPUFUNC(op_91fc_4), 37372 }, /* SUBA */
{ CPUFUNC(op_b000_4), 45056 }, /* CMP */
{ CPUFUNC(op_b010_4), 45072 }, /* CMP */
{ CPUFUNC(op_b018_4), 45080 }, /* CMP */
{ CPUFUNC(op_b020_4), 45088 }, /* CMP */
{ CPUFUNC(op_b028_4), 45096 }, /* CMP */
{ CPUFUNC(op_b030_4), 45104 }, /* CMP */
{ CPUFUNC(op_b038_4), 45112 }, /* CMP */
{ CPUFUNC(op_b039_4), 45113 }, /* CMP */
{ CPUFUNC(op_b03a_4), 45114 }, /* CMP */
{ CPUFUNC(op_b03b_4), 45115 }, /* CMP */
{ CPUFUNC(op_b03c_4), 45116 }, /* CMP */
{ CPUFUNC(op_b040_4), 45120 }, /* CMP */
{ CPUFUNC(op_b048_4), 45128 }, /* CMP */
{ CPUFUNC(op_b050_4), 45136 }, /* CMP */
{ CPUFUNC(op_b058_4), 45144 }, /* CMP */
{ CPUFUNC(op_b060_4), 45152 }, /* CMP */
{ CPUFUNC(op_b068_4), 45160 }, /* CMP */
{ CPUFUNC(op_b070_4), 45168 }, /* CMP */
{ CPUFUNC(op_b078_4), 45176 }, /* CMP */
{ CPUFUNC(op_b079_4), 45177 }, /* CMP */
{ CPUFUNC(op_b07a_4), 45178 }, /* CMP */
{ CPUFUNC(op_b07b_4), 45179 }, /* CMP */
{ CPUFUNC(op_b07c_4), 45180 }, /* CMP */
{ CPUFUNC(op_b080_4), 45184 }, /* CMP */
{ CPUFUNC(op_b088_4), 45192 }, /* CMP */
{ CPUFUNC(op_b090_4), 45200 }, /* CMP */
{ CPUFUNC(op_b098_4), 45208 }, /* CMP */
{ CPUFUNC(op_b0a0_4), 45216 }, /* CMP */
{ CPUFUNC(op_b0a8_4), 45224 }, /* CMP */
{ CPUFUNC(op_b0b0_4), 45232 }, /* CMP */
{ CPUFUNC(op_b0b8_4), 45240 }, /* CMP */
{ CPUFUNC(op_b0b9_4), 45241 }, /* CMP */
{ CPUFUNC(op_b0ba_4), 45242 }, /* CMP */
{ CPUFUNC(op_b0bb_4), 45243 }, /* CMP */
{ CPUFUNC(op_b0bc_4), 45244 }, /* CMP */
{ CPUFUNC(op_b0c0_4), 45248 }, /* CMPA */
{ CPUFUNC(op_b0c8_4), 45256 }, /* CMPA */
{ CPUFUNC(op_b0d0_4), 45264 }, /* CMPA */
{ CPUFUNC(op_b0d8_4), 45272 }, /* CMPA */
{ CPUFUNC(op_b0e0_4), 45280 }, /* CMPA */
{ CPUFUNC(op_b0e8_4), 45288 }, /* CMPA */
{ CPUFUNC(op_b0f0_4), 45296 }, /* CMPA */
{ CPUFUNC(op_b0f8_4), 45304 }, /* CMPA */
{ CPUFUNC(op_b0f9_4), 45305 }, /* CMPA */
{ CPUFUNC(op_b0fa_4), 45306 }, /* CMPA */
{ CPUFUNC(op_b0fb_4), 45307 }, /* CMPA */
{ CPUFUNC(op_b0fc_4), 45308 }, /* CMPA */
{ CPUFUNC(op_b100_4), 45312 }, /* EOR */
{ CPUFUNC(op_b108_4), 45320 }, /* CMPM */
{ CPUFUNC(op_b110_4), 45328 }, /* EOR */
{ CPUFUNC(op_b118_4), 45336 }, /* EOR */
{ CPUFUNC(op_b120_4), 45344 }, /* EOR */
{ CPUFUNC(op_b128_4), 45352 }, /* EOR */
{ CPUFUNC(op_b130_4), 45360 }, /* EOR */
{ CPUFUNC(op_b138_4), 45368 }, /* EOR */
{ CPUFUNC(op_b139_4), 45369 }, /* EOR */
{ CPUFUNC(op_b140_4), 45376 }, /* EOR */
{ CPUFUNC(op_b148_4), 45384 }, /* CMPM */
{ CPUFUNC(op_b150_4), 45392 }, /* EOR */
{ CPUFUNC(op_b158_4), 45400 }, /* EOR */
{ CPUFUNC(op_b160_4), 45408 }, /* EOR */
{ CPUFUNC(op_b168_4), 45416 }, /* EOR */
{ CPUFUNC(op_b170_4), 45424 }, /* EOR */
{ CPUFUNC(op_b178_4), 45432 }, /* EOR */
{ CPUFUNC(op_b179_4), 45433 }, /* EOR */
{ CPUFUNC(op_b180_4), 45440 }, /* EOR */
{ CPUFUNC(op_b188_4), 45448 }, /* CMPM */
{ CPUFUNC(op_b190_4), 45456 }, /* EOR */
{ CPUFUNC(op_b198_4), 45464 }, /* EOR */
{ CPUFUNC(op_b1a0_4), 45472 }, /* EOR */
{ CPUFUNC(op_b1a8_4), 45480 }, /* EOR */
{ CPUFUNC(op_b1b0_4), 45488 }, /* EOR */
{ CPUFUNC(op_b1b8_4), 45496 }, /* EOR */
{ CPUFUNC(op_b1b9_4), 45497 }, /* EOR */
{ CPUFUNC(op_b1c0_4), 45504 }, /* CMPA */
{ CPUFUNC(op_b1c8_4), 45512 }, /* CMPA */
{ CPUFUNC(op_b1d0_4), 45520 }, /* CMPA */
{ CPUFUNC(op_b1d8_4), 45528 }, /* CMPA */
{ CPUFUNC(op_b1e0_4), 45536 }, /* CMPA */
{ CPUFUNC(op_b1e8_4), 45544 }, /* CMPA */
{ CPUFUNC(op_b1f0_4), 45552 }, /* CMPA */
{ CPUFUNC(op_b1f8_4), 45560 }, /* CMPA */
{ CPUFUNC(op_b1f9_4), 45561 }, /* CMPA */
{ CPUFUNC(op_b1fa_4), 45562 }, /* CMPA */
{ CPUFUNC(op_b1fb_4), 45563 }, /* CMPA */
{ CPUFUNC(op_b1fc_4), 45564 }, /* CMPA */
{ CPUFUNC(op_c000_4), 49152 }, /* AND */
{ CPUFUNC(op_c010_4), 49168 }, /* AND */
{ CPUFUNC(op_c018_4), 49176 }, /* AND */
{ CPUFUNC(op_c020_4), 49184 }, /* AND */
{ CPUFUNC(op_c028_4), 49192 }, /* AND */
{ CPUFUNC(op_c030_4), 49200 }, /* AND */
{ CPUFUNC(op_c038_4), 49208 }, /* AND */
{ CPUFUNC(op_c039_4), 49209 }, /* AND */
{ CPUFUNC(op_c03a_4), 49210 }, /* AND */
{ CPUFUNC(op_c03b_4), 49211 }, /* AND */
{ CPUFUNC(op_c03c_4), 49212 }, /* AND */
{ CPUFUNC(op_c040_4), 49216 }, /* AND */
{ CPUFUNC(op_c050_4), 49232 }, /* AND */
{ CPUFUNC(op_c058_4), 49240 }, /* AND */
{ CPUFUNC(op_c060_4), 49248 }, /* AND */
{ CPUFUNC(op_c068_4), 49256 }, /* AND */
{ CPUFUNC(op_c070_4), 49264 }, /* AND */
{ CPUFUNC(op_c078_4), 49272 }, /* AND */
{ CPUFUNC(op_c079_4), 49273 }, /* AND */
{ CPUFUNC(op_c07a_4), 49274 }, /* AND */
{ CPUFUNC(op_c07b_4), 49275 }, /* AND */
{ CPUFUNC(op_c07c_4), 49276 }, /* AND */
{ CPUFUNC(op_c080_4), 49280 }, /* AND */
{ CPUFUNC(op_c090_4), 49296 }, /* AND */
{ CPUFUNC(op_c098_4), 49304 }, /* AND */
{ CPUFUNC(op_c0a0_4), 49312 }, /* AND */
{ CPUFUNC(op_c0a8_4), 49320 }, /* AND */
{ CPUFUNC(op_c0b0_4), 49328 }, /* AND */
{ CPUFUNC(op_c0b8_4), 49336 }, /* AND */
{ CPUFUNC(op_c0b9_4), 49337 }, /* AND */
{ CPUFUNC(op_c0ba_4), 49338 }, /* AND */
{ CPUFUNC(op_c0bb_4), 49339 }, /* AND */
{ CPUFUNC(op_c0bc_4), 49340 }, /* AND */
{ CPUFUNC(op_c0c0_4), 49344 }, /* MULU */
{ CPUFUNC(op_c0d0_4), 49360 }, /* MULU */
{ CPUFUNC(op_c0d8_4), 49368 }, /* MULU */
{ CPUFUNC(op_c0e0_4), 49376 }, /* MULU */
{ CPUFUNC(op_c0e8_4), 49384 }, /* MULU */
{ CPUFUNC(op_c0f0_4), 49392 }, /* MULU */
{ CPUFUNC(op_c0f8_4), 49400 }, /* MULU */
{ CPUFUNC(op_c0f9_4), 49401 }, /* MULU */
{ CPUFUNC(op_c0fa_4), 49402 }, /* MULU */
{ CPUFUNC(op_c0fb_4), 49403 }, /* MULU */
{ CPUFUNC(op_c0fc_4), 49404 }, /* MULU */
{ CPUFUNC(op_c100_4), 49408 }, /* ABCD */
{ CPUFUNC(op_c108_4), 49416 }, /* ABCD */
{ CPUFUNC(op_c110_4), 49424 }, /* AND */
{ CPUFUNC(op_c118_4), 49432 }, /* AND */
{ CPUFUNC(op_c120_4), 49440 }, /* AND */
{ CPUFUNC(op_c128_4), 49448 }, /* AND */
{ CPUFUNC(op_c130_4), 49456 }, /* AND */
{ CPUFUNC(op_c138_4), 49464 }, /* AND */
{ CPUFUNC(op_c139_4), 49465 }, /* AND */
{ CPUFUNC(op_c140_4), 49472 }, /* EXG */
{ CPUFUNC(op_c148_4), 49480 }, /* EXG */
{ CPUFUNC(op_c150_4), 49488 }, /* AND */
{ CPUFUNC(op_c158_4), 49496 }, /* AND */
{ CPUFUNC(op_c160_4), 49504 }, /* AND */
{ CPUFUNC(op_c168_4), 49512 }, /* AND */
{ CPUFUNC(op_c170_4), 49520 }, /* AND */
{ CPUFUNC(op_c178_4), 49528 }, /* AND */
{ CPUFUNC(op_c179_4), 49529 }, /* AND */
{ CPUFUNC(op_c188_4), 49544 }, /* EXG */
{ CPUFUNC(op_c190_4), 49552 }, /* AND */
{ CPUFUNC(op_c198_4), 49560 }, /* AND */
{ CPUFUNC(op_c1a0_4), 49568 }, /* AND */
{ CPUFUNC(op_c1a8_4), 49576 }, /* AND */
{ CPUFUNC(op_c1b0_4), 49584 }, /* AND */
{ CPUFUNC(op_c1b8_4), 49592 }, /* AND */
{ CPUFUNC(op_c1b9_4), 49593 }, /* AND */
{ CPUFUNC(op_c1c0_4), 49600 }, /* MULS */
{ CPUFUNC(op_c1d0_4), 49616 }, /* MULS */
{ CPUFUNC(op_c1d8_4), 49624 }, /* MULS */
{ CPUFUNC(op_c1e0_4), 49632 }, /* MULS */
{ CPUFUNC(op_c1e8_4), 49640 }, /* MULS */
{ CPUFUNC(op_c1f0_4), 49648 }, /* MULS */
{ CPUFUNC(op_c1f8_4), 49656 }, /* MULS */
{ CPUFUNC(op_c1f9_4), 49657 }, /* MULS */
{ CPUFUNC(op_c1fa_4), 49658 }, /* MULS */
{ CPUFUNC(op_c1fb_4), 49659 }, /* MULS */
{ CPUFUNC(op_c1fc_4), 49660 }, /* MULS */
{ CPUFUNC(op_d000_4), 53248 }, /* ADD */
{ CPUFUNC(op_d010_4), 53264 }, /* ADD */
{ CPUFUNC(op_d018_4), 53272 }, /* ADD */
{ CPUFUNC(op_d020_4), 53280 }, /* ADD */
{ CPUFUNC(op_d028_4), 53288 }, /* ADD */
{ CPUFUNC(op_d030_4), 53296 }, /* ADD */
{ CPUFUNC(op_d038_4), 53304 }, /* ADD */
{ CPUFUNC(op_d039_4), 53305 }, /* ADD */
{ CPUFUNC(op_d03a_4), 53306 }, /* ADD */
{ CPUFUNC(op_d03b_4), 53307 }, /* ADD */
{ CPUFUNC(op_d03c_4), 53308 }, /* ADD */
{ CPUFUNC(op_d040_4), 53312 }, /* ADD */
{ CPUFUNC(op_d048_4), 53320 }, /* ADD */
{ CPUFUNC(op_d050_4), 53328 }, /* ADD */
{ CPUFUNC(op_d058_4), 53336 }, /* ADD */
{ CPUFUNC(op_d060_4), 53344 }, /* ADD */
{ CPUFUNC(op_d068_4), 53352 }, /* ADD */
{ CPUFUNC(op_d070_4), 53360 }, /* ADD */
{ CPUFUNC(op_d078_4), 53368 }, /* ADD */
{ CPUFUNC(op_d079_4), 53369 }, /* ADD */
{ CPUFUNC(op_d07a_4), 53370 }, /* ADD */
{ CPUFUNC(op_d07b_4), 53371 }, /* ADD */
{ CPUFUNC(op_d07c_4), 53372 }, /* ADD */
{ CPUFUNC(op_d080_4), 53376 }, /* ADD */
{ CPUFUNC(op_d088_4), 53384 }, /* ADD */
{ CPUFUNC(op_d090_4), 53392 }, /* ADD */
{ CPUFUNC(op_d098_4), 53400 }, /* ADD */
{ CPUFUNC(op_d0a0_4), 53408 }, /* ADD */
{ CPUFUNC(op_d0a8_4), 53416 }, /* ADD */
{ CPUFUNC(op_d0b0_4), 53424 }, /* ADD */
{ CPUFUNC(op_d0b8_4), 53432 }, /* ADD */
{ CPUFUNC(op_d0b9_4), 53433 }, /* ADD */
{ CPUFUNC(op_d0ba_4), 53434 }, /* ADD */
{ CPUFUNC(op_d0bb_4), 53435 }, /* ADD */
{ CPUFUNC(op_d0bc_4), 53436 }, /* ADD */
{ CPUFUNC(op_d0c0_4), 53440 }, /* ADDA */
{ CPUFUNC(op_d0c8_4), 53448 }, /* ADDA */
{ CPUFUNC(op_d0d0_4), 53456 }, /* ADDA */
{ CPUFUNC(op_d0d8_4), 53464 }, /* ADDA */
{ CPUFUNC(op_d0e0_4), 53472 }, /* ADDA */
{ CPUFUNC(op_d0e8_4), 53480 }, /* ADDA */
{ CPUFUNC(op_d0f0_4), 53488 }, /* ADDA */
{ CPUFUNC(op_d0f8_4), 53496 }, /* ADDA */
{ CPUFUNC(op_d0f9_4), 53497 }, /* ADDA */
{ CPUFUNC(op_d0fa_4), 53498 }, /* ADDA */
{ CPUFUNC(op_d0fb_4), 53499 }, /* ADDA */
{ CPUFUNC(op_d0fc_4), 53500 }, /* ADDA */
{ CPUFUNC(op_d100_4), 53504 }, /* ADDX */
{ CPUFUNC(op_d108_4), 53512 }, /* ADDX */
{ CPUFUNC(op_d110_4), 53520 }, /* ADD */
{ CPUFUNC(op_d118_4), 53528 }, /* ADD */
{ CPUFUNC(op_d120_4), 53536 }, /* ADD */
{ CPUFUNC(op_d128_4), 53544 }, /* ADD */
{ CPUFUNC(op_d130_4), 53552 }, /* ADD */
{ CPUFUNC(op_d138_4), 53560 }, /* ADD */
{ CPUFUNC(op_d139_4), 53561 }, /* ADD */
{ CPUFUNC(op_d140_4), 53568 }, /* ADDX */
{ CPUFUNC(op_d148_4), 53576 }, /* ADDX */
{ CPUFUNC(op_d150_4), 53584 }, /* ADD */
{ CPUFUNC(op_d158_4), 53592 }, /* ADD */
{ CPUFUNC(op_d160_4), 53600 }, /* ADD */
{ CPUFUNC(op_d168_4), 53608 }, /* ADD */
{ CPUFUNC(op_d170_4), 53616 }, /* ADD */
{ CPUFUNC(op_d178_4), 53624 }, /* ADD */
{ CPUFUNC(op_d179_4), 53625 }, /* ADD */
{ CPUFUNC(op_d180_4), 53632 }, /* ADDX */
{ CPUFUNC(op_d188_4), 53640 }, /* ADDX */
{ CPUFUNC(op_d190_4), 53648 }, /* ADD */
{ CPUFUNC(op_d198_4), 53656 }, /* ADD */
{ CPUFUNC(op_d1a0_4), 53664 }, /* ADD */
{ CPUFUNC(op_d1a8_4), 53672 }, /* ADD */
{ CPUFUNC(op_d1b0_4), 53680 }, /* ADD */
{ CPUFUNC(op_d1b8_4), 53688 }, /* ADD */
{ CPUFUNC(op_d1b9_4), 53689 }, /* ADD */
{ CPUFUNC(op_d1c0_4), 53696 }, /* ADDA */
{ CPUFUNC(op_d1c8_4), 53704 }, /* ADDA */
{ CPUFUNC(op_d1d0_4), 53712 }, /* ADDA */
{ CPUFUNC(op_d1d8_4), 53720 }, /* ADDA */
{ CPUFUNC(op_d1e0_4), 53728 }, /* ADDA */
{ CPUFUNC(op_d1e8_4), 53736 }, /* ADDA */
{ CPUFUNC(op_d1f0_4), 53744 }, /* ADDA */
{ CPUFUNC(op_d1f8_4), 53752 }, /* ADDA */
{ CPUFUNC(op_d1f9_4), 53753 }, /* ADDA */
{ CPUFUNC(op_d1fa_4), 53754 }, /* ADDA */
{ CPUFUNC(op_d1fb_4), 53755 }, /* ADDA */
{ CPUFUNC(op_d1fc_4), 53756 }, /* ADDA */
{ CPUFUNC(op_e000_4), 57344 }, /* ASR */
{ CPUFUNC(op_e008_4), 57352 }, /* LSR */
{ CPUFUNC(op_e010_4), 57360 }, /* ROXR */
{ CPUFUNC(op_e018_4), 57368 }, /* ROR */
{ CPUFUNC(op_e020_4), 57376 }, /* ASR */
{ CPUFUNC(op_e028_4), 57384 }, /* LSR */
{ CPUFUNC(op_e030_4), 57392 }, /* ROXR */
{ CPUFUNC(op_e038_4), 57400 }, /* ROR */
{ CPUFUNC(op_e040_4), 57408 }, /* ASR */
{ CPUFUNC(op_e048_4), 57416 }, /* LSR */
{ CPUFUNC(op_e050_4), 57424 }, /* ROXR */
{ CPUFUNC(op_e058_4), 57432 }, /* ROR */
{ CPUFUNC(op_e060_4), 57440 }, /* ASR */
{ CPUFUNC(op_e068_4), 57448 }, /* LSR */
{ CPUFUNC(op_e070_4), 57456 }, /* ROXR */
{ CPUFUNC(op_e078_4), 57464 }, /* ROR */
{ CPUFUNC(op_e080_4), 57472 }, /* ASR */
{ CPUFUNC(op_e088_4), 57480 }, /* LSR */
{ CPUFUNC(op_e090_4), 57488 }, /* ROXR */
{ CPUFUNC(op_e098_4), 57496 }, /* ROR */
{ CPUFUNC(op_e0a0_4), 57504 }, /* ASR */
{ CPUFUNC(op_e0a8_4), 57512 }, /* LSR */
{ CPUFUNC(op_e0b0_4), 57520 }, /* ROXR */
{ CPUFUNC(op_e0b8_4), 57528 }, /* ROR */
{ CPUFUNC(op_e0d0_4), 57552 }, /* ASRW */
{ CPUFUNC(op_e0d8_4), 57560 }, /* ASRW */
{ CPUFUNC(op_e0e0_4), 57568 }, /* ASRW */
{ CPUFUNC(op_e0e8_4), 57576 }, /* ASRW */
{ CPUFUNC(op_e0f0_4), 57584 }, /* ASRW */
{ CPUFUNC(op_e0f8_4), 57592 }, /* ASRW */
{ CPUFUNC(op_e0f9_4), 57593 }, /* ASRW */
{ CPUFUNC(op_e100_4), 57600 }, /* ASL */
{ CPUFUNC(op_e108_4), 57608 }, /* LSL */
{ CPUFUNC(op_e110_4), 57616 }, /* ROXL */
{ CPUFUNC(op_e118_4), 57624 }, /* ROL */
{ CPUFUNC(op_e120_4), 57632 }, /* ASL */
{ CPUFUNC(op_e128_4), 57640 }, /* LSL */
{ CPUFUNC(op_e130_4), 57648 }, /* ROXL */
{ CPUFUNC(op_e138_4), 57656 }, /* ROL */
{ CPUFUNC(op_e140_4), 57664 }, /* ASL */
{ CPUFUNC(op_e148_4), 57672 }, /* LSL */
{ CPUFUNC(op_e150_4), 57680 }, /* ROXL */
{ CPUFUNC(op_e158_4), 57688 }, /* ROL */
{ CPUFUNC(op_e160_4), 57696 }, /* ASL */
{ CPUFUNC(op_e168_4), 57704 }, /* LSL */
{ CPUFUNC(op_e170_4), 57712 }, /* ROXL */
{ CPUFUNC(op_e178_4), 57720 }, /* ROL */
{ CPUFUNC(op_e180_4), 57728 }, /* ASL */
{ CPUFUNC(op_e188_4), 57736 }, /* LSL */
{ CPUFUNC(op_e190_4), 57744 }, /* ROXL */
{ CPUFUNC(op_e198_4), 57752 }, /* ROL */
{ CPUFUNC(op_e1a0_4), 57760 }, /* ASL */
{ CPUFUNC(op_e1a8_4), 57768 }, /* LSL */
{ CPUFUNC(op_e1b0_4), 57776 }, /* ROXL */
{ CPUFUNC(op_e1b8_4), 57784 }, /* ROL */
{ CPUFUNC(op_e1d0_4), 57808 }, /* ASLW */
{ CPUFUNC(op_e1d8_4), 57816 }, /* ASLW */
{ CPUFUNC(op_e1e0_4), 57824 }, /* ASLW */
{ CPUFUNC(op_e1e8_4), 57832 }, /* ASLW */
{ CPUFUNC(op_e1f0_4), 57840 }, /* ASLW */
{ CPUFUNC(op_e1f8_4), 57848 }, /* ASLW */
{ CPUFUNC(op_e1f9_4), 57849 }, /* ASLW */
{ CPUFUNC(op_e2d0_4), 58064 }, /* LSRW */
{ CPUFUNC(op_e2d8_4), 58072 }, /* LSRW */
{ CPUFUNC(op_e2e0_4), 58080 }, /* LSRW */
{ CPUFUNC(op_e2e8_4), 58088 }, /* LSRW */
{ CPUFUNC(op_e2f0_4), 58096 }, /* LSRW */
{ CPUFUNC(op_e2f8_4), 58104 }, /* LSRW */
{ CPUFUNC(op_e2f9_4), 58105 }, /* LSRW */
{ CPUFUNC(op_e3d0_4), 58320 }, /* LSLW */
{ CPUFUNC(op_e3d8_4), 58328 }, /* LSLW */
{ CPUFUNC(op_e3e0_4), 58336 }, /* LSLW */
{ CPUFUNC(op_e3e8_4), 58344 }, /* LSLW */
{ CPUFUNC(op_e3f0_4), 58352 }, /* LSLW */
{ CPUFUNC(op_e3f8_4), 58360 }, /* LSLW */
{ CPUFUNC(op_e3f9_4), 58361 }, /* LSLW */
{ CPUFUNC(op_e4d0_4), 58576 }, /* ROXRW */
{ CPUFUNC(op_e4d8_4), 58584 }, /* ROXRW */
{ CPUFUNC(op_e4e0_4), 58592 }, /* ROXRW */
{ CPUFUNC(op_e4e8_4), 58600 }, /* ROXRW */
{ CPUFUNC(op_e4f0_4), 58608 }, /* ROXRW */
{ CPUFUNC(op_e4f8_4), 58616 }, /* ROXRW */
{ CPUFUNC(op_e4f9_4), 58617 }, /* ROXRW */
{ CPUFUNC(op_e5d0_4), 58832 }, /* ROXLW */
{ CPUFUNC(op_e5d8_4), 58840 }, /* ROXLW */
{ CPUFUNC(op_e5e0_4), 58848 }, /* ROXLW */
{ CPUFUNC(op_e5e8_4), 58856 }, /* ROXLW */
{ CPUFUNC(op_e5f0_4), 58864 }, /* ROXLW */
{ CPUFUNC(op_e5f8_4), 58872 }, /* ROXLW */
{ CPUFUNC(op_e5f9_4), 58873 }, /* ROXLW */
{ CPUFUNC(op_e6d0_4), 59088 }, /* RORW */
{ CPUFUNC(op_e6d8_4), 59096 }, /* RORW */
{ CPUFUNC(op_e6e0_4), 59104 }, /* RORW */
{ CPUFUNC(op_e6e8_4), 59112 }, /* RORW */
{ CPUFUNC(op_e6f0_4), 59120 }, /* RORW */
{ CPUFUNC(op_e6f8_4), 59128 }, /* RORW */
{ CPUFUNC(op_e6f9_4), 59129 }, /* RORW */
{ CPUFUNC(op_e7d0_4), 59344 }, /* ROLW */
{ CPUFUNC(op_e7d8_4), 59352 }, /* ROLW */
{ CPUFUNC(op_e7e0_4), 59360 }, /* ROLW */
{ CPUFUNC(op_e7e8_4), 59368 }, /* ROLW */
{ CPUFUNC(op_e7f0_4), 59376 }, /* ROLW */
{ CPUFUNC(op_e7f8_4), 59384 }, /* ROLW */
{ CPUFUNC(op_e7f9_4), 59385 }, /* ROLW */
{ 0, 0 }};
const struct cputbl CPUFUNC(op_smalltbl_5)[] = {
{ CPUFUNC(op_0000_4), 0 }, /* OR */
{ CPUFUNC(op_0010_4), 16 }, /* OR */
{ CPUFUNC(op_0018_4), 24 }, /* OR */
{ CPUFUNC(op_0020_4), 32 }, /* OR */
{ CPUFUNC(op_0028_4), 40 }, /* OR */
{ CPUFUNC(op_0030_4), 48 }, /* OR */
{ CPUFUNC(op_0038_4), 56 }, /* OR */
{ CPUFUNC(op_0039_4), 57 }, /* OR */
{ CPUFUNC(op_003c_4), 60 }, /* ORSR */
{ CPUFUNC(op_0040_4), 64 }, /* OR */
{ CPUFUNC(op_0050_4), 80 }, /* OR */
{ CPUFUNC(op_0058_4), 88 }, /* OR */
{ CPUFUNC(op_0060_4), 96 }, /* OR */
{ CPUFUNC(op_0068_4), 104 }, /* OR */
{ CPUFUNC(op_0070_4), 112 }, /* OR */
{ CPUFUNC(op_0078_4), 120 }, /* OR */
{ CPUFUNC(op_0079_4), 121 }, /* OR */
{ CPUFUNC(op_007c_4), 124 }, /* ORSR */
{ CPUFUNC(op_0080_4), 128 }, /* OR */
{ CPUFUNC(op_0090_4), 144 }, /* OR */
{ CPUFUNC(op_0098_4), 152 }, /* OR */
{ CPUFUNC(op_00a0_4), 160 }, /* OR */
{ CPUFUNC(op_00a8_4), 168 }, /* OR */
{ CPUFUNC(op_00b0_4), 176 }, /* OR */
{ CPUFUNC(op_00b8_4), 184 }, /* OR */
{ CPUFUNC(op_00b9_4), 185 }, /* OR */
{ CPUFUNC(op_0100_4), 256 }, /* BTST */
{ CPUFUNC(op_0108_4), 264 }, /* MVPMR */
{ CPUFUNC(op_0110_4), 272 }, /* BTST */
{ CPUFUNC(op_0118_4), 280 }, /* BTST */
{ CPUFUNC(op_0120_4), 288 }, /* BTST */
{ CPUFUNC(op_0128_4), 296 }, /* BTST */
{ CPUFUNC(op_0130_4), 304 }, /* BTST */
{ CPUFUNC(op_0138_4), 312 }, /* BTST */
{ CPUFUNC(op_0139_4), 313 }, /* BTST */
{ CPUFUNC(op_013a_4), 314 }, /* BTST */
{ CPUFUNC(op_013b_4), 315 }, /* BTST */
{ CPUFUNC(op_013c_4), 316 }, /* BTST */
{ CPUFUNC(op_0140_4), 320 }, /* BCHG */
{ CPUFUNC(op_0148_4), 328 }, /* MVPMR */
{ CPUFUNC(op_0150_4), 336 }, /* BCHG */
{ CPUFUNC(op_0158_4), 344 }, /* BCHG */
{ CPUFUNC(op_0160_4), 352 }, /* BCHG */
{ CPUFUNC(op_0168_4), 360 }, /* BCHG */
{ CPUFUNC(op_0170_4), 368 }, /* BCHG */
{ CPUFUNC(op_0178_4), 376 }, /* BCHG */
{ CPUFUNC(op_0179_4), 377 }, /* BCHG */
{ CPUFUNC(op_0180_4), 384 }, /* BCLR */
{ CPUFUNC(op_0188_4), 392 }, /* MVPRM */
{ CPUFUNC(op_0190_4), 400 }, /* BCLR */
{ CPUFUNC(op_0198_4), 408 }, /* BCLR */
{ CPUFUNC(op_01a0_4), 416 }, /* BCLR */
{ CPUFUNC(op_01a8_4), 424 }, /* BCLR */
{ CPUFUNC(op_01b0_4), 432 }, /* BCLR */
{ CPUFUNC(op_01b8_4), 440 }, /* BCLR */
{ CPUFUNC(op_01b9_4), 441 }, /* BCLR */
{ CPUFUNC(op_01c0_4), 448 }, /* BSET */
{ CPUFUNC(op_01c8_4), 456 }, /* MVPRM */
{ CPUFUNC(op_01d0_4), 464 }, /* BSET */
{ CPUFUNC(op_01d8_4), 472 }, /* BSET */
{ CPUFUNC(op_01e0_4), 480 }, /* BSET */
{ CPUFUNC(op_01e8_4), 488 }, /* BSET */
{ CPUFUNC(op_01f0_4), 496 }, /* BSET */
{ CPUFUNC(op_01f8_4), 504 }, /* BSET */
{ CPUFUNC(op_01f9_4), 505 }, /* BSET */
{ CPUFUNC(op_0200_4), 512 }, /* AND */
{ CPUFUNC(op_0210_4), 528 }, /* AND */
{ CPUFUNC(op_0218_4), 536 }, /* AND */
{ CPUFUNC(op_0220_4), 544 }, /* AND */
{ CPUFUNC(op_0228_4), 552 }, /* AND */
{ CPUFUNC(op_0230_4), 560 }, /* AND */
{ CPUFUNC(op_0238_4), 568 }, /* AND */
{ CPUFUNC(op_0239_4), 569 }, /* AND */
{ CPUFUNC(op_023c_4), 572 }, /* ANDSR */
{ CPUFUNC(op_0240_4), 576 }, /* AND */
{ CPUFUNC(op_0250_4), 592 }, /* AND */
{ CPUFUNC(op_0258_4), 600 }, /* AND */
{ CPUFUNC(op_0260_4), 608 }, /* AND */
{ CPUFUNC(op_0268_4), 616 }, /* AND */
{ CPUFUNC(op_0270_4), 624 }, /* AND */
{ CPUFUNC(op_0278_4), 632 }, /* AND */
{ CPUFUNC(op_0279_4), 633 }, /* AND */
{ CPUFUNC(op_027c_4), 636 }, /* ANDSR */
{ CPUFUNC(op_0280_4), 640 }, /* AND */
{ CPUFUNC(op_0290_4), 656 }, /* AND */
{ CPUFUNC(op_0298_4), 664 }, /* AND */
{ CPUFUNC(op_02a0_4), 672 }, /* AND */
{ CPUFUNC(op_02a8_4), 680 }, /* AND */
{ CPUFUNC(op_02b0_4), 688 }, /* AND */
{ CPUFUNC(op_02b8_4), 696 }, /* AND */
{ CPUFUNC(op_02b9_4), 697 }, /* AND */
{ CPUFUNC(op_0400_4), 1024 }, /* SUB */
{ CPUFUNC(op_0410_4), 1040 }, /* SUB */
{ CPUFUNC(op_0418_4), 1048 }, /* SUB */
{ CPUFUNC(op_0420_4), 1056 }, /* SUB */
{ CPUFUNC(op_0428_4), 1064 }, /* SUB */
{ CPUFUNC(op_0430_4), 1072 }, /* SUB */
{ CPUFUNC(op_0438_4), 1080 }, /* SUB */
{ CPUFUNC(op_0439_4), 1081 }, /* SUB */
{ CPUFUNC(op_0440_4), 1088 }, /* SUB */
{ CPUFUNC(op_0450_4), 1104 }, /* SUB */
{ CPUFUNC(op_0458_4), 1112 }, /* SUB */
{ CPUFUNC(op_0460_4), 1120 }, /* SUB */
{ CPUFUNC(op_0468_4), 1128 }, /* SUB */
{ CPUFUNC(op_0470_4), 1136 }, /* SUB */
{ CPUFUNC(op_0478_4), 1144 }, /* SUB */
{ CPUFUNC(op_0479_4), 1145 }, /* SUB */
{ CPUFUNC(op_0480_4), 1152 }, /* SUB */
{ CPUFUNC(op_0490_4), 1168 }, /* SUB */
{ CPUFUNC(op_0498_4), 1176 }, /* SUB */
{ CPUFUNC(op_04a0_4), 1184 }, /* SUB */
{ CPUFUNC(op_04a8_4), 1192 }, /* SUB */
{ CPUFUNC(op_04b0_4), 1200 }, /* SUB */
{ CPUFUNC(op_04b8_4), 1208 }, /* SUB */
{ CPUFUNC(op_04b9_4), 1209 }, /* SUB */
{ CPUFUNC(op_0600_4), 1536 }, /* ADD */
{ CPUFUNC(op_0610_4), 1552 }, /* ADD */
{ CPUFUNC(op_0618_4), 1560 }, /* ADD */
{ CPUFUNC(op_0620_4), 1568 }, /* ADD */
{ CPUFUNC(op_0628_4), 1576 }, /* ADD */
{ CPUFUNC(op_0630_4), 1584 }, /* ADD */
{ CPUFUNC(op_0638_4), 1592 }, /* ADD */
{ CPUFUNC(op_0639_4), 1593 }, /* ADD */
{ CPUFUNC(op_0640_4), 1600 }, /* ADD */
{ CPUFUNC(op_0650_4), 1616 }, /* ADD */
{ CPUFUNC(op_0658_4), 1624 }, /* ADD */
{ CPUFUNC(op_0660_4), 1632 }, /* ADD */
{ CPUFUNC(op_0668_4), 1640 }, /* ADD */
{ CPUFUNC(op_0670_4), 1648 }, /* ADD */
{ CPUFUNC(op_0678_4), 1656 }, /* ADD */
{ CPUFUNC(op_0679_4), 1657 }, /* ADD */
{ CPUFUNC(op_0680_4), 1664 }, /* ADD */
{ CPUFUNC(op_0690_4), 1680 }, /* ADD */
{ CPUFUNC(op_0698_4), 1688 }, /* ADD */
{ CPUFUNC(op_06a0_4), 1696 }, /* ADD */
{ CPUFUNC(op_06a8_4), 1704 }, /* ADD */
{ CPUFUNC(op_06b0_4), 1712 }, /* ADD */
{ CPUFUNC(op_06b8_4), 1720 }, /* ADD */
{ CPUFUNC(op_06b9_4), 1721 }, /* ADD */
{ CPUFUNC(op_0800_4), 2048 }, /* BTST */
{ CPUFUNC(op_0810_4), 2064 }, /* BTST */
{ CPUFUNC(op_0818_4), 2072 }, /* BTST */
{ CPUFUNC(op_0820_4), 2080 }, /* BTST */
{ CPUFUNC(op_0828_4), 2088 }, /* BTST */
{ CPUFUNC(op_0830_4), 2096 }, /* BTST */
{ CPUFUNC(op_0838_4), 2104 }, /* BTST */
{ CPUFUNC(op_0839_4), 2105 }, /* BTST */
{ CPUFUNC(op_083a_4), 2106 }, /* BTST */
{ CPUFUNC(op_083b_4), 2107 }, /* BTST */
{ CPUFUNC(op_083c_4), 2108 }, /* BTST */
{ CPUFUNC(op_0840_4), 2112 }, /* BCHG */
{ CPUFUNC(op_0850_4), 2128 }, /* BCHG */
{ CPUFUNC(op_0858_4), 2136 }, /* BCHG */
{ CPUFUNC(op_0860_4), 2144 }, /* BCHG */
{ CPUFUNC(op_0868_4), 2152 }, /* BCHG */
{ CPUFUNC(op_0870_4), 2160 }, /* BCHG */
{ CPUFUNC(op_0878_4), 2168 }, /* BCHG */
{ CPUFUNC(op_0879_4), 2169 }, /* BCHG */
{ CPUFUNC(op_0880_4), 2176 }, /* BCLR */
{ CPUFUNC(op_0890_4), 2192 }, /* BCLR */
{ CPUFUNC(op_0898_4), 2200 }, /* BCLR */
{ CPUFUNC(op_08a0_4), 2208 }, /* BCLR */
{ CPUFUNC(op_08a8_4), 2216 }, /* BCLR */
{ CPUFUNC(op_08b0_4), 2224 }, /* BCLR */
{ CPUFUNC(op_08b8_4), 2232 }, /* BCLR */
{ CPUFUNC(op_08b9_4), 2233 }, /* BCLR */
{ CPUFUNC(op_08c0_4), 2240 }, /* BSET */
{ CPUFUNC(op_08d0_4), 2256 }, /* BSET */
{ CPUFUNC(op_08d8_4), 2264 }, /* BSET */
{ CPUFUNC(op_08e0_4), 2272 }, /* BSET */
{ CPUFUNC(op_08e8_4), 2280 }, /* BSET */
{ CPUFUNC(op_08f0_4), 2288 }, /* BSET */
{ CPUFUNC(op_08f8_4), 2296 }, /* BSET */
{ CPUFUNC(op_08f9_4), 2297 }, /* BSET */
{ CPUFUNC(op_0a00_4), 2560 }, /* EOR */
{ CPUFUNC(op_0a10_4), 2576 }, /* EOR */
{ CPUFUNC(op_0a18_4), 2584 }, /* EOR */
{ CPUFUNC(op_0a20_4), 2592 }, /* EOR */
{ CPUFUNC(op_0a28_4), 2600 }, /* EOR */
{ CPUFUNC(op_0a30_4), 2608 }, /* EOR */
{ CPUFUNC(op_0a38_4), 2616 }, /* EOR */
{ CPUFUNC(op_0a39_4), 2617 }, /* EOR */
{ CPUFUNC(op_0a3c_4), 2620 }, /* EORSR */
{ CPUFUNC(op_0a40_4), 2624 }, /* EOR */
{ CPUFUNC(op_0a50_4), 2640 }, /* EOR */
{ CPUFUNC(op_0a58_4), 2648 }, /* EOR */
{ CPUFUNC(op_0a60_4), 2656 }, /* EOR */
{ CPUFUNC(op_0a68_4), 2664 }, /* EOR */
{ CPUFUNC(op_0a70_4), 2672 }, /* EOR */
{ CPUFUNC(op_0a78_4), 2680 }, /* EOR */
{ CPUFUNC(op_0a79_4), 2681 }, /* EOR */
{ CPUFUNC(op_0a7c_4), 2684 }, /* EORSR */
{ CPUFUNC(op_0a80_4), 2688 }, /* EOR */
{ CPUFUNC(op_0a90_4), 2704 }, /* EOR */
{ CPUFUNC(op_0a98_4), 2712 }, /* EOR */
{ CPUFUNC(op_0aa0_4), 2720 }, /* EOR */
{ CPUFUNC(op_0aa8_4), 2728 }, /* EOR */
{ CPUFUNC(op_0ab0_4), 2736 }, /* EOR */
{ CPUFUNC(op_0ab8_4), 2744 }, /* EOR */
{ CPUFUNC(op_0ab9_4), 2745 }, /* EOR */
{ CPUFUNC(op_0c00_4), 3072 }, /* CMP */
{ CPUFUNC(op_0c10_4), 3088 }, /* CMP */
{ CPUFUNC(op_0c18_4), 3096 }, /* CMP */
{ CPUFUNC(op_0c20_4), 3104 }, /* CMP */
{ CPUFUNC(op_0c28_4), 3112 }, /* CMP */
{ CPUFUNC(op_0c30_4), 3120 }, /* CMP */
{ CPUFUNC(op_0c38_4), 3128 }, /* CMP */
{ CPUFUNC(op_0c39_4), 3129 }, /* CMP */
{ CPUFUNC(op_0c40_4), 3136 }, /* CMP */
{ CPUFUNC(op_0c50_4), 3152 }, /* CMP */
{ CPUFUNC(op_0c58_4), 3160 }, /* CMP */
{ CPUFUNC(op_0c60_4), 3168 }, /* CMP */
{ CPUFUNC(op_0c68_4), 3176 }, /* CMP */
{ CPUFUNC(op_0c70_4), 3184 }, /* CMP */
{ CPUFUNC(op_0c78_4), 3192 }, /* CMP */
{ CPUFUNC(op_0c79_4), 3193 }, /* CMP */
{ CPUFUNC(op_0c80_4), 3200 }, /* CMP */
{ CPUFUNC(op_0c90_4), 3216 }, /* CMP */
{ CPUFUNC(op_0c98_4), 3224 }, /* CMP */
{ CPUFUNC(op_0ca0_4), 3232 }, /* CMP */
{ CPUFUNC(op_0ca8_4), 3240 }, /* CMP */
{ CPUFUNC(op_0cb0_4), 3248 }, /* CMP */
{ CPUFUNC(op_0cb8_4), 3256 }, /* CMP */
{ CPUFUNC(op_0cb9_4), 3257 }, /* CMP */
{ CPUFUNC(op_1000_4), 4096 }, /* MOVE */
{ CPUFUNC(op_1010_4), 4112 }, /* MOVE */
{ CPUFUNC(op_1018_4), 4120 }, /* MOVE */
{ CPUFUNC(op_1020_4), 4128 }, /* MOVE */
{ CPUFUNC(op_1028_4), 4136 }, /* MOVE */
{ CPUFUNC(op_1030_4), 4144 }, /* MOVE */
{ CPUFUNC(op_1038_4), 4152 }, /* MOVE */
{ CPUFUNC(op_1039_4), 4153 }, /* MOVE */
{ CPUFUNC(op_103a_4), 4154 }, /* MOVE */
{ CPUFUNC(op_103b_4), 4155 }, /* MOVE */
{ CPUFUNC(op_103c_4), 4156 }, /* MOVE */
{ CPUFUNC(op_1080_4), 4224 }, /* MOVE */
{ CPUFUNC(op_1090_4), 4240 }, /* MOVE */
{ CPUFUNC(op_1098_4), 4248 }, /* MOVE */
{ CPUFUNC(op_10a0_4), 4256 }, /* MOVE */
{ CPUFUNC(op_10a8_4), 4264 }, /* MOVE */
{ CPUFUNC(op_10b0_4), 4272 }, /* MOVE */
{ CPUFUNC(op_10b8_4), 4280 }, /* MOVE */
{ CPUFUNC(op_10b9_4), 4281 }, /* MOVE */
{ CPUFUNC(op_10ba_4), 4282 }, /* MOVE */
{ CPUFUNC(op_10bb_4), 4283 }, /* MOVE */
{ CPUFUNC(op_10bc_4), 4284 }, /* MOVE */
{ CPUFUNC(op_10c0_4), 4288 }, /* MOVE */
{ CPUFUNC(op_10d0_4), 4304 }, /* MOVE */
{ CPUFUNC(op_10d8_4), 4312 }, /* MOVE */
{ CPUFUNC(op_10e0_4), 4320 }, /* MOVE */
{ CPUFUNC(op_10e8_4), 4328 }, /* MOVE */
{ CPUFUNC(op_10f0_4), 4336 }, /* MOVE */
{ CPUFUNC(op_10f8_4), 4344 }, /* MOVE */
{ CPUFUNC(op_10f9_4), 4345 }, /* MOVE */
{ CPUFUNC(op_10fa_4), 4346 }, /* MOVE */
{ CPUFUNC(op_10fb_4), 4347 }, /* MOVE */
{ CPUFUNC(op_10fc_4), 4348 }, /* MOVE */
{ CPUFUNC(op_1100_4), 4352 }, /* MOVE */
{ CPUFUNC(op_1110_4), 4368 }, /* MOVE */
{ CPUFUNC(op_1118_4), 4376 }, /* MOVE */
{ CPUFUNC(op_1120_4), 4384 }, /* MOVE */
{ CPUFUNC(op_1128_4), 4392 }, /* MOVE */
{ CPUFUNC(op_1130_4), 4400 }, /* MOVE */
{ CPUFUNC(op_1138_4), 4408 }, /* MOVE */
{ CPUFUNC(op_1139_4), 4409 }, /* MOVE */
{ CPUFUNC(op_113a_4), 4410 }, /* MOVE */
{ CPUFUNC(op_113b_4), 4411 }, /* MOVE */
{ CPUFUNC(op_113c_4), 4412 }, /* MOVE */
{ CPUFUNC(op_1140_4), 4416 }, /* MOVE */
{ CPUFUNC(op_1150_4), 4432 }, /* MOVE */
{ CPUFUNC(op_1158_4), 4440 }, /* MOVE */
{ CPUFUNC(op_1160_4), 4448 }, /* MOVE */
{ CPUFUNC(op_1168_4), 4456 }, /* MOVE */
{ CPUFUNC(op_1170_4), 4464 }, /* MOVE */
{ CPUFUNC(op_1178_4), 4472 }, /* MOVE */
{ CPUFUNC(op_1179_4), 4473 }, /* MOVE */
{ CPUFUNC(op_117a_4), 4474 }, /* MOVE */
{ CPUFUNC(op_117b_4), 4475 }, /* MOVE */
{ CPUFUNC(op_117c_4), 4476 }, /* MOVE */
{ CPUFUNC(op_1180_4), 4480 }, /* MOVE */
{ CPUFUNC(op_1190_4), 4496 }, /* MOVE */
{ CPUFUNC(op_1198_4), 4504 }, /* MOVE */
{ CPUFUNC(op_11a0_4), 4512 }, /* MOVE */
{ CPUFUNC(op_11a8_4), 4520 }, /* MOVE */
{ CPUFUNC(op_11b0_4), 4528 }, /* MOVE */
{ CPUFUNC(op_11b8_4), 4536 }, /* MOVE */
{ CPUFUNC(op_11b9_4), 4537 }, /* MOVE */
{ CPUFUNC(op_11ba_4), 4538 }, /* MOVE */
{ CPUFUNC(op_11bb_4), 4539 }, /* MOVE */
{ CPUFUNC(op_11bc_4), 4540 }, /* MOVE */
{ CPUFUNC(op_11c0_4), 4544 }, /* MOVE */
{ CPUFUNC(op_11d0_4), 4560 }, /* MOVE */
{ CPUFUNC(op_11d8_4), 4568 }, /* MOVE */
{ CPUFUNC(op_11e0_4), 4576 }, /* MOVE */
{ CPUFUNC(op_11e8_4), 4584 }, /* MOVE */
{ CPUFUNC(op_11f0_4), 4592 }, /* MOVE */
{ CPUFUNC(op_11f8_4), 4600 }, /* MOVE */
{ CPUFUNC(op_11f9_4), 4601 }, /* MOVE */
{ CPUFUNC(op_11fa_4), 4602 }, /* MOVE */
{ CPUFUNC(op_11fb_4), 4603 }, /* MOVE */
{ CPUFUNC(op_11fc_4), 4604 }, /* MOVE */
{ CPUFUNC(op_13c0_4), 5056 }, /* MOVE */
{ CPUFUNC(op_13d0_4), 5072 }, /* MOVE */
{ CPUFUNC(op_13d8_4), 5080 }, /* MOVE */
{ CPUFUNC(op_13e0_4), 5088 }, /* MOVE */
{ CPUFUNC(op_13e8_4), 5096 }, /* MOVE */
{ CPUFUNC(op_13f0_4), 5104 }, /* MOVE */
{ CPUFUNC(op_13f8_4), 5112 }, /* MOVE */
{ CPUFUNC(op_13f9_4), 5113 }, /* MOVE */
{ CPUFUNC(op_13fa_4), 5114 }, /* MOVE */
{ CPUFUNC(op_13fb_4), 5115 }, /* MOVE */
{ CPUFUNC(op_13fc_4), 5116 }, /* MOVE */
{ CPUFUNC(op_2000_4), 8192 }, /* MOVE */
{ CPUFUNC(op_2008_4), 8200 }, /* MOVE */
{ CPUFUNC(op_2010_4), 8208 }, /* MOVE */
{ CPUFUNC(op_2018_4), 8216 }, /* MOVE */
{ CPUFUNC(op_2020_4), 8224 }, /* MOVE */
{ CPUFUNC(op_2028_4), 8232 }, /* MOVE */
{ CPUFUNC(op_2030_4), 8240 }, /* MOVE */
{ CPUFUNC(op_2038_4), 8248 }, /* MOVE */
{ CPUFUNC(op_2039_4), 8249 }, /* MOVE */
{ CPUFUNC(op_203a_4), 8250 }, /* MOVE */
{ CPUFUNC(op_203b_4), 8251 }, /* MOVE */
{ CPUFUNC(op_203c_4), 8252 }, /* MOVE */
{ CPUFUNC(op_2040_4), 8256 }, /* MOVEA */
{ CPUFUNC(op_2048_4), 8264 }, /* MOVEA */
{ CPUFUNC(op_2050_4), 8272 }, /* MOVEA */
{ CPUFUNC(op_2058_4), 8280 }, /* MOVEA */
{ CPUFUNC(op_2060_4), 8288 }, /* MOVEA */
{ CPUFUNC(op_2068_4), 8296 }, /* MOVEA */
{ CPUFUNC(op_2070_4), 8304 }, /* MOVEA */
{ CPUFUNC(op_2078_4), 8312 }, /* MOVEA */
{ CPUFUNC(op_2079_4), 8313 }, /* MOVEA */
{ CPUFUNC(op_207a_4), 8314 }, /* MOVEA */
{ CPUFUNC(op_207b_4), 8315 }, /* MOVEA */
{ CPUFUNC(op_207c_4), 8316 }, /* MOVEA */
{ CPUFUNC(op_2080_4), 8320 }, /* MOVE */
{ CPUFUNC(op_2088_4), 8328 }, /* MOVE */
{ CPUFUNC(op_2090_4), 8336 }, /* MOVE */
{ CPUFUNC(op_2098_4), 8344 }, /* MOVE */
{ CPUFUNC(op_20a0_4), 8352 }, /* MOVE */
{ CPUFUNC(op_20a8_4), 8360 }, /* MOVE */
{ CPUFUNC(op_20b0_4), 8368 }, /* MOVE */
{ CPUFUNC(op_20b8_4), 8376 }, /* MOVE */
{ CPUFUNC(op_20b9_4), 8377 }, /* MOVE */
{ CPUFUNC(op_20ba_4), 8378 }, /* MOVE */
{ CPUFUNC(op_20bb_4), 8379 }, /* MOVE */
{ CPUFUNC(op_20bc_4), 8380 }, /* MOVE */
{ CPUFUNC(op_20c0_4), 8384 }, /* MOVE */
{ CPUFUNC(op_20c8_4), 8392 }, /* MOVE */
{ CPUFUNC(op_20d0_4), 8400 }, /* MOVE */
{ CPUFUNC(op_20d8_4), 8408 }, /* MOVE */
{ CPUFUNC(op_20e0_4), 8416 }, /* MOVE */
{ CPUFUNC(op_20e8_4), 8424 }, /* MOVE */
{ CPUFUNC(op_20f0_4), 8432 }, /* MOVE */
{ CPUFUNC(op_20f8_4), 8440 }, /* MOVE */
{ CPUFUNC(op_20f9_4), 8441 }, /* MOVE */
{ CPUFUNC(op_20fa_4), 8442 }, /* MOVE */
{ CPUFUNC(op_20fb_4), 8443 }, /* MOVE */
{ CPUFUNC(op_20fc_4), 8444 }, /* MOVE */
{ CPUFUNC(op_2100_4), 8448 }, /* MOVE */
{ CPUFUNC(op_2108_4), 8456 }, /* MOVE */
{ CPUFUNC(op_2110_4), 8464 }, /* MOVE */
{ CPUFUNC(op_2118_4), 8472 }, /* MOVE */
{ CPUFUNC(op_2120_4), 8480 }, /* MOVE */
{ CPUFUNC(op_2128_4), 8488 }, /* MOVE */
{ CPUFUNC(op_2130_4), 8496 }, /* MOVE */
{ CPUFUNC(op_2138_4), 8504 }, /* MOVE */
{ CPUFUNC(op_2139_4), 8505 }, /* MOVE */
{ CPUFUNC(op_213a_4), 8506 }, /* MOVE */
{ CPUFUNC(op_213b_4), 8507 }, /* MOVE */
{ CPUFUNC(op_213c_4), 8508 }, /* MOVE */
{ CPUFUNC(op_2140_4), 8512 }, /* MOVE */
{ CPUFUNC(op_2148_4), 8520 }, /* MOVE */
{ CPUFUNC(op_2150_4), 8528 }, /* MOVE */
{ CPUFUNC(op_2158_4), 8536 }, /* MOVE */
{ CPUFUNC(op_2160_4), 8544 }, /* MOVE */
{ CPUFUNC(op_2168_4), 8552 }, /* MOVE */
{ CPUFUNC(op_2170_4), 8560 }, /* MOVE */
{ CPUFUNC(op_2178_4), 8568 }, /* MOVE */
{ CPUFUNC(op_2179_4), 8569 }, /* MOVE */
{ CPUFUNC(op_217a_4), 8570 }, /* MOVE */
{ CPUFUNC(op_217b_4), 8571 }, /* MOVE */
{ CPUFUNC(op_217c_4), 8572 }, /* MOVE */
{ CPUFUNC(op_2180_4), 8576 }, /* MOVE */
{ CPUFUNC(op_2188_4), 8584 }, /* MOVE */
{ CPUFUNC(op_2190_4), 8592 }, /* MOVE */
{ CPUFUNC(op_2198_4), 8600 }, /* MOVE */
{ CPUFUNC(op_21a0_4), 8608 }, /* MOVE */
{ CPUFUNC(op_21a8_4), 8616 }, /* MOVE */
{ CPUFUNC(op_21b0_4), 8624 }, /* MOVE */
{ CPUFUNC(op_21b8_4), 8632 }, /* MOVE */
{ CPUFUNC(op_21b9_4), 8633 }, /* MOVE */
{ CPUFUNC(op_21ba_4), 8634 }, /* MOVE */
{ CPUFUNC(op_21bb_4), 8635 }, /* MOVE */
{ CPUFUNC(op_21bc_4), 8636 }, /* MOVE */
{ CPUFUNC(op_21c0_4), 8640 }, /* MOVE */
{ CPUFUNC(op_21c8_4), 8648 }, /* MOVE */
{ CPUFUNC(op_21d0_4), 8656 }, /* MOVE */
{ CPUFUNC(op_21d8_4), 8664 }, /* MOVE */
{ CPUFUNC(op_21e0_4), 8672 }, /* MOVE */
{ CPUFUNC(op_21e8_4), 8680 }, /* MOVE */
{ CPUFUNC(op_21f0_4), 8688 }, /* MOVE */
{ CPUFUNC(op_21f8_4), 8696 }, /* MOVE */
{ CPUFUNC(op_21f9_4), 8697 }, /* MOVE */
{ CPUFUNC(op_21fa_4), 8698 }, /* MOVE */
{ CPUFUNC(op_21fb_4), 8699 }, /* MOVE */
{ CPUFUNC(op_21fc_4), 8700 }, /* MOVE */
{ CPUFUNC(op_23c0_4), 9152 }, /* MOVE */
{ CPUFUNC(op_23c8_4), 9160 }, /* MOVE */
{ CPUFUNC(op_23d0_4), 9168 }, /* MOVE */
{ CPUFUNC(op_23d8_4), 9176 }, /* MOVE */
{ CPUFUNC(op_23e0_4), 9184 }, /* MOVE */
{ CPUFUNC(op_23e8_4), 9192 }, /* MOVE */
{ CPUFUNC(op_23f0_4), 9200 }, /* MOVE */
{ CPUFUNC(op_23f8_4), 9208 }, /* MOVE */
{ CPUFUNC(op_23f9_4), 9209 }, /* MOVE */
{ CPUFUNC(op_23fa_4), 9210 }, /* MOVE */
{ CPUFUNC(op_23fb_4), 9211 }, /* MOVE */
{ CPUFUNC(op_23fc_4), 9212 }, /* MOVE */
{ CPUFUNC(op_3000_4), 12288 }, /* MOVE */
{ CPUFUNC(op_3008_4), 12296 }, /* MOVE */
{ CPUFUNC(op_3010_4), 12304 }, /* MOVE */
{ CPUFUNC(op_3018_4), 12312 }, /* MOVE */
{ CPUFUNC(op_3020_4), 12320 }, /* MOVE */
{ CPUFUNC(op_3028_4), 12328 }, /* MOVE */
{ CPUFUNC(op_3030_4), 12336 }, /* MOVE */
{ CPUFUNC(op_3038_4), 12344 }, /* MOVE */
{ CPUFUNC(op_3039_4), 12345 }, /* MOVE */
{ CPUFUNC(op_303a_4), 12346 }, /* MOVE */
{ CPUFUNC(op_303b_4), 12347 }, /* MOVE */
{ CPUFUNC(op_303c_4), 12348 }, /* MOVE */
{ CPUFUNC(op_3040_4), 12352 }, /* MOVEA */
{ CPUFUNC(op_3048_4), 12360 }, /* MOVEA */
{ CPUFUNC(op_3050_4), 12368 }, /* MOVEA */
{ CPUFUNC(op_3058_4), 12376 }, /* MOVEA */
{ CPUFUNC(op_3060_4), 12384 }, /* MOVEA */
{ CPUFUNC(op_3068_4), 12392 }, /* MOVEA */
{ CPUFUNC(op_3070_4), 12400 }, /* MOVEA */
{ CPUFUNC(op_3078_4), 12408 }, /* MOVEA */
{ CPUFUNC(op_3079_4), 12409 }, /* MOVEA */
{ CPUFUNC(op_307a_4), 12410 }, /* MOVEA */
{ CPUFUNC(op_307b_4), 12411 }, /* MOVEA */
{ CPUFUNC(op_307c_4), 12412 }, /* MOVEA */
{ CPUFUNC(op_3080_4), 12416 }, /* MOVE */
{ CPUFUNC(op_3088_4), 12424 }, /* MOVE */
{ CPUFUNC(op_3090_4), 12432 }, /* MOVE */
{ CPUFUNC(op_3098_4), 12440 }, /* MOVE */
{ CPUFUNC(op_30a0_4), 12448 }, /* MOVE */
{ CPUFUNC(op_30a8_4), 12456 }, /* MOVE */
{ CPUFUNC(op_30b0_4), 12464 }, /* MOVE */
{ CPUFUNC(op_30b8_4), 12472 }, /* MOVE */
{ CPUFUNC(op_30b9_4), 12473 }, /* MOVE */
{ CPUFUNC(op_30ba_4), 12474 }, /* MOVE */
{ CPUFUNC(op_30bb_4), 12475 }, /* MOVE */
{ CPUFUNC(op_30bc_4), 12476 }, /* MOVE */
{ CPUFUNC(op_30c0_4), 12480 }, /* MOVE */
{ CPUFUNC(op_30c8_4), 12488 }, /* MOVE */
{ CPUFUNC(op_30d0_4), 12496 }, /* MOVE */
{ CPUFUNC(op_30d8_4), 12504 }, /* MOVE */
{ CPUFUNC(op_30e0_4), 12512 }, /* MOVE */
{ CPUFUNC(op_30e8_4), 12520 }, /* MOVE */
{ CPUFUNC(op_30f0_4), 12528 }, /* MOVE */
{ CPUFUNC(op_30f8_4), 12536 }, /* MOVE */
{ CPUFUNC(op_30f9_4), 12537 }, /* MOVE */
{ CPUFUNC(op_30fa_4), 12538 }, /* MOVE */
{ CPUFUNC(op_30fb_4), 12539 }, /* MOVE */
{ CPUFUNC(op_30fc_4), 12540 }, /* MOVE */
{ CPUFUNC(op_3100_4), 12544 }, /* MOVE */
{ CPUFUNC(op_3108_4), 12552 }, /* MOVE */
{ CPUFUNC(op_3110_4), 12560 }, /* MOVE */
{ CPUFUNC(op_3118_4), 12568 }, /* MOVE */
{ CPUFUNC(op_3120_4), 12576 }, /* MOVE */
{ CPUFUNC(op_3128_4), 12584 }, /* MOVE */
{ CPUFUNC(op_3130_4), 12592 }, /* MOVE */
{ CPUFUNC(op_3138_4), 12600 }, /* MOVE */
{ CPUFUNC(op_3139_4), 12601 }, /* MOVE */
{ CPUFUNC(op_313a_4), 12602 }, /* MOVE */
{ CPUFUNC(op_313b_4), 12603 }, /* MOVE */
{ CPUFUNC(op_313c_4), 12604 }, /* MOVE */
{ CPUFUNC(op_3140_4), 12608 }, /* MOVE */
{ CPUFUNC(op_3148_4), 12616 }, /* MOVE */
{ CPUFUNC(op_3150_4), 12624 }, /* MOVE */
{ CPUFUNC(op_3158_4), 12632 }, /* MOVE */
{ CPUFUNC(op_3160_4), 12640 }, /* MOVE */
{ CPUFUNC(op_3168_4), 12648 }, /* MOVE */
{ CPUFUNC(op_3170_4), 12656 }, /* MOVE */
{ CPUFUNC(op_3178_4), 12664 }, /* MOVE */
{ CPUFUNC(op_3179_4), 12665 }, /* MOVE */
{ CPUFUNC(op_317a_4), 12666 }, /* MOVE */
{ CPUFUNC(op_317b_4), 12667 }, /* MOVE */
{ CPUFUNC(op_317c_4), 12668 }, /* MOVE */
{ CPUFUNC(op_3180_4), 12672 }, /* MOVE */
{ CPUFUNC(op_3188_4), 12680 }, /* MOVE */
{ CPUFUNC(op_3190_4), 12688 }, /* MOVE */
{ CPUFUNC(op_3198_4), 12696 }, /* MOVE */
{ CPUFUNC(op_31a0_4), 12704 }, /* MOVE */
{ CPUFUNC(op_31a8_4), 12712 }, /* MOVE */
{ CPUFUNC(op_31b0_4), 12720 }, /* MOVE */
{ CPUFUNC(op_31b8_4), 12728 }, /* MOVE */
{ CPUFUNC(op_31b9_4), 12729 }, /* MOVE */
{ CPUFUNC(op_31ba_4), 12730 }, /* MOVE */
{ CPUFUNC(op_31bb_4), 12731 }, /* MOVE */
{ CPUFUNC(op_31bc_4), 12732 }, /* MOVE */
{ CPUFUNC(op_31c0_4), 12736 }, /* MOVE */
{ CPUFUNC(op_31c8_4), 12744 }, /* MOVE */
{ CPUFUNC(op_31d0_4), 12752 }, /* MOVE */
{ CPUFUNC(op_31d8_4), 12760 }, /* MOVE */
{ CPUFUNC(op_31e0_4), 12768 }, /* MOVE */
{ CPUFUNC(op_31e8_4), 12776 }, /* MOVE */
{ CPUFUNC(op_31f0_4), 12784 }, /* MOVE */
{ CPUFUNC(op_31f8_4), 12792 }, /* MOVE */
{ CPUFUNC(op_31f9_4), 12793 }, /* MOVE */
{ CPUFUNC(op_31fa_4), 12794 }, /* MOVE */
{ CPUFUNC(op_31fb_4), 12795 }, /* MOVE */
{ CPUFUNC(op_31fc_4), 12796 }, /* MOVE */
{ CPUFUNC(op_33c0_4), 13248 }, /* MOVE */
{ CPUFUNC(op_33c8_4), 13256 }, /* MOVE */
{ CPUFUNC(op_33d0_4), 13264 }, /* MOVE */
{ CPUFUNC(op_33d8_4), 13272 }, /* MOVE */
{ CPUFUNC(op_33e0_4), 13280 }, /* MOVE */
{ CPUFUNC(op_33e8_4), 13288 }, /* MOVE */
{ CPUFUNC(op_33f0_4), 13296 }, /* MOVE */
{ CPUFUNC(op_33f8_4), 13304 }, /* MOVE */
{ CPUFUNC(op_33f9_4), 13305 }, /* MOVE */
{ CPUFUNC(op_33fa_4), 13306 }, /* MOVE */
{ CPUFUNC(op_33fb_4), 13307 }, /* MOVE */
{ CPUFUNC(op_33fc_4), 13308 }, /* MOVE */
{ CPUFUNC(op_4000_4), 16384 }, /* NEGX */
{ CPUFUNC(op_4010_4), 16400 }, /* NEGX */
{ CPUFUNC(op_4018_4), 16408 }, /* NEGX */
{ CPUFUNC(op_4020_4), 16416 }, /* NEGX */
{ CPUFUNC(op_4028_4), 16424 }, /* NEGX */
{ CPUFUNC(op_4030_4), 16432 }, /* NEGX */
{ CPUFUNC(op_4038_4), 16440 }, /* NEGX */
{ CPUFUNC(op_4039_4), 16441 }, /* NEGX */
{ CPUFUNC(op_4040_4), 16448 }, /* NEGX */
{ CPUFUNC(op_4050_4), 16464 }, /* NEGX */
{ CPUFUNC(op_4058_4), 16472 }, /* NEGX */
{ CPUFUNC(op_4060_4), 16480 }, /* NEGX */
{ CPUFUNC(op_4068_4), 16488 }, /* NEGX */
{ CPUFUNC(op_4070_4), 16496 }, /* NEGX */
{ CPUFUNC(op_4078_4), 16504 }, /* NEGX */
{ CPUFUNC(op_4079_4), 16505 }, /* NEGX */
{ CPUFUNC(op_4080_4), 16512 }, /* NEGX */
{ CPUFUNC(op_4090_4), 16528 }, /* NEGX */
{ CPUFUNC(op_4098_4), 16536 }, /* NEGX */
{ CPUFUNC(op_40a0_4), 16544 }, /* NEGX */
{ CPUFUNC(op_40a8_4), 16552 }, /* NEGX */
{ CPUFUNC(op_40b0_4), 16560 }, /* NEGX */
{ CPUFUNC(op_40b8_4), 16568 }, /* NEGX */
{ CPUFUNC(op_40b9_4), 16569 }, /* NEGX */
{ CPUFUNC(op_40c0_5), 16576 }, /* MVSR2 */
{ CPUFUNC(op_40d0_5), 16592 }, /* MVSR2 */
{ CPUFUNC(op_40d8_5), 16600 }, /* MVSR2 */
{ CPUFUNC(op_40e0_5), 16608 }, /* MVSR2 */
{ CPUFUNC(op_40e8_5), 16616 }, /* MVSR2 */
{ CPUFUNC(op_40f0_5), 16624 }, /* MVSR2 */
{ CPUFUNC(op_40f8_5), 16632 }, /* MVSR2 */
{ CPUFUNC(op_40f9_5), 16633 }, /* MVSR2 */
{ CPUFUNC(op_4180_4), 16768 }, /* CHK */
{ CPUFUNC(op_4190_4), 16784 }, /* CHK */
{ CPUFUNC(op_4198_4), 16792 }, /* CHK */
{ CPUFUNC(op_41a0_4), 16800 }, /* CHK */
{ CPUFUNC(op_41a8_4), 16808 }, /* CHK */
{ CPUFUNC(op_41b0_4), 16816 }, /* CHK */
{ CPUFUNC(op_41b8_4), 16824 }, /* CHK */
{ CPUFUNC(op_41b9_4), 16825 }, /* CHK */
{ CPUFUNC(op_41ba_4), 16826 }, /* CHK */
{ CPUFUNC(op_41bb_4), 16827 }, /* CHK */
{ CPUFUNC(op_41bc_4), 16828 }, /* CHK */
{ CPUFUNC(op_41d0_4), 16848 }, /* LEA */
{ CPUFUNC(op_41e8_4), 16872 }, /* LEA */
{ CPUFUNC(op_41f0_4), 16880 }, /* LEA */
{ CPUFUNC(op_41f8_4), 16888 }, /* LEA */
{ CPUFUNC(op_41f9_4), 16889 }, /* LEA */
{ CPUFUNC(op_41fa_4), 16890 }, /* LEA */
{ CPUFUNC(op_41fb_4), 16891 }, /* LEA */
{ CPUFUNC(op_4200_4), 16896 }, /* CLR */
{ CPUFUNC(op_4210_4), 16912 }, /* CLR */
{ CPUFUNC(op_4218_4), 16920 }, /* CLR */
{ CPUFUNC(op_4220_4), 16928 }, /* CLR */
{ CPUFUNC(op_4228_4), 16936 }, /* CLR */
{ CPUFUNC(op_4230_4), 16944 }, /* CLR */
{ CPUFUNC(op_4238_4), 16952 }, /* CLR */
{ CPUFUNC(op_4239_4), 16953 }, /* CLR */
{ CPUFUNC(op_4240_4), 16960 }, /* CLR */
{ CPUFUNC(op_4250_4), 16976 }, /* CLR */
{ CPUFUNC(op_4258_4), 16984 }, /* CLR */
{ CPUFUNC(op_4260_4), 16992 }, /* CLR */
{ CPUFUNC(op_4268_4), 17000 }, /* CLR */
{ CPUFUNC(op_4270_4), 17008 }, /* CLR */
{ CPUFUNC(op_4278_4), 17016 }, /* CLR */
{ CPUFUNC(op_4279_4), 17017 }, /* CLR */
{ CPUFUNC(op_4280_4), 17024 }, /* CLR */
{ CPUFUNC(op_4290_4), 17040 }, /* CLR */
{ CPUFUNC(op_4298_4), 17048 }, /* CLR */
{ CPUFUNC(op_42a0_4), 17056 }, /* CLR */
{ CPUFUNC(op_42a8_4), 17064 }, /* CLR */
{ CPUFUNC(op_42b0_4), 17072 }, /* CLR */
{ CPUFUNC(op_42b8_4), 17080 }, /* CLR */
{ CPUFUNC(op_42b9_4), 17081 }, /* CLR */
{ CPUFUNC(op_4400_4), 17408 }, /* NEG */
{ CPUFUNC(op_4410_4), 17424 }, /* NEG */
{ CPUFUNC(op_4418_4), 17432 }, /* NEG */
{ CPUFUNC(op_4420_4), 17440 }, /* NEG */
{ CPUFUNC(op_4428_4), 17448 }, /* NEG */
{ CPUFUNC(op_4430_4), 17456 }, /* NEG */
{ CPUFUNC(op_4438_4), 17464 }, /* NEG */
{ CPUFUNC(op_4439_4), 17465 }, /* NEG */
{ CPUFUNC(op_4440_4), 17472 }, /* NEG */
{ CPUFUNC(op_4450_4), 17488 }, /* NEG */
{ CPUFUNC(op_4458_4), 17496 }, /* NEG */
{ CPUFUNC(op_4460_4), 17504 }, /* NEG */
{ CPUFUNC(op_4468_4), 17512 }, /* NEG */
{ CPUFUNC(op_4470_4), 17520 }, /* NEG */
{ CPUFUNC(op_4478_4), 17528 }, /* NEG */
{ CPUFUNC(op_4479_4), 17529 }, /* NEG */
{ CPUFUNC(op_4480_4), 17536 }, /* NEG */
{ CPUFUNC(op_4490_4), 17552 }, /* NEG */
{ CPUFUNC(op_4498_4), 17560 }, /* NEG */
{ CPUFUNC(op_44a0_4), 17568 }, /* NEG */
{ CPUFUNC(op_44a8_4), 17576 }, /* NEG */
{ CPUFUNC(op_44b0_4), 17584 }, /* NEG */
{ CPUFUNC(op_44b8_4), 17592 }, /* NEG */
{ CPUFUNC(op_44b9_4), 17593 }, /* NEG */
{ CPUFUNC(op_44c0_4), 17600 }, /* MV2SR */
{ CPUFUNC(op_44d0_4), 17616 }, /* MV2SR */
{ CPUFUNC(op_44d8_4), 17624 }, /* MV2SR */
{ CPUFUNC(op_44e0_4), 17632 }, /* MV2SR */
{ CPUFUNC(op_44e8_4), 17640 }, /* MV2SR */
{ CPUFUNC(op_44f0_4), 17648 }, /* MV2SR */
{ CPUFUNC(op_44f8_4), 17656 }, /* MV2SR */
{ CPUFUNC(op_44f9_4), 17657 }, /* MV2SR */
{ CPUFUNC(op_44fa_4), 17658 }, /* MV2SR */
{ CPUFUNC(op_44fb_4), 17659 }, /* MV2SR */
{ CPUFUNC(op_44fc_4), 17660 }, /* MV2SR */
{ CPUFUNC(op_4600_4), 17920 }, /* NOT */
{ CPUFUNC(op_4610_4), 17936 }, /* NOT */
{ CPUFUNC(op_4618_4), 17944 }, /* NOT */
{ CPUFUNC(op_4620_4), 17952 }, /* NOT */
{ CPUFUNC(op_4628_4), 17960 }, /* NOT */
{ CPUFUNC(op_4630_4), 17968 }, /* NOT */
{ CPUFUNC(op_4638_4), 17976 }, /* NOT */
{ CPUFUNC(op_4639_4), 17977 }, /* NOT */
{ CPUFUNC(op_4640_4), 17984 }, /* NOT */
{ CPUFUNC(op_4650_4), 18000 }, /* NOT */
{ CPUFUNC(op_4658_4), 18008 }, /* NOT */
{ CPUFUNC(op_4660_4), 18016 }, /* NOT */
{ CPUFUNC(op_4668_4), 18024 }, /* NOT */
{ CPUFUNC(op_4670_4), 18032 }, /* NOT */
{ CPUFUNC(op_4678_4), 18040 }, /* NOT */
{ CPUFUNC(op_4679_4), 18041 }, /* NOT */
{ CPUFUNC(op_4680_4), 18048 }, /* NOT */
{ CPUFUNC(op_4690_4), 18064 }, /* NOT */
{ CPUFUNC(op_4698_4), 18072 }, /* NOT */
{ CPUFUNC(op_46a0_4), 18080 }, /* NOT */
{ CPUFUNC(op_46a8_4), 18088 }, /* NOT */
{ CPUFUNC(op_46b0_4), 18096 }, /* NOT */
{ CPUFUNC(op_46b8_4), 18104 }, /* NOT */
{ CPUFUNC(op_46b9_4), 18105 }, /* NOT */
{ CPUFUNC(op_46c0_4), 18112 }, /* MV2SR */
{ CPUFUNC(op_46d0_4), 18128 }, /* MV2SR */
{ CPUFUNC(op_46d8_4), 18136 }, /* MV2SR */
{ CPUFUNC(op_46e0_4), 18144 }, /* MV2SR */
{ CPUFUNC(op_46e8_4), 18152 }, /* MV2SR */
{ CPUFUNC(op_46f0_4), 18160 }, /* MV2SR */
{ CPUFUNC(op_46f8_4), 18168 }, /* MV2SR */
{ CPUFUNC(op_46f9_4), 18169 }, /* MV2SR */
{ CPUFUNC(op_46fa_4), 18170 }, /* MV2SR */
{ CPUFUNC(op_46fb_4), 18171 }, /* MV2SR */
{ CPUFUNC(op_46fc_4), 18172 }, /* MV2SR */
{ CPUFUNC(op_4800_4), 18432 }, /* NBCD */
{ CPUFUNC(op_4810_4), 18448 }, /* NBCD */
{ CPUFUNC(op_4818_4), 18456 }, /* NBCD */
{ CPUFUNC(op_4820_4), 18464 }, /* NBCD */
{ CPUFUNC(op_4828_4), 18472 }, /* NBCD */
{ CPUFUNC(op_4830_4), 18480 }, /* NBCD */
{ CPUFUNC(op_4838_4), 18488 }, /* NBCD */
{ CPUFUNC(op_4839_4), 18489 }, /* NBCD */
{ CPUFUNC(op_4840_4), 18496 }, /* SWAP */
{ CPUFUNC(op_4850_4), 18512 }, /* PEA */
{ CPUFUNC(op_4868_4), 18536 }, /* PEA */
{ CPUFUNC(op_4870_4), 18544 }, /* PEA */
{ CPUFUNC(op_4878_4), 18552 }, /* PEA */
{ CPUFUNC(op_4879_4), 18553 }, /* PEA */
{ CPUFUNC(op_487a_4), 18554 }, /* PEA */
{ CPUFUNC(op_487b_4), 18555 }, /* PEA */
{ CPUFUNC(op_4880_4), 18560 }, /* EXT */
{ CPUFUNC(op_4890_4), 18576 }, /* MVMLE */
{ CPUFUNC(op_48a0_4), 18592 }, /* MVMLE */
{ CPUFUNC(op_48a8_4), 18600 }, /* MVMLE */
{ CPUFUNC(op_48b0_4), 18608 }, /* MVMLE */
{ CPUFUNC(op_48b8_4), 18616 }, /* MVMLE */
{ CPUFUNC(op_48b9_4), 18617 }, /* MVMLE */
{ CPUFUNC(op_48c0_4), 18624 }, /* EXT */
{ CPUFUNC(op_48d0_4), 18640 }, /* MVMLE */
{ CPUFUNC(op_48e0_4), 18656 }, /* MVMLE */
{ CPUFUNC(op_48e8_4), 18664 }, /* MVMLE */
{ CPUFUNC(op_48f0_4), 18672 }, /* MVMLE */
{ CPUFUNC(op_48f8_4), 18680 }, /* MVMLE */
{ CPUFUNC(op_48f9_4), 18681 }, /* MVMLE */
{ CPUFUNC(op_4a00_4), 18944 }, /* TST */
{ CPUFUNC(op_4a10_4), 18960 }, /* TST */
{ CPUFUNC(op_4a18_4), 18968 }, /* TST */
{ CPUFUNC(op_4a20_4), 18976 }, /* TST */
{ CPUFUNC(op_4a28_4), 18984 }, /* TST */
{ CPUFUNC(op_4a30_4), 18992 }, /* TST */
{ CPUFUNC(op_4a38_4), 19000 }, /* TST */
{ CPUFUNC(op_4a39_4), 19001 }, /* TST */
{ CPUFUNC(op_4a40_4), 19008 }, /* TST */
{ CPUFUNC(op_4a50_4), 19024 }, /* TST */
{ CPUFUNC(op_4a58_4), 19032 }, /* TST */
{ CPUFUNC(op_4a60_4), 19040 }, /* TST */
{ CPUFUNC(op_4a68_4), 19048 }, /* TST */
{ CPUFUNC(op_4a70_4), 19056 }, /* TST */
{ CPUFUNC(op_4a78_4), 19064 }, /* TST */
{ CPUFUNC(op_4a79_4), 19065 }, /* TST */
{ CPUFUNC(op_4a80_4), 19072 }, /* TST */
{ CPUFUNC(op_4a90_4), 19088 }, /* TST */
{ CPUFUNC(op_4a98_4), 19096 }, /* TST */
{ CPUFUNC(op_4aa0_4), 19104 }, /* TST */
{ CPUFUNC(op_4aa8_4), 19112 }, /* TST */
{ CPUFUNC(op_4ab0_4), 19120 }, /* TST */
{ CPUFUNC(op_4ab8_4), 19128 }, /* TST */
{ CPUFUNC(op_4ab9_4), 19129 }, /* TST */
{ CPUFUNC(op_4ac0_4), 19136 }, /* TAS */
{ CPUFUNC(op_4ad0_4), 19152 }, /* TAS */
{ CPUFUNC(op_4ad8_4), 19160 }, /* TAS */
{ CPUFUNC(op_4ae0_4), 19168 }, /* TAS */
{ CPUFUNC(op_4ae8_4), 19176 }, /* TAS */
{ CPUFUNC(op_4af0_4), 19184 }, /* TAS */
{ CPUFUNC(op_4af8_4), 19192 }, /* TAS */
{ CPUFUNC(op_4af9_4), 19193 }, /* TAS */
{ CPUFUNC(op_4c90_4), 19600 }, /* MVMEL */
{ CPUFUNC(op_4c98_4), 19608 }, /* MVMEL */
{ CPUFUNC(op_4ca8_4), 19624 }, /* MVMEL */
{ CPUFUNC(op_4cb0_4), 19632 }, /* MVMEL */
{ CPUFUNC(op_4cb8_4), 19640 }, /* MVMEL */
{ CPUFUNC(op_4cb9_4), 19641 }, /* MVMEL */
{ CPUFUNC(op_4cba_4), 19642 }, /* MVMEL */
{ CPUFUNC(op_4cbb_4), 19643 }, /* MVMEL */
{ CPUFUNC(op_4cd0_4), 19664 }, /* MVMEL */
{ CPUFUNC(op_4cd8_4), 19672 }, /* MVMEL */
{ CPUFUNC(op_4ce8_4), 19688 }, /* MVMEL */
{ CPUFUNC(op_4cf0_4), 19696 }, /* MVMEL */
{ CPUFUNC(op_4cf8_4), 19704 }, /* MVMEL */
{ CPUFUNC(op_4cf9_4), 19705 }, /* MVMEL */
{ CPUFUNC(op_4cfa_4), 19706 }, /* MVMEL */
{ CPUFUNC(op_4cfb_4), 19707 }, /* MVMEL */
{ CPUFUNC(op_4e40_4), 20032 }, /* TRAP */
{ CPUFUNC(op_4e50_4), 20048 }, /* LINK */
{ CPUFUNC(op_4e58_4), 20056 }, /* UNLK */
{ CPUFUNC(op_4e60_4), 20064 }, /* MVR2USP */
{ CPUFUNC(op_4e68_4), 20072 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_4), 20080 }, /* RESET */
{ CPUFUNC(op_4e71_4), 20081 }, /* NOP */
{ CPUFUNC(op_4e72_4), 20082 }, /* STOP */
{ CPUFUNC(op_4e73_5), 20083 }, /* RTE */
{ CPUFUNC(op_4e74_4), 20084 }, /* RTD */
{ CPUFUNC(op_4e75_4), 20085 }, /* RTS */
{ CPUFUNC(op_4e76_4), 20086 }, /* TRAPV */
{ CPUFUNC(op_4e77_4), 20087 }, /* RTR */
{ CPUFUNC(op_4e90_4), 20112 }, /* JSR */
{ CPUFUNC(op_4ea8_4), 20136 }, /* JSR */
{ CPUFUNC(op_4eb0_4), 20144 }, /* JSR */
{ CPUFUNC(op_4eb8_4), 20152 }, /* JSR */
{ CPUFUNC(op_4eb9_4), 20153 }, /* JSR */
{ CPUFUNC(op_4eba_4), 20154 }, /* JSR */
{ CPUFUNC(op_4ebb_4), 20155 }, /* JSR */
{ CPUFUNC(op_4ed0_4), 20176 }, /* JMP */
{ CPUFUNC(op_4ee8_4), 20200 }, /* JMP */
{ CPUFUNC(op_4ef0_4), 20208 }, /* JMP */
{ CPUFUNC(op_4ef8_4), 20216 }, /* JMP */
{ CPUFUNC(op_4ef9_4), 20217 }, /* JMP */
{ CPUFUNC(op_4efa_4), 20218 }, /* JMP */
{ CPUFUNC(op_4efb_4), 20219 }, /* JMP */
{ CPUFUNC(op_5000_4), 20480 }, /* ADD */
{ CPUFUNC(op_5010_4), 20496 }, /* ADD */
{ CPUFUNC(op_5018_4), 20504 }, /* ADD */
{ CPUFUNC(op_5020_4), 20512 }, /* ADD */
{ CPUFUNC(op_5028_4), 20520 }, /* ADD */
{ CPUFUNC(op_5030_4), 20528 }, /* ADD */
{ CPUFUNC(op_5038_4), 20536 }, /* ADD */
{ CPUFUNC(op_5039_4), 20537 }, /* ADD */
{ CPUFUNC(op_5040_4), 20544 }, /* ADD */
{ CPUFUNC(op_5048_4), 20552 }, /* ADDA */
{ CPUFUNC(op_5050_4), 20560 }, /* ADD */
{ CPUFUNC(op_5058_4), 20568 }, /* ADD */
{ CPUFUNC(op_5060_4), 20576 }, /* ADD */
{ CPUFUNC(op_5068_4), 20584 }, /* ADD */
{ CPUFUNC(op_5070_4), 20592 }, /* ADD */
{ CPUFUNC(op_5078_4), 20600 }, /* ADD */
{ CPUFUNC(op_5079_4), 20601 }, /* ADD */
{ CPUFUNC(op_5080_4), 20608 }, /* ADD */
{ CPUFUNC(op_5088_4), 20616 }, /* ADDA */
{ CPUFUNC(op_5090_4), 20624 }, /* ADD */
{ CPUFUNC(op_5098_4), 20632 }, /* ADD */
{ CPUFUNC(op_50a0_4), 20640 }, /* ADD */
{ CPUFUNC(op_50a8_4), 20648 }, /* ADD */
{ CPUFUNC(op_50b0_4), 20656 }, /* ADD */
{ CPUFUNC(op_50b8_4), 20664 }, /* ADD */
{ CPUFUNC(op_50b9_4), 20665 }, /* ADD */
{ CPUFUNC(op_50c0_4), 20672 }, /* Scc */
{ CPUFUNC(op_50c8_4), 20680 }, /* DBcc */
{ CPUFUNC(op_50d0_4), 20688 }, /* Scc */
{ CPUFUNC(op_50d8_4), 20696 }, /* Scc */
{ CPUFUNC(op_50e0_4), 20704 }, /* Scc */
{ CPUFUNC(op_50e8_4), 20712 }, /* Scc */
{ CPUFUNC(op_50f0_4), 20720 }, /* Scc */
{ CPUFUNC(op_50f8_4), 20728 }, /* Scc */
{ CPUFUNC(op_50f9_4), 20729 }, /* Scc */
{ CPUFUNC(op_5100_4), 20736 }, /* SUB */
{ CPUFUNC(op_5110_4), 20752 }, /* SUB */
{ CPUFUNC(op_5118_4), 20760 }, /* SUB */
{ CPUFUNC(op_5120_4), 20768 }, /* SUB */
{ CPUFUNC(op_5128_4), 20776 }, /* SUB */
{ CPUFUNC(op_5130_4), 20784 }, /* SUB */
{ CPUFUNC(op_5138_4), 20792 }, /* SUB */
{ CPUFUNC(op_5139_4), 20793 }, /* SUB */
{ CPUFUNC(op_5140_4), 20800 }, /* SUB */
{ CPUFUNC(op_5148_4), 20808 }, /* SUBA */
{ CPUFUNC(op_5150_4), 20816 }, /* SUB */
{ CPUFUNC(op_5158_4), 20824 }, /* SUB */
{ CPUFUNC(op_5160_4), 20832 }, /* SUB */
{ CPUFUNC(op_5168_4), 20840 }, /* SUB */
{ CPUFUNC(op_5170_4), 20848 }, /* SUB */
{ CPUFUNC(op_5178_4), 20856 }, /* SUB */
{ CPUFUNC(op_5179_4), 20857 }, /* SUB */
{ CPUFUNC(op_5180_4), 20864 }, /* SUB */
{ CPUFUNC(op_5188_4), 20872 }, /* SUBA */
{ CPUFUNC(op_5190_4), 20880 }, /* SUB */
{ CPUFUNC(op_5198_4), 20888 }, /* SUB */
{ CPUFUNC(op_51a0_4), 20896 }, /* SUB */
{ CPUFUNC(op_51a8_4), 20904 }, /* SUB */
{ CPUFUNC(op_51b0_4), 20912 }, /* SUB */
{ CPUFUNC(op_51b8_4), 20920 }, /* SUB */
{ CPUFUNC(op_51b9_4), 20921 }, /* SUB */
{ CPUFUNC(op_51c0_4), 20928 }, /* Scc */
{ CPUFUNC(op_51c8_4), 20936 }, /* DBcc */
{ CPUFUNC(op_51d0_4), 20944 }, /* Scc */
{ CPUFUNC(op_51d8_4), 20952 }, /* Scc */
{ CPUFUNC(op_51e0_4), 20960 }, /* Scc */
{ CPUFUNC(op_51e8_4), 20968 }, /* Scc */
{ CPUFUNC(op_51f0_4), 20976 }, /* Scc */
{ CPUFUNC(op_51f8_4), 20984 }, /* Scc */
{ CPUFUNC(op_51f9_4), 20985 }, /* Scc */
{ CPUFUNC(op_52c0_4), 21184 }, /* Scc */
{ CPUFUNC(op_52c8_4), 21192 }, /* DBcc */
{ CPUFUNC(op_52d0_4), 21200 }, /* Scc */
{ CPUFUNC(op_52d8_4), 21208 }, /* Scc */
{ CPUFUNC(op_52e0_4), 21216 }, /* Scc */
{ CPUFUNC(op_52e8_4), 21224 }, /* Scc */
{ CPUFUNC(op_52f0_4), 21232 }, /* Scc */
{ CPUFUNC(op_52f8_4), 21240 }, /* Scc */
{ CPUFUNC(op_52f9_4), 21241 }, /* Scc */
{ CPUFUNC(op_53c0_4), 21440 }, /* Scc */
{ CPUFUNC(op_53c8_4), 21448 }, /* DBcc */
{ CPUFUNC(op_53d0_4), 21456 }, /* Scc */
{ CPUFUNC(op_53d8_4), 21464 }, /* Scc */
{ CPUFUNC(op_53e0_4), 21472 }, /* Scc */
{ CPUFUNC(op_53e8_4), 21480 }, /* Scc */
{ CPUFUNC(op_53f0_4), 21488 }, /* Scc */
{ CPUFUNC(op_53f8_4), 21496 }, /* Scc */
{ CPUFUNC(op_53f9_4), 21497 }, /* Scc */
{ CPUFUNC(op_54c0_4), 21696 }, /* Scc */
{ CPUFUNC(op_54c8_4), 21704 }, /* DBcc */
{ CPUFUNC(op_54d0_4), 21712 }, /* Scc */
{ CPUFUNC(op_54d8_4), 21720 }, /* Scc */
{ CPUFUNC(op_54e0_4), 21728 }, /* Scc */
{ CPUFUNC(op_54e8_4), 21736 }, /* Scc */
{ CPUFUNC(op_54f0_4), 21744 }, /* Scc */
{ CPUFUNC(op_54f8_4), 21752 }, /* Scc */
{ CPUFUNC(op_54f9_4), 21753 }, /* Scc */
{ CPUFUNC(op_55c0_4), 21952 }, /* Scc */
{ CPUFUNC(op_55c8_4), 21960 }, /* DBcc */
{ CPUFUNC(op_55d0_4), 21968 }, /* Scc */
{ CPUFUNC(op_55d8_4), 21976 }, /* Scc */
{ CPUFUNC(op_55e0_4), 21984 }, /* Scc */
{ CPUFUNC(op_55e8_4), 21992 }, /* Scc */
{ CPUFUNC(op_55f0_4), 22000 }, /* Scc */
{ CPUFUNC(op_55f8_4), 22008 }, /* Scc */
{ CPUFUNC(op_55f9_4), 22009 }, /* Scc */
{ CPUFUNC(op_56c0_4), 22208 }, /* Scc */
{ CPUFUNC(op_56c8_4), 22216 }, /* DBcc */
{ CPUFUNC(op_56d0_4), 22224 }, /* Scc */
{ CPUFUNC(op_56d8_4), 22232 }, /* Scc */
{ CPUFUNC(op_56e0_4), 22240 }, /* Scc */
{ CPUFUNC(op_56e8_4), 22248 }, /* Scc */
{ CPUFUNC(op_56f0_4), 22256 }, /* Scc */
{ CPUFUNC(op_56f8_4), 22264 }, /* Scc */
{ CPUFUNC(op_56f9_4), 22265 }, /* Scc */
{ CPUFUNC(op_57c0_4), 22464 }, /* Scc */
{ CPUFUNC(op_57c8_4), 22472 }, /* DBcc */
{ CPUFUNC(op_57d0_4), 22480 }, /* Scc */
{ CPUFUNC(op_57d8_4), 22488 }, /* Scc */
{ CPUFUNC(op_57e0_4), 22496 }, /* Scc */
{ CPUFUNC(op_57e8_4), 22504 }, /* Scc */
{ CPUFUNC(op_57f0_4), 22512 }, /* Scc */
{ CPUFUNC(op_57f8_4), 22520 }, /* Scc */
{ CPUFUNC(op_57f9_4), 22521 }, /* Scc */
{ CPUFUNC(op_58c0_4), 22720 }, /* Scc */
{ CPUFUNC(op_58c8_4), 22728 }, /* DBcc */
{ CPUFUNC(op_58d0_4), 22736 }, /* Scc */
{ CPUFUNC(op_58d8_4), 22744 }, /* Scc */
{ CPUFUNC(op_58e0_4), 22752 }, /* Scc */
{ CPUFUNC(op_58e8_4), 22760 }, /* Scc */
{ CPUFUNC(op_58f0_4), 22768 }, /* Scc */
{ CPUFUNC(op_58f8_4), 22776 }, /* Scc */
{ CPUFUNC(op_58f9_4), 22777 }, /* Scc */
{ CPUFUNC(op_59c0_4), 22976 }, /* Scc */
{ CPUFUNC(op_59c8_4), 22984 }, /* DBcc */
{ CPUFUNC(op_59d0_4), 22992 }, /* Scc */
{ CPUFUNC(op_59d8_4), 23000 }, /* Scc */
{ CPUFUNC(op_59e0_4), 23008 }, /* Scc */
{ CPUFUNC(op_59e8_4), 23016 }, /* Scc */
{ CPUFUNC(op_59f0_4), 23024 }, /* Scc */
{ CPUFUNC(op_59f8_4), 23032 }, /* Scc */
{ CPUFUNC(op_59f9_4), 23033 }, /* Scc */
{ CPUFUNC(op_5ac0_4), 23232 }, /* Scc */
{ CPUFUNC(op_5ac8_4), 23240 }, /* DBcc */
{ CPUFUNC(op_5ad0_4), 23248 }, /* Scc */
{ CPUFUNC(op_5ad8_4), 23256 }, /* Scc */
{ CPUFUNC(op_5ae0_4), 23264 }, /* Scc */
{ CPUFUNC(op_5ae8_4), 23272 }, /* Scc */
{ CPUFUNC(op_5af0_4), 23280 }, /* Scc */
{ CPUFUNC(op_5af8_4), 23288 }, /* Scc */
{ CPUFUNC(op_5af9_4), 23289 }, /* Scc */
{ CPUFUNC(op_5bc0_4), 23488 }, /* Scc */
{ CPUFUNC(op_5bc8_4), 23496 }, /* DBcc */
{ CPUFUNC(op_5bd0_4), 23504 }, /* Scc */
{ CPUFUNC(op_5bd8_4), 23512 }, /* Scc */
{ CPUFUNC(op_5be0_4), 23520 }, /* Scc */
{ CPUFUNC(op_5be8_4), 23528 }, /* Scc */
{ CPUFUNC(op_5bf0_4), 23536 }, /* Scc */
{ CPUFUNC(op_5bf8_4), 23544 }, /* Scc */
{ CPUFUNC(op_5bf9_4), 23545 }, /* Scc */
{ CPUFUNC(op_5cc0_4), 23744 }, /* Scc */
{ CPUFUNC(op_5cc8_4), 23752 }, /* DBcc */
{ CPUFUNC(op_5cd0_4), 23760 }, /* Scc */
{ CPUFUNC(op_5cd8_4), 23768 }, /* Scc */
{ CPUFUNC(op_5ce0_4), 23776 }, /* Scc */
{ CPUFUNC(op_5ce8_4), 23784 }, /* Scc */
{ CPUFUNC(op_5cf0_4), 23792 }, /* Scc */
{ CPUFUNC(op_5cf8_4), 23800 }, /* Scc */
{ CPUFUNC(op_5cf9_4), 23801 }, /* Scc */
{ CPUFUNC(op_5dc0_4), 24000 }, /* Scc */
{ CPUFUNC(op_5dc8_4), 24008 }, /* DBcc */
{ CPUFUNC(op_5dd0_4), 24016 }, /* Scc */
{ CPUFUNC(op_5dd8_4), 24024 }, /* Scc */
{ CPUFUNC(op_5de0_4), 24032 }, /* Scc */
{ CPUFUNC(op_5de8_4), 24040 }, /* Scc */
{ CPUFUNC(op_5df0_4), 24048 }, /* Scc */
{ CPUFUNC(op_5df8_4), 24056 }, /* Scc */
{ CPUFUNC(op_5df9_4), 24057 }, /* Scc */
{ CPUFUNC(op_5ec0_4), 24256 }, /* Scc */
{ CPUFUNC(op_5ec8_4), 24264 }, /* DBcc */
{ CPUFUNC(op_5ed0_4), 24272 }, /* Scc */
{ CPUFUNC(op_5ed8_4), 24280 }, /* Scc */
{ CPUFUNC(op_5ee0_4), 24288 }, /* Scc */
{ CPUFUNC(op_5ee8_4), 24296 }, /* Scc */
{ CPUFUNC(op_5ef0_4), 24304 }, /* Scc */
{ CPUFUNC(op_5ef8_4), 24312 }, /* Scc */
{ CPUFUNC(op_5ef9_4), 24313 }, /* Scc */
{ CPUFUNC(op_5fc0_4), 24512 }, /* Scc */
{ CPUFUNC(op_5fc8_4), 24520 }, /* DBcc */
{ CPUFUNC(op_5fd0_4), 24528 }, /* Scc */
{ CPUFUNC(op_5fd8_4), 24536 }, /* Scc */
{ CPUFUNC(op_5fe0_4), 24544 }, /* Scc */
{ CPUFUNC(op_5fe8_4), 24552 }, /* Scc */
{ CPUFUNC(op_5ff0_4), 24560 }, /* Scc */
{ CPUFUNC(op_5ff8_4), 24568 }, /* Scc */
{ CPUFUNC(op_5ff9_4), 24569 }, /* Scc */
{ CPUFUNC(op_6000_4), 24576 }, /* Bcc */
{ CPUFUNC(op_6001_4), 24577 }, /* Bcc */
{ CPUFUNC(op_60ff_4), 24831 }, /* Bcc */
{ CPUFUNC(op_6100_4), 24832 }, /* BSR */
{ CPUFUNC(op_6101_4), 24833 }, /* BSR */
{ CPUFUNC(op_61ff_4), 25087 }, /* BSR */
{ CPUFUNC(op_6200_4), 25088 }, /* Bcc */
{ CPUFUNC(op_6201_4), 25089 }, /* Bcc */
{ CPUFUNC(op_62ff_4), 25343 }, /* Bcc */
{ CPUFUNC(op_6300_4), 25344 }, /* Bcc */
{ CPUFUNC(op_6301_4), 25345 }, /* Bcc */
{ CPUFUNC(op_63ff_4), 25599 }, /* Bcc */
{ CPUFUNC(op_6400_4), 25600 }, /* Bcc */
{ CPUFUNC(op_6401_4), 25601 }, /* Bcc */
{ CPUFUNC(op_64ff_4), 25855 }, /* Bcc */
{ CPUFUNC(op_6500_4), 25856 }, /* Bcc */
{ CPUFUNC(op_6501_4), 25857 }, /* Bcc */
{ CPUFUNC(op_65ff_4), 26111 }, /* Bcc */
{ CPUFUNC(op_6600_4), 26112 }, /* Bcc */
{ CPUFUNC(op_6601_4), 26113 }, /* Bcc */
{ CPUFUNC(op_66ff_4), 26367 }, /* Bcc */
{ CPUFUNC(op_6700_4), 26368 }, /* Bcc */
{ CPUFUNC(op_6701_4), 26369 }, /* Bcc */
{ CPUFUNC(op_67ff_4), 26623 }, /* Bcc */
{ CPUFUNC(op_6800_4), 26624 }, /* Bcc */
{ CPUFUNC(op_6801_4), 26625 }, /* Bcc */
{ CPUFUNC(op_68ff_4), 26879 }, /* Bcc */
{ CPUFUNC(op_6900_4), 26880 }, /* Bcc */
{ CPUFUNC(op_6901_4), 26881 }, /* Bcc */
{ CPUFUNC(op_69ff_4), 27135 }, /* Bcc */
{ CPUFUNC(op_6a00_4), 27136 }, /* Bcc */
{ CPUFUNC(op_6a01_4), 27137 }, /* Bcc */
{ CPUFUNC(op_6aff_4), 27391 }, /* Bcc */
{ CPUFUNC(op_6b00_4), 27392 }, /* Bcc */
{ CPUFUNC(op_6b01_4), 27393 }, /* Bcc */
{ CPUFUNC(op_6bff_4), 27647 }, /* Bcc */
{ CPUFUNC(op_6c00_4), 27648 }, /* Bcc */
{ CPUFUNC(op_6c01_4), 27649 }, /* Bcc */
{ CPUFUNC(op_6cff_4), 27903 }, /* Bcc */
{ CPUFUNC(op_6d00_4), 27904 }, /* Bcc */
{ CPUFUNC(op_6d01_4), 27905 }, /* Bcc */
{ CPUFUNC(op_6dff_4), 28159 }, /* Bcc */
{ CPUFUNC(op_6e00_4), 28160 }, /* Bcc */
{ CPUFUNC(op_6e01_4), 28161 }, /* Bcc */
{ CPUFUNC(op_6eff_4), 28415 }, /* Bcc */
{ CPUFUNC(op_6f00_4), 28416 }, /* Bcc */
{ CPUFUNC(op_6f01_4), 28417 }, /* Bcc */
{ CPUFUNC(op_6fff_4), 28671 }, /* Bcc */
{ CPUFUNC(op_7000_4), 28672 }, /* MOVE */
{ CPUFUNC(op_8000_4), 32768 }, /* OR */
{ CPUFUNC(op_8010_4), 32784 }, /* OR */
{ CPUFUNC(op_8018_4), 32792 }, /* OR */
{ CPUFUNC(op_8020_4), 32800 }, /* OR */
{ CPUFUNC(op_8028_4), 32808 }, /* OR */
{ CPUFUNC(op_8030_4), 32816 }, /* OR */
{ CPUFUNC(op_8038_4), 32824 }, /* OR */
{ CPUFUNC(op_8039_4), 32825 }, /* OR */
{ CPUFUNC(op_803a_4), 32826 }, /* OR */
{ CPUFUNC(op_803b_4), 32827 }, /* OR */
{ CPUFUNC(op_803c_4), 32828 }, /* OR */
{ CPUFUNC(op_8040_4), 32832 }, /* OR */
{ CPUFUNC(op_8050_4), 32848 }, /* OR */
{ CPUFUNC(op_8058_4), 32856 }, /* OR */
{ CPUFUNC(op_8060_4), 32864 }, /* OR */
{ CPUFUNC(op_8068_4), 32872 }, /* OR */
{ CPUFUNC(op_8070_4), 32880 }, /* OR */
{ CPUFUNC(op_8078_4), 32888 }, /* OR */
{ CPUFUNC(op_8079_4), 32889 }, /* OR */
{ CPUFUNC(op_807a_4), 32890 }, /* OR */
{ CPUFUNC(op_807b_4), 32891 }, /* OR */
{ CPUFUNC(op_807c_4), 32892 }, /* OR */
{ CPUFUNC(op_8080_4), 32896 }, /* OR */
{ CPUFUNC(op_8090_4), 32912 }, /* OR */
{ CPUFUNC(op_8098_4), 32920 }, /* OR */
{ CPUFUNC(op_80a0_4), 32928 }, /* OR */
{ CPUFUNC(op_80a8_4), 32936 }, /* OR */
{ CPUFUNC(op_80b0_4), 32944 }, /* OR */
{ CPUFUNC(op_80b8_4), 32952 }, /* OR */
{ CPUFUNC(op_80b9_4), 32953 }, /* OR */
{ CPUFUNC(op_80ba_4), 32954 }, /* OR */
{ CPUFUNC(op_80bb_4), 32955 }, /* OR */
{ CPUFUNC(op_80bc_4), 32956 }, /* OR */
{ CPUFUNC(op_80c0_4), 32960 }, /* DIVU */
{ CPUFUNC(op_80d0_4), 32976 }, /* DIVU */
{ CPUFUNC(op_80d8_4), 32984 }, /* DIVU */
{ CPUFUNC(op_80e0_4), 32992 }, /* DIVU */
{ CPUFUNC(op_80e8_4), 33000 }, /* DIVU */
{ CPUFUNC(op_80f0_4), 33008 }, /* DIVU */
{ CPUFUNC(op_80f8_4), 33016 }, /* DIVU */
{ CPUFUNC(op_80f9_4), 33017 }, /* DIVU */
{ CPUFUNC(op_80fa_4), 33018 }, /* DIVU */
{ CPUFUNC(op_80fb_4), 33019 }, /* DIVU */
{ CPUFUNC(op_80fc_4), 33020 }, /* DIVU */
{ CPUFUNC(op_8100_4), 33024 }, /* SBCD */
{ CPUFUNC(op_8108_4), 33032 }, /* SBCD */
{ CPUFUNC(op_8110_4), 33040 }, /* OR */
{ CPUFUNC(op_8118_4), 33048 }, /* OR */
{ CPUFUNC(op_8120_4), 33056 }, /* OR */
{ CPUFUNC(op_8128_4), 33064 }, /* OR */
{ CPUFUNC(op_8130_4), 33072 }, /* OR */
{ CPUFUNC(op_8138_4), 33080 }, /* OR */
{ CPUFUNC(op_8139_4), 33081 }, /* OR */
{ CPUFUNC(op_8150_4), 33104 }, /* OR */
{ CPUFUNC(op_8158_4), 33112 }, /* OR */
{ CPUFUNC(op_8160_4), 33120 }, /* OR */
{ CPUFUNC(op_8168_4), 33128 }, /* OR */
{ CPUFUNC(op_8170_4), 33136 }, /* OR */
{ CPUFUNC(op_8178_4), 33144 }, /* OR */
{ CPUFUNC(op_8179_4), 33145 }, /* OR */
{ CPUFUNC(op_8190_4), 33168 }, /* OR */
{ CPUFUNC(op_8198_4), 33176 }, /* OR */
{ CPUFUNC(op_81a0_4), 33184 }, /* OR */
{ CPUFUNC(op_81a8_4), 33192 }, /* OR */
{ CPUFUNC(op_81b0_4), 33200 }, /* OR */
{ CPUFUNC(op_81b8_4), 33208 }, /* OR */
{ CPUFUNC(op_81b9_4), 33209 }, /* OR */
{ CPUFUNC(op_81c0_4), 33216 }, /* DIVS */
{ CPUFUNC(op_81d0_4), 33232 }, /* DIVS */
{ CPUFUNC(op_81d8_4), 33240 }, /* DIVS */
{ CPUFUNC(op_81e0_4), 33248 }, /* DIVS */
{ CPUFUNC(op_81e8_4), 33256 }, /* DIVS */
{ CPUFUNC(op_81f0_4), 33264 }, /* DIVS */
{ CPUFUNC(op_81f8_4), 33272 }, /* DIVS */
{ CPUFUNC(op_81f9_4), 33273 }, /* DIVS */
{ CPUFUNC(op_81fa_4), 33274 }, /* DIVS */
{ CPUFUNC(op_81fb_4), 33275 }, /* DIVS */
{ CPUFUNC(op_81fc_4), 33276 }, /* DIVS */
{ CPUFUNC(op_9000_4), 36864 }, /* SUB */
{ CPUFUNC(op_9010_4), 36880 }, /* SUB */
{ CPUFUNC(op_9018_4), 36888 }, /* SUB */
{ CPUFUNC(op_9020_4), 36896 }, /* SUB */
{ CPUFUNC(op_9028_4), 36904 }, /* SUB */
{ CPUFUNC(op_9030_4), 36912 }, /* SUB */
{ CPUFUNC(op_9038_4), 36920 }, /* SUB */
{ CPUFUNC(op_9039_4), 36921 }, /* SUB */
{ CPUFUNC(op_903a_4), 36922 }, /* SUB */
{ CPUFUNC(op_903b_4), 36923 }, /* SUB */
{ CPUFUNC(op_903c_4), 36924 }, /* SUB */
{ CPUFUNC(op_9040_4), 36928 }, /* SUB */
{ CPUFUNC(op_9048_4), 36936 }, /* SUB */
{ CPUFUNC(op_9050_4), 36944 }, /* SUB */
{ CPUFUNC(op_9058_4), 36952 }, /* SUB */
{ CPUFUNC(op_9060_4), 36960 }, /* SUB */
{ CPUFUNC(op_9068_4), 36968 }, /* SUB */
{ CPUFUNC(op_9070_4), 36976 }, /* SUB */
{ CPUFUNC(op_9078_4), 36984 }, /* SUB */
{ CPUFUNC(op_9079_4), 36985 }, /* SUB */
{ CPUFUNC(op_907a_4), 36986 }, /* SUB */
{ CPUFUNC(op_907b_4), 36987 }, /* SUB */
{ CPUFUNC(op_907c_4), 36988 }, /* SUB */
{ CPUFUNC(op_9080_4), 36992 }, /* SUB */
{ CPUFUNC(op_9088_4), 37000 }, /* SUB */
{ CPUFUNC(op_9090_4), 37008 }, /* SUB */
{ CPUFUNC(op_9098_4), 37016 }, /* SUB */
{ CPUFUNC(op_90a0_4), 37024 }, /* SUB */
{ CPUFUNC(op_90a8_4), 37032 }, /* SUB */
{ CPUFUNC(op_90b0_4), 37040 }, /* SUB */
{ CPUFUNC(op_90b8_4), 37048 }, /* SUB */
{ CPUFUNC(op_90b9_4), 37049 }, /* SUB */
{ CPUFUNC(op_90ba_4), 37050 }, /* SUB */
{ CPUFUNC(op_90bb_4), 37051 }, /* SUB */
{ CPUFUNC(op_90bc_4), 37052 }, /* SUB */
{ CPUFUNC(op_90c0_4), 37056 }, /* SUBA */
{ CPUFUNC(op_90c8_4), 37064 }, /* SUBA */
{ CPUFUNC(op_90d0_4), 37072 }, /* SUBA */
{ CPUFUNC(op_90d8_4), 37080 }, /* SUBA */
{ CPUFUNC(op_90e0_4), 37088 }, /* SUBA */
{ CPUFUNC(op_90e8_4), 37096 }, /* SUBA */
{ CPUFUNC(op_90f0_4), 37104 }, /* SUBA */
{ CPUFUNC(op_90f8_4), 37112 }, /* SUBA */
{ CPUFUNC(op_90f9_4), 37113 }, /* SUBA */
{ CPUFUNC(op_90fa_4), 37114 }, /* SUBA */
{ CPUFUNC(op_90fb_4), 37115 }, /* SUBA */
{ CPUFUNC(op_90fc_4), 37116 }, /* SUBA */
{ CPUFUNC(op_9100_4), 37120 }, /* SUBX */
{ CPUFUNC(op_9108_4), 37128 }, /* SUBX */
{ CPUFUNC(op_9110_4), 37136 }, /* SUB */
{ CPUFUNC(op_9118_4), 37144 }, /* SUB */
{ CPUFUNC(op_9120_4), 37152 }, /* SUB */
{ CPUFUNC(op_9128_4), 37160 }, /* SUB */
{ CPUFUNC(op_9130_4), 37168 }, /* SUB */
{ CPUFUNC(op_9138_4), 37176 }, /* SUB */
{ CPUFUNC(op_9139_4), 37177 }, /* SUB */
{ CPUFUNC(op_9140_4), 37184 }, /* SUBX */
{ CPUFUNC(op_9148_4), 37192 }, /* SUBX */
{ CPUFUNC(op_9150_4), 37200 }, /* SUB */
{ CPUFUNC(op_9158_4), 37208 }, /* SUB */
{ CPUFUNC(op_9160_4), 37216 }, /* SUB */
{ CPUFUNC(op_9168_4), 37224 }, /* SUB */
{ CPUFUNC(op_9170_4), 37232 }, /* SUB */
{ CPUFUNC(op_9178_4), 37240 }, /* SUB */
{ CPUFUNC(op_9179_4), 37241 }, /* SUB */
{ CPUFUNC(op_9180_4), 37248 }, /* SUBX */
{ CPUFUNC(op_9188_4), 37256 }, /* SUBX */
{ CPUFUNC(op_9190_4), 37264 }, /* SUB */
{ CPUFUNC(op_9198_4), 37272 }, /* SUB */
{ CPUFUNC(op_91a0_4), 37280 }, /* SUB */
{ CPUFUNC(op_91a8_4), 37288 }, /* SUB */
{ CPUFUNC(op_91b0_4), 37296 }, /* SUB */
{ CPUFUNC(op_91b8_4), 37304 }, /* SUB */
{ CPUFUNC(op_91b9_4), 37305 }, /* SUB */
{ CPUFUNC(op_91c0_4), 37312 }, /* SUBA */
{ CPUFUNC(op_91c8_4), 37320 }, /* SUBA */
{ CPUFUNC(op_91d0_4), 37328 }, /* SUBA */
{ CPUFUNC(op_91d8_4), 37336 }, /* SUBA */
{ CPUFUNC(op_91e0_4), 37344 }, /* SUBA */
{ CPUFUNC(op_91e8_4), 37352 }, /* SUBA */
{ CPUFUNC(op_91f0_4), 37360 }, /* SUBA */
{ CPUFUNC(op_91f8_4), 37368 }, /* SUBA */
{ CPUFUNC(op_91f9_4), 37369 }, /* SUBA */
{ CPUFUNC(op_91fa_4), 37370 }, /* SUBA */
{ CPUFUNC(op_91fb_4), 37371 }, /* SUBA */
{ CPUFUNC(op_91fc_4), 37372 }, /* SUBA */
{ CPUFUNC(op_b000_4), 45056 }, /* CMP */
{ CPUFUNC(op_b010_4), 45072 }, /* CMP */
{ CPUFUNC(op_b018_4), 45080 }, /* CMP */
{ CPUFUNC(op_b020_4), 45088 }, /* CMP */
{ CPUFUNC(op_b028_4), 45096 }, /* CMP */
{ CPUFUNC(op_b030_4), 45104 }, /* CMP */
{ CPUFUNC(op_b038_4), 45112 }, /* CMP */
{ CPUFUNC(op_b039_4), 45113 }, /* CMP */
{ CPUFUNC(op_b03a_4), 45114 }, /* CMP */
{ CPUFUNC(op_b03b_4), 45115 }, /* CMP */
{ CPUFUNC(op_b03c_4), 45116 }, /* CMP */
{ CPUFUNC(op_b040_4), 45120 }, /* CMP */
{ CPUFUNC(op_b048_4), 45128 }, /* CMP */
{ CPUFUNC(op_b050_4), 45136 }, /* CMP */
{ CPUFUNC(op_b058_4), 45144 }, /* CMP */
{ CPUFUNC(op_b060_4), 45152 }, /* CMP */
{ CPUFUNC(op_b068_4), 45160 }, /* CMP */
{ CPUFUNC(op_b070_4), 45168 }, /* CMP */
{ CPUFUNC(op_b078_4), 45176 }, /* CMP */
{ CPUFUNC(op_b079_4), 45177 }, /* CMP */
{ CPUFUNC(op_b07a_4), 45178 }, /* CMP */
{ CPUFUNC(op_b07b_4), 45179 }, /* CMP */
{ CPUFUNC(op_b07c_4), 45180 }, /* CMP */
{ CPUFUNC(op_b080_4), 45184 }, /* CMP */
{ CPUFUNC(op_b088_4), 45192 }, /* CMP */
{ CPUFUNC(op_b090_4), 45200 }, /* CMP */
{ CPUFUNC(op_b098_4), 45208 }, /* CMP */
{ CPUFUNC(op_b0a0_4), 45216 }, /* CMP */
{ CPUFUNC(op_b0a8_4), 45224 }, /* CMP */
{ CPUFUNC(op_b0b0_4), 45232 }, /* CMP */
{ CPUFUNC(op_b0b8_4), 45240 }, /* CMP */
{ CPUFUNC(op_b0b9_4), 45241 }, /* CMP */
{ CPUFUNC(op_b0ba_4), 45242 }, /* CMP */
{ CPUFUNC(op_b0bb_4), 45243 }, /* CMP */
{ CPUFUNC(op_b0bc_4), 45244 }, /* CMP */
{ CPUFUNC(op_b0c0_4), 45248 }, /* CMPA */
{ CPUFUNC(op_b0c8_4), 45256 }, /* CMPA */
{ CPUFUNC(op_b0d0_4), 45264 }, /* CMPA */
{ CPUFUNC(op_b0d8_4), 45272 }, /* CMPA */
{ CPUFUNC(op_b0e0_4), 45280 }, /* CMPA */
{ CPUFUNC(op_b0e8_4), 45288 }, /* CMPA */
{ CPUFUNC(op_b0f0_4), 45296 }, /* CMPA */
{ CPUFUNC(op_b0f8_4), 45304 }, /* CMPA */
{ CPUFUNC(op_b0f9_4), 45305 }, /* CMPA */
{ CPUFUNC(op_b0fa_4), 45306 }, /* CMPA */
{ CPUFUNC(op_b0fb_4), 45307 }, /* CMPA */
{ CPUFUNC(op_b0fc_4), 45308 }, /* CMPA */
{ CPUFUNC(op_b100_4), 45312 }, /* EOR */
{ CPUFUNC(op_b108_4), 45320 }, /* CMPM */
{ CPUFUNC(op_b110_4), 45328 }, /* EOR */
{ CPUFUNC(op_b118_4), 45336 }, /* EOR */
{ CPUFUNC(op_b120_4), 45344 }, /* EOR */
{ CPUFUNC(op_b128_4), 45352 }, /* EOR */
{ CPUFUNC(op_b130_4), 45360 }, /* EOR */
{ CPUFUNC(op_b138_4), 45368 }, /* EOR */
{ CPUFUNC(op_b139_4), 45369 }, /* EOR */
{ CPUFUNC(op_b140_4), 45376 }, /* EOR */
{ CPUFUNC(op_b148_4), 45384 }, /* CMPM */
{ CPUFUNC(op_b150_4), 45392 }, /* EOR */
{ CPUFUNC(op_b158_4), 45400 }, /* EOR */
{ CPUFUNC(op_b160_4), 45408 }, /* EOR */
{ CPUFUNC(op_b168_4), 45416 }, /* EOR */
{ CPUFUNC(op_b170_4), 45424 }, /* EOR */
{ CPUFUNC(op_b178_4), 45432 }, /* EOR */
{ CPUFUNC(op_b179_4), 45433 }, /* EOR */
{ CPUFUNC(op_b180_4), 45440 }, /* EOR */
{ CPUFUNC(op_b188_4), 45448 }, /* CMPM */
{ CPUFUNC(op_b190_4), 45456 }, /* EOR */
{ CPUFUNC(op_b198_4), 45464 }, /* EOR */
{ CPUFUNC(op_b1a0_4), 45472 }, /* EOR */
{ CPUFUNC(op_b1a8_4), 45480 }, /* EOR */
{ CPUFUNC(op_b1b0_4), 45488 }, /* EOR */
{ CPUFUNC(op_b1b8_4), 45496 }, /* EOR */
{ CPUFUNC(op_b1b9_4), 45497 }, /* EOR */
{ CPUFUNC(op_b1c0_4), 45504 }, /* CMPA */
{ CPUFUNC(op_b1c8_4), 45512 }, /* CMPA */
{ CPUFUNC(op_b1d0_4), 45520 }, /* CMPA */
{ CPUFUNC(op_b1d8_4), 45528 }, /* CMPA */
{ CPUFUNC(op_b1e0_4), 45536 }, /* CMPA */
{ CPUFUNC(op_b1e8_4), 45544 }, /* CMPA */
{ CPUFUNC(op_b1f0_4), 45552 }, /* CMPA */
{ CPUFUNC(op_b1f8_4), 45560 }, /* CMPA */
{ CPUFUNC(op_b1f9_4), 45561 }, /* CMPA */
{ CPUFUNC(op_b1fa_4), 45562 }, /* CMPA */
{ CPUFUNC(op_b1fb_4), 45563 }, /* CMPA */
{ CPUFUNC(op_b1fc_4), 45564 }, /* CMPA */
{ CPUFUNC(op_c000_4), 49152 }, /* AND */
{ CPUFUNC(op_c010_4), 49168 }, /* AND */
{ CPUFUNC(op_c018_4), 49176 }, /* AND */
{ CPUFUNC(op_c020_4), 49184 }, /* AND */
{ CPUFUNC(op_c028_4), 49192 }, /* AND */
{ CPUFUNC(op_c030_4), 49200 }, /* AND */
{ CPUFUNC(op_c038_4), 49208 }, /* AND */
{ CPUFUNC(op_c039_4), 49209 }, /* AND */
{ CPUFUNC(op_c03a_4), 49210 }, /* AND */
{ CPUFUNC(op_c03b_4), 49211 }, /* AND */
{ CPUFUNC(op_c03c_4), 49212 }, /* AND */
{ CPUFUNC(op_c040_4), 49216 }, /* AND */
{ CPUFUNC(op_c050_4), 49232 }, /* AND */
{ CPUFUNC(op_c058_4), 49240 }, /* AND */
{ CPUFUNC(op_c060_4), 49248 }, /* AND */
{ CPUFUNC(op_c068_4), 49256 }, /* AND */
{ CPUFUNC(op_c070_4), 49264 }, /* AND */
{ CPUFUNC(op_c078_4), 49272 }, /* AND */
{ CPUFUNC(op_c079_4), 49273 }, /* AND */
{ CPUFUNC(op_c07a_4), 49274 }, /* AND */
{ CPUFUNC(op_c07b_4), 49275 }, /* AND */
{ CPUFUNC(op_c07c_4), 49276 }, /* AND */
{ CPUFUNC(op_c080_4), 49280 }, /* AND */
{ CPUFUNC(op_c090_4), 49296 }, /* AND */
{ CPUFUNC(op_c098_4), 49304 }, /* AND */
{ CPUFUNC(op_c0a0_4), 49312 }, /* AND */
{ CPUFUNC(op_c0a8_4), 49320 }, /* AND */
{ CPUFUNC(op_c0b0_4), 49328 }, /* AND */
{ CPUFUNC(op_c0b8_4), 49336 }, /* AND */
{ CPUFUNC(op_c0b9_4), 49337 }, /* AND */
{ CPUFUNC(op_c0ba_4), 49338 }, /* AND */
{ CPUFUNC(op_c0bb_4), 49339 }, /* AND */
{ CPUFUNC(op_c0bc_4), 49340 }, /* AND */
{ CPUFUNC(op_c0c0_4), 49344 }, /* MULU */
{ CPUFUNC(op_c0d0_4), 49360 }, /* MULU */
{ CPUFUNC(op_c0d8_4), 49368 }, /* MULU */
{ CPUFUNC(op_c0e0_4), 49376 }, /* MULU */
{ CPUFUNC(op_c0e8_4), 49384 }, /* MULU */
{ CPUFUNC(op_c0f0_4), 49392 }, /* MULU */
{ CPUFUNC(op_c0f8_4), 49400 }, /* MULU */
{ CPUFUNC(op_c0f9_4), 49401 }, /* MULU */
{ CPUFUNC(op_c0fa_4), 49402 }, /* MULU */
{ CPUFUNC(op_c0fb_4), 49403 }, /* MULU */
{ CPUFUNC(op_c0fc_4), 49404 }, /* MULU */
{ CPUFUNC(op_c100_4), 49408 }, /* ABCD */
{ CPUFUNC(op_c108_4), 49416 }, /* ABCD */
{ CPUFUNC(op_c110_4), 49424 }, /* AND */
{ CPUFUNC(op_c118_4), 49432 }, /* AND */
{ CPUFUNC(op_c120_4), 49440 }, /* AND */
{ CPUFUNC(op_c128_4), 49448 }, /* AND */
{ CPUFUNC(op_c130_4), 49456 }, /* AND */
{ CPUFUNC(op_c138_4), 49464 }, /* AND */
{ CPUFUNC(op_c139_4), 49465 }, /* AND */
{ CPUFUNC(op_c140_4), 49472 }, /* EXG */
{ CPUFUNC(op_c148_4), 49480 }, /* EXG */
{ CPUFUNC(op_c150_4), 49488 }, /* AND */
{ CPUFUNC(op_c158_4), 49496 }, /* AND */
{ CPUFUNC(op_c160_4), 49504 }, /* AND */
{ CPUFUNC(op_c168_4), 49512 }, /* AND */
{ CPUFUNC(op_c170_4), 49520 }, /* AND */
{ CPUFUNC(op_c178_4), 49528 }, /* AND */
{ CPUFUNC(op_c179_4), 49529 }, /* AND */
{ CPUFUNC(op_c188_4), 49544 }, /* EXG */
{ CPUFUNC(op_c190_4), 49552 }, /* AND */
{ CPUFUNC(op_c198_4), 49560 }, /* AND */
{ CPUFUNC(op_c1a0_4), 49568 }, /* AND */
{ CPUFUNC(op_c1a8_4), 49576 }, /* AND */
{ CPUFUNC(op_c1b0_4), 49584 }, /* AND */
{ CPUFUNC(op_c1b8_4), 49592 }, /* AND */
{ CPUFUNC(op_c1b9_4), 49593 }, /* AND */
{ CPUFUNC(op_c1c0_4), 49600 }, /* MULS */
{ CPUFUNC(op_c1d0_4), 49616 }, /* MULS */
{ CPUFUNC(op_c1d8_4), 49624 }, /* MULS */
{ CPUFUNC(op_c1e0_4), 49632 }, /* MULS */
{ CPUFUNC(op_c1e8_4), 49640 }, /* MULS */
{ CPUFUNC(op_c1f0_4), 49648 }, /* MULS */
{ CPUFUNC(op_c1f8_4), 49656 }, /* MULS */
{ CPUFUNC(op_c1f9_4), 49657 }, /* MULS */
{ CPUFUNC(op_c1fa_4), 49658 }, /* MULS */
{ CPUFUNC(op_c1fb_4), 49659 }, /* MULS */
{ CPUFUNC(op_c1fc_4), 49660 }, /* MULS */
{ CPUFUNC(op_d000_4), 53248 }, /* ADD */
{ CPUFUNC(op_d010_4), 53264 }, /* ADD */
{ CPUFUNC(op_d018_4), 53272 }, /* ADD */
{ CPUFUNC(op_d020_4), 53280 }, /* ADD */
{ CPUFUNC(op_d028_4), 53288 }, /* ADD */
{ CPUFUNC(op_d030_4), 53296 }, /* ADD */
{ CPUFUNC(op_d038_4), 53304 }, /* ADD */
{ CPUFUNC(op_d039_4), 53305 }, /* ADD */
{ CPUFUNC(op_d03a_4), 53306 }, /* ADD */
{ CPUFUNC(op_d03b_4), 53307 }, /* ADD */
{ CPUFUNC(op_d03c_4), 53308 }, /* ADD */
{ CPUFUNC(op_d040_4), 53312 }, /* ADD */
{ CPUFUNC(op_d048_4), 53320 }, /* ADD */
{ CPUFUNC(op_d050_4), 53328 }, /* ADD */
{ CPUFUNC(op_d058_4), 53336 }, /* ADD */
{ CPUFUNC(op_d060_4), 53344 }, /* ADD */
{ CPUFUNC(op_d068_4), 53352 }, /* ADD */
{ CPUFUNC(op_d070_4), 53360 }, /* ADD */
{ CPUFUNC(op_d078_4), 53368 }, /* ADD */
{ CPUFUNC(op_d079_4), 53369 }, /* ADD */
{ CPUFUNC(op_d07a_4), 53370 }, /* ADD */
{ CPUFUNC(op_d07b_4), 53371 }, /* ADD */
{ CPUFUNC(op_d07c_4), 53372 }, /* ADD */
{ CPUFUNC(op_d080_4), 53376 }, /* ADD */
{ CPUFUNC(op_d088_4), 53384 }, /* ADD */
{ CPUFUNC(op_d090_4), 53392 }, /* ADD */
{ CPUFUNC(op_d098_4), 53400 }, /* ADD */
{ CPUFUNC(op_d0a0_4), 53408 }, /* ADD */
{ CPUFUNC(op_d0a8_4), 53416 }, /* ADD */
{ CPUFUNC(op_d0b0_4), 53424 }, /* ADD */
{ CPUFUNC(op_d0b8_4), 53432 }, /* ADD */
{ CPUFUNC(op_d0b9_4), 53433 }, /* ADD */
{ CPUFUNC(op_d0ba_4), 53434 }, /* ADD */
{ CPUFUNC(op_d0bb_4), 53435 }, /* ADD */
{ CPUFUNC(op_d0bc_4), 53436 }, /* ADD */
{ CPUFUNC(op_d0c0_4), 53440 }, /* ADDA */
{ CPUFUNC(op_d0c8_4), 53448 }, /* ADDA */
{ CPUFUNC(op_d0d0_4), 53456 }, /* ADDA */
{ CPUFUNC(op_d0d8_4), 53464 }, /* ADDA */
{ CPUFUNC(op_d0e0_4), 53472 }, /* ADDA */
{ CPUFUNC(op_d0e8_4), 53480 }, /* ADDA */
{ CPUFUNC(op_d0f0_4), 53488 }, /* ADDA */
{ CPUFUNC(op_d0f8_4), 53496 }, /* ADDA */
{ CPUFUNC(op_d0f9_4), 53497 }, /* ADDA */
{ CPUFUNC(op_d0fa_4), 53498 }, /* ADDA */
{ CPUFUNC(op_d0fb_4), 53499 }, /* ADDA */
{ CPUFUNC(op_d0fc_4), 53500 }, /* ADDA */
{ CPUFUNC(op_d100_4), 53504 }, /* ADDX */
{ CPUFUNC(op_d108_4), 53512 }, /* ADDX */
{ CPUFUNC(op_d110_4), 53520 }, /* ADD */
{ CPUFUNC(op_d118_4), 53528 }, /* ADD */
{ CPUFUNC(op_d120_4), 53536 }, /* ADD */
{ CPUFUNC(op_d128_4), 53544 }, /* ADD */
{ CPUFUNC(op_d130_4), 53552 }, /* ADD */
{ CPUFUNC(op_d138_4), 53560 }, /* ADD */
{ CPUFUNC(op_d139_4), 53561 }, /* ADD */
{ CPUFUNC(op_d140_4), 53568 }, /* ADDX */
{ CPUFUNC(op_d148_4), 53576 }, /* ADDX */
{ CPUFUNC(op_d150_4), 53584 }, /* ADD */
{ CPUFUNC(op_d158_4), 53592 }, /* ADD */
{ CPUFUNC(op_d160_4), 53600 }, /* ADD */
{ CPUFUNC(op_d168_4), 53608 }, /* ADD */
{ CPUFUNC(op_d170_4), 53616 }, /* ADD */
{ CPUFUNC(op_d178_4), 53624 }, /* ADD */
{ CPUFUNC(op_d179_4), 53625 }, /* ADD */
{ CPUFUNC(op_d180_4), 53632 }, /* ADDX */
{ CPUFUNC(op_d188_4), 53640 }, /* ADDX */
{ CPUFUNC(op_d190_4), 53648 }, /* ADD */
{ CPUFUNC(op_d198_4), 53656 }, /* ADD */
{ CPUFUNC(op_d1a0_4), 53664 }, /* ADD */
{ CPUFUNC(op_d1a8_4), 53672 }, /* ADD */
{ CPUFUNC(op_d1b0_4), 53680 }, /* ADD */
{ CPUFUNC(op_d1b8_4), 53688 }, /* ADD */
{ CPUFUNC(op_d1b9_4), 53689 }, /* ADD */
{ CPUFUNC(op_d1c0_4), 53696 }, /* ADDA */
{ CPUFUNC(op_d1c8_4), 53704 }, /* ADDA */
{ CPUFUNC(op_d1d0_4), 53712 }, /* ADDA */
{ CPUFUNC(op_d1d8_4), 53720 }, /* ADDA */
{ CPUFUNC(op_d1e0_4), 53728 }, /* ADDA */
{ CPUFUNC(op_d1e8_4), 53736 }, /* ADDA */
{ CPUFUNC(op_d1f0_4), 53744 }, /* ADDA */
{ CPUFUNC(op_d1f8_4), 53752 }, /* ADDA */
{ CPUFUNC(op_d1f9_4), 53753 }, /* ADDA */
{ CPUFUNC(op_d1fa_4), 53754 }, /* ADDA */
{ CPUFUNC(op_d1fb_4), 53755 }, /* ADDA */
{ CPUFUNC(op_d1fc_4), 53756 }, /* ADDA */
{ CPUFUNC(op_e000_4), 57344 }, /* ASR */
{ CPUFUNC(op_e008_4), 57352 }, /* LSR */
{ CPUFUNC(op_e010_4), 57360 }, /* ROXR */
{ CPUFUNC(op_e018_4), 57368 }, /* ROR */
{ CPUFUNC(op_e020_4), 57376 }, /* ASR */
{ CPUFUNC(op_e028_4), 57384 }, /* LSR */
{ CPUFUNC(op_e030_4), 57392 }, /* ROXR */
{ CPUFUNC(op_e038_4), 57400 }, /* ROR */
{ CPUFUNC(op_e040_4), 57408 }, /* ASR */
{ CPUFUNC(op_e048_4), 57416 }, /* LSR */
{ CPUFUNC(op_e050_4), 57424 }, /* ROXR */
{ CPUFUNC(op_e058_4), 57432 }, /* ROR */
{ CPUFUNC(op_e060_4), 57440 }, /* ASR */
{ CPUFUNC(op_e068_4), 57448 }, /* LSR */
{ CPUFUNC(op_e070_4), 57456 }, /* ROXR */
{ CPUFUNC(op_e078_4), 57464 }, /* ROR */
{ CPUFUNC(op_e080_4), 57472 }, /* ASR */
{ CPUFUNC(op_e088_4), 57480 }, /* LSR */
{ CPUFUNC(op_e090_4), 57488 }, /* ROXR */
{ CPUFUNC(op_e098_4), 57496 }, /* ROR */
{ CPUFUNC(op_e0a0_4), 57504 }, /* ASR */
{ CPUFUNC(op_e0a8_4), 57512 }, /* LSR */
{ CPUFUNC(op_e0b0_4), 57520 }, /* ROXR */
{ CPUFUNC(op_e0b8_4), 57528 }, /* ROR */
{ CPUFUNC(op_e0d0_4), 57552 }, /* ASRW */
{ CPUFUNC(op_e0d8_4), 57560 }, /* ASRW */
{ CPUFUNC(op_e0e0_4), 57568 }, /* ASRW */
{ CPUFUNC(op_e0e8_4), 57576 }, /* ASRW */
{ CPUFUNC(op_e0f0_4), 57584 }, /* ASRW */
{ CPUFUNC(op_e0f8_4), 57592 }, /* ASRW */
{ CPUFUNC(op_e0f9_4), 57593 }, /* ASRW */
{ CPUFUNC(op_e100_4), 57600 }, /* ASL */
{ CPUFUNC(op_e108_4), 57608 }, /* LSL */
{ CPUFUNC(op_e110_4), 57616 }, /* ROXL */
{ CPUFUNC(op_e118_4), 57624 }, /* ROL */
{ CPUFUNC(op_e120_4), 57632 }, /* ASL */
{ CPUFUNC(op_e128_4), 57640 }, /* LSL */
{ CPUFUNC(op_e130_4), 57648 }, /* ROXL */
{ CPUFUNC(op_e138_4), 57656 }, /* ROL */
{ CPUFUNC(op_e140_4), 57664 }, /* ASL */
{ CPUFUNC(op_e148_4), 57672 }, /* LSL */
{ CPUFUNC(op_e150_4), 57680 }, /* ROXL */
{ CPUFUNC(op_e158_4), 57688 }, /* ROL */
{ CPUFUNC(op_e160_4), 57696 }, /* ASL */
{ CPUFUNC(op_e168_4), 57704 }, /* LSL */
{ CPUFUNC(op_e170_4), 57712 }, /* ROXL */
{ CPUFUNC(op_e178_4), 57720 }, /* ROL */
{ CPUFUNC(op_e180_4), 57728 }, /* ASL */
{ CPUFUNC(op_e188_4), 57736 }, /* LSL */
{ CPUFUNC(op_e190_4), 57744 }, /* ROXL */
{ CPUFUNC(op_e198_4), 57752 }, /* ROL */
{ CPUFUNC(op_e1a0_4), 57760 }, /* ASL */
{ CPUFUNC(op_e1a8_4), 57768 }, /* LSL */
{ CPUFUNC(op_e1b0_4), 57776 }, /* ROXL */
{ CPUFUNC(op_e1b8_4), 57784 }, /* ROL */
{ CPUFUNC(op_e1d0_4), 57808 }, /* ASLW */
{ CPUFUNC(op_e1d8_4), 57816 }, /* ASLW */
{ CPUFUNC(op_e1e0_4), 57824 }, /* ASLW */
{ CPUFUNC(op_e1e8_4), 57832 }, /* ASLW */
{ CPUFUNC(op_e1f0_4), 57840 }, /* ASLW */
{ CPUFUNC(op_e1f8_4), 57848 }, /* ASLW */
{ CPUFUNC(op_e1f9_4), 57849 }, /* ASLW */
{ CPUFUNC(op_e2d0_4), 58064 }, /* LSRW */
{ CPUFUNC(op_e2d8_4), 58072 }, /* LSRW */
{ CPUFUNC(op_e2e0_4), 58080 }, /* LSRW */
{ CPUFUNC(op_e2e8_4), 58088 }, /* LSRW */
{ CPUFUNC(op_e2f0_4), 58096 }, /* LSRW */
{ CPUFUNC(op_e2f8_4), 58104 }, /* LSRW */
{ CPUFUNC(op_e2f9_4), 58105 }, /* LSRW */
{ CPUFUNC(op_e3d0_4), 58320 }, /* LSLW */
{ CPUFUNC(op_e3d8_4), 58328 }, /* LSLW */
{ CPUFUNC(op_e3e0_4), 58336 }, /* LSLW */
{ CPUFUNC(op_e3e8_4), 58344 }, /* LSLW */
{ CPUFUNC(op_e3f0_4), 58352 }, /* LSLW */
{ CPUFUNC(op_e3f8_4), 58360 }, /* LSLW */
{ CPUFUNC(op_e3f9_4), 58361 }, /* LSLW */
{ CPUFUNC(op_e4d0_4), 58576 }, /* ROXRW */
{ CPUFUNC(op_e4d8_4), 58584 }, /* ROXRW */
{ CPUFUNC(op_e4e0_4), 58592 }, /* ROXRW */
{ CPUFUNC(op_e4e8_4), 58600 }, /* ROXRW */
{ CPUFUNC(op_e4f0_4), 58608 }, /* ROXRW */
{ CPUFUNC(op_e4f8_4), 58616 }, /* ROXRW */
{ CPUFUNC(op_e4f9_4), 58617 }, /* ROXRW */
{ CPUFUNC(op_e5d0_4), 58832 }, /* ROXLW */
{ CPUFUNC(op_e5d8_4), 58840 }, /* ROXLW */
{ CPUFUNC(op_e5e0_4), 58848 }, /* ROXLW */
{ CPUFUNC(op_e5e8_4), 58856 }, /* ROXLW */
{ CPUFUNC(op_e5f0_4), 58864 }, /* ROXLW */
{ CPUFUNC(op_e5f8_4), 58872 }, /* ROXLW */
{ CPUFUNC(op_e5f9_4), 58873 }, /* ROXLW */
{ CPUFUNC(op_e6d0_4), 59088 }, /* RORW */
{ CPUFUNC(op_e6d8_4), 59096 }, /* RORW */
{ CPUFUNC(op_e6e0_4), 59104 }, /* RORW */
{ CPUFUNC(op_e6e8_4), 59112 }, /* RORW */
{ CPUFUNC(op_e6f0_4), 59120 }, /* RORW */
{ CPUFUNC(op_e6f8_4), 59128 }, /* RORW */
{ CPUFUNC(op_e6f9_4), 59129 }, /* RORW */
{ CPUFUNC(op_e7d0_4), 59344 }, /* ROLW */
{ CPUFUNC(op_e7d8_4), 59352 }, /* ROLW */
{ CPUFUNC(op_e7e0_4), 59360 }, /* ROLW */
{ CPUFUNC(op_e7e8_4), 59368 }, /* ROLW */
{ CPUFUNC(op_e7f0_4), 59376 }, /* ROLW */
{ CPUFUNC(op_e7f8_4), 59384 }, /* ROLW */
{ CPUFUNC(op_e7f9_4), 59385 }, /* ROLW */
{ 0, 0 }};
#ifdef CPUEMU_11
const struct cputbl CPUFUNC(op_smalltbl_11)[] = {
{ CPUFUNC(op_0000_11), 0 }, /* OR */
{ CPUFUNC(op_0010_11), 16 }, /* OR */
{ CPUFUNC(op_0018_11), 24 }, /* OR */
{ CPUFUNC(op_0020_11), 32 }, /* OR */
{ CPUFUNC(op_0028_11), 40 }, /* OR */
{ CPUFUNC(op_0030_11), 48 }, /* OR */
{ CPUFUNC(op_0038_11), 56 }, /* OR */
{ CPUFUNC(op_0039_11), 57 }, /* OR */
{ CPUFUNC(op_003c_11), 60 }, /* ORSR */
{ CPUFUNC(op_0040_11), 64 }, /* OR */
{ CPUFUNC(op_0050_11), 80 }, /* OR */
{ CPUFUNC(op_0058_11), 88 }, /* OR */
{ CPUFUNC(op_0060_11), 96 }, /* OR */
{ CPUFUNC(op_0068_11), 104 }, /* OR */
{ CPUFUNC(op_0070_11), 112 }, /* OR */
{ CPUFUNC(op_0078_11), 120 }, /* OR */
{ CPUFUNC(op_0079_11), 121 }, /* OR */
{ CPUFUNC(op_007c_11), 124 }, /* ORSR */
{ CPUFUNC(op_0080_11), 128 }, /* OR */
{ CPUFUNC(op_0090_11), 144 }, /* OR */
{ CPUFUNC(op_0098_11), 152 }, /* OR */
{ CPUFUNC(op_00a0_11), 160 }, /* OR */
{ CPUFUNC(op_00a8_11), 168 }, /* OR */
{ CPUFUNC(op_00b0_11), 176 }, /* OR */
{ CPUFUNC(op_00b8_11), 184 }, /* OR */
{ CPUFUNC(op_00b9_11), 185 }, /* OR */
{ CPUFUNC(op_0100_11), 256 }, /* BTST */
{ CPUFUNC(op_0108_11), 264 }, /* MVPMR */
{ CPUFUNC(op_0110_11), 272 }, /* BTST */
{ CPUFUNC(op_0118_11), 280 }, /* BTST */
{ CPUFUNC(op_0120_11), 288 }, /* BTST */
{ CPUFUNC(op_0128_11), 296 }, /* BTST */
{ CPUFUNC(op_0130_11), 304 }, /* BTST */
{ CPUFUNC(op_0138_11), 312 }, /* BTST */
{ CPUFUNC(op_0139_11), 313 }, /* BTST */
{ CPUFUNC(op_013a_11), 314 }, /* BTST */
{ CPUFUNC(op_013b_11), 315 }, /* BTST */
{ CPUFUNC(op_013c_11), 316 }, /* BTST */
{ CPUFUNC(op_0140_11), 320 }, /* BCHG */
{ CPUFUNC(op_0148_11), 328 }, /* MVPMR */
{ CPUFUNC(op_0150_11), 336 }, /* BCHG */
{ CPUFUNC(op_0158_11), 344 }, /* BCHG */
{ CPUFUNC(op_0160_11), 352 }, /* BCHG */
{ CPUFUNC(op_0168_11), 360 }, /* BCHG */
{ CPUFUNC(op_0170_11), 368 }, /* BCHG */
{ CPUFUNC(op_0178_11), 376 }, /* BCHG */
{ CPUFUNC(op_0179_11), 377 }, /* BCHG */
{ CPUFUNC(op_0180_11), 384 }, /* BCLR */
{ CPUFUNC(op_0188_11), 392 }, /* MVPRM */
{ CPUFUNC(op_0190_11), 400 }, /* BCLR */
{ CPUFUNC(op_0198_11), 408 }, /* BCLR */
{ CPUFUNC(op_01a0_11), 416 }, /* BCLR */
{ CPUFUNC(op_01a8_11), 424 }, /* BCLR */
{ CPUFUNC(op_01b0_11), 432 }, /* BCLR */
{ CPUFUNC(op_01b8_11), 440 }, /* BCLR */
{ CPUFUNC(op_01b9_11), 441 }, /* BCLR */
{ CPUFUNC(op_01c0_11), 448 }, /* BSET */
{ CPUFUNC(op_01c8_11), 456 }, /* MVPRM */
{ CPUFUNC(op_01d0_11), 464 }, /* BSET */
{ CPUFUNC(op_01d8_11), 472 }, /* BSET */
{ CPUFUNC(op_01e0_11), 480 }, /* BSET */
{ CPUFUNC(op_01e8_11), 488 }, /* BSET */
{ CPUFUNC(op_01f0_11), 496 }, /* BSET */
{ CPUFUNC(op_01f8_11), 504 }, /* BSET */
{ CPUFUNC(op_01f9_11), 505 }, /* BSET */
{ CPUFUNC(op_0200_11), 512 }, /* AND */
{ CPUFUNC(op_0210_11), 528 }, /* AND */
{ CPUFUNC(op_0218_11), 536 }, /* AND */
{ CPUFUNC(op_0220_11), 544 }, /* AND */
{ CPUFUNC(op_0228_11), 552 }, /* AND */
{ CPUFUNC(op_0230_11), 560 }, /* AND */
{ CPUFUNC(op_0238_11), 568 }, /* AND */
{ CPUFUNC(op_0239_11), 569 }, /* AND */
{ CPUFUNC(op_023c_11), 572 }, /* ANDSR */
{ CPUFUNC(op_0240_11), 576 }, /* AND */
{ CPUFUNC(op_0250_11), 592 }, /* AND */
{ CPUFUNC(op_0258_11), 600 }, /* AND */
{ CPUFUNC(op_0260_11), 608 }, /* AND */
{ CPUFUNC(op_0268_11), 616 }, /* AND */
{ CPUFUNC(op_0270_11), 624 }, /* AND */
{ CPUFUNC(op_0278_11), 632 }, /* AND */
{ CPUFUNC(op_0279_11), 633 }, /* AND */
{ CPUFUNC(op_027c_11), 636 }, /* ANDSR */
{ CPUFUNC(op_0280_11), 640 }, /* AND */
{ CPUFUNC(op_0290_11), 656 }, /* AND */
{ CPUFUNC(op_0298_11), 664 }, /* AND */
{ CPUFUNC(op_02a0_11), 672 }, /* AND */
{ CPUFUNC(op_02a8_11), 680 }, /* AND */
{ CPUFUNC(op_02b0_11), 688 }, /* AND */
{ CPUFUNC(op_02b8_11), 696 }, /* AND */
{ CPUFUNC(op_02b9_11), 697 }, /* AND */
{ CPUFUNC(op_0400_11), 1024 }, /* SUB */
{ CPUFUNC(op_0410_11), 1040 }, /* SUB */
{ CPUFUNC(op_0418_11), 1048 }, /* SUB */
{ CPUFUNC(op_0420_11), 1056 }, /* SUB */
{ CPUFUNC(op_0428_11), 1064 }, /* SUB */
{ CPUFUNC(op_0430_11), 1072 }, /* SUB */
{ CPUFUNC(op_0438_11), 1080 }, /* SUB */
{ CPUFUNC(op_0439_11), 1081 }, /* SUB */
{ CPUFUNC(op_0440_11), 1088 }, /* SUB */
{ CPUFUNC(op_0450_11), 1104 }, /* SUB */
{ CPUFUNC(op_0458_11), 1112 }, /* SUB */
{ CPUFUNC(op_0460_11), 1120 }, /* SUB */
{ CPUFUNC(op_0468_11), 1128 }, /* SUB */
{ CPUFUNC(op_0470_11), 1136 }, /* SUB */
{ CPUFUNC(op_0478_11), 1144 }, /* SUB */
{ CPUFUNC(op_0479_11), 1145 }, /* SUB */
{ CPUFUNC(op_0480_11), 1152 }, /* SUB */
{ CPUFUNC(op_0490_11), 1168 }, /* SUB */
{ CPUFUNC(op_0498_11), 1176 }, /* SUB */
{ CPUFUNC(op_04a0_11), 1184 }, /* SUB */
{ CPUFUNC(op_04a8_11), 1192 }, /* SUB */
{ CPUFUNC(op_04b0_11), 1200 }, /* SUB */
{ CPUFUNC(op_04b8_11), 1208 }, /* SUB */
{ CPUFUNC(op_04b9_11), 1209 }, /* SUB */
{ CPUFUNC(op_0600_11), 1536 }, /* ADD */
{ CPUFUNC(op_0610_11), 1552 }, /* ADD */
{ CPUFUNC(op_0618_11), 1560 }, /* ADD */
{ CPUFUNC(op_0620_11), 1568 }, /* ADD */
{ CPUFUNC(op_0628_11), 1576 }, /* ADD */
{ CPUFUNC(op_0630_11), 1584 }, /* ADD */
{ CPUFUNC(op_0638_11), 1592 }, /* ADD */
{ CPUFUNC(op_0639_11), 1593 }, /* ADD */
{ CPUFUNC(op_0640_11), 1600 }, /* ADD */
{ CPUFUNC(op_0650_11), 1616 }, /* ADD */
{ CPUFUNC(op_0658_11), 1624 }, /* ADD */
{ CPUFUNC(op_0660_11), 1632 }, /* ADD */
{ CPUFUNC(op_0668_11), 1640 }, /* ADD */
{ CPUFUNC(op_0670_11), 1648 }, /* ADD */
{ CPUFUNC(op_0678_11), 1656 }, /* ADD */
{ CPUFUNC(op_0679_11), 1657 }, /* ADD */
{ CPUFUNC(op_0680_11), 1664 }, /* ADD */
{ CPUFUNC(op_0690_11), 1680 }, /* ADD */
{ CPUFUNC(op_0698_11), 1688 }, /* ADD */
{ CPUFUNC(op_06a0_11), 1696 }, /* ADD */
{ CPUFUNC(op_06a8_11), 1704 }, /* ADD */
{ CPUFUNC(op_06b0_11), 1712 }, /* ADD */
{ CPUFUNC(op_06b8_11), 1720 }, /* ADD */
{ CPUFUNC(op_06b9_11), 1721 }, /* ADD */
{ CPUFUNC(op_0800_11), 2048 }, /* BTST */
{ CPUFUNC(op_0810_11), 2064 }, /* BTST */
{ CPUFUNC(op_0818_11), 2072 }, /* BTST */
{ CPUFUNC(op_0820_11), 2080 }, /* BTST */
{ CPUFUNC(op_0828_11), 2088 }, /* BTST */
{ CPUFUNC(op_0830_11), 2096 }, /* BTST */
{ CPUFUNC(op_0838_11), 2104 }, /* BTST */
{ CPUFUNC(op_0839_11), 2105 }, /* BTST */
{ CPUFUNC(op_083a_11), 2106 }, /* BTST */
{ CPUFUNC(op_083b_11), 2107 }, /* BTST */
{ CPUFUNC(op_083c_11), 2108 }, /* BTST */
{ CPUFUNC(op_0840_11), 2112 }, /* BCHG */
{ CPUFUNC(op_0850_11), 2128 }, /* BCHG */
{ CPUFUNC(op_0858_11), 2136 }, /* BCHG */
{ CPUFUNC(op_0860_11), 2144 }, /* BCHG */
{ CPUFUNC(op_0868_11), 2152 }, /* BCHG */
{ CPUFUNC(op_0870_11), 2160 }, /* BCHG */
{ CPUFUNC(op_0878_11), 2168 }, /* BCHG */
{ CPUFUNC(op_0879_11), 2169 }, /* BCHG */
{ CPUFUNC(op_0880_11), 2176 }, /* BCLR */
{ CPUFUNC(op_0890_11), 2192 }, /* BCLR */
{ CPUFUNC(op_0898_11), 2200 }, /* BCLR */
{ CPUFUNC(op_08a0_11), 2208 }, /* BCLR */
{ CPUFUNC(op_08a8_11), 2216 }, /* BCLR */
{ CPUFUNC(op_08b0_11), 2224 }, /* BCLR */
{ CPUFUNC(op_08b8_11), 2232 }, /* BCLR */
{ CPUFUNC(op_08b9_11), 2233 }, /* BCLR */
{ CPUFUNC(op_08c0_11), 2240 }, /* BSET */
{ CPUFUNC(op_08d0_11), 2256 }, /* BSET */
{ CPUFUNC(op_08d8_11), 2264 }, /* BSET */
{ CPUFUNC(op_08e0_11), 2272 }, /* BSET */
{ CPUFUNC(op_08e8_11), 2280 }, /* BSET */
{ CPUFUNC(op_08f0_11), 2288 }, /* BSET */
{ CPUFUNC(op_08f8_11), 2296 }, /* BSET */
{ CPUFUNC(op_08f9_11), 2297 }, /* BSET */
{ CPUFUNC(op_0a00_11), 2560 }, /* EOR */
{ CPUFUNC(op_0a10_11), 2576 }, /* EOR */
{ CPUFUNC(op_0a18_11), 2584 }, /* EOR */
{ CPUFUNC(op_0a20_11), 2592 }, /* EOR */
{ CPUFUNC(op_0a28_11), 2600 }, /* EOR */
{ CPUFUNC(op_0a30_11), 2608 }, /* EOR */
{ CPUFUNC(op_0a38_11), 2616 }, /* EOR */
{ CPUFUNC(op_0a39_11), 2617 }, /* EOR */
{ CPUFUNC(op_0a3c_11), 2620 }, /* EORSR */
{ CPUFUNC(op_0a40_11), 2624 }, /* EOR */
{ CPUFUNC(op_0a50_11), 2640 }, /* EOR */
{ CPUFUNC(op_0a58_11), 2648 }, /* EOR */
{ CPUFUNC(op_0a60_11), 2656 }, /* EOR */
{ CPUFUNC(op_0a68_11), 2664 }, /* EOR */
{ CPUFUNC(op_0a70_11), 2672 }, /* EOR */
{ CPUFUNC(op_0a78_11), 2680 }, /* EOR */
{ CPUFUNC(op_0a79_11), 2681 }, /* EOR */
{ CPUFUNC(op_0a7c_11), 2684 }, /* EORSR */
{ CPUFUNC(op_0a80_11), 2688 }, /* EOR */
{ CPUFUNC(op_0a90_11), 2704 }, /* EOR */
{ CPUFUNC(op_0a98_11), 2712 }, /* EOR */
{ CPUFUNC(op_0aa0_11), 2720 }, /* EOR */
{ CPUFUNC(op_0aa8_11), 2728 }, /* EOR */
{ CPUFUNC(op_0ab0_11), 2736 }, /* EOR */
{ CPUFUNC(op_0ab8_11), 2744 }, /* EOR */
{ CPUFUNC(op_0ab9_11), 2745 }, /* EOR */
{ CPUFUNC(op_0c00_11), 3072 }, /* CMP */
{ CPUFUNC(op_0c10_11), 3088 }, /* CMP */
{ CPUFUNC(op_0c18_11), 3096 }, /* CMP */
{ CPUFUNC(op_0c20_11), 3104 }, /* CMP */
{ CPUFUNC(op_0c28_11), 3112 }, /* CMP */
{ CPUFUNC(op_0c30_11), 3120 }, /* CMP */
{ CPUFUNC(op_0c38_11), 3128 }, /* CMP */
{ CPUFUNC(op_0c39_11), 3129 }, /* CMP */
{ CPUFUNC(op_0c40_11), 3136 }, /* CMP */
{ CPUFUNC(op_0c50_11), 3152 }, /* CMP */
{ CPUFUNC(op_0c58_11), 3160 }, /* CMP */
{ CPUFUNC(op_0c60_11), 3168 }, /* CMP */
{ CPUFUNC(op_0c68_11), 3176 }, /* CMP */
{ CPUFUNC(op_0c70_11), 3184 }, /* CMP */
{ CPUFUNC(op_0c78_11), 3192 }, /* CMP */
{ CPUFUNC(op_0c79_11), 3193 }, /* CMP */
{ CPUFUNC(op_0c80_11), 3200 }, /* CMP */
{ CPUFUNC(op_0c90_11), 3216 }, /* CMP */
{ CPUFUNC(op_0c98_11), 3224 }, /* CMP */
{ CPUFUNC(op_0ca0_11), 3232 }, /* CMP */
{ CPUFUNC(op_0ca8_11), 3240 }, /* CMP */
{ CPUFUNC(op_0cb0_11), 3248 }, /* CMP */
{ CPUFUNC(op_0cb8_11), 3256 }, /* CMP */
{ CPUFUNC(op_0cb9_11), 3257 }, /* CMP */
{ CPUFUNC(op_1000_11), 4096 }, /* MOVE */
{ CPUFUNC(op_1010_11), 4112 }, /* MOVE */
{ CPUFUNC(op_1018_11), 4120 }, /* MOVE */
{ CPUFUNC(op_1020_11), 4128 }, /* MOVE */
{ CPUFUNC(op_1028_11), 4136 }, /* MOVE */
{ CPUFUNC(op_1030_11), 4144 }, /* MOVE */
{ CPUFUNC(op_1038_11), 4152 }, /* MOVE */
{ CPUFUNC(op_1039_11), 4153 }, /* MOVE */
{ CPUFUNC(op_103a_11), 4154 }, /* MOVE */
{ CPUFUNC(op_103b_11), 4155 }, /* MOVE */
{ CPUFUNC(op_103c_11), 4156 }, /* MOVE */
{ CPUFUNC(op_1080_11), 4224 }, /* MOVE */
{ CPUFUNC(op_1090_11), 4240 }, /* MOVE */
{ CPUFUNC(op_1098_11), 4248 }, /* MOVE */
{ CPUFUNC(op_10a0_11), 4256 }, /* MOVE */
{ CPUFUNC(op_10a8_11), 4264 }, /* MOVE */
{ CPUFUNC(op_10b0_11), 4272 }, /* MOVE */
{ CPUFUNC(op_10b8_11), 4280 }, /* MOVE */
{ CPUFUNC(op_10b9_11), 4281 }, /* MOVE */
{ CPUFUNC(op_10ba_11), 4282 }, /* MOVE */
{ CPUFUNC(op_10bb_11), 4283 }, /* MOVE */
{ CPUFUNC(op_10bc_11), 4284 }, /* MOVE */
{ CPUFUNC(op_10c0_11), 4288 }, /* MOVE */
{ CPUFUNC(op_10d0_11), 4304 }, /* MOVE */
{ CPUFUNC(op_10d8_11), 4312 }, /* MOVE */
{ CPUFUNC(op_10e0_11), 4320 }, /* MOVE */
{ CPUFUNC(op_10e8_11), 4328 }, /* MOVE */
{ CPUFUNC(op_10f0_11), 4336 }, /* MOVE */
{ CPUFUNC(op_10f8_11), 4344 }, /* MOVE */
{ CPUFUNC(op_10f9_11), 4345 }, /* MOVE */
{ CPUFUNC(op_10fa_11), 4346 }, /* MOVE */
{ CPUFUNC(op_10fb_11), 4347 }, /* MOVE */
{ CPUFUNC(op_10fc_11), 4348 }, /* MOVE */
{ CPUFUNC(op_1100_11), 4352 }, /* MOVE */
{ CPUFUNC(op_1110_11), 4368 }, /* MOVE */
{ CPUFUNC(op_1118_11), 4376 }, /* MOVE */
{ CPUFUNC(op_1120_11), 4384 }, /* MOVE */
{ CPUFUNC(op_1128_11), 4392 }, /* MOVE */
{ CPUFUNC(op_1130_11), 4400 }, /* MOVE */
{ CPUFUNC(op_1138_11), 4408 }, /* MOVE */
{ CPUFUNC(op_1139_11), 4409 }, /* MOVE */
{ CPUFUNC(op_113a_11), 4410 }, /* MOVE */
{ CPUFUNC(op_113b_11), 4411 }, /* MOVE */
{ CPUFUNC(op_113c_11), 4412 }, /* MOVE */
{ CPUFUNC(op_1140_11), 4416 }, /* MOVE */
{ CPUFUNC(op_1150_11), 4432 }, /* MOVE */
{ CPUFUNC(op_1158_11), 4440 }, /* MOVE */
{ CPUFUNC(op_1160_11), 4448 }, /* MOVE */
{ CPUFUNC(op_1168_11), 4456 }, /* MOVE */
{ CPUFUNC(op_1170_11), 4464 }, /* MOVE */
{ CPUFUNC(op_1178_11), 4472 }, /* MOVE */
{ CPUFUNC(op_1179_11), 4473 }, /* MOVE */
{ CPUFUNC(op_117a_11), 4474 }, /* MOVE */
{ CPUFUNC(op_117b_11), 4475 }, /* MOVE */
{ CPUFUNC(op_117c_11), 4476 }, /* MOVE */
{ CPUFUNC(op_1180_11), 4480 }, /* MOVE */
{ CPUFUNC(op_1190_11), 4496 }, /* MOVE */
{ CPUFUNC(op_1198_11), 4504 }, /* MOVE */
{ CPUFUNC(op_11a0_11), 4512 }, /* MOVE */
{ CPUFUNC(op_11a8_11), 4520 }, /* MOVE */
{ CPUFUNC(op_11b0_11), 4528 }, /* MOVE */
{ CPUFUNC(op_11b8_11), 4536 }, /* MOVE */
{ CPUFUNC(op_11b9_11), 4537 }, /* MOVE */
{ CPUFUNC(op_11ba_11), 4538 }, /* MOVE */
{ CPUFUNC(op_11bb_11), 4539 }, /* MOVE */
{ CPUFUNC(op_11bc_11), 4540 }, /* MOVE */
{ CPUFUNC(op_11c0_11), 4544 }, /* MOVE */
{ CPUFUNC(op_11d0_11), 4560 }, /* MOVE */
{ CPUFUNC(op_11d8_11), 4568 }, /* MOVE */
{ CPUFUNC(op_11e0_11), 4576 }, /* MOVE */
{ CPUFUNC(op_11e8_11), 4584 }, /* MOVE */
{ CPUFUNC(op_11f0_11), 4592 }, /* MOVE */
{ CPUFUNC(op_11f8_11), 4600 }, /* MOVE */
{ CPUFUNC(op_11f9_11), 4601 }, /* MOVE */
{ CPUFUNC(op_11fa_11), 4602 }, /* MOVE */
{ CPUFUNC(op_11fb_11), 4603 }, /* MOVE */
{ CPUFUNC(op_11fc_11), 4604 }, /* MOVE */
{ CPUFUNC(op_13c0_11), 5056 }, /* MOVE */
{ CPUFUNC(op_13d0_11), 5072 }, /* MOVE */
{ CPUFUNC(op_13d8_11), 5080 }, /* MOVE */
{ CPUFUNC(op_13e0_11), 5088 }, /* MOVE */
{ CPUFUNC(op_13e8_11), 5096 }, /* MOVE */
{ CPUFUNC(op_13f0_11), 5104 }, /* MOVE */
{ CPUFUNC(op_13f8_11), 5112 }, /* MOVE */
{ CPUFUNC(op_13f9_11), 5113 }, /* MOVE */
{ CPUFUNC(op_13fa_11), 5114 }, /* MOVE */
{ CPUFUNC(op_13fb_11), 5115 }, /* MOVE */
{ CPUFUNC(op_13fc_11), 5116 }, /* MOVE */
{ CPUFUNC(op_2000_11), 8192 }, /* MOVE */
{ CPUFUNC(op_2008_11), 8200 }, /* MOVE */
{ CPUFUNC(op_2010_11), 8208 }, /* MOVE */
{ CPUFUNC(op_2018_11), 8216 }, /* MOVE */
{ CPUFUNC(op_2020_11), 8224 }, /* MOVE */
{ CPUFUNC(op_2028_11), 8232 }, /* MOVE */
{ CPUFUNC(op_2030_11), 8240 }, /* MOVE */
{ CPUFUNC(op_2038_11), 8248 }, /* MOVE */
{ CPUFUNC(op_2039_11), 8249 }, /* MOVE */
{ CPUFUNC(op_203a_11), 8250 }, /* MOVE */
{ CPUFUNC(op_203b_11), 8251 }, /* MOVE */
{ CPUFUNC(op_203c_11), 8252 }, /* MOVE */
{ CPUFUNC(op_2040_11), 8256 }, /* MOVEA */
{ CPUFUNC(op_2048_11), 8264 }, /* MOVEA */
{ CPUFUNC(op_2050_11), 8272 }, /* MOVEA */
{ CPUFUNC(op_2058_11), 8280 }, /* MOVEA */
{ CPUFUNC(op_2060_11), 8288 }, /* MOVEA */
{ CPUFUNC(op_2068_11), 8296 }, /* MOVEA */
{ CPUFUNC(op_2070_11), 8304 }, /* MOVEA */
{ CPUFUNC(op_2078_11), 8312 }, /* MOVEA */
{ CPUFUNC(op_2079_11), 8313 }, /* MOVEA */
{ CPUFUNC(op_207a_11), 8314 }, /* MOVEA */
{ CPUFUNC(op_207b_11), 8315 }, /* MOVEA */
{ CPUFUNC(op_207c_11), 8316 }, /* MOVEA */
{ CPUFUNC(op_2080_11), 8320 }, /* MOVE */
{ CPUFUNC(op_2088_11), 8328 }, /* MOVE */
{ CPUFUNC(op_2090_11), 8336 }, /* MOVE */
{ CPUFUNC(op_2098_11), 8344 }, /* MOVE */
{ CPUFUNC(op_20a0_11), 8352 }, /* MOVE */
{ CPUFUNC(op_20a8_11), 8360 }, /* MOVE */
{ CPUFUNC(op_20b0_11), 8368 }, /* MOVE */
{ CPUFUNC(op_20b8_11), 8376 }, /* MOVE */
{ CPUFUNC(op_20b9_11), 8377 }, /* MOVE */
{ CPUFUNC(op_20ba_11), 8378 }, /* MOVE */
{ CPUFUNC(op_20bb_11), 8379 }, /* MOVE */
{ CPUFUNC(op_20bc_11), 8380 }, /* MOVE */
{ CPUFUNC(op_20c0_11), 8384 }, /* MOVE */
{ CPUFUNC(op_20c8_11), 8392 }, /* MOVE */
{ CPUFUNC(op_20d0_11), 8400 }, /* MOVE */
{ CPUFUNC(op_20d8_11), 8408 }, /* MOVE */
{ CPUFUNC(op_20e0_11), 8416 }, /* MOVE */
{ CPUFUNC(op_20e8_11), 8424 }, /* MOVE */
{ CPUFUNC(op_20f0_11), 8432 }, /* MOVE */
{ CPUFUNC(op_20f8_11), 8440 }, /* MOVE */
{ CPUFUNC(op_20f9_11), 8441 }, /* MOVE */
{ CPUFUNC(op_20fa_11), 8442 }, /* MOVE */
{ CPUFUNC(op_20fb_11), 8443 }, /* MOVE */
{ CPUFUNC(op_20fc_11), 8444 }, /* MOVE */
{ CPUFUNC(op_2100_11), 8448 }, /* MOVE */
{ CPUFUNC(op_2108_11), 8456 }, /* MOVE */
{ CPUFUNC(op_2110_11), 8464 }, /* MOVE */
{ CPUFUNC(op_2118_11), 8472 }, /* MOVE */
{ CPUFUNC(op_2120_11), 8480 }, /* MOVE */
{ CPUFUNC(op_2128_11), 8488 }, /* MOVE */
{ CPUFUNC(op_2130_11), 8496 }, /* MOVE */
{ CPUFUNC(op_2138_11), 8504 }, /* MOVE */
{ CPUFUNC(op_2139_11), 8505 }, /* MOVE */
{ CPUFUNC(op_213a_11), 8506 }, /* MOVE */
{ CPUFUNC(op_213b_11), 8507 }, /* MOVE */
{ CPUFUNC(op_213c_11), 8508 }, /* MOVE */
{ CPUFUNC(op_2140_11), 8512 }, /* MOVE */
{ CPUFUNC(op_2148_11), 8520 }, /* MOVE */
{ CPUFUNC(op_2150_11), 8528 }, /* MOVE */
{ CPUFUNC(op_2158_11), 8536 }, /* MOVE */
{ CPUFUNC(op_2160_11), 8544 }, /* MOVE */
{ CPUFUNC(op_2168_11), 8552 }, /* MOVE */
{ CPUFUNC(op_2170_11), 8560 }, /* MOVE */
{ CPUFUNC(op_2178_11), 8568 }, /* MOVE */
{ CPUFUNC(op_2179_11), 8569 }, /* MOVE */
{ CPUFUNC(op_217a_11), 8570 }, /* MOVE */
{ CPUFUNC(op_217b_11), 8571 }, /* MOVE */
{ CPUFUNC(op_217c_11), 8572 }, /* MOVE */
{ CPUFUNC(op_2180_11), 8576 }, /* MOVE */
{ CPUFUNC(op_2188_11), 8584 }, /* MOVE */
{ CPUFUNC(op_2190_11), 8592 }, /* MOVE */
{ CPUFUNC(op_2198_11), 8600 }, /* MOVE */
{ CPUFUNC(op_21a0_11), 8608 }, /* MOVE */
{ CPUFUNC(op_21a8_11), 8616 }, /* MOVE */
{ CPUFUNC(op_21b0_11), 8624 }, /* MOVE */
{ CPUFUNC(op_21b8_11), 8632 }, /* MOVE */
{ CPUFUNC(op_21b9_11), 8633 }, /* MOVE */
{ CPUFUNC(op_21ba_11), 8634 }, /* MOVE */
{ CPUFUNC(op_21bb_11), 8635 }, /* MOVE */
{ CPUFUNC(op_21bc_11), 8636 }, /* MOVE */
{ CPUFUNC(op_21c0_11), 8640 }, /* MOVE */
{ CPUFUNC(op_21c8_11), 8648 }, /* MOVE */
{ CPUFUNC(op_21d0_11), 8656 }, /* MOVE */
{ CPUFUNC(op_21d8_11), 8664 }, /* MOVE */
{ CPUFUNC(op_21e0_11), 8672 }, /* MOVE */
{ CPUFUNC(op_21e8_11), 8680 }, /* MOVE */
{ CPUFUNC(op_21f0_11), 8688 }, /* MOVE */
{ CPUFUNC(op_21f8_11), 8696 }, /* MOVE */
{ CPUFUNC(op_21f9_11), 8697 }, /* MOVE */
{ CPUFUNC(op_21fa_11), 8698 }, /* MOVE */
{ CPUFUNC(op_21fb_11), 8699 }, /* MOVE */
{ CPUFUNC(op_21fc_11), 8700 }, /* MOVE */
{ CPUFUNC(op_23c0_11), 9152 }, /* MOVE */
{ CPUFUNC(op_23c8_11), 9160 }, /* MOVE */
{ CPUFUNC(op_23d0_11), 9168 }, /* MOVE */
{ CPUFUNC(op_23d8_11), 9176 }, /* MOVE */
{ CPUFUNC(op_23e0_11), 9184 }, /* MOVE */
{ CPUFUNC(op_23e8_11), 9192 }, /* MOVE */
{ CPUFUNC(op_23f0_11), 9200 }, /* MOVE */
{ CPUFUNC(op_23f8_11), 9208 }, /* MOVE */
{ CPUFUNC(op_23f9_11), 9209 }, /* MOVE */
{ CPUFUNC(op_23fa_11), 9210 }, /* MOVE */
{ CPUFUNC(op_23fb_11), 9211 }, /* MOVE */
{ CPUFUNC(op_23fc_11), 9212 }, /* MOVE */
{ CPUFUNC(op_3000_11), 12288 }, /* MOVE */
{ CPUFUNC(op_3008_11), 12296 }, /* MOVE */
{ CPUFUNC(op_3010_11), 12304 }, /* MOVE */
{ CPUFUNC(op_3018_11), 12312 }, /* MOVE */
{ CPUFUNC(op_3020_11), 12320 }, /* MOVE */
{ CPUFUNC(op_3028_11), 12328 }, /* MOVE */
{ CPUFUNC(op_3030_11), 12336 }, /* MOVE */
{ CPUFUNC(op_3038_11), 12344 }, /* MOVE */
{ CPUFUNC(op_3039_11), 12345 }, /* MOVE */
{ CPUFUNC(op_303a_11), 12346 }, /* MOVE */
{ CPUFUNC(op_303b_11), 12347 }, /* MOVE */
{ CPUFUNC(op_303c_11), 12348 }, /* MOVE */
{ CPUFUNC(op_3040_11), 12352 }, /* MOVEA */
{ CPUFUNC(op_3048_11), 12360 }, /* MOVEA */
{ CPUFUNC(op_3050_11), 12368 }, /* MOVEA */
{ CPUFUNC(op_3058_11), 12376 }, /* MOVEA */
{ CPUFUNC(op_3060_11), 12384 }, /* MOVEA */
{ CPUFUNC(op_3068_11), 12392 }, /* MOVEA */
{ CPUFUNC(op_3070_11), 12400 }, /* MOVEA */
{ CPUFUNC(op_3078_11), 12408 }, /* MOVEA */
{ CPUFUNC(op_3079_11), 12409 }, /* MOVEA */
{ CPUFUNC(op_307a_11), 12410 }, /* MOVEA */
{ CPUFUNC(op_307b_11), 12411 }, /* MOVEA */
{ CPUFUNC(op_307c_11), 12412 }, /* MOVEA */
{ CPUFUNC(op_3080_11), 12416 }, /* MOVE */
{ CPUFUNC(op_3088_11), 12424 }, /* MOVE */
{ CPUFUNC(op_3090_11), 12432 }, /* MOVE */
{ CPUFUNC(op_3098_11), 12440 }, /* MOVE */
{ CPUFUNC(op_30a0_11), 12448 }, /* MOVE */
{ CPUFUNC(op_30a8_11), 12456 }, /* MOVE */
{ CPUFUNC(op_30b0_11), 12464 }, /* MOVE */
{ CPUFUNC(op_30b8_11), 12472 }, /* MOVE */
{ CPUFUNC(op_30b9_11), 12473 }, /* MOVE */
{ CPUFUNC(op_30ba_11), 12474 }, /* MOVE */
{ CPUFUNC(op_30bb_11), 12475 }, /* MOVE */
{ CPUFUNC(op_30bc_11), 12476 }, /* MOVE */
{ CPUFUNC(op_30c0_11), 12480 }, /* MOVE */
{ CPUFUNC(op_30c8_11), 12488 }, /* MOVE */
{ CPUFUNC(op_30d0_11), 12496 }, /* MOVE */
{ CPUFUNC(op_30d8_11), 12504 }, /* MOVE */
{ CPUFUNC(op_30e0_11), 12512 }, /* MOVE */
{ CPUFUNC(op_30e8_11), 12520 }, /* MOVE */
{ CPUFUNC(op_30f0_11), 12528 }, /* MOVE */
{ CPUFUNC(op_30f8_11), 12536 }, /* MOVE */
{ CPUFUNC(op_30f9_11), 12537 }, /* MOVE */
{ CPUFUNC(op_30fa_11), 12538 }, /* MOVE */
{ CPUFUNC(op_30fb_11), 12539 }, /* MOVE */
{ CPUFUNC(op_30fc_11), 12540 }, /* MOVE */
{ CPUFUNC(op_3100_11), 12544 }, /* MOVE */
{ CPUFUNC(op_3108_11), 12552 }, /* MOVE */
{ CPUFUNC(op_3110_11), 12560 }, /* MOVE */
{ CPUFUNC(op_3118_11), 12568 }, /* MOVE */
{ CPUFUNC(op_3120_11), 12576 }, /* MOVE */
{ CPUFUNC(op_3128_11), 12584 }, /* MOVE */
{ CPUFUNC(op_3130_11), 12592 }, /* MOVE */
{ CPUFUNC(op_3138_11), 12600 }, /* MOVE */
{ CPUFUNC(op_3139_11), 12601 }, /* MOVE */
{ CPUFUNC(op_313a_11), 12602 }, /* MOVE */
{ CPUFUNC(op_313b_11), 12603 }, /* MOVE */
{ CPUFUNC(op_313c_11), 12604 }, /* MOVE */
{ CPUFUNC(op_3140_11), 12608 }, /* MOVE */
{ CPUFUNC(op_3148_11), 12616 }, /* MOVE */
{ CPUFUNC(op_3150_11), 12624 }, /* MOVE */
{ CPUFUNC(op_3158_11), 12632 }, /* MOVE */
{ CPUFUNC(op_3160_11), 12640 }, /* MOVE */
{ CPUFUNC(op_3168_11), 12648 }, /* MOVE */
{ CPUFUNC(op_3170_11), 12656 }, /* MOVE */
{ CPUFUNC(op_3178_11), 12664 }, /* MOVE */
{ CPUFUNC(op_3179_11), 12665 }, /* MOVE */
{ CPUFUNC(op_317a_11), 12666 }, /* MOVE */
{ CPUFUNC(op_317b_11), 12667 }, /* MOVE */
{ CPUFUNC(op_317c_11), 12668 }, /* MOVE */
{ CPUFUNC(op_3180_11), 12672 }, /* MOVE */
{ CPUFUNC(op_3188_11), 12680 }, /* MOVE */
{ CPUFUNC(op_3190_11), 12688 }, /* MOVE */
{ CPUFUNC(op_3198_11), 12696 }, /* MOVE */
{ CPUFUNC(op_31a0_11), 12704 }, /* MOVE */
{ CPUFUNC(op_31a8_11), 12712 }, /* MOVE */
{ CPUFUNC(op_31b0_11), 12720 }, /* MOVE */
{ CPUFUNC(op_31b8_11), 12728 }, /* MOVE */
{ CPUFUNC(op_31b9_11), 12729 }, /* MOVE */
{ CPUFUNC(op_31ba_11), 12730 }, /* MOVE */
{ CPUFUNC(op_31bb_11), 12731 }, /* MOVE */
{ CPUFUNC(op_31bc_11), 12732 }, /* MOVE */
{ CPUFUNC(op_31c0_11), 12736 }, /* MOVE */
{ CPUFUNC(op_31c8_11), 12744 }, /* MOVE */
{ CPUFUNC(op_31d0_11), 12752 }, /* MOVE */
{ CPUFUNC(op_31d8_11), 12760 }, /* MOVE */
{ CPUFUNC(op_31e0_11), 12768 }, /* MOVE */
{ CPUFUNC(op_31e8_11), 12776 }, /* MOVE */
{ CPUFUNC(op_31f0_11), 12784 }, /* MOVE */
{ CPUFUNC(op_31f8_11), 12792 }, /* MOVE */
{ CPUFUNC(op_31f9_11), 12793 }, /* MOVE */
{ CPUFUNC(op_31fa_11), 12794 }, /* MOVE */
{ CPUFUNC(op_31fb_11), 12795 }, /* MOVE */
{ CPUFUNC(op_31fc_11), 12796 }, /* MOVE */
{ CPUFUNC(op_33c0_11), 13248 }, /* MOVE */
{ CPUFUNC(op_33c8_11), 13256 }, /* MOVE */
{ CPUFUNC(op_33d0_11), 13264 }, /* MOVE */
{ CPUFUNC(op_33d8_11), 13272 }, /* MOVE */
{ CPUFUNC(op_33e0_11), 13280 }, /* MOVE */
{ CPUFUNC(op_33e8_11), 13288 }, /* MOVE */
{ CPUFUNC(op_33f0_11), 13296 }, /* MOVE */
{ CPUFUNC(op_33f8_11), 13304 }, /* MOVE */
{ CPUFUNC(op_33f9_11), 13305 }, /* MOVE */
{ CPUFUNC(op_33fa_11), 13306 }, /* MOVE */
{ CPUFUNC(op_33fb_11), 13307 }, /* MOVE */
{ CPUFUNC(op_33fc_11), 13308 }, /* MOVE */
{ CPUFUNC(op_4000_11), 16384 }, /* NEGX */
{ CPUFUNC(op_4010_11), 16400 }, /* NEGX */
{ CPUFUNC(op_4018_11), 16408 }, /* NEGX */
{ CPUFUNC(op_4020_11), 16416 }, /* NEGX */
{ CPUFUNC(op_4028_11), 16424 }, /* NEGX */
{ CPUFUNC(op_4030_11), 16432 }, /* NEGX */
{ CPUFUNC(op_4038_11), 16440 }, /* NEGX */
{ CPUFUNC(op_4039_11), 16441 }, /* NEGX */
{ CPUFUNC(op_4040_11), 16448 }, /* NEGX */
{ CPUFUNC(op_4050_11), 16464 }, /* NEGX */
{ CPUFUNC(op_4058_11), 16472 }, /* NEGX */
{ CPUFUNC(op_4060_11), 16480 }, /* NEGX */
{ CPUFUNC(op_4068_11), 16488 }, /* NEGX */
{ CPUFUNC(op_4070_11), 16496 }, /* NEGX */
{ CPUFUNC(op_4078_11), 16504 }, /* NEGX */
{ CPUFUNC(op_4079_11), 16505 }, /* NEGX */
{ CPUFUNC(op_4080_11), 16512 }, /* NEGX */
{ CPUFUNC(op_4090_11), 16528 }, /* NEGX */
{ CPUFUNC(op_4098_11), 16536 }, /* NEGX */
{ CPUFUNC(op_40a0_11), 16544 }, /* NEGX */
{ CPUFUNC(op_40a8_11), 16552 }, /* NEGX */
{ CPUFUNC(op_40b0_11), 16560 }, /* NEGX */
{ CPUFUNC(op_40b8_11), 16568 }, /* NEGX */
{ CPUFUNC(op_40b9_11), 16569 }, /* NEGX */
{ CPUFUNC(op_40c0_11), 16576 }, /* MVSR2 */
{ CPUFUNC(op_40d0_11), 16592 }, /* MVSR2 */
{ CPUFUNC(op_40d8_11), 16600 }, /* MVSR2 */
{ CPUFUNC(op_40e0_11), 16608 }, /* MVSR2 */
{ CPUFUNC(op_40e8_11), 16616 }, /* MVSR2 */
{ CPUFUNC(op_40f0_11), 16624 }, /* MVSR2 */
{ CPUFUNC(op_40f8_11), 16632 }, /* MVSR2 */
{ CPUFUNC(op_40f9_11), 16633 }, /* MVSR2 */
{ CPUFUNC(op_4180_11), 16768 }, /* CHK */
{ CPUFUNC(op_4190_11), 16784 }, /* CHK */
{ CPUFUNC(op_4198_11), 16792 }, /* CHK */
{ CPUFUNC(op_41a0_11), 16800 }, /* CHK */
{ CPUFUNC(op_41a8_11), 16808 }, /* CHK */
{ CPUFUNC(op_41b0_11), 16816 }, /* CHK */
{ CPUFUNC(op_41b8_11), 16824 }, /* CHK */
{ CPUFUNC(op_41b9_11), 16825 }, /* CHK */
{ CPUFUNC(op_41ba_11), 16826 }, /* CHK */
{ CPUFUNC(op_41bb_11), 16827 }, /* CHK */
{ CPUFUNC(op_41bc_11), 16828 }, /* CHK */
{ CPUFUNC(op_41d0_11), 16848 }, /* LEA */
{ CPUFUNC(op_41e8_11), 16872 }, /* LEA */
{ CPUFUNC(op_41f0_11), 16880 }, /* LEA */
{ CPUFUNC(op_41f8_11), 16888 }, /* LEA */
{ CPUFUNC(op_41f9_11), 16889 }, /* LEA */
{ CPUFUNC(op_41fa_11), 16890 }, /* LEA */
{ CPUFUNC(op_41fb_11), 16891 }, /* LEA */
{ CPUFUNC(op_4200_11), 16896 }, /* CLR */
{ CPUFUNC(op_4210_11), 16912 }, /* CLR */
{ CPUFUNC(op_4218_11), 16920 }, /* CLR */
{ CPUFUNC(op_4220_11), 16928 }, /* CLR */
{ CPUFUNC(op_4228_11), 16936 }, /* CLR */
{ CPUFUNC(op_4230_11), 16944 }, /* CLR */
{ CPUFUNC(op_4238_11), 16952 }, /* CLR */
{ CPUFUNC(op_4239_11), 16953 }, /* CLR */
{ CPUFUNC(op_4240_11), 16960 }, /* CLR */
{ CPUFUNC(op_4250_11), 16976 }, /* CLR */
{ CPUFUNC(op_4258_11), 16984 }, /* CLR */
{ CPUFUNC(op_4260_11), 16992 }, /* CLR */
{ CPUFUNC(op_4268_11), 17000 }, /* CLR */
{ CPUFUNC(op_4270_11), 17008 }, /* CLR */
{ CPUFUNC(op_4278_11), 17016 }, /* CLR */
{ CPUFUNC(op_4279_11), 17017 }, /* CLR */
{ CPUFUNC(op_4280_11), 17024 }, /* CLR */
{ CPUFUNC(op_4290_11), 17040 }, /* CLR */
{ CPUFUNC(op_4298_11), 17048 }, /* CLR */
{ CPUFUNC(op_42a0_11), 17056 }, /* CLR */
{ CPUFUNC(op_42a8_11), 17064 }, /* CLR */
{ CPUFUNC(op_42b0_11), 17072 }, /* CLR */
{ CPUFUNC(op_42b8_11), 17080 }, /* CLR */
{ CPUFUNC(op_42b9_11), 17081 }, /* CLR */
{ CPUFUNC(op_4400_11), 17408 }, /* NEG */
{ CPUFUNC(op_4410_11), 17424 }, /* NEG */
{ CPUFUNC(op_4418_11), 17432 }, /* NEG */
{ CPUFUNC(op_4420_11), 17440 }, /* NEG */
{ CPUFUNC(op_4428_11), 17448 }, /* NEG */
{ CPUFUNC(op_4430_11), 17456 }, /* NEG */
{ CPUFUNC(op_4438_11), 17464 }, /* NEG */
{ CPUFUNC(op_4439_11), 17465 }, /* NEG */
{ CPUFUNC(op_4440_11), 17472 }, /* NEG */
{ CPUFUNC(op_4450_11), 17488 }, /* NEG */
{ CPUFUNC(op_4458_11), 17496 }, /* NEG */
{ CPUFUNC(op_4460_11), 17504 }, /* NEG */
{ CPUFUNC(op_4468_11), 17512 }, /* NEG */
{ CPUFUNC(op_4470_11), 17520 }, /* NEG */
{ CPUFUNC(op_4478_11), 17528 }, /* NEG */
{ CPUFUNC(op_4479_11), 17529 }, /* NEG */
{ CPUFUNC(op_4480_11), 17536 }, /* NEG */
{ CPUFUNC(op_4490_11), 17552 }, /* NEG */
{ CPUFUNC(op_4498_11), 17560 }, /* NEG */
{ CPUFUNC(op_44a0_11), 17568 }, /* NEG */
{ CPUFUNC(op_44a8_11), 17576 }, /* NEG */
{ CPUFUNC(op_44b0_11), 17584 }, /* NEG */
{ CPUFUNC(op_44b8_11), 17592 }, /* NEG */
{ CPUFUNC(op_44b9_11), 17593 }, /* NEG */
{ CPUFUNC(op_44c0_11), 17600 }, /* MV2SR */
{ CPUFUNC(op_44d0_11), 17616 }, /* MV2SR */
{ CPUFUNC(op_44d8_11), 17624 }, /* MV2SR */
{ CPUFUNC(op_44e0_11), 17632 }, /* MV2SR */
{ CPUFUNC(op_44e8_11), 17640 }, /* MV2SR */
{ CPUFUNC(op_44f0_11), 17648 }, /* MV2SR */
{ CPUFUNC(op_44f8_11), 17656 }, /* MV2SR */
{ CPUFUNC(op_44f9_11), 17657 }, /* MV2SR */
{ CPUFUNC(op_44fa_11), 17658 }, /* MV2SR */
{ CPUFUNC(op_44fb_11), 17659 }, /* MV2SR */
{ CPUFUNC(op_44fc_11), 17660 }, /* MV2SR */
{ CPUFUNC(op_4600_11), 17920 }, /* NOT */
{ CPUFUNC(op_4610_11), 17936 }, /* NOT */
{ CPUFUNC(op_4618_11), 17944 }, /* NOT */
{ CPUFUNC(op_4620_11), 17952 }, /* NOT */
{ CPUFUNC(op_4628_11), 17960 }, /* NOT */
{ CPUFUNC(op_4630_11), 17968 }, /* NOT */
{ CPUFUNC(op_4638_11), 17976 }, /* NOT */
{ CPUFUNC(op_4639_11), 17977 }, /* NOT */
{ CPUFUNC(op_4640_11), 17984 }, /* NOT */
{ CPUFUNC(op_4650_11), 18000 }, /* NOT */
{ CPUFUNC(op_4658_11), 18008 }, /* NOT */
{ CPUFUNC(op_4660_11), 18016 }, /* NOT */
{ CPUFUNC(op_4668_11), 18024 }, /* NOT */
{ CPUFUNC(op_4670_11), 18032 }, /* NOT */
{ CPUFUNC(op_4678_11), 18040 }, /* NOT */
{ CPUFUNC(op_4679_11), 18041 }, /* NOT */
{ CPUFUNC(op_4680_11), 18048 }, /* NOT */
{ CPUFUNC(op_4690_11), 18064 }, /* NOT */
{ CPUFUNC(op_4698_11), 18072 }, /* NOT */
{ CPUFUNC(op_46a0_11), 18080 }, /* NOT */
{ CPUFUNC(op_46a8_11), 18088 }, /* NOT */
{ CPUFUNC(op_46b0_11), 18096 }, /* NOT */
{ CPUFUNC(op_46b8_11), 18104 }, /* NOT */
{ CPUFUNC(op_46b9_11), 18105 }, /* NOT */
{ CPUFUNC(op_46c0_11), 18112 }, /* MV2SR */
{ CPUFUNC(op_46d0_11), 18128 }, /* MV2SR */
{ CPUFUNC(op_46d8_11), 18136 }, /* MV2SR */
{ CPUFUNC(op_46e0_11), 18144 }, /* MV2SR */
{ CPUFUNC(op_46e8_11), 18152 }, /* MV2SR */
{ CPUFUNC(op_46f0_11), 18160 }, /* MV2SR */
{ CPUFUNC(op_46f8_11), 18168 }, /* MV2SR */
{ CPUFUNC(op_46f9_11), 18169 }, /* MV2SR */
{ CPUFUNC(op_46fa_11), 18170 }, /* MV2SR */
{ CPUFUNC(op_46fb_11), 18171 }, /* MV2SR */
{ CPUFUNC(op_46fc_11), 18172 }, /* MV2SR */
{ CPUFUNC(op_4800_11), 18432 }, /* NBCD */
{ CPUFUNC(op_4810_11), 18448 }, /* NBCD */
{ CPUFUNC(op_4818_11), 18456 }, /* NBCD */
{ CPUFUNC(op_4820_11), 18464 }, /* NBCD */
{ CPUFUNC(op_4828_11), 18472 }, /* NBCD */
{ CPUFUNC(op_4830_11), 18480 }, /* NBCD */
{ CPUFUNC(op_4838_11), 18488 }, /* NBCD */
{ CPUFUNC(op_4839_11), 18489 }, /* NBCD */
{ CPUFUNC(op_4840_11), 18496 }, /* SWAP */
{ CPUFUNC(op_4850_11), 18512 }, /* PEA */
{ CPUFUNC(op_4868_11), 18536 }, /* PEA */
{ CPUFUNC(op_4870_11), 18544 }, /* PEA */
{ CPUFUNC(op_4878_11), 18552 }, /* PEA */
{ CPUFUNC(op_4879_11), 18553 }, /* PEA */
{ CPUFUNC(op_487a_11), 18554 }, /* PEA */
{ CPUFUNC(op_487b_11), 18555 }, /* PEA */
{ CPUFUNC(op_4880_11), 18560 }, /* EXT */
{ CPUFUNC(op_4890_11), 18576 }, /* MVMLE */
{ CPUFUNC(op_48a0_11), 18592 }, /* MVMLE */
{ CPUFUNC(op_48a8_11), 18600 }, /* MVMLE */
{ CPUFUNC(op_48b0_11), 18608 }, /* MVMLE */
{ CPUFUNC(op_48b8_11), 18616 }, /* MVMLE */
{ CPUFUNC(op_48b9_11), 18617 }, /* MVMLE */
{ CPUFUNC(op_48c0_11), 18624 }, /* EXT */
{ CPUFUNC(op_48d0_11), 18640 }, /* MVMLE */
{ CPUFUNC(op_48e0_11), 18656 }, /* MVMLE */
{ CPUFUNC(op_48e8_11), 18664 }, /* MVMLE */
{ CPUFUNC(op_48f0_11), 18672 }, /* MVMLE */
{ CPUFUNC(op_48f8_11), 18680 }, /* MVMLE */
{ CPUFUNC(op_48f9_11), 18681 }, /* MVMLE */
{ CPUFUNC(op_4a00_11), 18944 }, /* TST */
{ CPUFUNC(op_4a10_11), 18960 }, /* TST */
{ CPUFUNC(op_4a18_11), 18968 }, /* TST */
{ CPUFUNC(op_4a20_11), 18976 }, /* TST */
{ CPUFUNC(op_4a28_11), 18984 }, /* TST */
{ CPUFUNC(op_4a30_11), 18992 }, /* TST */
{ CPUFUNC(op_4a38_11), 19000 }, /* TST */
{ CPUFUNC(op_4a39_11), 19001 }, /* TST */
{ CPUFUNC(op_4a40_11), 19008 }, /* TST */
{ CPUFUNC(op_4a50_11), 19024 }, /* TST */
{ CPUFUNC(op_4a58_11), 19032 }, /* TST */
{ CPUFUNC(op_4a60_11), 19040 }, /* TST */
{ CPUFUNC(op_4a68_11), 19048 }, /* TST */
{ CPUFUNC(op_4a70_11), 19056 }, /* TST */
{ CPUFUNC(op_4a78_11), 19064 }, /* TST */
{ CPUFUNC(op_4a79_11), 19065 }, /* TST */
{ CPUFUNC(op_4a80_11), 19072 }, /* TST */
{ CPUFUNC(op_4a90_11), 19088 }, /* TST */
{ CPUFUNC(op_4a98_11), 19096 }, /* TST */
{ CPUFUNC(op_4aa0_11), 19104 }, /* TST */
{ CPUFUNC(op_4aa8_11), 19112 }, /* TST */
{ CPUFUNC(op_4ab0_11), 19120 }, /* TST */
{ CPUFUNC(op_4ab8_11), 19128 }, /* TST */
{ CPUFUNC(op_4ab9_11), 19129 }, /* TST */
{ CPUFUNC(op_4ac0_11), 19136 }, /* TAS */
{ CPUFUNC(op_4ad0_11), 19152 }, /* TAS */
{ CPUFUNC(op_4ad8_11), 19160 }, /* TAS */
{ CPUFUNC(op_4ae0_11), 19168 }, /* TAS */
{ CPUFUNC(op_4ae8_11), 19176 }, /* TAS */
{ CPUFUNC(op_4af0_11), 19184 }, /* TAS */
{ CPUFUNC(op_4af8_11), 19192 }, /* TAS */
{ CPUFUNC(op_4af9_11), 19193 }, /* TAS */
{ CPUFUNC(op_4c90_11), 19600 }, /* MVMEL */
{ CPUFUNC(op_4c98_11), 19608 }, /* MVMEL */
{ CPUFUNC(op_4ca8_11), 19624 }, /* MVMEL */
{ CPUFUNC(op_4cb0_11), 19632 }, /* MVMEL */
{ CPUFUNC(op_4cb8_11), 19640 }, /* MVMEL */
{ CPUFUNC(op_4cb9_11), 19641 }, /* MVMEL */
{ CPUFUNC(op_4cba_11), 19642 }, /* MVMEL */
{ CPUFUNC(op_4cbb_11), 19643 }, /* MVMEL */
{ CPUFUNC(op_4cd0_11), 19664 }, /* MVMEL */
{ CPUFUNC(op_4cd8_11), 19672 }, /* MVMEL */
{ CPUFUNC(op_4ce8_11), 19688 }, /* MVMEL */
{ CPUFUNC(op_4cf0_11), 19696 }, /* MVMEL */
{ CPUFUNC(op_4cf8_11), 19704 }, /* MVMEL */
{ CPUFUNC(op_4cf9_11), 19705 }, /* MVMEL */
{ CPUFUNC(op_4cfa_11), 19706 }, /* MVMEL */
{ CPUFUNC(op_4cfb_11), 19707 }, /* MVMEL */
{ CPUFUNC(op_4e40_11), 20032 }, /* TRAP */
{ CPUFUNC(op_4e50_11), 20048 }, /* LINK */
{ CPUFUNC(op_4e58_11), 20056 }, /* UNLK */
{ CPUFUNC(op_4e60_11), 20064 }, /* MVR2USP */
{ CPUFUNC(op_4e68_11), 20072 }, /* MVUSP2R */
{ CPUFUNC(op_4e70_11), 20080 }, /* RESET */
{ CPUFUNC(op_4e71_11), 20081 }, /* NOP */
{ CPUFUNC(op_4e72_11), 20082 }, /* STOP */
{ CPUFUNC(op_4e73_11), 20083 }, /* RTE */
{ CPUFUNC(op_4e74_11), 20084 }, /* RTD */
{ CPUFUNC(op_4e75_11), 20085 }, /* RTS */
{ CPUFUNC(op_4e76_11), 20086 }, /* TRAPV */
{ CPUFUNC(op_4e77_11), 20087 }, /* RTR */
{ CPUFUNC(op_4e90_11), 20112 }, /* JSR */
{ CPUFUNC(op_4ea8_11), 20136 }, /* JSR */
{ CPUFUNC(op_4eb0_11), 20144 }, /* JSR */
{ CPUFUNC(op_4eb8_11), 20152 }, /* JSR */
{ CPUFUNC(op_4eb9_11), 20153 }, /* JSR */
{ CPUFUNC(op_4eba_11), 20154 }, /* JSR */
{ CPUFUNC(op_4ebb_11), 20155 }, /* JSR */
{ CPUFUNC(op_4ed0_11), 20176 }, /* JMP */
{ CPUFUNC(op_4ee8_11), 20200 }, /* JMP */
{ CPUFUNC(op_4ef0_11), 20208 }, /* JMP */
{ CPUFUNC(op_4ef8_11), 20216 }, /* JMP */
{ CPUFUNC(op_4ef9_11), 20217 }, /* JMP */
{ CPUFUNC(op_4efa_11), 20218 }, /* JMP */
{ CPUFUNC(op_4efb_11), 20219 }, /* JMP */
{ CPUFUNC(op_5000_11), 20480 }, /* ADD */
{ CPUFUNC(op_5010_11), 20496 }, /* ADD */
{ CPUFUNC(op_5018_11), 20504 }, /* ADD */
{ CPUFUNC(op_5020_11), 20512 }, /* ADD */
{ CPUFUNC(op_5028_11), 20520 }, /* ADD */
{ CPUFUNC(op_5030_11), 20528 }, /* ADD */
{ CPUFUNC(op_5038_11), 20536 }, /* ADD */
{ CPUFUNC(op_5039_11), 20537 }, /* ADD */
{ CPUFUNC(op_5040_11), 20544 }, /* ADD */
{ CPUFUNC(op_5048_11), 20552 }, /* ADDA */
{ CPUFUNC(op_5050_11), 20560 }, /* ADD */
{ CPUFUNC(op_5058_11), 20568 }, /* ADD */
{ CPUFUNC(op_5060_11), 20576 }, /* ADD */
{ CPUFUNC(op_5068_11), 20584 }, /* ADD */
{ CPUFUNC(op_5070_11), 20592 }, /* ADD */
{ CPUFUNC(op_5078_11), 20600 }, /* ADD */
{ CPUFUNC(op_5079_11), 20601 }, /* ADD */
{ CPUFUNC(op_5080_11), 20608 }, /* ADD */
{ CPUFUNC(op_5088_11), 20616 }, /* ADDA */
{ CPUFUNC(op_5090_11), 20624 }, /* ADD */
{ CPUFUNC(op_5098_11), 20632 }, /* ADD */
{ CPUFUNC(op_50a0_11), 20640 }, /* ADD */
{ CPUFUNC(op_50a8_11), 20648 }, /* ADD */
{ CPUFUNC(op_50b0_11), 20656 }, /* ADD */
{ CPUFUNC(op_50b8_11), 20664 }, /* ADD */
{ CPUFUNC(op_50b9_11), 20665 }, /* ADD */
{ CPUFUNC(op_50c0_11), 20672 }, /* Scc */
{ CPUFUNC(op_50c8_11), 20680 }, /* DBcc */
{ CPUFUNC(op_50d0_11), 20688 }, /* Scc */
{ CPUFUNC(op_50d8_11), 20696 }, /* Scc */
{ CPUFUNC(op_50e0_11), 20704 }, /* Scc */
{ CPUFUNC(op_50e8_11), 20712 }, /* Scc */
{ CPUFUNC(op_50f0_11), 20720 }, /* Scc */
{ CPUFUNC(op_50f8_11), 20728 }, /* Scc */
{ CPUFUNC(op_50f9_11), 20729 }, /* Scc */
{ CPUFUNC(op_5100_11), 20736 }, /* SUB */
{ CPUFUNC(op_5110_11), 20752 }, /* SUB */
{ CPUFUNC(op_5118_11), 20760 }, /* SUB */
{ CPUFUNC(op_5120_11), 20768 }, /* SUB */
{ CPUFUNC(op_5128_11), 20776 }, /* SUB */
{ CPUFUNC(op_5130_11), 20784 }, /* SUB */
{ CPUFUNC(op_5138_11), 20792 }, /* SUB */
{ CPUFUNC(op_5139_11), 20793 }, /* SUB */
{ CPUFUNC(op_5140_11), 20800 }, /* SUB */
{ CPUFUNC(op_5148_11), 20808 }, /* SUBA */
{ CPUFUNC(op_5150_11), 20816 }, /* SUB */
{ CPUFUNC(op_5158_11), 20824 }, /* SUB */
{ CPUFUNC(op_5160_11), 20832 }, /* SUB */
{ CPUFUNC(op_5168_11), 20840 }, /* SUB */
{ CPUFUNC(op_5170_11), 20848 }, /* SUB */
{ CPUFUNC(op_5178_11), 20856 }, /* SUB */
{ CPUFUNC(op_5179_11), 20857 }, /* SUB */
{ CPUFUNC(op_5180_11), 20864 }, /* SUB */
{ CPUFUNC(op_5188_11), 20872 }, /* SUBA */
{ CPUFUNC(op_5190_11), 20880 }, /* SUB */
{ CPUFUNC(op_5198_11), 20888 }, /* SUB */
{ CPUFUNC(op_51a0_11), 20896 }, /* SUB */
{ CPUFUNC(op_51a8_11), 20904 }, /* SUB */
{ CPUFUNC(op_51b0_11), 20912 }, /* SUB */
{ CPUFUNC(op_51b8_11), 20920 }, /* SUB */
{ CPUFUNC(op_51b9_11), 20921 }, /* SUB */
{ CPUFUNC(op_51c0_11), 20928 }, /* Scc */
{ CPUFUNC(op_51c8_11), 20936 }, /* DBcc */
{ CPUFUNC(op_51d0_11), 20944 }, /* Scc */
{ CPUFUNC(op_51d8_11), 20952 }, /* Scc */
{ CPUFUNC(op_51e0_11), 20960 }, /* Scc */
{ CPUFUNC(op_51e8_11), 20968 }, /* Scc */
{ CPUFUNC(op_51f0_11), 20976 }, /* Scc */
{ CPUFUNC(op_51f8_11), 20984 }, /* Scc */
{ CPUFUNC(op_51f9_11), 20985 }, /* Scc */
{ CPUFUNC(op_52c0_11), 21184 }, /* Scc */
{ CPUFUNC(op_52c8_11), 21192 }, /* DBcc */
{ CPUFUNC(op_52d0_11), 21200 }, /* Scc */
{ CPUFUNC(op_52d8_11), 21208 }, /* Scc */
{ CPUFUNC(op_52e0_11), 21216 }, /* Scc */
{ CPUFUNC(op_52e8_11), 21224 }, /* Scc */
{ CPUFUNC(op_52f0_11), 21232 }, /* Scc */
{ CPUFUNC(op_52f8_11), 21240 }, /* Scc */
{ CPUFUNC(op_52f9_11), 21241 }, /* Scc */
{ CPUFUNC(op_53c0_11), 21440 }, /* Scc */
{ CPUFUNC(op_53c8_11), 21448 }, /* DBcc */
{ CPUFUNC(op_53d0_11), 21456 }, /* Scc */
{ CPUFUNC(op_53d8_11), 21464 }, /* Scc */
{ CPUFUNC(op_53e0_11), 21472 }, /* Scc */
{ CPUFUNC(op_53e8_11), 21480 }, /* Scc */
{ CPUFUNC(op_53f0_11), 21488 }, /* Scc */
{ CPUFUNC(op_53f8_11), 21496 }, /* Scc */
{ CPUFUNC(op_53f9_11), 21497 }, /* Scc */
{ CPUFUNC(op_54c0_11), 21696 }, /* Scc */
{ CPUFUNC(op_54c8_11), 21704 }, /* DBcc */
{ CPUFUNC(op_54d0_11), 21712 }, /* Scc */
{ CPUFUNC(op_54d8_11), 21720 }, /* Scc */
{ CPUFUNC(op_54e0_11), 21728 }, /* Scc */
{ CPUFUNC(op_54e8_11), 21736 }, /* Scc */
{ CPUFUNC(op_54f0_11), 21744 }, /* Scc */
{ CPUFUNC(op_54f8_11), 21752 }, /* Scc */
{ CPUFUNC(op_54f9_11), 21753 }, /* Scc */
{ CPUFUNC(op_55c0_11), 21952 }, /* Scc */
{ CPUFUNC(op_55c8_11), 21960 }, /* DBcc */
{ CPUFUNC(op_55d0_11), 21968 }, /* Scc */
{ CPUFUNC(op_55d8_11), 21976 }, /* Scc */
{ CPUFUNC(op_55e0_11), 21984 }, /* Scc */
{ CPUFUNC(op_55e8_11), 21992 }, /* Scc */
{ CPUFUNC(op_55f0_11), 22000 }, /* Scc */
{ CPUFUNC(op_55f8_11), 22008 }, /* Scc */
{ CPUFUNC(op_55f9_11), 22009 }, /* Scc */
{ CPUFUNC(op_56c0_11), 22208 }, /* Scc */
{ CPUFUNC(op_56c8_11), 22216 }, /* DBcc */
{ CPUFUNC(op_56d0_11), 22224 }, /* Scc */
{ CPUFUNC(op_56d8_11), 22232 }, /* Scc */
{ CPUFUNC(op_56e0_11), 22240 }, /* Scc */
{ CPUFUNC(op_56e8_11), 22248 }, /* Scc */
{ CPUFUNC(op_56f0_11), 22256 }, /* Scc */
{ CPUFUNC(op_56f8_11), 22264 }, /* Scc */
{ CPUFUNC(op_56f9_11), 22265 }, /* Scc */
{ CPUFUNC(op_57c0_11), 22464 }, /* Scc */
{ CPUFUNC(op_57c8_11), 22472 }, /* DBcc */
{ CPUFUNC(op_57d0_11), 22480 }, /* Scc */
{ CPUFUNC(op_57d8_11), 22488 }, /* Scc */
{ CPUFUNC(op_57e0_11), 22496 }, /* Scc */
{ CPUFUNC(op_57e8_11), 22504 }, /* Scc */
{ CPUFUNC(op_57f0_11), 22512 }, /* Scc */
{ CPUFUNC(op_57f8_11), 22520 }, /* Scc */
{ CPUFUNC(op_57f9_11), 22521 }, /* Scc */
{ CPUFUNC(op_58c0_11), 22720 }, /* Scc */
{ CPUFUNC(op_58c8_11), 22728 }, /* DBcc */
{ CPUFUNC(op_58d0_11), 22736 }, /* Scc */
{ CPUFUNC(op_58d8_11), 22744 }, /* Scc */
{ CPUFUNC(op_58e0_11), 22752 }, /* Scc */
{ CPUFUNC(op_58e8_11), 22760 }, /* Scc */
{ CPUFUNC(op_58f0_11), 22768 }, /* Scc */
{ CPUFUNC(op_58f8_11), 22776 }, /* Scc */
{ CPUFUNC(op_58f9_11), 22777 }, /* Scc */
{ CPUFUNC(op_59c0_11), 22976 }, /* Scc */
{ CPUFUNC(op_59c8_11), 22984 }, /* DBcc */
{ CPUFUNC(op_59d0_11), 22992 }, /* Scc */
{ CPUFUNC(op_59d8_11), 23000 }, /* Scc */
{ CPUFUNC(op_59e0_11), 23008 }, /* Scc */
{ CPUFUNC(op_59e8_11), 23016 }, /* Scc */
{ CPUFUNC(op_59f0_11), 23024 }, /* Scc */
{ CPUFUNC(op_59f8_11), 23032 }, /* Scc */
{ CPUFUNC(op_59f9_11), 23033 }, /* Scc */
{ CPUFUNC(op_5ac0_11), 23232 }, /* Scc */
{ CPUFUNC(op_5ac8_11), 23240 }, /* DBcc */
{ CPUFUNC(op_5ad0_11), 23248 }, /* Scc */
{ CPUFUNC(op_5ad8_11), 23256 }, /* Scc */
{ CPUFUNC(op_5ae0_11), 23264 }, /* Scc */
{ CPUFUNC(op_5ae8_11), 23272 }, /* Scc */
{ CPUFUNC(op_5af0_11), 23280 }, /* Scc */
{ CPUFUNC(op_5af8_11), 23288 }, /* Scc */
{ CPUFUNC(op_5af9_11), 23289 }, /* Scc */
{ CPUFUNC(op_5bc0_11), 23488 }, /* Scc */
{ CPUFUNC(op_5bc8_11), 23496 }, /* DBcc */
{ CPUFUNC(op_5bd0_11), 23504 }, /* Scc */
{ CPUFUNC(op_5bd8_11), 23512 }, /* Scc */
{ CPUFUNC(op_5be0_11), 23520 }, /* Scc */
{ CPUFUNC(op_5be8_11), 23528 }, /* Scc */
{ CPUFUNC(op_5bf0_11), 23536 }, /* Scc */
{ CPUFUNC(op_5bf8_11), 23544 }, /* Scc */
{ CPUFUNC(op_5bf9_11), 23545 }, /* Scc */
{ CPUFUNC(op_5cc0_11), 23744 }, /* Scc */
{ CPUFUNC(op_5cc8_11), 23752 }, /* DBcc */
{ CPUFUNC(op_5cd0_11), 23760 }, /* Scc */
{ CPUFUNC(op_5cd8_11), 23768 }, /* Scc */
{ CPUFUNC(op_5ce0_11), 23776 }, /* Scc */
{ CPUFUNC(op_5ce8_11), 23784 }, /* Scc */
{ CPUFUNC(op_5cf0_11), 23792 }, /* Scc */
{ CPUFUNC(op_5cf8_11), 23800 }, /* Scc */
{ CPUFUNC(op_5cf9_11), 23801 }, /* Scc */
{ CPUFUNC(op_5dc0_11), 24000 }, /* Scc */
{ CPUFUNC(op_5dc8_11), 24008 }, /* DBcc */
{ CPUFUNC(op_5dd0_11), 24016 }, /* Scc */
{ CPUFUNC(op_5dd8_11), 24024 }, /* Scc */
{ CPUFUNC(op_5de0_11), 24032 }, /* Scc */
{ CPUFUNC(op_5de8_11), 24040 }, /* Scc */
{ CPUFUNC(op_5df0_11), 24048 }, /* Scc */
{ CPUFUNC(op_5df8_11), 24056 }, /* Scc */
{ CPUFUNC(op_5df9_11), 24057 }, /* Scc */
{ CPUFUNC(op_5ec0_11), 24256 }, /* Scc */
{ CPUFUNC(op_5ec8_11), 24264 }, /* DBcc */
{ CPUFUNC(op_5ed0_11), 24272 }, /* Scc */
{ CPUFUNC(op_5ed8_11), 24280 }, /* Scc */
{ CPUFUNC(op_5ee0_11), 24288 }, /* Scc */
{ CPUFUNC(op_5ee8_11), 24296 }, /* Scc */
{ CPUFUNC(op_5ef0_11), 24304 }, /* Scc */
{ CPUFUNC(op_5ef8_11), 24312 }, /* Scc */
{ CPUFUNC(op_5ef9_11), 24313 }, /* Scc */
{ CPUFUNC(op_5fc0_11), 24512 }, /* Scc */
{ CPUFUNC(op_5fc8_11), 24520 }, /* DBcc */
{ CPUFUNC(op_5fd0_11), 24528 }, /* Scc */
{ CPUFUNC(op_5fd8_11), 24536 }, /* Scc */
{ CPUFUNC(op_5fe0_11), 24544 }, /* Scc */
{ CPUFUNC(op_5fe8_11), 24552 }, /* Scc */
{ CPUFUNC(op_5ff0_11), 24560 }, /* Scc */
{ CPUFUNC(op_5ff8_11), 24568 }, /* Scc */
{ CPUFUNC(op_5ff9_11), 24569 }, /* Scc */
{ CPUFUNC(op_6000_11), 24576 }, /* Bcc */
{ CPUFUNC(op_6001_11), 24577 }, /* Bcc */
{ CPUFUNC(op_60ff_11), 24831 }, /* Bcc */
{ CPUFUNC(op_6100_11), 24832 }, /* BSR */
{ CPUFUNC(op_6101_11), 24833 }, /* BSR */
{ CPUFUNC(op_61ff_11), 25087 }, /* BSR */
{ CPUFUNC(op_6200_11), 25088 }, /* Bcc */
{ CPUFUNC(op_6201_11), 25089 }, /* Bcc */
{ CPUFUNC(op_62ff_11), 25343 }, /* Bcc */
{ CPUFUNC(op_6300_11), 25344 }, /* Bcc */
{ CPUFUNC(op_6301_11), 25345 }, /* Bcc */
{ CPUFUNC(op_63ff_11), 25599 }, /* Bcc */
{ CPUFUNC(op_6400_11), 25600 }, /* Bcc */
{ CPUFUNC(op_6401_11), 25601 }, /* Bcc */
{ CPUFUNC(op_64ff_11), 25855 }, /* Bcc */
{ CPUFUNC(op_6500_11), 25856 }, /* Bcc */
{ CPUFUNC(op_6501_11), 25857 }, /* Bcc */
{ CPUFUNC(op_65ff_11), 26111 }, /* Bcc */
{ CPUFUNC(op_6600_11), 26112 }, /* Bcc */
{ CPUFUNC(op_6601_11), 26113 }, /* Bcc */
{ CPUFUNC(op_66ff_11), 26367 }, /* Bcc */
{ CPUFUNC(op_6700_11), 26368 }, /* Bcc */
{ CPUFUNC(op_6701_11), 26369 }, /* Bcc */
{ CPUFUNC(op_67ff_11), 26623 }, /* Bcc */
{ CPUFUNC(op_6800_11), 26624 }, /* Bcc */
{ CPUFUNC(op_6801_11), 26625 }, /* Bcc */
{ CPUFUNC(op_68ff_11), 26879 }, /* Bcc */
{ CPUFUNC(op_6900_11), 26880 }, /* Bcc */
{ CPUFUNC(op_6901_11), 26881 }, /* Bcc */
{ CPUFUNC(op_69ff_11), 27135 }, /* Bcc */
{ CPUFUNC(op_6a00_11), 27136 }, /* Bcc */
{ CPUFUNC(op_6a01_11), 27137 }, /* Bcc */
{ CPUFUNC(op_6aff_11), 27391 }, /* Bcc */
{ CPUFUNC(op_6b00_11), 27392 }, /* Bcc */
{ CPUFUNC(op_6b01_11), 27393 }, /* Bcc */
{ CPUFUNC(op_6bff_11), 27647 }, /* Bcc */
{ CPUFUNC(op_6c00_11), 27648 }, /* Bcc */
{ CPUFUNC(op_6c01_11), 27649 }, /* Bcc */
{ CPUFUNC(op_6cff_11), 27903 }, /* Bcc */
{ CPUFUNC(op_6d00_11), 27904 }, /* Bcc */
{ CPUFUNC(op_6d01_11), 27905 }, /* Bcc */
{ CPUFUNC(op_6dff_11), 28159 }, /* Bcc */
{ CPUFUNC(op_6e00_11), 28160 }, /* Bcc */
{ CPUFUNC(op_6e01_11), 28161 }, /* Bcc */
{ CPUFUNC(op_6eff_11), 28415 }, /* Bcc */
{ CPUFUNC(op_6f00_11), 28416 }, /* Bcc */
{ CPUFUNC(op_6f01_11), 28417 }, /* Bcc */
{ CPUFUNC(op_6fff_11), 28671 }, /* Bcc */
{ CPUFUNC(op_7000_11), 28672 }, /* MOVE */
{ CPUFUNC(op_8000_11), 32768 }, /* OR */
{ CPUFUNC(op_8010_11), 32784 }, /* OR */
{ CPUFUNC(op_8018_11), 32792 }, /* OR */
{ CPUFUNC(op_8020_11), 32800 }, /* OR */
{ CPUFUNC(op_8028_11), 32808 }, /* OR */
{ CPUFUNC(op_8030_11), 32816 }, /* OR */
{ CPUFUNC(op_8038_11), 32824 }, /* OR */
{ CPUFUNC(op_8039_11), 32825 }, /* OR */
{ CPUFUNC(op_803a_11), 32826 }, /* OR */
{ CPUFUNC(op_803b_11), 32827 }, /* OR */
{ CPUFUNC(op_803c_11), 32828 }, /* OR */
{ CPUFUNC(op_8040_11), 32832 }, /* OR */
{ CPUFUNC(op_8050_11), 32848 }, /* OR */
{ CPUFUNC(op_8058_11), 32856 }, /* OR */
{ CPUFUNC(op_8060_11), 32864 }, /* OR */
{ CPUFUNC(op_8068_11), 32872 }, /* OR */
{ CPUFUNC(op_8070_11), 32880 }, /* OR */
{ CPUFUNC(op_8078_11), 32888 }, /* OR */
{ CPUFUNC(op_8079_11), 32889 }, /* OR */
{ CPUFUNC(op_807a_11), 32890 }, /* OR */
{ CPUFUNC(op_807b_11), 32891 }, /* OR */
{ CPUFUNC(op_807c_11), 32892 }, /* OR */
{ CPUFUNC(op_8080_11), 32896 }, /* OR */
{ CPUFUNC(op_8090_11), 32912 }, /* OR */
{ CPUFUNC(op_8098_11), 32920 }, /* OR */
{ CPUFUNC(op_80a0_11), 32928 }, /* OR */
{ CPUFUNC(op_80a8_11), 32936 }, /* OR */
{ CPUFUNC(op_80b0_11), 32944 }, /* OR */
{ CPUFUNC(op_80b8_11), 32952 }, /* OR */
{ CPUFUNC(op_80b9_11), 32953 }, /* OR */
{ CPUFUNC(op_80ba_11), 32954 }, /* OR */
{ CPUFUNC(op_80bb_11), 32955 }, /* OR */
{ CPUFUNC(op_80bc_11), 32956 }, /* OR */
{ CPUFUNC(op_80c0_11), 32960 }, /* DIVU */
{ CPUFUNC(op_80d0_11), 32976 }, /* DIVU */
{ CPUFUNC(op_80d8_11), 32984 }, /* DIVU */
{ CPUFUNC(op_80e0_11), 32992 }, /* DIVU */
{ CPUFUNC(op_80e8_11), 33000 }, /* DIVU */
{ CPUFUNC(op_80f0_11), 33008 }, /* DIVU */
{ CPUFUNC(op_80f8_11), 33016 }, /* DIVU */
{ CPUFUNC(op_80f9_11), 33017 }, /* DIVU */
{ CPUFUNC(op_80fa_11), 33018 }, /* DIVU */
{ CPUFUNC(op_80fb_11), 33019 }, /* DIVU */
{ CPUFUNC(op_80fc_11), 33020 }, /* DIVU */
{ CPUFUNC(op_8100_11), 33024 }, /* SBCD */
{ CPUFUNC(op_8108_11), 33032 }, /* SBCD */
{ CPUFUNC(op_8110_11), 33040 }, /* OR */
{ CPUFUNC(op_8118_11), 33048 }, /* OR */
{ CPUFUNC(op_8120_11), 33056 }, /* OR */
{ CPUFUNC(op_8128_11), 33064 }, /* OR */
{ CPUFUNC(op_8130_11), 33072 }, /* OR */
{ CPUFUNC(op_8138_11), 33080 }, /* OR */
{ CPUFUNC(op_8139_11), 33081 }, /* OR */
{ CPUFUNC(op_8150_11), 33104 }, /* OR */
{ CPUFUNC(op_8158_11), 33112 }, /* OR */
{ CPUFUNC(op_8160_11), 33120 }, /* OR */
{ CPUFUNC(op_8168_11), 33128 }, /* OR */
{ CPUFUNC(op_8170_11), 33136 }, /* OR */
{ CPUFUNC(op_8178_11), 33144 }, /* OR */
{ CPUFUNC(op_8179_11), 33145 }, /* OR */
{ CPUFUNC(op_8190_11), 33168 }, /* OR */
{ CPUFUNC(op_8198_11), 33176 }, /* OR */
{ CPUFUNC(op_81a0_11), 33184 }, /* OR */
{ CPUFUNC(op_81a8_11), 33192 }, /* OR */
{ CPUFUNC(op_81b0_11), 33200 }, /* OR */
{ CPUFUNC(op_81b8_11), 33208 }, /* OR */
{ CPUFUNC(op_81b9_11), 33209 }, /* OR */
{ CPUFUNC(op_81c0_11), 33216 }, /* DIVS */
{ CPUFUNC(op_81d0_11), 33232 }, /* DIVS */
{ CPUFUNC(op_81d8_11), 33240 }, /* DIVS */
{ CPUFUNC(op_81e0_11), 33248 }, /* DIVS */
{ CPUFUNC(op_81e8_11), 33256 }, /* DIVS */
{ CPUFUNC(op_81f0_11), 33264 }, /* DIVS */
{ CPUFUNC(op_81f8_11), 33272 }, /* DIVS */
{ CPUFUNC(op_81f9_11), 33273 }, /* DIVS */
{ CPUFUNC(op_81fa_11), 33274 }, /* DIVS */
{ CPUFUNC(op_81fb_11), 33275 }, /* DIVS */
{ CPUFUNC(op_81fc_11), 33276 }, /* DIVS */
{ CPUFUNC(op_9000_11), 36864 }, /* SUB */
{ CPUFUNC(op_9010_11), 36880 }, /* SUB */
{ CPUFUNC(op_9018_11), 36888 }, /* SUB */
{ CPUFUNC(op_9020_11), 36896 }, /* SUB */
{ CPUFUNC(op_9028_11), 36904 }, /* SUB */
{ CPUFUNC(op_9030_11), 36912 }, /* SUB */
{ CPUFUNC(op_9038_11), 36920 }, /* SUB */
{ CPUFUNC(op_9039_11), 36921 }, /* SUB */
{ CPUFUNC(op_903a_11), 36922 }, /* SUB */
{ CPUFUNC(op_903b_11), 36923 }, /* SUB */
{ CPUFUNC(op_903c_11), 36924 }, /* SUB */
{ CPUFUNC(op_9040_11), 36928 }, /* SUB */
{ CPUFUNC(op_9048_11), 36936 }, /* SUB */
{ CPUFUNC(op_9050_11), 36944 }, /* SUB */
{ CPUFUNC(op_9058_11), 36952 }, /* SUB */
{ CPUFUNC(op_9060_11), 36960 }, /* SUB */
{ CPUFUNC(op_9068_11), 36968 }, /* SUB */
{ CPUFUNC(op_9070_11), 36976 }, /* SUB */
{ CPUFUNC(op_9078_11), 36984 }, /* SUB */
{ CPUFUNC(op_9079_11), 36985 }, /* SUB */
{ CPUFUNC(op_907a_11), 36986 }, /* SUB */
{ CPUFUNC(op_907b_11), 36987 }, /* SUB */
{ CPUFUNC(op_907c_11), 36988 }, /* SUB */
{ CPUFUNC(op_9080_11), 36992 }, /* SUB */
{ CPUFUNC(op_9088_11), 37000 }, /* SUB */
{ CPUFUNC(op_9090_11), 37008 }, /* SUB */
{ CPUFUNC(op_9098_11), 37016 }, /* SUB */
{ CPUFUNC(op_90a0_11), 37024 }, /* SUB */
{ CPUFUNC(op_90a8_11), 37032 }, /* SUB */
{ CPUFUNC(op_90b0_11), 37040 }, /* SUB */
{ CPUFUNC(op_90b8_11), 37048 }, /* SUB */
{ CPUFUNC(op_90b9_11), 37049 }, /* SUB */
{ CPUFUNC(op_90ba_11), 37050 }, /* SUB */
{ CPUFUNC(op_90bb_11), 37051 }, /* SUB */
{ CPUFUNC(op_90bc_11), 37052 }, /* SUB */
{ CPUFUNC(op_90c0_11), 37056 }, /* SUBA */
{ CPUFUNC(op_90c8_11), 37064 }, /* SUBA */
{ CPUFUNC(op_90d0_11), 37072 }, /* SUBA */
{ CPUFUNC(op_90d8_11), 37080 }, /* SUBA */
{ CPUFUNC(op_90e0_11), 37088 }, /* SUBA */
{ CPUFUNC(op_90e8_11), 37096 }, /* SUBA */
{ CPUFUNC(op_90f0_11), 37104 }, /* SUBA */
{ CPUFUNC(op_90f8_11), 37112 }, /* SUBA */
{ CPUFUNC(op_90f9_11), 37113 }, /* SUBA */
{ CPUFUNC(op_90fa_11), 37114 }, /* SUBA */
{ CPUFUNC(op_90fb_11), 37115 }, /* SUBA */
{ CPUFUNC(op_90fc_11), 37116 }, /* SUBA */
{ CPUFUNC(op_9100_11), 37120 }, /* SUBX */
{ CPUFUNC(op_9108_11), 37128 }, /* SUBX */
{ CPUFUNC(op_9110_11), 37136 }, /* SUB */
{ CPUFUNC(op_9118_11), 37144 }, /* SUB */
{ CPUFUNC(op_9120_11), 37152 }, /* SUB */
{ CPUFUNC(op_9128_11), 37160 }, /* SUB */
{ CPUFUNC(op_9130_11), 37168 }, /* SUB */
{ CPUFUNC(op_9138_11), 37176 }, /* SUB */
{ CPUFUNC(op_9139_11), 37177 }, /* SUB */
{ CPUFUNC(op_9140_11), 37184 }, /* SUBX */
{ CPUFUNC(op_9148_11), 37192 }, /* SUBX */
{ CPUFUNC(op_9150_11), 37200 }, /* SUB */
{ CPUFUNC(op_9158_11), 37208 }, /* SUB */
{ CPUFUNC(op_9160_11), 37216 }, /* SUB */
{ CPUFUNC(op_9168_11), 37224 }, /* SUB */
{ CPUFUNC(op_9170_11), 37232 }, /* SUB */
{ CPUFUNC(op_9178_11), 37240 }, /* SUB */
{ CPUFUNC(op_9179_11), 37241 }, /* SUB */
{ CPUFUNC(op_9180_11), 37248 }, /* SUBX */
{ CPUFUNC(op_9188_11), 37256 }, /* SUBX */
{ CPUFUNC(op_9190_11), 37264 }, /* SUB */
{ CPUFUNC(op_9198_11), 37272 }, /* SUB */
{ CPUFUNC(op_91a0_11), 37280 }, /* SUB */
{ CPUFUNC(op_91a8_11), 37288 }, /* SUB */
{ CPUFUNC(op_91b0_11), 37296 }, /* SUB */
{ CPUFUNC(op_91b8_11), 37304 }, /* SUB */
{ CPUFUNC(op_91b9_11), 37305 }, /* SUB */
{ CPUFUNC(op_91c0_11), 37312 }, /* SUBA */
{ CPUFUNC(op_91c8_11), 37320 }, /* SUBA */
{ CPUFUNC(op_91d0_11), 37328 }, /* SUBA */
{ CPUFUNC(op_91d8_11), 37336 }, /* SUBA */
{ CPUFUNC(op_91e0_11), 37344 }, /* SUBA */
{ CPUFUNC(op_91e8_11), 37352 }, /* SUBA */
{ CPUFUNC(op_91f0_11), 37360 }, /* SUBA */
{ CPUFUNC(op_91f8_11), 37368 }, /* SUBA */
{ CPUFUNC(op_91f9_11), 37369 }, /* SUBA */
{ CPUFUNC(op_91fa_11), 37370 }, /* SUBA */
{ CPUFUNC(op_91fb_11), 37371 }, /* SUBA */
{ CPUFUNC(op_91fc_11), 37372 }, /* SUBA */
{ CPUFUNC(op_b000_11), 45056 }, /* CMP */
{ CPUFUNC(op_b010_11), 45072 }, /* CMP */
{ CPUFUNC(op_b018_11), 45080 }, /* CMP */
{ CPUFUNC(op_b020_11), 45088 }, /* CMP */
{ CPUFUNC(op_b028_11), 45096 }, /* CMP */
{ CPUFUNC(op_b030_11), 45104 }, /* CMP */
{ CPUFUNC(op_b038_11), 45112 }, /* CMP */
{ CPUFUNC(op_b039_11), 45113 }, /* CMP */
{ CPUFUNC(op_b03a_11), 45114 }, /* CMP */
{ CPUFUNC(op_b03b_11), 45115 }, /* CMP */
{ CPUFUNC(op_b03c_11), 45116 }, /* CMP */
{ CPUFUNC(op_b040_11), 45120 }, /* CMP */
{ CPUFUNC(op_b048_11), 45128 }, /* CMP */
{ CPUFUNC(op_b050_11), 45136 }, /* CMP */
{ CPUFUNC(op_b058_11), 45144 }, /* CMP */
{ CPUFUNC(op_b060_11), 45152 }, /* CMP */
{ CPUFUNC(op_b068_11), 45160 }, /* CMP */
{ CPUFUNC(op_b070_11), 45168 }, /* CMP */
{ CPUFUNC(op_b078_11), 45176 }, /* CMP */
{ CPUFUNC(op_b079_11), 45177 }, /* CMP */
{ CPUFUNC(op_b07a_11), 45178 }, /* CMP */
{ CPUFUNC(op_b07b_11), 45179 }, /* CMP */
{ CPUFUNC(op_b07c_11), 45180 }, /* CMP */
{ CPUFUNC(op_b080_11), 45184 }, /* CMP */
{ CPUFUNC(op_b088_11), 45192 }, /* CMP */
{ CPUFUNC(op_b090_11), 45200 }, /* CMP */
{ CPUFUNC(op_b098_11), 45208 }, /* CMP */
{ CPUFUNC(op_b0a0_11), 45216 }, /* CMP */
{ CPUFUNC(op_b0a8_11), 45224 }, /* CMP */
{ CPUFUNC(op_b0b0_11), 45232 }, /* CMP */
{ CPUFUNC(op_b0b8_11), 45240 }, /* CMP */
{ CPUFUNC(op_b0b9_11), 45241 }, /* CMP */
{ CPUFUNC(op_b0ba_11), 45242 }, /* CMP */
{ CPUFUNC(op_b0bb_11), 45243 }, /* CMP */
{ CPUFUNC(op_b0bc_11), 45244 }, /* CMP */
{ CPUFUNC(op_b0c0_11), 45248 }, /* CMPA */
{ CPUFUNC(op_b0c8_11), 45256 }, /* CMPA */
{ CPUFUNC(op_b0d0_11), 45264 }, /* CMPA */
{ CPUFUNC(op_b0d8_11), 45272 }, /* CMPA */
{ CPUFUNC(op_b0e0_11), 45280 }, /* CMPA */
{ CPUFUNC(op_b0e8_11), 45288 }, /* CMPA */
{ CPUFUNC(op_b0f0_11), 45296 }, /* CMPA */
{ CPUFUNC(op_b0f8_11), 45304 }, /* CMPA */
{ CPUFUNC(op_b0f9_11), 45305 }, /* CMPA */
{ CPUFUNC(op_b0fa_11), 45306 }, /* CMPA */
{ CPUFUNC(op_b0fb_11), 45307 }, /* CMPA */
{ CPUFUNC(op_b0fc_11), 45308 }, /* CMPA */
{ CPUFUNC(op_b100_11), 45312 }, /* EOR */
{ CPUFUNC(op_b108_11), 45320 }, /* CMPM */
{ CPUFUNC(op_b110_11), 45328 }, /* EOR */
{ CPUFUNC(op_b118_11), 45336 }, /* EOR */
{ CPUFUNC(op_b120_11), 45344 }, /* EOR */
{ CPUFUNC(op_b128_11), 45352 }, /* EOR */
{ CPUFUNC(op_b130_11), 45360 }, /* EOR */
{ CPUFUNC(op_b138_11), 45368 }, /* EOR */
{ CPUFUNC(op_b139_11), 45369 }, /* EOR */
{ CPUFUNC(op_b140_11), 45376 }, /* EOR */
{ CPUFUNC(op_b148_11), 45384 }, /* CMPM */
{ CPUFUNC(op_b150_11), 45392 }, /* EOR */
{ CPUFUNC(op_b158_11), 45400 }, /* EOR */
{ CPUFUNC(op_b160_11), 45408 }, /* EOR */
{ CPUFUNC(op_b168_11), 45416 }, /* EOR */
{ CPUFUNC(op_b170_11), 45424 }, /* EOR */
{ CPUFUNC(op_b178_11), 45432 }, /* EOR */
{ CPUFUNC(op_b179_11), 45433 }, /* EOR */
{ CPUFUNC(op_b180_11), 45440 }, /* EOR */
{ CPUFUNC(op_b188_11), 45448 }, /* CMPM */
{ CPUFUNC(op_b190_11), 45456 }, /* EOR */
{ CPUFUNC(op_b198_11), 45464 }, /* EOR */
{ CPUFUNC(op_b1a0_11), 45472 }, /* EOR */
{ CPUFUNC(op_b1a8_11), 45480 }, /* EOR */
{ CPUFUNC(op_b1b0_11), 45488 }, /* EOR */
{ CPUFUNC(op_b1b8_11), 45496 }, /* EOR */
{ CPUFUNC(op_b1b9_11), 45497 }, /* EOR */
{ CPUFUNC(op_b1c0_11), 45504 }, /* CMPA */
{ CPUFUNC(op_b1c8_11), 45512 }, /* CMPA */
{ CPUFUNC(op_b1d0_11), 45520 }, /* CMPA */
{ CPUFUNC(op_b1d8_11), 45528 }, /* CMPA */
{ CPUFUNC(op_b1e0_11), 45536 }, /* CMPA */
{ CPUFUNC(op_b1e8_11), 45544 }, /* CMPA */
{ CPUFUNC(op_b1f0_11), 45552 }, /* CMPA */
{ CPUFUNC(op_b1f8_11), 45560 }, /* CMPA */
{ CPUFUNC(op_b1f9_11), 45561 }, /* CMPA */
{ CPUFUNC(op_b1fa_11), 45562 }, /* CMPA */
{ CPUFUNC(op_b1fb_11), 45563 }, /* CMPA */
{ CPUFUNC(op_b1fc_11), 45564 }, /* CMPA */
{ CPUFUNC(op_c000_11), 49152 }, /* AND */
{ CPUFUNC(op_c010_11), 49168 }, /* AND */
{ CPUFUNC(op_c018_11), 49176 }, /* AND */
{ CPUFUNC(op_c020_11), 49184 }, /* AND */
{ CPUFUNC(op_c028_11), 49192 }, /* AND */
{ CPUFUNC(op_c030_11), 49200 }, /* AND */
{ CPUFUNC(op_c038_11), 49208 }, /* AND */
{ CPUFUNC(op_c039_11), 49209 }, /* AND */
{ CPUFUNC(op_c03a_11), 49210 }, /* AND */
{ CPUFUNC(op_c03b_11), 49211 }, /* AND */
{ CPUFUNC(op_c03c_11), 49212 }, /* AND */
{ CPUFUNC(op_c040_11), 49216 }, /* AND */
{ CPUFUNC(op_c050_11), 49232 }, /* AND */
{ CPUFUNC(op_c058_11), 49240 }, /* AND */
{ CPUFUNC(op_c060_11), 49248 }, /* AND */
{ CPUFUNC(op_c068_11), 49256 }, /* AND */
{ CPUFUNC(op_c070_11), 49264 }, /* AND */
{ CPUFUNC(op_c078_11), 49272 }, /* AND */
{ CPUFUNC(op_c079_11), 49273 }, /* AND */
{ CPUFUNC(op_c07a_11), 49274 }, /* AND */
{ CPUFUNC(op_c07b_11), 49275 }, /* AND */
{ CPUFUNC(op_c07c_11), 49276 }, /* AND */
{ CPUFUNC(op_c080_11), 49280 }, /* AND */
{ CPUFUNC(op_c090_11), 49296 }, /* AND */
{ CPUFUNC(op_c098_11), 49304 }, /* AND */
{ CPUFUNC(op_c0a0_11), 49312 }, /* AND */
{ CPUFUNC(op_c0a8_11), 49320 }, /* AND */
{ CPUFUNC(op_c0b0_11), 49328 }, /* AND */
{ CPUFUNC(op_c0b8_11), 49336 }, /* AND */
{ CPUFUNC(op_c0b9_11), 49337 }, /* AND */
{ CPUFUNC(op_c0ba_11), 49338 }, /* AND */
{ CPUFUNC(op_c0bb_11), 49339 }, /* AND */
{ CPUFUNC(op_c0bc_11), 49340 }, /* AND */
{ CPUFUNC(op_c0c0_11), 49344 }, /* MULU */
{ CPUFUNC(op_c0d0_11), 49360 }, /* MULU */
{ CPUFUNC(op_c0d8_11), 49368 }, /* MULU */
{ CPUFUNC(op_c0e0_11), 49376 }, /* MULU */
{ CPUFUNC(op_c0e8_11), 49384 }, /* MULU */
{ CPUFUNC(op_c0f0_11), 49392 }, /* MULU */
{ CPUFUNC(op_c0f8_11), 49400 }, /* MULU */
{ CPUFUNC(op_c0f9_11), 49401 }, /* MULU */
{ CPUFUNC(op_c0fa_11), 49402 }, /* MULU */
{ CPUFUNC(op_c0fb_11), 49403 }, /* MULU */
{ CPUFUNC(op_c0fc_11), 49404 }, /* MULU */
{ CPUFUNC(op_c100_11), 49408 }, /* ABCD */
{ CPUFUNC(op_c108_11), 49416 }, /* ABCD */
{ CPUFUNC(op_c110_11), 49424 }, /* AND */
{ CPUFUNC(op_c118_11), 49432 }, /* AND */
{ CPUFUNC(op_c120_11), 49440 }, /* AND */
{ CPUFUNC(op_c128_11), 49448 }, /* AND */
{ CPUFUNC(op_c130_11), 49456 }, /* AND */
{ CPUFUNC(op_c138_11), 49464 }, /* AND */
{ CPUFUNC(op_c139_11), 49465 }, /* AND */
{ CPUFUNC(op_c140_11), 49472 }, /* EXG */
{ CPUFUNC(op_c148_11), 49480 }, /* EXG */
{ CPUFUNC(op_c150_11), 49488 }, /* AND */
{ CPUFUNC(op_c158_11), 49496 }, /* AND */
{ CPUFUNC(op_c160_11), 49504 }, /* AND */
{ CPUFUNC(op_c168_11), 49512 }, /* AND */
{ CPUFUNC(op_c170_11), 49520 }, /* AND */
{ CPUFUNC(op_c178_11), 49528 }, /* AND */
{ CPUFUNC(op_c179_11), 49529 }, /* AND */
{ CPUFUNC(op_c188_11), 49544 }, /* EXG */
{ CPUFUNC(op_c190_11), 49552 }, /* AND */
{ CPUFUNC(op_c198_11), 49560 }, /* AND */
{ CPUFUNC(op_c1a0_11), 49568 }, /* AND */
{ CPUFUNC(op_c1a8_11), 49576 }, /* AND */
{ CPUFUNC(op_c1b0_11), 49584 }, /* AND */
{ CPUFUNC(op_c1b8_11), 49592 }, /* AND */
{ CPUFUNC(op_c1b9_11), 49593 }, /* AND */
{ CPUFUNC(op_c1c0_11), 49600 }, /* MULS */
{ CPUFUNC(op_c1d0_11), 49616 }, /* MULS */
{ CPUFUNC(op_c1d8_11), 49624 }, /* MULS */
{ CPUFUNC(op_c1e0_11), 49632 }, /* MULS */
{ CPUFUNC(op_c1e8_11), 49640 }, /* MULS */
{ CPUFUNC(op_c1f0_11), 49648 }, /* MULS */
{ CPUFUNC(op_c1f8_11), 49656 }, /* MULS */
{ CPUFUNC(op_c1f9_11), 49657 }, /* MULS */
{ CPUFUNC(op_c1fa_11), 49658 }, /* MULS */
{ CPUFUNC(op_c1fb_11), 49659 }, /* MULS */
{ CPUFUNC(op_c1fc_11), 49660 }, /* MULS */
{ CPUFUNC(op_d000_11), 53248 }, /* ADD */
{ CPUFUNC(op_d010_11), 53264 }, /* ADD */
{ CPUFUNC(op_d018_11), 53272 }, /* ADD */
{ CPUFUNC(op_d020_11), 53280 }, /* ADD */
{ CPUFUNC(op_d028_11), 53288 }, /* ADD */
{ CPUFUNC(op_d030_11), 53296 }, /* ADD */
{ CPUFUNC(op_d038_11), 53304 }, /* ADD */
{ CPUFUNC(op_d039_11), 53305 }, /* ADD */
{ CPUFUNC(op_d03a_11), 53306 }, /* ADD */
{ CPUFUNC(op_d03b_11), 53307 }, /* ADD */
{ CPUFUNC(op_d03c_11), 53308 }, /* ADD */
{ CPUFUNC(op_d040_11), 53312 }, /* ADD */
{ CPUFUNC(op_d048_11), 53320 }, /* ADD */
{ CPUFUNC(op_d050_11), 53328 }, /* ADD */
{ CPUFUNC(op_d058_11), 53336 }, /* ADD */
{ CPUFUNC(op_d060_11), 53344 }, /* ADD */
{ CPUFUNC(op_d068_11), 53352 }, /* ADD */
{ CPUFUNC(op_d070_11), 53360 }, /* ADD */
{ CPUFUNC(op_d078_11), 53368 }, /* ADD */
{ CPUFUNC(op_d079_11), 53369 }, /* ADD */
{ CPUFUNC(op_d07a_11), 53370 }, /* ADD */
{ CPUFUNC(op_d07b_11), 53371 }, /* ADD */
{ CPUFUNC(op_d07c_11), 53372 }, /* ADD */
{ CPUFUNC(op_d080_11), 53376 }, /* ADD */
{ CPUFUNC(op_d088_11), 53384 }, /* ADD */
{ CPUFUNC(op_d090_11), 53392 }, /* ADD */
{ CPUFUNC(op_d098_11), 53400 }, /* ADD */
{ CPUFUNC(op_d0a0_11), 53408 }, /* ADD */
{ CPUFUNC(op_d0a8_11), 53416 }, /* ADD */
{ CPUFUNC(op_d0b0_11), 53424 }, /* ADD */
{ CPUFUNC(op_d0b8_11), 53432 }, /* ADD */
{ CPUFUNC(op_d0b9_11), 53433 }, /* ADD */
{ CPUFUNC(op_d0ba_11), 53434 }, /* ADD */
{ CPUFUNC(op_d0bb_11), 53435 }, /* ADD */
{ CPUFUNC(op_d0bc_11), 53436 }, /* ADD */
{ CPUFUNC(op_d0c0_11), 53440 }, /* ADDA */
{ CPUFUNC(op_d0c8_11), 53448 }, /* ADDA */
{ CPUFUNC(op_d0d0_11), 53456 }, /* ADDA */
{ CPUFUNC(op_d0d8_11), 53464 }, /* ADDA */
{ CPUFUNC(op_d0e0_11), 53472 }, /* ADDA */
{ CPUFUNC(op_d0e8_11), 53480 }, /* ADDA */
{ CPUFUNC(op_d0f0_11), 53488 }, /* ADDA */
{ CPUFUNC(op_d0f8_11), 53496 }, /* ADDA */
{ CPUFUNC(op_d0f9_11), 53497 }, /* ADDA */
{ CPUFUNC(op_d0fa_11), 53498 }, /* ADDA */
{ CPUFUNC(op_d0fb_11), 53499 }, /* ADDA */
{ CPUFUNC(op_d0fc_11), 53500 }, /* ADDA */
{ CPUFUNC(op_d100_11), 53504 }, /* ADDX */
{ CPUFUNC(op_d108_11), 53512 }, /* ADDX */
{ CPUFUNC(op_d110_11), 53520 }, /* ADD */
{ CPUFUNC(op_d118_11), 53528 }, /* ADD */
{ CPUFUNC(op_d120_11), 53536 }, /* ADD */
{ CPUFUNC(op_d128_11), 53544 }, /* ADD */
{ CPUFUNC(op_d130_11), 53552 }, /* ADD */
{ CPUFUNC(op_d138_11), 53560 }, /* ADD */
{ CPUFUNC(op_d139_11), 53561 }, /* ADD */
{ CPUFUNC(op_d140_11), 53568 }, /* ADDX */
{ CPUFUNC(op_d148_11), 53576 }, /* ADDX */
{ CPUFUNC(op_d150_11), 53584 }, /* ADD */
{ CPUFUNC(op_d158_11), 53592 }, /* ADD */
{ CPUFUNC(op_d160_11), 53600 }, /* ADD */
{ CPUFUNC(op_d168_11), 53608 }, /* ADD */
{ CPUFUNC(op_d170_11), 53616 }, /* ADD */
{ CPUFUNC(op_d178_11), 53624 }, /* ADD */
{ CPUFUNC(op_d179_11), 53625 }, /* ADD */
{ CPUFUNC(op_d180_11), 53632 }, /* ADDX */
{ CPUFUNC(op_d188_11), 53640 }, /* ADDX */
{ CPUFUNC(op_d190_11), 53648 }, /* ADD */
{ CPUFUNC(op_d198_11), 53656 }, /* ADD */
{ CPUFUNC(op_d1a0_11), 53664 }, /* ADD */
{ CPUFUNC(op_d1a8_11), 53672 }, /* ADD */
{ CPUFUNC(op_d1b0_11), 53680 }, /* ADD */
{ CPUFUNC(op_d1b8_11), 53688 }, /* ADD */
{ CPUFUNC(op_d1b9_11), 53689 }, /* ADD */
{ CPUFUNC(op_d1c0_11), 53696 }, /* ADDA */
{ CPUFUNC(op_d1c8_11), 53704 }, /* ADDA */
{ CPUFUNC(op_d1d0_11), 53712 }, /* ADDA */
{ CPUFUNC(op_d1d8_11), 53720 }, /* ADDA */
{ CPUFUNC(op_d1e0_11), 53728 }, /* ADDA */
{ CPUFUNC(op_d1e8_11), 53736 }, /* ADDA */
{ CPUFUNC(op_d1f0_11), 53744 }, /* ADDA */
{ CPUFUNC(op_d1f8_11), 53752 }, /* ADDA */
{ CPUFUNC(op_d1f9_11), 53753 }, /* ADDA */
{ CPUFUNC(op_d1fa_11), 53754 }, /* ADDA */
{ CPUFUNC(op_d1fb_11), 53755 }, /* ADDA */
{ CPUFUNC(op_d1fc_11), 53756 }, /* ADDA */
{ CPUFUNC(op_e000_11), 57344 }, /* ASR */
{ CPUFUNC(op_e008_11), 57352 }, /* LSR */
{ CPUFUNC(op_e010_11), 57360 }, /* ROXR */
{ CPUFUNC(op_e018_11), 57368 }, /* ROR */
{ CPUFUNC(op_e020_11), 57376 }, /* ASR */
{ CPUFUNC(op_e028_11), 57384 }, /* LSR */
{ CPUFUNC(op_e030_11), 57392 }, /* ROXR */
{ CPUFUNC(op_e038_11), 57400 }, /* ROR */
{ CPUFUNC(op_e040_11), 57408 }, /* ASR */
{ CPUFUNC(op_e048_11), 57416 }, /* LSR */
{ CPUFUNC(op_e050_11), 57424 }, /* ROXR */
{ CPUFUNC(op_e058_11), 57432 }, /* ROR */
{ CPUFUNC(op_e060_11), 57440 }, /* ASR */
{ CPUFUNC(op_e068_11), 57448 }, /* LSR */
{ CPUFUNC(op_e070_11), 57456 }, /* ROXR */
{ CPUFUNC(op_e078_11), 57464 }, /* ROR */
{ CPUFUNC(op_e080_11), 57472 }, /* ASR */
{ CPUFUNC(op_e088_11), 57480 }, /* LSR */
{ CPUFUNC(op_e090_11), 57488 }, /* ROXR */
{ CPUFUNC(op_e098_11), 57496 }, /* ROR */
{ CPUFUNC(op_e0a0_11), 57504 }, /* ASR */
{ CPUFUNC(op_e0a8_11), 57512 }, /* LSR */
{ CPUFUNC(op_e0b0_11), 57520 }, /* ROXR */
{ CPUFUNC(op_e0b8_11), 57528 }, /* ROR */
{ CPUFUNC(op_e0d0_11), 57552 }, /* ASRW */
{ CPUFUNC(op_e0d8_11), 57560 }, /* ASRW */
{ CPUFUNC(op_e0e0_11), 57568 }, /* ASRW */
{ CPUFUNC(op_e0e8_11), 57576 }, /* ASRW */
{ CPUFUNC(op_e0f0_11), 57584 }, /* ASRW */
{ CPUFUNC(op_e0f8_11), 57592 }, /* ASRW */
{ CPUFUNC(op_e0f9_11), 57593 }, /* ASRW */
{ CPUFUNC(op_e100_11), 57600 }, /* ASL */
{ CPUFUNC(op_e108_11), 57608 }, /* LSL */
{ CPUFUNC(op_e110_11), 57616 }, /* ROXL */
{ CPUFUNC(op_e118_11), 57624 }, /* ROL */
{ CPUFUNC(op_e120_11), 57632 }, /* ASL */
{ CPUFUNC(op_e128_11), 57640 }, /* LSL */
{ CPUFUNC(op_e130_11), 57648 }, /* ROXL */
{ CPUFUNC(op_e138_11), 57656 }, /* ROL */
{ CPUFUNC(op_e140_11), 57664 }, /* ASL */
{ CPUFUNC(op_e148_11), 57672 }, /* LSL */
{ CPUFUNC(op_e150_11), 57680 }, /* ROXL */
{ CPUFUNC(op_e158_11), 57688 }, /* ROL */
{ CPUFUNC(op_e160_11), 57696 }, /* ASL */
{ CPUFUNC(op_e168_11), 57704 }, /* LSL */
{ CPUFUNC(op_e170_11), 57712 }, /* ROXL */
{ CPUFUNC(op_e178_11), 57720 }, /* ROL */
{ CPUFUNC(op_e180_11), 57728 }, /* ASL */
{ CPUFUNC(op_e188_11), 57736 }, /* LSL */
{ CPUFUNC(op_e190_11), 57744 }, /* ROXL */
{ CPUFUNC(op_e198_11), 57752 }, /* ROL */
{ CPUFUNC(op_e1a0_11), 57760 }, /* ASL */
{ CPUFUNC(op_e1a8_11), 57768 }, /* LSL */
{ CPUFUNC(op_e1b0_11), 57776 }, /* ROXL */
{ CPUFUNC(op_e1b8_11), 57784 }, /* ROL */
{ CPUFUNC(op_e1d0_11), 57808 }, /* ASLW */
{ CPUFUNC(op_e1d8_11), 57816 }, /* ASLW */
{ CPUFUNC(op_e1e0_11), 57824 }, /* ASLW */
{ CPUFUNC(op_e1e8_11), 57832 }, /* ASLW */
{ CPUFUNC(op_e1f0_11), 57840 }, /* ASLW */
{ CPUFUNC(op_e1f8_11), 57848 }, /* ASLW */
{ CPUFUNC(op_e1f9_11), 57849 }, /* ASLW */
{ CPUFUNC(op_e2d0_11), 58064 }, /* LSRW */
{ CPUFUNC(op_e2d8_11), 58072 }, /* LSRW */
{ CPUFUNC(op_e2e0_11), 58080 }, /* LSRW */
{ CPUFUNC(op_e2e8_11), 58088 }, /* LSRW */
{ CPUFUNC(op_e2f0_11), 58096 }, /* LSRW */
{ CPUFUNC(op_e2f8_11), 58104 }, /* LSRW */
{ CPUFUNC(op_e2f9_11), 58105 }, /* LSRW */
{ CPUFUNC(op_e3d0_11), 58320 }, /* LSLW */
{ CPUFUNC(op_e3d8_11), 58328 }, /* LSLW */
{ CPUFUNC(op_e3e0_11), 58336 }, /* LSLW */
{ CPUFUNC(op_e3e8_11), 58344 }, /* LSLW */
{ CPUFUNC(op_e3f0_11), 58352 }, /* LSLW */
{ CPUFUNC(op_e3f8_11), 58360 }, /* LSLW */
{ CPUFUNC(op_e3f9_11), 58361 }, /* LSLW */
{ CPUFUNC(op_e4d0_11), 58576 }, /* ROXRW */
{ CPUFUNC(op_e4d8_11), 58584 }, /* ROXRW */
{ CPUFUNC(op_e4e0_11), 58592 }, /* ROXRW */
{ CPUFUNC(op_e4e8_11), 58600 }, /* ROXRW */
{ CPUFUNC(op_e4f0_11), 58608 }, /* ROXRW */
{ CPUFUNC(op_e4f8_11), 58616 }, /* ROXRW */
{ CPUFUNC(op_e4f9_11), 58617 }, /* ROXRW */
{ CPUFUNC(op_e5d0_11), 58832 }, /* ROXLW */
{ CPUFUNC(op_e5d8_11), 58840 }, /* ROXLW */
{ CPUFUNC(op_e5e0_11), 58848 }, /* ROXLW */
{ CPUFUNC(op_e5e8_11), 58856 }, /* ROXLW */
{ CPUFUNC(op_e5f0_11), 58864 }, /* ROXLW */
{ CPUFUNC(op_e5f8_11), 58872 }, /* ROXLW */
{ CPUFUNC(op_e5f9_11), 58873 }, /* ROXLW */
{ CPUFUNC(op_e6d0_11), 59088 }, /* RORW */
{ CPUFUNC(op_e6d8_11), 59096 }, /* RORW */
{ CPUFUNC(op_e6e0_11), 59104 }, /* RORW */
{ CPUFUNC(op_e6e8_11), 59112 }, /* RORW */
{ CPUFUNC(op_e6f0_11), 59120 }, /* RORW */
{ CPUFUNC(op_e6f8_11), 59128 }, /* RORW */
{ CPUFUNC(op_e6f9_11), 59129 }, /* RORW */
{ CPUFUNC(op_e7d0_11), 59344 }, /* ROLW */
{ CPUFUNC(op_e7d8_11), 59352 }, /* ROLW */
{ CPUFUNC(op_e7e0_11), 59360 }, /* ROLW */
{ CPUFUNC(op_e7e8_11), 59368 }, /* ROLW */
{ CPUFUNC(op_e7f0_11), 59376 }, /* ROLW */
{ CPUFUNC(op_e7f8_11), 59384 }, /* ROLW */
{ CPUFUNC(op_e7f9_11), 59385 }, /* ROLW */
{ 0, 0 }};
#endif /* CPUEMU_11 */
